/* DockTheme.c generated by valac 0.56.18, the Vala compiler
 * generated from DockTheme.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <pango/pango.h>
#include <pango/pangocairo.h>

#define PLANK_DOCK_THEME_MIN_INDICATOR_SIZE 0.0
#define PLANK_DOCK_THEME_MAX_INDICATOR_SIZE 10.0
#define PLANK_DOCK_THEME_MAX_ICON_SHADOW_SIZE 5.0
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PLANK_DOCK_THEME_0_PROPERTY,
	PLANK_DOCK_THEME_HORIZ_PADDING_PROPERTY,
	PLANK_DOCK_THEME_TOP_PADDING_PROPERTY,
	PLANK_DOCK_THEME_BOTTOM_PADDING_PROPERTY,
	PLANK_DOCK_THEME_ITEM_PADDING_PROPERTY,
	PLANK_DOCK_THEME_INDICATOR_SIZE_PROPERTY,
	PLANK_DOCK_THEME_ICON_SHADOW_SIZE_PROPERTY,
	PLANK_DOCK_THEME_URGENT_BOUNCE_HEIGHT_PROPERTY,
	PLANK_DOCK_THEME_LAUNCH_BOUNCE_HEIGHT_PROPERTY,
	PLANK_DOCK_THEME_FADE_OPACITY_PROPERTY,
	PLANK_DOCK_THEME_CLICK_TIME_PROPERTY,
	PLANK_DOCK_THEME_URGENT_BOUNCE_TIME_PROPERTY,
	PLANK_DOCK_THEME_LAUNCH_BOUNCE_TIME_PROPERTY,
	PLANK_DOCK_THEME_ACTIVE_TIME_PROPERTY,
	PLANK_DOCK_THEME_SLIDE_TIME_PROPERTY,
	PLANK_DOCK_THEME_FADE_TIME_PROPERTY,
	PLANK_DOCK_THEME_HIDE_TIME_PROPERTY,
	PLANK_DOCK_THEME_GLOW_SIZE_PROPERTY,
	PLANK_DOCK_THEME_GLOW_TIME_PROPERTY,
	PLANK_DOCK_THEME_GLOW_PULSE_TIME_PROPERTY,
	PLANK_DOCK_THEME_URGENT_HUE_SHIFT_PROPERTY,
	PLANK_DOCK_THEME_ITEM_MOVE_TIME_PROPERTY,
	PLANK_DOCK_THEME_CASCADE_HIDE_PROPERTY,
	PLANK_DOCK_THEME_BADGE_COLOR_PROPERTY,
	PLANK_DOCK_THEME_NUM_PROPERTIES
};
static GParamSpec* plank_dock_theme_properties[PLANK_DOCK_THEME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _PlankDockThemePrivate {
	gdouble _HorizPadding;
	gdouble _TopPadding;
	gdouble _BottomPadding;
	gdouble _ItemPadding;
	gdouble _IndicatorSize;
	gdouble _IconShadowSize;
	gdouble _UrgentBounceHeight;
	gdouble _LaunchBounceHeight;
	gdouble _FadeOpacity;
	gint _ClickTime;
	gint _UrgentBounceTime;
	gint _LaunchBounceTime;
	gint _ActiveTime;
	gint _SlideTime;
	gint _FadeTime;
	gint _HideTime;
	gint _GlowSize;
	gint _GlowTime;
	gint _GlowPulseTime;
	gint _UrgentHueShift;
	gint _ItemMoveTime;
	gboolean _CascadeHide;
	PlankColor _BadgeColor;
};

static gint PlankDockTheme_private_offset;
static gpointer plank_dock_theme_parent_class = NULL;

static void plank_dock_theme_real_reset_properties (PlankPreferences* base);
static void plank_dock_theme_real_verify (PlankPreferences* base,
                                   const gchar* prop);
static gboolean _gdk_rgba_equal (const GdkRGBA * s1,
                          const GdkRGBA * s2);
static void plank_dock_theme_finalize (GObject * obj);
static GType plank_dock_theme_get_type_once (void);
static void _vala_plank_dock_theme_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_plank_dock_theme_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
plank_dock_theme_get_instance_private (PlankDockTheme* self)
{
	return G_STRUCT_MEMBER_P (self, PlankDockTheme_private_offset);
}

PlankDockTheme*
plank_dock_theme_construct (GType object_type,
                            const gchar* name)
{
	PlankDockTheme * self = NULL;
#line 100 "Drawing/DockTheme.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 102 "Drawing/DockTheme.vala"
	self = (PlankDockTheme*) plank_theme_construct_with_name (object_type, name);
#line 100 "Drawing/DockTheme.vala"
	return self;
#line 143 "DockTheme.c"
}

PlankDockTheme*
plank_dock_theme_new (const gchar* name)
{
#line 100 "Drawing/DockTheme.vala"
	return plank_dock_theme_construct (PLANK_TYPE_DOCK_THEME, name);
#line 151 "DockTheme.c"
}

/**
 * {@inheritDoc}
 */
static void
plank_dock_theme_real_reset_properties (PlankPreferences* base)
{
	PlankDockTheme * self;
	PlankColor _tmp0_ = {0};
#line 108 "Drawing/DockTheme.vala"
	self = (PlankDockTheme*) base;
#line 110 "Drawing/DockTheme.vala"
	PLANK_PREFERENCES_CLASS (plank_dock_theme_parent_class)->reset_properties ((PlankPreferences*) G_TYPE_CHECK_INSTANCE_CAST (self, PLANK_TYPE_THEME, PlankTheme));
#line 111 "Drawing/DockTheme.vala"
	plank_theme_set_TopRoundness ((PlankTheme*) self, 4);
#line 112 "Drawing/DockTheme.vala"
	plank_theme_set_BottomRoundness ((PlankTheme*) self, 0);
#line 113 "Drawing/DockTheme.vala"
	plank_dock_theme_set_HorizPadding (self, 0.0);
#line 114 "Drawing/DockTheme.vala"
	plank_dock_theme_set_TopPadding (self, -11.0);
#line 115 "Drawing/DockTheme.vala"
	plank_dock_theme_set_BottomPadding (self, 2.5);
#line 116 "Drawing/DockTheme.vala"
	plank_dock_theme_set_ItemPadding (self, 2.5);
#line 117 "Drawing/DockTheme.vala"
	plank_dock_theme_set_IndicatorSize (self, 5.0);
#line 118 "Drawing/DockTheme.vala"
	plank_dock_theme_set_IconShadowSize (self, 1.0);
#line 119 "Drawing/DockTheme.vala"
	plank_dock_theme_set_UrgentBounceHeight (self, 5.0 / 3.0);
#line 120 "Drawing/DockTheme.vala"
	plank_dock_theme_set_LaunchBounceHeight (self, 0.625);
#line 121 "Drawing/DockTheme.vala"
	plank_dock_theme_set_FadeOpacity (self, 1.0);
#line 122 "Drawing/DockTheme.vala"
	plank_dock_theme_set_ClickTime (self, 300);
#line 123 "Drawing/DockTheme.vala"
	plank_dock_theme_set_UrgentBounceTime (self, 600);
#line 124 "Drawing/DockTheme.vala"
	plank_dock_theme_set_LaunchBounceTime (self, 600);
#line 125 "Drawing/DockTheme.vala"
	plank_dock_theme_set_ActiveTime (self, 300);
#line 126 "Drawing/DockTheme.vala"
	plank_dock_theme_set_SlideTime (self, 300);
#line 127 "Drawing/DockTheme.vala"
	plank_dock_theme_set_FadeTime (self, 250);
#line 128 "Drawing/DockTheme.vala"
	plank_dock_theme_set_HideTime (self, 250);
#line 129 "Drawing/DockTheme.vala"
	plank_dock_theme_set_GlowSize (self, 30);
#line 130 "Drawing/DockTheme.vala"
	plank_dock_theme_set_GlowTime (self, 10000);
#line 131 "Drawing/DockTheme.vala"
	plank_dock_theme_set_GlowPulseTime (self, 2000);
#line 132 "Drawing/DockTheme.vala"
	plank_dock_theme_set_UrgentHueShift (self, 150);
#line 133 "Drawing/DockTheme.vala"
	plank_dock_theme_set_ItemMoveTime (self, 450);
#line 134 "Drawing/DockTheme.vala"
	plank_dock_theme_set_CascadeHide (self, TRUE);
#line 135 "Drawing/DockTheme.vala"
	_tmp0_.red = 0.0;
#line 135 "Drawing/DockTheme.vala"
	_tmp0_.green = 0.0;
#line 135 "Drawing/DockTheme.vala"
	_tmp0_.blue = 0.0;
#line 135 "Drawing/DockTheme.vala"
	_tmp0_.alpha = 0.0;
#line 135 "Drawing/DockTheme.vala"
	plank_dock_theme_set_BadgeColor (self, &_tmp0_);
#line 224 "DockTheme.c"
}

/**
 * Creates a surface for the dock background.
 *
 * @param width the width of the background
 * @param height the height of the background
 * @param position the position of the dock
 * @param model existing surface to use as basis of new surface
 * @return a new surface with the background drawn on it
 */
PlankSurface*
plank_dock_theme_create_background (PlankDockTheme* self,
                                    gint width,
                                    gint height,
                                    GtkPositionType position,
                                    PlankSurface* model)
{
	PlankSurface* surface = NULL;
	PlankSurface* _tmp0_;
	PlankSurface* _tmp1_;
	gboolean _tmp2_ = FALSE;
	PlankSurface* temp = NULL;
	PlankSurface* _tmp8_;
	cairo_t* cr = NULL;
	PlankSurface* _tmp9_;
	cairo_t* _tmp10_;
	cairo_t* _tmp11_;
	gdouble rotate = 0.0;
	gdouble x_offset = 0.0;
	gdouble y_offset = 0.0;
	cairo_t* _tmp12_;
	cairo_t* _tmp13_;
	cairo_t* _tmp14_;
	PlankSurface* _tmp15_;
	cairo_surface_t* _tmp16_;
	cairo_surface_t* _tmp17_;
	cairo_t* _tmp18_;
	cairo_t* _tmp19_;
	PlankSurface* result;
#line 147 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 147 "Drawing/DockTheme.vala"
	g_return_val_if_fail (model != NULL, NULL);
#line 149 "Drawing/DockTheme.vala"
	plank_logger_verbose ("DockTheme.create_background (width = %i, height = %i)", width, height, NULL);
#line 151 "Drawing/DockTheme.vala"
	_tmp0_ = plank_surface_new_with_surface (width, height, model);
#line 151 "Drawing/DockTheme.vala"
	surface = _tmp0_;
#line 152 "Drawing/DockTheme.vala"
	_tmp1_ = surface;
#line 152 "Drawing/DockTheme.vala"
	plank_surface_clear (_tmp1_);
#line 154 "Drawing/DockTheme.vala"
	if (width <= 0) {
#line 154 "Drawing/DockTheme.vala"
		_tmp2_ = TRUE;
#line 283 "DockTheme.c"
	} else {
#line 154 "Drawing/DockTheme.vala"
		_tmp2_ = height <= 0;
#line 287 "DockTheme.c"
	}
#line 154 "Drawing/DockTheme.vala"
	if (_tmp2_) {
#line 155 "Drawing/DockTheme.vala"
		result = surface;
#line 155 "Drawing/DockTheme.vala"
		return result;
#line 295 "DockTheme.c"
	}
#line 157 "Drawing/DockTheme.vala"
	if (position == GTK_POS_BOTTOM) {
#line 299 "DockTheme.c"
		PlankSurface* _tmp3_;
#line 158 "Drawing/DockTheme.vala"
		_tmp3_ = surface;
#line 158 "Drawing/DockTheme.vala"
		plank_theme_draw_background ((PlankTheme*) self, _tmp3_);
#line 159 "Drawing/DockTheme.vala"
		result = surface;
#line 159 "Drawing/DockTheme.vala"
		return result;
#line 309 "DockTheme.c"
	}
#line 163 "Drawing/DockTheme.vala"
	if (position == GTK_POS_TOP) {
#line 313 "DockTheme.c"
		PlankSurface* _tmp4_;
		PlankSurface* _tmp5_;
#line 164 "Drawing/DockTheme.vala"
		_tmp4_ = surface;
#line 164 "Drawing/DockTheme.vala"
		_tmp5_ = plank_surface_new_with_surface (width, height, _tmp4_);
#line 164 "Drawing/DockTheme.vala"
		_g_object_unref0 (temp);
#line 164 "Drawing/DockTheme.vala"
		temp = _tmp5_;
#line 324 "DockTheme.c"
	} else {
		PlankSurface* _tmp6_;
		PlankSurface* _tmp7_;
#line 166 "Drawing/DockTheme.vala"
		_tmp6_ = surface;
#line 166 "Drawing/DockTheme.vala"
		_tmp7_ = plank_surface_new_with_surface (height, width, _tmp6_);
#line 166 "Drawing/DockTheme.vala"
		_g_object_unref0 (temp);
#line 166 "Drawing/DockTheme.vala"
		temp = _tmp7_;
#line 336 "DockTheme.c"
	}
#line 168 "Drawing/DockTheme.vala"
	_tmp8_ = temp;
#line 168 "Drawing/DockTheme.vala"
	plank_theme_draw_background ((PlankTheme*) self, _tmp8_);
#line 170 "Drawing/DockTheme.vala"
	_tmp9_ = surface;
#line 170 "Drawing/DockTheme.vala"
	_tmp10_ = plank_surface_get_Context (_tmp9_);
#line 170 "Drawing/DockTheme.vala"
	_tmp11_ = _tmp10_;
#line 170 "Drawing/DockTheme.vala"
	cr = _tmp11_;
#line 172 "Drawing/DockTheme.vala"
	rotate = 0.0;
#line 173 "Drawing/DockTheme.vala"
	x_offset = 0.0;
#line 173 "Drawing/DockTheme.vala"
	y_offset = 0.0;
#line 175 "Drawing/DockTheme.vala"
	switch (position) {
#line 358 "DockTheme.c"
		default:
#line 175 "Drawing/DockTheme.vala"
		case GTK_POS_BOTTOM:
#line 362 "DockTheme.c"
		{
#line 178 "Drawing/DockTheme.vala"
			break;
#line 366 "DockTheme.c"
		}
#line 175 "Drawing/DockTheme.vala"
		case GTK_POS_TOP:
#line 370 "DockTheme.c"
		{
#line 180 "Drawing/DockTheme.vala"
			rotate = G_PI;
#line 181 "Drawing/DockTheme.vala"
			x_offset = (gdouble) (-width);
#line 182 "Drawing/DockTheme.vala"
			y_offset = (gdouble) (-height);
#line 183 "Drawing/DockTheme.vala"
			break;
#line 380 "DockTheme.c"
		}
#line 175 "Drawing/DockTheme.vala"
		case GTK_POS_LEFT:
#line 384 "DockTheme.c"
		{
#line 185 "Drawing/DockTheme.vala"
			rotate = G_PI_2;
#line 186 "Drawing/DockTheme.vala"
			y_offset = (gdouble) (-width);
#line 187 "Drawing/DockTheme.vala"
			break;
#line 392 "DockTheme.c"
		}
#line 175 "Drawing/DockTheme.vala"
		case GTK_POS_RIGHT:
#line 396 "DockTheme.c"
		{
#line 189 "Drawing/DockTheme.vala"
			rotate = -G_PI_2;
#line 190 "Drawing/DockTheme.vala"
			x_offset = (gdouble) (-height);
#line 191 "Drawing/DockTheme.vala"
			break;
#line 404 "DockTheme.c"
		}
	}
#line 194 "Drawing/DockTheme.vala"
	_tmp12_ = cr;
#line 194 "Drawing/DockTheme.vala"
	cairo_save (_tmp12_);
#line 195 "Drawing/DockTheme.vala"
	_tmp13_ = cr;
#line 195 "Drawing/DockTheme.vala"
	cairo_rotate (_tmp13_, rotate);
#line 196 "Drawing/DockTheme.vala"
	_tmp14_ = cr;
#line 196 "Drawing/DockTheme.vala"
	_tmp15_ = temp;
#line 196 "Drawing/DockTheme.vala"
	_tmp16_ = plank_surface_get_Internal (_tmp15_);
#line 196 "Drawing/DockTheme.vala"
	_tmp17_ = _tmp16_;
#line 196 "Drawing/DockTheme.vala"
	cairo_set_source_surface (_tmp14_, _tmp17_, x_offset, y_offset);
#line 197 "Drawing/DockTheme.vala"
	_tmp18_ = cr;
#line 197 "Drawing/DockTheme.vala"
	cairo_paint (_tmp18_);
#line 198 "Drawing/DockTheme.vala"
	_tmp19_ = cr;
#line 198 "Drawing/DockTheme.vala"
	cairo_restore (_tmp19_);
#line 200 "Drawing/DockTheme.vala"
	result = surface;
#line 200 "Drawing/DockTheme.vala"
	_g_object_unref0 (temp);
#line 200 "Drawing/DockTheme.vala"
	return result;
#line 439 "DockTheme.c"
}

/**
 * Creates a surface for an indicator.
 *
 * @param size the size of the indicator
 * @param color the color of the indicator
 * @param model existing surface to use as basis of new surface
 * @return a new surface with the indicator drawn on it
 */
PlankSurface*
plank_dock_theme_create_indicator (PlankDockTheme* self,
                                   gint size,
                                   PlankColor* color,
                                   PlankSurface* model)
{
	PlankSurface* surface = NULL;
	PlankSurface* _tmp0_;
	PlankSurface* _tmp1_;
	cairo_t* cr = NULL;
	PlankSurface* _tmp2_;
	cairo_t* _tmp3_;
	cairo_t* _tmp4_;
	gint x = 0;
	gint y = 0;
	cairo_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_pattern_t* rg = NULL;
	cairo_pattern_t* _tmp8_;
	cairo_pattern_t* _tmp9_;
	cairo_pattern_t* _tmp10_;
	PlankColor _tmp11_;
	PlankColor _tmp12_;
	PlankColor _tmp13_;
	cairo_pattern_t* _tmp14_;
	PlankColor _tmp15_;
	PlankColor _tmp16_;
	PlankColor _tmp17_;
	cairo_pattern_t* _tmp18_;
	PlankColor _tmp19_;
	PlankColor _tmp20_;
	PlankColor _tmp21_;
	cairo_pattern_t* _tmp22_;
	PlankColor _tmp23_;
	PlankColor _tmp24_;
	PlankColor _tmp25_;
	cairo_pattern_t* _tmp26_;
	PlankColor _tmp27_;
	PlankColor _tmp28_;
	PlankColor _tmp29_;
	cairo_t* _tmp30_;
	cairo_pattern_t* _tmp31_;
	cairo_t* _tmp32_;
	PlankSurface* result;
#line 211 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 211 "Drawing/DockTheme.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 211 "Drawing/DockTheme.vala"
	g_return_val_if_fail (model != NULL, NULL);
#line 213 "Drawing/DockTheme.vala"
	plank_logger_verbose ("DockTheme.create_indicator (size = %i)", size, NULL);
#line 215 "Drawing/DockTheme.vala"
	_tmp0_ = plank_surface_new_with_surface (size, size, model);
#line 215 "Drawing/DockTheme.vala"
	surface = _tmp0_;
#line 216 "Drawing/DockTheme.vala"
	_tmp1_ = surface;
#line 216 "Drawing/DockTheme.vala"
	plank_surface_clear (_tmp1_);
#line 218 "Drawing/DockTheme.vala"
	if (size <= 0) {
#line 219 "Drawing/DockTheme.vala"
		result = surface;
#line 219 "Drawing/DockTheme.vala"
		return result;
#line 517 "DockTheme.c"
	}
#line 221 "Drawing/DockTheme.vala"
	_tmp2_ = surface;
#line 221 "Drawing/DockTheme.vala"
	_tmp3_ = plank_surface_get_Context (_tmp2_);
#line 221 "Drawing/DockTheme.vala"
	_tmp4_ = _tmp3_;
#line 221 "Drawing/DockTheme.vala"
	cr = _tmp4_;
#line 223 "Drawing/DockTheme.vala"
	x = size / 2;
#line 224 "Drawing/DockTheme.vala"
	y = x;
#line 226 "Drawing/DockTheme.vala"
	_tmp5_ = cr;
#line 226 "Drawing/DockTheme.vala"
	cairo_move_to (_tmp5_, (gdouble) x, (gdouble) y);
#line 227 "Drawing/DockTheme.vala"
	_tmp6_ = cr;
#line 227 "Drawing/DockTheme.vala"
	cairo_arc (_tmp6_, (gdouble) x, (gdouble) y, (gdouble) (size / 2), (gdouble) 0, G_PI * 2);
#line 228 "Drawing/DockTheme.vala"
	_tmp7_ = cr;
#line 228 "Drawing/DockTheme.vala"
	cairo_close_path (_tmp7_);
#line 230 "Drawing/DockTheme.vala"
	_tmp8_ = cairo_pattern_create_radial ((gdouble) x, (gdouble) y, (gdouble) 0, (gdouble) x, (gdouble) y, (gdouble) (size / 2));
#line 230 "Drawing/DockTheme.vala"
	rg = _tmp8_;
#line 231 "Drawing/DockTheme.vala"
	_tmp9_ = rg;
#line 231 "Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp9_, (gdouble) 0, (gdouble) 1, (gdouble) 1, (gdouble) 1, (gdouble) 1);
#line 232 "Drawing/DockTheme.vala"
	_tmp10_ = rg;
#line 232 "Drawing/DockTheme.vala"
	_tmp11_ = *color;
#line 232 "Drawing/DockTheme.vala"
	_tmp12_ = *color;
#line 232 "Drawing/DockTheme.vala"
	_tmp13_ = *color;
#line 232 "Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp10_, 0.1, _tmp11_.red, _tmp12_.green, _tmp13_.blue, (gdouble) 1);
#line 233 "Drawing/DockTheme.vala"
	_tmp14_ = rg;
#line 233 "Drawing/DockTheme.vala"
	_tmp15_ = *color;
#line 233 "Drawing/DockTheme.vala"
	_tmp16_ = *color;
#line 233 "Drawing/DockTheme.vala"
	_tmp17_ = *color;
#line 233 "Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp14_, 0.2, _tmp15_.red, _tmp16_.green, _tmp17_.blue, 0.6);
#line 234 "Drawing/DockTheme.vala"
	_tmp18_ = rg;
#line 234 "Drawing/DockTheme.vala"
	_tmp19_ = *color;
#line 234 "Drawing/DockTheme.vala"
	_tmp20_ = *color;
#line 234 "Drawing/DockTheme.vala"
	_tmp21_ = *color;
#line 234 "Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp18_, 0.25, _tmp19_.red, _tmp20_.green, _tmp21_.blue, 0.25);
#line 235 "Drawing/DockTheme.vala"
	_tmp22_ = rg;
#line 235 "Drawing/DockTheme.vala"
	_tmp23_ = *color;
#line 235 "Drawing/DockTheme.vala"
	_tmp24_ = *color;
#line 235 "Drawing/DockTheme.vala"
	_tmp25_ = *color;
#line 235 "Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp22_, 0.5, _tmp23_.red, _tmp24_.green, _tmp25_.blue, 0.15);
#line 236 "Drawing/DockTheme.vala"
	_tmp26_ = rg;
#line 236 "Drawing/DockTheme.vala"
	_tmp27_ = *color;
#line 236 "Drawing/DockTheme.vala"
	_tmp28_ = *color;
#line 236 "Drawing/DockTheme.vala"
	_tmp29_ = *color;
#line 236 "Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp26_, 1.0, _tmp27_.red, _tmp28_.green, _tmp29_.blue, 0.0);
#line 238 "Drawing/DockTheme.vala"
	_tmp30_ = cr;
#line 238 "Drawing/DockTheme.vala"
	_tmp31_ = rg;
#line 238 "Drawing/DockTheme.vala"
	cairo_set_source (_tmp30_, _tmp31_);
#line 239 "Drawing/DockTheme.vala"
	_tmp32_ = cr;
#line 239 "Drawing/DockTheme.vala"
	cairo_fill (_tmp32_);
#line 241 "Drawing/DockTheme.vala"
	result = surface;
#line 241 "Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (rg);
#line 241 "Drawing/DockTheme.vala"
	return result;
#line 617 "DockTheme.c"
}

/**
 * Creates a surface for an urgent glow.
 *
 * @param size the size of the urgent glow
 * @param color the color of the urgent glow
 * @param model existing surface to use as basis of new surface
 * @return a new surface with the urgent glow drawn on it
 */
PlankSurface*
plank_dock_theme_create_urgent_glow (PlankDockTheme* self,
                                     gint size,
                                     PlankColor* color,
                                     PlankSurface* model)
{
	PlankSurface* surface = NULL;
	PlankSurface* _tmp0_;
	PlankSurface* _tmp1_;
	cairo_t* cr = NULL;
	PlankSurface* _tmp2_;
	cairo_t* _tmp3_;
	cairo_t* _tmp4_;
	gdouble x = 0.0;
	cairo_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_pattern_t* rg = NULL;
	cairo_pattern_t* _tmp8_;
	cairo_pattern_t* _tmp9_;
	cairo_pattern_t* _tmp10_;
	PlankColor _tmp11_;
	PlankColor _tmp12_;
	PlankColor _tmp13_;
	cairo_pattern_t* _tmp14_;
	PlankColor _tmp15_;
	PlankColor _tmp16_;
	PlankColor _tmp17_;
	cairo_pattern_t* _tmp18_;
	PlankColor _tmp19_;
	PlankColor _tmp20_;
	PlankColor _tmp21_;
	cairo_t* _tmp22_;
	cairo_pattern_t* _tmp23_;
	cairo_t* _tmp24_;
	PlankSurface* result;
#line 252 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 252 "Drawing/DockTheme.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 252 "Drawing/DockTheme.vala"
	g_return_val_if_fail (model != NULL, NULL);
#line 254 "Drawing/DockTheme.vala"
	plank_logger_verbose ("DockTheme.create_urgent_glow (size = %i)", size, NULL);
#line 256 "Drawing/DockTheme.vala"
	_tmp0_ = plank_surface_new_with_surface (size, size, model);
#line 256 "Drawing/DockTheme.vala"
	surface = _tmp0_;
#line 257 "Drawing/DockTheme.vala"
	_tmp1_ = surface;
#line 257 "Drawing/DockTheme.vala"
	plank_surface_clear (_tmp1_);
#line 259 "Drawing/DockTheme.vala"
	if (size <= 0) {
#line 260 "Drawing/DockTheme.vala"
		result = surface;
#line 260 "Drawing/DockTheme.vala"
		return result;
#line 686 "DockTheme.c"
	}
#line 262 "Drawing/DockTheme.vala"
	_tmp2_ = surface;
#line 262 "Drawing/DockTheme.vala"
	_tmp3_ = plank_surface_get_Context (_tmp2_);
#line 262 "Drawing/DockTheme.vala"
	_tmp4_ = _tmp3_;
#line 262 "Drawing/DockTheme.vala"
	cr = _tmp4_;
#line 264 "Drawing/DockTheme.vala"
	x = size / 2.0;
#line 266 "Drawing/DockTheme.vala"
	_tmp5_ = cr;
#line 266 "Drawing/DockTheme.vala"
	cairo_move_to (_tmp5_, x, x);
#line 267 "Drawing/DockTheme.vala"
	_tmp6_ = cr;
#line 267 "Drawing/DockTheme.vala"
	cairo_arc (_tmp6_, x, x, (gdouble) (size / 2), (gdouble) 0, G_PI * 2);
#line 268 "Drawing/DockTheme.vala"
	_tmp7_ = cr;
#line 268 "Drawing/DockTheme.vala"
	cairo_close_path (_tmp7_);
#line 270 "Drawing/DockTheme.vala"
	_tmp8_ = cairo_pattern_create_radial (x, x, (gdouble) 0, x, x, (gdouble) (size / 2));
#line 270 "Drawing/DockTheme.vala"
	rg = _tmp8_;
#line 271 "Drawing/DockTheme.vala"
	_tmp9_ = rg;
#line 271 "Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp9_, (gdouble) 0, (gdouble) 1, (gdouble) 1, (gdouble) 1, (gdouble) 1);
#line 272 "Drawing/DockTheme.vala"
	_tmp10_ = rg;
#line 272 "Drawing/DockTheme.vala"
	_tmp11_ = *color;
#line 272 "Drawing/DockTheme.vala"
	_tmp12_ = *color;
#line 272 "Drawing/DockTheme.vala"
	_tmp13_ = *color;
#line 272 "Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp10_, 0.33, _tmp11_.red, _tmp12_.green, _tmp13_.blue, 0.66);
#line 273 "Drawing/DockTheme.vala"
	_tmp14_ = rg;
#line 273 "Drawing/DockTheme.vala"
	_tmp15_ = *color;
#line 273 "Drawing/DockTheme.vala"
	_tmp16_ = *color;
#line 273 "Drawing/DockTheme.vala"
	_tmp17_ = *color;
#line 273 "Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp14_, 0.66, _tmp15_.red, _tmp16_.green, _tmp17_.blue, 0.33);
#line 274 "Drawing/DockTheme.vala"
	_tmp18_ = rg;
#line 274 "Drawing/DockTheme.vala"
	_tmp19_ = *color;
#line 274 "Drawing/DockTheme.vala"
	_tmp20_ = *color;
#line 274 "Drawing/DockTheme.vala"
	_tmp21_ = *color;
#line 274 "Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp18_, 1.0, _tmp19_.red, _tmp20_.green, _tmp21_.blue, 0.0);
#line 276 "Drawing/DockTheme.vala"
	_tmp22_ = cr;
#line 276 "Drawing/DockTheme.vala"
	_tmp23_ = rg;
#line 276 "Drawing/DockTheme.vala"
	cairo_set_source (_tmp22_, _tmp23_);
#line 277 "Drawing/DockTheme.vala"
	_tmp24_ = cr;
#line 277 "Drawing/DockTheme.vala"
	cairo_fill (_tmp24_);
#line 279 "Drawing/DockTheme.vala"
	result = surface;
#line 279 "Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (rg);
#line 279 "Drawing/DockTheme.vala"
	return result;
#line 764 "DockTheme.c"
}

/**
 * Draws an active glow for an item.
 *
 * @param surface the surface to draw onto
 * @param clip_rect the rect to clip the glow to
 * @param rect the rect for the glow
 * @param color the color of the glow
 * @param opacity the opacity of the glow
 * @param pos the dock's position
 */
void
plank_dock_theme_draw_active_glow (PlankDockTheme* self,
                                   PlankSurface* surface,
                                   GdkRectangle* clip_rect,
                                   GdkRectangle* rect,
                                   PlankColor* color,
                                   gdouble opacity,
                                   GtkPositionType pos)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	cairo_t* cr = NULL;
	cairo_t* _tmp4_;
	cairo_t* _tmp5_;
	gdouble rotate = 0.0;
	gdouble xoffset = 0.0;
	gdouble yoffset = 0.0;
	cairo_pattern_t* gradient = NULL;
	cairo_t* _tmp32_;
	cairo_t* _tmp33_;
	cairo_t* _tmp34_;
	gboolean _tmp35_ = FALSE;
	cairo_t* _tmp42_;
	cairo_t* _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	cairo_t* _tmp46_;
	cairo_pattern_t* _tmp47_;
	PlankColor _tmp48_;
	PlankColor _tmp49_;
	PlankColor _tmp50_;
	cairo_pattern_t* _tmp51_;
	PlankColor _tmp52_;
	PlankColor _tmp53_;
	PlankColor _tmp54_;
	cairo_t* _tmp55_;
	GdkRectangle _tmp56_;
	GdkRectangle _tmp57_;
	GdkRectangle _tmp58_;
	GdkRectangle _tmp59_;
	cairo_t* _tmp60_;
	cairo_pattern_t* _tmp61_;
	cairo_t* _tmp62_;
	cairo_t* _tmp63_;
#line 292 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 292 "Drawing/DockTheme.vala"
	g_return_if_fail (surface != NULL);
#line 292 "Drawing/DockTheme.vala"
	g_return_if_fail (clip_rect != NULL);
#line 292 "Drawing/DockTheme.vala"
	g_return_if_fail (rect != NULL);
#line 292 "Drawing/DockTheme.vala"
	g_return_if_fail (color != NULL);
#line 294 "Drawing/DockTheme.vala"
	if (opacity <= 0.0) {
#line 294 "Drawing/DockTheme.vala"
		_tmp1_ = TRUE;
#line 835 "DockTheme.c"
	} else {
		GdkRectangle _tmp2_;
#line 294 "Drawing/DockTheme.vala"
		_tmp2_ = *rect;
#line 294 "Drawing/DockTheme.vala"
		_tmp1_ = _tmp2_.width <= 0;
#line 842 "DockTheme.c"
	}
#line 294 "Drawing/DockTheme.vala"
	if (_tmp1_) {
#line 294 "Drawing/DockTheme.vala"
		_tmp0_ = TRUE;
#line 848 "DockTheme.c"
	} else {
		GdkRectangle _tmp3_;
#line 294 "Drawing/DockTheme.vala"
		_tmp3_ = *rect;
#line 294 "Drawing/DockTheme.vala"
		_tmp0_ = _tmp3_.height <= 0;
#line 855 "DockTheme.c"
	}
#line 294 "Drawing/DockTheme.vala"
	if (_tmp0_) {
#line 295 "Drawing/DockTheme.vala"
		return;
#line 861 "DockTheme.c"
	}
#line 297 "Drawing/DockTheme.vala"
	_tmp4_ = plank_surface_get_Context (surface);
#line 297 "Drawing/DockTheme.vala"
	_tmp5_ = _tmp4_;
#line 297 "Drawing/DockTheme.vala"
	cr = _tmp5_;
#line 299 "Drawing/DockTheme.vala"
	rotate = 0.0;
#line 300 "Drawing/DockTheme.vala"
	xoffset = 0.0;
#line 300 "Drawing/DockTheme.vala"
	yoffset = 0.0;
#line 302 "Drawing/DockTheme.vala"
	gradient = NULL;
#line 304 "Drawing/DockTheme.vala"
	switch (pos) {
#line 879 "DockTheme.c"
		default:
#line 304 "Drawing/DockTheme.vala"
		case GTK_POS_BOTTOM:
#line 883 "DockTheme.c"
		{
			GdkRectangle _tmp6_;
			GdkRectangle _tmp7_;
			GdkRectangle _tmp8_;
			GdkRectangle _tmp9_;
			GdkRectangle _tmp10_;
			cairo_pattern_t* _tmp11_;
#line 307 "Drawing/DockTheme.vala"
			_tmp6_ = *clip_rect;
#line 307 "Drawing/DockTheme.vala"
			xoffset = (gdouble) _tmp6_.x;
#line 308 "Drawing/DockTheme.vala"
			_tmp7_ = *clip_rect;
#line 308 "Drawing/DockTheme.vala"
			yoffset = (gdouble) _tmp7_.y;
#line 310 "Drawing/DockTheme.vala"
			_tmp8_ = *rect;
#line 310 "Drawing/DockTheme.vala"
			_tmp9_ = *rect;
#line 310 "Drawing/DockTheme.vala"
			_tmp10_ = *rect;
#line 310 "Drawing/DockTheme.vala"
			_tmp11_ = cairo_pattern_create_linear ((gdouble) 0, (gdouble) _tmp8_.y, (gdouble) 0, (gdouble) (_tmp9_.y + _tmp10_.height));
#line 310 "Drawing/DockTheme.vala"
			_cairo_pattern_destroy0 (gradient);
#line 310 "Drawing/DockTheme.vala"
			gradient = _tmp11_;
#line 311 "Drawing/DockTheme.vala"
			break;
#line 913 "DockTheme.c"
		}
#line 304 "Drawing/DockTheme.vala"
		case GTK_POS_TOP:
#line 917 "DockTheme.c"
		{
			GdkRectangle _tmp12_;
			GdkRectangle _tmp13_;
			GdkRectangle _tmp14_;
			GdkRectangle _tmp15_;
			GdkRectangle _tmp16_;
			GdkRectangle _tmp17_;
			cairo_pattern_t* _tmp18_;
#line 313 "Drawing/DockTheme.vala"
			rotate = G_PI;
#line 314 "Drawing/DockTheme.vala"
			_tmp12_ = *clip_rect;
#line 314 "Drawing/DockTheme.vala"
			_tmp13_ = *clip_rect;
#line 314 "Drawing/DockTheme.vala"
			xoffset = (gdouble) ((-_tmp12_.x) - _tmp13_.width);
#line 315 "Drawing/DockTheme.vala"
			_tmp14_ = *clip_rect;
#line 315 "Drawing/DockTheme.vala"
			yoffset = (gdouble) (-_tmp14_.height);
#line 317 "Drawing/DockTheme.vala"
			_tmp15_ = *rect;
#line 317 "Drawing/DockTheme.vala"
			_tmp16_ = *rect;
#line 317 "Drawing/DockTheme.vala"
			_tmp17_ = *rect;
#line 317 "Drawing/DockTheme.vala"
			_tmp18_ = cairo_pattern_create_linear ((gdouble) 0, (gdouble) (_tmp15_.y + _tmp16_.height), (gdouble) 0, (gdouble) _tmp17_.y);
#line 317 "Drawing/DockTheme.vala"
			_cairo_pattern_destroy0 (gradient);
#line 317 "Drawing/DockTheme.vala"
			gradient = _tmp18_;
#line 318 "Drawing/DockTheme.vala"
			break;
#line 952 "DockTheme.c"
		}
#line 304 "Drawing/DockTheme.vala"
		case GTK_POS_LEFT:
#line 956 "DockTheme.c"
		{
			GdkRectangle _tmp19_;
			GdkRectangle _tmp20_;
			GdkRectangle _tmp21_;
			GdkRectangle _tmp22_;
			GdkRectangle _tmp23_;
			cairo_pattern_t* _tmp24_;
#line 320 "Drawing/DockTheme.vala"
			rotate = G_PI_2;
#line 321 "Drawing/DockTheme.vala"
			_tmp19_ = *clip_rect;
#line 321 "Drawing/DockTheme.vala"
			xoffset = (gdouble) _tmp19_.y;
#line 322 "Drawing/DockTheme.vala"
			_tmp20_ = *clip_rect;
#line 322 "Drawing/DockTheme.vala"
			yoffset = (gdouble) (-_tmp20_.width);
#line 324 "Drawing/DockTheme.vala"
			_tmp21_ = *rect;
#line 324 "Drawing/DockTheme.vala"
			_tmp22_ = *rect;
#line 324 "Drawing/DockTheme.vala"
			_tmp23_ = *rect;
#line 324 "Drawing/DockTheme.vala"
			_tmp24_ = cairo_pattern_create_linear ((gdouble) (_tmp21_.x + _tmp22_.width), (gdouble) 0, (gdouble) _tmp23_.x, (gdouble) 0);
#line 324 "Drawing/DockTheme.vala"
			_cairo_pattern_destroy0 (gradient);
#line 324 "Drawing/DockTheme.vala"
			gradient = _tmp24_;
#line 325 "Drawing/DockTheme.vala"
			break;
#line 988 "DockTheme.c"
		}
#line 304 "Drawing/DockTheme.vala"
		case GTK_POS_RIGHT:
#line 992 "DockTheme.c"
		{
			GdkRectangle _tmp25_;
			GdkRectangle _tmp26_;
			GdkRectangle _tmp27_;
			GdkRectangle _tmp28_;
			GdkRectangle _tmp29_;
			GdkRectangle _tmp30_;
			cairo_pattern_t* _tmp31_;
#line 327 "Drawing/DockTheme.vala"
			rotate = -G_PI_2;
#line 328 "Drawing/DockTheme.vala"
			_tmp25_ = *clip_rect;
#line 328 "Drawing/DockTheme.vala"
			_tmp26_ = *clip_rect;
#line 328 "Drawing/DockTheme.vala"
			xoffset = (gdouble) ((-_tmp25_.y) - _tmp26_.height);
#line 329 "Drawing/DockTheme.vala"
			_tmp27_ = *clip_rect;
#line 329 "Drawing/DockTheme.vala"
			yoffset = (gdouble) _tmp27_.x;
#line 331 "Drawing/DockTheme.vala"
			_tmp28_ = *rect;
#line 331 "Drawing/DockTheme.vala"
			_tmp29_ = *rect;
#line 331 "Drawing/DockTheme.vala"
			_tmp30_ = *rect;
#line 331 "Drawing/DockTheme.vala"
			_tmp31_ = cairo_pattern_create_linear ((gdouble) _tmp28_.x, (gdouble) 0, (gdouble) (_tmp29_.x + _tmp30_.width), (gdouble) 0);
#line 331 "Drawing/DockTheme.vala"
			_cairo_pattern_destroy0 (gradient);
#line 331 "Drawing/DockTheme.vala"
			gradient = _tmp31_;
#line 332 "Drawing/DockTheme.vala"
			break;
#line 1027 "DockTheme.c"
		}
	}
#line 335 "Drawing/DockTheme.vala"
	_tmp32_ = cr;
#line 335 "Drawing/DockTheme.vala"
	cairo_save (_tmp32_);
#line 336 "Drawing/DockTheme.vala"
	_tmp33_ = cr;
#line 336 "Drawing/DockTheme.vala"
	cairo_rotate (_tmp33_, rotate);
#line 337 "Drawing/DockTheme.vala"
	_tmp34_ = cr;
#line 337 "Drawing/DockTheme.vala"
	cairo_translate (_tmp34_, xoffset, yoffset);
#line 338 "Drawing/DockTheme.vala"
	if (pos == GTK_POS_BOTTOM) {
#line 338 "Drawing/DockTheme.vala"
		_tmp35_ = TRUE;
#line 1046 "DockTheme.c"
	} else {
#line 338 "Drawing/DockTheme.vala"
		_tmp35_ = pos == GTK_POS_TOP;
#line 1050 "DockTheme.c"
	}
#line 338 "Drawing/DockTheme.vala"
	if (_tmp35_) {
#line 1054 "DockTheme.c"
		cairo_t* _tmp36_;
		GdkRectangle _tmp37_;
		GdkRectangle _tmp38_;
#line 339 "Drawing/DockTheme.vala"
		_tmp36_ = cr;
#line 339 "Drawing/DockTheme.vala"
		_tmp37_ = *clip_rect;
#line 339 "Drawing/DockTheme.vala"
		_tmp38_ = *clip_rect;
#line 339 "Drawing/DockTheme.vala"
		plank_theme_draw_inner_rect ((PlankTheme*) self, _tmp36_, _tmp37_.width, _tmp38_.height);
#line 1066 "DockTheme.c"
	} else {
		cairo_t* _tmp39_;
		GdkRectangle _tmp40_;
		GdkRectangle _tmp41_;
#line 341 "Drawing/DockTheme.vala"
		_tmp39_ = cr;
#line 341 "Drawing/DockTheme.vala"
		_tmp40_ = *clip_rect;
#line 341 "Drawing/DockTheme.vala"
		_tmp41_ = *clip_rect;
#line 341 "Drawing/DockTheme.vala"
		plank_theme_draw_inner_rect ((PlankTheme*) self, _tmp39_, _tmp40_.height, _tmp41_.width);
#line 1079 "DockTheme.c"
	}
#line 342 "Drawing/DockTheme.vala"
	_tmp42_ = cr;
#line 342 "Drawing/DockTheme.vala"
	cairo_restore (_tmp42_);
#line 344 "Drawing/DockTheme.vala"
	_tmp43_ = cr;
#line 344 "Drawing/DockTheme.vala"
	_tmp44_ = plank_theme_get_LineWidth ((PlankTheme*) self);
#line 344 "Drawing/DockTheme.vala"
	_tmp45_ = _tmp44_;
#line 344 "Drawing/DockTheme.vala"
	cairo_set_line_width (_tmp43_, (gdouble) _tmp45_);
#line 345 "Drawing/DockTheme.vala"
	_tmp46_ = cr;
#line 345 "Drawing/DockTheme.vala"
	cairo_clip (_tmp46_);
#line 347 "Drawing/DockTheme.vala"
	_tmp47_ = gradient;
#line 347 "Drawing/DockTheme.vala"
	_tmp48_ = *color;
#line 347 "Drawing/DockTheme.vala"
	_tmp49_ = *color;
#line 347 "Drawing/DockTheme.vala"
	_tmp50_ = *color;
#line 347 "Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp47_, (gdouble) 0, _tmp48_.red, _tmp49_.green, _tmp50_.blue, (gdouble) 0);
#line 348 "Drawing/DockTheme.vala"
	_tmp51_ = gradient;
#line 348 "Drawing/DockTheme.vala"
	_tmp52_ = *color;
#line 348 "Drawing/DockTheme.vala"
	_tmp53_ = *color;
#line 348 "Drawing/DockTheme.vala"
	_tmp54_ = *color;
#line 348 "Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp51_, (gdouble) 1, _tmp52_.red, _tmp53_.green, _tmp54_.blue, 0.6 * opacity);
#line 350 "Drawing/DockTheme.vala"
	_tmp55_ = cr;
#line 350 "Drawing/DockTheme.vala"
	_tmp56_ = *rect;
#line 350 "Drawing/DockTheme.vala"
	_tmp57_ = *rect;
#line 350 "Drawing/DockTheme.vala"
	_tmp58_ = *rect;
#line 350 "Drawing/DockTheme.vala"
	_tmp59_ = *rect;
#line 350 "Drawing/DockTheme.vala"
	cairo_rectangle (_tmp55_, (gdouble) _tmp56_.x, (gdouble) _tmp57_.y, (gdouble) _tmp58_.width, (gdouble) _tmp59_.height);
#line 351 "Drawing/DockTheme.vala"
	_tmp60_ = cr;
#line 351 "Drawing/DockTheme.vala"
	_tmp61_ = gradient;
#line 351 "Drawing/DockTheme.vala"
	cairo_set_source (_tmp60_, _tmp61_);
#line 352 "Drawing/DockTheme.vala"
	_tmp62_ = cr;
#line 352 "Drawing/DockTheme.vala"
	cairo_fill (_tmp62_);
#line 354 "Drawing/DockTheme.vala"
	_tmp63_ = cr;
#line 354 "Drawing/DockTheme.vala"
	cairo_reset_clip (_tmp63_);
#line 292 "Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (gradient);
#line 1145 "DockTheme.c"
}

/**
 * Draws a badge for an item.
 *
 * @param surface the surface to draw the badge onto
 * @param icon_size the icon-size of the dock
 * @param color the color of the badge
 * @param count the number for the badge to show
 */
void
plank_dock_theme_draw_item_count (PlankDockTheme* self,
                                  PlankSurface* surface,
                                  gint icon_size,
                                  PlankColor* color,
                                  gint64 count)
{
	cairo_t* cr = NULL;
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	gdouble x = 0.0;
	gint _tmp2_;
	gint _tmp3_;
	gdouble y = 0.0;
	gint _tmp4_;
	gint _tmp5_;
	PlankColor badge_color_start = {0};
	PlankColor _tmp6_;
	PlankColor badge_color_middle = {0};
	PlankColor _tmp7_;
	PlankColor badge_color_end = {0};
	PlankColor _tmp8_;
	PlankColor stroke_color_start = {0};
	PlankColor _tmp9_;
	PlankColor stroke_color_end = {0};
	PlankColor _tmp10_;
	gboolean is_small = FALSE;
	gboolean is_large = FALSE;
	gdouble _tmp11_ = 0.0;
	gdouble padding = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble line_width = 0.0;
	gdouble _tmp15_ = 0.0;
	gdouble height = 0.0;
	gdouble width = 0.0;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gdouble _tmp20_;
	gdouble max_width = 0.0;
	cairo_t* _tmp21_;
	cairo_pattern_t* stroke = NULL;
	cairo_pattern_t* fill = NULL;
	PangoLayout* layout = NULL;
	PangoContext* _tmp53_;
	PangoContext* _tmp54_;
	PangoLayout* _tmp55_;
	PangoLayout* _tmp56_;
	PangoLayout* _tmp57_;
	PangoLayout* _tmp58_;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp59_;
	PangoFontDescription* font_description = NULL;
	GtkStyleContext* _tmp60_;
	GtkStyleContext* _tmp61_;
	PangoFontDescription* _tmp62_;
	PangoFontDescription* _tmp63_;
	PangoFontDescription* _tmp64_;
	PangoLayout* _tmp65_;
	PangoFontDescription* _tmp66_;
	PangoLayout* _tmp67_;
	gchar* _tmp68_;
	gchar* _tmp69_;
	PangoRectangle logical_rect = {0};
	PangoLayout* _tmp70_;
	PangoRectangle _tmp71_ = {0};
	gdouble scale = 0.0;
	PangoRectangle _tmp72_;
	PangoRectangle _tmp73_;
	cairo_t* _tmp76_;
	PangoRectangle _tmp77_;
	PangoRectangle _tmp78_;
	cairo_t* _tmp79_;
	cairo_t* _tmp81_;
	cairo_t* _tmp82_;
	PangoLayout* _tmp83_;
	cairo_t* _tmp84_;
	cairo_t* _tmp85_;
	cairo_t* _tmp86_;
	cairo_t* _tmp87_;
#line 365 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 365 "Drawing/DockTheme.vala"
	g_return_if_fail (surface != NULL);
#line 365 "Drawing/DockTheme.vala"
	g_return_if_fail (color != NULL);
#line 367 "Drawing/DockTheme.vala"
	_tmp0_ = plank_surface_get_Context (surface);
#line 367 "Drawing/DockTheme.vala"
	_tmp1_ = _tmp0_;
#line 367 "Drawing/DockTheme.vala"
	cr = _tmp1_;
#line 371 "Drawing/DockTheme.vala"
	_tmp2_ = plank_surface_get_Width (surface);
#line 371 "Drawing/DockTheme.vala"
	_tmp3_ = _tmp2_;
#line 371 "Drawing/DockTheme.vala"
	x = floor ((gdouble) ((_tmp3_ - icon_size) / 2));
#line 372 "Drawing/DockTheme.vala"
	_tmp4_ = plank_surface_get_Height (surface);
#line 372 "Drawing/DockTheme.vala"
	_tmp5_ = _tmp4_;
#line 372 "Drawing/DockTheme.vala"
	y = floor ((gdouble) ((_tmp5_ - icon_size) / 2));
#line 374 "Drawing/DockTheme.vala"
	_tmp6_ = *color;
#line 374 "Drawing/DockTheme.vala"
	badge_color_start = _tmp6_;
#line 375 "Drawing/DockTheme.vala"
	plank_color_brighten_val (&badge_color_start, 1.0);
#line 376 "Drawing/DockTheme.vala"
	_tmp7_ = *color;
#line 376 "Drawing/DockTheme.vala"
	badge_color_middle = _tmp7_;
#line 377 "Drawing/DockTheme.vala"
	plank_color_set_sat (&badge_color_middle, 0.87);
#line 378 "Drawing/DockTheme.vala"
	_tmp8_ = *color;
#line 378 "Drawing/DockTheme.vala"
	badge_color_end = _tmp8_;
#line 379 "Drawing/DockTheme.vala"
	plank_color_set_sat (&badge_color_end, 0.87);
#line 380 "Drawing/DockTheme.vala"
	plank_color_darken_val (&badge_color_end, 0.7);
#line 381 "Drawing/DockTheme.vala"
	_tmp9_ = *color;
#line 381 "Drawing/DockTheme.vala"
	stroke_color_start = _tmp9_;
#line 382 "Drawing/DockTheme.vala"
	plank_color_set_sat (&stroke_color_start, 0.9);
#line 383 "Drawing/DockTheme.vala"
	_tmp10_ = *color;
#line 383 "Drawing/DockTheme.vala"
	stroke_color_end = _tmp10_;
#line 384 "Drawing/DockTheme.vala"
	plank_color_set_sat (&stroke_color_end, 0.9);
#line 385 "Drawing/DockTheme.vala"
	plank_color_darken_val (&stroke_color_end, 0.9);
#line 388 "Drawing/DockTheme.vala"
	is_small = icon_size < 32;
#line 389 "Drawing/DockTheme.vala"
	is_large = icon_size > 54;
#line 390 "Drawing/DockTheme.vala"
	if (is_small) {
#line 390 "Drawing/DockTheme.vala"
		_tmp11_ = 1.0;
#line 1303 "DockTheme.c"
	} else {
		gdouble _tmp12_ = 0.0;
#line 390 "Drawing/DockTheme.vala"
		if (is_large) {
#line 390 "Drawing/DockTheme.vala"
			_tmp12_ = 4.5;
#line 1310 "DockTheme.c"
		} else {
#line 390 "Drawing/DockTheme.vala"
			_tmp12_ = 2.0;
#line 1314 "DockTheme.c"
		}
#line 390 "Drawing/DockTheme.vala"
		_tmp11_ = _tmp12_;
#line 1318 "DockTheme.c"
	}
#line 390 "Drawing/DockTheme.vala"
	padding = _tmp11_;
#line 391 "Drawing/DockTheme.vala"
	if (is_small) {
#line 391 "Drawing/DockTheme.vala"
		_tmp13_ = 0.0;
#line 1326 "DockTheme.c"
	} else {
		gdouble _tmp14_ = 0.0;
#line 391 "Drawing/DockTheme.vala"
		if (is_large) {
#line 391 "Drawing/DockTheme.vala"
			_tmp14_ = 2.0;
#line 1333 "DockTheme.c"
		} else {
#line 391 "Drawing/DockTheme.vala"
			_tmp14_ = 1.0;
#line 1337 "DockTheme.c"
		}
#line 391 "Drawing/DockTheme.vala"
		_tmp13_ = _tmp14_;
#line 1341 "DockTheme.c"
	}
#line 391 "Drawing/DockTheme.vala"
	line_width = _tmp13_;
#line 393 "Drawing/DockTheme.vala"
	if (is_small) {
#line 393 "Drawing/DockTheme.vala"
		_tmp15_ = 0.80;
#line 1349 "DockTheme.c"
	} else {
#line 393 "Drawing/DockTheme.vala"
		_tmp15_ = 0.50;
#line 1353 "DockTheme.c"
	}
#line 393 "Drawing/DockTheme.vala"
	height = floor ((_tmp15_ * icon_size) - (2.0 * line_width));
#line 394 "Drawing/DockTheme.vala"
	_tmp16_ = g_strdup_printf ("%" G_GINT64_FORMAT, count);
#line 394 "Drawing/DockTheme.vala"
	_tmp17_ = _tmp16_;
#line 394 "Drawing/DockTheme.vala"
	_tmp18_ = strlen (_tmp17_);
#line 394 "Drawing/DockTheme.vala"
	_tmp19_ = _tmp18_;
#line 394 "Drawing/DockTheme.vala"
	_tmp20_ = floor ((0.75 + (0.25 * _tmp19_)) * height);
#line 394 "Drawing/DockTheme.vala"
	_g_free0 (_tmp17_);
#line 394 "Drawing/DockTheme.vala"
	width = _tmp20_;
#line 395 "Drawing/DockTheme.vala"
	max_width = icon_size - (2.0 * line_width);
#line 396 "Drawing/DockTheme.vala"
	if (width > max_width) {
#line 397 "Drawing/DockTheme.vala"
		width = max_width;
#line 1377 "DockTheme.c"
	}
#line 400 "Drawing/DockTheme.vala"
	if (gtk_widget_get_default_direction () == GTK_TEXT_DIR_RTL) {
#line 401 "Drawing/DockTheme.vala"
		x += line_width + (line_width / 2.0);
#line 1383 "DockTheme.c"
	} else {
#line 403 "Drawing/DockTheme.vala"
		x += (icon_size - width) - (1.5 * line_width);
#line 1387 "DockTheme.c"
	}
#line 404 "Drawing/DockTheme.vala"
	y += line_width + (line_width / 2.0);
#line 406 "Drawing/DockTheme.vala"
	_tmp21_ = cr;
#line 406 "Drawing/DockTheme.vala"
	cairo_set_line_width (_tmp21_, line_width);
#line 410 "Drawing/DockTheme.vala"
	if (!is_small) {
#line 1397 "DockTheme.c"
		cairo_pattern_t* _tmp22_;
		cairo_t* _tmp23_;
		cairo_pattern_t* _tmp24_;
		cairo_pattern_t* _tmp25_;
		cairo_pattern_t* _tmp26_;
		PlankColor _tmp27_;
		PlankColor _tmp28_;
		PlankColor _tmp29_;
		cairo_pattern_t* _tmp30_;
		PlankColor _tmp31_;
		PlankColor _tmp32_;
		PlankColor _tmp33_;
		cairo_pattern_t* _tmp34_;
		cairo_pattern_t* _tmp35_;
		PlankColor _tmp36_;
		PlankColor _tmp37_;
		PlankColor _tmp38_;
		cairo_pattern_t* _tmp39_;
		PlankColor _tmp40_;
		PlankColor _tmp41_;
		PlankColor _tmp42_;
		cairo_pattern_t* _tmp43_;
		PlankColor _tmp44_;
		PlankColor _tmp45_;
		PlankColor _tmp46_;
		cairo_t* _tmp47_;
		cairo_pattern_t* _tmp48_;
		cairo_pattern_t* _tmp49_;
		cairo_pattern_t* _tmp50_;
		cairo_t* _tmp51_;
		cairo_pattern_t* _tmp52_;
#line 412 "Drawing/DockTheme.vala"
		_tmp22_ = cairo_pattern_create_rgba (0.2, 0.2, 0.2, 0.3);
#line 412 "Drawing/DockTheme.vala"
		_cairo_pattern_destroy0 (stroke);
#line 412 "Drawing/DockTheme.vala"
		stroke = _tmp22_;
#line 413 "Drawing/DockTheme.vala"
		_tmp23_ = cr;
#line 413 "Drawing/DockTheme.vala"
		_tmp24_ = stroke;
#line 413 "Drawing/DockTheme.vala"
		plank_theme_draw_rounded_line (_tmp23_, x, y, width + line_width, height, TRUE, TRUE, _tmp24_, NULL);
#line 416 "Drawing/DockTheme.vala"
		_tmp25_ = cairo_pattern_create_linear ((gdouble) 0, y, (gdouble) 0, y + height);
#line 416 "Drawing/DockTheme.vala"
		_cairo_pattern_destroy0 (stroke);
#line 416 "Drawing/DockTheme.vala"
		stroke = _tmp25_;
#line 417 "Drawing/DockTheme.vala"
		_tmp26_ = stroke;
#line 417 "Drawing/DockTheme.vala"
		_tmp27_ = stroke_color_start;
#line 417 "Drawing/DockTheme.vala"
		_tmp28_ = stroke_color_start;
#line 417 "Drawing/DockTheme.vala"
		_tmp29_ = stroke_color_start;
#line 417 "Drawing/DockTheme.vala"
		cairo_pattern_add_color_stop_rgba (_tmp26_, 0.2, _tmp27_.red, _tmp28_.green, _tmp29_.blue, 0.8);
#line 418 "Drawing/DockTheme.vala"
		_tmp30_ = stroke;
#line 418 "Drawing/DockTheme.vala"
		_tmp31_ = stroke_color_end;
#line 418 "Drawing/DockTheme.vala"
		_tmp32_ = stroke_color_end;
#line 418 "Drawing/DockTheme.vala"
		_tmp33_ = stroke_color_end;
#line 418 "Drawing/DockTheme.vala"
		cairo_pattern_add_color_stop_rgba (_tmp30_, 0.8, _tmp31_.red, _tmp32_.green, _tmp33_.blue, 0.8);
#line 419 "Drawing/DockTheme.vala"
		_tmp34_ = cairo_pattern_create_linear ((gdouble) 0, y, (gdouble) 0, y + height);
#line 419 "Drawing/DockTheme.vala"
		_cairo_pattern_destroy0 (fill);
#line 419 "Drawing/DockTheme.vala"
		fill = _tmp34_;
#line 420 "Drawing/DockTheme.vala"
		_tmp35_ = fill;
#line 420 "Drawing/DockTheme.vala"
		_tmp36_ = badge_color_start;
#line 420 "Drawing/DockTheme.vala"
		_tmp37_ = badge_color_start;
#line 420 "Drawing/DockTheme.vala"
		_tmp38_ = badge_color_start;
#line 420 "Drawing/DockTheme.vala"
		cairo_pattern_add_color_stop_rgba (_tmp35_, 0.1, _tmp36_.red, _tmp37_.green, _tmp38_.blue, 1.0);
#line 421 "Drawing/DockTheme.vala"
		_tmp39_ = fill;
#line 421 "Drawing/DockTheme.vala"
		_tmp40_ = badge_color_middle;
#line 421 "Drawing/DockTheme.vala"
		_tmp41_ = badge_color_middle;
#line 421 "Drawing/DockTheme.vala"
		_tmp42_ = badge_color_middle;
#line 421 "Drawing/DockTheme.vala"
		cairo_pattern_add_color_stop_rgba (_tmp39_, 0.5, _tmp40_.red, _tmp41_.green, _tmp42_.blue, 1.0);
#line 422 "Drawing/DockTheme.vala"
		_tmp43_ = fill;
#line 422 "Drawing/DockTheme.vala"
		_tmp44_ = badge_color_end;
#line 422 "Drawing/DockTheme.vala"
		_tmp45_ = badge_color_end;
#line 422 "Drawing/DockTheme.vala"
		_tmp46_ = badge_color_end;
#line 422 "Drawing/DockTheme.vala"
		cairo_pattern_add_color_stop_rgba (_tmp43_, 0.9, _tmp44_.red, _tmp45_.green, _tmp46_.blue, 1.0);
#line 423 "Drawing/DockTheme.vala"
		_tmp47_ = cr;
#line 423 "Drawing/DockTheme.vala"
		_tmp48_ = stroke;
#line 423 "Drawing/DockTheme.vala"
		_tmp49_ = fill;
#line 423 "Drawing/DockTheme.vala"
		plank_theme_draw_rounded_line (_tmp47_, x, y, width, height, TRUE, TRUE, _tmp48_, _tmp49_);
#line 426 "Drawing/DockTheme.vala"
		_tmp50_ = cairo_pattern_create_rgba (0.9, 0.9, 0.9, 0.1);
#line 426 "Drawing/DockTheme.vala"
		_cairo_pattern_destroy0 (stroke);
#line 426 "Drawing/DockTheme.vala"
		stroke = _tmp50_;
#line 427 "Drawing/DockTheme.vala"
		_tmp51_ = cr;
#line 427 "Drawing/DockTheme.vala"
		_tmp52_ = stroke;
#line 427 "Drawing/DockTheme.vala"
		plank_theme_draw_rounded_line (_tmp51_, x + line_width, y + line_width, width - (2 * line_width), height - (2 * line_width), TRUE, TRUE, _tmp52_, NULL);
#line 1523 "DockTheme.c"
	}
#line 430 "Drawing/DockTheme.vala"
	_tmp53_ = gdk_pango_context_get ();
#line 430 "Drawing/DockTheme.vala"
	_tmp54_ = _tmp53_;
#line 430 "Drawing/DockTheme.vala"
	_tmp55_ = pango_layout_new (_tmp54_);
#line 430 "Drawing/DockTheme.vala"
	_tmp56_ = _tmp55_;
#line 430 "Drawing/DockTheme.vala"
	_g_object_unref0 (_tmp54_);
#line 430 "Drawing/DockTheme.vala"
	layout = _tmp56_;
#line 431 "Drawing/DockTheme.vala"
	_tmp57_ = layout;
#line 431 "Drawing/DockTheme.vala"
	pango_layout_set_width (_tmp57_, (gint) (width * PANGO_SCALE));
#line 432 "Drawing/DockTheme.vala"
	_tmp58_ = layout;
#line 432 "Drawing/DockTheme.vala"
	pango_layout_set_ellipsize (_tmp58_, PANGO_ELLIPSIZE_NONE);
#line 434 "Drawing/DockTheme.vala"
	_tmp59_ = plank_theme_get_style_context ((PlankTheme*) self);
#line 434 "Drawing/DockTheme.vala"
	style_context = _tmp59_;
#line 435 "Drawing/DockTheme.vala"
	_tmp60_ = style_context;
#line 435 "Drawing/DockTheme.vala"
	_tmp61_ = style_context;
#line 435 "Drawing/DockTheme.vala"
	_tmp62_ = gtk_style_context_get_font (_tmp60_, gtk_style_context_get_state (_tmp61_));
#line 435 "Drawing/DockTheme.vala"
	font_description = _tmp62_;
#line 436 "Drawing/DockTheme.vala"
	_tmp63_ = font_description;
#line 436 "Drawing/DockTheme.vala"
	pango_font_description_set_absolute_size (_tmp63_, (gdouble) ((gint) (height * PANGO_SCALE)));
#line 437 "Drawing/DockTheme.vala"
	_tmp64_ = font_description;
#line 437 "Drawing/DockTheme.vala"
	pango_font_description_set_weight (_tmp64_, PANGO_WEIGHT_BOLD);
#line 438 "Drawing/DockTheme.vala"
	_tmp65_ = layout;
#line 438 "Drawing/DockTheme.vala"
	_tmp66_ = font_description;
#line 438 "Drawing/DockTheme.vala"
	pango_layout_set_font_description (_tmp65_, _tmp66_);
#line 440 "Drawing/DockTheme.vala"
	_tmp67_ = layout;
#line 440 "Drawing/DockTheme.vala"
	_tmp68_ = g_strdup_printf ("%" G_GINT64_FORMAT, count);
#line 440 "Drawing/DockTheme.vala"
	_tmp69_ = _tmp68_;
#line 440 "Drawing/DockTheme.vala"
	pango_layout_set_text (_tmp67_, _tmp69_, -1);
#line 440 "Drawing/DockTheme.vala"
	_g_free0 (_tmp69_);
#line 442 "Drawing/DockTheme.vala"
	_tmp70_ = layout;
#line 442 "Drawing/DockTheme.vala"
	pango_layout_get_pixel_extents (_tmp70_, NULL, &_tmp71_);
#line 442 "Drawing/DockTheme.vala"
	logical_rect = _tmp71_;
#line 444 "Drawing/DockTheme.vala"
	_tmp72_ = logical_rect;
#line 444 "Drawing/DockTheme.vala"
	_tmp73_ = logical_rect;
#line 444 "Drawing/DockTheme.vala"
	scale = MIN (1.0, MIN (((width - (2.0 * padding)) - (2.0 * line_width)) / ((gdouble) _tmp72_.width), (height - (2.0 * padding)) / ((gdouble) _tmp73_.height)));
#line 446 "Drawing/DockTheme.vala"
	if (!is_small) {
#line 1595 "DockTheme.c"
		cairo_t* _tmp74_;
#line 447 "Drawing/DockTheme.vala"
		_tmp74_ = cr;
#line 447 "Drawing/DockTheme.vala"
		cairo_set_source_rgba (_tmp74_, 0.0, 0.0, 0.0, 0.2);
#line 1601 "DockTheme.c"
	} else {
		cairo_t* _tmp75_;
#line 449 "Drawing/DockTheme.vala"
		_tmp75_ = cr;
#line 449 "Drawing/DockTheme.vala"
		cairo_set_source_rgba (_tmp75_, 0.0, 0.0, 0.0, 0.6);
#line 1608 "DockTheme.c"
	}
#line 451 "Drawing/DockTheme.vala"
	_tmp76_ = cr;
#line 451 "Drawing/DockTheme.vala"
	_tmp77_ = logical_rect;
#line 451 "Drawing/DockTheme.vala"
	_tmp78_ = logical_rect;
#line 451 "Drawing/DockTheme.vala"
	cairo_move_to (_tmp76_, x + floor ((width / 2.0) - ((scale * _tmp77_.width) / 2.0)), y + floor ((height / 2.0) - ((scale * _tmp78_.height) / 2.0)));
#line 454 "Drawing/DockTheme.vala"
	_tmp79_ = cr;
#line 454 "Drawing/DockTheme.vala"
	cairo_save (_tmp79_);
#line 455 "Drawing/DockTheme.vala"
	if (scale < ((gdouble) 1)) {
#line 1624 "DockTheme.c"
		cairo_t* _tmp80_;
#line 456 "Drawing/DockTheme.vala"
		_tmp80_ = cr;
#line 456 "Drawing/DockTheme.vala"
		cairo_scale (_tmp80_, scale, scale);
#line 1630 "DockTheme.c"
	}
#line 458 "Drawing/DockTheme.vala"
	_tmp81_ = cr;
#line 458 "Drawing/DockTheme.vala"
	cairo_set_line_width (_tmp81_, line_width);
#line 459 "Drawing/DockTheme.vala"
	_tmp82_ = cr;
#line 459 "Drawing/DockTheme.vala"
	_tmp83_ = layout;
#line 459 "Drawing/DockTheme.vala"
	pango_cairo_layout_path (_tmp82_, _tmp83_);
#line 460 "Drawing/DockTheme.vala"
	_tmp84_ = cr;
#line 460 "Drawing/DockTheme.vala"
	cairo_stroke_preserve (_tmp84_);
#line 461 "Drawing/DockTheme.vala"
	_tmp85_ = cr;
#line 461 "Drawing/DockTheme.vala"
	cairo_set_source_rgba (_tmp85_, 1.0, 1.0, 1.0, 0.95);
#line 462 "Drawing/DockTheme.vala"
	_tmp86_ = cr;
#line 462 "Drawing/DockTheme.vala"
	cairo_fill (_tmp86_);
#line 463 "Drawing/DockTheme.vala"
	_tmp87_ = cr;
#line 463 "Drawing/DockTheme.vala"
	cairo_restore (_tmp87_);
#line 365 "Drawing/DockTheme.vala"
	_g_object_unref0 (layout);
#line 365 "Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (fill);
#line 365 "Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (stroke);
#line 1664 "DockTheme.c"
}

/**
 * Draws a progress bar for an item.
 *
 * @param surface the surface to draw the progress onto
 * @param icon_size the icon-size of the dock
 * @param color the color of the progress
 * @param progress the value between 0.0 and 1.0
 */
void
plank_dock_theme_draw_item_progress (PlankDockTheme* self,
                                     PlankSurface* surface,
                                     gint icon_size,
                                     PlankColor* color,
                                     gdouble progress)
{
	cairo_t* cr = NULL;
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	gdouble x = 0.0;
	gint _tmp2_;
	gint _tmp3_;
	gdouble y = 0.0;
	gint _tmp4_;
	gint _tmp5_;
	gdouble line_width = 0.0;
	gdouble padding = 0.0;
	gdouble width = 0.0;
	gdouble height = 0.0;
	cairo_t* _tmp6_;
	cairo_pattern_t* stroke = NULL;
	cairo_pattern_t* fill = NULL;
	cairo_pattern_t* _tmp7_;
	cairo_pattern_t* _tmp8_;
	cairo_pattern_t* _tmp9_;
	cairo_t* _tmp10_;
	cairo_pattern_t* _tmp11_;
	cairo_pattern_t* _tmp12_;
	cairo_pattern_t* _tmp13_;
	cairo_pattern_t* _tmp14_;
	cairo_pattern_t* _tmp15_;
	cairo_t* _tmp16_;
	cairo_pattern_t* _tmp17_;
	cairo_pattern_t* _tmp18_;
	gdouble finished_width = 0.0;
	cairo_pattern_t* _tmp19_;
	cairo_pattern_t* _tmp20_;
#line 475 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 475 "Drawing/DockTheme.vala"
	g_return_if_fail (surface != NULL);
#line 475 "Drawing/DockTheme.vala"
	g_return_if_fail (color != NULL);
#line 477 "Drawing/DockTheme.vala"
	if (progress < ((gdouble) 0)) {
#line 478 "Drawing/DockTheme.vala"
		return;
#line 1723 "DockTheme.c"
	}
#line 480 "Drawing/DockTheme.vala"
	if (progress > 1.0) {
#line 481 "Drawing/DockTheme.vala"
		progress = 1.0;
#line 1729 "DockTheme.c"
	}
#line 483 "Drawing/DockTheme.vala"
	_tmp0_ = plank_surface_get_Context (surface);
#line 483 "Drawing/DockTheme.vala"
	_tmp1_ = _tmp0_;
#line 483 "Drawing/DockTheme.vala"
	cr = _tmp1_;
#line 487 "Drawing/DockTheme.vala"
	_tmp2_ = plank_surface_get_Width (surface);
#line 487 "Drawing/DockTheme.vala"
	_tmp3_ = _tmp2_;
#line 487 "Drawing/DockTheme.vala"
	x = floor ((gdouble) ((_tmp3_ - icon_size) / 2));
#line 488 "Drawing/DockTheme.vala"
	_tmp4_ = plank_surface_get_Height (surface);
#line 488 "Drawing/DockTheme.vala"
	_tmp5_ = _tmp4_;
#line 488 "Drawing/DockTheme.vala"
	y = floor ((gdouble) ((_tmp5_ - icon_size) / 2));
#line 491 "Drawing/DockTheme.vala"
	line_width = 1.0;
#line 492 "Drawing/DockTheme.vala"
	padding = 4.0;
#line 493 "Drawing/DockTheme.vala"
	width = icon_size - (2.0 * padding);
#line 494 "Drawing/DockTheme.vala"
	height = floor (MIN (18.0, (gdouble) ((gint) (0.15 * icon_size))));
#line 495 "Drawing/DockTheme.vala"
	x += padding;
#line 496 "Drawing/DockTheme.vala"
	y += (icon_size - height) - padding;
#line 498 "Drawing/DockTheme.vala"
	_tmp6_ = cr;
#line 498 "Drawing/DockTheme.vala"
	cairo_set_line_width (_tmp6_, line_width);
#line 503 "Drawing/DockTheme.vala"
	_tmp7_ = cairo_pattern_create_linear ((gdouble) 0, y, (gdouble) 0, y + height);
#line 503 "Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (stroke);
#line 503 "Drawing/DockTheme.vala"
	stroke = _tmp7_;
#line 504 "Drawing/DockTheme.vala"
	_tmp8_ = stroke;
#line 504 "Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp8_, 0.5, 0.5, 0.5, 0.5, 0.1);
#line 505 "Drawing/DockTheme.vala"
	_tmp9_ = stroke;
#line 505 "Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp9_, 0.9, 0.8, 0.8, 0.8, 0.4);
#line 506 "Drawing/DockTheme.vala"
	_tmp10_ = cr;
#line 506 "Drawing/DockTheme.vala"
	_tmp11_ = stroke;
#line 506 "Drawing/DockTheme.vala"
	plank_theme_draw_rounded_line (_tmp10_, x + (line_width / 2.0), y + (line_width / 2.0), width, height, TRUE, TRUE, _tmp11_, NULL);
#line 509 "Drawing/DockTheme.vala"
	x += line_width;
#line 510 "Drawing/DockTheme.vala"
	y += line_width;
#line 511 "Drawing/DockTheme.vala"
	width -= 2.0 * line_width;
#line 512 "Drawing/DockTheme.vala"
	height -= 2.0 * line_width;
#line 514 "Drawing/DockTheme.vala"
	_tmp12_ = cairo_pattern_create_rgba (0.20, 0.20, 0.20, 0.9);
#line 514 "Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (stroke);
#line 514 "Drawing/DockTheme.vala"
	stroke = _tmp12_;
#line 515 "Drawing/DockTheme.vala"
	_tmp13_ = cairo_pattern_create_linear ((gdouble) 0, y, (gdouble) 0, y + height);
#line 515 "Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (fill);
#line 515 "Drawing/DockTheme.vala"
	fill = _tmp13_;
#line 516 "Drawing/DockTheme.vala"
	_tmp14_ = fill;
#line 516 "Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp14_, 0.4, 0.25, 0.25, 0.25, 1.0);
#line 517 "Drawing/DockTheme.vala"
	_tmp15_ = fill;
#line 517 "Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp15_, 0.9, 0.35, 0.35, 0.35, 1.0);
#line 518 "Drawing/DockTheme.vala"
	_tmp16_ = cr;
#line 518 "Drawing/DockTheme.vala"
	_tmp17_ = stroke;
#line 518 "Drawing/DockTheme.vala"
	_tmp18_ = fill;
#line 518 "Drawing/DockTheme.vala"
	plank_theme_draw_rounded_line (_tmp16_, x + (line_width / 2.0), y + (line_width / 2.0), width, height, TRUE, TRUE, _tmp17_, _tmp18_);
#line 521 "Drawing/DockTheme.vala"
	x += line_width;
#line 522 "Drawing/DockTheme.vala"
	y += line_width;
#line 523 "Drawing/DockTheme.vala"
	width -= 2.0 * line_width;
#line 524 "Drawing/DockTheme.vala"
	height -= 2.0 * line_width;
#line 526 "Drawing/DockTheme.vala"
	finished_width = ceil (progress * width);
#line 527 "Drawing/DockTheme.vala"
	_tmp19_ = cairo_pattern_create_rgba (0.8, 0.8, 0.8, 1.0);
#line 527 "Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (stroke);
#line 527 "Drawing/DockTheme.vala"
	stroke = _tmp19_;
#line 528 "Drawing/DockTheme.vala"
	_tmp20_ = cairo_pattern_create_rgba (0.9, 0.9, 0.9, 1.0);
#line 528 "Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (fill);
#line 528 "Drawing/DockTheme.vala"
	fill = _tmp20_;
#line 531 "Drawing/DockTheme.vala"
	if (gtk_widget_get_default_direction () == GTK_TEXT_DIR_RTL) {
#line 1845 "DockTheme.c"
		cairo_t* _tmp21_;
		cairo_pattern_t* _tmp22_;
		cairo_pattern_t* _tmp23_;
#line 532 "Drawing/DockTheme.vala"
		_tmp21_ = cr;
#line 532 "Drawing/DockTheme.vala"
		_tmp22_ = stroke;
#line 532 "Drawing/DockTheme.vala"
		_tmp23_ = fill;
#line 532 "Drawing/DockTheme.vala"
		plank_theme_draw_rounded_line (_tmp21_, ((x + (line_width / 2.0)) + width) - finished_width, y + (line_width / 2.0), finished_width, height, TRUE, TRUE, _tmp22_, _tmp23_);
#line 1857 "DockTheme.c"
	} else {
		cairo_t* _tmp24_;
		cairo_pattern_t* _tmp25_;
		cairo_pattern_t* _tmp26_;
#line 534 "Drawing/DockTheme.vala"
		_tmp24_ = cr;
#line 534 "Drawing/DockTheme.vala"
		_tmp25_ = stroke;
#line 534 "Drawing/DockTheme.vala"
		_tmp26_ = fill;
#line 534 "Drawing/DockTheme.vala"
		plank_theme_draw_rounded_line (_tmp24_, x + (line_width / 2.0), y + (line_width / 2.0), finished_width, height, TRUE, TRUE, _tmp25_, _tmp26_);
#line 1870 "DockTheme.c"
	}
#line 475 "Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (fill);
#line 475 "Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (stroke);
#line 1876 "DockTheme.c"
}

/**
 * {@inheritDoc}
 */
static void
plank_dock_theme_real_verify (PlankPreferences* base,
                              const gchar* prop)
{
	PlankDockTheme * self;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label0 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label1 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label2 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label3 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label4 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label5 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label6 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label7 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label8 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label9 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label10 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label11 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label12 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label13 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label14 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label15 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label16 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label17 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label18 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label19 = 0;
#line 544 "Drawing/DockTheme.vala"
	static GQuark _tmp1_label20 = 0;
#line 540 "Drawing/DockTheme.vala"
	self = (PlankDockTheme*) base;
#line 540 "Drawing/DockTheme.vala"
	g_return_if_fail (prop != NULL);
#line 542 "Drawing/DockTheme.vala"
	PLANK_PREFERENCES_CLASS (plank_dock_theme_parent_class)->verify ((PlankPreferences*) G_TYPE_CHECK_INSTANCE_CAST (self, PLANK_TYPE_THEME, PlankTheme), prop);
#line 544 "Drawing/DockTheme.vala"
	_tmp0_ = prop;
#line 544 "Drawing/DockTheme.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 544 "Drawing/DockTheme.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("HorizPadding")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 1945 "DockTheme.c"
			default:
			{
#line 546 "Drawing/DockTheme.vala"
				break;
#line 1950 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("TopPadding")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 1956 "DockTheme.c"
			default:
			{
#line 549 "Drawing/DockTheme.vala"
				break;
#line 1961 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("BottomPadding")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 1967 "DockTheme.c"
			default:
			{
				gdouble _tmp3_;
#line 552 "Drawing/DockTheme.vala"
				_tmp3_ = self->priv->_BottomPadding;
#line 552 "Drawing/DockTheme.vala"
				if (_tmp3_ < ((gdouble) 0)) {
#line 553 "Drawing/DockTheme.vala"
					plank_dock_theme_set_BottomPadding (self, (gdouble) 0);
#line 1977 "DockTheme.c"
				}
#line 554 "Drawing/DockTheme.vala"
				break;
#line 1981 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("ItemPadding")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 1987 "DockTheme.c"
			default:
			{
				gdouble _tmp4_;
#line 557 "Drawing/DockTheme.vala"
				_tmp4_ = self->priv->_ItemPadding;
#line 557 "Drawing/DockTheme.vala"
				if (_tmp4_ < ((gdouble) 0)) {
#line 558 "Drawing/DockTheme.vala"
					plank_dock_theme_set_ItemPadding (self, (gdouble) 0);
#line 1997 "DockTheme.c"
				}
#line 559 "Drawing/DockTheme.vala"
				break;
#line 2001 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("IndicatorSize")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 2007 "DockTheme.c"
			default:
			{
				gdouble _tmp5_;
#line 562 "Drawing/DockTheme.vala"
				_tmp5_ = self->priv->_IndicatorSize;
#line 562 "Drawing/DockTheme.vala"
				if (_tmp5_ < PLANK_DOCK_THEME_MIN_INDICATOR_SIZE) {
#line 563 "Drawing/DockTheme.vala"
					plank_dock_theme_set_IndicatorSize (self, PLANK_DOCK_THEME_MIN_INDICATOR_SIZE);
#line 2017 "DockTheme.c"
				} else {
					gdouble _tmp6_;
#line 564 "Drawing/DockTheme.vala"
					_tmp6_ = self->priv->_IndicatorSize;
#line 564 "Drawing/DockTheme.vala"
					if (_tmp6_ > PLANK_DOCK_THEME_MAX_INDICATOR_SIZE) {
#line 565 "Drawing/DockTheme.vala"
						plank_dock_theme_set_IndicatorSize (self, PLANK_DOCK_THEME_MAX_INDICATOR_SIZE);
#line 2026 "DockTheme.c"
					}
				}
#line 566 "Drawing/DockTheme.vala"
				break;
#line 2031 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("IconShadowSize")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 2037 "DockTheme.c"
			default:
			{
				gdouble _tmp7_;
#line 569 "Drawing/DockTheme.vala"
				_tmp7_ = self->priv->_IconShadowSize;
#line 569 "Drawing/DockTheme.vala"
				if (_tmp7_ < ((gdouble) 0)) {
#line 570 "Drawing/DockTheme.vala"
					plank_dock_theme_set_IconShadowSize (self, (gdouble) 0);
#line 2047 "DockTheme.c"
				} else {
					gdouble _tmp8_;
#line 571 "Drawing/DockTheme.vala"
					_tmp8_ = self->priv->_IconShadowSize;
#line 571 "Drawing/DockTheme.vala"
					if (_tmp8_ > PLANK_DOCK_THEME_MAX_ICON_SHADOW_SIZE) {
#line 572 "Drawing/DockTheme.vala"
						plank_dock_theme_set_IconShadowSize (self, PLANK_DOCK_THEME_MAX_ICON_SHADOW_SIZE);
#line 2056 "DockTheme.c"
					}
				}
#line 573 "Drawing/DockTheme.vala"
				break;
#line 2061 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label6) ? _tmp1_label6 : (_tmp1_label6 = g_quark_from_static_string ("UrgentBounceHeight")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 2067 "DockTheme.c"
			default:
			{
				gdouble _tmp9_;
#line 576 "Drawing/DockTheme.vala"
				_tmp9_ = self->priv->_UrgentBounceHeight;
#line 576 "Drawing/DockTheme.vala"
				if (_tmp9_ < ((gdouble) 0)) {
#line 577 "Drawing/DockTheme.vala"
					plank_dock_theme_set_UrgentBounceHeight (self, (gdouble) 0);
#line 2077 "DockTheme.c"
				}
#line 578 "Drawing/DockTheme.vala"
				break;
#line 2081 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label7) ? _tmp1_label7 : (_tmp1_label7 = g_quark_from_static_string ("LaunchBounceHeight")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 2087 "DockTheme.c"
			default:
			{
				gdouble _tmp10_;
#line 581 "Drawing/DockTheme.vala"
				_tmp10_ = self->priv->_LaunchBounceHeight;
#line 581 "Drawing/DockTheme.vala"
				if (_tmp10_ < ((gdouble) 0)) {
#line 582 "Drawing/DockTheme.vala"
					plank_dock_theme_set_LaunchBounceHeight (self, (gdouble) 0);
#line 2097 "DockTheme.c"
				}
#line 583 "Drawing/DockTheme.vala"
				break;
#line 2101 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label8) ? _tmp1_label8 : (_tmp1_label8 = g_quark_from_static_string ("FadeOpacity")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 2107 "DockTheme.c"
			default:
			{
				gdouble _tmp11_;
#line 586 "Drawing/DockTheme.vala"
				_tmp11_ = self->priv->_FadeOpacity;
#line 586 "Drawing/DockTheme.vala"
				if (_tmp11_ < ((gdouble) 0)) {
#line 587 "Drawing/DockTheme.vala"
					plank_dock_theme_set_FadeOpacity (self, (gdouble) 0);
#line 2117 "DockTheme.c"
				} else {
					gdouble _tmp12_;
#line 588 "Drawing/DockTheme.vala"
					_tmp12_ = self->priv->_FadeOpacity;
#line 588 "Drawing/DockTheme.vala"
					if (_tmp12_ > ((gdouble) 1)) {
#line 589 "Drawing/DockTheme.vala"
						plank_dock_theme_set_FadeOpacity (self, (gdouble) 1);
#line 2126 "DockTheme.c"
					}
				}
#line 590 "Drawing/DockTheme.vala"
				break;
#line 2131 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label9) ? _tmp1_label9 : (_tmp1_label9 = g_quark_from_static_string ("ClickTime")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 2137 "DockTheme.c"
			default:
			{
				gint _tmp13_;
#line 593 "Drawing/DockTheme.vala"
				_tmp13_ = self->priv->_ClickTime;
#line 593 "Drawing/DockTheme.vala"
				if (_tmp13_ < 0) {
#line 594 "Drawing/DockTheme.vala"
					plank_dock_theme_set_ClickTime (self, 0);
#line 2147 "DockTheme.c"
				}
#line 595 "Drawing/DockTheme.vala"
				break;
#line 2151 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label10) ? _tmp1_label10 : (_tmp1_label10 = g_quark_from_static_string ("UrgentBounceTime")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 2157 "DockTheme.c"
			default:
			{
				gint _tmp14_;
#line 598 "Drawing/DockTheme.vala"
				_tmp14_ = self->priv->_UrgentBounceTime;
#line 598 "Drawing/DockTheme.vala"
				if (_tmp14_ < 0) {
#line 599 "Drawing/DockTheme.vala"
					plank_dock_theme_set_UrgentBounceTime (self, 0);
#line 2167 "DockTheme.c"
				}
#line 600 "Drawing/DockTheme.vala"
				break;
#line 2171 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label11) ? _tmp1_label11 : (_tmp1_label11 = g_quark_from_static_string ("LaunchBounceTime")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 2177 "DockTheme.c"
			default:
			{
				gint _tmp15_;
#line 603 "Drawing/DockTheme.vala"
				_tmp15_ = self->priv->_LaunchBounceTime;
#line 603 "Drawing/DockTheme.vala"
				if (_tmp15_ < 0) {
#line 604 "Drawing/DockTheme.vala"
					plank_dock_theme_set_LaunchBounceTime (self, 0);
#line 2187 "DockTheme.c"
				}
#line 605 "Drawing/DockTheme.vala"
				break;
#line 2191 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label12) ? _tmp1_label12 : (_tmp1_label12 = g_quark_from_static_string ("ActiveTime")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 2197 "DockTheme.c"
			default:
			{
				gint _tmp16_;
#line 608 "Drawing/DockTheme.vala"
				_tmp16_ = self->priv->_ActiveTime;
#line 608 "Drawing/DockTheme.vala"
				if (_tmp16_ < 0) {
#line 609 "Drawing/DockTheme.vala"
					plank_dock_theme_set_ActiveTime (self, 0);
#line 2207 "DockTheme.c"
				}
#line 610 "Drawing/DockTheme.vala"
				break;
#line 2211 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label13) ? _tmp1_label13 : (_tmp1_label13 = g_quark_from_static_string ("SlideTime")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 2217 "DockTheme.c"
			default:
			{
				gint _tmp17_;
#line 613 "Drawing/DockTheme.vala"
				_tmp17_ = self->priv->_SlideTime;
#line 613 "Drawing/DockTheme.vala"
				if (_tmp17_ < 0) {
#line 614 "Drawing/DockTheme.vala"
					plank_dock_theme_set_SlideTime (self, 0);
#line 2227 "DockTheme.c"
				}
#line 615 "Drawing/DockTheme.vala"
				break;
#line 2231 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label14) ? _tmp1_label14 : (_tmp1_label14 = g_quark_from_static_string ("FadeTime")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 2237 "DockTheme.c"
			default:
			{
				gint _tmp18_;
#line 618 "Drawing/DockTheme.vala"
				_tmp18_ = self->priv->_FadeTime;
#line 618 "Drawing/DockTheme.vala"
				if (_tmp18_ < 0) {
#line 619 "Drawing/DockTheme.vala"
					plank_dock_theme_set_FadeTime (self, 0);
#line 2247 "DockTheme.c"
				}
#line 620 "Drawing/DockTheme.vala"
				break;
#line 2251 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label15) ? _tmp1_label15 : (_tmp1_label15 = g_quark_from_static_string ("HideTime")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 2257 "DockTheme.c"
			default:
			{
				gint _tmp19_;
#line 623 "Drawing/DockTheme.vala"
				_tmp19_ = self->priv->_HideTime;
#line 623 "Drawing/DockTheme.vala"
				if (_tmp19_ < 0) {
#line 624 "Drawing/DockTheme.vala"
					plank_dock_theme_set_HideTime (self, 0);
#line 2267 "DockTheme.c"
				}
#line 625 "Drawing/DockTheme.vala"
				break;
#line 2271 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label16) ? _tmp1_label16 : (_tmp1_label16 = g_quark_from_static_string ("GlowSize")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 2277 "DockTheme.c"
			default:
			{
				gint _tmp20_;
#line 628 "Drawing/DockTheme.vala"
				_tmp20_ = self->priv->_GlowSize;
#line 628 "Drawing/DockTheme.vala"
				if (_tmp20_ < 0) {
#line 629 "Drawing/DockTheme.vala"
					plank_dock_theme_set_GlowSize (self, 0);
#line 2287 "DockTheme.c"
				}
#line 630 "Drawing/DockTheme.vala"
				break;
#line 2291 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label17) ? _tmp1_label17 : (_tmp1_label17 = g_quark_from_static_string ("GlowTime")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 2297 "DockTheme.c"
			default:
			{
				gint _tmp21_;
#line 633 "Drawing/DockTheme.vala"
				_tmp21_ = self->priv->_GlowTime;
#line 633 "Drawing/DockTheme.vala"
				if (_tmp21_ < 0) {
#line 634 "Drawing/DockTheme.vala"
					plank_dock_theme_set_GlowTime (self, 0);
#line 2307 "DockTheme.c"
				}
#line 635 "Drawing/DockTheme.vala"
				break;
#line 2311 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label18) ? _tmp1_label18 : (_tmp1_label18 = g_quark_from_static_string ("GlowPulseTime")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 2317 "DockTheme.c"
			default:
			{
				gint _tmp22_;
#line 638 "Drawing/DockTheme.vala"
				_tmp22_ = self->priv->_GlowPulseTime;
#line 638 "Drawing/DockTheme.vala"
				if (_tmp22_ < 0) {
#line 639 "Drawing/DockTheme.vala"
					plank_dock_theme_set_GlowPulseTime (self, 0);
#line 2327 "DockTheme.c"
				}
#line 640 "Drawing/DockTheme.vala"
				break;
#line 2331 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label19) ? _tmp1_label19 : (_tmp1_label19 = g_quark_from_static_string ("UrgentHueShift")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 2337 "DockTheme.c"
			default:
			{
				gint _tmp23_;
#line 643 "Drawing/DockTheme.vala"
				_tmp23_ = self->priv->_UrgentHueShift;
#line 643 "Drawing/DockTheme.vala"
				if (_tmp23_ < -180) {
#line 644 "Drawing/DockTheme.vala"
					plank_dock_theme_set_UrgentHueShift (self, -180);
#line 2347 "DockTheme.c"
				} else {
					gint _tmp24_;
#line 645 "Drawing/DockTheme.vala"
					_tmp24_ = self->priv->_UrgentHueShift;
#line 645 "Drawing/DockTheme.vala"
					if (_tmp24_ > 180) {
#line 646 "Drawing/DockTheme.vala"
						plank_dock_theme_set_UrgentHueShift (self, 180);
#line 2356 "DockTheme.c"
					}
				}
#line 647 "Drawing/DockTheme.vala"
				break;
#line 2361 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label20) ? _tmp1_label20 : (_tmp1_label20 = g_quark_from_static_string ("BadgeColor")))) {
#line 544 "Drawing/DockTheme.vala"
		switch (0) {
#line 2367 "DockTheme.c"
			default:
			{
#line 650 "Drawing/DockTheme.vala"
				break;
#line 2372 "DockTheme.c"
			}
		}
	}
}

gdouble
plank_dock_theme_get_HorizPadding (PlankDockTheme* self)
{
	gdouble result;
#line 32 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 32 "Drawing/DockTheme.vala"
	result = self->priv->_HorizPadding;
#line 32 "Drawing/DockTheme.vala"
	return result;
#line 2388 "DockTheme.c"
}

void
plank_dock_theme_set_HorizPadding (PlankDockTheme* self,
                                   gdouble value)
{
	gdouble old_value;
#line 32 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 32 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_HorizPadding (self);
#line 32 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 32 "Drawing/DockTheme.vala"
		self->priv->_HorizPadding = value;
#line 32 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_HORIZ_PADDING_PROPERTY]);
#line 2406 "DockTheme.c"
	}
}

gdouble
plank_dock_theme_get_TopPadding (PlankDockTheme* self)
{
	gdouble result;
#line 35 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 35 "Drawing/DockTheme.vala"
	result = self->priv->_TopPadding;
#line 35 "Drawing/DockTheme.vala"
	return result;
#line 2420 "DockTheme.c"
}

void
plank_dock_theme_set_TopPadding (PlankDockTheme* self,
                                 gdouble value)
{
	gdouble old_value;
#line 35 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 35 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_TopPadding (self);
#line 35 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 35 "Drawing/DockTheme.vala"
		self->priv->_TopPadding = value;
#line 35 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_TOP_PADDING_PROPERTY]);
#line 2438 "DockTheme.c"
	}
}

gdouble
plank_dock_theme_get_BottomPadding (PlankDockTheme* self)
{
	gdouble result;
#line 38 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 38 "Drawing/DockTheme.vala"
	result = self->priv->_BottomPadding;
#line 38 "Drawing/DockTheme.vala"
	return result;
#line 2452 "DockTheme.c"
}

void
plank_dock_theme_set_BottomPadding (PlankDockTheme* self,
                                    gdouble value)
{
	gdouble old_value;
#line 38 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 38 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_BottomPadding (self);
#line 38 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 38 "Drawing/DockTheme.vala"
		self->priv->_BottomPadding = value;
#line 38 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_BOTTOM_PADDING_PROPERTY]);
#line 2470 "DockTheme.c"
	}
}

gdouble
plank_dock_theme_get_ItemPadding (PlankDockTheme* self)
{
	gdouble result;
#line 41 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 41 "Drawing/DockTheme.vala"
	result = self->priv->_ItemPadding;
#line 41 "Drawing/DockTheme.vala"
	return result;
#line 2484 "DockTheme.c"
}

void
plank_dock_theme_set_ItemPadding (PlankDockTheme* self,
                                  gdouble value)
{
	gdouble old_value;
#line 41 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 41 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_ItemPadding (self);
#line 41 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 41 "Drawing/DockTheme.vala"
		self->priv->_ItemPadding = value;
#line 41 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_ITEM_PADDING_PROPERTY]);
#line 2502 "DockTheme.c"
	}
}

gdouble
plank_dock_theme_get_IndicatorSize (PlankDockTheme* self)
{
	gdouble result;
#line 44 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 44 "Drawing/DockTheme.vala"
	result = self->priv->_IndicatorSize;
#line 44 "Drawing/DockTheme.vala"
	return result;
#line 2516 "DockTheme.c"
}

void
plank_dock_theme_set_IndicatorSize (PlankDockTheme* self,
                                    gdouble value)
{
	gdouble old_value;
#line 44 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 44 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_IndicatorSize (self);
#line 44 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 44 "Drawing/DockTheme.vala"
		self->priv->_IndicatorSize = value;
#line 44 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_INDICATOR_SIZE_PROPERTY]);
#line 2534 "DockTheme.c"
	}
}

gdouble
plank_dock_theme_get_IconShadowSize (PlankDockTheme* self)
{
	gdouble result;
#line 47 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 47 "Drawing/DockTheme.vala"
	result = self->priv->_IconShadowSize;
#line 47 "Drawing/DockTheme.vala"
	return result;
#line 2548 "DockTheme.c"
}

void
plank_dock_theme_set_IconShadowSize (PlankDockTheme* self,
                                     gdouble value)
{
	gdouble old_value;
#line 47 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 47 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_IconShadowSize (self);
#line 47 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 47 "Drawing/DockTheme.vala"
		self->priv->_IconShadowSize = value;
#line 47 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_ICON_SHADOW_SIZE_PROPERTY]);
#line 2566 "DockTheme.c"
	}
}

gdouble
plank_dock_theme_get_UrgentBounceHeight (PlankDockTheme* self)
{
	gdouble result;
#line 50 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 50 "Drawing/DockTheme.vala"
	result = self->priv->_UrgentBounceHeight;
#line 50 "Drawing/DockTheme.vala"
	return result;
#line 2580 "DockTheme.c"
}

void
plank_dock_theme_set_UrgentBounceHeight (PlankDockTheme* self,
                                         gdouble value)
{
	gdouble old_value;
#line 50 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 50 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_UrgentBounceHeight (self);
#line 50 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 50 "Drawing/DockTheme.vala"
		self->priv->_UrgentBounceHeight = value;
#line 50 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_URGENT_BOUNCE_HEIGHT_PROPERTY]);
#line 2598 "DockTheme.c"
	}
}

gdouble
plank_dock_theme_get_LaunchBounceHeight (PlankDockTheme* self)
{
	gdouble result;
#line 53 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 53 "Drawing/DockTheme.vala"
	result = self->priv->_LaunchBounceHeight;
#line 53 "Drawing/DockTheme.vala"
	return result;
#line 2612 "DockTheme.c"
}

void
plank_dock_theme_set_LaunchBounceHeight (PlankDockTheme* self,
                                         gdouble value)
{
	gdouble old_value;
#line 53 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 53 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_LaunchBounceHeight (self);
#line 53 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 53 "Drawing/DockTheme.vala"
		self->priv->_LaunchBounceHeight = value;
#line 53 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_LAUNCH_BOUNCE_HEIGHT_PROPERTY]);
#line 2630 "DockTheme.c"
	}
}

gdouble
plank_dock_theme_get_FadeOpacity (PlankDockTheme* self)
{
	gdouble result;
#line 56 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 56 "Drawing/DockTheme.vala"
	result = self->priv->_FadeOpacity;
#line 56 "Drawing/DockTheme.vala"
	return result;
#line 2644 "DockTheme.c"
}

void
plank_dock_theme_set_FadeOpacity (PlankDockTheme* self,
                                  gdouble value)
{
	gdouble old_value;
#line 56 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 56 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_FadeOpacity (self);
#line 56 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 56 "Drawing/DockTheme.vala"
		self->priv->_FadeOpacity = value;
#line 56 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_FADE_OPACITY_PROPERTY]);
#line 2662 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_ClickTime (PlankDockTheme* self)
{
	gint result;
#line 59 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 59 "Drawing/DockTheme.vala"
	result = self->priv->_ClickTime;
#line 59 "Drawing/DockTheme.vala"
	return result;
#line 2676 "DockTheme.c"
}

void
plank_dock_theme_set_ClickTime (PlankDockTheme* self,
                                gint value)
{
	gint old_value;
#line 59 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 59 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_ClickTime (self);
#line 59 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 59 "Drawing/DockTheme.vala"
		self->priv->_ClickTime = value;
#line 59 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_CLICK_TIME_PROPERTY]);
#line 2694 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_UrgentBounceTime (PlankDockTheme* self)
{
	gint result;
#line 62 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 62 "Drawing/DockTheme.vala"
	result = self->priv->_UrgentBounceTime;
#line 62 "Drawing/DockTheme.vala"
	return result;
#line 2708 "DockTheme.c"
}

void
plank_dock_theme_set_UrgentBounceTime (PlankDockTheme* self,
                                       gint value)
{
	gint old_value;
#line 62 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 62 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_UrgentBounceTime (self);
#line 62 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 62 "Drawing/DockTheme.vala"
		self->priv->_UrgentBounceTime = value;
#line 62 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_URGENT_BOUNCE_TIME_PROPERTY]);
#line 2726 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_LaunchBounceTime (PlankDockTheme* self)
{
	gint result;
#line 65 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 65 "Drawing/DockTheme.vala"
	result = self->priv->_LaunchBounceTime;
#line 65 "Drawing/DockTheme.vala"
	return result;
#line 2740 "DockTheme.c"
}

void
plank_dock_theme_set_LaunchBounceTime (PlankDockTheme* self,
                                       gint value)
{
	gint old_value;
#line 65 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 65 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_LaunchBounceTime (self);
#line 65 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 65 "Drawing/DockTheme.vala"
		self->priv->_LaunchBounceTime = value;
#line 65 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_LAUNCH_BOUNCE_TIME_PROPERTY]);
#line 2758 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_ActiveTime (PlankDockTheme* self)
{
	gint result;
#line 68 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 68 "Drawing/DockTheme.vala"
	result = self->priv->_ActiveTime;
#line 68 "Drawing/DockTheme.vala"
	return result;
#line 2772 "DockTheme.c"
}

void
plank_dock_theme_set_ActiveTime (PlankDockTheme* self,
                                 gint value)
{
	gint old_value;
#line 68 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 68 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_ActiveTime (self);
#line 68 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 68 "Drawing/DockTheme.vala"
		self->priv->_ActiveTime = value;
#line 68 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_ACTIVE_TIME_PROPERTY]);
#line 2790 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_SlideTime (PlankDockTheme* self)
{
	gint result;
#line 71 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 71 "Drawing/DockTheme.vala"
	result = self->priv->_SlideTime;
#line 71 "Drawing/DockTheme.vala"
	return result;
#line 2804 "DockTheme.c"
}

void
plank_dock_theme_set_SlideTime (PlankDockTheme* self,
                                gint value)
{
	gint old_value;
#line 71 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 71 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_SlideTime (self);
#line 71 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 71 "Drawing/DockTheme.vala"
		self->priv->_SlideTime = value;
#line 71 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_SLIDE_TIME_PROPERTY]);
#line 2822 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_FadeTime (PlankDockTheme* self)
{
	gint result;
#line 74 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 74 "Drawing/DockTheme.vala"
	result = self->priv->_FadeTime;
#line 74 "Drawing/DockTheme.vala"
	return result;
#line 2836 "DockTheme.c"
}

void
plank_dock_theme_set_FadeTime (PlankDockTheme* self,
                               gint value)
{
	gint old_value;
#line 74 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 74 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_FadeTime (self);
#line 74 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 74 "Drawing/DockTheme.vala"
		self->priv->_FadeTime = value;
#line 74 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_FADE_TIME_PROPERTY]);
#line 2854 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_HideTime (PlankDockTheme* self)
{
	gint result;
#line 77 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 77 "Drawing/DockTheme.vala"
	result = self->priv->_HideTime;
#line 77 "Drawing/DockTheme.vala"
	return result;
#line 2868 "DockTheme.c"
}

void
plank_dock_theme_set_HideTime (PlankDockTheme* self,
                               gint value)
{
	gint old_value;
#line 77 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 77 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_HideTime (self);
#line 77 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 77 "Drawing/DockTheme.vala"
		self->priv->_HideTime = value;
#line 77 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_HIDE_TIME_PROPERTY]);
#line 2886 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_GlowSize (PlankDockTheme* self)
{
	gint result;
#line 80 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 80 "Drawing/DockTheme.vala"
	result = self->priv->_GlowSize;
#line 80 "Drawing/DockTheme.vala"
	return result;
#line 2900 "DockTheme.c"
}

void
plank_dock_theme_set_GlowSize (PlankDockTheme* self,
                               gint value)
{
	gint old_value;
#line 80 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 80 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_GlowSize (self);
#line 80 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 80 "Drawing/DockTheme.vala"
		self->priv->_GlowSize = value;
#line 80 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_GLOW_SIZE_PROPERTY]);
#line 2918 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_GlowTime (PlankDockTheme* self)
{
	gint result;
#line 83 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 83 "Drawing/DockTheme.vala"
	result = self->priv->_GlowTime;
#line 83 "Drawing/DockTheme.vala"
	return result;
#line 2932 "DockTheme.c"
}

void
plank_dock_theme_set_GlowTime (PlankDockTheme* self,
                               gint value)
{
	gint old_value;
#line 83 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 83 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_GlowTime (self);
#line 83 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 83 "Drawing/DockTheme.vala"
		self->priv->_GlowTime = value;
#line 83 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_GLOW_TIME_PROPERTY]);
#line 2950 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_GlowPulseTime (PlankDockTheme* self)
{
	gint result;
#line 86 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 86 "Drawing/DockTheme.vala"
	result = self->priv->_GlowPulseTime;
#line 86 "Drawing/DockTheme.vala"
	return result;
#line 2964 "DockTheme.c"
}

void
plank_dock_theme_set_GlowPulseTime (PlankDockTheme* self,
                                    gint value)
{
	gint old_value;
#line 86 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 86 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_GlowPulseTime (self);
#line 86 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 86 "Drawing/DockTheme.vala"
		self->priv->_GlowPulseTime = value;
#line 86 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_GLOW_PULSE_TIME_PROPERTY]);
#line 2982 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_UrgentHueShift (PlankDockTheme* self)
{
	gint result;
#line 89 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 89 "Drawing/DockTheme.vala"
	result = self->priv->_UrgentHueShift;
#line 89 "Drawing/DockTheme.vala"
	return result;
#line 2996 "DockTheme.c"
}

void
plank_dock_theme_set_UrgentHueShift (PlankDockTheme* self,
                                     gint value)
{
	gint old_value;
#line 89 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 89 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_UrgentHueShift (self);
#line 89 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 89 "Drawing/DockTheme.vala"
		self->priv->_UrgentHueShift = value;
#line 89 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_URGENT_HUE_SHIFT_PROPERTY]);
#line 3014 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_ItemMoveTime (PlankDockTheme* self)
{
	gint result;
#line 92 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 92 "Drawing/DockTheme.vala"
	result = self->priv->_ItemMoveTime;
#line 92 "Drawing/DockTheme.vala"
	return result;
#line 3028 "DockTheme.c"
}

void
plank_dock_theme_set_ItemMoveTime (PlankDockTheme* self,
                                   gint value)
{
	gint old_value;
#line 92 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 92 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_ItemMoveTime (self);
#line 92 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 92 "Drawing/DockTheme.vala"
		self->priv->_ItemMoveTime = value;
#line 92 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_ITEM_MOVE_TIME_PROPERTY]);
#line 3046 "DockTheme.c"
	}
}

gboolean
plank_dock_theme_get_CascadeHide (PlankDockTheme* self)
{
	gboolean result;
#line 95 "Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 95 "Drawing/DockTheme.vala"
	result = self->priv->_CascadeHide;
#line 95 "Drawing/DockTheme.vala"
	return result;
#line 3060 "DockTheme.c"
}

void
plank_dock_theme_set_CascadeHide (PlankDockTheme* self,
                                  gboolean value)
{
	gboolean old_value;
#line 95 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 95 "Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_CascadeHide (self);
#line 95 "Drawing/DockTheme.vala"
	if (old_value != value) {
#line 95 "Drawing/DockTheme.vala"
		self->priv->_CascadeHide = value;
#line 95 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_CASCADE_HIDE_PROPERTY]);
#line 3078 "DockTheme.c"
	}
}

void
plank_dock_theme_get_BadgeColor (PlankDockTheme* self,
                                 PlankColor * result)
{
	PlankColor _tmp0_;
#line 98 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 98 "Drawing/DockTheme.vala"
	_tmp0_ = self->priv->_BadgeColor;
#line 98 "Drawing/DockTheme.vala"
	*result = _tmp0_;
#line 98 "Drawing/DockTheme.vala"
	return;
#line 3095 "DockTheme.c"
}

static gboolean
_gdk_rgba_equal (const GdkRGBA * s1,
                 const GdkRGBA * s2)
{
#line 98 "Drawing/DockTheme.vala"
	if (s1 == s2) {
#line 98 "Drawing/DockTheme.vala"
		return TRUE;
#line 3106 "DockTheme.c"
	}
#line 98 "Drawing/DockTheme.vala"
	if (s1 == NULL) {
#line 98 "Drawing/DockTheme.vala"
		return FALSE;
#line 3112 "DockTheme.c"
	}
#line 98 "Drawing/DockTheme.vala"
	if (s2 == NULL) {
#line 98 "Drawing/DockTheme.vala"
		return FALSE;
#line 3118 "DockTheme.c"
	}
#line 98 "Drawing/DockTheme.vala"
	if (s1->red != s2->red) {
#line 98 "Drawing/DockTheme.vala"
		return FALSE;
#line 3124 "DockTheme.c"
	}
#line 98 "Drawing/DockTheme.vala"
	if (s1->green != s2->green) {
#line 98 "Drawing/DockTheme.vala"
		return FALSE;
#line 3130 "DockTheme.c"
	}
#line 98 "Drawing/DockTheme.vala"
	if (s1->blue != s2->blue) {
#line 98 "Drawing/DockTheme.vala"
		return FALSE;
#line 3136 "DockTheme.c"
	}
#line 98 "Drawing/DockTheme.vala"
	if (s1->alpha != s2->alpha) {
#line 98 "Drawing/DockTheme.vala"
		return FALSE;
#line 3142 "DockTheme.c"
	}
#line 98 "Drawing/DockTheme.vala"
	return TRUE;
#line 3146 "DockTheme.c"
}

void
plank_dock_theme_set_BadgeColor (PlankDockTheme* self,
                                 PlankColor * value)
{
	PlankColor old_value;
#line 98 "Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 98 "Drawing/DockTheme.vala"
	plank_dock_theme_get_BadgeColor (self, &old_value);
#line 98 "Drawing/DockTheme.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 3160 "DockTheme.c"
		PlankColor _tmp0_;
#line 98 "Drawing/DockTheme.vala"
		_tmp0_ = *value;
#line 98 "Drawing/DockTheme.vala"
		self->priv->_BadgeColor = _tmp0_;
#line 98 "Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_BADGE_COLOR_PROPERTY]);
#line 3168 "DockTheme.c"
	}
}

static void
plank_dock_theme_class_init (PlankDockThemeClass * klass,
                             gpointer klass_data)
{
#line 25 "Drawing/DockTheme.vala"
	plank_dock_theme_parent_class = g_type_class_peek_parent (klass);
#line 25 "Drawing/DockTheme.vala"
	g_type_class_adjust_private_offset (klass, &PlankDockTheme_private_offset);
#line 25 "Drawing/DockTheme.vala"
	((PlankPreferencesClass *) klass)->reset_properties = (void (*) (PlankPreferences*)) plank_dock_theme_real_reset_properties;
#line 25 "Drawing/DockTheme.vala"
	((PlankPreferencesClass *) klass)->verify = (void (*) (PlankPreferences*, const gchar*)) plank_dock_theme_real_verify;
#line 25 "Drawing/DockTheme.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_dock_theme_get_property;
#line 25 "Drawing/DockTheme.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_dock_theme_set_property;
#line 25 "Drawing/DockTheme.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_dock_theme_finalize;
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_HORIZ_PADDING_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_HORIZ_PADDING_PROPERTY] = g_param_spec_double ("HorizPadding", "horizontal-padding", "The padding on the left/right dock edges, in tenths of a percent of IconSize.", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_TOP_PADDING_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_TOP_PADDING_PROPERTY] = g_param_spec_double ("TopPadding", "top-padding", "The padding on the top dock edge, in tenths of a percent of IconSize.", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_BOTTOM_PADDING_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_BOTTOM_PADDING_PROPERTY] = g_param_spec_double ("BottomPadding", "bottom-padding", "The padding on the bottom dock edge, in tenths of a percent of IconSize.", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_ITEM_PADDING_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_ITEM_PADDING_PROPERTY] = g_param_spec_double ("ItemPadding", "item-padding", "The padding between items on the dock, in tenths of a percent of IconSize.", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_INDICATOR_SIZE_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_INDICATOR_SIZE_PROPERTY] = g_param_spec_double ("IndicatorSize", "indicator-size", "The size of item indicators, in tenths of a percent of IconSize.", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_ICON_SHADOW_SIZE_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_ICON_SHADOW_SIZE_PROPERTY] = g_param_spec_double ("IconShadowSize", "icon-shadow-size", "The size of the icon-shadow behind every item, in tenths of a percent of IconSize.", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_URGENT_BOUNCE_HEIGHT_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_URGENT_BOUNCE_HEIGHT_PROPERTY] = g_param_spec_double ("UrgentBounceHeight", "urgent-bounce", "The height (in percent of IconSize) to bounce an icon when the application sets urgent.", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_LAUNCH_BOUNCE_HEIGHT_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_LAUNCH_BOUNCE_HEIGHT_PROPERTY] = g_param_spec_double ("LaunchBounceHeight", "launch-bounce", "The height (in percent of IconSize) to bounce an icon when launching an application.", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_FADE_OPACITY_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_FADE_OPACITY_PROPERTY] = g_param_spec_double ("FadeOpacity", "fade-opacity", "The opacity value (0 to 1) to fade the dock to when hiding it.", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_CLICK_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_CLICK_TIME_PROPERTY] = g_param_spec_int ("ClickTime", "click-time", "The amount of time (in ms) for click animations.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_URGENT_BOUNCE_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_URGENT_BOUNCE_TIME_PROPERTY] = g_param_spec_int ("UrgentBounceTime", "urgent-bounce-time", "The amount of time (in ms) to bounce an urgent icon.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_LAUNCH_BOUNCE_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_LAUNCH_BOUNCE_TIME_PROPERTY] = g_param_spec_int ("LaunchBounceTime", "launch-bounce-time", "The amount of time (in ms) to bounce an icon when launching an application.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_ACTIVE_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_ACTIVE_TIME_PROPERTY] = g_param_spec_int ("ActiveTime", "active-time", "The amount of time (in ms) for active window indicator animations.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_SLIDE_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_SLIDE_TIME_PROPERTY] = g_param_spec_int ("SlideTime", "slide-time", "The amount of time (in ms) to slide icons into/out of the dock.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_FADE_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_FADE_TIME_PROPERTY] = g_param_spec_int ("FadeTime", "fade-time", "The time (in ms) to fade the dock in/out on a hide (if FadeOpacity is < 1).", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_HIDE_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_HIDE_TIME_PROPERTY] = g_param_spec_int ("HideTime", "hide-time", "The time (in ms) to slide the dock in/out on a hide (if FadeOpacity is 1).", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_GLOW_SIZE_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_GLOW_SIZE_PROPERTY] = g_param_spec_int ("GlowSize", "glow-size", "The size of the urgent glow (shown when dock is hidden), in tenths of a percent of IconSize.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_GLOW_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_GLOW_TIME_PROPERTY] = g_param_spec_int ("GlowTime", "glow-time", "The total time (in ms) to show the hidden-dock urgent glow.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_GLOW_PULSE_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_GLOW_PULSE_TIME_PROPERTY] = g_param_spec_int ("GlowPulseTime", "glow-pulse-time", "The time (in ms) of each pulse of the hidden-dock urgent glow.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_URGENT_HUE_SHIFT_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_URGENT_HUE_SHIFT_PROPERTY] = g_param_spec_int ("UrgentHueShift", "urgent-hue-shift", "The hue-shift (-180 to 180) of the urgent indicator color.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_ITEM_MOVE_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_ITEM_MOVE_TIME_PROPERTY] = g_param_spec_int ("ItemMoveTime", "item-move-time", "The time (in ms) to move an item to its new position or its addition/removal to/from the dock.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_CASCADE_HIDE_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_CASCADE_HIDE_PROPERTY] = g_param_spec_boolean ("CascadeHide", "cascade-hide", "Whether background and icons will unhide/hide with different speeds. The top-border of both will leave/hit the screen-edge at the same time.", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_BADGE_COLOR_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_BADGE_COLOR_PROPERTY] = g_param_spec_boxed ("BadgeColor", "badge-color", "The color (RGBA) of the badge displaying urgent count", PLANK_TYPE_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3236 "DockTheme.c"
}

static void
plank_dock_theme_instance_init (PlankDockTheme * self,
                                gpointer klass)
{
#line 25 "Drawing/DockTheme.vala"
	self->priv = plank_dock_theme_get_instance_private (self);
#line 3245 "DockTheme.c"
}

static void
plank_dock_theme_finalize (GObject * obj)
{
	PlankDockTheme * self;
#line 25 "Drawing/DockTheme.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DOCK_THEME, PlankDockTheme);
#line 25 "Drawing/DockTheme.vala"
	G_OBJECT_CLASS (plank_dock_theme_parent_class)->finalize (obj);
#line 3256 "DockTheme.c"
}

/**
 * A themed renderer for dock windows.
 */
static GType
plank_dock_theme_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankDockThemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_dock_theme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDockTheme), 0, (GInstanceInitFunc) plank_dock_theme_instance_init, NULL };
	GType plank_dock_theme_type_id;
	plank_dock_theme_type_id = g_type_register_static (PLANK_TYPE_THEME, "PlankDockTheme", &g_define_type_info, 0);
	PlankDockTheme_private_offset = g_type_add_instance_private (plank_dock_theme_type_id, sizeof (PlankDockThemePrivate));
	return plank_dock_theme_type_id;
}

GType
plank_dock_theme_get_type (void)
{
	static volatile gsize plank_dock_theme_type_id__once = 0;
	if (g_once_init_enter (&plank_dock_theme_type_id__once)) {
		GType plank_dock_theme_type_id;
		plank_dock_theme_type_id = plank_dock_theme_get_type_once ();
		g_once_init_leave (&plank_dock_theme_type_id__once, plank_dock_theme_type_id);
	}
	return plank_dock_theme_type_id__once;
}

static void
_vala_plank_dock_theme_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	PlankDockTheme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DOCK_THEME, PlankDockTheme);
#line 25 "Drawing/DockTheme.vala"
	switch (property_id) {
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_HORIZ_PADDING_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_double (value, plank_dock_theme_get_HorizPadding (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_TOP_PADDING_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_double (value, plank_dock_theme_get_TopPadding (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_BOTTOM_PADDING_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_double (value, plank_dock_theme_get_BottomPadding (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_ITEM_PADDING_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_double (value, plank_dock_theme_get_ItemPadding (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_INDICATOR_SIZE_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_double (value, plank_dock_theme_get_IndicatorSize (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_ICON_SHADOW_SIZE_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_double (value, plank_dock_theme_get_IconShadowSize (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_URGENT_BOUNCE_HEIGHT_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_double (value, plank_dock_theme_get_UrgentBounceHeight (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_LAUNCH_BOUNCE_HEIGHT_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_double (value, plank_dock_theme_get_LaunchBounceHeight (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_FADE_OPACITY_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_double (value, plank_dock_theme_get_FadeOpacity (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_CLICK_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_ClickTime (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_URGENT_BOUNCE_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_UrgentBounceTime (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_LAUNCH_BOUNCE_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_LaunchBounceTime (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_ACTIVE_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_ActiveTime (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_SLIDE_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_SlideTime (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_FADE_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_FadeTime (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_HIDE_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_HideTime (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_GLOW_SIZE_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_GlowSize (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_GLOW_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_GlowTime (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_GLOW_PULSE_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_GlowPulseTime (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_URGENT_HUE_SHIFT_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_UrgentHueShift (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_ITEM_MOVE_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_ItemMoveTime (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_CASCADE_HIDE_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		g_value_set_boolean (value, plank_dock_theme_get_CascadeHide (self));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_BADGE_COLOR_PROPERTY:
#line 3428 "DockTheme.c"
		{
			PlankColor boxed;
#line 25 "Drawing/DockTheme.vala"
			plank_dock_theme_get_BadgeColor (self, &boxed);
#line 25 "Drawing/DockTheme.vala"
			g_value_set_boxed (value, &boxed);
#line 3435 "DockTheme.c"
		}
#line 25 "Drawing/DockTheme.vala"
		break;
#line 3439 "DockTheme.c"
		default:
#line 25 "Drawing/DockTheme.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "Drawing/DockTheme.vala"
		break;
#line 3445 "DockTheme.c"
	}
}

static void
_vala_plank_dock_theme_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	PlankDockTheme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DOCK_THEME, PlankDockTheme);
#line 25 "Drawing/DockTheme.vala"
	switch (property_id) {
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_HORIZ_PADDING_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_HorizPadding (self, g_value_get_double (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_TOP_PADDING_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_TopPadding (self, g_value_get_double (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_BOTTOM_PADDING_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_BottomPadding (self, g_value_get_double (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_ITEM_PADDING_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_ItemPadding (self, g_value_get_double (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_INDICATOR_SIZE_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_IndicatorSize (self, g_value_get_double (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_ICON_SHADOW_SIZE_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_IconShadowSize (self, g_value_get_double (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_URGENT_BOUNCE_HEIGHT_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_UrgentBounceHeight (self, g_value_get_double (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_LAUNCH_BOUNCE_HEIGHT_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_LaunchBounceHeight (self, g_value_get_double (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_FADE_OPACITY_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_FadeOpacity (self, g_value_get_double (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_CLICK_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_ClickTime (self, g_value_get_int (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_URGENT_BOUNCE_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_UrgentBounceTime (self, g_value_get_int (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_LAUNCH_BOUNCE_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_LaunchBounceTime (self, g_value_get_int (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_ACTIVE_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_ActiveTime (self, g_value_get_int (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_SLIDE_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_SlideTime (self, g_value_get_int (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_FADE_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_FadeTime (self, g_value_get_int (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_HIDE_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_HideTime (self, g_value_get_int (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_GLOW_SIZE_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_GlowSize (self, g_value_get_int (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_GLOW_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_GlowTime (self, g_value_get_int (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_GLOW_PULSE_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_GlowPulseTime (self, g_value_get_int (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_URGENT_HUE_SHIFT_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_UrgentHueShift (self, g_value_get_int (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_ITEM_MOVE_TIME_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_ItemMoveTime (self, g_value_get_int (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_CASCADE_HIDE_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_CascadeHide (self, g_value_get_boolean (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 25 "Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_BADGE_COLOR_PROPERTY:
#line 25 "Drawing/DockTheme.vala"
		plank_dock_theme_set_BadgeColor (self, g_value_get_boxed (value));
#line 25 "Drawing/DockTheme.vala"
		break;
#line 3597 "DockTheme.c"
		default:
#line 25 "Drawing/DockTheme.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "Drawing/DockTheme.vala"
		break;
#line 3603 "DockTheme.c"
	}
}

