/* DockWindow.c generated by valac 0.56.18, the Vala compiler
 * generated from DockWindow.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Michal Hruby, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <gtk/gtk.h>
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include "plank-internal.h"
#include <libbamf/libbamf.h>
#include <gio/gio.h>
#include <gdk/gdkx.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>

#define PLANK_DOCK_WINDOW_LONG_PRESS_TIME 750U
#define PLANK_DOCK_WINDOW_HOVER_DELAY_TIME 200U
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PLANK_DOCK_WINDOW_0_PROPERTY,
	PLANK_DOCK_WINDOW_CONTROLLER_PROPERTY,
	PLANK_DOCK_WINDOW_HOVERED_ITEM_PROPERTY,
	PLANK_DOCK_WINDOW_HOVERED_ITEM_PROVIDER_PROPERTY,
	PLANK_DOCK_WINDOW_NUM_PROPERTIES
};
static GParamSpec* plank_dock_window_properties[PLANK_DOCK_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block18Data Block18Data;
typedef struct _Block19Data Block19Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_region_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_region_destroy (var), NULL)))

struct _PlankDockWindowPrivate {
	PlankDockController* _controller;
	PlankDockItem* _HoveredItem;
	PlankDockItemProvider* _HoveredItemProvider;
	PlankDockItem* _ClickedItem;
	GtkMenu* menu;
	GeeArrayList* menu_items;
	guint hover_reposition_timer_id;
	guint long_press_timer_id;
	gboolean long_press_active;
	guint long_press_button;
	GdkRectangle input_rect;
	gint requested_x;
	gint requested_y;
	gint window_position_retry;
};

struct _Block18Data {
	int _ref_count_;
	PlankDockController* controller;
};

struct _Block19Data {
	int _ref_count_;
	GFile* dock_item_file;
	PlankDockItem* item;
};

static gint PlankDockWindow_private_offset;
static gpointer plank_dock_window_parent_class = NULL;

static void plank_dock_window_on_menu_show (PlankDockWindow* self);
static void _plank_dock_window_on_menu_show_gtk_widget_show (GtkWidget* _sender,
                                                      gpointer self);
static void plank_dock_window_on_menu_hide (PlankDockWindow* self);
static void _plank_dock_window_on_menu_hide_gtk_widget_hide (GtkWidget* _sender,
                                                      gpointer self);
static PlankDockController* plank_dock_window_get_controller (PlankDockWindow* self);
static void plank_dock_window_set_struts (PlankDockWindow* self);
static void _plank_dock_window_set_struts_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static gboolean plank_dock_window_real_button_press_event (GtkWidget* base,
                                                    GdkEventButton* event);
static void plank_dock_window_set_ClickedItem (PlankDockWindow* self,
                                        PlankDockItem* value);
static gboolean plank_dock_window_show_menu (PlankDockWindow* self,
                                      PlankDockItem* item,
                                      GdkEventButton* event);
static gboolean __lambda56_ (PlankDockWindow* self);
static gboolean ___lambda56__gsource_func (gpointer self);
static gboolean plank_dock_window_real_button_release_event (GtkWidget* base,
                                                      GdkEventButton* event);
static PlankDockItem* plank_dock_window_get_ClickedItem (PlankDockWindow* self);
static gboolean plank_dock_window_real_enter_notify_event (GtkWidget* base,
                                                    GdkEventCrossing* event);
static gboolean plank_dock_window_real_leave_notify_event (GtkWidget* base,
                                                    GdkEventCrossing* event);
static void plank_dock_window_set_hovered_provider (PlankDockWindow* self,
                                             PlankDockItemProvider* provider);
static void plank_dock_window_set_hovered (PlankDockWindow* self,
                                    PlankDockItem* item);
static gboolean plank_dock_window_real_motion_notify_event (GtkWidget* base,
                                                     GdkEventMotion* event);
static void plank_dock_window_real_drag_begin (GtkWidget* base,
                                        GdkDragContext* context);
static gboolean plank_dock_window_real_scroll_event (GtkWidget* base,
                                              GdkEventScroll* event);
static gboolean plank_dock_window_real_configure_event (GtkWidget* base,
                                                 GdkEventConfigure* event);
static gboolean plank_dock_window_real_draw (GtkWidget* base,
                                      cairo_t* cr);
static void plank_dock_window_set_input_mask (PlankDockWindow* self);
static gboolean plank_dock_window_real_map_event (GtkWidget* base,
                                           GdkEventAny* event);
static void plank_dock_window_set_HoveredItemProvider (PlankDockWindow* self,
                                                PlankDockItemProvider* value);
static void plank_dock_window_set_HoveredItem (PlankDockWindow* self,
                                        PlankDockItem* value);
static gboolean __lambda44_ (PlankDockWindow* self);
static gboolean ___lambda44__gsource_func (gpointer self);
VALA_EXTERN BamfApplication* plank_application_dock_item_get_App (PlankApplicationDockItem* self);
static GeeArrayList* plank_dock_window_get_dock_debug_menu_items (PlankDockController* controller);
static GeeArrayList* plank_dock_window_get_item_debug_menu_items (PlankDockItem* item);
static void plank_dock_window_position_menu (GtkMenu* menu,
                                      gint* x,
                                      gint* y,
                                      gboolean* push_in,
                                      PlankDockWindow* self);
static Block18Data* block18_data_ref (Block18Data* _data18_);
static void block18_data_unref (void * _userdata_);
static void __lambda51_ (Block18Data* _data18_);
static void ___lambda51__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda52_ (Block18Data* _data18_);
static void ___lambda52__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static Block19Data* block19_data_ref (Block19Data* _data19_);
static void block19_data_unref (void * _userdata_);
static void __lambda53_ (Block19Data* _data19_);
static void ___lambda53__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda54_ (Block19Data* _data19_);
static void ___lambda54__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda55_ (Block19Data* _data19_);
static void ___lambda55__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static gboolean _cairo_rectangle_int_equal (const cairo_rectangle_int_t * s1,
                                     const cairo_rectangle_int_t * s2);
static GObject * plank_dock_window_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void plank_dock_window_finalize (GObject * obj);
static GType plank_dock_window_get_type_once (void);
static void _vala_plank_dock_window_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_plank_dock_window_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
plank_dock_window_get_instance_private (PlankDockWindow* self)
{
	return G_STRUCT_MEMBER_P (self, PlankDockWindow_private_offset);
}

static void
_plank_dock_window_on_menu_show_gtk_widget_show (GtkWidget* _sender,
                                                 gpointer self)
{
#line 100 "Widgets/DockWindow.vala"
	plank_dock_window_on_menu_show ((PlankDockWindow*) self);
#line 205 "DockWindow.c"
}

static void
_plank_dock_window_on_menu_hide_gtk_widget_hide (GtkWidget* _sender,
                                                 gpointer self)
{
#line 101 "Widgets/DockWindow.vala"
	plank_dock_window_on_menu_hide ((PlankDockWindow*) self);
#line 214 "DockWindow.c"
}

static void
_plank_dock_window_set_struts_g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
#line 104 "Widgets/DockWindow.vala"
	plank_dock_window_set_struts ((PlankDockWindow*) self);
#line 224 "DockWindow.c"
}

/**
 * Creates a new dock window.
 */
PlankDockWindow*
plank_dock_window_construct (GType object_type,
                             PlankDockController* controller)
{
	PlankDockWindow * self = NULL;
#line 72 "Widgets/DockWindow.vala"
	g_return_val_if_fail (controller != NULL, NULL);
#line 74 "Widgets/DockWindow.vala"
	self = (PlankDockWindow*) g_object_new (object_type, "controller", controller, "type", GTK_WINDOW_TOPLEVEL, "type-hint", GDK_WINDOW_TYPE_HINT_DOCK, NULL);
#line 72 "Widgets/DockWindow.vala"
	return self;
#line 241 "DockWindow.c"
}

PlankDockWindow*
plank_dock_window_new (PlankDockController* controller)
{
#line 72 "Widgets/DockWindow.vala"
	return plank_dock_window_construct (PLANK_TYPE_DOCK_WINDOW, controller);
#line 249 "DockWindow.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
__lambda56_ (PlankDockWindow* self)
{
	gboolean result;
#line 147 "Widgets/DockWindow.vala"
	self->priv->long_press_active = TRUE;
#line 148 "Widgets/DockWindow.vala"
	self->priv->long_press_timer_id = 0U;
#line 149 "Widgets/DockWindow.vala"
	result = FALSE;
#line 149 "Widgets/DockWindow.vala"
	return result;
#line 267 "DockWindow.c"
}

static gboolean
___lambda56__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda56_ ((PlankDockWindow*) self);
#line 146 "Widgets/DockWindow.vala"
	return result;
#line 277 "DockWindow.c"
}

static gboolean
plank_dock_window_real_button_press_event (GtkWidget* base,
                                           GdkEventButton* event)
{
	PlankDockWindow * self;
	PlankDockController* _tmp0_;
	PlankHideManager* _tmp1_;
	PlankHideManager* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	PlankDockController* _tmp5_;
	PlankDragManager* _tmp6_;
	PlankDragManager* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	PlankDockItem* _tmp10_;
	PlankDockItem* _tmp11_;
	PlankDockItem* _tmp12_;
	gboolean result;
#line 115 "Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 115 "Widgets/DockWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 118 "Widgets/DockWindow.vala"
	if (plank_dock_window_menu_is_visible (self)) {
#line 119 "Widgets/DockWindow.vala"
		result = GDK_EVENT_PROPAGATE;
#line 119 "Widgets/DockWindow.vala"
		return result;
#line 309 "DockWindow.c"
	}
#line 122 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 122 "Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_hide_manager (_tmp0_);
#line 122 "Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 122 "Widgets/DockWindow.vala"
	_tmp3_ = plank_hide_manager_get_Hidden (_tmp2_);
#line 122 "Widgets/DockWindow.vala"
	_tmp4_ = _tmp3_;
#line 122 "Widgets/DockWindow.vala"
	if (_tmp4_) {
#line 123 "Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 123 "Widgets/DockWindow.vala"
		return result;
#line 327 "DockWindow.c"
	}
#line 127 "Widgets/DockWindow.vala"
	_tmp5_ = self->priv->_controller;
#line 127 "Widgets/DockWindow.vala"
	_tmp6_ = plank_dock_controller_get_drag_manager (_tmp5_);
#line 127 "Widgets/DockWindow.vala"
	_tmp7_ = _tmp6_;
#line 127 "Widgets/DockWindow.vala"
	_tmp8_ = plank_drag_manager_get_InternalDragActive (_tmp7_);
#line 127 "Widgets/DockWindow.vala"
	_tmp9_ = _tmp8_;
#line 127 "Widgets/DockWindow.vala"
	if (_tmp9_) {
#line 128 "Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 128 "Widgets/DockWindow.vala"
		return result;
#line 345 "DockWindow.c"
	}
#line 133 "Widgets/DockWindow.vala"
	_tmp10_ = self->priv->_HoveredItem;
#line 133 "Widgets/DockWindow.vala"
	if (_tmp10_ == NULL) {
#line 134 "Widgets/DockWindow.vala"
		plank_dock_window_update_hovered (self, (gint) event->x, (gint) event->y);
#line 353 "DockWindow.c"
	}
#line 136 "Widgets/DockWindow.vala"
	_tmp11_ = self->priv->_HoveredItem;
#line 136 "Widgets/DockWindow.vala"
	plank_dock_window_set_ClickedItem (self, _tmp11_);
#line 139 "Widgets/DockWindow.vala"
	_tmp12_ = self->priv->_HoveredItem;
#line 139 "Widgets/DockWindow.vala"
	if (plank_dock_window_show_menu (self, _tmp12_, event)) {
#line 140 "Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 140 "Widgets/DockWindow.vala"
		return result;
#line 367 "DockWindow.c"
	}
#line 142 "Widgets/DockWindow.vala"
	self->priv->long_press_active = FALSE;
#line 143 "Widgets/DockWindow.vala"
	self->priv->long_press_button = event->button;
#line 144 "Widgets/DockWindow.vala"
	if (self->priv->long_press_timer_id > 0U) {
#line 145 "Widgets/DockWindow.vala"
		g_source_remove (self->priv->long_press_timer_id);
#line 377 "DockWindow.c"
	}
#line 146 "Widgets/DockWindow.vala"
	self->priv->long_press_timer_id = gdk_threads_add_timeout (PLANK_DOCK_WINDOW_LONG_PRESS_TIME, ___lambda56__gsource_func, self);
#line 152 "Widgets/DockWindow.vala"
	result = GDK_EVENT_PROPAGATE;
#line 152 "Widgets/DockWindow.vala"
	return result;
#line 385 "DockWindow.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_dock_window_real_button_release_event (GtkWidget* base,
                                             GdkEventButton* event)
{
	PlankDockWindow * self;
	PlankDockController* _tmp0_;
	PlankHideManager* _tmp1_;
	PlankHideManager* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_ = FALSE;
	PlankDockController* _tmp6_;
	PlankDragManager* _tmp7_;
	PlankDragManager* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	PlankDockItem* _tmp13_;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	PlankDockItem* _tmp18_;
	gboolean result;
#line 158 "Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 158 "Widgets/DockWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 161 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 161 "Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_hide_manager (_tmp0_);
#line 161 "Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 161 "Widgets/DockWindow.vala"
	_tmp3_ = plank_hide_manager_get_Hidden (_tmp2_);
#line 161 "Widgets/DockWindow.vala"
	_tmp4_ = _tmp3_;
#line 161 "Widgets/DockWindow.vala"
	if (_tmp4_) {
#line 162 "Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 162 "Widgets/DockWindow.vala"
		return result;
#line 434 "DockWindow.c"
	}
#line 164 "Widgets/DockWindow.vala"
	if (self->priv->long_press_timer_id > 0U) {
#line 165 "Widgets/DockWindow.vala"
		g_source_remove (self->priv->long_press_timer_id);
#line 166 "Widgets/DockWindow.vala"
		self->priv->long_press_timer_id = 0U;
#line 442 "DockWindow.c"
	}
#line 169 "Widgets/DockWindow.vala"
	if (self->priv->long_press_active) {
#line 169 "Widgets/DockWindow.vala"
		_tmp5_ = self->priv->long_press_button == event->button;
#line 448 "DockWindow.c"
	} else {
#line 169 "Widgets/DockWindow.vala"
		_tmp5_ = FALSE;
#line 452 "DockWindow.c"
	}
#line 169 "Widgets/DockWindow.vala"
	if (_tmp5_) {
#line 170 "Widgets/DockWindow.vala"
		self->priv->long_press_active = FALSE;
#line 171 "Widgets/DockWindow.vala"
		self->priv->long_press_button = (guint) 0;
#line 172 "Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 172 "Widgets/DockWindow.vala"
		return result;
#line 464 "DockWindow.c"
	}
#line 175 "Widgets/DockWindow.vala"
	_tmp6_ = self->priv->_controller;
#line 175 "Widgets/DockWindow.vala"
	_tmp7_ = plank_dock_controller_get_drag_manager (_tmp6_);
#line 175 "Widgets/DockWindow.vala"
	_tmp8_ = _tmp7_;
#line 175 "Widgets/DockWindow.vala"
	_tmp9_ = plank_drag_manager_get_InternalDragActive (_tmp8_);
#line 175 "Widgets/DockWindow.vala"
	_tmp10_ = _tmp9_;
#line 175 "Widgets/DockWindow.vala"
	if (_tmp10_) {
#line 176 "Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 176 "Widgets/DockWindow.vala"
		return result;
#line 482 "DockWindow.c"
	}
#line 179 "Widgets/DockWindow.vala"
	_tmp13_ = self->priv->_HoveredItem;
#line 179 "Widgets/DockWindow.vala"
	if (_tmp13_ != NULL) {
#line 488 "DockWindow.c"
		PlankDockItem* _tmp14_;
#line 179 "Widgets/DockWindow.vala"
		_tmp14_ = self->priv->_ClickedItem;
#line 179 "Widgets/DockWindow.vala"
		_tmp12_ = _tmp14_ == NULL;
#line 494 "DockWindow.c"
	} else {
#line 179 "Widgets/DockWindow.vala"
		_tmp12_ = FALSE;
#line 498 "DockWindow.c"
	}
#line 179 "Widgets/DockWindow.vala"
	if (_tmp12_) {
#line 179 "Widgets/DockWindow.vala"
		_tmp11_ = plank_dock_window_menu_is_visible (self);
#line 504 "DockWindow.c"
	} else {
#line 179 "Widgets/DockWindow.vala"
		_tmp11_ = FALSE;
#line 508 "DockWindow.c"
	}
#line 179 "Widgets/DockWindow.vala"
	if (_tmp11_) {
#line 512 "DockWindow.c"
		GtkMenu* _tmp15_;
#line 180 "Widgets/DockWindow.vala"
		_tmp15_ = self->priv->menu;
#line 180 "Widgets/DockWindow.vala"
		gtk_widget_hide ((GtkWidget*) _tmp15_);
#line 518 "DockWindow.c"
	}
#line 183 "Widgets/DockWindow.vala"
	_tmp18_ = self->priv->_ClickedItem;
#line 183 "Widgets/DockWindow.vala"
	if (_tmp18_ != NULL) {
#line 524 "DockWindow.c"
		PlankDockItem* _tmp19_;
		PlankDockItem* _tmp20_;
#line 183 "Widgets/DockWindow.vala"
		_tmp19_ = self->priv->_HoveredItem;
#line 183 "Widgets/DockWindow.vala"
		_tmp20_ = self->priv->_ClickedItem;
#line 183 "Widgets/DockWindow.vala"
		_tmp17_ = _tmp19_ == _tmp20_;
#line 533 "DockWindow.c"
	} else {
#line 183 "Widgets/DockWindow.vala"
		_tmp17_ = FALSE;
#line 537 "DockWindow.c"
	}
#line 183 "Widgets/DockWindow.vala"
	if (_tmp17_) {
#line 183 "Widgets/DockWindow.vala"
		_tmp16_ = !plank_dock_window_menu_is_visible (self);
#line 543 "DockWindow.c"
	} else {
#line 183 "Widgets/DockWindow.vala"
		_tmp16_ = FALSE;
#line 547 "DockWindow.c"
	}
#line 183 "Widgets/DockWindow.vala"
	if (_tmp16_) {
#line 551 "DockWindow.c"
		PlankDockController* _tmp21_;
		PlankHoverWindow* _tmp22_;
		PlankHoverWindow* _tmp23_;
		PlankDockItem* _tmp24_;
#line 185 "Widgets/DockWindow.vala"
		_tmp21_ = self->priv->_controller;
#line 185 "Widgets/DockWindow.vala"
		_tmp22_ = plank_dock_controller_get_hover (_tmp21_);
#line 185 "Widgets/DockWindow.vala"
		_tmp23_ = _tmp22_;
#line 185 "Widgets/DockWindow.vala"
		gtk_widget_hide ((GtkWidget*) _tmp23_);
#line 187 "Widgets/DockWindow.vala"
		_tmp24_ = self->priv->_HoveredItem;
#line 187 "Widgets/DockWindow.vala"
		plank_dock_element_clicked ((PlankDockElement*) _tmp24_, plank_popup_button_from_event_button (event), event->state, event->time);
#line 568 "DockWindow.c"
	}
#line 190 "Widgets/DockWindow.vala"
	plank_dock_window_set_ClickedItem (self, NULL);
#line 192 "Widgets/DockWindow.vala"
	result = GDK_EVENT_PROPAGATE;
#line 192 "Widgets/DockWindow.vala"
	return result;
#line 576 "DockWindow.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_dock_window_real_enter_notify_event (GtkWidget* base,
                                           GdkEventCrossing* event)
{
	PlankDockWindow * self;
	PlankDockController* _tmp0_;
	PlankDockRenderer* _tmp1_;
	PlankDockRenderer* _tmp2_;
	gboolean result;
#line 198 "Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 198 "Widgets/DockWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 200 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 200 "Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_renderer (_tmp0_);
#line 200 "Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 200 "Widgets/DockWindow.vala"
	plank_dock_renderer_update_local_cursor (_tmp2_, (gint) event->x, (gint) event->y);
#line 201 "Widgets/DockWindow.vala"
	plank_dock_window_update_hovered (self, (gint) event->x, (gint) event->y);
#line 203 "Widgets/DockWindow.vala"
	result = GDK_EVENT_STOP;
#line 203 "Widgets/DockWindow.vala"
	return result;
#line 609 "DockWindow.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_dock_window_real_leave_notify_event (GtkWidget* base,
                                           GdkEventCrossing* event)
{
	PlankDockWindow * self;
	gboolean result;
#line 209 "Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 209 "Widgets/DockWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 212 "Widgets/DockWindow.vala"
	if ((gboolean) event->send_event) {
#line 213 "Widgets/DockWindow.vala"
		result = GDK_EVENT_PROPAGATE;
#line 213 "Widgets/DockWindow.vala"
		return result;
#line 631 "DockWindow.c"
	}
#line 215 "Widgets/DockWindow.vala"
	if (!plank_dock_window_menu_is_visible (self)) {
#line 216 "Widgets/DockWindow.vala"
		plank_dock_window_set_hovered_provider (self, NULL);
#line 217 "Widgets/DockWindow.vala"
		plank_dock_window_set_hovered (self, NULL);
#line 639 "DockWindow.c"
	} else {
		PlankDockController* _tmp0_;
		PlankHoverWindow* _tmp1_;
		PlankHoverWindow* _tmp2_;
#line 219 "Widgets/DockWindow.vala"
		_tmp0_ = self->priv->_controller;
#line 219 "Widgets/DockWindow.vala"
		_tmp1_ = plank_dock_controller_get_hover (_tmp0_);
#line 219 "Widgets/DockWindow.vala"
		_tmp2_ = _tmp1_;
#line 219 "Widgets/DockWindow.vala"
		gtk_widget_hide ((GtkWidget*) _tmp2_);
#line 652 "DockWindow.c"
	}
#line 221 "Widgets/DockWindow.vala"
	result = GDK_EVENT_STOP;
#line 221 "Widgets/DockWindow.vala"
	return result;
#line 658 "DockWindow.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_dock_window_real_motion_notify_event (GtkWidget* base,
                                            GdkEventMotion* event)
{
	PlankDockWindow * self;
	PlankDockController* _tmp0_;
	PlankDockRenderer* _tmp1_;
	PlankDockRenderer* _tmp2_;
	gboolean result;
#line 227 "Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 227 "Widgets/DockWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 230 "Widgets/DockWindow.vala"
	if (plank_dock_window_menu_is_visible (self)) {
#line 231 "Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 231 "Widgets/DockWindow.vala"
		return result;
#line 683 "DockWindow.c"
	}
#line 233 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 233 "Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_renderer (_tmp0_);
#line 233 "Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 233 "Widgets/DockWindow.vala"
	plank_dock_renderer_update_local_cursor (_tmp2_, (gint) event->x, (gint) event->y);
#line 234 "Widgets/DockWindow.vala"
	plank_dock_window_update_hovered (self, (gint) event->x, (gint) event->y);
#line 236 "Widgets/DockWindow.vala"
	result = GDK_EVENT_PROPAGATE;
#line 236 "Widgets/DockWindow.vala"
	return result;
#line 699 "DockWindow.c"
}

/**
 * {@inheritDoc}
 */
static void
plank_dock_window_real_drag_begin (GtkWidget* base,
                                   GdkDragContext* context)
{
	PlankDockWindow * self;
#line 242 "Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 242 "Widgets/DockWindow.vala"
	g_return_if_fail (context != NULL);
#line 244 "Widgets/DockWindow.vala"
	self->priv->long_press_active = FALSE;
#line 245 "Widgets/DockWindow.vala"
	if (self->priv->long_press_timer_id > 0U) {
#line 246 "Widgets/DockWindow.vala"
		g_source_remove (self->priv->long_press_timer_id);
#line 247 "Widgets/DockWindow.vala"
		self->priv->long_press_timer_id = 0U;
#line 722 "DockWindow.c"
	}
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_dock_window_real_scroll_event (GtkWidget* base,
                                     GdkEventScroll* event)
{
	PlankDockWindow * self;
	PlankDockController* _tmp0_;
	PlankHideManager* _tmp1_;
	PlankHideManager* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	PlankDockController* _tmp5_;
	PlankDragManager* _tmp6_;
	PlankDragManager* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	PlankDockItem* _tmp16_;
	gboolean result;
#line 254 "Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 254 "Widgets/DockWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 257 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 257 "Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_hide_manager (_tmp0_);
#line 257 "Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 257 "Widgets/DockWindow.vala"
	_tmp3_ = plank_hide_manager_get_Hidden (_tmp2_);
#line 257 "Widgets/DockWindow.vala"
	_tmp4_ = _tmp3_;
#line 257 "Widgets/DockWindow.vala"
	if (_tmp4_) {
#line 258 "Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 258 "Widgets/DockWindow.vala"
		return result;
#line 766 "DockWindow.c"
	}
#line 260 "Widgets/DockWindow.vala"
	_tmp5_ = self->priv->_controller;
#line 260 "Widgets/DockWindow.vala"
	_tmp6_ = plank_dock_controller_get_drag_manager (_tmp5_);
#line 260 "Widgets/DockWindow.vala"
	_tmp7_ = _tmp6_;
#line 260 "Widgets/DockWindow.vala"
	_tmp8_ = plank_drag_manager_get_InternalDragActive (_tmp7_);
#line 260 "Widgets/DockWindow.vala"
	_tmp9_ = _tmp8_;
#line 260 "Widgets/DockWindow.vala"
	if (_tmp9_) {
#line 261 "Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 261 "Widgets/DockWindow.vala"
		return result;
#line 784 "DockWindow.c"
	}
#line 264 "Widgets/DockWindow.vala"
	if (event->direction >= 4) {
#line 265 "Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 265 "Widgets/DockWindow.vala"
		return result;
#line 792 "DockWindow.c"
	}
#line 267 "Widgets/DockWindow.vala"
	if ((event->state & GDK_CONTROL_MASK) != 0) {
#line 268 "Widgets/DockWindow.vala"
		if (event->direction == GDK_SCROLL_UP) {
#line 798 "DockWindow.c"
			PlankDockController* _tmp10_;
			PlankDockPreferences* _tmp11_;
			PlankDockPreferences* _tmp12_;
#line 269 "Widgets/DockWindow.vala"
			_tmp10_ = self->priv->_controller;
#line 269 "Widgets/DockWindow.vala"
			_tmp11_ = plank_dock_controller_get_prefs (_tmp10_);
#line 269 "Widgets/DockWindow.vala"
			_tmp12_ = _tmp11_;
#line 269 "Widgets/DockWindow.vala"
			plank_dock_preferences_increase_icon_size (_tmp12_);
#line 810 "DockWindow.c"
		} else {
#line 270 "Widgets/DockWindow.vala"
			if (event->direction == GDK_SCROLL_DOWN) {
#line 814 "DockWindow.c"
				PlankDockController* _tmp13_;
				PlankDockPreferences* _tmp14_;
				PlankDockPreferences* _tmp15_;
#line 271 "Widgets/DockWindow.vala"
				_tmp13_ = self->priv->_controller;
#line 271 "Widgets/DockWindow.vala"
				_tmp14_ = plank_dock_controller_get_prefs (_tmp13_);
#line 271 "Widgets/DockWindow.vala"
				_tmp15_ = _tmp14_;
#line 271 "Widgets/DockWindow.vala"
				plank_dock_preferences_decrease_icon_size (_tmp15_);
#line 826 "DockWindow.c"
			}
		}
#line 273 "Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 273 "Widgets/DockWindow.vala"
		return result;
#line 833 "DockWindow.c"
	}
#line 276 "Widgets/DockWindow.vala"
	_tmp16_ = self->priv->_HoveredItem;
#line 276 "Widgets/DockWindow.vala"
	if (_tmp16_ != NULL) {
#line 839 "DockWindow.c"
		PlankDockController* _tmp17_;
		PlankHoverWindow* _tmp18_;
		PlankHoverWindow* _tmp19_;
		PlankDockItem* _tmp20_;
		PlankDockController* _tmp21_;
		PlankDockRenderer* _tmp22_;
		PlankDockRenderer* _tmp23_;
#line 278 "Widgets/DockWindow.vala"
		_tmp17_ = self->priv->_controller;
#line 278 "Widgets/DockWindow.vala"
		_tmp18_ = plank_dock_controller_get_hover (_tmp17_);
#line 278 "Widgets/DockWindow.vala"
		_tmp19_ = _tmp18_;
#line 278 "Widgets/DockWindow.vala"
		gtk_widget_hide ((GtkWidget*) _tmp19_);
#line 280 "Widgets/DockWindow.vala"
		_tmp20_ = self->priv->_HoveredItem;
#line 280 "Widgets/DockWindow.vala"
		plank_dock_element_scrolled ((PlankDockElement*) _tmp20_, event->direction, event->state, event->time);
#line 281 "Widgets/DockWindow.vala"
		_tmp21_ = self->priv->_controller;
#line 281 "Widgets/DockWindow.vala"
		_tmp22_ = plank_dock_controller_get_renderer (_tmp21_);
#line 281 "Widgets/DockWindow.vala"
		_tmp23_ = _tmp22_;
#line 281 "Widgets/DockWindow.vala"
		plank_renderer_animated_draw ((PlankRenderer*) _tmp23_);
#line 867 "DockWindow.c"
	}
#line 284 "Widgets/DockWindow.vala"
	result = GDK_EVENT_STOP;
#line 284 "Widgets/DockWindow.vala"
	return result;
#line 873 "DockWindow.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_dock_window_real_configure_event (GtkWidget* base,
                                        GdkEventConfigure* event)
{
	PlankDockWindow * self;
	GdkRectangle win_rect = {0};
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	GdkRectangle _tmp3_ = {0};
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	GdkRectangle _tmp7_;
	gboolean needs_update = FALSE;
	gboolean result;
#line 290 "Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 290 "Widgets/DockWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 292 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 292 "Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 292 "Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 292 "Widgets/DockWindow.vala"
	plank_position_manager_get_dock_window_region (_tmp2_, &_tmp3_);
#line 292 "Widgets/DockWindow.vala"
	win_rect = _tmp3_;
#line 293 "Widgets/DockWindow.vala"
	_tmp7_ = win_rect;
#line 293 "Widgets/DockWindow.vala"
	if (_tmp7_.width != event->width) {
#line 293 "Widgets/DockWindow.vala"
		_tmp6_ = TRUE;
#line 915 "DockWindow.c"
	} else {
		GdkRectangle _tmp8_;
#line 293 "Widgets/DockWindow.vala"
		_tmp8_ = win_rect;
#line 293 "Widgets/DockWindow.vala"
		_tmp6_ = _tmp8_.height != event->height;
#line 922 "DockWindow.c"
	}
#line 293 "Widgets/DockWindow.vala"
	if (_tmp6_) {
#line 293 "Widgets/DockWindow.vala"
		_tmp5_ = TRUE;
#line 928 "DockWindow.c"
	} else {
		GdkRectangle _tmp9_;
#line 294 "Widgets/DockWindow.vala"
		_tmp9_ = win_rect;
#line 294 "Widgets/DockWindow.vala"
		_tmp5_ = _tmp9_.x != event->x;
#line 935 "DockWindow.c"
	}
#line 293 "Widgets/DockWindow.vala"
	if (_tmp5_) {
#line 293 "Widgets/DockWindow.vala"
		_tmp4_ = TRUE;
#line 941 "DockWindow.c"
	} else {
		GdkRectangle _tmp10_;
#line 294 "Widgets/DockWindow.vala"
		_tmp10_ = win_rect;
#line 294 "Widgets/DockWindow.vala"
		_tmp4_ = _tmp10_.y != event->y;
#line 948 "DockWindow.c"
	}
#line 293 "Widgets/DockWindow.vala"
	needs_update = _tmp4_;
#line 296 "Widgets/DockWindow.vala"
	if (needs_update) {
#line 954 "DockWindow.c"
		gint _tmp11_;
#line 297 "Widgets/DockWindow.vala"
		self->priv->window_position_retry = self->priv->window_position_retry + 1;
#line 297 "Widgets/DockWindow.vala"
		_tmp11_ = self->priv->window_position_retry;
#line 297 "Widgets/DockWindow.vala"
		if (_tmp11_ < 3) {
#line 298 "Widgets/DockWindow.vala"
			g_critical ("DockWindow.vala:298: Retry #%i update_size_and_position() to force req" \
"uested values!", self->priv->window_position_retry);
#line 299 "Widgets/DockWindow.vala"
			plank_dock_window_update_size_and_position (self);
#line 966 "DockWindow.c"
		}
	} else {
#line 302 "Widgets/DockWindow.vala"
		self->priv->window_position_retry = 0;
#line 971 "DockWindow.c"
	}
#line 305 "Widgets/DockWindow.vala"
	result = GTK_WIDGET_CLASS (plank_dock_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, PLANK_TYPE_COMPOSITED_WINDOW, PlankCompositedWindow), event);
#line 305 "Widgets/DockWindow.vala"
	return result;
#line 977 "DockWindow.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_dock_window_real_draw (GtkWidget* base,
                             cairo_t* cr)
{
	PlankDockWindow * self;
	gboolean result;
#line 311 "Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 311 "Widgets/DockWindow.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 313 "Widgets/DockWindow.vala"
	plank_dock_window_set_input_mask (self);
#line 315 "Widgets/DockWindow.vala"
	result = GDK_EVENT_STOP;
#line 315 "Widgets/DockWindow.vala"
	return result;
#line 999 "DockWindow.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_dock_window_real_map_event (GtkWidget* base,
                                  GdkEventAny* event)
{
	PlankDockWindow * self;
	gboolean result;
#line 321 "Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 321 "Widgets/DockWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 323 "Widgets/DockWindow.vala"
	plank_dock_window_set_struts (self);
#line 325 "Widgets/DockWindow.vala"
	result = GTK_WIDGET_CLASS (plank_dock_window_parent_class)->map_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, PLANK_TYPE_COMPOSITED_WINDOW, PlankCompositedWindow), event);
#line 325 "Widgets/DockWindow.vala"
	return result;
#line 1021 "DockWindow.c"
}

/**
 * Sets the currently hovered item-provider for this dock.
 *
 * @param provider the hovered item-provider (if any) for this dock
 */
static void
plank_dock_window_set_hovered_provider (PlankDockWindow* self,
                                        PlankDockItemProvider* provider)
{
	PlankDockItemProvider* _tmp0_;
#line 333 "Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 335 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_HoveredItemProvider;
#line 335 "Widgets/DockWindow.vala"
	if (_tmp0_ == provider) {
#line 336 "Widgets/DockWindow.vala"
		return;
#line 1042 "DockWindow.c"
	}
#line 338 "Widgets/DockWindow.vala"
	plank_dock_window_set_HoveredItemProvider (self, provider);
#line 1046 "DockWindow.c"
}

/**
 * Sets the currently hovered item for this dock.
 *
 * @param item the hovered item (if any) for this dock
 */
static gboolean
__lambda44_ (PlankDockWindow* self)
{
	PlankDockItem* _tmp0_;
	gboolean _tmp1_ = FALSE;
	PlankDockController* _tmp2_;
	PlankHideManager* _tmp3_;
	PlankHideManager* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	PlankHoverWindow* hover = NULL;
	PlankDockController* _tmp12_;
	PlankHoverWindow* _tmp13_;
	PlankHoverWindow* _tmp14_;
	gint x = 0;
	gint y = 0;
	PlankHoverWindow* _tmp15_;
	PlankDockItem* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	PlankDockController* _tmp19_;
	PlankPositionManager* _tmp20_;
	PlankPositionManager* _tmp21_;
	PlankDockItem* _tmp22_;
	gint _tmp23_ = 0;
	gint _tmp24_ = 0;
	PlankHoverWindow* _tmp25_;
	PlankDockController* _tmp26_;
	PlankPositionManager* _tmp27_;
	PlankPositionManager* _tmp28_;
	GtkPositionType _tmp29_;
	GtkPositionType _tmp30_;
	gboolean result;
#line 377 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_HoveredItem;
#line 377 "Widgets/DockWindow.vala"
	if (_tmp0_ == NULL) {
#line 378 "Widgets/DockWindow.vala"
		self->priv->hover_reposition_timer_id = 0U;
#line 379 "Widgets/DockWindow.vala"
		result = FALSE;
#line 379 "Widgets/DockWindow.vala"
		return result;
#line 1097 "DockWindow.c"
	}
#line 383 "Widgets/DockWindow.vala"
	_tmp2_ = self->priv->_controller;
#line 383 "Widgets/DockWindow.vala"
	_tmp3_ = plank_dock_controller_get_hide_manager (_tmp2_);
#line 383 "Widgets/DockWindow.vala"
	_tmp4_ = _tmp3_;
#line 383 "Widgets/DockWindow.vala"
	_tmp5_ = plank_hide_manager_get_Hidden (_tmp4_);
#line 383 "Widgets/DockWindow.vala"
	_tmp6_ = _tmp5_;
#line 383 "Widgets/DockWindow.vala"
	if (!_tmp6_) {
#line 1111 "DockWindow.c"
		PlankDockController* _tmp7_;
		PlankDockRenderer* _tmp8_;
		PlankDockRenderer* _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
#line 384 "Widgets/DockWindow.vala"
		_tmp7_ = self->priv->_controller;
#line 384 "Widgets/DockWindow.vala"
		_tmp8_ = plank_dock_controller_get_renderer (_tmp7_);
#line 384 "Widgets/DockWindow.vala"
		_tmp9_ = _tmp8_;
#line 384 "Widgets/DockWindow.vala"
		_tmp10_ = plank_dock_renderer_get_hide_progress (_tmp9_);
#line 384 "Widgets/DockWindow.vala"
		_tmp11_ = _tmp10_;
#line 384 "Widgets/DockWindow.vala"
		_tmp1_ = _tmp11_ > 0.0;
#line 1129 "DockWindow.c"
	} else {
#line 383 "Widgets/DockWindow.vala"
		_tmp1_ = FALSE;
#line 1133 "DockWindow.c"
	}
#line 383 "Widgets/DockWindow.vala"
	if (_tmp1_) {
#line 385 "Widgets/DockWindow.vala"
		result = TRUE;
#line 385 "Widgets/DockWindow.vala"
		return result;
#line 1141 "DockWindow.c"
	}
#line 387 "Widgets/DockWindow.vala"
	self->priv->hover_reposition_timer_id = 0U;
#line 388 "Widgets/DockWindow.vala"
	_tmp12_ = self->priv->_controller;
#line 388 "Widgets/DockWindow.vala"
	_tmp13_ = plank_dock_controller_get_hover (_tmp12_);
#line 388 "Widgets/DockWindow.vala"
	_tmp14_ = _tmp13_;
#line 388 "Widgets/DockWindow.vala"
	hover = _tmp14_;
#line 391 "Widgets/DockWindow.vala"
	_tmp15_ = hover;
#line 391 "Widgets/DockWindow.vala"
	_tmp16_ = self->priv->_HoveredItem;
#line 391 "Widgets/DockWindow.vala"
	_tmp17_ = plank_dock_element_get_Text ((PlankDockElement*) _tmp16_);
#line 391 "Widgets/DockWindow.vala"
	_tmp18_ = _tmp17_;
#line 391 "Widgets/DockWindow.vala"
	plank_hover_window_set_text (_tmp15_, _tmp18_);
#line 392 "Widgets/DockWindow.vala"
	_tmp19_ = self->priv->_controller;
#line 392 "Widgets/DockWindow.vala"
	_tmp20_ = plank_dock_controller_get_position_manager (_tmp19_);
#line 392 "Widgets/DockWindow.vala"
	_tmp21_ = _tmp20_;
#line 392 "Widgets/DockWindow.vala"
	_tmp22_ = self->priv->_HoveredItem;
#line 392 "Widgets/DockWindow.vala"
	plank_position_manager_get_hover_position (_tmp21_, _tmp22_, &_tmp23_, &_tmp24_);
#line 392 "Widgets/DockWindow.vala"
	x = _tmp23_;
#line 392 "Widgets/DockWindow.vala"
	y = _tmp24_;
#line 393 "Widgets/DockWindow.vala"
	_tmp25_ = hover;
#line 393 "Widgets/DockWindow.vala"
	_tmp26_ = self->priv->_controller;
#line 393 "Widgets/DockWindow.vala"
	_tmp27_ = plank_dock_controller_get_position_manager (_tmp26_);
#line 393 "Widgets/DockWindow.vala"
	_tmp28_ = _tmp27_;
#line 393 "Widgets/DockWindow.vala"
	_tmp29_ = plank_position_manager_get_Position (_tmp28_);
#line 393 "Widgets/DockWindow.vala"
	_tmp30_ = _tmp29_;
#line 393 "Widgets/DockWindow.vala"
	plank_hover_window_show_at (_tmp25_, x, y, _tmp30_);
#line 395 "Widgets/DockWindow.vala"
	if (plank_dock_window_menu_is_visible (self)) {
#line 1193 "DockWindow.c"
		PlankHoverWindow* _tmp31_;
#line 396 "Widgets/DockWindow.vala"
		_tmp31_ = hover;
#line 396 "Widgets/DockWindow.vala"
		gtk_widget_hide ((GtkWidget*) _tmp31_);
#line 1199 "DockWindow.c"
	}
#line 398 "Widgets/DockWindow.vala"
	result = FALSE;
#line 398 "Widgets/DockWindow.vala"
	return result;
#line 1205 "DockWindow.c"
}

static gboolean
___lambda44__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda44_ ((PlankDockWindow*) self);
#line 376 "Widgets/DockWindow.vala"
	return result;
#line 1215 "DockWindow.c"
}

static void
plank_dock_window_set_hovered (PlankDockWindow* self,
                               PlankDockItem* item)
{
	PlankDockItem* _tmp0_;
	PlankDockItem* _tmp1_;
	PlankDockController* _tmp3_;
	PlankDragManager* _tmp4_;
	PlankDragManager* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	PlankDockController* _tmp8_;
	PlankHoverWindow* _tmp9_;
	PlankHoverWindow* _tmp10_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	PlankDockItem* _tmp13_;
#line 346 "Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 348 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_HoveredItem;
#line 348 "Widgets/DockWindow.vala"
	if (_tmp0_ == item) {
#line 349 "Widgets/DockWindow.vala"
		return;
#line 1243 "DockWindow.c"
	}
#line 351 "Widgets/DockWindow.vala"
	_tmp1_ = self->priv->_HoveredItem;
#line 351 "Widgets/DockWindow.vala"
	if (_tmp1_ != NULL) {
#line 1249 "DockWindow.c"
		PlankDockItem* _tmp2_;
#line 352 "Widgets/DockWindow.vala"
		_tmp2_ = self->priv->_HoveredItem;
#line 352 "Widgets/DockWindow.vala"
		plank_dock_element_hovered ((PlankDockElement*) _tmp2_);
#line 1255 "DockWindow.c"
	}
#line 354 "Widgets/DockWindow.vala"
	if (item != NULL) {
#line 355 "Widgets/DockWindow.vala"
		plank_dock_element_hovered ((PlankDockElement*) item);
#line 1261 "DockWindow.c"
	}
#line 357 "Widgets/DockWindow.vala"
	plank_dock_window_set_HoveredItem (self, item);
#line 360 "Widgets/DockWindow.vala"
	if (self->priv->hover_reposition_timer_id > 0U) {
#line 361 "Widgets/DockWindow.vala"
		g_source_remove (self->priv->hover_reposition_timer_id);
#line 362 "Widgets/DockWindow.vala"
		self->priv->hover_reposition_timer_id = 0U;
#line 1271 "DockWindow.c"
	}
#line 365 "Widgets/DockWindow.vala"
	_tmp3_ = self->priv->_controller;
#line 365 "Widgets/DockWindow.vala"
	_tmp4_ = plank_dock_controller_get_drag_manager (_tmp3_);
#line 365 "Widgets/DockWindow.vala"
	_tmp5_ = _tmp4_;
#line 365 "Widgets/DockWindow.vala"
	_tmp6_ = plank_drag_manager_get_ExternalDragActive (_tmp5_);
#line 365 "Widgets/DockWindow.vala"
	_tmp7_ = _tmp6_;
#line 365 "Widgets/DockWindow.vala"
	if (_tmp7_) {
#line 366 "Widgets/DockWindow.vala"
		return;
#line 1287 "DockWindow.c"
	}
#line 368 "Widgets/DockWindow.vala"
	_tmp8_ = self->priv->_controller;
#line 368 "Widgets/DockWindow.vala"
	_tmp9_ = plank_dock_controller_get_hover (_tmp8_);
#line 368 "Widgets/DockWindow.vala"
	_tmp10_ = _tmp9_;
#line 368 "Widgets/DockWindow.vala"
	gtk_widget_hide ((GtkWidget*) _tmp10_);
#line 370 "Widgets/DockWindow.vala"
	_tmp13_ = self->priv->_HoveredItem;
#line 370 "Widgets/DockWindow.vala"
	if (_tmp13_ == NULL) {
#line 370 "Widgets/DockWindow.vala"
		_tmp12_ = TRUE;
#line 1303 "DockWindow.c"
	} else {
		PlankDockController* _tmp14_;
		PlankDockPreferences* _tmp15_;
		PlankDockPreferences* _tmp16_;
		gboolean _tmp17_;
		gboolean _tmp18_;
#line 371 "Widgets/DockWindow.vala"
		_tmp14_ = self->priv->_controller;
#line 371 "Widgets/DockWindow.vala"
		_tmp15_ = plank_dock_controller_get_prefs (_tmp14_);
#line 371 "Widgets/DockWindow.vala"
		_tmp16_ = _tmp15_;
#line 371 "Widgets/DockWindow.vala"
		_tmp17_ = plank_dock_preferences_get_TooltipsEnabled (_tmp16_);
#line 371 "Widgets/DockWindow.vala"
		_tmp18_ = _tmp17_;
#line 371 "Widgets/DockWindow.vala"
		_tmp12_ = !_tmp18_;
#line 1322 "DockWindow.c"
	}
#line 370 "Widgets/DockWindow.vala"
	if (_tmp12_) {
#line 370 "Widgets/DockWindow.vala"
		_tmp11_ = TRUE;
#line 1328 "DockWindow.c"
	} else {
		PlankDockController* _tmp19_;
		PlankDragManager* _tmp20_;
		PlankDragManager* _tmp21_;
		gboolean _tmp22_;
		gboolean _tmp23_;
#line 372 "Widgets/DockWindow.vala"
		_tmp19_ = self->priv->_controller;
#line 372 "Widgets/DockWindow.vala"
		_tmp20_ = plank_dock_controller_get_drag_manager (_tmp19_);
#line 372 "Widgets/DockWindow.vala"
		_tmp21_ = _tmp20_;
#line 372 "Widgets/DockWindow.vala"
		_tmp22_ = plank_drag_manager_get_InternalDragActive (_tmp21_);
#line 372 "Widgets/DockWindow.vala"
		_tmp23_ = _tmp22_;
#line 372 "Widgets/DockWindow.vala"
		_tmp11_ = _tmp23_;
#line 1347 "DockWindow.c"
	}
#line 370 "Widgets/DockWindow.vala"
	if (_tmp11_) {
#line 373 "Widgets/DockWindow.vala"
		return;
#line 1353 "DockWindow.c"
	}
#line 376 "Widgets/DockWindow.vala"
	self->priv->hover_reposition_timer_id = gdk_threads_add_timeout (PLANK_DOCK_WINDOW_HOVER_DELAY_TIME, ___lambda44__gsource_func, self);
#line 1357 "DockWindow.c"
}

/**
 * Determines if an item is hovered by the cursor at the x/y position.
 *
 * @param x the cursor x position
 * @param y the cursor x position
 * @return if a dock item is hovered
 */
gboolean
plank_dock_window_update_hovered (PlankDockWindow* self,
                                  gint x,
                                  gint y)
{
	PlankDockController* _tmp0_;
	PlankHideManager* _tmp1_;
	PlankHideManager* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp5_;
	PlankPositionManager* _tmp6_;
	PlankPositionManager* _tmp7_;
	PlankDockItem* drag_item = NULL;
	PlankDockController* _tmp8_;
	PlankDragManager* _tmp9_;
	PlankDragManager* _tmp10_;
	PlankDockItem* _tmp11_;
	PlankDockItem* _tmp12_;
	GdkRectangle rect = {0};
	PlankDockItem* _tmp13_;
	PlankPositionManager* _tmp31_;
	GdkRectangle _tmp32_ = {0};
	gboolean _tmp33_ = FALSE;
	gboolean _tmp34_ = FALSE;
	gboolean _tmp35_ = FALSE;
	GdkRectangle _tmp36_;
	gboolean found_hovered_provider = FALSE;
	PlankDockItem* item = NULL;
	PlankDockItemProvider* provider = NULL;
	gboolean result;
#line 409 "Widgets/DockWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 412 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 412 "Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_hide_manager (_tmp0_);
#line 412 "Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 412 "Widgets/DockWindow.vala"
	_tmp3_ = plank_hide_manager_get_Hidden (_tmp2_);
#line 412 "Widgets/DockWindow.vala"
	_tmp4_ = _tmp3_;
#line 412 "Widgets/DockWindow.vala"
	if (_tmp4_) {
#line 413 "Widgets/DockWindow.vala"
		plank_dock_window_set_hovered_provider (self, NULL);
#line 414 "Widgets/DockWindow.vala"
		plank_dock_window_set_hovered (self, NULL);
#line 415 "Widgets/DockWindow.vala"
		result = FALSE;
#line 415 "Widgets/DockWindow.vala"
		return result;
#line 1421 "DockWindow.c"
	}
#line 418 "Widgets/DockWindow.vala"
	_tmp5_ = self->priv->_controller;
#line 418 "Widgets/DockWindow.vala"
	_tmp6_ = plank_dock_controller_get_position_manager (_tmp5_);
#line 418 "Widgets/DockWindow.vala"
	_tmp7_ = _tmp6_;
#line 418 "Widgets/DockWindow.vala"
	position_manager = _tmp7_;
#line 419 "Widgets/DockWindow.vala"
	_tmp8_ = self->priv->_controller;
#line 419 "Widgets/DockWindow.vala"
	_tmp9_ = plank_dock_controller_get_drag_manager (_tmp8_);
#line 419 "Widgets/DockWindow.vala"
	_tmp10_ = _tmp9_;
#line 419 "Widgets/DockWindow.vala"
	_tmp11_ = plank_drag_manager_get_DragItem (_tmp10_);
#line 419 "Widgets/DockWindow.vala"
	_tmp12_ = _tmp11_;
#line 419 "Widgets/DockWindow.vala"
	drag_item = _tmp12_;
#line 423 "Widgets/DockWindow.vala"
	_tmp13_ = self->priv->_HoveredItem;
#line 423 "Widgets/DockWindow.vala"
	if (_tmp13_ != NULL) {
#line 1447 "DockWindow.c"
		PlankPositionManager* _tmp14_;
		PlankDockItem* _tmp15_;
		GdkRectangle _tmp16_ = {0};
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
		GdkRectangle _tmp20_;
#line 424 "Widgets/DockWindow.vala"
		_tmp14_ = position_manager;
#line 424 "Widgets/DockWindow.vala"
		_tmp15_ = self->priv->_HoveredItem;
#line 424 "Widgets/DockWindow.vala"
		plank_position_manager_get_hover_region_for_element (_tmp14_, (PlankDockElement*) _tmp15_, &_tmp16_);
#line 424 "Widgets/DockWindow.vala"
		rect = _tmp16_;
#line 425 "Widgets/DockWindow.vala"
		_tmp20_ = rect;
#line 425 "Widgets/DockWindow.vala"
		if (y >= _tmp20_.y) {
#line 1467 "DockWindow.c"
			GdkRectangle _tmp21_;
			GdkRectangle _tmp22_;
#line 425 "Widgets/DockWindow.vala"
			_tmp21_ = rect;
#line 425 "Widgets/DockWindow.vala"
			_tmp22_ = rect;
#line 425 "Widgets/DockWindow.vala"
			_tmp19_ = y < (_tmp21_.y + _tmp22_.height);
#line 1476 "DockWindow.c"
		} else {
#line 425 "Widgets/DockWindow.vala"
			_tmp19_ = FALSE;
#line 1480 "DockWindow.c"
		}
#line 425 "Widgets/DockWindow.vala"
		if (_tmp19_) {
#line 1484 "DockWindow.c"
			GdkRectangle _tmp23_;
#line 425 "Widgets/DockWindow.vala"
			_tmp23_ = rect;
#line 425 "Widgets/DockWindow.vala"
			_tmp18_ = x >= _tmp23_.x;
#line 1490 "DockWindow.c"
		} else {
#line 425 "Widgets/DockWindow.vala"
			_tmp18_ = FALSE;
#line 1494 "DockWindow.c"
		}
#line 425 "Widgets/DockWindow.vala"
		if (_tmp18_) {
#line 1498 "DockWindow.c"
			GdkRectangle _tmp24_;
			GdkRectangle _tmp25_;
#line 425 "Widgets/DockWindow.vala"
			_tmp24_ = rect;
#line 425 "Widgets/DockWindow.vala"
			_tmp25_ = rect;
#line 425 "Widgets/DockWindow.vala"
			_tmp17_ = x < (_tmp24_.x + _tmp25_.width);
#line 1507 "DockWindow.c"
		} else {
#line 425 "Widgets/DockWindow.vala"
			_tmp17_ = FALSE;
#line 1511 "DockWindow.c"
		}
#line 425 "Widgets/DockWindow.vala"
		if (_tmp17_) {
#line 1515 "DockWindow.c"
			PlankDockItem* _tmp26_;
			PlankDockItem* _tmp27_;
#line 427 "Widgets/DockWindow.vala"
			_tmp26_ = drag_item;
#line 427 "Widgets/DockWindow.vala"
			_tmp27_ = self->priv->_HoveredItem;
#line 427 "Widgets/DockWindow.vala"
			if (_tmp26_ == _tmp27_) {
#line 1524 "DockWindow.c"
				PlankDockItem* _tmp28_;
				PlankDockContainer* _tmp29_;
				PlankDockContainer* _tmp30_;
#line 428 "Widgets/DockWindow.vala"
				_tmp28_ = self->priv->_HoveredItem;
#line 428 "Widgets/DockWindow.vala"
				_tmp29_ = plank_dock_element_get_Container ((PlankDockElement*) _tmp28_);
#line 428 "Widgets/DockWindow.vala"
				_tmp30_ = _tmp29_;
#line 428 "Widgets/DockWindow.vala"
				plank_dock_window_set_hovered_provider (self, PLANK_IS_DOCK_ITEM_PROVIDER (_tmp30_) ? ((PlankDockItemProvider*) _tmp30_) : NULL);
#line 429 "Widgets/DockWindow.vala"
				plank_dock_window_set_hovered (self, NULL);
#line 430 "Widgets/DockWindow.vala"
				result = FALSE;
#line 430 "Widgets/DockWindow.vala"
				return result;
#line 1542 "DockWindow.c"
			} else {
#line 433 "Widgets/DockWindow.vala"
				result = TRUE;
#line 433 "Widgets/DockWindow.vala"
				return result;
#line 1548 "DockWindow.c"
			}
		}
	}
#line 437 "Widgets/DockWindow.vala"
	_tmp31_ = position_manager;
#line 437 "Widgets/DockWindow.vala"
	plank_position_manager_get_cursor_region (_tmp31_, &_tmp32_);
#line 437 "Widgets/DockWindow.vala"
	rect = _tmp32_;
#line 438 "Widgets/DockWindow.vala"
	_tmp36_ = rect;
#line 438 "Widgets/DockWindow.vala"
	if (y < _tmp36_.y) {
#line 438 "Widgets/DockWindow.vala"
		_tmp35_ = TRUE;
#line 1564 "DockWindow.c"
	} else {
		GdkRectangle _tmp37_;
		GdkRectangle _tmp38_;
#line 438 "Widgets/DockWindow.vala"
		_tmp37_ = rect;
#line 438 "Widgets/DockWindow.vala"
		_tmp38_ = rect;
#line 438 "Widgets/DockWindow.vala"
		_tmp35_ = y >= (_tmp37_.y + _tmp38_.height);
#line 1574 "DockWindow.c"
	}
#line 438 "Widgets/DockWindow.vala"
	if (_tmp35_) {
#line 438 "Widgets/DockWindow.vala"
		_tmp34_ = TRUE;
#line 1580 "DockWindow.c"
	} else {
		GdkRectangle _tmp39_;
#line 438 "Widgets/DockWindow.vala"
		_tmp39_ = rect;
#line 438 "Widgets/DockWindow.vala"
		_tmp34_ = x < _tmp39_.x;
#line 1587 "DockWindow.c"
	}
#line 438 "Widgets/DockWindow.vala"
	if (_tmp34_) {
#line 438 "Widgets/DockWindow.vala"
		_tmp33_ = TRUE;
#line 1593 "DockWindow.c"
	} else {
		GdkRectangle _tmp40_;
		GdkRectangle _tmp41_;
#line 438 "Widgets/DockWindow.vala"
		_tmp40_ = rect;
#line 438 "Widgets/DockWindow.vala"
		_tmp41_ = rect;
#line 438 "Widgets/DockWindow.vala"
		_tmp33_ = x >= (_tmp40_.x + _tmp41_.width);
#line 1603 "DockWindow.c"
	}
#line 438 "Widgets/DockWindow.vala"
	if (_tmp33_) {
#line 439 "Widgets/DockWindow.vala"
		plank_dock_window_set_hovered_provider (self, NULL);
#line 440 "Widgets/DockWindow.vala"
		plank_dock_window_set_hovered (self, NULL);
#line 441 "Widgets/DockWindow.vala"
		result = FALSE;
#line 441 "Widgets/DockWindow.vala"
		return result;
#line 1615 "DockWindow.c"
	}
#line 444 "Widgets/DockWindow.vala"
	found_hovered_provider = FALSE;
#line 445 "Widgets/DockWindow.vala"
	item = NULL;
#line 446 "Widgets/DockWindow.vala"
	provider = NULL;
#line 1623 "DockWindow.c"
	{
		GeeArrayList* _element_list = NULL;
		PlankDockController* _tmp42_;
		GeeArrayList* _tmp43_;
		GeeArrayList* _tmp44_;
		gint _element_size = 0;
		GeeArrayList* _tmp45_;
		gint _tmp46_;
		gint _tmp47_;
		gint _element_index = 0;
#line 448 "Widgets/DockWindow.vala"
		_tmp42_ = self->priv->_controller;
#line 448 "Widgets/DockWindow.vala"
		_tmp43_ = plank_dock_container_get_VisibleElements ((PlankDockContainer*) _tmp42_);
#line 448 "Widgets/DockWindow.vala"
		_tmp44_ = _tmp43_;
#line 448 "Widgets/DockWindow.vala"
		_element_list = _tmp44_;
#line 448 "Widgets/DockWindow.vala"
		_tmp45_ = _element_list;
#line 448 "Widgets/DockWindow.vala"
		_tmp46_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp45_);
#line 448 "Widgets/DockWindow.vala"
		_tmp47_ = _tmp46_;
#line 448 "Widgets/DockWindow.vala"
		_element_size = _tmp47_;
#line 448 "Widgets/DockWindow.vala"
		_element_index = -1;
#line 448 "Widgets/DockWindow.vala"
		while (TRUE) {
#line 1654 "DockWindow.c"
			gint _tmp48_;
			gint _tmp49_;
			PlankDockElement* element = NULL;
			GeeArrayList* _tmp50_;
			gpointer _tmp51_;
			PlankDockElement* _tmp52_;
			PlankDockItem* _tmp53_;
			PlankDockElement* _tmp69_;
			PlankDockItemProvider* _tmp70_;
			PlankPositionManager* _tmp71_;
			PlankDockItemProvider* _tmp72_;
			GdkRectangle _tmp73_ = {0};
			gboolean _tmp74_ = FALSE;
			gboolean _tmp75_ = FALSE;
			gboolean _tmp76_ = FALSE;
			GdkRectangle _tmp77_;
			PlankDockItemProvider* _tmp83_;
#line 448 "Widgets/DockWindow.vala"
			_element_index = _element_index + 1;
#line 448 "Widgets/DockWindow.vala"
			_tmp48_ = _element_index;
#line 448 "Widgets/DockWindow.vala"
			_tmp49_ = _element_size;
#line 448 "Widgets/DockWindow.vala"
			if (!(_tmp48_ < _tmp49_)) {
#line 448 "Widgets/DockWindow.vala"
				break;
#line 1682 "DockWindow.c"
			}
#line 448 "Widgets/DockWindow.vala"
			_tmp50_ = _element_list;
#line 448 "Widgets/DockWindow.vala"
			_tmp51_ = gee_abstract_list_get ((GeeAbstractList*) _tmp50_, _element_index);
#line 448 "Widgets/DockWindow.vala"
			element = (PlankDockElement*) _tmp51_;
#line 449 "Widgets/DockWindow.vala"
			_tmp52_ = element;
#line 449 "Widgets/DockWindow.vala"
			item = PLANK_IS_DOCK_ITEM (_tmp52_) ? ((PlankDockItem*) _tmp52_) : NULL;
#line 450 "Widgets/DockWindow.vala"
			_tmp53_ = item;
#line 450 "Widgets/DockWindow.vala"
			if (_tmp53_ != NULL) {
#line 1698 "DockWindow.c"
				PlankPositionManager* _tmp54_;
				PlankDockItem* _tmp55_;
				GdkRectangle _tmp56_ = {0};
				gboolean _tmp57_ = FALSE;
				gboolean _tmp58_ = FALSE;
				gboolean _tmp59_ = FALSE;
				GdkRectangle _tmp60_;
				PlankDockItem* _tmp66_;
				PlankDockItem* _tmp67_;
				PlankDockItem* _tmp68_;
#line 451 "Widgets/DockWindow.vala"
				_tmp54_ = position_manager;
#line 451 "Widgets/DockWindow.vala"
				_tmp55_ = item;
#line 451 "Widgets/DockWindow.vala"
				plank_position_manager_get_hover_region_for_element (_tmp54_, (PlankDockElement*) _tmp55_, &_tmp56_);
#line 451 "Widgets/DockWindow.vala"
				rect = _tmp56_;
#line 452 "Widgets/DockWindow.vala"
				_tmp60_ = rect;
#line 452 "Widgets/DockWindow.vala"
				if (y < _tmp60_.y) {
#line 452 "Widgets/DockWindow.vala"
					_tmp59_ = TRUE;
#line 1723 "DockWindow.c"
				} else {
					GdkRectangle _tmp61_;
					GdkRectangle _tmp62_;
#line 452 "Widgets/DockWindow.vala"
					_tmp61_ = rect;
#line 452 "Widgets/DockWindow.vala"
					_tmp62_ = rect;
#line 452 "Widgets/DockWindow.vala"
					_tmp59_ = y >= (_tmp61_.y + _tmp62_.height);
#line 1733 "DockWindow.c"
				}
#line 452 "Widgets/DockWindow.vala"
				if (_tmp59_) {
#line 452 "Widgets/DockWindow.vala"
					_tmp58_ = TRUE;
#line 1739 "DockWindow.c"
				} else {
					GdkRectangle _tmp63_;
#line 452 "Widgets/DockWindow.vala"
					_tmp63_ = rect;
#line 452 "Widgets/DockWindow.vala"
					_tmp58_ = x < _tmp63_.x;
#line 1746 "DockWindow.c"
				}
#line 452 "Widgets/DockWindow.vala"
				if (_tmp58_) {
#line 452 "Widgets/DockWindow.vala"
					_tmp57_ = TRUE;
#line 1752 "DockWindow.c"
				} else {
					GdkRectangle _tmp64_;
					GdkRectangle _tmp65_;
#line 452 "Widgets/DockWindow.vala"
					_tmp64_ = rect;
#line 452 "Widgets/DockWindow.vala"
					_tmp65_ = rect;
#line 452 "Widgets/DockWindow.vala"
					_tmp57_ = x >= (_tmp64_.x + _tmp65_.width);
#line 1762 "DockWindow.c"
				}
#line 452 "Widgets/DockWindow.vala"
				if (_tmp57_) {
#line 453 "Widgets/DockWindow.vala"
					_g_object_unref0 (element);
#line 453 "Widgets/DockWindow.vala"
					continue;
#line 1770 "DockWindow.c"
				}
#line 456 "Widgets/DockWindow.vala"
				_tmp66_ = drag_item;
#line 456 "Widgets/DockWindow.vala"
				_tmp67_ = item;
#line 456 "Widgets/DockWindow.vala"
				if (_tmp66_ == _tmp67_) {
#line 457 "Widgets/DockWindow.vala"
					_g_object_unref0 (element);
#line 457 "Widgets/DockWindow.vala"
					break;
#line 1782 "DockWindow.c"
				}
#line 459 "Widgets/DockWindow.vala"
				plank_dock_window_set_hovered_provider (self, NULL);
#line 460 "Widgets/DockWindow.vala"
				_tmp68_ = item;
#line 460 "Widgets/DockWindow.vala"
				plank_dock_window_set_hovered (self, PLANK_IS_DOCK_ITEM (_tmp68_) ? ((PlankDockItem*) _tmp68_) : NULL);
#line 461 "Widgets/DockWindow.vala"
				result = TRUE;
#line 461 "Widgets/DockWindow.vala"
				_g_object_unref0 (element);
#line 461 "Widgets/DockWindow.vala"
				return result;
#line 1796 "DockWindow.c"
			}
#line 464 "Widgets/DockWindow.vala"
			_tmp69_ = element;
#line 464 "Widgets/DockWindow.vala"
			provider = PLANK_IS_DOCK_ITEM_PROVIDER (_tmp69_) ? ((PlankDockItemProvider*) _tmp69_) : NULL;
#line 465 "Widgets/DockWindow.vala"
			_tmp70_ = provider;
#line 465 "Widgets/DockWindow.vala"
			if (_tmp70_ == NULL) {
#line 466 "Widgets/DockWindow.vala"
				_g_object_unref0 (element);
#line 466 "Widgets/DockWindow.vala"
				continue;
#line 1810 "DockWindow.c"
			}
#line 468 "Widgets/DockWindow.vala"
			_tmp71_ = position_manager;
#line 468 "Widgets/DockWindow.vala"
			_tmp72_ = provider;
#line 468 "Widgets/DockWindow.vala"
			plank_position_manager_get_hover_region_for_element (_tmp71_, (PlankDockElement*) _tmp72_, &_tmp73_);
#line 468 "Widgets/DockWindow.vala"
			rect = _tmp73_;
#line 469 "Widgets/DockWindow.vala"
			_tmp77_ = rect;
#line 469 "Widgets/DockWindow.vala"
			if (y < _tmp77_.y) {
#line 469 "Widgets/DockWindow.vala"
				_tmp76_ = TRUE;
#line 1826 "DockWindow.c"
			} else {
				GdkRectangle _tmp78_;
				GdkRectangle _tmp79_;
#line 469 "Widgets/DockWindow.vala"
				_tmp78_ = rect;
#line 469 "Widgets/DockWindow.vala"
				_tmp79_ = rect;
#line 469 "Widgets/DockWindow.vala"
				_tmp76_ = y >= (_tmp78_.y + _tmp79_.height);
#line 1836 "DockWindow.c"
			}
#line 469 "Widgets/DockWindow.vala"
			if (_tmp76_) {
#line 469 "Widgets/DockWindow.vala"
				_tmp75_ = TRUE;
#line 1842 "DockWindow.c"
			} else {
				GdkRectangle _tmp80_;
#line 469 "Widgets/DockWindow.vala"
				_tmp80_ = rect;
#line 469 "Widgets/DockWindow.vala"
				_tmp75_ = x < _tmp80_.x;
#line 1849 "DockWindow.c"
			}
#line 469 "Widgets/DockWindow.vala"
			if (_tmp75_) {
#line 469 "Widgets/DockWindow.vala"
				_tmp74_ = TRUE;
#line 1855 "DockWindow.c"
			} else {
				GdkRectangle _tmp81_;
				GdkRectangle _tmp82_;
#line 469 "Widgets/DockWindow.vala"
				_tmp81_ = rect;
#line 469 "Widgets/DockWindow.vala"
				_tmp82_ = rect;
#line 469 "Widgets/DockWindow.vala"
				_tmp74_ = x >= (_tmp81_.x + _tmp82_.width);
#line 1865 "DockWindow.c"
			}
#line 469 "Widgets/DockWindow.vala"
			if (_tmp74_) {
#line 470 "Widgets/DockWindow.vala"
				_g_object_unref0 (element);
#line 470 "Widgets/DockWindow.vala"
				continue;
#line 1873 "DockWindow.c"
			}
#line 472 "Widgets/DockWindow.vala"
			_tmp83_ = provider;
#line 472 "Widgets/DockWindow.vala"
			plank_dock_window_set_hovered_provider (self, _tmp83_);
#line 473 "Widgets/DockWindow.vala"
			found_hovered_provider = TRUE;
#line 1881 "DockWindow.c"
			{
				GeeArrayList* _element2_list = NULL;
				PlankDockItemProvider* _tmp84_;
				GeeArrayList* _tmp85_;
				GeeArrayList* _tmp86_;
				gint _element2_size = 0;
				GeeArrayList* _tmp87_;
				gint _tmp88_;
				gint _tmp89_;
				gint _element2_index = 0;
#line 475 "Widgets/DockWindow.vala"
				_tmp84_ = provider;
#line 475 "Widgets/DockWindow.vala"
				_tmp85_ = plank_dock_container_get_VisibleElements ((PlankDockContainer*) _tmp84_);
#line 475 "Widgets/DockWindow.vala"
				_tmp86_ = _tmp85_;
#line 475 "Widgets/DockWindow.vala"
				_element2_list = _tmp86_;
#line 475 "Widgets/DockWindow.vala"
				_tmp87_ = _element2_list;
#line 475 "Widgets/DockWindow.vala"
				_tmp88_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp87_);
#line 475 "Widgets/DockWindow.vala"
				_tmp89_ = _tmp88_;
#line 475 "Widgets/DockWindow.vala"
				_element2_size = _tmp89_;
#line 475 "Widgets/DockWindow.vala"
				_element2_index = -1;
#line 475 "Widgets/DockWindow.vala"
				while (TRUE) {
#line 1912 "DockWindow.c"
					gint _tmp90_;
					gint _tmp91_;
					PlankDockElement* element2 = NULL;
					GeeArrayList* _tmp92_;
					gpointer _tmp93_;
					PlankPositionManager* _tmp94_;
					PlankDockElement* _tmp95_;
					GdkRectangle _tmp96_ = {0};
					gboolean _tmp97_ = FALSE;
					gboolean _tmp98_ = FALSE;
					gboolean _tmp99_ = FALSE;
					GdkRectangle _tmp100_;
					PlankDockItem* _tmp106_;
					PlankDockElement* _tmp107_;
					PlankDockElement* _tmp108_;
#line 475 "Widgets/DockWindow.vala"
					_element2_index = _element2_index + 1;
#line 475 "Widgets/DockWindow.vala"
					_tmp90_ = _element2_index;
#line 475 "Widgets/DockWindow.vala"
					_tmp91_ = _element2_size;
#line 475 "Widgets/DockWindow.vala"
					if (!(_tmp90_ < _tmp91_)) {
#line 475 "Widgets/DockWindow.vala"
						break;
#line 1938 "DockWindow.c"
					}
#line 475 "Widgets/DockWindow.vala"
					_tmp92_ = _element2_list;
#line 475 "Widgets/DockWindow.vala"
					_tmp93_ = gee_abstract_list_get ((GeeAbstractList*) _tmp92_, _element2_index);
#line 475 "Widgets/DockWindow.vala"
					element2 = (PlankDockElement*) _tmp93_;
#line 476 "Widgets/DockWindow.vala"
					_tmp94_ = position_manager;
#line 476 "Widgets/DockWindow.vala"
					_tmp95_ = element2;
#line 476 "Widgets/DockWindow.vala"
					plank_position_manager_get_hover_region_for_element (_tmp94_, _tmp95_, &_tmp96_);
#line 476 "Widgets/DockWindow.vala"
					rect = _tmp96_;
#line 477 "Widgets/DockWindow.vala"
					_tmp100_ = rect;
#line 477 "Widgets/DockWindow.vala"
					if (y < _tmp100_.y) {
#line 477 "Widgets/DockWindow.vala"
						_tmp99_ = TRUE;
#line 1960 "DockWindow.c"
					} else {
						GdkRectangle _tmp101_;
						GdkRectangle _tmp102_;
#line 477 "Widgets/DockWindow.vala"
						_tmp101_ = rect;
#line 477 "Widgets/DockWindow.vala"
						_tmp102_ = rect;
#line 477 "Widgets/DockWindow.vala"
						_tmp99_ = y >= (_tmp101_.y + _tmp102_.height);
#line 1970 "DockWindow.c"
					}
#line 477 "Widgets/DockWindow.vala"
					if (_tmp99_) {
#line 477 "Widgets/DockWindow.vala"
						_tmp98_ = TRUE;
#line 1976 "DockWindow.c"
					} else {
						GdkRectangle _tmp103_;
#line 477 "Widgets/DockWindow.vala"
						_tmp103_ = rect;
#line 477 "Widgets/DockWindow.vala"
						_tmp98_ = x < _tmp103_.x;
#line 1983 "DockWindow.c"
					}
#line 477 "Widgets/DockWindow.vala"
					if (_tmp98_) {
#line 477 "Widgets/DockWindow.vala"
						_tmp97_ = TRUE;
#line 1989 "DockWindow.c"
					} else {
						GdkRectangle _tmp104_;
						GdkRectangle _tmp105_;
#line 477 "Widgets/DockWindow.vala"
						_tmp104_ = rect;
#line 477 "Widgets/DockWindow.vala"
						_tmp105_ = rect;
#line 477 "Widgets/DockWindow.vala"
						_tmp97_ = x >= (_tmp104_.x + _tmp105_.width);
#line 1999 "DockWindow.c"
					}
#line 477 "Widgets/DockWindow.vala"
					if (_tmp97_) {
#line 478 "Widgets/DockWindow.vala"
						_g_object_unref0 (element2);
#line 478 "Widgets/DockWindow.vala"
						continue;
#line 2007 "DockWindow.c"
					}
#line 481 "Widgets/DockWindow.vala"
					_tmp106_ = drag_item;
#line 481 "Widgets/DockWindow.vala"
					_tmp107_ = element2;
#line 481 "Widgets/DockWindow.vala"
					if (G_TYPE_CHECK_INSTANCE_CAST (_tmp106_, PLANK_TYPE_DOCK_ELEMENT, PlankDockElement) == _tmp107_) {
#line 482 "Widgets/DockWindow.vala"
						_g_object_unref0 (element2);
#line 482 "Widgets/DockWindow.vala"
						break;
#line 2019 "DockWindow.c"
					}
#line 484 "Widgets/DockWindow.vala"
					_tmp108_ = element2;
#line 484 "Widgets/DockWindow.vala"
					plank_dock_window_set_hovered (self, PLANK_IS_DOCK_ITEM (_tmp108_) ? ((PlankDockItem*) _tmp108_) : NULL);
#line 485 "Widgets/DockWindow.vala"
					result = TRUE;
#line 485 "Widgets/DockWindow.vala"
					_g_object_unref0 (element2);
#line 485 "Widgets/DockWindow.vala"
					_g_object_unref0 (element);
#line 485 "Widgets/DockWindow.vala"
					return result;
#line 2033 "DockWindow.c"
				}
			}
#line 448 "Widgets/DockWindow.vala"
			_g_object_unref0 (element);
#line 2038 "DockWindow.c"
		}
	}
#line 489 "Widgets/DockWindow.vala"
	if (!found_hovered_provider) {
#line 490 "Widgets/DockWindow.vala"
		plank_dock_window_set_hovered_provider (self, NULL);
#line 2045 "DockWindow.c"
	}
#line 491 "Widgets/DockWindow.vala"
	plank_dock_window_set_hovered (self, NULL);
#line 492 "Widgets/DockWindow.vala"
	result = FALSE;
#line 492 "Widgets/DockWindow.vala"
	return result;
#line 2053 "DockWindow.c"
}

/**
 * Sets the size of the dock window and repositions it if needed.
 */
void
plank_dock_window_update_size_and_position (PlankDockWindow* self)
{
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	GdkRectangle win_rect = {0};
	PlankPositionManager* _tmp3_;
	GdkRectangle _tmp4_ = {0};
	gint width_current = 0;
	gint height_current = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gboolean _tmp7_ = FALSE;
	GdkRectangle _tmp8_;
	gboolean needs_resize = FALSE;
	gboolean needs_reposition = FALSE;
#line 498 "Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 500 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 500 "Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 500 "Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 500 "Widgets/DockWindow.vala"
	position_manager = _tmp2_;
#line 502 "Widgets/DockWindow.vala"
	_tmp3_ = position_manager;
#line 502 "Widgets/DockWindow.vala"
	plank_position_manager_get_dock_window_region (_tmp3_, &_tmp4_);
#line 502 "Widgets/DockWindow.vala"
	win_rect = _tmp4_;
#line 505 "Widgets/DockWindow.vala"
	gtk_widget_get_size_request ((GtkWidget*) self, &_tmp5_, &_tmp6_);
#line 505 "Widgets/DockWindow.vala"
	width_current = _tmp5_;
#line 505 "Widgets/DockWindow.vala"
	height_current = _tmp6_;
#line 506 "Widgets/DockWindow.vala"
	_tmp8_ = win_rect;
#line 506 "Widgets/DockWindow.vala"
	if (_tmp8_.width != width_current) {
#line 506 "Widgets/DockWindow.vala"
		_tmp7_ = TRUE;
#line 2105 "DockWindow.c"
	} else {
		GdkRectangle _tmp9_;
#line 506 "Widgets/DockWindow.vala"
		_tmp9_ = win_rect;
#line 506 "Widgets/DockWindow.vala"
		_tmp7_ = _tmp9_.height != height_current;
#line 2112 "DockWindow.c"
	}
#line 506 "Widgets/DockWindow.vala"
	needs_resize = _tmp7_;
#line 508 "Widgets/DockWindow.vala"
	needs_reposition = TRUE;
#line 509 "Widgets/DockWindow.vala"
	if (gtk_widget_get_realized ((GtkWidget*) self)) {
#line 2120 "DockWindow.c"
		gint x_current = 0;
		gint y_current = 0;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		gboolean _tmp12_ = FALSE;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		GdkRectangle _tmp15_;
#line 511 "Widgets/DockWindow.vala"
		gtk_window_get_position ((GtkWindow*) self, &_tmp10_, &_tmp11_);
#line 511 "Widgets/DockWindow.vala"
		x_current = _tmp10_;
#line 511 "Widgets/DockWindow.vala"
		y_current = _tmp11_;
#line 512 "Widgets/DockWindow.vala"
		_tmp15_ = win_rect;
#line 512 "Widgets/DockWindow.vala"
		if (_tmp15_.x != x_current) {
#line 512 "Widgets/DockWindow.vala"
			_tmp14_ = TRUE;
#line 2141 "DockWindow.c"
		} else {
			GdkRectangle _tmp16_;
#line 512 "Widgets/DockWindow.vala"
			_tmp16_ = win_rect;
#line 512 "Widgets/DockWindow.vala"
			_tmp14_ = _tmp16_.y != y_current;
#line 2148 "DockWindow.c"
		}
#line 512 "Widgets/DockWindow.vala"
		if (_tmp14_) {
#line 512 "Widgets/DockWindow.vala"
			_tmp13_ = TRUE;
#line 2154 "DockWindow.c"
		} else {
			GdkRectangle _tmp17_;
#line 513 "Widgets/DockWindow.vala"
			_tmp17_ = win_rect;
#line 513 "Widgets/DockWindow.vala"
			_tmp13_ = _tmp17_.x != self->priv->requested_x;
#line 2161 "DockWindow.c"
		}
#line 512 "Widgets/DockWindow.vala"
		if (_tmp13_) {
#line 512 "Widgets/DockWindow.vala"
			_tmp12_ = TRUE;
#line 2167 "DockWindow.c"
		} else {
			GdkRectangle _tmp18_;
#line 513 "Widgets/DockWindow.vala"
			_tmp18_ = win_rect;
#line 513 "Widgets/DockWindow.vala"
			_tmp12_ = _tmp18_.y != self->priv->requested_y;
#line 2174 "DockWindow.c"
		}
#line 512 "Widgets/DockWindow.vala"
		needs_reposition = _tmp12_;
#line 2178 "DockWindow.c"
	}
#line 516 "Widgets/DockWindow.vala"
	if (needs_resize) {
#line 2182 "DockWindow.c"
		GdkRectangle _tmp19_;
		GdkRectangle _tmp20_;
		GdkRectangle _tmp21_;
		GdkRectangle _tmp22_;
		PlankDockController* _tmp23_;
		PlankDockRenderer* _tmp24_;
		PlankDockRenderer* _tmp25_;
#line 517 "Widgets/DockWindow.vala"
		_tmp19_ = win_rect;
#line 517 "Widgets/DockWindow.vala"
		_tmp20_ = win_rect;
#line 517 "Widgets/DockWindow.vala"
		plank_logger_verbose ("DockWindow.set_size_request (width = %i, height = %i)", _tmp19_.width, _tmp20_.height, NULL);
#line 518 "Widgets/DockWindow.vala"
		_tmp21_ = win_rect;
#line 518 "Widgets/DockWindow.vala"
		_tmp22_ = win_rect;
#line 518 "Widgets/DockWindow.vala"
		gtk_widget_set_size_request ((GtkWidget*) self, _tmp21_.width, _tmp22_.height);
#line 519 "Widgets/DockWindow.vala"
		_tmp23_ = self->priv->_controller;
#line 519 "Widgets/DockWindow.vala"
		_tmp24_ = plank_dock_controller_get_renderer (_tmp23_);
#line 519 "Widgets/DockWindow.vala"
		_tmp25_ = _tmp24_;
#line 519 "Widgets/DockWindow.vala"
		plank_dock_renderer_reset_buffers (_tmp25_);
#line 521 "Widgets/DockWindow.vala"
		if (!needs_reposition) {
#line 522 "Widgets/DockWindow.vala"
			plank_dock_window_update_icon_regions (self);
#line 523 "Widgets/DockWindow.vala"
			plank_dock_window_set_struts (self);
#line 524 "Widgets/DockWindow.vala"
			plank_dock_window_set_hovered_provider (self, NULL);
#line 525 "Widgets/DockWindow.vala"
			plank_dock_window_set_hovered (self, NULL);
#line 2220 "DockWindow.c"
		}
	}
#line 529 "Widgets/DockWindow.vala"
	if (needs_reposition) {
#line 2225 "DockWindow.c"
		GdkRectangle _tmp26_;
		GdkRectangle _tmp27_;
		GdkRectangle _tmp28_;
		GdkRectangle _tmp29_;
		GdkRectangle _tmp30_;
		GdkRectangle _tmp31_;
#line 530 "Widgets/DockWindow.vala"
		_tmp26_ = win_rect;
#line 530 "Widgets/DockWindow.vala"
		_tmp27_ = win_rect;
#line 530 "Widgets/DockWindow.vala"
		plank_logger_verbose ("DockWindow.move (x = %i, y = %i)", _tmp26_.x, _tmp27_.y, NULL);
#line 531 "Widgets/DockWindow.vala"
		_tmp28_ = win_rect;
#line 531 "Widgets/DockWindow.vala"
		self->priv->requested_x = _tmp28_.x;
#line 532 "Widgets/DockWindow.vala"
		_tmp29_ = win_rect;
#line 532 "Widgets/DockWindow.vala"
		self->priv->requested_y = _tmp29_.y;
#line 533 "Widgets/DockWindow.vala"
		_tmp30_ = win_rect;
#line 533 "Widgets/DockWindow.vala"
		_tmp31_ = win_rect;
#line 533 "Widgets/DockWindow.vala"
		gtk_window_move ((GtkWindow*) self, _tmp30_.x, _tmp31_.y);
#line 535 "Widgets/DockWindow.vala"
		plank_dock_window_update_icon_regions (self);
#line 536 "Widgets/DockWindow.vala"
		plank_dock_window_set_struts (self);
#line 537 "Widgets/DockWindow.vala"
		plank_dock_window_set_hovered_provider (self, NULL);
#line 538 "Widgets/DockWindow.vala"
		plank_dock_window_set_hovered (self, NULL);
#line 2260 "DockWindow.c"
	}
}

/**
 * Updates the icon regions for all items on the dock.
 */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 551 "Widgets/DockWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 2272 "DockWindow.c"
}

void
plank_dock_window_update_icon_regions (PlankDockWindow* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean use_hidden_region = FALSE;
#line 545 "Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 547 "Widgets/DockWindow.vala"
	plank_logger_verbose ("DockWindow.update_icon_regions ()", NULL);
#line 549 "Widgets/DockWindow.vala"
	if (plank_dock_window_menu_is_visible (self)) {
#line 549 "Widgets/DockWindow.vala"
		_tmp0_ = TRUE;
#line 2288 "DockWindow.c"
	} else {
		PlankDockController* _tmp1_;
		PlankHideManager* _tmp2_;
		PlankHideManager* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 549 "Widgets/DockWindow.vala"
		_tmp1_ = self->priv->_controller;
#line 549 "Widgets/DockWindow.vala"
		_tmp2_ = plank_dock_controller_get_hide_manager (_tmp1_);
#line 549 "Widgets/DockWindow.vala"
		_tmp3_ = _tmp2_;
#line 549 "Widgets/DockWindow.vala"
		_tmp4_ = plank_hide_manager_get_Hidden (_tmp3_);
#line 549 "Widgets/DockWindow.vala"
		_tmp5_ = _tmp4_;
#line 549 "Widgets/DockWindow.vala"
		_tmp0_ = _tmp5_;
#line 2307 "DockWindow.c"
	}
#line 549 "Widgets/DockWindow.vala"
	use_hidden_region = _tmp0_;
#line 2311 "DockWindow.c"
	{
		GeeArrayList* _item_list = NULL;
		PlankDockController* _tmp6_;
		GeeArrayList* _tmp7_;
		GeeArrayList* _tmp8_;
		gint _item_size = 0;
		GeeArrayList* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _item_index = 0;
#line 551 "Widgets/DockWindow.vala"
		_tmp6_ = self->priv->_controller;
#line 551 "Widgets/DockWindow.vala"
		_tmp7_ = plank_dock_controller_get_VisibleItems (_tmp6_);
#line 551 "Widgets/DockWindow.vala"
		_tmp8_ = _tmp7_;
#line 551 "Widgets/DockWindow.vala"
		_item_list = _tmp8_;
#line 551 "Widgets/DockWindow.vala"
		_tmp9_ = _item_list;
#line 551 "Widgets/DockWindow.vala"
		_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
#line 551 "Widgets/DockWindow.vala"
		_tmp11_ = _tmp10_;
#line 551 "Widgets/DockWindow.vala"
		_item_size = _tmp11_;
#line 551 "Widgets/DockWindow.vala"
		_item_index = -1;
#line 551 "Widgets/DockWindow.vala"
		while (TRUE) {
#line 2342 "DockWindow.c"
			gint _tmp12_;
			gint _tmp13_;
			PlankDockItem* item = NULL;
			GeeArrayList* _tmp14_;
			gpointer _tmp15_;
			PlankDockItem* _tmp16_;
			PlankApplicationDockItem* appitem = NULL;
			PlankDockItem* _tmp17_;
			gboolean _tmp18_ = FALSE;
			PlankApplicationDockItem* _tmp19_;
			GdkRectangle region = {0};
			PlankDockController* _tmp21_;
			PlankPositionManager* _tmp22_;
			PlankPositionManager* _tmp23_;
			PlankApplicationDockItem* _tmp24_;
			GdkRectangle _tmp25_ = {0};
			PlankApplicationDockItem* _tmp26_;
			BamfApplication* _tmp27_;
			BamfApplication* _tmp28_;
			GdkRectangle _tmp29_;
#line 551 "Widgets/DockWindow.vala"
			_item_index = _item_index + 1;
#line 551 "Widgets/DockWindow.vala"
			_tmp12_ = _item_index;
#line 551 "Widgets/DockWindow.vala"
			_tmp13_ = _item_size;
#line 551 "Widgets/DockWindow.vala"
			if (!(_tmp12_ < _tmp13_)) {
#line 551 "Widgets/DockWindow.vala"
				break;
#line 2373 "DockWindow.c"
			}
#line 551 "Widgets/DockWindow.vala"
			_tmp14_ = _item_list;
#line 551 "Widgets/DockWindow.vala"
			_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, _item_index);
#line 551 "Widgets/DockWindow.vala"
			_tmp16_ = _g_object_ref0 ((PlankDockItem*) _tmp15_);
#line 551 "Widgets/DockWindow.vala"
			item = _tmp16_;
#line 552 "Widgets/DockWindow.vala"
			_tmp17_ = item;
#line 552 "Widgets/DockWindow.vala"
			appitem = PLANK_IS_APPLICATION_DOCK_ITEM (_tmp17_) ? ((PlankApplicationDockItem*) _tmp17_) : NULL;
#line 553 "Widgets/DockWindow.vala"
			_tmp19_ = appitem;
#line 553 "Widgets/DockWindow.vala"
			if (_tmp19_ == NULL) {
#line 553 "Widgets/DockWindow.vala"
				_tmp18_ = TRUE;
#line 2393 "DockWindow.c"
			} else {
				PlankApplicationDockItem* _tmp20_;
#line 553 "Widgets/DockWindow.vala"
				_tmp20_ = appitem;
#line 553 "Widgets/DockWindow.vala"
				_tmp18_ = !plank_application_dock_item_is_running (_tmp20_);
#line 2400 "DockWindow.c"
			}
#line 553 "Widgets/DockWindow.vala"
			if (_tmp18_) {
#line 554 "Widgets/DockWindow.vala"
				_g_object_unref0 (item);
#line 554 "Widgets/DockWindow.vala"
				continue;
#line 2408 "DockWindow.c"
			}
#line 556 "Widgets/DockWindow.vala"
			_tmp21_ = self->priv->_controller;
#line 556 "Widgets/DockWindow.vala"
			_tmp22_ = plank_dock_controller_get_position_manager (_tmp21_);
#line 556 "Widgets/DockWindow.vala"
			_tmp23_ = _tmp22_;
#line 556 "Widgets/DockWindow.vala"
			_tmp24_ = appitem;
#line 556 "Widgets/DockWindow.vala"
			plank_position_manager_get_icon_geometry (_tmp23_, _tmp24_, use_hidden_region, &_tmp25_);
#line 556 "Widgets/DockWindow.vala"
			region = _tmp25_;
#line 557 "Widgets/DockWindow.vala"
			_tmp26_ = appitem;
#line 557 "Widgets/DockWindow.vala"
			_tmp27_ = plank_application_dock_item_get_App (_tmp26_);
#line 557 "Widgets/DockWindow.vala"
			_tmp28_ = _tmp27_;
#line 557 "Widgets/DockWindow.vala"
			_tmp29_ = region;
#line 557 "Widgets/DockWindow.vala"
			plank_window_control_update_icon_regions (_tmp28_, &_tmp29_);
#line 551 "Widgets/DockWindow.vala"
			_g_object_unref0 (item);
#line 2434 "DockWindow.c"
		}
	}
}

/**
 * Updates the icon region for the given item.
 *
 + @param appitem the item to update the icon region for
 */
void
plank_dock_window_update_icon_region (PlankDockWindow* self,
                                      PlankApplicationDockItem* appitem)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean use_hidden_region = FALSE;
	GdkRectangle region = {0};
	PlankDockController* _tmp8_;
	PlankPositionManager* _tmp9_;
	PlankPositionManager* _tmp10_;
	GdkRectangle _tmp11_ = {0};
	BamfApplication* _tmp12_;
	BamfApplication* _tmp13_;
	GdkRectangle _tmp14_;
#line 566 "Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 566 "Widgets/DockWindow.vala"
	g_return_if_fail (appitem != NULL);
#line 568 "Widgets/DockWindow.vala"
	if (!plank_application_dock_item_is_running (appitem)) {
#line 569 "Widgets/DockWindow.vala"
		return;
#line 2468 "DockWindow.c"
	}
#line 571 "Widgets/DockWindow.vala"
	_tmp0_ = plank_dock_element_get_Text ((PlankDockElement*) appitem);
#line 571 "Widgets/DockWindow.vala"
	_tmp1_ = _tmp0_;
#line 571 "Widgets/DockWindow.vala"
	plank_logger_verbose ("DockWindow.update_icon_region ('%s')", _tmp1_, NULL);
#line 573 "Widgets/DockWindow.vala"
	if (plank_dock_window_menu_is_visible (self)) {
#line 573 "Widgets/DockWindow.vala"
		_tmp2_ = TRUE;
#line 2480 "DockWindow.c"
	} else {
		PlankDockController* _tmp3_;
		PlankHideManager* _tmp4_;
		PlankHideManager* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 573 "Widgets/DockWindow.vala"
		_tmp3_ = self->priv->_controller;
#line 573 "Widgets/DockWindow.vala"
		_tmp4_ = plank_dock_controller_get_hide_manager (_tmp3_);
#line 573 "Widgets/DockWindow.vala"
		_tmp5_ = _tmp4_;
#line 573 "Widgets/DockWindow.vala"
		_tmp6_ = plank_hide_manager_get_Hidden (_tmp5_);
#line 573 "Widgets/DockWindow.vala"
		_tmp7_ = _tmp6_;
#line 573 "Widgets/DockWindow.vala"
		_tmp2_ = _tmp7_;
#line 2499 "DockWindow.c"
	}
#line 573 "Widgets/DockWindow.vala"
	use_hidden_region = _tmp2_;
#line 574 "Widgets/DockWindow.vala"
	_tmp8_ = self->priv->_controller;
#line 574 "Widgets/DockWindow.vala"
	_tmp9_ = plank_dock_controller_get_position_manager (_tmp8_);
#line 574 "Widgets/DockWindow.vala"
	_tmp10_ = _tmp9_;
#line 574 "Widgets/DockWindow.vala"
	plank_position_manager_get_icon_geometry (_tmp10_, appitem, use_hidden_region, &_tmp11_);
#line 574 "Widgets/DockWindow.vala"
	region = _tmp11_;
#line 575 "Widgets/DockWindow.vala"
	_tmp12_ = plank_application_dock_item_get_App (appitem);
#line 575 "Widgets/DockWindow.vala"
	_tmp13_ = _tmp12_;
#line 575 "Widgets/DockWindow.vala"
	_tmp14_ = region;
#line 575 "Widgets/DockWindow.vala"
	plank_window_control_update_icon_regions (_tmp13_, &_tmp14_);
#line 2521 "DockWindow.c"
}

/**
 * If the popup menu is currently visible.
 */
gboolean
plank_dock_window_menu_is_visible (PlankDockWindow* self)
{
	gboolean _tmp0_ = FALSE;
	GtkMenu* _tmp1_;
	gboolean result;
#line 581 "Widgets/DockWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 583 "Widgets/DockWindow.vala"
	_tmp1_ = self->priv->menu;
#line 583 "Widgets/DockWindow.vala"
	if (_tmp1_ != NULL) {
#line 2539 "DockWindow.c"
		GtkMenu* _tmp2_;
#line 583 "Widgets/DockWindow.vala"
		_tmp2_ = self->priv->menu;
#line 583 "Widgets/DockWindow.vala"
		_tmp0_ = gtk_widget_get_visible ((GtkWidget*) _tmp2_);
#line 2545 "DockWindow.c"
	} else {
#line 583 "Widgets/DockWindow.vala"
		_tmp0_ = FALSE;
#line 2549 "DockWindow.c"
	}
#line 583 "Widgets/DockWindow.vala"
	result = _tmp0_;
#line 583 "Widgets/DockWindow.vala"
	return result;
#line 2555 "DockWindow.c"
}

/**
 * Shows the popup menu.
 *
 * @param item the item to show a menu for, or NULL
 * @param event the event which triggerd this request
 */
static gboolean
plank_dock_window_show_menu (PlankDockWindow* self,
                             PlankDockItem* item,
                             GdkEventButton* event)
{
	GtkMenu* _tmp0_;
	GtkMenuPositionFunc position_func = NULL;
	gpointer position_func_target;
	GDestroyNotify position_func_target_destroy_notify;
	PlankPopupButton button = 0U;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp30_ = FALSE;
	GeeArrayList* _tmp31_;
	GtkMenu* _tmp35_;
	GtkMenu* _tmp36_;
	GtkMenu* _tmp37_;
	GtkMenu* _tmp38_;
	GeeBidirListIterator* iterator = NULL;
	GeeArrayList* _tmp39_;
	GeeBidirListIterator* _tmp40_;
	PlankDockController* _tmp41_;
	PlankDockPreferences* _tmp42_;
	PlankDockPreferences* _tmp43_;
	GtkPositionType _tmp44_;
	GtkPositionType _tmp45_;
	GtkMenu* _tmp62_;
	GtkMenuPositionFunc _tmp63_;
	gpointer _tmp63__target;
	gboolean result;
#line 592 "Widgets/DockWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 592 "Widgets/DockWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 594 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->menu;
#line 594 "Widgets/DockWindow.vala"
	if (_tmp0_ != NULL) {
#line 2601 "DockWindow.c"
		GtkMenu* _tmp1_;
		GList* _tmp2_;
		GtkMenu* _tmp5_;
		guint _tmp6_;
		GtkMenu* _tmp7_;
		guint _tmp8_;
		GtkMenu* _tmp9_;
#line 595 "Widgets/DockWindow.vala"
		_tmp1_ = self->priv->menu;
#line 595 "Widgets/DockWindow.vala"
		_tmp2_ = gtk_container_get_children ((GtkContainer*) _tmp1_);
#line 2613 "DockWindow.c"
		{
			GList* w_collection = NULL;
			GList* w_it = NULL;
#line 595 "Widgets/DockWindow.vala"
			w_collection = _tmp2_;
#line 595 "Widgets/DockWindow.vala"
			for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
#line 2621 "DockWindow.c"
				GtkWidget* w = NULL;
#line 595 "Widgets/DockWindow.vala"
				w = (GtkWidget*) w_it->data;
#line 2625 "DockWindow.c"
				{
					GtkMenu* _tmp3_;
					GtkWidget* _tmp4_;
#line 596 "Widgets/DockWindow.vala"
					_tmp3_ = self->priv->menu;
#line 596 "Widgets/DockWindow.vala"
					_tmp4_ = w;
#line 596 "Widgets/DockWindow.vala"
					gtk_container_remove ((GtkContainer*) _tmp3_, _tmp4_);
#line 2635 "DockWindow.c"
				}
			}
#line 595 "Widgets/DockWindow.vala"
			(w_collection == NULL) ? NULL : (w_collection = (g_list_free (w_collection), NULL));
#line 2640 "DockWindow.c"
		}
#line 598 "Widgets/DockWindow.vala"
		_tmp5_ = self->priv->menu;
#line 598 "Widgets/DockWindow.vala"
		g_signal_parse_name ("show", gtk_widget_get_type (), &_tmp6_, NULL, FALSE);
#line 598 "Widgets/DockWindow.vala"
		g_signal_handlers_disconnect_matched ((GtkWidget*) _tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _plank_dock_window_on_menu_show_gtk_widget_show, self);
#line 599 "Widgets/DockWindow.vala"
		_tmp7_ = self->priv->menu;
#line 599 "Widgets/DockWindow.vala"
		g_signal_parse_name ("hide", gtk_widget_get_type (), &_tmp8_, NULL, FALSE);
#line 599 "Widgets/DockWindow.vala"
		g_signal_handlers_disconnect_matched ((GtkWidget*) _tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _plank_dock_window_on_menu_hide_gtk_widget_hide, self);
#line 600 "Widgets/DockWindow.vala"
		_tmp9_ = self->priv->menu;
#line 600 "Widgets/DockWindow.vala"
		gtk_menu_detach (_tmp9_);
#line 601 "Widgets/DockWindow.vala"
		_g_object_unref0 (self->priv->menu);
#line 601 "Widgets/DockWindow.vala"
		self->priv->menu = NULL;
#line 2662 "DockWindow.c"
	}
#line 604 "Widgets/DockWindow.vala"
	_g_object_unref0 (self->priv->menu_items);
#line 604 "Widgets/DockWindow.vala"
	self->priv->menu_items = NULL;
#line 605 "Widgets/DockWindow.vala"
	position_func = NULL;
#line 605 "Widgets/DockWindow.vala"
	position_func_target = NULL;
#line 605 "Widgets/DockWindow.vala"
	position_func_target_destroy_notify = NULL;
#line 606 "Widgets/DockWindow.vala"
	button = plank_popup_button_from_event_button (event);
#line 608 "Widgets/DockWindow.vala"
	if ((button & PLANK_POPUP_BUTTON_RIGHT) != 0) {
#line 2678 "DockWindow.c"
		gboolean _tmp11_ = FALSE;
#line 609 "Widgets/DockWindow.vala"
		if (item == NULL) {
#line 609 "Widgets/DockWindow.vala"
			_tmp11_ = TRUE;
#line 2684 "DockWindow.c"
		} else {
#line 609 "Widgets/DockWindow.vala"
			_tmp11_ = (event->state & GDK_CONTROL_MASK) != 0;
#line 2688 "DockWindow.c"
		}
#line 609 "Widgets/DockWindow.vala"
		_tmp10_ = _tmp11_;
#line 2692 "DockWindow.c"
	} else {
#line 608 "Widgets/DockWindow.vala"
		_tmp10_ = FALSE;
#line 2696 "DockWindow.c"
	}
#line 608 "Widgets/DockWindow.vala"
	if (_tmp10_) {
#line 2700 "DockWindow.c"
		PlankItemFactory* _tmp12_;
		PlankDockItem* _tmp13_;
		PlankDockItem* _tmp14_;
		GeeArrayList* _tmp15_;
		gboolean _tmp16_ = FALSE;
#line 610 "Widgets/DockWindow.vala"
		_tmp12_ = plank_factory_item_factory;
#line 610 "Widgets/DockWindow.vala"
		_tmp13_ = plank_item_factory_get_item_for_dock (_tmp12_);
#line 610 "Widgets/DockWindow.vala"
		_tmp14_ = _tmp13_;
#line 610 "Widgets/DockWindow.vala"
		_tmp15_ = plank_dock_element_get_menu_items ((PlankDockElement*) _tmp14_);
#line 610 "Widgets/DockWindow.vala"
		_g_object_unref0 (self->priv->menu_items);
#line 610 "Widgets/DockWindow.vala"
		self->priv->menu_items = _tmp15_;
#line 610 "Widgets/DockWindow.vala"
		_g_object_unref0 (_tmp14_);
#line 611 "Widgets/DockWindow.vala"
		if ((event->state & GDK_MOD1_MASK) != 0) {
#line 612 "Widgets/DockWindow.vala"
			_tmp16_ = (event->state & GDK_SHIFT_MASK) != 0;
#line 2724 "DockWindow.c"
		} else {
#line 611 "Widgets/DockWindow.vala"
			_tmp16_ = FALSE;
#line 2728 "DockWindow.c"
		}
#line 611 "Widgets/DockWindow.vala"
		if (_tmp16_) {
#line 2732 "DockWindow.c"
			GeeArrayList* _tmp17_;
			PlankDockController* _tmp18_;
			GeeArrayList* _tmp19_;
			GeeArrayList* _tmp20_;
#line 613 "Widgets/DockWindow.vala"
			_tmp17_ = self->priv->menu_items;
#line 613 "Widgets/DockWindow.vala"
			_tmp18_ = self->priv->_controller;
#line 613 "Widgets/DockWindow.vala"
			_tmp19_ = plank_dock_window_get_dock_debug_menu_items (_tmp18_);
#line 613 "Widgets/DockWindow.vala"
			_tmp20_ = _tmp19_;
#line 613 "Widgets/DockWindow.vala"
			gee_array_list_add_all (_tmp17_, (GeeCollection*) _tmp20_);
#line 613 "Widgets/DockWindow.vala"
			_g_object_unref0 (_tmp20_);
#line 2749 "DockWindow.c"
		}
#line 614 "Widgets/DockWindow.vala"
		plank_dock_window_set_hovered_provider (self, NULL);
#line 615 "Widgets/DockWindow.vala"
		plank_dock_window_set_hovered (self, NULL);
#line 2755 "DockWindow.c"
	} else {
		gboolean _tmp21_ = FALSE;
		gboolean _tmp22_ = FALSE;
#line 616 "Widgets/DockWindow.vala"
		if (item != NULL) {
#line 616 "Widgets/DockWindow.vala"
			_tmp22_ = plank_dock_item_is_valid (item);
#line 2763 "DockWindow.c"
		} else {
#line 616 "Widgets/DockWindow.vala"
			_tmp22_ = FALSE;
#line 2767 "DockWindow.c"
		}
#line 616 "Widgets/DockWindow.vala"
		if (_tmp22_) {
#line 2771 "DockWindow.c"
			PlankPopupButton _tmp23_;
			PlankPopupButton _tmp24_;
#line 616 "Widgets/DockWindow.vala"
			_tmp23_ = plank_dock_element_get_Button ((PlankDockElement*) item);
#line 616 "Widgets/DockWindow.vala"
			_tmp24_ = _tmp23_;
#line 616 "Widgets/DockWindow.vala"
			_tmp21_ = (_tmp24_ & button) != 0;
#line 2780 "DockWindow.c"
		} else {
#line 616 "Widgets/DockWindow.vala"
			_tmp21_ = FALSE;
#line 2784 "DockWindow.c"
		}
#line 616 "Widgets/DockWindow.vala"
		if (_tmp21_) {
#line 2788 "DockWindow.c"
			GeeArrayList* _tmp25_;
			gboolean _tmp26_ = FALSE;
#line 617 "Widgets/DockWindow.vala"
			_tmp25_ = plank_dock_element_get_menu_items ((PlankDockElement*) item);
#line 617 "Widgets/DockWindow.vala"
			_g_object_unref0 (self->priv->menu_items);
#line 617 "Widgets/DockWindow.vala"
			self->priv->menu_items = _tmp25_;
#line 618 "Widgets/DockWindow.vala"
			if ((event->state & GDK_MOD1_MASK) != 0) {
#line 619 "Widgets/DockWindow.vala"
				_tmp26_ = (event->state & GDK_SHIFT_MASK) != 0;
#line 2801 "DockWindow.c"
			} else {
#line 618 "Widgets/DockWindow.vala"
				_tmp26_ = FALSE;
#line 2805 "DockWindow.c"
			}
#line 618 "Widgets/DockWindow.vala"
			if (_tmp26_) {
#line 2809 "DockWindow.c"
				GeeArrayList* _tmp27_;
				GeeArrayList* _tmp28_;
				GeeArrayList* _tmp29_;
#line 620 "Widgets/DockWindow.vala"
				_tmp27_ = self->priv->menu_items;
#line 620 "Widgets/DockWindow.vala"
				_tmp28_ = plank_dock_window_get_item_debug_menu_items (item);
#line 620 "Widgets/DockWindow.vala"
				_tmp29_ = _tmp28_;
#line 620 "Widgets/DockWindow.vala"
				gee_array_list_add_all (_tmp27_, (GeeCollection*) _tmp29_);
#line 620 "Widgets/DockWindow.vala"
				_g_object_unref0 (_tmp29_);
#line 2823 "DockWindow.c"
			}
#line 621 "Widgets/DockWindow.vala"
			(position_func_target_destroy_notify == NULL) ? NULL : (position_func_target_destroy_notify (position_func_target), NULL);
#line 621 "Widgets/DockWindow.vala"
			position_func = NULL;
#line 621 "Widgets/DockWindow.vala"
			position_func_target = NULL;
#line 621 "Widgets/DockWindow.vala"
			position_func_target_destroy_notify = NULL;
#line 621 "Widgets/DockWindow.vala"
			position_func = (GtkMenuPositionFunc) plank_dock_window_position_menu;
#line 621 "Widgets/DockWindow.vala"
			position_func_target = g_object_ref (self);
#line 621 "Widgets/DockWindow.vala"
			position_func_target_destroy_notify = g_object_unref;
#line 2839 "DockWindow.c"
		}
	}
#line 624 "Widgets/DockWindow.vala"
	_tmp31_ = self->priv->menu_items;
#line 624 "Widgets/DockWindow.vala"
	if (_tmp31_ == NULL) {
#line 624 "Widgets/DockWindow.vala"
		_tmp30_ = TRUE;
#line 2848 "DockWindow.c"
	} else {
		GeeArrayList* _tmp32_;
		gint _tmp33_;
		gint _tmp34_;
#line 624 "Widgets/DockWindow.vala"
		_tmp32_ = self->priv->menu_items;
#line 624 "Widgets/DockWindow.vala"
		_tmp33_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp32_);
#line 624 "Widgets/DockWindow.vala"
		_tmp34_ = _tmp33_;
#line 624 "Widgets/DockWindow.vala"
		_tmp30_ = _tmp34_ == 0;
#line 2861 "DockWindow.c"
	}
#line 624 "Widgets/DockWindow.vala"
	if (_tmp30_) {
#line 625 "Widgets/DockWindow.vala"
		result = FALSE;
#line 625 "Widgets/DockWindow.vala"
		(position_func_target_destroy_notify == NULL) ? NULL : (position_func_target_destroy_notify (position_func_target), NULL);
#line 625 "Widgets/DockWindow.vala"
		position_func = NULL;
#line 625 "Widgets/DockWindow.vala"
		position_func_target = NULL;
#line 625 "Widgets/DockWindow.vala"
		position_func_target_destroy_notify = NULL;
#line 625 "Widgets/DockWindow.vala"
		return result;
#line 2877 "DockWindow.c"
	}
#line 627 "Widgets/DockWindow.vala"
	_tmp35_ = (GtkMenu*) gtk_menu_new ();
#line 627 "Widgets/DockWindow.vala"
	g_object_ref_sink (_tmp35_);
#line 627 "Widgets/DockWindow.vala"
	_g_object_unref0 (self->priv->menu);
#line 627 "Widgets/DockWindow.vala"
	self->priv->menu = _tmp35_;
#line 628 "Widgets/DockWindow.vala"
	_tmp36_ = self->priv->menu;
#line 628 "Widgets/DockWindow.vala"
	gtk_menu_attach_to_widget (_tmp36_, (GtkWidget*) self, NULL);
#line 629 "Widgets/DockWindow.vala"
	_tmp37_ = self->priv->menu;
#line 629 "Widgets/DockWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp37_, "show", (GCallback) _plank_dock_window_on_menu_show_gtk_widget_show, self, 0);
#line 630 "Widgets/DockWindow.vala"
	_tmp38_ = self->priv->menu;
#line 630 "Widgets/DockWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp38_, "hide", (GCallback) _plank_dock_window_on_menu_hide_gtk_widget_hide, self, 0);
#line 632 "Widgets/DockWindow.vala"
	_tmp39_ = self->priv->menu_items;
#line 632 "Widgets/DockWindow.vala"
	_tmp40_ = gee_abstract_bidir_list_bidir_list_iterator ((GeeAbstractBidirList*) _tmp39_);
#line 632 "Widgets/DockWindow.vala"
	iterator = _tmp40_;
#line 633 "Widgets/DockWindow.vala"
	_tmp41_ = self->priv->_controller;
#line 633 "Widgets/DockWindow.vala"
	_tmp42_ = plank_dock_controller_get_prefs (_tmp41_);
#line 633 "Widgets/DockWindow.vala"
	_tmp43_ = _tmp42_;
#line 633 "Widgets/DockWindow.vala"
	_tmp44_ = plank_dock_preferences_get_Position (_tmp43_);
#line 633 "Widgets/DockWindow.vala"
	_tmp45_ = _tmp44_;
#line 633 "Widgets/DockWindow.vala"
	if (_tmp45_ == GTK_POS_TOP) {
#line 2917 "DockWindow.c"
		GeeBidirListIterator* _tmp46_;
#line 634 "Widgets/DockWindow.vala"
		_tmp46_ = iterator;
#line 634 "Widgets/DockWindow.vala"
		gee_bidir_iterator_last ((GeeBidirIterator*) _tmp46_);
#line 2923 "DockWindow.c"
		{
			gboolean _tmp47_ = FALSE;
#line 635 "Widgets/DockWindow.vala"
			_tmp47_ = TRUE;
#line 635 "Widgets/DockWindow.vala"
			while (TRUE) {
#line 2930 "DockWindow.c"
				GtkMenuItem* menu_item = NULL;
				GeeBidirListIterator* _tmp49_;
				gpointer _tmp50_;
				GtkMenuItem* _tmp51_;
				GtkMenu* _tmp52_;
				GtkMenuItem* _tmp53_;
#line 635 "Widgets/DockWindow.vala"
				if (!_tmp47_) {
#line 2939 "DockWindow.c"
					GeeBidirListIterator* _tmp48_;
#line 639 "Widgets/DockWindow.vala"
					_tmp48_ = iterator;
#line 639 "Widgets/DockWindow.vala"
					if (!gee_bidir_iterator_previous ((GeeBidirIterator*) _tmp48_)) {
#line 639 "Widgets/DockWindow.vala"
						break;
#line 2947 "DockWindow.c"
					}
				}
#line 635 "Widgets/DockWindow.vala"
				_tmp47_ = FALSE;
#line 636 "Widgets/DockWindow.vala"
				_tmp49_ = iterator;
#line 636 "Widgets/DockWindow.vala"
				_tmp50_ = gee_iterator_get ((GeeIterator*) _tmp49_);
#line 636 "Widgets/DockWindow.vala"
				menu_item = (GtkMenuItem*) _tmp50_;
#line 637 "Widgets/DockWindow.vala"
				_tmp51_ = menu_item;
#line 637 "Widgets/DockWindow.vala"
				gtk_widget_show ((GtkWidget*) _tmp51_);
#line 638 "Widgets/DockWindow.vala"
				_tmp52_ = self->priv->menu;
#line 638 "Widgets/DockWindow.vala"
				_tmp53_ = menu_item;
#line 638 "Widgets/DockWindow.vala"
				gtk_menu_shell_append ((GtkMenuShell*) _tmp52_, _tmp53_);
#line 635 "Widgets/DockWindow.vala"
				_g_object_unref0 (menu_item);
#line 2970 "DockWindow.c"
			}
		}
	} else {
		GeeBidirListIterator* _tmp54_;
#line 641 "Widgets/DockWindow.vala"
		_tmp54_ = iterator;
#line 641 "Widgets/DockWindow.vala"
		gee_bidir_iterator_first ((GeeBidirIterator*) _tmp54_);
#line 2979 "DockWindow.c"
		{
			gboolean _tmp55_ = FALSE;
#line 642 "Widgets/DockWindow.vala"
			_tmp55_ = TRUE;
#line 642 "Widgets/DockWindow.vala"
			while (TRUE) {
#line 2986 "DockWindow.c"
				GtkMenuItem* menu_item = NULL;
				GeeBidirListIterator* _tmp57_;
				gpointer _tmp58_;
				GtkMenuItem* _tmp59_;
				GtkMenu* _tmp60_;
				GtkMenuItem* _tmp61_;
#line 642 "Widgets/DockWindow.vala"
				if (!_tmp55_) {
#line 2995 "DockWindow.c"
					GeeBidirListIterator* _tmp56_;
#line 646 "Widgets/DockWindow.vala"
					_tmp56_ = iterator;
#line 646 "Widgets/DockWindow.vala"
					if (!gee_iterator_next ((GeeIterator*) _tmp56_)) {
#line 646 "Widgets/DockWindow.vala"
						break;
#line 3003 "DockWindow.c"
					}
				}
#line 642 "Widgets/DockWindow.vala"
				_tmp55_ = FALSE;
#line 643 "Widgets/DockWindow.vala"
				_tmp57_ = iterator;
#line 643 "Widgets/DockWindow.vala"
				_tmp58_ = gee_iterator_get ((GeeIterator*) _tmp57_);
#line 643 "Widgets/DockWindow.vala"
				menu_item = (GtkMenuItem*) _tmp58_;
#line 644 "Widgets/DockWindow.vala"
				_tmp59_ = menu_item;
#line 644 "Widgets/DockWindow.vala"
				gtk_widget_show ((GtkWidget*) _tmp59_);
#line 645 "Widgets/DockWindow.vala"
				_tmp60_ = self->priv->menu;
#line 645 "Widgets/DockWindow.vala"
				_tmp61_ = menu_item;
#line 645 "Widgets/DockWindow.vala"
				gtk_menu_shell_append ((GtkMenuShell*) _tmp60_, _tmp61_);
#line 642 "Widgets/DockWindow.vala"
				_g_object_unref0 (menu_item);
#line 3026 "DockWindow.c"
			}
		}
	}
#line 649 "Widgets/DockWindow.vala"
	_tmp62_ = self->priv->menu;
#line 649 "Widgets/DockWindow.vala"
	_tmp63_ = position_func;
#line 649 "Widgets/DockWindow.vala"
	_tmp63__target = position_func_target;
#line 649 "Widgets/DockWindow.vala"
	gtk_menu_popup (_tmp62_, NULL, NULL, _tmp63_, _tmp63__target, event->button, event->time);
#line 651 "Widgets/DockWindow.vala"
	result = TRUE;
#line 651 "Widgets/DockWindow.vala"
	_g_object_unref0 (iterator);
#line 651 "Widgets/DockWindow.vala"
	(position_func_target_destroy_notify == NULL) ? NULL : (position_func_target_destroy_notify (position_func_target), NULL);
#line 651 "Widgets/DockWindow.vala"
	position_func = NULL;
#line 651 "Widgets/DockWindow.vala"
	position_func_target = NULL;
#line 651 "Widgets/DockWindow.vala"
	position_func_target_destroy_notify = NULL;
#line 651 "Widgets/DockWindow.vala"
	return result;
#line 3052 "DockWindow.c"
}

static Block18Data*
block18_data_ref (Block18Data* _data18_)
{
#line 654 "Widgets/DockWindow.vala"
	g_atomic_int_inc (&_data18_->_ref_count_);
#line 654 "Widgets/DockWindow.vala"
	return _data18_;
#line 3062 "DockWindow.c"
}

static void
block18_data_unref (void * _userdata_)
{
	Block18Data* _data18_;
	_data18_ = (Block18Data*) _userdata_;
#line 654 "Widgets/DockWindow.vala"
	if (g_atomic_int_dec_and_test (&_data18_->_ref_count_)) {
#line 654 "Widgets/DockWindow.vala"
		_g_object_unref0 (_data18_->controller);
#line 654 "Widgets/DockWindow.vala"
		g_slice_free (Block18Data, _data18_);
#line 3076 "DockWindow.c"
	}
}

static void
__lambda51_ (Block18Data* _data18_)
{
	PlankSystem* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
#line 665 "Widgets/DockWindow.vala"
	_tmp0_ = plank_system_get_default ();
#line 665 "Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_config_folder (_data18_->controller);
#line 665 "Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 665 "Widgets/DockWindow.vala"
	plank_system_open (_tmp0_, _tmp2_);
#line 3094 "DockWindow.c"
}

static void
___lambda51__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 664 "Widgets/DockWindow.vala"
	__lambda51_ (self);
#line 3103 "DockWindow.c"
}

static void
__lambda52_ (Block18Data* _data18_)
{
	PlankSystem* _tmp0_;
	PlankDockRenderer* _tmp1_;
	PlankDockRenderer* _tmp2_;
	PlankDockTheme* _tmp3_;
	PlankDockTheme* _tmp4_;
	GFile* _tmp5_;
#line 671 "Widgets/DockWindow.vala"
	_tmp0_ = plank_system_get_default ();
#line 671 "Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_renderer (_data18_->controller);
#line 671 "Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 671 "Widgets/DockWindow.vala"
	_tmp3_ = plank_dock_renderer_get_theme (_tmp2_);
#line 671 "Widgets/DockWindow.vala"
	_tmp4_ = _tmp3_;
#line 671 "Widgets/DockWindow.vala"
	_tmp5_ = plank_preferences_get_backing_file ((PlankPreferences*) _tmp4_);
#line 671 "Widgets/DockWindow.vala"
	plank_system_open (_tmp0_, _tmp5_);
#line 3129 "DockWindow.c"
}

static void
___lambda52__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 670 "Widgets/DockWindow.vala"
	__lambda52_ (self);
#line 3138 "DockWindow.c"
}

static GeeArrayList*
plank_dock_window_get_dock_debug_menu_items (PlankDockController* controller)
{
	Block18Data* _data18_;
	PlankDockController* _tmp0_;
	GeeArrayList* debug_items = NULL;
	GeeArrayList* _tmp1_;
	GtkSeparatorMenuItem* _tmp2_;
	GtkSeparatorMenuItem* _tmp3_;
	PlankTitledSeparatorMenuItem* _tmp4_;
	PlankTitledSeparatorMenuItem* _tmp5_;
	GtkMenuItem* menu_item = NULL;
	GtkMenuItem* _tmp6_;
	GtkMenuItem* _tmp7_;
	GtkMenuItem* _tmp8_;
	GtkMenuItem* _tmp9_;
	GtkMenuItem* _tmp10_;
	GtkMenuItem* _tmp11_;
	GeeArrayList* result;
#line 654 "Widgets/DockWindow.vala"
	g_return_val_if_fail (controller != NULL, NULL);
#line 654 "Widgets/DockWindow.vala"
	_data18_ = g_slice_new0 (Block18Data);
#line 654 "Widgets/DockWindow.vala"
	_data18_->_ref_count_ = 1;
#line 654 "Widgets/DockWindow.vala"
	_tmp0_ = _g_object_ref0 (controller);
#line 654 "Widgets/DockWindow.vala"
	_g_object_unref0 (_data18_->controller);
#line 654 "Widgets/DockWindow.vala"
	_data18_->controller = _tmp0_;
#line 656 "Widgets/DockWindow.vala"
	_tmp1_ = gee_array_list_new (gtk_menu_item_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 656 "Widgets/DockWindow.vala"
	debug_items = _tmp1_;
#line 658 "Widgets/DockWindow.vala"
	_tmp2_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 658 "Widgets/DockWindow.vala"
	g_object_ref_sink (_tmp2_);
#line 658 "Widgets/DockWindow.vala"
	_tmp3_ = _tmp2_;
#line 658 "Widgets/DockWindow.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) debug_items, (GtkMenuItem*) _tmp3_);
#line 658 "Widgets/DockWindow.vala"
	_g_object_unref0 (_tmp3_);
#line 659 "Widgets/DockWindow.vala"
	_tmp4_ = plank_titled_separator_menu_item_new_no_line ("debug this dock");
#line 659 "Widgets/DockWindow.vala"
	g_object_ref_sink (_tmp4_);
#line 659 "Widgets/DockWindow.vala"
	_tmp5_ = _tmp4_;
#line 659 "Widgets/DockWindow.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) debug_items, (GtkMenuItem*) _tmp5_);
#line 659 "Widgets/DockWindow.vala"
	_g_object_unref0 (_tmp5_);
#line 663 "Widgets/DockWindow.vala"
	_tmp6_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic ("Open config folder");
#line 663 "Widgets/DockWindow.vala"
	g_object_ref_sink (_tmp6_);
#line 663 "Widgets/DockWindow.vala"
	_g_object_unref0 (menu_item);
#line 663 "Widgets/DockWindow.vala"
	menu_item = _tmp6_;
#line 664 "Widgets/DockWindow.vala"
	_tmp7_ = menu_item;
#line 664 "Widgets/DockWindow.vala"
	g_signal_connect_data (_tmp7_, "activate", (GCallback) ___lambda51__gtk_menu_item_activate, block18_data_ref (_data18_), (GClosureNotify) block18_data_unref, 0);
#line 667 "Widgets/DockWindow.vala"
	_tmp8_ = menu_item;
#line 667 "Widgets/DockWindow.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) debug_items, _tmp8_);
#line 669 "Widgets/DockWindow.vala"
	_tmp9_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic ("Open current theme file");
#line 669 "Widgets/DockWindow.vala"
	g_object_ref_sink (_tmp9_);
#line 669 "Widgets/DockWindow.vala"
	_g_object_unref0 (menu_item);
#line 669 "Widgets/DockWindow.vala"
	menu_item = _tmp9_;
#line 670 "Widgets/DockWindow.vala"
	_tmp10_ = menu_item;
#line 670 "Widgets/DockWindow.vala"
	g_signal_connect_data (_tmp10_, "activate", (GCallback) ___lambda52__gtk_menu_item_activate, block18_data_ref (_data18_), (GClosureNotify) block18_data_unref, 0);
#line 673 "Widgets/DockWindow.vala"
	_tmp11_ = menu_item;
#line 673 "Widgets/DockWindow.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) debug_items, _tmp11_);
#line 675 "Widgets/DockWindow.vala"
	result = debug_items;
#line 675 "Widgets/DockWindow.vala"
	_g_object_unref0 (menu_item);
#line 675 "Widgets/DockWindow.vala"
	block18_data_unref (_data18_);
#line 675 "Widgets/DockWindow.vala"
	_data18_ = NULL;
#line 675 "Widgets/DockWindow.vala"
	return result;
#line 3238 "DockWindow.c"
}

static Block19Data*
block19_data_ref (Block19Data* _data19_)
{
#line 678 "Widgets/DockWindow.vala"
	g_atomic_int_inc (&_data19_->_ref_count_);
#line 678 "Widgets/DockWindow.vala"
	return _data19_;
#line 3248 "DockWindow.c"
}

static void
block19_data_unref (void * _userdata_)
{
	Block19Data* _data19_;
	_data19_ = (Block19Data*) _userdata_;
#line 678 "Widgets/DockWindow.vala"
	if (g_atomic_int_dec_and_test (&_data19_->_ref_count_)) {
#line 678 "Widgets/DockWindow.vala"
		_g_object_unref0 (_data19_->dock_item_file);
#line 678 "Widgets/DockWindow.vala"
		_g_object_unref0 (_data19_->item);
#line 678 "Widgets/DockWindow.vala"
		g_slice_free (Block19Data, _data19_);
#line 3264 "DockWindow.c"
	}
}

static void
__lambda53_ (Block19Data* _data19_)
{
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
#line 691 "Widgets/DockWindow.vala"
	_tmp1_ = _data19_->dock_item_file;
#line 691 "Widgets/DockWindow.vala"
	if (_tmp1_ != NULL) {
#line 3283 "DockWindow.c"
		GFile* _tmp2_;
		gchar* _tmp3_;
#line 691 "Widgets/DockWindow.vala"
		_tmp2_ = _data19_->dock_item_file;
#line 691 "Widgets/DockWindow.vala"
		_tmp3_ = g_file_get_uri (_tmp2_);
#line 691 "Widgets/DockWindow.vala"
		_g_free0 (_tmp0_);
#line 691 "Widgets/DockWindow.vala"
		_tmp0_ = _tmp3_;
#line 3294 "DockWindow.c"
	} else {
		gchar* _tmp4_;
#line 691 "Widgets/DockWindow.vala"
		_tmp4_ = g_strdup ("");
#line 691 "Widgets/DockWindow.vala"
		_g_free0 (_tmp0_);
#line 691 "Widgets/DockWindow.vala"
		_tmp0_ = _tmp4_;
#line 3303 "DockWindow.c"
	}
#line 690 "Widgets/DockWindow.vala"
	_tmp5_ = plank_dock_element_get_Text ((PlankDockElement*) _data19_->item);
#line 690 "Widgets/DockWindow.vala"
	_tmp6_ = _tmp5_;
#line 690 "Widgets/DockWindow.vala"
	_tmp7_ = plank_dock_item_get_Icon (_data19_->item);
#line 690 "Widgets/DockWindow.vala"
	_tmp8_ = _tmp7_;
#line 690 "Widgets/DockWindow.vala"
	_tmp9_ = plank_dock_item_get_Launcher (_data19_->item);
#line 690 "Widgets/DockWindow.vala"
	_tmp10_ = _tmp9_;
#line 690 "Widgets/DockWindow.vala"
	g_print ("DockItemFile: '%s'\nText = '%s'\nIcon = '%s'\nLauncher = '%s'\n", _tmp0_, _tmp6_, _tmp8_, _tmp10_);
#line 689 "Widgets/DockWindow.vala"
	_g_free0 (_tmp0_);
#line 3321 "DockWindow.c"
}

static void
___lambda53__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 689 "Widgets/DockWindow.vala"
	__lambda53_ (self);
#line 3330 "DockWindow.c"
}

static void
__lambda54_ (Block19Data* _data19_)
{
	PlankSystem* _tmp0_;
	GFile* _tmp1_;
#line 698 "Widgets/DockWindow.vala"
	_tmp0_ = plank_system_get_default ();
#line 698 "Widgets/DockWindow.vala"
	_tmp1_ = _data19_->dock_item_file;
#line 698 "Widgets/DockWindow.vala"
	plank_system_open (_tmp0_, _tmp1_);
#line 3344 "DockWindow.c"
}

static void
___lambda54__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 697 "Widgets/DockWindow.vala"
	__lambda54_ (self);
#line 3353 "DockWindow.c"
}

static void
__lambda55_ (Block19Data* _data19_)
{
	PlankSystem* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
#line 705 "Widgets/DockWindow.vala"
	_tmp0_ = plank_system_get_default ();
#line 705 "Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_item_get_Launcher (_data19_->item);
#line 705 "Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 705 "Widgets/DockWindow.vala"
	_tmp3_ = g_file_new_for_uri (_tmp2_);
#line 705 "Widgets/DockWindow.vala"
	_tmp4_ = _tmp3_;
#line 705 "Widgets/DockWindow.vala"
	plank_system_open (_tmp0_, _tmp4_);
#line 705 "Widgets/DockWindow.vala"
	_g_object_unref0 (_tmp4_);
#line 3378 "DockWindow.c"
}

static void
___lambda55__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 704 "Widgets/DockWindow.vala"
	__lambda55_ (self);
#line 3387 "DockWindow.c"
}

static GeeArrayList*
plank_dock_window_get_item_debug_menu_items (PlankDockItem* item)
{
	Block19Data* _data19_;
	PlankDockItem* _tmp0_;
	GeeArrayList* debug_items = NULL;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	GtkSeparatorMenuItem* _tmp3_;
	GtkSeparatorMenuItem* _tmp4_;
	GeeArrayList* _tmp5_;
	PlankTitledSeparatorMenuItem* _tmp6_;
	PlankTitledSeparatorMenuItem* _tmp7_;
	GtkMenuItem* menu_item = NULL;
	PlankDockItemPreferences* _tmp8_;
	PlankDockItemPreferences* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GtkMenuItem* _tmp12_;
	GtkMenuItem* _tmp13_;
	GeeArrayList* _tmp14_;
	GtkMenuItem* _tmp15_;
	GtkMenuItem* _tmp16_;
	GtkMenuItem* _tmp17_;
	gboolean _tmp18_ = FALSE;
	GFile* _tmp19_;
	GtkMenuItem* _tmp21_;
	GeeArrayList* _tmp22_;
	GtkMenuItem* _tmp23_;
	GtkMenuItem* _tmp24_;
	GtkMenuItem* _tmp25_;
	GtkMenuItem* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	GeeArrayList* _tmp29_;
	GtkMenuItem* _tmp30_;
	GeeArrayList* result;
#line 678 "Widgets/DockWindow.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 678 "Widgets/DockWindow.vala"
	_data19_ = g_slice_new0 (Block19Data);
#line 678 "Widgets/DockWindow.vala"
	_data19_->_ref_count_ = 1;
#line 678 "Widgets/DockWindow.vala"
	_tmp0_ = _g_object_ref0 (item);
#line 678 "Widgets/DockWindow.vala"
	_g_object_unref0 (_data19_->item);
#line 678 "Widgets/DockWindow.vala"
	_data19_->item = _tmp0_;
#line 680 "Widgets/DockWindow.vala"
	_tmp1_ = gee_array_list_new (gtk_menu_item_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 680 "Widgets/DockWindow.vala"
	debug_items = _tmp1_;
#line 682 "Widgets/DockWindow.vala"
	_tmp2_ = debug_items;
#line 682 "Widgets/DockWindow.vala"
	_tmp3_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 682 "Widgets/DockWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 682 "Widgets/DockWindow.vala"
	_tmp4_ = _tmp3_;
#line 682 "Widgets/DockWindow.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, (GtkMenuItem*) _tmp4_);
#line 682 "Widgets/DockWindow.vala"
	_g_object_unref0 (_tmp4_);
#line 683 "Widgets/DockWindow.vala"
	_tmp5_ = debug_items;
#line 683 "Widgets/DockWindow.vala"
	_tmp6_ = plank_titled_separator_menu_item_new_no_line ("debug this item");
#line 683 "Widgets/DockWindow.vala"
	g_object_ref_sink (_tmp6_);
#line 683 "Widgets/DockWindow.vala"
	_tmp7_ = _tmp6_;
#line 683 "Widgets/DockWindow.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, (GtkMenuItem*) _tmp7_);
#line 683 "Widgets/DockWindow.vala"
	_g_object_unref0 (_tmp7_);
#line 687 "Widgets/DockWindow.vala"
	_tmp8_ = plank_dock_item_get_Prefs (_data19_->item);
#line 687 "Widgets/DockWindow.vala"
	_tmp9_ = _tmp8_;
#line 687 "Widgets/DockWindow.vala"
	_tmp10_ = plank_preferences_get_backing_file ((PlankPreferences*) _tmp9_);
#line 687 "Widgets/DockWindow.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 687 "Widgets/DockWindow.vala"
	_data19_->dock_item_file = _tmp11_;
#line 688 "Widgets/DockWindow.vala"
	_tmp12_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic ("Print info to stdout");
#line 688 "Widgets/DockWindow.vala"
	g_object_ref_sink (_tmp12_);
#line 688 "Widgets/DockWindow.vala"
	_g_object_unref0 (menu_item);
#line 688 "Widgets/DockWindow.vala"
	menu_item = _tmp12_;
#line 689 "Widgets/DockWindow.vala"
	_tmp13_ = menu_item;
#line 689 "Widgets/DockWindow.vala"
	g_signal_connect_data (_tmp13_, "activate", (GCallback) ___lambda53__gtk_menu_item_activate, block19_data_ref (_data19_), (GClosureNotify) block19_data_unref, 0);
#line 694 "Widgets/DockWindow.vala"
	_tmp14_ = debug_items;
#line 694 "Widgets/DockWindow.vala"
	_tmp15_ = menu_item;
#line 694 "Widgets/DockWindow.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 696 "Widgets/DockWindow.vala"
	_tmp16_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic ("Open dockitem file");
#line 696 "Widgets/DockWindow.vala"
	g_object_ref_sink (_tmp16_);
#line 696 "Widgets/DockWindow.vala"
	_g_object_unref0 (menu_item);
#line 696 "Widgets/DockWindow.vala"
	menu_item = _tmp16_;
#line 697 "Widgets/DockWindow.vala"
	_tmp17_ = menu_item;
#line 697 "Widgets/DockWindow.vala"
	g_signal_connect_data (_tmp17_, "activate", (GCallback) ___lambda54__gtk_menu_item_activate, block19_data_ref (_data19_), (GClosureNotify) block19_data_unref, 0);
#line 700 "Widgets/DockWindow.vala"
	_tmp19_ = _data19_->dock_item_file;
#line 700 "Widgets/DockWindow.vala"
	if (_tmp19_ != NULL) {
#line 3511 "DockWindow.c"
		GFile* _tmp20_;
#line 700 "Widgets/DockWindow.vala"
		_tmp20_ = _data19_->dock_item_file;
#line 700 "Widgets/DockWindow.vala"
		_tmp18_ = g_file_query_exists (_tmp20_, NULL);
#line 3517 "DockWindow.c"
	} else {
#line 700 "Widgets/DockWindow.vala"
		_tmp18_ = FALSE;
#line 3521 "DockWindow.c"
	}
#line 700 "Widgets/DockWindow.vala"
	_tmp21_ = menu_item;
#line 700 "Widgets/DockWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp21_, _tmp18_);
#line 701 "Widgets/DockWindow.vala"
	_tmp22_ = debug_items;
#line 701 "Widgets/DockWindow.vala"
	_tmp23_ = menu_item;
#line 701 "Widgets/DockWindow.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, _tmp23_);
#line 703 "Widgets/DockWindow.vala"
	_tmp24_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic ("Open launcher file");
#line 703 "Widgets/DockWindow.vala"
	g_object_ref_sink (_tmp24_);
#line 703 "Widgets/DockWindow.vala"
	_g_object_unref0 (menu_item);
#line 703 "Widgets/DockWindow.vala"
	menu_item = _tmp24_;
#line 704 "Widgets/DockWindow.vala"
	_tmp25_ = menu_item;
#line 704 "Widgets/DockWindow.vala"
	g_signal_connect_data (_tmp25_, "activate", (GCallback) ___lambda55__gtk_menu_item_activate, block19_data_ref (_data19_), (GClosureNotify) block19_data_unref, 0);
#line 707 "Widgets/DockWindow.vala"
	_tmp26_ = menu_item;
#line 707 "Widgets/DockWindow.vala"
	_tmp27_ = plank_dock_item_get_Launcher (_data19_->item);
#line 707 "Widgets/DockWindow.vala"
	_tmp28_ = _tmp27_;
#line 707 "Widgets/DockWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp26_, g_strcmp0 (_tmp28_, "") != 0);
#line 708 "Widgets/DockWindow.vala"
	_tmp29_ = debug_items;
#line 708 "Widgets/DockWindow.vala"
	_tmp30_ = menu_item;
#line 708 "Widgets/DockWindow.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, _tmp30_);
#line 710 "Widgets/DockWindow.vala"
	result = debug_items;
#line 710 "Widgets/DockWindow.vala"
	_g_object_unref0 (menu_item);
#line 710 "Widgets/DockWindow.vala"
	block19_data_unref (_data19_);
#line 710 "Widgets/DockWindow.vala"
	_data19_ = NULL;
#line 710 "Widgets/DockWindow.vala"
	return result;
#line 3569 "DockWindow.c"
}

/**
 * Called when the popup menu hides.
 */
static void
plank_dock_window_on_menu_hide (PlankDockWindow* self)
{
	PlankHideManager* hide_manager = NULL;
	PlankDockController* _tmp0_;
	PlankHideManager* _tmp1_;
	PlankHideManager* _tmp2_;
	PlankHideManager* _tmp3_;
	PlankHideManager* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
#line 716 "Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 718 "Widgets/DockWindow.vala"
	plank_dock_window_update_icon_regions (self);
#line 719 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 719 "Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_hide_manager (_tmp0_);
#line 719 "Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 719 "Widgets/DockWindow.vala"
	hide_manager = _tmp2_;
#line 720 "Widgets/DockWindow.vala"
	_tmp3_ = hide_manager;
#line 720 "Widgets/DockWindow.vala"
	plank_hide_manager_update_hovered (_tmp3_);
#line 721 "Widgets/DockWindow.vala"
	_tmp4_ = hide_manager;
#line 721 "Widgets/DockWindow.vala"
	_tmp5_ = plank_hide_manager_get_Hovered (_tmp4_);
#line 721 "Widgets/DockWindow.vala"
	_tmp6_ = _tmp5_;
#line 721 "Widgets/DockWindow.vala"
	if (!_tmp6_) {
#line 722 "Widgets/DockWindow.vala"
		plank_dock_window_set_hovered_provider (self, NULL);
#line 723 "Widgets/DockWindow.vala"
		plank_dock_window_set_hovered (self, NULL);
#line 3614 "DockWindow.c"
	}
#line 726 "Widgets/DockWindow.vala"
	_g_object_unref0 (self->priv->menu_items);
#line 726 "Widgets/DockWindow.vala"
	self->priv->menu_items = NULL;
#line 3620 "DockWindow.c"
}

/**
 * Called when the popup menu shows.
 */
static void
plank_dock_window_on_menu_show (PlankDockWindow* self)
{
	PlankDockController* _tmp0_;
	PlankHoverWindow* _tmp1_;
	PlankHoverWindow* _tmp2_;
	PlankDockController* _tmp3_;
	PlankDockRenderer* _tmp4_;
	PlankDockRenderer* _tmp5_;
#line 732 "Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 734 "Widgets/DockWindow.vala"
	plank_dock_window_update_icon_regions (self);
#line 735 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 735 "Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_hover (_tmp0_);
#line 735 "Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 735 "Widgets/DockWindow.vala"
	gtk_widget_hide ((GtkWidget*) _tmp2_);
#line 736 "Widgets/DockWindow.vala"
	_tmp3_ = self->priv->_controller;
#line 736 "Widgets/DockWindow.vala"
	_tmp4_ = plank_dock_controller_get_renderer (_tmp3_);
#line 736 "Widgets/DockWindow.vala"
	_tmp5_ = _tmp4_;
#line 736 "Widgets/DockWindow.vala"
	plank_renderer_animated_draw ((PlankRenderer*) _tmp5_);
#line 3655 "DockWindow.c"
}

/**
 * Positions the popup menu.
 *
 * @param menu the popup menu to show
 * @param x the x location to show the menu
 * @param y the y location to show the menu
 * @param push_in if the menu should push into the screen
 */
static void
plank_dock_window_position_menu (GtkMenu* menu,
                                 gint* x,
                                 gint* y,
                                 gboolean* push_in,
                                 PlankDockWindow* self)
{
	gboolean _vala_push_in = FALSE;
	GtkRequisition requisition = {0};
	GtkRequisition _tmp0_ = {0};
	PlankDockController* _tmp1_;
	PlankPositionManager* _tmp2_;
	PlankPositionManager* _tmp3_;
	PlankDockItem* _tmp4_;
	GtkRequisition _tmp5_;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
#line 748 "Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 748 "Widgets/DockWindow.vala"
	g_return_if_fail (menu != NULL);
#line 751 "Widgets/DockWindow.vala"
	gtk_widget_get_preferred_size ((GtkWidget*) menu, NULL, &_tmp0_);
#line 751 "Widgets/DockWindow.vala"
	requisition = _tmp0_;
#line 752 "Widgets/DockWindow.vala"
	_tmp1_ = self->priv->_controller;
#line 752 "Widgets/DockWindow.vala"
	_tmp2_ = plank_dock_controller_get_position_manager (_tmp1_);
#line 752 "Widgets/DockWindow.vala"
	_tmp3_ = _tmp2_;
#line 752 "Widgets/DockWindow.vala"
	_tmp4_ = self->priv->_HoveredItem;
#line 752 "Widgets/DockWindow.vala"
	_tmp5_ = requisition;
#line 752 "Widgets/DockWindow.vala"
	plank_position_manager_get_menu_position (_tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 752 "Widgets/DockWindow.vala"
	*x = _tmp6_;
#line 752 "Widgets/DockWindow.vala"
	*y = _tmp7_;
#line 753 "Widgets/DockWindow.vala"
	_vala_push_in = FALSE;
#line 748 "Widgets/DockWindow.vala"
	if (push_in) {
#line 748 "Widgets/DockWindow.vala"
		*push_in = _vala_push_in;
#line 3713 "DockWindow.c"
	}
}

static gboolean
_cairo_rectangle_int_equal (const cairo_rectangle_int_t * s1,
                            const cairo_rectangle_int_t * s2)
{
#line 766 "Widgets/DockWindow.vala"
	if (s1 == s2) {
#line 766 "Widgets/DockWindow.vala"
		return TRUE;
#line 3725 "DockWindow.c"
	}
#line 766 "Widgets/DockWindow.vala"
	if (s1 == NULL) {
#line 766 "Widgets/DockWindow.vala"
		return FALSE;
#line 3731 "DockWindow.c"
	}
#line 766 "Widgets/DockWindow.vala"
	if (s2 == NULL) {
#line 766 "Widgets/DockWindow.vala"
		return FALSE;
#line 3737 "DockWindow.c"
	}
#line 766 "Widgets/DockWindow.vala"
	if (s1->x != s2->x) {
#line 766 "Widgets/DockWindow.vala"
		return FALSE;
#line 3743 "DockWindow.c"
	}
#line 766 "Widgets/DockWindow.vala"
	if (s1->y != s2->y) {
#line 766 "Widgets/DockWindow.vala"
		return FALSE;
#line 3749 "DockWindow.c"
	}
#line 766 "Widgets/DockWindow.vala"
	if (s1->width != s2->width) {
#line 766 "Widgets/DockWindow.vala"
		return FALSE;
#line 3755 "DockWindow.c"
	}
#line 766 "Widgets/DockWindow.vala"
	if (s1->height != s2->height) {
#line 766 "Widgets/DockWindow.vala"
		return FALSE;
#line 3761 "DockWindow.c"
	}
#line 766 "Widgets/DockWindow.vala"
	return TRUE;
#line 3765 "DockWindow.c"
}

static void
plank_dock_window_set_input_mask (PlankDockWindow* self)
{
	GdkRectangle cursor_rect = {0};
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	GdkRectangle _tmp3_ = {0};
	GdkRectangle _tmp4_;
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
	GdkRectangle _tmp7_;
#line 756 "Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 758 "Widgets/DockWindow.vala"
	if (!gtk_widget_get_realized ((GtkWidget*) self)) {
#line 759 "Widgets/DockWindow.vala"
		return;
#line 3786 "DockWindow.c"
	}
#line 761 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 761 "Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 761 "Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 761 "Widgets/DockWindow.vala"
	plank_position_manager_get_cursor_region (_tmp2_, &_tmp3_);
#line 761 "Widgets/DockWindow.vala"
	cursor_rect = _tmp3_;
#line 763 "Widgets/DockWindow.vala"
	_tmp4_ = cursor_rect;
#line 763 "Widgets/DockWindow.vala"
	g_return_if_fail (_tmp4_.width > 0);
#line 764 "Widgets/DockWindow.vala"
	_tmp5_ = cursor_rect;
#line 764 "Widgets/DockWindow.vala"
	g_return_if_fail (_tmp5_.height > 0);
#line 766 "Widgets/DockWindow.vala"
	_tmp6_ = cursor_rect;
#line 766 "Widgets/DockWindow.vala"
	_tmp7_ = self->priv->input_rect;
#line 766 "Widgets/DockWindow.vala"
	if (_cairo_rectangle_int_equal (&_tmp6_, &_tmp7_) != TRUE) {
#line 3812 "DockWindow.c"
		GdkRectangle _tmp8_;
		GdkWindow* _tmp9_;
		GdkRectangle _tmp10_;
		cairo_rectangle_int_t _tmp11_;
		cairo_region_t* _tmp12_;
		cairo_region_t* _tmp13_;
#line 767 "Widgets/DockWindow.vala"
		_tmp8_ = cursor_rect;
#line 767 "Widgets/DockWindow.vala"
		self->priv->input_rect = _tmp8_;
#line 768 "Widgets/DockWindow.vala"
		_tmp9_ = gtk_widget_get_window ((GtkWidget*) self);
#line 768 "Widgets/DockWindow.vala"
		_tmp10_ = cursor_rect;
#line 768 "Widgets/DockWindow.vala"
		_tmp11_ = (cairo_rectangle_int_t) _tmp10_;
#line 768 "Widgets/DockWindow.vala"
		_tmp12_ = cairo_region_create_rectangle (&_tmp11_);
#line 768 "Widgets/DockWindow.vala"
		_tmp13_ = _tmp12_;
#line 768 "Widgets/DockWindow.vala"
		gdk_window_input_shape_combine_region (_tmp9_, _tmp13_, 0, 0);
#line 768 "Widgets/DockWindow.vala"
		_cairo_region_destroy0 (_tmp13_);
#line 3837 "DockWindow.c"
	}
}

static void
plank_dock_window_set_struts (PlankDockWindow* self)
{
	GdkX11Display* gdk_display = NULL;
	GdkDisplay* _tmp0_;
	GdkX11Display* _tmp1_;
	GdkX11Window* gdk_window = NULL;
	GdkWindow* _tmp2_;
	GdkX11Window* _tmp3_;
	gulong* struts = NULL;
	gulong* _tmp4_;
	gint struts_length1;
	gint _struts_size_;
	PlankDockController* _tmp5_;
	PlankDockPreferences* _tmp6_;
	PlankDockPreferences* _tmp7_;
	PlankHideType _tmp8_;
	PlankHideType _tmp9_;
	gulong* first_struts = NULL;
	gulong* _tmp13_;
	gint first_struts_length1;
	gint _first_struts_size_;
	Display* display = NULL;
	GdkX11Display* _tmp20_;
	Display* _tmp21_;
	Window xid = 0;
	GdkX11Window* _tmp22_;
	GdkX11Display* _tmp23_;
	Display* _tmp24_;
	Display* _tmp25_;
	gulong* _tmp26_;
	gint _tmp26__length1;
	gulong* _tmp27_;
	gint _tmp27__length1;
	Display* _tmp28_;
	Display* _tmp29_;
	gulong* _tmp30_;
	gint _tmp30__length1;
	gulong* _tmp31_;
	gint _tmp31__length1;
	GdkX11Display* _tmp32_;
#line 772 "Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 774 "Widgets/DockWindow.vala"
	if (!gtk_widget_get_realized ((GtkWidget*) self)) {
#line 775 "Widgets/DockWindow.vala"
		return;
#line 3888 "DockWindow.c"
	}
#line 777 "Widgets/DockWindow.vala"
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
#line 777 "Widgets/DockWindow.vala"
	gdk_display = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp0_) : NULL;
#line 778 "Widgets/DockWindow.vala"
	_tmp1_ = gdk_display;
#line 778 "Widgets/DockWindow.vala"
	if (_tmp1_ == NULL) {
#line 779 "Widgets/DockWindow.vala"
		return;
#line 3900 "DockWindow.c"
	}
#line 781 "Widgets/DockWindow.vala"
	_tmp2_ = gtk_widget_get_window ((GtkWidget*) self);
#line 781 "Widgets/DockWindow.vala"
	gdk_window = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gdk_x11_window_get_type ()) ? ((GdkX11Window*) _tmp2_) : NULL;
#line 782 "Widgets/DockWindow.vala"
	_tmp3_ = gdk_window;
#line 782 "Widgets/DockWindow.vala"
	if (_tmp3_ == NULL) {
#line 783 "Widgets/DockWindow.vala"
		return;
#line 3912 "DockWindow.c"
	}
#line 785 "Widgets/DockWindow.vala"
	_tmp4_ = g_new0 (gulong, PLANK_STRUTS_N_VALUES);
#line 785 "Widgets/DockWindow.vala"
	struts = _tmp4_;
#line 785 "Widgets/DockWindow.vala"
	struts_length1 = PLANK_STRUTS_N_VALUES;
#line 785 "Widgets/DockWindow.vala"
	_struts_size_ = struts_length1;
#line 787 "Widgets/DockWindow.vala"
	_tmp5_ = self->priv->_controller;
#line 787 "Widgets/DockWindow.vala"
	_tmp6_ = plank_dock_controller_get_prefs (_tmp5_);
#line 787 "Widgets/DockWindow.vala"
	_tmp7_ = _tmp6_;
#line 787 "Widgets/DockWindow.vala"
	_tmp8_ = plank_dock_preferences_get_HideMode (_tmp7_);
#line 787 "Widgets/DockWindow.vala"
	_tmp9_ = _tmp8_;
#line 787 "Widgets/DockWindow.vala"
	if (_tmp9_ == PLANK_HIDE_TYPE_NONE) {
#line 3934 "DockWindow.c"
		PlankDockController* _tmp10_;
		PlankPositionManager* _tmp11_;
		PlankPositionManager* _tmp12_;
#line 788 "Widgets/DockWindow.vala"
		_tmp10_ = self->priv->_controller;
#line 788 "Widgets/DockWindow.vala"
		_tmp11_ = plank_dock_controller_get_position_manager (_tmp10_);
#line 788 "Widgets/DockWindow.vala"
		_tmp12_ = _tmp11_;
#line 788 "Widgets/DockWindow.vala"
		plank_position_manager_get_struts (_tmp12_, &struts, (gint*) (&struts_length1));
#line 788 "Widgets/DockWindow.vala"
		_struts_size_ = struts_length1;
#line 3948 "DockWindow.c"
	}
#line 790 "Widgets/DockWindow.vala"
	_tmp13_ = g_new0 (gulong, PLANK_STRUTS_BOTTOM + 1);
#line 790 "Widgets/DockWindow.vala"
	first_struts = _tmp13_;
#line 790 "Widgets/DockWindow.vala"
	first_struts_length1 = PLANK_STRUTS_BOTTOM + 1;
#line 790 "Widgets/DockWindow.vala"
	_first_struts_size_ = first_struts_length1;
#line 3958 "DockWindow.c"
	{
		gint i = 0;
#line 791 "Widgets/DockWindow.vala"
		i = 0;
#line 3963 "DockWindow.c"
		{
			gboolean _tmp14_ = FALSE;
#line 791 "Widgets/DockWindow.vala"
			_tmp14_ = TRUE;
#line 791 "Widgets/DockWindow.vala"
			while (TRUE) {
#line 3970 "DockWindow.c"
				gulong* _tmp16_;
				gint _tmp16__length1;
				gulong* _tmp17_;
				gint _tmp17__length1;
				gulong* _tmp18_;
				gint _tmp18__length1;
				gulong _tmp19_;
#line 791 "Widgets/DockWindow.vala"
				if (!_tmp14_) {
#line 3980 "DockWindow.c"
					gint _tmp15_;
#line 791 "Widgets/DockWindow.vala"
					_tmp15_ = i;
#line 791 "Widgets/DockWindow.vala"
					i = _tmp15_ + 1;
#line 3986 "DockWindow.c"
				}
#line 791 "Widgets/DockWindow.vala"
				_tmp14_ = FALSE;
#line 791 "Widgets/DockWindow.vala"
				_tmp16_ = first_struts;
#line 791 "Widgets/DockWindow.vala"
				_tmp16__length1 = first_struts_length1;
#line 791 "Widgets/DockWindow.vala"
				if (!(i < _tmp16__length1)) {
#line 791 "Widgets/DockWindow.vala"
					break;
#line 3998 "DockWindow.c"
				}
#line 792 "Widgets/DockWindow.vala"
				_tmp17_ = first_struts;
#line 792 "Widgets/DockWindow.vala"
				_tmp17__length1 = first_struts_length1;
#line 792 "Widgets/DockWindow.vala"
				_tmp18_ = struts;
#line 792 "Widgets/DockWindow.vala"
				_tmp18__length1 = struts_length1;
#line 792 "Widgets/DockWindow.vala"
				_tmp19_ = _tmp18_[i];
#line 792 "Widgets/DockWindow.vala"
				_tmp17_[i] = _tmp19_;
#line 4012 "DockWindow.c"
			}
		}
	}
#line 794 "Widgets/DockWindow.vala"
	_tmp20_ = gdk_display;
#line 794 "Widgets/DockWindow.vala"
	_tmp21_ = gdk_x11_display_get_xdisplay (_tmp20_);
#line 794 "Widgets/DockWindow.vala"
	display = _tmp21_;
#line 795 "Widgets/DockWindow.vala"
	_tmp22_ = gdk_window;
#line 795 "Widgets/DockWindow.vala"
	xid = gdk_x11_window_get_xid (_tmp22_);
#line 797 "Widgets/DockWindow.vala"
	_tmp23_ = gdk_display;
#line 797 "Widgets/DockWindow.vala"
	gdk_x11_display_error_trap_push (_tmp23_);
#line 798 "Widgets/DockWindow.vala"
	_tmp24_ = display;
#line 798 "Widgets/DockWindow.vala"
	_tmp25_ = display;
#line 798 "Widgets/DockWindow.vala"
	_tmp26_ = struts;
#line 798 "Widgets/DockWindow.vala"
	_tmp26__length1 = struts_length1;
#line 798 "Widgets/DockWindow.vala"
	_tmp27_ = struts;
#line 798 "Widgets/DockWindow.vala"
	_tmp27__length1 = struts_length1;
#line 798 "Widgets/DockWindow.vala"
	XChangeProperty (_tmp24_, xid, XInternAtom (_tmp25_, "_NET_WM_STRUT_PARTIAL", FALSE), XA_CARDINAL, 32, (gint) PropModeReplace, (guchar*) _tmp26_, _tmp27__length1);
#line 800 "Widgets/DockWindow.vala"
	_tmp28_ = display;
#line 800 "Widgets/DockWindow.vala"
	_tmp29_ = display;
#line 800 "Widgets/DockWindow.vala"
	_tmp30_ = first_struts;
#line 800 "Widgets/DockWindow.vala"
	_tmp30__length1 = first_struts_length1;
#line 800 "Widgets/DockWindow.vala"
	_tmp31_ = first_struts;
#line 800 "Widgets/DockWindow.vala"
	_tmp31__length1 = first_struts_length1;
#line 800 "Widgets/DockWindow.vala"
	XChangeProperty (_tmp28_, xid, XInternAtom (_tmp29_, "_NET_WM_STRUT", FALSE), XA_CARDINAL, 32, (gint) PropModeReplace, (guchar*) _tmp30_, _tmp31__length1);
#line 802 "Widgets/DockWindow.vala"
	_tmp32_ = gdk_display;
#line 802 "Widgets/DockWindow.vala"
	if (gdk_x11_display_error_trap_pop (_tmp32_) != Success) {
#line 803 "Widgets/DockWindow.vala"
		g_critical ("DockWindow.vala:803: Error while setting struts");
#line 4064 "DockWindow.c"
	}
#line 772 "Widgets/DockWindow.vala"
	first_struts = (g_free (first_struts), NULL);
#line 772 "Widgets/DockWindow.vala"
	struts = (g_free (struts), NULL);
#line 4070 "DockWindow.c"
}

static PlankDockController*
plank_dock_window_get_controller (PlankDockWindow* self)
{
	PlankDockController* result;
	PlankDockController* _tmp0_;
#line 33 "Widgets/DockWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 33 "Widgets/DockWindow.vala"
	result = _tmp0_;
#line 33 "Widgets/DockWindow.vala"
	return result;
#line 4086 "DockWindow.c"
}

static void
plank_dock_window_set_controller (PlankDockWindow* self,
                                  PlankDockController* value)
{
	PlankDockController* old_value;
#line 33 "Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 33 "Widgets/DockWindow.vala"
	old_value = plank_dock_window_get_controller (self);
#line 33 "Widgets/DockWindow.vala"
	if (old_value != value) {
#line 4100 "DockWindow.c"
		PlankDockController* _tmp0_;
#line 33 "Widgets/DockWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 33 "Widgets/DockWindow.vala"
		_g_object_unref0 (self->priv->_controller);
#line 33 "Widgets/DockWindow.vala"
		self->priv->_controller = _tmp0_;
#line 33 "Widgets/DockWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_window_properties[PLANK_DOCK_WINDOW_CONTROLLER_PROPERTY]);
#line 4110 "DockWindow.c"
	}
}

PlankDockItem*
plank_dock_window_get_HoveredItem (PlankDockWindow* self)
{
	PlankDockItem* result;
	PlankDockItem* _tmp0_;
#line 39 "Widgets/DockWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_HoveredItem;
#line 39 "Widgets/DockWindow.vala"
	result = _tmp0_;
#line 39 "Widgets/DockWindow.vala"
	return result;
#line 4127 "DockWindow.c"
}

static void
plank_dock_window_set_HoveredItem (PlankDockWindow* self,
                                   PlankDockItem* value)
{
	PlankDockItem* old_value;
#line 39 "Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 39 "Widgets/DockWindow.vala"
	old_value = plank_dock_window_get_HoveredItem (self);
#line 39 "Widgets/DockWindow.vala"
	if (old_value != value) {
#line 4141 "DockWindow.c"
		PlankDockItem* _tmp0_;
#line 39 "Widgets/DockWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 39 "Widgets/DockWindow.vala"
		_g_object_unref0 (self->priv->_HoveredItem);
#line 39 "Widgets/DockWindow.vala"
		self->priv->_HoveredItem = _tmp0_;
#line 39 "Widgets/DockWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_window_properties[PLANK_DOCK_WINDOW_HOVERED_ITEM_PROPERTY]);
#line 4151 "DockWindow.c"
	}
}

PlankDockItemProvider*
plank_dock_window_get_HoveredItemProvider (PlankDockWindow* self)
{
	PlankDockItemProvider* result;
	PlankDockItemProvider* _tmp0_;
#line 44 "Widgets/DockWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_HoveredItemProvider;
#line 44 "Widgets/DockWindow.vala"
	result = _tmp0_;
#line 44 "Widgets/DockWindow.vala"
	return result;
#line 4168 "DockWindow.c"
}

static void
plank_dock_window_set_HoveredItemProvider (PlankDockWindow* self,
                                           PlankDockItemProvider* value)
{
	PlankDockItemProvider* old_value;
#line 44 "Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 44 "Widgets/DockWindow.vala"
	old_value = plank_dock_window_get_HoveredItemProvider (self);
#line 44 "Widgets/DockWindow.vala"
	if (old_value != value) {
#line 4182 "DockWindow.c"
		PlankDockItemProvider* _tmp0_;
#line 44 "Widgets/DockWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 44 "Widgets/DockWindow.vala"
		_g_object_unref0 (self->priv->_HoveredItemProvider);
#line 44 "Widgets/DockWindow.vala"
		self->priv->_HoveredItemProvider = _tmp0_;
#line 44 "Widgets/DockWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_window_properties[PLANK_DOCK_WINDOW_HOVERED_ITEM_PROVIDER_PROPERTY]);
#line 4192 "DockWindow.c"
	}
}

static PlankDockItem*
plank_dock_window_get_ClickedItem (PlankDockWindow* self)
{
	PlankDockItem* result;
	PlankDockItem* _tmp0_;
#line 50 "Widgets/DockWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_ClickedItem;
#line 50 "Widgets/DockWindow.vala"
	result = _tmp0_;
#line 50 "Widgets/DockWindow.vala"
	return result;
#line 4209 "DockWindow.c"
}

static void
plank_dock_window_set_ClickedItem (PlankDockWindow* self,
                                   PlankDockItem* value)
{
#line 50 "Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 50 "Widgets/DockWindow.vala"
	self->priv->_ClickedItem = value;
#line 4220 "DockWindow.c"
}

static GObject *
plank_dock_window_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankDockWindow * self;
	PlankDockController* _tmp0_;
	PlankDockPreferences* _tmp1_;
	PlankDockPreferences* _tmp2_;
#line 77 "Widgets/DockWindow.vala"
	parent_class = G_OBJECT_CLASS (plank_dock_window_parent_class);
#line 77 "Widgets/DockWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 77 "Widgets/DockWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DOCK_WINDOW, PlankDockWindow);
#line 79 "Widgets/DockWindow.vala"
	gtk_window_set_accept_focus ((GtkWindow*) self, FALSE);
#line 80 "Widgets/DockWindow.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, FALSE);
#line 81 "Widgets/DockWindow.vala"
	gtk_window_set_skip_pager_hint ((GtkWindow*) self, TRUE);
#line 82 "Widgets/DockWindow.vala"
	gtk_window_set_skip_taskbar_hint ((GtkWindow*) self, TRUE);
#line 84 "Widgets/DockWindow.vala"
	gtk_window_stick ((GtkWindow*) self);
#line 86 "Widgets/DockWindow.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) ((((((GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK) | GDK_ENTER_NOTIFY_MASK) | GDK_LEAVE_NOTIFY_MASK) | GDK_POINTER_MOTION_MASK) | GDK_SCROLL_MASK) | GDK_STRUCTURE_MASK));
#line 94 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 94 "Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_prefs (_tmp0_);
#line 94 "Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 94 "Widgets/DockWindow.vala"
	g_signal_connect_object ((GObject*) _tmp2_, "notify::HideMode", (GCallback) _plank_dock_window_set_struts_g_object_notify, self, 0);
#line 77 "Widgets/DockWindow.vala"
	return obj;
#line 4262 "DockWindow.c"
}

static void
plank_dock_window_class_init (PlankDockWindowClass * klass,
                              gpointer klass_data)
{
#line 25 "Widgets/DockWindow.vala"
	plank_dock_window_parent_class = g_type_class_peek_parent (klass);
#line 25 "Widgets/DockWindow.vala"
	g_type_class_adjust_private_offset (klass, &PlankDockWindow_private_offset);
#line 25 "Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) plank_dock_window_real_button_press_event;
#line 25 "Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) plank_dock_window_real_button_release_event;
#line 25 "Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->enter_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) plank_dock_window_real_enter_notify_event;
#line 25 "Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->leave_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) plank_dock_window_real_leave_notify_event;
#line 25 "Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->motion_notify_event = (gboolean (*) (GtkWidget*, GdkEventMotion*)) plank_dock_window_real_motion_notify_event;
#line 25 "Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->drag_begin = (void (*) (GtkWidget*, GdkDragContext*)) plank_dock_window_real_drag_begin;
#line 25 "Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->scroll_event = (gboolean (*) (GtkWidget*, GdkEventScroll*)) plank_dock_window_real_scroll_event;
#line 25 "Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) plank_dock_window_real_configure_event;
#line 25 "Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) plank_dock_window_real_draw;
#line 25 "Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->map_event = (gboolean (*) (GtkWidget*, GdkEventAny*)) plank_dock_window_real_map_event;
#line 25 "Widgets/DockWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_dock_window_get_property;
#line 25 "Widgets/DockWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_dock_window_set_property;
#line 25 "Widgets/DockWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_dock_window_constructor;
#line 25 "Widgets/DockWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_dock_window_finalize;
#line 4301 "DockWindow.c"
	/**
	 * The controller for this dock.
	 */
#line 25 "Widgets/DockWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_WINDOW_CONTROLLER_PROPERTY, plank_dock_window_properties[PLANK_DOCK_WINDOW_CONTROLLER_PROPERTY] = g_param_spec_object ("controller", "controller", "controller", PLANK_TYPE_DOCK_CONTROLLER, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 4307 "DockWindow.c"
	/**
	 * The currently hovered item (if any).
	 */
#line 25 "Widgets/DockWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_WINDOW_HOVERED_ITEM_PROPERTY, plank_dock_window_properties[PLANK_DOCK_WINDOW_HOVERED_ITEM_PROPERTY] = g_param_spec_object ("HoveredItem", "HoveredItem", "HoveredItem", PLANK_TYPE_DOCK_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4313 "DockWindow.c"
	/**
	 * The currently hovered item-provider (if any).
	 */
#line 25 "Widgets/DockWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_WINDOW_HOVERED_ITEM_PROVIDER_PROPERTY, plank_dock_window_properties[PLANK_DOCK_WINDOW_HOVERED_ITEM_PROVIDER_PROPERTY] = g_param_spec_object ("HoveredItemProvider", "HoveredItemProvider", "HoveredItemProvider", PLANK_TYPE_DOCK_ITEM_PROVIDER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4319 "DockWindow.c"
}

static void
plank_dock_window_instance_init (PlankDockWindow * self,
                                 gpointer klass)
{
#line 25 "Widgets/DockWindow.vala"
	self->priv = plank_dock_window_get_instance_private (self);
#line 58 "Widgets/DockWindow.vala"
	self->priv->hover_reposition_timer_id = 0U;
#line 60 "Widgets/DockWindow.vala"
	self->priv->long_press_timer_id = 0U;
#line 61 "Widgets/DockWindow.vala"
	self->priv->long_press_active = FALSE;
#line 62 "Widgets/DockWindow.vala"
	self->priv->long_press_button = 0U;
#line 67 "Widgets/DockWindow.vala"
	self->priv->window_position_retry = 0;
#line 4338 "DockWindow.c"
}

static void
plank_dock_window_finalize (GObject * obj)
{
	PlankDockWindow * self;
	GtkMenu* _tmp0_;
	PlankDockController* _tmp5_;
	PlankDockPreferences* _tmp6_;
	PlankDockPreferences* _tmp7_;
	guint _tmp8_;
	GQuark _tmp9_;
#line 25 "Widgets/DockWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DOCK_WINDOW, PlankDockWindow);
#line 99 "Widgets/DockWindow.vala"
	_tmp0_ = self->priv->menu;
#line 99 "Widgets/DockWindow.vala"
	if (_tmp0_ != NULL) {
#line 4357 "DockWindow.c"
		GtkMenu* _tmp1_;
		guint _tmp2_;
		GtkMenu* _tmp3_;
		guint _tmp4_;
#line 100 "Widgets/DockWindow.vala"
		_tmp1_ = self->priv->menu;
#line 100 "Widgets/DockWindow.vala"
		g_signal_parse_name ("show", gtk_widget_get_type (), &_tmp2_, NULL, FALSE);
#line 100 "Widgets/DockWindow.vala"
		g_signal_handlers_disconnect_matched ((GtkWidget*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _plank_dock_window_on_menu_show_gtk_widget_show, self);
#line 101 "Widgets/DockWindow.vala"
		_tmp3_ = self->priv->menu;
#line 101 "Widgets/DockWindow.vala"
		g_signal_parse_name ("hide", gtk_widget_get_type (), &_tmp4_, NULL, FALSE);
#line 101 "Widgets/DockWindow.vala"
		g_signal_handlers_disconnect_matched ((GtkWidget*) _tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _plank_dock_window_on_menu_hide_gtk_widget_hide, self);
#line 4374 "DockWindow.c"
	}
#line 104 "Widgets/DockWindow.vala"
	_tmp5_ = self->priv->_controller;
#line 104 "Widgets/DockWindow.vala"
	_tmp6_ = plank_dock_controller_get_prefs (_tmp5_);
#line 104 "Widgets/DockWindow.vala"
	_tmp7_ = _tmp6_;
#line 104 "Widgets/DockWindow.vala"
	g_signal_parse_name ("notify::HideMode", G_TYPE_OBJECT, &_tmp8_, &_tmp9_, TRUE);
#line 104 "Widgets/DockWindow.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, _tmp9_, NULL, (GCallback) _plank_dock_window_set_struts_g_object_notify, self);
#line 106 "Widgets/DockWindow.vala"
	if (self->priv->hover_reposition_timer_id > 0U) {
#line 107 "Widgets/DockWindow.vala"
		g_source_remove (self->priv->hover_reposition_timer_id);
#line 108 "Widgets/DockWindow.vala"
		self->priv->hover_reposition_timer_id = 0U;
#line 4392 "DockWindow.c"
	}
#line 33 "Widgets/DockWindow.vala"
	_g_object_unref0 (self->priv->_controller);
#line 39 "Widgets/DockWindow.vala"
	_g_object_unref0 (self->priv->_HoveredItem);
#line 44 "Widgets/DockWindow.vala"
	_g_object_unref0 (self->priv->_HoveredItemProvider);
#line 55 "Widgets/DockWindow.vala"
	_g_object_unref0 (self->priv->menu);
#line 56 "Widgets/DockWindow.vala"
	_g_object_unref0 (self->priv->menu_items);
#line 25 "Widgets/DockWindow.vala"
	G_OBJECT_CLASS (plank_dock_window_parent_class)->finalize (obj);
#line 4406 "DockWindow.c"
}

/**
 * The main window for all docks.
 */
static GType
plank_dock_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankDockWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_dock_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDockWindow), 0, (GInstanceInitFunc) plank_dock_window_instance_init, NULL };
	GType plank_dock_window_type_id;
	plank_dock_window_type_id = g_type_register_static (PLANK_TYPE_COMPOSITED_WINDOW, "PlankDockWindow", &g_define_type_info, 0);
	PlankDockWindow_private_offset = g_type_add_instance_private (plank_dock_window_type_id, sizeof (PlankDockWindowPrivate));
	return plank_dock_window_type_id;
}

GType
plank_dock_window_get_type (void)
{
	static volatile gsize plank_dock_window_type_id__once = 0;
	if (g_once_init_enter (&plank_dock_window_type_id__once)) {
		GType plank_dock_window_type_id;
		plank_dock_window_type_id = plank_dock_window_get_type_once ();
		g_once_init_leave (&plank_dock_window_type_id__once, plank_dock_window_type_id);
	}
	return plank_dock_window_type_id__once;
}

static void
_vala_plank_dock_window_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	PlankDockWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DOCK_WINDOW, PlankDockWindow);
#line 25 "Widgets/DockWindow.vala"
	switch (property_id) {
#line 25 "Widgets/DockWindow.vala"
		case PLANK_DOCK_WINDOW_CONTROLLER_PROPERTY:
#line 25 "Widgets/DockWindow.vala"
		g_value_set_object (value, plank_dock_window_get_controller (self));
#line 25 "Widgets/DockWindow.vala"
		break;
#line 25 "Widgets/DockWindow.vala"
		case PLANK_DOCK_WINDOW_HOVERED_ITEM_PROPERTY:
#line 25 "Widgets/DockWindow.vala"
		g_value_set_object (value, plank_dock_window_get_HoveredItem (self));
#line 25 "Widgets/DockWindow.vala"
		break;
#line 25 "Widgets/DockWindow.vala"
		case PLANK_DOCK_WINDOW_HOVERED_ITEM_PROVIDER_PROPERTY:
#line 25 "Widgets/DockWindow.vala"
		g_value_set_object (value, plank_dock_window_get_HoveredItemProvider (self));
#line 25 "Widgets/DockWindow.vala"
		break;
#line 4462 "DockWindow.c"
		default:
#line 25 "Widgets/DockWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "Widgets/DockWindow.vala"
		break;
#line 4468 "DockWindow.c"
	}
}

static void
_vala_plank_dock_window_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	PlankDockWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DOCK_WINDOW, PlankDockWindow);
#line 25 "Widgets/DockWindow.vala"
	switch (property_id) {
#line 25 "Widgets/DockWindow.vala"
		case PLANK_DOCK_WINDOW_CONTROLLER_PROPERTY:
#line 25 "Widgets/DockWindow.vala"
		plank_dock_window_set_controller (self, g_value_get_object (value));
#line 25 "Widgets/DockWindow.vala"
		break;
#line 25 "Widgets/DockWindow.vala"
		case PLANK_DOCK_WINDOW_HOVERED_ITEM_PROPERTY:
#line 25 "Widgets/DockWindow.vala"
		plank_dock_window_set_HoveredItem (self, g_value_get_object (value));
#line 25 "Widgets/DockWindow.vala"
		break;
#line 25 "Widgets/DockWindow.vala"
		case PLANK_DOCK_WINDOW_HOVERED_ITEM_PROVIDER_PROPERTY:
#line 25 "Widgets/DockWindow.vala"
		plank_dock_window_set_HoveredItemProvider (self, g_value_get_object (value));
#line 25 "Widgets/DockWindow.vala"
		break;
#line 4500 "DockWindow.c"
		default:
#line 25 "Widgets/DockWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "Widgets/DockWindow.vala"
		break;
#line 4506 "DockWindow.c"
	}
}

