/* PreferencesWindow.c generated by valac 0.56.18, the Vala compiler
 * generated from PreferencesWindow.vala, do not modify */

/**/
/*  Copyright (C) 2014 Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include "plank-internal.h"
#include <gee.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo-gobject.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PLANK_PREFERENCES_WINDOW_0_PROPERTY,
	PLANK_PREFERENCES_WINDOW_CONTROLLER_PROPERTY,
	PLANK_PREFERENCES_WINDOW_NUM_PROPERTIES
};
static GParamSpec* plank_preferences_window_properties[PLANK_PREFERENCES_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

struct _PlankPreferencesWindowPrivate {
	PlankDockController* _controller;
	PlankDockPreferences* prefs;
	GtkComboBoxText* cb_theme;
	GtkComboBoxText* cb_hidemode;
	GtkComboBoxText* cb_display_plug;
	GtkComboBoxText* cb_position;
	GtkComboBoxText* cb_alignment;
	GtkComboBoxText* cb_items_alignment;
	GtkSpinButton* sp_hide_delay;
	GtkSpinButton* sp_unhide_delay;
	GtkScale* s_offset;
	GtkScale* s_zoom_percent;
	GtkAdjustment* adj_hide_delay;
	GtkAdjustment* adj_unhide_delay;
	GtkAdjustment* adj_iconsize;
	GtkAdjustment* adj_offset;
	GtkAdjustment* adj_zoom_percent;
	GtkSwitch* sw_hide;
	GtkSwitch* sw_primary_display;
	GtkSwitch* sw_workspace_only;
	GtkSwitch* sw_show_unpinned;
	GtkSwitch* sw_lock_items;
	GtkSwitch* sw_pressure_reveal;
	GtkSwitch* sw_zoom_enabled;
	GtkIconView* view_docklets;
};

static gint PlankPreferencesWindow_private_offset;
static gpointer plank_preferences_window_parent_class = NULL;

static void plank_preferences_window_controller_changed (PlankPreferencesWindow* self);
static void plank_preferences_window_disconnect_signals (PlankPreferencesWindow* self);
static void plank_preferences_window_init_dock_tab (PlankPreferencesWindow* self);
static void plank_preferences_window_connect_signals (PlankPreferencesWindow* self);
static gboolean plank_preferences_window_real_key_press_event (GtkWidget* base,
                                                        GdkEventKey* event);
static void plank_preferences_window_prefs_changed (PlankPreferencesWindow* self,
                                             GObject* o,
                                             GParamSpec* prop);
static void plank_preferences_window_theme_changed (PlankPreferencesWindow* self,
                                             GtkComboBox* widget);
static void plank_preferences_window_hidemode_changed (PlankPreferencesWindow* self,
                                                GtkComboBox* widget);
static void plank_preferences_window_position_changed (PlankPreferencesWindow* self,
                                                GtkComboBox* widget);
static void plank_preferences_window_alignment_changed (PlankPreferencesWindow* self,
                                                 GtkComboBox* widget);
static void plank_preferences_window_items_alignment_changed (PlankPreferencesWindow* self,
                                                       GtkComboBox* widget);
static void plank_preferences_window_hide_toggled (PlankPreferencesWindow* self,
                                            GObject* widget,
                                            GParamSpec* param);
static void plank_preferences_window_primary_display_toggled (PlankPreferencesWindow* self,
                                                       GObject* widget,
                                                       GParamSpec* param);
static void plank_preferences_window_workspace_only_toggled (PlankPreferencesWindow* self,
                                                      GObject* widget,
                                                      GParamSpec* param);
static void plank_preferences_window_show_unpinned_toggled (PlankPreferencesWindow* self,
                                                     GObject* widget,
                                                     GParamSpec* param);
static void plank_preferences_window_lock_items_toggled (PlankPreferencesWindow* self,
                                                  GObject* widget,
                                                  GParamSpec* param);
static void plank_preferences_window_pressure_reveal_toggled (PlankPreferencesWindow* self,
                                                       GObject* widget,
                                                       GParamSpec* param);
static void plank_preferences_window_zoom_enabled_toggled (PlankPreferencesWindow* self,
                                                    GObject* widget,
                                                    GParamSpec* param);
static void plank_preferences_window_iconsize_changed (PlankPreferencesWindow* self,
                                                GtkAdjustment* adj);
static void plank_preferences_window_offset_changed (PlankPreferencesWindow* self,
                                              GtkAdjustment* adj);
static void plank_preferences_window_hide_delay_changed (PlankPreferencesWindow* self,
                                                  GtkAdjustment* adj);
static void plank_preferences_window_unhide_delay_changed (PlankPreferencesWindow* self,
                                                    GtkAdjustment* adj);
static void plank_preferences_window_zoom_percent_changed (PlankPreferencesWindow* self,
                                                    GtkAdjustment* adj);
static void plank_preferences_window_monitor_changed (PlankPreferencesWindow* self,
                                               GtkComboBox* widget);
static void _plank_preferences_window_prefs_changed_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void _plank_preferences_window_theme_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                    gpointer self);
static void _plank_preferences_window_hidemode_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                       gpointer self);
static void _plank_preferences_window_position_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                       gpointer self);
static void _plank_preferences_window_hide_delay_changed_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                                gpointer self);
static void _plank_preferences_window_unhide_delay_changed_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                                  gpointer self);
static void _plank_preferences_window_monitor_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                      gpointer self);
static void _plank_preferences_window_iconsize_changed_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                              gpointer self);
static void _plank_preferences_window_offset_changed_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                            gpointer self);
static void _plank_preferences_window_zoom_percent_changed_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                                  gpointer self);
static void _plank_preferences_window_hide_toggled_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void _plank_preferences_window_primary_display_toggled_g_object_notify (GObject* _sender,
                                                                        GParamSpec* pspec,
                                                                        gpointer self);
static void _plank_preferences_window_workspace_only_toggled_g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self);
static void _plank_preferences_window_show_unpinned_toggled_g_object_notify (GObject* _sender,
                                                                      GParamSpec* pspec,
                                                                      gpointer self);
static void _plank_preferences_window_lock_items_toggled_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static void _plank_preferences_window_pressure_reveal_toggled_g_object_notify (GObject* _sender,
                                                                        GParamSpec* pspec,
                                                                        gpointer self);
static void _plank_preferences_window_zoom_enabled_toggled_g_object_notify (GObject* _sender,
                                                                     GParamSpec* pspec,
                                                                     gpointer self);
static void _plank_preferences_window_alignment_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                        gpointer self);
static void _plank_preferences_window_items_alignment_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                              gpointer self);
static void plank_preferences_window_init_docklets_tab (PlankPreferencesWindow* self);
static void plank_preferences_window_view_drag_begin (GtkWidget* widget,
                                               GdkDragContext* context,
                                               PlankPreferencesWindow* self);
static void _plank_preferences_window_view_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                                      GdkDragContext* context,
                                                                      gpointer self);
static void plank_preferences_window_view_item_activated (GtkIconView* view,
                                                   GtkTreePath* path,
                                                   PlankPreferencesWindow* self);
static void _plank_preferences_window_view_item_activated_gtk_icon_view_item_activated (GtkIconView* _sender,
                                                                                 GtkTreePath* path,
                                                                                 gpointer self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void __vala_GtkTreePath_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreePath_free0_ (GList* self);
static GtkTreePath* _vala_GtkTreePath_copy (GtkTreePath* self);
static GObject * plank_preferences_window_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void _plank_preferences_window_controller_changed_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static void plank_preferences_window_finalize (GObject * obj);
static GType plank_preferences_window_get_type_once (void);
static void _vala_plank_preferences_window_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_plank_preferences_window_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
plank_preferences_window_get_instance_private (PlankPreferencesWindow* self)
{
	return G_STRUCT_MEMBER_P (self, PlankPreferencesWindow_private_offset);
}

PlankPreferencesWindow*
plank_preferences_window_construct (GType object_type,
                                    PlankDockController* controller)
{
	PlankPreferencesWindow * self = NULL;
#line 83 "Widgets/PreferencesWindow.vala"
	g_return_val_if_fail (controller != NULL, NULL);
#line 85 "Widgets/PreferencesWindow.vala"
	self = (PlankPreferencesWindow*) g_object_new (object_type, "controller", controller, NULL);
#line 83 "Widgets/PreferencesWindow.vala"
	return self;
#line 245 "PreferencesWindow.c"
}

PlankPreferencesWindow*
plank_preferences_window_new (PlankDockController* controller)
{
#line 83 "Widgets/PreferencesWindow.vala"
	return plank_preferences_window_construct (PLANK_TYPE_PREFERENCES_WINDOW, controller);
#line 253 "PreferencesWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 105 "Widgets/PreferencesWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 261 "PreferencesWindow.c"
}

static void
plank_preferences_window_controller_changed (PlankPreferencesWindow* self)
{
	PlankDockController* _tmp0_;
	PlankDockPreferences* _tmp1_;
	PlankDockPreferences* _tmp2_;
	PlankDockPreferences* _tmp3_;
#line 101 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 103 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_disconnect_signals (self);
#line 105 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 105 "Widgets/PreferencesWindow.vala"
	_tmp1_ = plank_dock_controller_get_prefs (_tmp0_);
#line 105 "Widgets/PreferencesWindow.vala"
	_tmp2_ = _tmp1_;
#line 105 "Widgets/PreferencesWindow.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 105 "Widgets/PreferencesWindow.vala"
	_g_object_unref0 (self->priv->prefs);
#line 105 "Widgets/PreferencesWindow.vala"
	self->priv->prefs = _tmp3_;
#line 107 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_init_dock_tab (self);
#line 108 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_connect_signals (self);
#line 291 "PreferencesWindow.c"
}

static gboolean
plank_preferences_window_real_key_press_event (GtkWidget* base,
                                               GdkEventKey* event)
{
	PlankPreferencesWindow * self;
	gboolean result;
#line 111 "Widgets/PreferencesWindow.vala"
	self = (PlankPreferencesWindow*) base;
#line 111 "Widgets/PreferencesWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 113 "Widgets/PreferencesWindow.vala"
	if (event->keyval == GDK_KEY_Escape) {
#line 114 "Widgets/PreferencesWindow.vala"
		gtk_widget_hide ((GtkWidget*) self);
#line 308 "PreferencesWindow.c"
	}
#line 116 "Widgets/PreferencesWindow.vala"
	result = GTK_WIDGET_CLASS (plank_preferences_window_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), event);
#line 116 "Widgets/PreferencesWindow.vala"
	return result;
#line 314 "PreferencesWindow.c"
}

static void
plank_preferences_window_prefs_changed (PlankPreferencesWindow* self,
                                        GObject* o,
                                        GParamSpec* prop)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 121 "Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label0 = 0;
#line 121 "Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label1 = 0;
#line 121 "Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label2 = 0;
#line 121 "Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label3 = 0;
#line 121 "Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label4 = 0;
#line 121 "Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label5 = 0;
#line 121 "Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label6 = 0;
#line 121 "Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label7 = 0;
#line 121 "Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label8 = 0;
#line 121 "Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label9 = 0;
#line 121 "Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label10 = 0;
#line 121 "Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label11 = 0;
#line 121 "Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label12 = 0;
#line 121 "Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label13 = 0;
#line 121 "Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label14 = 0;
#line 121 "Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label15 = 0;
#line 121 "Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label16 = 0;
#line 119 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 119 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (o != NULL);
#line 119 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (prop != NULL);
#line 121 "Widgets/PreferencesWindow.vala"
	_tmp0_ = prop->name;
#line 121 "Widgets/PreferencesWindow.vala"
	_tmp1_ = _tmp0_;
#line 121 "Widgets/PreferencesWindow.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 121 "Widgets/PreferencesWindow.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("Alignment")))) {
#line 121 "Widgets/PreferencesWindow.vala"
		switch (0) {
#line 375 "PreferencesWindow.c"
			default:
			{
				GtkComboBoxText* _tmp4_;
				PlankDockPreferences* _tmp5_;
				GtkAlign _tmp6_;
				GtkAlign _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 123 "Widgets/PreferencesWindow.vala"
				_tmp4_ = self->priv->cb_alignment;
#line 123 "Widgets/PreferencesWindow.vala"
				_tmp5_ = self->priv->prefs;
#line 123 "Widgets/PreferencesWindow.vala"
				_tmp6_ = plank_dock_preferences_get_Alignment (_tmp5_);
#line 123 "Widgets/PreferencesWindow.vala"
				_tmp7_ = _tmp6_;
#line 123 "Widgets/PreferencesWindow.vala"
				_tmp8_ = g_strdup_printf ("%i", (gint) _tmp7_);
#line 123 "Widgets/PreferencesWindow.vala"
				_tmp9_ = _tmp8_;
#line 123 "Widgets/PreferencesWindow.vala"
				gtk_combo_box_set_active_id ((GtkComboBox*) _tmp4_, _tmp9_);
#line 123 "Widgets/PreferencesWindow.vala"
				_g_free0 (_tmp9_);
#line 124 "Widgets/PreferencesWindow.vala"
				break;
#line 402 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("CurrentWorkspaceOnly")))) {
#line 121 "Widgets/PreferencesWindow.vala"
		switch (0) {
#line 408 "PreferencesWindow.c"
			default:
			{
				GtkSwitch* _tmp10_;
				PlankDockPreferences* _tmp11_;
				gboolean _tmp12_;
				gboolean _tmp13_;
#line 126 "Widgets/PreferencesWindow.vala"
				_tmp10_ = self->priv->sw_workspace_only;
#line 126 "Widgets/PreferencesWindow.vala"
				_tmp11_ = self->priv->prefs;
#line 126 "Widgets/PreferencesWindow.vala"
				_tmp12_ = plank_dock_preferences_get_CurrentWorkspaceOnly (_tmp11_);
#line 126 "Widgets/PreferencesWindow.vala"
				_tmp13_ = _tmp12_;
#line 126 "Widgets/PreferencesWindow.vala"
				gtk_switch_set_active (_tmp10_, _tmp13_);
#line 127 "Widgets/PreferencesWindow.vala"
				break;
#line 427 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("IconSize")))) {
#line 121 "Widgets/PreferencesWindow.vala"
		switch (0) {
#line 433 "PreferencesWindow.c"
			default:
			{
				GtkAdjustment* _tmp14_;
				PlankDockPreferences* _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
#line 129 "Widgets/PreferencesWindow.vala"
				_tmp14_ = self->priv->adj_iconsize;
#line 129 "Widgets/PreferencesWindow.vala"
				_tmp15_ = self->priv->prefs;
#line 129 "Widgets/PreferencesWindow.vala"
				_tmp16_ = plank_dock_preferences_get_IconSize (_tmp15_);
#line 129 "Widgets/PreferencesWindow.vala"
				_tmp17_ = _tmp16_;
#line 129 "Widgets/PreferencesWindow.vala"
				gtk_adjustment_set_value (_tmp14_, (gdouble) _tmp17_);
#line 130 "Widgets/PreferencesWindow.vala"
				break;
#line 452 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("ItemsAlignment")))) {
#line 121 "Widgets/PreferencesWindow.vala"
		switch (0) {
#line 458 "PreferencesWindow.c"
			default:
			{
				GtkComboBoxText* _tmp18_;
				PlankDockPreferences* _tmp19_;
				GtkAlign _tmp20_;
				GtkAlign _tmp21_;
				gchar* _tmp22_;
				gchar* _tmp23_;
#line 132 "Widgets/PreferencesWindow.vala"
				_tmp18_ = self->priv->cb_items_alignment;
#line 132 "Widgets/PreferencesWindow.vala"
				_tmp19_ = self->priv->prefs;
#line 132 "Widgets/PreferencesWindow.vala"
				_tmp20_ = plank_dock_preferences_get_ItemsAlignment (_tmp19_);
#line 132 "Widgets/PreferencesWindow.vala"
				_tmp21_ = _tmp20_;
#line 132 "Widgets/PreferencesWindow.vala"
				_tmp22_ = g_strdup_printf ("%i", (gint) _tmp21_);
#line 132 "Widgets/PreferencesWindow.vala"
				_tmp23_ = _tmp22_;
#line 132 "Widgets/PreferencesWindow.vala"
				gtk_combo_box_set_active_id ((GtkComboBox*) _tmp18_, _tmp23_);
#line 132 "Widgets/PreferencesWindow.vala"
				_g_free0 (_tmp23_);
#line 133 "Widgets/PreferencesWindow.vala"
				break;
#line 485 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("HideMode")))) {
#line 121 "Widgets/PreferencesWindow.vala"
		switch (0) {
#line 491 "PreferencesWindow.c"
			default:
			{
				gboolean hide_none = FALSE;
				PlankDockPreferences* _tmp24_;
				PlankHideType _tmp25_;
				PlankHideType _tmp26_;
				GtkSwitch* _tmp27_;
#line 135 "Widgets/PreferencesWindow.vala"
				_tmp24_ = self->priv->prefs;
#line 135 "Widgets/PreferencesWindow.vala"
				_tmp25_ = plank_dock_preferences_get_HideMode (_tmp24_);
#line 135 "Widgets/PreferencesWindow.vala"
				_tmp26_ = _tmp25_;
#line 135 "Widgets/PreferencesWindow.vala"
				hide_none = _tmp26_ != PLANK_HIDE_TYPE_NONE;
#line 136 "Widgets/PreferencesWindow.vala"
				_tmp27_ = self->priv->sw_hide;
#line 136 "Widgets/PreferencesWindow.vala"
				gtk_switch_set_active (_tmp27_, hide_none);
#line 137 "Widgets/PreferencesWindow.vala"
				if (!hide_none) {
#line 513 "PreferencesWindow.c"
					GtkComboBoxText* _tmp28_;
					PlankDockPreferences* _tmp29_;
					PlankHideType _tmp30_;
					PlankHideType _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
#line 138 "Widgets/PreferencesWindow.vala"
					_tmp28_ = self->priv->cb_hidemode;
#line 138 "Widgets/PreferencesWindow.vala"
					_tmp29_ = self->priv->prefs;
#line 138 "Widgets/PreferencesWindow.vala"
					_tmp30_ = plank_dock_preferences_get_HideMode (_tmp29_);
#line 138 "Widgets/PreferencesWindow.vala"
					_tmp31_ = _tmp30_;
#line 138 "Widgets/PreferencesWindow.vala"
					_tmp32_ = g_strdup_printf ("%i", (gint) _tmp31_);
#line 138 "Widgets/PreferencesWindow.vala"
					_tmp33_ = _tmp32_;
#line 138 "Widgets/PreferencesWindow.vala"
					gtk_combo_box_set_active_id ((GtkComboBox*) _tmp28_, _tmp33_);
#line 138 "Widgets/PreferencesWindow.vala"
					_g_free0 (_tmp33_);
#line 536 "PreferencesWindow.c"
				}
#line 139 "Widgets/PreferencesWindow.vala"
				break;
#line 540 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("LockItems")))) {
#line 121 "Widgets/PreferencesWindow.vala"
		switch (0) {
#line 546 "PreferencesWindow.c"
			default:
			{
				GtkSwitch* _tmp34_;
				PlankDockPreferences* _tmp35_;
				gboolean _tmp36_;
				gboolean _tmp37_;
#line 141 "Widgets/PreferencesWindow.vala"
				_tmp34_ = self->priv->sw_lock_items;
#line 141 "Widgets/PreferencesWindow.vala"
				_tmp35_ = self->priv->prefs;
#line 141 "Widgets/PreferencesWindow.vala"
				_tmp36_ = plank_dock_preferences_get_LockItems (_tmp35_);
#line 141 "Widgets/PreferencesWindow.vala"
				_tmp37_ = _tmp36_;
#line 141 "Widgets/PreferencesWindow.vala"
				gtk_switch_set_active (_tmp34_, _tmp37_);
#line 142 "Widgets/PreferencesWindow.vala"
				break;
#line 565 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("Monitor")))) {
#line 121 "Widgets/PreferencesWindow.vala"
		switch (0) {
#line 571 "PreferencesWindow.c"
			default:
			{
				gint pos = 0;
				GdkScreen* _tmp38_;
				gint _tmp39_ = 0;
				gchar** _tmp40_;
#line 144 "Widgets/PreferencesWindow.vala"
				pos = 0;
#line 145 "Widgets/PreferencesWindow.vala"
				_tmp38_ = gtk_window_get_screen ((GtkWindow*) self);
#line 145 "Widgets/PreferencesWindow.vala"
				_tmp40_ = plank_position_manager_get_monitor_plug_names (_tmp38_, &_tmp39_);
#line 584 "PreferencesWindow.c"
				{
					gchar** plug_name_collection = NULL;
					gint plug_name_collection_length1 = 0;
					gint _plug_name_collection_size_ = 0;
					gint plug_name_it = 0;
#line 145 "Widgets/PreferencesWindow.vala"
					plug_name_collection = _tmp40_;
#line 145 "Widgets/PreferencesWindow.vala"
					plug_name_collection_length1 = _tmp39_;
#line 145 "Widgets/PreferencesWindow.vala"
					for (plug_name_it = 0; plug_name_it < plug_name_collection_length1; plug_name_it = plug_name_it + 1) {
#line 596 "PreferencesWindow.c"
						const gchar* plug_name = NULL;
#line 145 "Widgets/PreferencesWindow.vala"
						plug_name = plug_name_collection[plug_name_it];
#line 600 "PreferencesWindow.c"
						{
							const gchar* _tmp41_;
							PlankDockPreferences* _tmp42_;
							const gchar* _tmp43_;
							const gchar* _tmp44_;
							gint _tmp46_;
#line 146 "Widgets/PreferencesWindow.vala"
							_tmp41_ = plug_name;
#line 146 "Widgets/PreferencesWindow.vala"
							_tmp42_ = self->priv->prefs;
#line 146 "Widgets/PreferencesWindow.vala"
							_tmp43_ = plank_dock_preferences_get_Monitor (_tmp42_);
#line 146 "Widgets/PreferencesWindow.vala"
							_tmp44_ = _tmp43_;
#line 146 "Widgets/PreferencesWindow.vala"
							if (g_strcmp0 (_tmp41_, _tmp44_) == 0) {
#line 617 "PreferencesWindow.c"
								GtkComboBoxText* _tmp45_;
#line 147 "Widgets/PreferencesWindow.vala"
								_tmp45_ = self->priv->cb_display_plug;
#line 147 "Widgets/PreferencesWindow.vala"
								gtk_combo_box_set_active ((GtkComboBox*) _tmp45_, pos);
#line 623 "PreferencesWindow.c"
							}
#line 148 "Widgets/PreferencesWindow.vala"
							_tmp46_ = pos;
#line 148 "Widgets/PreferencesWindow.vala"
							pos = _tmp46_ + 1;
#line 629 "PreferencesWindow.c"
						}
					}
#line 145 "Widgets/PreferencesWindow.vala"
					plug_name_collection = (_vala_array_free (plug_name_collection, plug_name_collection_length1, (GDestroyNotify) g_free), NULL);
#line 634 "PreferencesWindow.c"
				}
#line 150 "Widgets/PreferencesWindow.vala"
				break;
#line 638 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("Offset")))) {
#line 121 "Widgets/PreferencesWindow.vala"
		switch (0) {
#line 644 "PreferencesWindow.c"
			default:
			{
				GtkAdjustment* _tmp47_;
				PlankDockPreferences* _tmp48_;
				gint _tmp49_;
				gint _tmp50_;
#line 152 "Widgets/PreferencesWindow.vala"
				_tmp47_ = self->priv->adj_offset;
#line 152 "Widgets/PreferencesWindow.vala"
				_tmp48_ = self->priv->prefs;
#line 152 "Widgets/PreferencesWindow.vala"
				_tmp49_ = plank_dock_preferences_get_Offset (_tmp48_);
#line 152 "Widgets/PreferencesWindow.vala"
				_tmp50_ = _tmp49_;
#line 152 "Widgets/PreferencesWindow.vala"
				gtk_adjustment_set_value (_tmp47_, (gdouble) _tmp50_);
#line 153 "Widgets/PreferencesWindow.vala"
				break;
#line 663 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("PinnedOnly")))) {
#line 121 "Widgets/PreferencesWindow.vala"
		switch (0) {
#line 669 "PreferencesWindow.c"
			default:
			{
				GtkSwitch* _tmp51_;
				PlankDockPreferences* _tmp52_;
				gboolean _tmp53_;
				gboolean _tmp54_;
#line 155 "Widgets/PreferencesWindow.vala"
				_tmp51_ = self->priv->sw_show_unpinned;
#line 155 "Widgets/PreferencesWindow.vala"
				_tmp52_ = self->priv->prefs;
#line 155 "Widgets/PreferencesWindow.vala"
				_tmp53_ = plank_dock_preferences_get_PinnedOnly (_tmp52_);
#line 155 "Widgets/PreferencesWindow.vala"
				_tmp54_ = _tmp53_;
#line 155 "Widgets/PreferencesWindow.vala"
				gtk_switch_set_active (_tmp51_, !_tmp54_);
#line 156 "Widgets/PreferencesWindow.vala"
				break;
#line 688 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("Position")))) {
#line 121 "Widgets/PreferencesWindow.vala"
		switch (0) {
#line 694 "PreferencesWindow.c"
			default:
			{
				GtkComboBoxText* _tmp55_;
				PlankDockPreferences* _tmp56_;
				GtkPositionType _tmp57_;
				GtkPositionType _tmp58_;
				gchar* _tmp59_;
				gchar* _tmp60_;
#line 158 "Widgets/PreferencesWindow.vala"
				_tmp55_ = self->priv->cb_position;
#line 158 "Widgets/PreferencesWindow.vala"
				_tmp56_ = self->priv->prefs;
#line 158 "Widgets/PreferencesWindow.vala"
				_tmp57_ = plank_dock_preferences_get_Position (_tmp56_);
#line 158 "Widgets/PreferencesWindow.vala"
				_tmp58_ = _tmp57_;
#line 158 "Widgets/PreferencesWindow.vala"
				_tmp59_ = g_strdup_printf ("%i", (gint) _tmp58_);
#line 158 "Widgets/PreferencesWindow.vala"
				_tmp60_ = _tmp59_;
#line 158 "Widgets/PreferencesWindow.vala"
				gtk_combo_box_set_active_id ((GtkComboBox*) _tmp55_, _tmp60_);
#line 158 "Widgets/PreferencesWindow.vala"
				_g_free0 (_tmp60_);
#line 159 "Widgets/PreferencesWindow.vala"
				break;
#line 721 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("PressureReveal")))) {
#line 121 "Widgets/PreferencesWindow.vala"
		switch (0) {
#line 727 "PreferencesWindow.c"
			default:
			{
				GtkSwitch* _tmp61_;
				PlankDockPreferences* _tmp62_;
				gboolean _tmp63_;
				gboolean _tmp64_;
#line 161 "Widgets/PreferencesWindow.vala"
				_tmp61_ = self->priv->sw_pressure_reveal;
#line 161 "Widgets/PreferencesWindow.vala"
				_tmp62_ = self->priv->prefs;
#line 161 "Widgets/PreferencesWindow.vala"
				_tmp63_ = plank_dock_preferences_get_PressureReveal (_tmp62_);
#line 161 "Widgets/PreferencesWindow.vala"
				_tmp64_ = _tmp63_;
#line 161 "Widgets/PreferencesWindow.vala"
				gtk_switch_set_active (_tmp61_, _tmp64_);
#line 162 "Widgets/PreferencesWindow.vala"
				break;
#line 746 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("Theme")))) {
#line 121 "Widgets/PreferencesWindow.vala"
		switch (0) {
#line 752 "PreferencesWindow.c"
			default:
			{
				gint pos = 0;
				gint _tmp65_ = 0;
				gchar** _tmp66_;
#line 164 "Widgets/PreferencesWindow.vala"
				pos = 0;
#line 165 "Widgets/PreferencesWindow.vala"
				_tmp66_ = plank_theme_get_theme_list (&_tmp65_);
#line 762 "PreferencesWindow.c"
				{
					gchar** theme_collection = NULL;
					gint theme_collection_length1 = 0;
					gint _theme_collection_size_ = 0;
					gint theme_it = 0;
#line 165 "Widgets/PreferencesWindow.vala"
					theme_collection = _tmp66_;
#line 165 "Widgets/PreferencesWindow.vala"
					theme_collection_length1 = _tmp65_;
#line 165 "Widgets/PreferencesWindow.vala"
					for (theme_it = 0; theme_it < theme_collection_length1; theme_it = theme_it + 1) {
#line 774 "PreferencesWindow.c"
						const gchar* theme = NULL;
#line 165 "Widgets/PreferencesWindow.vala"
						theme = theme_collection[theme_it];
#line 778 "PreferencesWindow.c"
						{
							const gchar* _tmp67_;
							PlankDockPreferences* _tmp68_;
							const gchar* _tmp69_;
							const gchar* _tmp70_;
							gint _tmp72_;
#line 166 "Widgets/PreferencesWindow.vala"
							_tmp67_ = theme;
#line 166 "Widgets/PreferencesWindow.vala"
							_tmp68_ = self->priv->prefs;
#line 166 "Widgets/PreferencesWindow.vala"
							_tmp69_ = plank_dock_preferences_get_Theme (_tmp68_);
#line 166 "Widgets/PreferencesWindow.vala"
							_tmp70_ = _tmp69_;
#line 166 "Widgets/PreferencesWindow.vala"
							if (g_strcmp0 (_tmp67_, _tmp70_) == 0) {
#line 795 "PreferencesWindow.c"
								GtkComboBoxText* _tmp71_;
#line 167 "Widgets/PreferencesWindow.vala"
								_tmp71_ = self->priv->cb_theme;
#line 167 "Widgets/PreferencesWindow.vala"
								gtk_combo_box_set_active ((GtkComboBox*) _tmp71_, pos);
#line 801 "PreferencesWindow.c"
							}
#line 168 "Widgets/PreferencesWindow.vala"
							_tmp72_ = pos;
#line 168 "Widgets/PreferencesWindow.vala"
							pos = _tmp72_ + 1;
#line 807 "PreferencesWindow.c"
						}
					}
#line 165 "Widgets/PreferencesWindow.vala"
					theme_collection = (_vala_array_free (theme_collection, theme_collection_length1, (GDestroyNotify) g_free), NULL);
#line 812 "PreferencesWindow.c"
				}
#line 170 "Widgets/PreferencesWindow.vala"
				break;
#line 816 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("HideDelay")))) {
#line 121 "Widgets/PreferencesWindow.vala"
		switch (0) {
#line 822 "PreferencesWindow.c"
			default:
			{
				GtkAdjustment* _tmp73_;
				PlankDockPreferences* _tmp74_;
				guint _tmp75_;
				guint _tmp76_;
#line 172 "Widgets/PreferencesWindow.vala"
				_tmp73_ = self->priv->adj_hide_delay;
#line 172 "Widgets/PreferencesWindow.vala"
				_tmp74_ = self->priv->prefs;
#line 172 "Widgets/PreferencesWindow.vala"
				_tmp75_ = plank_dock_preferences_get_HideDelay (_tmp74_);
#line 172 "Widgets/PreferencesWindow.vala"
				_tmp76_ = _tmp75_;
#line 172 "Widgets/PreferencesWindow.vala"
				gtk_adjustment_set_value (_tmp73_, (gdouble) _tmp76_);
#line 173 "Widgets/PreferencesWindow.vala"
				break;
#line 841 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label13) ? _tmp2_label13 : (_tmp2_label13 = g_quark_from_static_string ("UnhideDelay")))) {
#line 121 "Widgets/PreferencesWindow.vala"
		switch (0) {
#line 847 "PreferencesWindow.c"
			default:
			{
				GtkAdjustment* _tmp77_;
				PlankDockPreferences* _tmp78_;
				guint _tmp79_;
				guint _tmp80_;
#line 175 "Widgets/PreferencesWindow.vala"
				_tmp77_ = self->priv->adj_unhide_delay;
#line 175 "Widgets/PreferencesWindow.vala"
				_tmp78_ = self->priv->prefs;
#line 175 "Widgets/PreferencesWindow.vala"
				_tmp79_ = plank_dock_preferences_get_UnhideDelay (_tmp78_);
#line 175 "Widgets/PreferencesWindow.vala"
				_tmp80_ = _tmp79_;
#line 175 "Widgets/PreferencesWindow.vala"
				gtk_adjustment_set_value (_tmp77_, (gdouble) _tmp80_);
#line 176 "Widgets/PreferencesWindow.vala"
				break;
#line 866 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label14) ? _tmp2_label14 : (_tmp2_label14 = g_quark_from_static_string ("ZoomEnabled")))) {
#line 121 "Widgets/PreferencesWindow.vala"
		switch (0) {
#line 872 "PreferencesWindow.c"
			default:
			{
				GtkSwitch* _tmp81_;
				PlankDockPreferences* _tmp82_;
				gboolean _tmp83_;
				gboolean _tmp84_;
#line 178 "Widgets/PreferencesWindow.vala"
				_tmp81_ = self->priv->sw_zoom_enabled;
#line 178 "Widgets/PreferencesWindow.vala"
				_tmp82_ = self->priv->prefs;
#line 178 "Widgets/PreferencesWindow.vala"
				_tmp83_ = plank_dock_preferences_get_ZoomEnabled (_tmp82_);
#line 178 "Widgets/PreferencesWindow.vala"
				_tmp84_ = _tmp83_;
#line 178 "Widgets/PreferencesWindow.vala"
				gtk_switch_set_active (_tmp81_, _tmp84_);
#line 179 "Widgets/PreferencesWindow.vala"
				break;
#line 891 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label15) ? _tmp2_label15 : (_tmp2_label15 = g_quark_from_static_string ("ZoomPercent")))) {
#line 121 "Widgets/PreferencesWindow.vala"
		switch (0) {
#line 897 "PreferencesWindow.c"
			default:
			{
				GtkAdjustment* _tmp85_;
				PlankDockPreferences* _tmp86_;
				guint _tmp87_;
				guint _tmp88_;
#line 181 "Widgets/PreferencesWindow.vala"
				_tmp85_ = self->priv->adj_zoom_percent;
#line 181 "Widgets/PreferencesWindow.vala"
				_tmp86_ = self->priv->prefs;
#line 181 "Widgets/PreferencesWindow.vala"
				_tmp87_ = plank_dock_preferences_get_ZoomPercent (_tmp86_);
#line 181 "Widgets/PreferencesWindow.vala"
				_tmp88_ = _tmp87_;
#line 181 "Widgets/PreferencesWindow.vala"
				gtk_adjustment_set_value (_tmp85_, (gdouble) _tmp88_);
#line 182 "Widgets/PreferencesWindow.vala"
				break;
#line 916 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label16) ? _tmp2_label16 : (_tmp2_label16 = g_quark_from_static_string ("DockItems")))) {
#line 121 "Widgets/PreferencesWindow.vala"
		switch (0) {
#line 922 "PreferencesWindow.c"
			default:
			{
#line 185 "Widgets/PreferencesWindow.vala"
				break;
#line 927 "PreferencesWindow.c"
			}
		}
	} else {
#line 121 "Widgets/PreferencesWindow.vala"
		switch (0) {
#line 933 "PreferencesWindow.c"
			default:
			{
				const gchar* _tmp89_;
#line 187 "Widgets/PreferencesWindow.vala"
				_tmp89_ = prop->name;
#line 187 "Widgets/PreferencesWindow.vala"
				g_warning ("PreferencesWindow.vala:187: %s not supported", _tmp89_);
#line 188 "Widgets/PreferencesWindow.vala"
				break;
#line 943 "PreferencesWindow.c"
			}
		}
	}
}

static void
plank_preferences_window_theme_changed (PlankPreferencesWindow* self,
                                        GtkComboBox* widget)
{
	PlankDockPreferences* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 193 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 193 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 195 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 195 "Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_combo_box_text_get_active_text (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_combo_box_text_get_type (), GtkComboBoxText));
#line 195 "Widgets/PreferencesWindow.vala"
	_tmp2_ = _tmp1_;
#line 195 "Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_Theme (_tmp0_, _tmp2_);
#line 195 "Widgets/PreferencesWindow.vala"
	_g_free0 (_tmp2_);
#line 970 "PreferencesWindow.c"
}

static void
plank_preferences_window_hidemode_changed (PlankPreferencesWindow* self,
                                           GtkComboBox* widget)
{
	PlankDockPreferences* _tmp0_;
	const gchar* _tmp1_;
#line 198 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 198 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 200 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 200 "Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_combo_box_get_active_id (widget);
#line 200 "Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_HideMode (_tmp0_, (PlankHideType) atoi (_tmp1_));
#line 989 "PreferencesWindow.c"
}

static void
plank_preferences_window_position_changed (PlankPreferencesWindow* self,
                                           GtkComboBox* widget)
{
	PlankDockPreferences* _tmp0_;
	const gchar* _tmp1_;
#line 203 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 203 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 205 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 205 "Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_combo_box_get_active_id (widget);
#line 205 "Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_Position (_tmp0_, (GtkPositionType) atoi (_tmp1_));
#line 1008 "PreferencesWindow.c"
}

static void
plank_preferences_window_alignment_changed (PlankPreferencesWindow* self,
                                            GtkComboBox* widget)
{
	PlankDockPreferences* _tmp0_;
	const gchar* _tmp1_;
	GtkComboBoxText* _tmp2_;
	PlankDockPreferences* _tmp3_;
	GtkAlign _tmp4_;
	GtkAlign _tmp5_;
	GtkScale* _tmp6_;
	PlankDockPreferences* _tmp7_;
	GtkAlign _tmp8_;
	GtkAlign _tmp9_;
#line 208 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 208 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 210 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 210 "Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_combo_box_get_active_id (widget);
#line 210 "Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_Alignment (_tmp0_, (GtkAlign) atoi (_tmp1_));
#line 211 "Widgets/PreferencesWindow.vala"
	_tmp2_ = self->priv->cb_items_alignment;
#line 211 "Widgets/PreferencesWindow.vala"
	_tmp3_ = self->priv->prefs;
#line 211 "Widgets/PreferencesWindow.vala"
	_tmp4_ = plank_dock_preferences_get_Alignment (_tmp3_);
#line 211 "Widgets/PreferencesWindow.vala"
	_tmp5_ = _tmp4_;
#line 211 "Widgets/PreferencesWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, _tmp5_ == GTK_ALIGN_FILL);
#line 212 "Widgets/PreferencesWindow.vala"
	_tmp6_ = self->priv->s_offset;
#line 212 "Widgets/PreferencesWindow.vala"
	_tmp7_ = self->priv->prefs;
#line 212 "Widgets/PreferencesWindow.vala"
	_tmp8_ = plank_dock_preferences_get_Alignment (_tmp7_);
#line 212 "Widgets/PreferencesWindow.vala"
	_tmp9_ = _tmp8_;
#line 212 "Widgets/PreferencesWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, _tmp9_ == GTK_ALIGN_CENTER);
#line 1055 "PreferencesWindow.c"
}

static void
plank_preferences_window_items_alignment_changed (PlankPreferencesWindow* self,
                                                  GtkComboBox* widget)
{
	PlankDockPreferences* _tmp0_;
	const gchar* _tmp1_;
#line 215 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 215 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 217 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 217 "Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_combo_box_get_active_id (widget);
#line 217 "Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_ItemsAlignment (_tmp0_, (GtkAlign) atoi (_tmp1_));
#line 1074 "PreferencesWindow.c"
}

static void
plank_preferences_window_hide_toggled (PlankPreferencesWindow* self,
                                       GObject* widget,
                                       GParamSpec* param)
{
#line 220 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 220 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 220 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (param != NULL);
#line 222 "Widgets/PreferencesWindow.vala"
	if (gtk_switch_get_active (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_switch_get_type (), GtkSwitch))) {
#line 1090 "PreferencesWindow.c"
		PlankDockPreferences* _tmp0_;
		GtkComboBoxText* _tmp1_;
		GtkSpinButton* _tmp2_;
		GtkSpinButton* _tmp3_;
		GtkSwitch* _tmp4_;
#line 223 "Widgets/PreferencesWindow.vala"
		_tmp0_ = self->priv->prefs;
#line 223 "Widgets/PreferencesWindow.vala"
		plank_dock_preferences_set_HideMode (_tmp0_, PLANK_HIDE_TYPE_INTELLIGENT);
#line 224 "Widgets/PreferencesWindow.vala"
		_tmp1_ = self->priv->cb_hidemode;
#line 224 "Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, TRUE);
#line 225 "Widgets/PreferencesWindow.vala"
		_tmp2_ = self->priv->sp_hide_delay;
#line 225 "Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, TRUE);
#line 226 "Widgets/PreferencesWindow.vala"
		_tmp3_ = self->priv->sp_unhide_delay;
#line 226 "Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, TRUE);
#line 227 "Widgets/PreferencesWindow.vala"
		_tmp4_ = self->priv->sw_pressure_reveal;
#line 227 "Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, TRUE);
#line 1116 "PreferencesWindow.c"
	} else {
		PlankDockPreferences* _tmp5_;
		GtkComboBoxText* _tmp6_;
		GtkSpinButton* _tmp7_;
		GtkSpinButton* _tmp8_;
		GtkSwitch* _tmp9_;
#line 229 "Widgets/PreferencesWindow.vala"
		_tmp5_ = self->priv->prefs;
#line 229 "Widgets/PreferencesWindow.vala"
		plank_dock_preferences_set_HideMode (_tmp5_, PLANK_HIDE_TYPE_NONE);
#line 230 "Widgets/PreferencesWindow.vala"
		_tmp6_ = self->priv->cb_hidemode;
#line 230 "Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, FALSE);
#line 231 "Widgets/PreferencesWindow.vala"
		_tmp7_ = self->priv->sp_hide_delay;
#line 231 "Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
#line 232 "Widgets/PreferencesWindow.vala"
		_tmp8_ = self->priv->sp_unhide_delay;
#line 232 "Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
#line 233 "Widgets/PreferencesWindow.vala"
		_tmp9_ = self->priv->sw_pressure_reveal;
#line 233 "Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, FALSE);
#line 1143 "PreferencesWindow.c"
	}
}

static void
plank_preferences_window_primary_display_toggled (PlankPreferencesWindow* self,
                                                  GObject* widget,
                                                  GParamSpec* param)
{
#line 237 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 237 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 237 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (param != NULL);
#line 239 "Widgets/PreferencesWindow.vala"
	if (gtk_switch_get_active (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_switch_get_type (), GtkSwitch))) {
#line 1160 "PreferencesWindow.c"
		PlankDockPreferences* _tmp0_;
		GtkComboBoxText* _tmp1_;
#line 240 "Widgets/PreferencesWindow.vala"
		_tmp0_ = self->priv->prefs;
#line 240 "Widgets/PreferencesWindow.vala"
		plank_dock_preferences_set_Monitor (_tmp0_, "");
#line 241 "Widgets/PreferencesWindow.vala"
		_tmp1_ = self->priv->cb_display_plug;
#line 241 "Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
#line 1171 "PreferencesWindow.c"
	} else {
		PlankDockPreferences* _tmp2_;
		GtkComboBoxText* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GtkComboBoxText* _tmp6_;
#line 243 "Widgets/PreferencesWindow.vala"
		_tmp2_ = self->priv->prefs;
#line 243 "Widgets/PreferencesWindow.vala"
		_tmp3_ = self->priv->cb_display_plug;
#line 243 "Widgets/PreferencesWindow.vala"
		_tmp4_ = gtk_combo_box_text_get_active_text (_tmp3_);
#line 243 "Widgets/PreferencesWindow.vala"
		_tmp5_ = _tmp4_;
#line 243 "Widgets/PreferencesWindow.vala"
		plank_dock_preferences_set_Monitor (_tmp2_, _tmp5_);
#line 243 "Widgets/PreferencesWindow.vala"
		_g_free0 (_tmp5_);
#line 244 "Widgets/PreferencesWindow.vala"
		_tmp6_ = self->priv->cb_display_plug;
#line 244 "Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, TRUE);
#line 1194 "PreferencesWindow.c"
	}
}

static void
plank_preferences_window_workspace_only_toggled (PlankPreferencesWindow* self,
                                                 GObject* widget,
                                                 GParamSpec* param)
{
	PlankDockPreferences* _tmp0_;
#line 248 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 248 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 248 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (param != NULL);
#line 250 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 250 "Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_CurrentWorkspaceOnly (_tmp0_, gtk_switch_get_active (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_switch_get_type (), GtkSwitch)));
#line 1214 "PreferencesWindow.c"
}

static void
plank_preferences_window_show_unpinned_toggled (PlankPreferencesWindow* self,
                                                GObject* widget,
                                                GParamSpec* param)
{
	PlankDockPreferences* _tmp0_;
#line 253 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 253 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 253 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (param != NULL);
#line 255 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 255 "Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_PinnedOnly (_tmp0_, !gtk_switch_get_active (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_switch_get_type (), GtkSwitch)));
#line 1233 "PreferencesWindow.c"
}

static void
plank_preferences_window_lock_items_toggled (PlankPreferencesWindow* self,
                                             GObject* widget,
                                             GParamSpec* param)
{
	PlankDockPreferences* _tmp0_;
#line 258 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 258 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 258 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (param != NULL);
#line 260 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 260 "Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_LockItems (_tmp0_, gtk_switch_get_active (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_switch_get_type (), GtkSwitch)));
#line 1252 "PreferencesWindow.c"
}

static void
plank_preferences_window_pressure_reveal_toggled (PlankPreferencesWindow* self,
                                                  GObject* widget,
                                                  GParamSpec* param)
{
	PlankDockPreferences* _tmp0_;
#line 263 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 263 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 263 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (param != NULL);
#line 265 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 265 "Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_PressureReveal (_tmp0_, gtk_switch_get_active (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_switch_get_type (), GtkSwitch)));
#line 1271 "PreferencesWindow.c"
}

static void
plank_preferences_window_zoom_enabled_toggled (PlankPreferencesWindow* self,
                                               GObject* widget,
                                               GParamSpec* param)
{
#line 268 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 268 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 268 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (param != NULL);
#line 270 "Widgets/PreferencesWindow.vala"
	if (gtk_switch_get_active (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_switch_get_type (), GtkSwitch))) {
#line 1287 "PreferencesWindow.c"
		PlankDockPreferences* _tmp0_;
		GtkScale* _tmp1_;
#line 271 "Widgets/PreferencesWindow.vala"
		_tmp0_ = self->priv->prefs;
#line 271 "Widgets/PreferencesWindow.vala"
		plank_dock_preferences_set_ZoomEnabled (_tmp0_, TRUE);
#line 272 "Widgets/PreferencesWindow.vala"
		_tmp1_ = self->priv->s_zoom_percent;
#line 272 "Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, TRUE);
#line 1298 "PreferencesWindow.c"
	} else {
		PlankDockPreferences* _tmp2_;
		GtkScale* _tmp3_;
#line 274 "Widgets/PreferencesWindow.vala"
		_tmp2_ = self->priv->prefs;
#line 274 "Widgets/PreferencesWindow.vala"
		plank_dock_preferences_set_ZoomEnabled (_tmp2_, FALSE);
#line 275 "Widgets/PreferencesWindow.vala"
		_tmp3_ = self->priv->s_zoom_percent;
#line 275 "Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, FALSE);
#line 1310 "PreferencesWindow.c"
	}
}

static void
plank_preferences_window_iconsize_changed (PlankPreferencesWindow* self,
                                           GtkAdjustment* adj)
{
	PlankDockPreferences* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 279 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 279 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (adj != NULL);
#line 281 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 281 "Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_adjustment_get_value (adj);
#line 281 "Widgets/PreferencesWindow.vala"
	_tmp2_ = _tmp1_;
#line 281 "Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_IconSize (_tmp0_, (gint) _tmp2_);
#line 1333 "PreferencesWindow.c"
}

static void
plank_preferences_window_offset_changed (PlankPreferencesWindow* self,
                                         GtkAdjustment* adj)
{
	PlankDockPreferences* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 284 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 284 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (adj != NULL);
#line 286 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 286 "Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_adjustment_get_value (adj);
#line 286 "Widgets/PreferencesWindow.vala"
	_tmp2_ = _tmp1_;
#line 286 "Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_Offset (_tmp0_, (gint) _tmp2_);
#line 1355 "PreferencesWindow.c"
}

static void
plank_preferences_window_hide_delay_changed (PlankPreferencesWindow* self,
                                             GtkAdjustment* adj)
{
	PlankDockPreferences* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 289 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 289 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (adj != NULL);
#line 291 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 291 "Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_adjustment_get_value (adj);
#line 291 "Widgets/PreferencesWindow.vala"
	_tmp2_ = _tmp1_;
#line 291 "Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_HideDelay (_tmp0_, (guint) ((gint) _tmp2_));
#line 1377 "PreferencesWindow.c"
}

static void
plank_preferences_window_unhide_delay_changed (PlankPreferencesWindow* self,
                                               GtkAdjustment* adj)
{
	PlankDockPreferences* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 294 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 294 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (adj != NULL);
#line 296 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 296 "Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_adjustment_get_value (adj);
#line 296 "Widgets/PreferencesWindow.vala"
	_tmp2_ = _tmp1_;
#line 296 "Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_UnhideDelay (_tmp0_, (guint) ((gint) _tmp2_));
#line 1399 "PreferencesWindow.c"
}

static void
plank_preferences_window_zoom_percent_changed (PlankPreferencesWindow* self,
                                               GtkAdjustment* adj)
{
	PlankDockPreferences* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 299 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 299 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (adj != NULL);
#line 301 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 301 "Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_adjustment_get_value (adj);
#line 301 "Widgets/PreferencesWindow.vala"
	_tmp2_ = _tmp1_;
#line 301 "Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_ZoomPercent (_tmp0_, (guint) ((gint) _tmp2_));
#line 1421 "PreferencesWindow.c"
}

static void
plank_preferences_window_monitor_changed (PlankPreferencesWindow* self,
                                          GtkComboBox* widget)
{
	PlankDockPreferences* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 304 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 304 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 306 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 306 "Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_combo_box_text_get_active_text (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_combo_box_text_get_type (), GtkComboBoxText));
#line 306 "Widgets/PreferencesWindow.vala"
	_tmp2_ = _tmp1_;
#line 306 "Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_Monitor (_tmp0_, _tmp2_);
#line 306 "Widgets/PreferencesWindow.vala"
	_g_free0 (_tmp2_);
#line 1445 "PreferencesWindow.c"
}

static void
_plank_preferences_window_prefs_changed_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
#line 311 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_prefs_changed ((PlankPreferencesWindow*) self, _sender, pspec);
#line 1455 "PreferencesWindow.c"
}

static void
_plank_preferences_window_theme_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                               gpointer self)
{
#line 313 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_theme_changed ((PlankPreferencesWindow*) self, _sender);
#line 1464 "PreferencesWindow.c"
}

static void
_plank_preferences_window_hidemode_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                  gpointer self)
{
#line 314 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_hidemode_changed ((PlankPreferencesWindow*) self, _sender);
#line 1473 "PreferencesWindow.c"
}

static void
_plank_preferences_window_position_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                  gpointer self)
{
#line 315 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_position_changed ((PlankPreferencesWindow*) self, _sender);
#line 1482 "PreferencesWindow.c"
}

static void
_plank_preferences_window_hide_delay_changed_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                           gpointer self)
{
#line 316 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_hide_delay_changed ((PlankPreferencesWindow*) self, _sender);
#line 1491 "PreferencesWindow.c"
}

static void
_plank_preferences_window_unhide_delay_changed_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                             gpointer self)
{
#line 317 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_unhide_delay_changed ((PlankPreferencesWindow*) self, _sender);
#line 1500 "PreferencesWindow.c"
}

static void
_plank_preferences_window_monitor_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self)
{
#line 318 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_monitor_changed ((PlankPreferencesWindow*) self, _sender);
#line 1509 "PreferencesWindow.c"
}

static void
_plank_preferences_window_iconsize_changed_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                         gpointer self)
{
#line 319 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_iconsize_changed ((PlankPreferencesWindow*) self, _sender);
#line 1518 "PreferencesWindow.c"
}

static void
_plank_preferences_window_offset_changed_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                       gpointer self)
{
#line 320 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_offset_changed ((PlankPreferencesWindow*) self, _sender);
#line 1527 "PreferencesWindow.c"
}

static void
_plank_preferences_window_zoom_percent_changed_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                             gpointer self)
{
#line 321 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_zoom_percent_changed ((PlankPreferencesWindow*) self, _sender);
#line 1536 "PreferencesWindow.c"
}

static void
_plank_preferences_window_hide_toggled_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
#line 322 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_hide_toggled ((PlankPreferencesWindow*) self, _sender, pspec);
#line 1546 "PreferencesWindow.c"
}

static void
_plank_preferences_window_primary_display_toggled_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self)
{
#line 323 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_primary_display_toggled ((PlankPreferencesWindow*) self, _sender, pspec);
#line 1556 "PreferencesWindow.c"
}

static void
_plank_preferences_window_workspace_only_toggled_g_object_notify (GObject* _sender,
                                                                  GParamSpec* pspec,
                                                                  gpointer self)
{
#line 324 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_workspace_only_toggled ((PlankPreferencesWindow*) self, _sender, pspec);
#line 1566 "PreferencesWindow.c"
}

static void
_plank_preferences_window_show_unpinned_toggled_g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self)
{
#line 325 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_show_unpinned_toggled ((PlankPreferencesWindow*) self, _sender, pspec);
#line 1576 "PreferencesWindow.c"
}

static void
_plank_preferences_window_lock_items_toggled_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
#line 326 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_lock_items_toggled ((PlankPreferencesWindow*) self, _sender, pspec);
#line 1586 "PreferencesWindow.c"
}

static void
_plank_preferences_window_pressure_reveal_toggled_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self)
{
#line 327 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_pressure_reveal_toggled ((PlankPreferencesWindow*) self, _sender, pspec);
#line 1596 "PreferencesWindow.c"
}

static void
_plank_preferences_window_zoom_enabled_toggled_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self)
{
#line 328 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_zoom_enabled_toggled ((PlankPreferencesWindow*) self, _sender, pspec);
#line 1606 "PreferencesWindow.c"
}

static void
_plank_preferences_window_alignment_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                   gpointer self)
{
#line 329 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_alignment_changed ((PlankPreferencesWindow*) self, _sender);
#line 1615 "PreferencesWindow.c"
}

static void
_plank_preferences_window_items_alignment_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                         gpointer self)
{
#line 330 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_items_alignment_changed ((PlankPreferencesWindow*) self, _sender);
#line 1624 "PreferencesWindow.c"
}

static void
plank_preferences_window_connect_signals (PlankPreferencesWindow* self)
{
	PlankDockPreferences* _tmp0_;
	GtkComboBoxText* _tmp1_;
	GtkComboBoxText* _tmp2_;
	GtkComboBoxText* _tmp3_;
	GtkAdjustment* _tmp4_;
	GtkAdjustment* _tmp5_;
	GtkComboBoxText* _tmp6_;
	GtkAdjustment* _tmp7_;
	GtkAdjustment* _tmp8_;
	GtkAdjustment* _tmp9_;
	GtkSwitch* _tmp10_;
	GtkSwitch* _tmp11_;
	GtkSwitch* _tmp12_;
	GtkSwitch* _tmp13_;
	GtkSwitch* _tmp14_;
	GtkSwitch* _tmp15_;
	GtkSwitch* _tmp16_;
	GtkComboBoxText* _tmp17_;
	GtkComboBoxText* _tmp18_;
#line 309 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 311 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 311 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GObject*) _tmp0_, "notify", (GCallback) _plank_preferences_window_prefs_changed_g_object_notify, self, 0);
#line 313 "Widgets/PreferencesWindow.vala"
	_tmp1_ = self->priv->cb_theme;
#line 313 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp1_, "changed", (GCallback) _plank_preferences_window_theme_changed_gtk_combo_box_changed, self, 0);
#line 314 "Widgets/PreferencesWindow.vala"
	_tmp2_ = self->priv->cb_hidemode;
#line 314 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp2_, "changed", (GCallback) _plank_preferences_window_hidemode_changed_gtk_combo_box_changed, self, 0);
#line 315 "Widgets/PreferencesWindow.vala"
	_tmp3_ = self->priv->cb_position;
#line 315 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp3_, "changed", (GCallback) _plank_preferences_window_position_changed_gtk_combo_box_changed, self, 0);
#line 316 "Widgets/PreferencesWindow.vala"
	_tmp4_ = self->priv->adj_hide_delay;
#line 316 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object (_tmp4_, "value-changed", (GCallback) _plank_preferences_window_hide_delay_changed_gtk_adjustment_value_changed, self, 0);
#line 317 "Widgets/PreferencesWindow.vala"
	_tmp5_ = self->priv->adj_unhide_delay;
#line 317 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object (_tmp5_, "value-changed", (GCallback) _plank_preferences_window_unhide_delay_changed_gtk_adjustment_value_changed, self, 0);
#line 318 "Widgets/PreferencesWindow.vala"
	_tmp6_ = self->priv->cb_display_plug;
#line 318 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp6_, "changed", (GCallback) _plank_preferences_window_monitor_changed_gtk_combo_box_changed, self, 0);
#line 319 "Widgets/PreferencesWindow.vala"
	_tmp7_ = self->priv->adj_iconsize;
#line 319 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object (_tmp7_, "value-changed", (GCallback) _plank_preferences_window_iconsize_changed_gtk_adjustment_value_changed, self, 0);
#line 320 "Widgets/PreferencesWindow.vala"
	_tmp8_ = self->priv->adj_offset;
#line 320 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object (_tmp8_, "value-changed", (GCallback) _plank_preferences_window_offset_changed_gtk_adjustment_value_changed, self, 0);
#line 321 "Widgets/PreferencesWindow.vala"
	_tmp9_ = self->priv->adj_zoom_percent;
#line 321 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object (_tmp9_, "value-changed", (GCallback) _plank_preferences_window_zoom_percent_changed_gtk_adjustment_value_changed, self, 0);
#line 322 "Widgets/PreferencesWindow.vala"
	_tmp10_ = self->priv->sw_hide;
#line 322 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GObject*) _tmp10_, "notify::active", (GCallback) _plank_preferences_window_hide_toggled_g_object_notify, self, 0);
#line 323 "Widgets/PreferencesWindow.vala"
	_tmp11_ = self->priv->sw_primary_display;
#line 323 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GObject*) _tmp11_, "notify::active", (GCallback) _plank_preferences_window_primary_display_toggled_g_object_notify, self, 0);
#line 324 "Widgets/PreferencesWindow.vala"
	_tmp12_ = self->priv->sw_workspace_only;
#line 324 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GObject*) _tmp12_, "notify::active", (GCallback) _plank_preferences_window_workspace_only_toggled_g_object_notify, self, 0);
#line 325 "Widgets/PreferencesWindow.vala"
	_tmp13_ = self->priv->sw_show_unpinned;
#line 325 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GObject*) _tmp13_, "notify::active", (GCallback) _plank_preferences_window_show_unpinned_toggled_g_object_notify, self, 0);
#line 326 "Widgets/PreferencesWindow.vala"
	_tmp14_ = self->priv->sw_lock_items;
#line 326 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GObject*) _tmp14_, "notify::active", (GCallback) _plank_preferences_window_lock_items_toggled_g_object_notify, self, 0);
#line 327 "Widgets/PreferencesWindow.vala"
	_tmp15_ = self->priv->sw_pressure_reveal;
#line 327 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GObject*) _tmp15_, "notify::active", (GCallback) _plank_preferences_window_pressure_reveal_toggled_g_object_notify, self, 0);
#line 328 "Widgets/PreferencesWindow.vala"
	_tmp16_ = self->priv->sw_zoom_enabled;
#line 328 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GObject*) _tmp16_, "notify::active", (GCallback) _plank_preferences_window_zoom_enabled_toggled_g_object_notify, self, 0);
#line 329 "Widgets/PreferencesWindow.vala"
	_tmp17_ = self->priv->cb_alignment;
#line 329 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp17_, "changed", (GCallback) _plank_preferences_window_alignment_changed_gtk_combo_box_changed, self, 0);
#line 330 "Widgets/PreferencesWindow.vala"
	_tmp18_ = self->priv->cb_items_alignment;
#line 330 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp18_, "changed", (GCallback) _plank_preferences_window_items_alignment_changed_gtk_combo_box_changed, self, 0);
#line 1727 "PreferencesWindow.c"
}

static void
plank_preferences_window_disconnect_signals (PlankPreferencesWindow* self)
{
	PlankDockPreferences* _tmp0_;
	guint _tmp1_;
	GtkComboBoxText* _tmp2_;
	guint _tmp3_;
	GtkComboBoxText* _tmp4_;
	guint _tmp5_;
	GtkComboBoxText* _tmp6_;
	guint _tmp7_;
	GtkAdjustment* _tmp8_;
	guint _tmp9_;
	GtkAdjustment* _tmp10_;
	guint _tmp11_;
	GtkComboBoxText* _tmp12_;
	guint _tmp13_;
	GtkAdjustment* _tmp14_;
	guint _tmp15_;
	GtkAdjustment* _tmp16_;
	guint _tmp17_;
	GtkAdjustment* _tmp18_;
	guint _tmp19_;
	GtkSwitch* _tmp20_;
	guint _tmp21_;
	GQuark _tmp22_;
	GtkSwitch* _tmp23_;
	guint _tmp24_;
	GQuark _tmp25_;
	GtkSwitch* _tmp26_;
	guint _tmp27_;
	GQuark _tmp28_;
	GtkSwitch* _tmp29_;
	guint _tmp30_;
	GQuark _tmp31_;
	GtkSwitch* _tmp32_;
	guint _tmp33_;
	GQuark _tmp34_;
	GtkSwitch* _tmp35_;
	guint _tmp36_;
	GQuark _tmp37_;
	GtkSwitch* _tmp38_;
	guint _tmp39_;
	GQuark _tmp40_;
	GtkComboBoxText* _tmp41_;
	guint _tmp42_;
	GtkComboBoxText* _tmp43_;
	guint _tmp44_;
#line 333 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 335 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 335 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp1_, NULL, FALSE);
#line 335 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _plank_preferences_window_prefs_changed_g_object_notify, self);
#line 337 "Widgets/PreferencesWindow.vala"
	_tmp2_ = self->priv->cb_theme;
#line 337 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("changed", gtk_combo_box_get_type (), &_tmp3_, NULL, FALSE);
#line 337 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GtkComboBox*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _plank_preferences_window_theme_changed_gtk_combo_box_changed, self);
#line 338 "Widgets/PreferencesWindow.vala"
	_tmp4_ = self->priv->cb_hidemode;
#line 338 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("changed", gtk_combo_box_get_type (), &_tmp5_, NULL, FALSE);
#line 338 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GtkComboBox*) _tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _plank_preferences_window_hidemode_changed_gtk_combo_box_changed, self);
#line 339 "Widgets/PreferencesWindow.vala"
	_tmp6_ = self->priv->cb_position;
#line 339 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("changed", gtk_combo_box_get_type (), &_tmp7_, NULL, FALSE);
#line 339 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GtkComboBox*) _tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _plank_preferences_window_position_changed_gtk_combo_box_changed, self);
#line 340 "Widgets/PreferencesWindow.vala"
	_tmp8_ = self->priv->adj_hide_delay;
#line 340 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("value-changed", gtk_adjustment_get_type (), &_tmp9_, NULL, FALSE);
#line 340 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _plank_preferences_window_hide_delay_changed_gtk_adjustment_value_changed, self);
#line 341 "Widgets/PreferencesWindow.vala"
	_tmp10_ = self->priv->adj_unhide_delay;
#line 341 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("value-changed", gtk_adjustment_get_type (), &_tmp11_, NULL, FALSE);
#line 341 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _plank_preferences_window_unhide_delay_changed_gtk_adjustment_value_changed, self);
#line 342 "Widgets/PreferencesWindow.vala"
	_tmp12_ = self->priv->cb_display_plug;
#line 342 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("changed", gtk_combo_box_get_type (), &_tmp13_, NULL, FALSE);
#line 342 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GtkComboBox*) _tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _plank_preferences_window_monitor_changed_gtk_combo_box_changed, self);
#line 343 "Widgets/PreferencesWindow.vala"
	_tmp14_ = self->priv->adj_iconsize;
#line 343 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("value-changed", gtk_adjustment_get_type (), &_tmp15_, NULL, FALSE);
#line 343 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched (_tmp14_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _plank_preferences_window_iconsize_changed_gtk_adjustment_value_changed, self);
#line 344 "Widgets/PreferencesWindow.vala"
	_tmp16_ = self->priv->adj_offset;
#line 344 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("value-changed", gtk_adjustment_get_type (), &_tmp17_, NULL, FALSE);
#line 344 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched (_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _plank_preferences_window_offset_changed_gtk_adjustment_value_changed, self);
#line 345 "Widgets/PreferencesWindow.vala"
	_tmp18_ = self->priv->adj_zoom_percent;
#line 345 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("value-changed", gtk_adjustment_get_type (), &_tmp19_, NULL, FALSE);
#line 345 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched (_tmp18_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp19_, 0, NULL, (GCallback) _plank_preferences_window_zoom_percent_changed_gtk_adjustment_value_changed, self);
#line 346 "Widgets/PreferencesWindow.vala"
	_tmp20_ = self->priv->sw_hide;
#line 346 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("notify::active", G_TYPE_OBJECT, &_tmp21_, &_tmp22_, TRUE);
#line 346 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp20_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp21_, _tmp22_, NULL, (GCallback) _plank_preferences_window_hide_toggled_g_object_notify, self);
#line 347 "Widgets/PreferencesWindow.vala"
	_tmp23_ = self->priv->sw_primary_display;
#line 347 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("notify::active", G_TYPE_OBJECT, &_tmp24_, &_tmp25_, TRUE);
#line 347 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp23_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp24_, _tmp25_, NULL, (GCallback) _plank_preferences_window_primary_display_toggled_g_object_notify, self);
#line 348 "Widgets/PreferencesWindow.vala"
	_tmp26_ = self->priv->sw_workspace_only;
#line 348 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("notify::active", G_TYPE_OBJECT, &_tmp27_, &_tmp28_, TRUE);
#line 348 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp26_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp27_, _tmp28_, NULL, (GCallback) _plank_preferences_window_workspace_only_toggled_g_object_notify, self);
#line 349 "Widgets/PreferencesWindow.vala"
	_tmp29_ = self->priv->sw_show_unpinned;
#line 349 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("notify::active", G_TYPE_OBJECT, &_tmp30_, &_tmp31_, TRUE);
#line 349 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp29_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp30_, _tmp31_, NULL, (GCallback) _plank_preferences_window_show_unpinned_toggled_g_object_notify, self);
#line 350 "Widgets/PreferencesWindow.vala"
	_tmp32_ = self->priv->sw_lock_items;
#line 350 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("notify::active", G_TYPE_OBJECT, &_tmp33_, &_tmp34_, TRUE);
#line 350 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp32_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp33_, _tmp34_, NULL, (GCallback) _plank_preferences_window_lock_items_toggled_g_object_notify, self);
#line 351 "Widgets/PreferencesWindow.vala"
	_tmp35_ = self->priv->sw_pressure_reveal;
#line 351 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("notify::active", G_TYPE_OBJECT, &_tmp36_, &_tmp37_, TRUE);
#line 351 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp35_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp36_, _tmp37_, NULL, (GCallback) _plank_preferences_window_pressure_reveal_toggled_g_object_notify, self);
#line 352 "Widgets/PreferencesWindow.vala"
	_tmp38_ = self->priv->sw_zoom_enabled;
#line 352 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("notify::active", G_TYPE_OBJECT, &_tmp39_, &_tmp40_, TRUE);
#line 352 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp38_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp39_, _tmp40_, NULL, (GCallback) _plank_preferences_window_zoom_enabled_toggled_g_object_notify, self);
#line 353 "Widgets/PreferencesWindow.vala"
	_tmp41_ = self->priv->cb_alignment;
#line 353 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("changed", gtk_combo_box_get_type (), &_tmp42_, NULL, FALSE);
#line 353 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GtkComboBox*) _tmp41_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp42_, 0, NULL, (GCallback) _plank_preferences_window_alignment_changed_gtk_combo_box_changed, self);
#line 354 "Widgets/PreferencesWindow.vala"
	_tmp43_ = self->priv->cb_items_alignment;
#line 354 "Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("changed", gtk_combo_box_get_type (), &_tmp44_, NULL, FALSE);
#line 354 "Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GtkComboBox*) _tmp43_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp44_, 0, NULL, (GCallback) _plank_preferences_window_items_alignment_changed_gtk_combo_box_changed, self);
#line 1894 "PreferencesWindow.c"
}

static void
plank_preferences_window_init_dock_tab (PlankPreferencesWindow* self)
{
	gint pos = 0;
	GtkComboBoxText* _tmp0_;
	gint _tmp1_ = 0;
	gchar** _tmp2_;
	GtkComboBoxText* _tmp13_;
	PlankDockPreferences* _tmp14_;
	PlankHideType _tmp15_;
	PlankHideType _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GtkComboBoxText* _tmp19_;
	PlankDockPreferences* _tmp20_;
	PlankHideType _tmp21_;
	PlankHideType _tmp22_;
	GtkComboBoxText* _tmp23_;
	PlankDockPreferences* _tmp24_;
	GtkPositionType _tmp25_;
	GtkPositionType _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GtkAdjustment* _tmp29_;
	PlankDockPreferences* _tmp30_;
	guint _tmp31_;
	guint _tmp32_;
	GtkAdjustment* _tmp33_;
	PlankDockPreferences* _tmp34_;
	guint _tmp35_;
	guint _tmp36_;
	GtkComboBoxText* _tmp37_;
	GdkScreen* _tmp38_;
	gint _tmp39_ = 0;
	gchar** _tmp40_;
	PlankDockPreferences* _tmp51_;
	const gchar* _tmp52_;
	const gchar* _tmp53_;
	GtkComboBoxText* _tmp55_;
	PlankDockPreferences* _tmp56_;
	const gchar* _tmp57_;
	const gchar* _tmp58_;
	GtkSpinButton* _tmp59_;
	PlankDockPreferences* _tmp60_;
	PlankHideType _tmp61_;
	PlankHideType _tmp62_;
	GtkSpinButton* _tmp63_;
	PlankDockPreferences* _tmp64_;
	PlankHideType _tmp65_;
	PlankHideType _tmp66_;
	GtkAdjustment* _tmp67_;
	PlankDockPreferences* _tmp68_;
	gint _tmp69_;
	gint _tmp70_;
	GtkAdjustment* _tmp71_;
	PlankDockPreferences* _tmp72_;
	gint _tmp73_;
	gint _tmp74_;
	GtkAdjustment* _tmp75_;
	PlankDockPreferences* _tmp76_;
	guint _tmp77_;
	guint _tmp78_;
	GtkScale* _tmp79_;
	PlankDockPreferences* _tmp80_;
	GtkAlign _tmp81_;
	GtkAlign _tmp82_;
	GtkScale* _tmp83_;
	PlankDockPreferences* _tmp84_;
	gboolean _tmp85_;
	gboolean _tmp86_;
	GtkSwitch* _tmp87_;
	PlankDockPreferences* _tmp88_;
	PlankHideType _tmp89_;
	PlankHideType _tmp90_;
	GtkSwitch* _tmp91_;
	PlankDockPreferences* _tmp92_;
	const gchar* _tmp93_;
	const gchar* _tmp94_;
	GtkSwitch* _tmp95_;
	PlankDockPreferences* _tmp96_;
	gboolean _tmp97_;
	gboolean _tmp98_;
	GtkSwitch* _tmp99_;
	PlankDockPreferences* _tmp100_;
	gboolean _tmp101_;
	gboolean _tmp102_;
	GtkSwitch* _tmp103_;
	PlankDockPreferences* _tmp104_;
	gboolean _tmp105_;
	gboolean _tmp106_;
	GtkSwitch* _tmp107_;
	PlankDockPreferences* _tmp108_;
	gboolean _tmp109_;
	gboolean _tmp110_;
	GtkSwitch* _tmp111_;
	PlankDockPreferences* _tmp112_;
	gboolean _tmp113_;
	gboolean _tmp114_;
	GtkComboBoxText* _tmp115_;
	PlankDockPreferences* _tmp116_;
	GtkAlign _tmp117_;
	GtkAlign _tmp118_;
	gchar* _tmp119_;
	gchar* _tmp120_;
	GtkComboBoxText* _tmp121_;
	PlankDockPreferences* _tmp122_;
	GtkAlign _tmp123_;
	GtkAlign _tmp124_;
	gchar* _tmp125_;
	gchar* _tmp126_;
	GtkComboBoxText* _tmp127_;
	PlankDockPreferences* _tmp128_;
	GtkAlign _tmp129_;
	GtkAlign _tmp130_;
#line 357 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 359 "Widgets/PreferencesWindow.vala"
	pos = 0;
#line 360 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->cb_theme;
#line 360 "Widgets/PreferencesWindow.vala"
	gtk_combo_box_text_remove_all (_tmp0_);
#line 361 "Widgets/PreferencesWindow.vala"
	_tmp2_ = plank_theme_get_theme_list (&_tmp1_);
#line 2021 "PreferencesWindow.c"
	{
		gchar** theme_collection = NULL;
		gint theme_collection_length1 = 0;
		gint _theme_collection_size_ = 0;
		gint theme_it = 0;
#line 361 "Widgets/PreferencesWindow.vala"
		theme_collection = _tmp2_;
#line 361 "Widgets/PreferencesWindow.vala"
		theme_collection_length1 = _tmp1_;
#line 361 "Widgets/PreferencesWindow.vala"
		for (theme_it = 0; theme_it < theme_collection_length1; theme_it = theme_it + 1) {
#line 2033 "PreferencesWindow.c"
			const gchar* theme = NULL;
#line 361 "Widgets/PreferencesWindow.vala"
			theme = theme_collection[theme_it];
#line 2037 "PreferencesWindow.c"
			{
				GtkComboBoxText* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
				PlankDockPreferences* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				gint _tmp12_;
#line 362 "Widgets/PreferencesWindow.vala"
				_tmp3_ = self->priv->cb_theme;
#line 362 "Widgets/PreferencesWindow.vala"
				_tmp4_ = g_strdup_printf ("%i", pos);
#line 362 "Widgets/PreferencesWindow.vala"
				_tmp5_ = _tmp4_;
#line 362 "Widgets/PreferencesWindow.vala"
				_tmp6_ = theme;
#line 362 "Widgets/PreferencesWindow.vala"
				gtk_combo_box_text_append (_tmp3_, _tmp5_, _tmp6_);
#line 362 "Widgets/PreferencesWindow.vala"
				_g_free0 (_tmp5_);
#line 363 "Widgets/PreferencesWindow.vala"
				_tmp7_ = theme;
#line 363 "Widgets/PreferencesWindow.vala"
				_tmp8_ = self->priv->prefs;
#line 363 "Widgets/PreferencesWindow.vala"
				_tmp9_ = plank_dock_preferences_get_Theme (_tmp8_);
#line 363 "Widgets/PreferencesWindow.vala"
				_tmp10_ = _tmp9_;
#line 363 "Widgets/PreferencesWindow.vala"
				if (g_strcmp0 (_tmp7_, _tmp10_) == 0) {
#line 2070 "PreferencesWindow.c"
					GtkComboBoxText* _tmp11_;
#line 364 "Widgets/PreferencesWindow.vala"
					_tmp11_ = self->priv->cb_theme;
#line 364 "Widgets/PreferencesWindow.vala"
					gtk_combo_box_set_active ((GtkComboBox*) _tmp11_, pos);
#line 2076 "PreferencesWindow.c"
				}
#line 365 "Widgets/PreferencesWindow.vala"
				_tmp12_ = pos;
#line 365 "Widgets/PreferencesWindow.vala"
				pos = _tmp12_ + 1;
#line 2082 "PreferencesWindow.c"
			}
		}
#line 361 "Widgets/PreferencesWindow.vala"
		theme_collection = (_vala_array_free (theme_collection, theme_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2087 "PreferencesWindow.c"
	}
#line 368 "Widgets/PreferencesWindow.vala"
	_tmp13_ = self->priv->cb_hidemode;
#line 368 "Widgets/PreferencesWindow.vala"
	_tmp14_ = self->priv->prefs;
#line 368 "Widgets/PreferencesWindow.vala"
	_tmp15_ = plank_dock_preferences_get_HideMode (_tmp14_);
#line 368 "Widgets/PreferencesWindow.vala"
	_tmp16_ = _tmp15_;
#line 368 "Widgets/PreferencesWindow.vala"
	_tmp17_ = g_strdup_printf ("%i", (gint) _tmp16_);
#line 368 "Widgets/PreferencesWindow.vala"
	_tmp18_ = _tmp17_;
#line 368 "Widgets/PreferencesWindow.vala"
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp13_, _tmp18_);
#line 368 "Widgets/PreferencesWindow.vala"
	_g_free0 (_tmp18_);
#line 369 "Widgets/PreferencesWindow.vala"
	_tmp19_ = self->priv->cb_hidemode;
#line 369 "Widgets/PreferencesWindow.vala"
	_tmp20_ = self->priv->prefs;
#line 369 "Widgets/PreferencesWindow.vala"
	_tmp21_ = plank_dock_preferences_get_HideMode (_tmp20_);
#line 369 "Widgets/PreferencesWindow.vala"
	_tmp22_ = _tmp21_;
#line 369 "Widgets/PreferencesWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, _tmp22_ != PLANK_HIDE_TYPE_NONE);
#line 370 "Widgets/PreferencesWindow.vala"
	_tmp23_ = self->priv->cb_position;
#line 370 "Widgets/PreferencesWindow.vala"
	_tmp24_ = self->priv->prefs;
#line 370 "Widgets/PreferencesWindow.vala"
	_tmp25_ = plank_dock_preferences_get_Position (_tmp24_);
#line 370 "Widgets/PreferencesWindow.vala"
	_tmp26_ = _tmp25_;
#line 370 "Widgets/PreferencesWindow.vala"
	_tmp27_ = g_strdup_printf ("%i", (gint) _tmp26_);
#line 370 "Widgets/PreferencesWindow.vala"
	_tmp28_ = _tmp27_;
#line 370 "Widgets/PreferencesWindow.vala"
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp23_, _tmp28_);
#line 370 "Widgets/PreferencesWindow.vala"
	_g_free0 (_tmp28_);
#line 371 "Widgets/PreferencesWindow.vala"
	_tmp29_ = self->priv->adj_hide_delay;
#line 371 "Widgets/PreferencesWindow.vala"
	_tmp30_ = self->priv->prefs;
#line 371 "Widgets/PreferencesWindow.vala"
	_tmp31_ = plank_dock_preferences_get_HideDelay (_tmp30_);
#line 371 "Widgets/PreferencesWindow.vala"
	_tmp32_ = _tmp31_;
#line 371 "Widgets/PreferencesWindow.vala"
	gtk_adjustment_set_value (_tmp29_, (gdouble) _tmp32_);
#line 372 "Widgets/PreferencesWindow.vala"
	_tmp33_ = self->priv->adj_unhide_delay;
#line 372 "Widgets/PreferencesWindow.vala"
	_tmp34_ = self->priv->prefs;
#line 372 "Widgets/PreferencesWindow.vala"
	_tmp35_ = plank_dock_preferences_get_UnhideDelay (_tmp34_);
#line 372 "Widgets/PreferencesWindow.vala"
	_tmp36_ = _tmp35_;
#line 372 "Widgets/PreferencesWindow.vala"
	gtk_adjustment_set_value (_tmp33_, (gdouble) _tmp36_);
#line 374 "Widgets/PreferencesWindow.vala"
	pos = 0;
#line 375 "Widgets/PreferencesWindow.vala"
	_tmp37_ = self->priv->cb_display_plug;
#line 375 "Widgets/PreferencesWindow.vala"
	gtk_combo_box_text_remove_all (_tmp37_);
#line 376 "Widgets/PreferencesWindow.vala"
	_tmp38_ = gtk_window_get_screen ((GtkWindow*) self);
#line 376 "Widgets/PreferencesWindow.vala"
	_tmp40_ = plank_position_manager_get_monitor_plug_names (_tmp38_, &_tmp39_);
#line 2161 "PreferencesWindow.c"
	{
		gchar** plug_name_collection = NULL;
		gint plug_name_collection_length1 = 0;
		gint _plug_name_collection_size_ = 0;
		gint plug_name_it = 0;
#line 376 "Widgets/PreferencesWindow.vala"
		plug_name_collection = _tmp40_;
#line 376 "Widgets/PreferencesWindow.vala"
		plug_name_collection_length1 = _tmp39_;
#line 376 "Widgets/PreferencesWindow.vala"
		for (plug_name_it = 0; plug_name_it < plug_name_collection_length1; plug_name_it = plug_name_it + 1) {
#line 2173 "PreferencesWindow.c"
			const gchar* plug_name = NULL;
#line 376 "Widgets/PreferencesWindow.vala"
			plug_name = plug_name_collection[plug_name_it];
#line 2177 "PreferencesWindow.c"
			{
				GtkComboBoxText* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				const gchar* _tmp44_;
				const gchar* _tmp45_;
				PlankDockPreferences* _tmp46_;
				const gchar* _tmp47_;
				const gchar* _tmp48_;
				gint _tmp50_;
#line 377 "Widgets/PreferencesWindow.vala"
				_tmp41_ = self->priv->cb_display_plug;
#line 377 "Widgets/PreferencesWindow.vala"
				_tmp42_ = g_strdup_printf ("%i", pos);
#line 377 "Widgets/PreferencesWindow.vala"
				_tmp43_ = _tmp42_;
#line 377 "Widgets/PreferencesWindow.vala"
				_tmp44_ = plug_name;
#line 377 "Widgets/PreferencesWindow.vala"
				gtk_combo_box_text_append (_tmp41_, _tmp43_, _tmp44_);
#line 377 "Widgets/PreferencesWindow.vala"
				_g_free0 (_tmp43_);
#line 378 "Widgets/PreferencesWindow.vala"
				_tmp45_ = plug_name;
#line 378 "Widgets/PreferencesWindow.vala"
				_tmp46_ = self->priv->prefs;
#line 378 "Widgets/PreferencesWindow.vala"
				_tmp47_ = plank_dock_preferences_get_Monitor (_tmp46_);
#line 378 "Widgets/PreferencesWindow.vala"
				_tmp48_ = _tmp47_;
#line 378 "Widgets/PreferencesWindow.vala"
				if (g_strcmp0 (_tmp45_, _tmp48_) == 0) {
#line 2210 "PreferencesWindow.c"
					GtkComboBoxText* _tmp49_;
#line 379 "Widgets/PreferencesWindow.vala"
					_tmp49_ = self->priv->cb_display_plug;
#line 379 "Widgets/PreferencesWindow.vala"
					gtk_combo_box_set_active ((GtkComboBox*) _tmp49_, pos);
#line 2216 "PreferencesWindow.c"
				}
#line 380 "Widgets/PreferencesWindow.vala"
				_tmp50_ = pos;
#line 380 "Widgets/PreferencesWindow.vala"
				pos = _tmp50_ + 1;
#line 2222 "PreferencesWindow.c"
			}
		}
#line 376 "Widgets/PreferencesWindow.vala"
		plug_name_collection = (_vala_array_free (plug_name_collection, plug_name_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2227 "PreferencesWindow.c"
	}
#line 382 "Widgets/PreferencesWindow.vala"
	_tmp51_ = self->priv->prefs;
#line 382 "Widgets/PreferencesWindow.vala"
	_tmp52_ = plank_dock_preferences_get_Monitor (_tmp51_);
#line 382 "Widgets/PreferencesWindow.vala"
	_tmp53_ = _tmp52_;
#line 382 "Widgets/PreferencesWindow.vala"
	if (g_strcmp0 (_tmp53_, "") == 0) {
#line 2237 "PreferencesWindow.c"
		GtkComboBoxText* _tmp54_;
#line 383 "Widgets/PreferencesWindow.vala"
		_tmp54_ = self->priv->cb_display_plug;
#line 383 "Widgets/PreferencesWindow.vala"
		gtk_combo_box_set_active ((GtkComboBox*) _tmp54_, 0);
#line 2243 "PreferencesWindow.c"
	}
#line 384 "Widgets/PreferencesWindow.vala"
	_tmp55_ = self->priv->cb_display_plug;
#line 384 "Widgets/PreferencesWindow.vala"
	_tmp56_ = self->priv->prefs;
#line 384 "Widgets/PreferencesWindow.vala"
	_tmp57_ = plank_dock_preferences_get_Monitor (_tmp56_);
#line 384 "Widgets/PreferencesWindow.vala"
	_tmp58_ = _tmp57_;
#line 384 "Widgets/PreferencesWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp55_, g_strcmp0 (_tmp58_, "") != 0);
#line 386 "Widgets/PreferencesWindow.vala"
	_tmp59_ = self->priv->sp_hide_delay;
#line 386 "Widgets/PreferencesWindow.vala"
	_tmp60_ = self->priv->prefs;
#line 386 "Widgets/PreferencesWindow.vala"
	_tmp61_ = plank_dock_preferences_get_HideMode (_tmp60_);
#line 386 "Widgets/PreferencesWindow.vala"
	_tmp62_ = _tmp61_;
#line 386 "Widgets/PreferencesWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp59_, _tmp62_ != PLANK_HIDE_TYPE_NONE);
#line 387 "Widgets/PreferencesWindow.vala"
	_tmp63_ = self->priv->sp_unhide_delay;
#line 387 "Widgets/PreferencesWindow.vala"
	_tmp64_ = self->priv->prefs;
#line 387 "Widgets/PreferencesWindow.vala"
	_tmp65_ = plank_dock_preferences_get_HideMode (_tmp64_);
#line 387 "Widgets/PreferencesWindow.vala"
	_tmp66_ = _tmp65_;
#line 387 "Widgets/PreferencesWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp63_, _tmp66_ != PLANK_HIDE_TYPE_NONE);
#line 389 "Widgets/PreferencesWindow.vala"
	_tmp67_ = self->priv->adj_iconsize;
#line 389 "Widgets/PreferencesWindow.vala"
	_tmp68_ = self->priv->prefs;
#line 389 "Widgets/PreferencesWindow.vala"
	_tmp69_ = plank_dock_preferences_get_IconSize (_tmp68_);
#line 389 "Widgets/PreferencesWindow.vala"
	_tmp70_ = _tmp69_;
#line 389 "Widgets/PreferencesWindow.vala"
	gtk_adjustment_set_value (_tmp67_, (gdouble) _tmp70_);
#line 390 "Widgets/PreferencesWindow.vala"
	_tmp71_ = self->priv->adj_offset;
#line 390 "Widgets/PreferencesWindow.vala"
	_tmp72_ = self->priv->prefs;
#line 390 "Widgets/PreferencesWindow.vala"
	_tmp73_ = plank_dock_preferences_get_Offset (_tmp72_);
#line 390 "Widgets/PreferencesWindow.vala"
	_tmp74_ = _tmp73_;
#line 390 "Widgets/PreferencesWindow.vala"
	gtk_adjustment_set_value (_tmp71_, (gdouble) _tmp74_);
#line 391 "Widgets/PreferencesWindow.vala"
	_tmp75_ = self->priv->adj_zoom_percent;
#line 391 "Widgets/PreferencesWindow.vala"
	_tmp76_ = self->priv->prefs;
#line 391 "Widgets/PreferencesWindow.vala"
	_tmp77_ = plank_dock_preferences_get_ZoomPercent (_tmp76_);
#line 391 "Widgets/PreferencesWindow.vala"
	_tmp78_ = _tmp77_;
#line 391 "Widgets/PreferencesWindow.vala"
	gtk_adjustment_set_value (_tmp75_, (gdouble) _tmp78_);
#line 392 "Widgets/PreferencesWindow.vala"
	_tmp79_ = self->priv->s_offset;
#line 392 "Widgets/PreferencesWindow.vala"
	_tmp80_ = self->priv->prefs;
#line 392 "Widgets/PreferencesWindow.vala"
	_tmp81_ = plank_dock_preferences_get_Alignment (_tmp80_);
#line 392 "Widgets/PreferencesWindow.vala"
	_tmp82_ = _tmp81_;
#line 392 "Widgets/PreferencesWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp79_, _tmp82_ == GTK_ALIGN_CENTER);
#line 393 "Widgets/PreferencesWindow.vala"
	_tmp83_ = self->priv->s_zoom_percent;
#line 393 "Widgets/PreferencesWindow.vala"
	_tmp84_ = self->priv->prefs;
#line 393 "Widgets/PreferencesWindow.vala"
	_tmp85_ = plank_dock_preferences_get_ZoomEnabled (_tmp84_);
#line 393 "Widgets/PreferencesWindow.vala"
	_tmp86_ = _tmp85_;
#line 393 "Widgets/PreferencesWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp83_, _tmp86_);
#line 394 "Widgets/PreferencesWindow.vala"
	_tmp87_ = self->priv->sw_hide;
#line 394 "Widgets/PreferencesWindow.vala"
	_tmp88_ = self->priv->prefs;
#line 394 "Widgets/PreferencesWindow.vala"
	_tmp89_ = plank_dock_preferences_get_HideMode (_tmp88_);
#line 394 "Widgets/PreferencesWindow.vala"
	_tmp90_ = _tmp89_;
#line 394 "Widgets/PreferencesWindow.vala"
	gtk_switch_set_active (_tmp87_, _tmp90_ != PLANK_HIDE_TYPE_NONE);
#line 395 "Widgets/PreferencesWindow.vala"
	_tmp91_ = self->priv->sw_primary_display;
#line 395 "Widgets/PreferencesWindow.vala"
	_tmp92_ = self->priv->prefs;
#line 395 "Widgets/PreferencesWindow.vala"
	_tmp93_ = plank_dock_preferences_get_Monitor (_tmp92_);
#line 395 "Widgets/PreferencesWindow.vala"
	_tmp94_ = _tmp93_;
#line 395 "Widgets/PreferencesWindow.vala"
	gtk_switch_set_active (_tmp91_, g_strcmp0 (_tmp94_, "") == 0);
#line 396 "Widgets/PreferencesWindow.vala"
	_tmp95_ = self->priv->sw_workspace_only;
#line 396 "Widgets/PreferencesWindow.vala"
	_tmp96_ = self->priv->prefs;
#line 396 "Widgets/PreferencesWindow.vala"
	_tmp97_ = plank_dock_preferences_get_CurrentWorkspaceOnly (_tmp96_);
#line 396 "Widgets/PreferencesWindow.vala"
	_tmp98_ = _tmp97_;
#line 396 "Widgets/PreferencesWindow.vala"
	gtk_switch_set_active (_tmp95_, _tmp98_);
#line 397 "Widgets/PreferencesWindow.vala"
	_tmp99_ = self->priv->sw_show_unpinned;
#line 397 "Widgets/PreferencesWindow.vala"
	_tmp100_ = self->priv->prefs;
#line 397 "Widgets/PreferencesWindow.vala"
	_tmp101_ = plank_dock_preferences_get_PinnedOnly (_tmp100_);
#line 397 "Widgets/PreferencesWindow.vala"
	_tmp102_ = _tmp101_;
#line 397 "Widgets/PreferencesWindow.vala"
	gtk_switch_set_active (_tmp99_, !_tmp102_);
#line 398 "Widgets/PreferencesWindow.vala"
	_tmp103_ = self->priv->sw_lock_items;
#line 398 "Widgets/PreferencesWindow.vala"
	_tmp104_ = self->priv->prefs;
#line 398 "Widgets/PreferencesWindow.vala"
	_tmp105_ = plank_dock_preferences_get_LockItems (_tmp104_);
#line 398 "Widgets/PreferencesWindow.vala"
	_tmp106_ = _tmp105_;
#line 398 "Widgets/PreferencesWindow.vala"
	gtk_switch_set_active (_tmp103_, _tmp106_);
#line 399 "Widgets/PreferencesWindow.vala"
	_tmp107_ = self->priv->sw_pressure_reveal;
#line 399 "Widgets/PreferencesWindow.vala"
	_tmp108_ = self->priv->prefs;
#line 399 "Widgets/PreferencesWindow.vala"
	_tmp109_ = plank_dock_preferences_get_PressureReveal (_tmp108_);
#line 399 "Widgets/PreferencesWindow.vala"
	_tmp110_ = _tmp109_;
#line 399 "Widgets/PreferencesWindow.vala"
	gtk_switch_set_active (_tmp107_, _tmp110_);
#line 400 "Widgets/PreferencesWindow.vala"
	_tmp111_ = self->priv->sw_zoom_enabled;
#line 400 "Widgets/PreferencesWindow.vala"
	_tmp112_ = self->priv->prefs;
#line 400 "Widgets/PreferencesWindow.vala"
	_tmp113_ = plank_dock_preferences_get_ZoomEnabled (_tmp112_);
#line 400 "Widgets/PreferencesWindow.vala"
	_tmp114_ = _tmp113_;
#line 400 "Widgets/PreferencesWindow.vala"
	gtk_switch_set_active (_tmp111_, _tmp114_);
#line 401 "Widgets/PreferencesWindow.vala"
	_tmp115_ = self->priv->cb_alignment;
#line 401 "Widgets/PreferencesWindow.vala"
	_tmp116_ = self->priv->prefs;
#line 401 "Widgets/PreferencesWindow.vala"
	_tmp117_ = plank_dock_preferences_get_Alignment (_tmp116_);
#line 401 "Widgets/PreferencesWindow.vala"
	_tmp118_ = _tmp117_;
#line 401 "Widgets/PreferencesWindow.vala"
	_tmp119_ = g_strdup_printf ("%i", (gint) _tmp118_);
#line 401 "Widgets/PreferencesWindow.vala"
	_tmp120_ = _tmp119_;
#line 401 "Widgets/PreferencesWindow.vala"
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp115_, _tmp120_);
#line 401 "Widgets/PreferencesWindow.vala"
	_g_free0 (_tmp120_);
#line 402 "Widgets/PreferencesWindow.vala"
	_tmp121_ = self->priv->cb_items_alignment;
#line 402 "Widgets/PreferencesWindow.vala"
	_tmp122_ = self->priv->prefs;
#line 402 "Widgets/PreferencesWindow.vala"
	_tmp123_ = plank_dock_preferences_get_ItemsAlignment (_tmp122_);
#line 402 "Widgets/PreferencesWindow.vala"
	_tmp124_ = _tmp123_;
#line 402 "Widgets/PreferencesWindow.vala"
	_tmp125_ = g_strdup_printf ("%i", (gint) _tmp124_);
#line 402 "Widgets/PreferencesWindow.vala"
	_tmp126_ = _tmp125_;
#line 402 "Widgets/PreferencesWindow.vala"
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp121_, _tmp126_);
#line 402 "Widgets/PreferencesWindow.vala"
	_g_free0 (_tmp126_);
#line 403 "Widgets/PreferencesWindow.vala"
	_tmp127_ = self->priv->cb_items_alignment;
#line 403 "Widgets/PreferencesWindow.vala"
	_tmp128_ = self->priv->prefs;
#line 403 "Widgets/PreferencesWindow.vala"
	_tmp129_ = plank_dock_preferences_get_Alignment (_tmp128_);
#line 403 "Widgets/PreferencesWindow.vala"
	_tmp130_ = _tmp129_;
#line 403 "Widgets/PreferencesWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp127_, _tmp130_ == GTK_ALIGN_FILL);
#line 2437 "PreferencesWindow.c"
}

static void
_plank_preferences_window_view_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                                 GdkDragContext* context,
                                                                 gpointer self)
{
#line 416 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_view_drag_begin (_sender, context, (PlankPreferencesWindow*) self);
#line 2447 "PreferencesWindow.c"
}

static void
_plank_preferences_window_view_item_activated_gtk_icon_view_item_activated (GtkIconView* _sender,
                                                                            GtkTreePath* path,
                                                                            gpointer self)
{
#line 417 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_view_item_activated (_sender, path, (PlankPreferencesWindow*) self);
#line 2457 "PreferencesWindow.c"
}

static void
plank_preferences_window_init_docklets_tab (PlankPreferencesWindow* self)
{
	PlankDockletViewModel* model_docklets = NULL;
	PlankDockletViewModel* _tmp0_;
	GtkTreeModelSort* sorted_docklets = NULL;
	PlankDockletViewModel* _tmp1_;
	GtkTreeModelSort* _tmp2_;
	GtkTargetEntry te = {0};
	GtkTargetEntry _tmp3_ = {0};
	GtkIconView* _tmp4_;
	GtkTargetEntry _tmp5_;
	GtkTargetEntry* _tmp6_;
	GtkTargetEntry* _tmp7_;
	gint _tmp7__length1;
	GtkIconView* _tmp8_;
	GtkIconView* _tmp9_;
	GtkIconView* _tmp10_;
	GtkIconView* _tmp11_;
	GtkIconView* _tmp12_;
	GtkTreeModelSort* _tmp34_;
	GtkIconView* _tmp35_;
	GtkTreeModelSort* _tmp36_;
#line 406 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 408 "Widgets/PreferencesWindow.vala"
	_tmp0_ = plank_docklet_view_model_new ();
#line 408 "Widgets/PreferencesWindow.vala"
	model_docklets = _tmp0_;
#line 409 "Widgets/PreferencesWindow.vala"
	_tmp1_ = model_docklets;
#line 409 "Widgets/PreferencesWindow.vala"
	_tmp2_ = (GtkTreeModelSort*) gtk_tree_model_sort_new_with_model ((GtkTreeModel*) _tmp1_);
#line 409 "Widgets/PreferencesWindow.vala"
	sorted_docklets = _tmp2_;
#line 411 "Widgets/PreferencesWindow.vala"
	_tmp3_.target = "text/plank-uri-list";
#line 411 "Widgets/PreferencesWindow.vala"
	_tmp3_.flags = (guint) GTK_TARGET_SAME_APP;
#line 411 "Widgets/PreferencesWindow.vala"
	_tmp3_.info = (guint) 0;
#line 411 "Widgets/PreferencesWindow.vala"
	te = _tmp3_;
#line 412 "Widgets/PreferencesWindow.vala"
	_tmp4_ = self->priv->view_docklets;
#line 412 "Widgets/PreferencesWindow.vala"
	_tmp5_ = te;
#line 412 "Widgets/PreferencesWindow.vala"
	_tmp6_ = g_new0 (GtkTargetEntry, 1);
#line 412 "Widgets/PreferencesWindow.vala"
	_tmp6_[0] = _tmp5_;
#line 412 "Widgets/PreferencesWindow.vala"
	_tmp7_ = _tmp6_;
#line 412 "Widgets/PreferencesWindow.vala"
	_tmp7__length1 = 1;
#line 412 "Widgets/PreferencesWindow.vala"
	gtk_icon_view_enable_model_drag_source (_tmp4_, GDK_BUTTON1_MASK, _tmp7_, (gint) 1, GDK_ACTION_PRIVATE);
#line 412 "Widgets/PreferencesWindow.vala"
	_tmp7_ = (g_free (_tmp7_), NULL);
#line 413 "Widgets/PreferencesWindow.vala"
	_tmp8_ = self->priv->view_docklets;
#line 413 "Widgets/PreferencesWindow.vala"
	gtk_icon_view_set_text_column (_tmp8_, (gint) PLANK_DOCKLET_VIEW_MODEL_COLUMN_NAME);
#line 414 "Widgets/PreferencesWindow.vala"
	_tmp9_ = self->priv->view_docklets;
#line 414 "Widgets/PreferencesWindow.vala"
	gtk_icon_view_set_tooltip_column (_tmp9_, (gint) PLANK_DOCKLET_VIEW_MODEL_COLUMN_DESCRIPTION);
#line 415 "Widgets/PreferencesWindow.vala"
	_tmp10_ = self->priv->view_docklets;
#line 415 "Widgets/PreferencesWindow.vala"
	gtk_icon_view_set_pixbuf_column (_tmp10_, (gint) PLANK_DOCKLET_VIEW_MODEL_COLUMN_PIXBUF);
#line 416 "Widgets/PreferencesWindow.vala"
	_tmp11_ = self->priv->view_docklets;
#line 416 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp11_, "drag-begin", (GCallback) _plank_preferences_window_view_drag_begin_gtk_widget_drag_begin, self, G_CONNECT_AFTER);
#line 417 "Widgets/PreferencesWindow.vala"
	_tmp12_ = self->priv->view_docklets;
#line 417 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object (_tmp12_, "item-activated", (GCallback) _plank_preferences_window_view_item_activated_gtk_icon_view_item_activated, self, 0);
#line 2539 "PreferencesWindow.c"
	{
		GeeIterator* _docklet_it = NULL;
		PlankDockletManager* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeIterator* _tmp16_;
		GeeIterator* _tmp17_;
#line 419 "Widgets/PreferencesWindow.vala"
		_tmp13_ = plank_docklet_manager_get_default ();
#line 419 "Widgets/PreferencesWindow.vala"
		_tmp14_ = plank_docklet_manager_list_docklets (_tmp13_);
#line 419 "Widgets/PreferencesWindow.vala"
		_tmp15_ = _tmp14_;
#line 419 "Widgets/PreferencesWindow.vala"
		_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
#line 419 "Widgets/PreferencesWindow.vala"
		_tmp17_ = _tmp16_;
#line 419 "Widgets/PreferencesWindow.vala"
		_g_object_unref0 (_tmp15_);
#line 419 "Widgets/PreferencesWindow.vala"
		_docklet_it = _tmp17_;
#line 419 "Widgets/PreferencesWindow.vala"
		while (TRUE) {
#line 2563 "PreferencesWindow.c"
			GeeIterator* _tmp18_;
			PlankDocklet* docklet = NULL;
			GeeIterator* _tmp19_;
			gpointer _tmp20_;
			GdkPixbuf* pixbuf = NULL;
			PlankDocklet* _tmp21_;
			const gchar* _tmp22_;
			GdkPixbuf* _tmp23_;
			PlankDockletViewModel* _tmp24_;
			PlankDocklet* _tmp25_;
			const gchar* _tmp26_;
			PlankDocklet* _tmp27_;
			const gchar* _tmp28_;
			PlankDocklet* _tmp29_;
			const gchar* _tmp30_;
			PlankDocklet* _tmp31_;
			const gchar* _tmp32_;
			GdkPixbuf* _tmp33_;
#line 419 "Widgets/PreferencesWindow.vala"
			_tmp18_ = _docklet_it;
#line 419 "Widgets/PreferencesWindow.vala"
			if (!gee_iterator_next (_tmp18_)) {
#line 419 "Widgets/PreferencesWindow.vala"
				break;
#line 2588 "PreferencesWindow.c"
			}
#line 419 "Widgets/PreferencesWindow.vala"
			_tmp19_ = _docklet_it;
#line 419 "Widgets/PreferencesWindow.vala"
			_tmp20_ = gee_iterator_get (_tmp19_);
#line 419 "Widgets/PreferencesWindow.vala"
			docklet = (PlankDocklet*) _tmp20_;
#line 420 "Widgets/PreferencesWindow.vala"
			_tmp21_ = docklet;
#line 420 "Widgets/PreferencesWindow.vala"
			_tmp22_ = plank_docklet_get_icon (_tmp21_);
#line 420 "Widgets/PreferencesWindow.vala"
			_tmp23_ = plank_drawing_service_load_icon (_tmp22_, 48, 48);
#line 420 "Widgets/PreferencesWindow.vala"
			pixbuf = _tmp23_;
#line 421 "Widgets/PreferencesWindow.vala"
			_tmp24_ = model_docklets;
#line 421 "Widgets/PreferencesWindow.vala"
			_tmp25_ = docklet;
#line 421 "Widgets/PreferencesWindow.vala"
			_tmp26_ = plank_docklet_get_id (_tmp25_);
#line 421 "Widgets/PreferencesWindow.vala"
			_tmp27_ = docklet;
#line 421 "Widgets/PreferencesWindow.vala"
			_tmp28_ = plank_docklet_get_name (_tmp27_);
#line 421 "Widgets/PreferencesWindow.vala"
			_tmp29_ = docklet;
#line 421 "Widgets/PreferencesWindow.vala"
			_tmp30_ = plank_docklet_get_description (_tmp29_);
#line 421 "Widgets/PreferencesWindow.vala"
			_tmp31_ = docklet;
#line 421 "Widgets/PreferencesWindow.vala"
			_tmp32_ = plank_docklet_get_icon (_tmp31_);
#line 421 "Widgets/PreferencesWindow.vala"
			_tmp33_ = pixbuf;
#line 421 "Widgets/PreferencesWindow.vala"
			plank_docklet_view_model_add (_tmp24_, _tmp26_, _tmp28_, _tmp30_, _tmp32_, _tmp33_);
#line 419 "Widgets/PreferencesWindow.vala"
			_g_object_unref0 (pixbuf);
#line 419 "Widgets/PreferencesWindow.vala"
			_g_object_unref0 (docklet);
#line 2630 "PreferencesWindow.c"
		}
#line 419 "Widgets/PreferencesWindow.vala"
		_g_object_unref0 (_docklet_it);
#line 2634 "PreferencesWindow.c"
	}
#line 424 "Widgets/PreferencesWindow.vala"
	_tmp34_ = sorted_docklets;
#line 424 "Widgets/PreferencesWindow.vala"
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp34_, (gint) PLANK_DOCKLET_VIEW_MODEL_COLUMN_NAME, GTK_SORT_ASCENDING);
#line 425 "Widgets/PreferencesWindow.vala"
	_tmp35_ = self->priv->view_docklets;
#line 425 "Widgets/PreferencesWindow.vala"
	_tmp36_ = sorted_docklets;
#line 425 "Widgets/PreferencesWindow.vala"
	gtk_icon_view_set_model (_tmp35_, (GtkTreeModel*) _tmp36_);
#line 406 "Widgets/PreferencesWindow.vala"
	_g_object_unref0 (sorted_docklets);
#line 406 "Widgets/PreferencesWindow.vala"
	_g_object_unref0 (model_docklets);
#line 2650 "PreferencesWindow.c"
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 435 "Widgets/PreferencesWindow.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 2658 "PreferencesWindow.c"
}

static void
__vala_GtkTreePath_free0_ (gpointer var)
{
#line 435 "Widgets/PreferencesWindow.vala"
	(var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL));
#line 2666 "PreferencesWindow.c"
}

static inline void
_g_list_free___vala_GtkTreePath_free0_ (GList* self)
{
#line 435 "Widgets/PreferencesWindow.vala"
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreePath_free0_);
#line 2674 "PreferencesWindow.c"
}

static GtkTreePath*
_vala_GtkTreePath_copy (GtkTreePath* self)
{
#line 440 "Widgets/PreferencesWindow.vala"
	return g_boxed_copy (gtk_tree_path_get_type (), self);
#line 2682 "PreferencesWindow.c"
}

static gpointer
__vala_GtkTreePath_copy0 (gpointer self)
{
#line 440 "Widgets/PreferencesWindow.vala"
	return self ? _vala_GtkTreePath_copy (self) : NULL;
#line 2690 "PreferencesWindow.c"
}

static void
plank_preferences_window_view_drag_begin (GtkWidget* widget,
                                          GdkDragContext* context,
                                          PlankPreferencesWindow* self)
{
	GtkIconView* view = NULL;
	GList* selection = NULL;
	GtkIconView* _tmp0_;
	GList* _tmp1_;
	GList* path_list = NULL;
	GList* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
	GtkTreeModel* model = NULL;
	GtkIconView* _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeIter iter = {0};
	GValue val = {0};
	GtkTreePath* path = NULL;
	GList* _tmp7_;
	gconstpointer _tmp8_;
	GtkTreePath* _tmp9_;
	GtkTreeModel* _tmp10_;
	GtkTreePath* _tmp11_;
	GtkTreeIter _tmp12_ = {0};
	GtkTreeModel* _tmp13_;
	GtkTreeIter _tmp14_;
	GValue _tmp15_ = {0};
	gchar* icon_name = NULL;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gint icon_size = 0;
	PlankDockPreferences* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint window_scale_factor = 0;
	GdkWindow* _tmp21_;
	cairo_surface_t* surface = NULL;
	const gchar* _tmp22_;
	cairo_surface_t* _tmp23_;
	cairo_surface_t* _tmp24_;
	cairo_surface_t* _tmp25_;
#line 429 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 429 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 429 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (context != NULL);
#line 431 "Widgets/PreferencesWindow.vala"
	view = G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_icon_view_get_type (), GtkIconView);
#line 432 "Widgets/PreferencesWindow.vala"
	_tmp0_ = view;
#line 432 "Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_icon_view_get_selected_items (_tmp0_);
#line 432 "Widgets/PreferencesWindow.vala"
	selection = _tmp1_;
#line 433 "Widgets/PreferencesWindow.vala"
	_tmp2_ = selection;
#line 433 "Widgets/PreferencesWindow.vala"
	_tmp3_ = g_list_first (_tmp2_);
#line 433 "Widgets/PreferencesWindow.vala"
	path_list = _tmp3_;
#line 434 "Widgets/PreferencesWindow.vala"
	_tmp4_ = path_list;
#line 434 "Widgets/PreferencesWindow.vala"
	if (_tmp4_ == NULL) {
#line 435 "Widgets/PreferencesWindow.vala"
		(selection == NULL) ? NULL : (selection = (_g_list_free___vala_GtkTreePath_free0_ (selection), NULL));
#line 435 "Widgets/PreferencesWindow.vala"
		return;
#line 2763 "PreferencesWindow.c"
	}
#line 437 "Widgets/PreferencesWindow.vala"
	_tmp5_ = view;
#line 437 "Widgets/PreferencesWindow.vala"
	_tmp6_ = gtk_icon_view_get_model (_tmp5_);
#line 437 "Widgets/PreferencesWindow.vala"
	model = _tmp6_;
#line 440 "Widgets/PreferencesWindow.vala"
	_tmp7_ = path_list;
#line 440 "Widgets/PreferencesWindow.vala"
	_tmp8_ = _tmp7_->data;
#line 440 "Widgets/PreferencesWindow.vala"
	_tmp9_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) _tmp8_);
#line 440 "Widgets/PreferencesWindow.vala"
	path = _tmp9_;
#line 441 "Widgets/PreferencesWindow.vala"
	_tmp10_ = model;
#line 441 "Widgets/PreferencesWindow.vala"
	_tmp11_ = path;
#line 441 "Widgets/PreferencesWindow.vala"
	gtk_tree_model_get_iter (_tmp10_, &_tmp12_, _tmp11_);
#line 441 "Widgets/PreferencesWindow.vala"
	iter = _tmp12_;
#line 442 "Widgets/PreferencesWindow.vala"
	_tmp13_ = model;
#line 442 "Widgets/PreferencesWindow.vala"
	_tmp14_ = iter;
#line 442 "Widgets/PreferencesWindow.vala"
	gtk_tree_model_get_value (_tmp13_, &_tmp14_, (gint) PLANK_DOCKLET_VIEW_MODEL_COLUMN_ICON, &_tmp15_);
#line 442 "Widgets/PreferencesWindow.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 442 "Widgets/PreferencesWindow.vala"
	val = _tmp15_;
#line 444 "Widgets/PreferencesWindow.vala"
	_tmp16_ = g_value_get_string (&val);
#line 444 "Widgets/PreferencesWindow.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 444 "Widgets/PreferencesWindow.vala"
	icon_name = _tmp17_;
#line 445 "Widgets/PreferencesWindow.vala"
	_tmp18_ = self->priv->prefs;
#line 445 "Widgets/PreferencesWindow.vala"
	_tmp19_ = plank_dock_preferences_get_IconSize (_tmp18_);
#line 445 "Widgets/PreferencesWindow.vala"
	_tmp20_ = _tmp19_;
#line 445 "Widgets/PreferencesWindow.vala"
	icon_size = _tmp20_;
#line 446 "Widgets/PreferencesWindow.vala"
	_tmp21_ = gtk_widget_get_window ((GtkWidget*) self);
#line 446 "Widgets/PreferencesWindow.vala"
	window_scale_factor = gdk_window_get_scale_factor (_tmp21_);
#line 447 "Widgets/PreferencesWindow.vala"
	icon_size *= window_scale_factor;
#line 448 "Widgets/PreferencesWindow.vala"
	_tmp22_ = icon_name;
#line 448 "Widgets/PreferencesWindow.vala"
	_tmp23_ = plank_drawing_service_load_icon_for_scale (_tmp22_, icon_size, icon_size, window_scale_factor);
#line 448 "Widgets/PreferencesWindow.vala"
	surface = _tmp23_;
#line 449 "Widgets/PreferencesWindow.vala"
	_tmp24_ = surface;
#line 449 "Widgets/PreferencesWindow.vala"
	cairo_surface_set_device_offset (_tmp24_, (-icon_size) / 2.0, (-icon_size) / 2.0);
#line 450 "Widgets/PreferencesWindow.vala"
	_tmp25_ = surface;
#line 450 "Widgets/PreferencesWindow.vala"
	gtk_drag_set_icon_surface (context, _tmp25_);
#line 429 "Widgets/PreferencesWindow.vala"
	_cairo_surface_destroy0 (surface);
#line 429 "Widgets/PreferencesWindow.vala"
	_g_free0 (icon_name);
#line 429 "Widgets/PreferencesWindow.vala"
	__vala_GtkTreePath_free0 (path);
#line 429 "Widgets/PreferencesWindow.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 429 "Widgets/PreferencesWindow.vala"
	(selection == NULL) ? NULL : (selection = (_g_list_free___vala_GtkTreePath_free0_ (selection), NULL));
#line 2841 "PreferencesWindow.c"
}

static void
plank_preferences_window_view_item_activated (GtkIconView* view,
                                              GtkTreePath* path,
                                              PlankPreferencesWindow* self)
{
	PlankApplicationDockItemProvider* provider = NULL;
	PlankDockController* _tmp0_;
	PlankDockItemProvider* _tmp1_;
	PlankDockItemProvider* _tmp2_;
	PlankApplicationDockItemProvider* _tmp3_;
	GtkTreeModel* model = NULL;
	GtkTreeModel* _tmp4_;
	GtkTreeIter iter = {0};
	GValue val = {0};
	GtkTreeModel* _tmp5_;
	GtkTreeIter _tmp6_ = {0};
	GtkTreeModel* _tmp7_;
	GtkTreeIter _tmp8_;
	GValue _tmp9_ = {0};
	gchar* uri = NULL;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	PlankApplicationDockItemProvider* _tmp13_;
	const gchar* _tmp14_;
#line 454 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 454 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (view != NULL);
#line 454 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (path != NULL);
#line 456 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 456 "Widgets/PreferencesWindow.vala"
	_tmp1_ = plank_dock_controller_get_default_provider (_tmp0_);
#line 456 "Widgets/PreferencesWindow.vala"
	_tmp2_ = _tmp1_;
#line 456 "Widgets/PreferencesWindow.vala"
	provider = PLANK_IS_APPLICATION_DOCK_ITEM_PROVIDER (_tmp2_) ? ((PlankApplicationDockItemProvider*) _tmp2_) : NULL;
#line 457 "Widgets/PreferencesWindow.vala"
	_tmp3_ = provider;
#line 457 "Widgets/PreferencesWindow.vala"
	if (_tmp3_ == NULL) {
#line 458 "Widgets/PreferencesWindow.vala"
		return;
#line 2889 "PreferencesWindow.c"
	}
#line 460 "Widgets/PreferencesWindow.vala"
	_tmp4_ = gtk_icon_view_get_model (view);
#line 460 "Widgets/PreferencesWindow.vala"
	model = _tmp4_;
#line 463 "Widgets/PreferencesWindow.vala"
	_tmp5_ = model;
#line 463 "Widgets/PreferencesWindow.vala"
	gtk_tree_model_get_iter (_tmp5_, &_tmp6_, path);
#line 463 "Widgets/PreferencesWindow.vala"
	iter = _tmp6_;
#line 464 "Widgets/PreferencesWindow.vala"
	_tmp7_ = model;
#line 464 "Widgets/PreferencesWindow.vala"
	_tmp8_ = iter;
#line 464 "Widgets/PreferencesWindow.vala"
	gtk_tree_model_get_value (_tmp7_, &_tmp8_, (gint) PLANK_DOCKLET_VIEW_MODEL_COLUMN_ID, &_tmp9_);
#line 464 "Widgets/PreferencesWindow.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 464 "Widgets/PreferencesWindow.vala"
	val = _tmp9_;
#line 466 "Widgets/PreferencesWindow.vala"
	_tmp10_ = g_value_get_string (&val);
#line 466 "Widgets/PreferencesWindow.vala"
	_tmp11_ = g_strdup_printf ("%s%s", PLANK_DOCKLET_URI_PREFIX, _tmp10_);
#line 466 "Widgets/PreferencesWindow.vala"
	uri = _tmp11_;
#line 467 "Widgets/PreferencesWindow.vala"
	_tmp12_ = uri;
#line 467 "Widgets/PreferencesWindow.vala"
	g_debug ("PreferencesWindow.vala:467: Try to add docklet for '%s'", _tmp12_);
#line 468 "Widgets/PreferencesWindow.vala"
	_tmp13_ = provider;
#line 468 "Widgets/PreferencesWindow.vala"
	_tmp14_ = uri;
#line 468 "Widgets/PreferencesWindow.vala"
	plank_dock_item_provider_add_item_with_uri ((PlankDockItemProvider*) _tmp13_, _tmp14_, NULL);
#line 454 "Widgets/PreferencesWindow.vala"
	_g_free0 (uri);
#line 454 "Widgets/PreferencesWindow.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 2931 "PreferencesWindow.c"
}

PlankDockController*
plank_preferences_window_get_controller (PlankPreferencesWindow* self)
{
	PlankDockController* result;
	PlankDockController* _tmp0_;
#line 28 "Widgets/PreferencesWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 28 "Widgets/PreferencesWindow.vala"
	result = _tmp0_;
#line 28 "Widgets/PreferencesWindow.vala"
	return result;
#line 2947 "PreferencesWindow.c"
}

void
plank_preferences_window_set_controller (PlankPreferencesWindow* self,
                                         PlankDockController* value)
{
	PlankDockController* old_value;
#line 28 "Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 28 "Widgets/PreferencesWindow.vala"
	old_value = plank_preferences_window_get_controller (self);
#line 28 "Widgets/PreferencesWindow.vala"
	if (old_value != value) {
#line 2961 "PreferencesWindow.c"
		PlankDockController* _tmp0_;
#line 28 "Widgets/PreferencesWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 28 "Widgets/PreferencesWindow.vala"
		_g_object_unref0 (self->priv->_controller);
#line 28 "Widgets/PreferencesWindow.vala"
		self->priv->_controller = _tmp0_;
#line 28 "Widgets/PreferencesWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_preferences_window_properties[PLANK_PREFERENCES_WINDOW_CONTROLLER_PROPERTY]);
#line 2971 "PreferencesWindow.c"
	}
}

static void
_plank_preferences_window_controller_changed_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
#line 98 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_controller_changed ((PlankPreferencesWindow*) self);
#line 2982 "PreferencesWindow.c"
}

static GObject *
plank_preferences_window_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankPreferencesWindow * self;
	gchar* title = NULL;
	gchar* _tmp0_;
	PlankDockController* _tmp1_;
	PlankDockPreferences* _tmp2_;
	PlankDockPreferences* _tmp3_;
	PlankDockPreferences* _tmp4_;
#line 88 "Widgets/PreferencesWindow.vala"
	parent_class = G_OBJECT_CLASS (plank_preferences_window_parent_class);
#line 88 "Widgets/PreferencesWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 88 "Widgets/PreferencesWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_PREFERENCES_WINDOW, PlankPreferencesWindow);
#line 90 "Widgets/PreferencesWindow.vala"
	_tmp0_ = g_strdup (_ ("Preferences"));
#line 90 "Widgets/PreferencesWindow.vala"
	title = _tmp0_;
#line 92 "Widgets/PreferencesWindow.vala"
	_tmp1_ = self->priv->_controller;
#line 92 "Widgets/PreferencesWindow.vala"
	_tmp2_ = plank_dock_controller_get_prefs (_tmp1_);
#line 92 "Widgets/PreferencesWindow.vala"
	_tmp3_ = _tmp2_;
#line 92 "Widgets/PreferencesWindow.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 92 "Widgets/PreferencesWindow.vala"
	_g_object_unref0 (self->priv->prefs);
#line 92 "Widgets/PreferencesWindow.vala"
	self->priv->prefs = _tmp4_;
#line 94 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_init_dock_tab (self);
#line 95 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_init_docklets_tab (self);
#line 96 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_connect_signals (self);
#line 98 "Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GObject*) self, "notify::controller", (GCallback) _plank_preferences_window_controller_changed_g_object_notify, self, 0);
#line 88 "Widgets/PreferencesWindow.vala"
	_g_free0 (title);
#line 88 "Widgets/PreferencesWindow.vala"
	return obj;
#line 3033 "PreferencesWindow.c"
}

static void
plank_preferences_window_class_init (PlankPreferencesWindowClass * klass,
                                     gpointer klass_data)
{
#line 23 "Widgets/PreferencesWindow.vala"
	plank_preferences_window_parent_class = g_type_class_peek_parent (klass);
#line 23 "Widgets/PreferencesWindow.vala"
	g_type_class_adjust_private_offset (klass, &PlankPreferencesWindow_private_offset);
#line 23 "Widgets/PreferencesWindow.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) plank_preferences_window_real_key_press_event;
#line 23 "Widgets/PreferencesWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_preferences_window_get_property;
#line 23 "Widgets/PreferencesWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_preferences_window_set_property;
#line 23 "Widgets/PreferencesWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_preferences_window_constructor;
#line 23 "Widgets/PreferencesWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_preferences_window_finalize;
#line 3054 "PreferencesWindow.c"
	/**
	 * The controller for this dock.
	 */
#line 23 "Widgets/PreferencesWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_PREFERENCES_WINDOW_CONTROLLER_PROPERTY, plank_preferences_window_properties[PLANK_PREFERENCES_WINDOW_CONTROLLER_PROPERTY] = g_param_spec_object ("controller", "controller", "controller", PLANK_TYPE_DOCK_CONTROLLER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/net/launchpad/plank/ui/preferences.ui");
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cb_theme", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, cb_theme));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cb_hidemode", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, cb_hidemode));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cb_display_plug", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, cb_display_plug));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cb_position", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, cb_position));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cb_alignment", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, cb_alignment));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cb_items_alignment", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, cb_items_alignment));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sp_hide_delay", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, sp_hide_delay));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sp_unhide_delay", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, sp_unhide_delay));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "s_offset", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, s_offset));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "s_zoom_percent", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, s_zoom_percent));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "adj_hide_delay", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, adj_hide_delay));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "adj_unhide_delay", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, adj_unhide_delay));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "adj_iconsize", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, adj_iconsize));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "adj_offset", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, adj_offset));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "adj_zoom_percent", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, adj_zoom_percent));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sw_hide", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, sw_hide));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sw_primary_display", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, sw_primary_display));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sw_workspace_only", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, sw_workspace_only));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sw_show_unpinned", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, sw_show_unpinned));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sw_lock_items", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, sw_lock_items));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sw_pressure_reveal", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, sw_pressure_reveal));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sw_zoom_enabled", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, sw_zoom_enabled));
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "view_docklets", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, view_docklets));
#line 3108 "PreferencesWindow.c"
}

static void
plank_preferences_window_instance_init (PlankPreferencesWindow * self,
                                        gpointer klass)
{
#line 23 "Widgets/PreferencesWindow.vala"
	self->priv = plank_preferences_window_get_instance_private (self);
#line 23 "Widgets/PreferencesWindow.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 3119 "PreferencesWindow.c"
}

static void
plank_preferences_window_finalize (GObject * obj)
{
	PlankPreferencesWindow * self;
#line 23 "Widgets/PreferencesWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_PREFERENCES_WINDOW, PlankPreferencesWindow);
#line 28 "Widgets/PreferencesWindow.vala"
	_g_object_unref0 (self->priv->_controller);
#line 30 "Widgets/PreferencesWindow.vala"
	_g_object_unref0 (self->priv->prefs);
#line 23 "Widgets/PreferencesWindow.vala"
	G_OBJECT_CLASS (plank_preferences_window_parent_class)->finalize (obj);
#line 3134 "PreferencesWindow.c"
}

static GType
plank_preferences_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankPreferencesWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_preferences_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankPreferencesWindow), 0, (GInstanceInitFunc) plank_preferences_window_instance_init, NULL };
	GType plank_preferences_window_type_id;
	plank_preferences_window_type_id = g_type_register_static (gtk_window_get_type (), "PlankPreferencesWindow", &g_define_type_info, 0);
	PlankPreferencesWindow_private_offset = g_type_add_instance_private (plank_preferences_window_type_id, sizeof (PlankPreferencesWindowPrivate));
	return plank_preferences_window_type_id;
}

GType
plank_preferences_window_get_type (void)
{
	static volatile gsize plank_preferences_window_type_id__once = 0;
	if (g_once_init_enter (&plank_preferences_window_type_id__once)) {
		GType plank_preferences_window_type_id;
		plank_preferences_window_type_id = plank_preferences_window_get_type_once ();
		g_once_init_leave (&plank_preferences_window_type_id__once, plank_preferences_window_type_id);
	}
	return plank_preferences_window_type_id__once;
}

static void
_vala_plank_preferences_window_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	PlankPreferencesWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_PREFERENCES_WINDOW, PlankPreferencesWindow);
#line 23 "Widgets/PreferencesWindow.vala"
	switch (property_id) {
#line 23 "Widgets/PreferencesWindow.vala"
		case PLANK_PREFERENCES_WINDOW_CONTROLLER_PROPERTY:
#line 23 "Widgets/PreferencesWindow.vala"
		g_value_set_object (value, plank_preferences_window_get_controller (self));
#line 23 "Widgets/PreferencesWindow.vala"
		break;
#line 3175 "PreferencesWindow.c"
		default:
#line 23 "Widgets/PreferencesWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "Widgets/PreferencesWindow.vala"
		break;
#line 3181 "PreferencesWindow.c"
	}
}

static void
_vala_plank_preferences_window_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	PlankPreferencesWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_PREFERENCES_WINDOW, PlankPreferencesWindow);
#line 23 "Widgets/PreferencesWindow.vala"
	switch (property_id) {
#line 23 "Widgets/PreferencesWindow.vala"
		case PLANK_PREFERENCES_WINDOW_CONTROLLER_PROPERTY:
#line 23 "Widgets/PreferencesWindow.vala"
		plank_preferences_window_set_controller (self, g_value_get_object (value));
#line 23 "Widgets/PreferencesWindow.vala"
		break;
#line 3201 "PreferencesWindow.c"
		default:
#line 23 "Widgets/PreferencesWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "Widgets/PreferencesWindow.vala"
		break;
#line 3207 "PreferencesWindow.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 114 "Services/EnvironmentSettings.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 3218 "PreferencesWindow.c"
		gssize i;
#line 114 "Services/EnvironmentSettings.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 114 "Services/EnvironmentSettings.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 114 "Services/EnvironmentSettings.vala"
				destroy_func (((gpointer*) array)[i]);
#line 3226 "PreferencesWindow.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 114 "Services/EnvironmentSettings.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 114 "Services/EnvironmentSettings.vala"
	g_free (array);
#line 3241 "PreferencesWindow.c"
}

