/* DockRenderer.c generated by valac 0.56.18, the Vala compiler
 * generated from DockRenderer.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <glib-object.h>
#include <cairo-gobject.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include "plank-internal.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PLANK_DOCK_RENDERER_0_PROPERTY,
	PLANK_DOCK_RENDERER_CONTROLLER_PROPERTY,
	PLANK_DOCK_RENDERER_THEME_PROPERTY,
	PLANK_DOCK_RENDERER_HIDE_PROGRESS_PROPERTY,
	PLANK_DOCK_RENDERER_ZOOM_IN_PROGRESS_PROPERTY,
	PLANK_DOCK_RENDERER_NUM_PROPERTIES
};
static GParamSpec* plank_dock_renderer_properties[PLANK_DOCK_RENDERER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define PLANK_TYPE_ENVIRONMENT_SETTINGS (plank_environment_settings_get_type ())
#define PLANK_ENVIRONMENT_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_ENVIRONMENT_SETTINGS, PlankEnvironmentSettings))
#define PLANK_ENVIRONMENT_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_ENVIRONMENT_SETTINGS, PlankEnvironmentSettingsClass))
#define PLANK_IS_ENVIRONMENT_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_ENVIRONMENT_SETTINGS))
#define PLANK_IS_ENVIRONMENT_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_ENVIRONMENT_SETTINGS))
#define PLANK_ENVIRONMENT_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_ENVIRONMENT_SETTINGS, PlankEnvironmentSettingsClass))

typedef struct _PlankEnvironmentSettings PlankEnvironmentSettings;
typedef struct _PlankEnvironmentSettingsClass PlankEnvironmentSettingsClass;
typedef struct _Block1Data Block1Data;
#define _plank_dock_item_draw_value_unref0(var) ((var == NULL) ? NULL : (var = (plank_dock_item_draw_value_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PlankDockRendererPrivate {
	PlankDockController* _controller;
	PlankDockTheme* _theme;
	gdouble _hide_progress;
	gdouble _opacity;
	gdouble _zoom_in_progress;
	GdkPoint _local_cursor;
	PlankSurface* main_buffer;
	PlankSurface* fade_buffer;
	PlankSurface* item_buffer;
	PlankSurface* shadow_buffer;
	PlankSurface* background_buffer;
	GdkRectangle background_rect;
	PlankSurface* indicator_buffer;
	PlankSurface* urgent_indicator_buffer;
	PlankSurface* urgent_glow_buffer;
	gint64 last_hide;
	gint64 last_hovered_changed;
	gboolean screen_is_composited;
	gboolean show_notifications;
	guint reset_position_manager_timer_id;
	gint window_scale_factor;
	gboolean is_first_frame;
	gboolean zoom_changed;
	gulong gtk_theme_name_changed_handler_id;
	gdouble dynamic_animation_offset;
	GeeArrayList* current_items;
	GeeHashSet* transient_items;
};

struct _Block1Data {
	int _ref_count_;
	PlankDockRenderer* self;
	gint64 frame_time;
};

struct _Block2Data {
	int _ref_count_;
	PlankDockRenderer* self;
	GtkPositionType position;
	gdouble x_offset;
};

static gint PlankDockRenderer_private_offset;
static gpointer plank_dock_renderer_parent_class = NULL;

static PlankDockController* plank_dock_renderer_get_controller (PlankDockRenderer* self);
static void plank_dock_renderer_prefs_changed (PlankDockRenderer* self,
                                        GObject* prefs,
                                        GParamSpec* prop);
static void _plank_dock_renderer_prefs_changed_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void plank_dock_renderer_theme_changed (PlankDockRenderer* self);
static void _plank_dock_renderer_theme_changed_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void plank_dock_renderer_hidden_changed (PlankDockRenderer* self);
static void _plank_dock_renderer_hidden_changed_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void plank_dock_renderer_hovered_changed (PlankDockRenderer* self);
static void _plank_dock_renderer_hovered_changed_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self);
static void _plank_renderer_animated_draw_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void plank_dock_renderer_reset_position_manager (PlankDockRenderer* self);
static void plank_dock_renderer_load_theme (PlankDockRenderer* self);
static gboolean __lambda45_ (PlankDockRenderer* self);
static void plank_dock_renderer_reset_item_buffers (PlankDockRenderer* self);
static gboolean ___lambda45__gsource_func (gpointer self);
static void _plank_dock_renderer_load_theme_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void plank_dock_renderer_set_theme (PlankDockRenderer* self,
                                    PlankDockTheme* value);
static void plank_dock_renderer_real_initialize_frame (PlankRenderer* base,
                                                gint64 frame_time);
VALA_EXTERN GType plank_environment_settings_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PlankEnvironmentSettings* plank_environment_settings_get_instance (void);
VALA_EXTERN gboolean plank_environment_settings_get_ShowNotifications (PlankEnvironmentSettings* self);
static void plank_dock_renderer_set_hide_progress (PlankDockRenderer* self,
                                            gdouble value);
static void plank_dock_renderer_set_zoom_in_progress (PlankDockRenderer* self,
                                               gdouble value);
static void plank_dock_renderer_set_opacity (PlankDockRenderer* self,
                                      gdouble value);
static gint plank_dock_renderer_compare_dock_item_position (PlankDockItem* i1,
                                                     PlankDockItem* i2);
static void plank_dock_renderer_animate_draw_value_for_item (PlankDockItem* item,
                                                      PlankDockItemDrawValue* draw_value,
                                                      PlankDockRenderer* self);
static void plank_dock_renderer_post_process_draw_values (GeeHashMap* draw_values,
                                                   PlankDockRenderer* self);
static void plank_dock_renderer_real_draw (PlankRenderer* base,
                                    cairo_t* cr,
                                    gint64 frame_time);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gdouble plank_dock_renderer_get_opacity (PlankDockRenderer* self);
static void plank_dock_renderer_draw_urgent_glow (PlankDockRenderer* self,
                                           PlankDockItem* item,
                                           cairo_t* cr,
                                           gint64 frame_time);
static void plank_dock_renderer_draw_dock_background (PlankDockRenderer* self,
                                               cairo_t* cr,
                                               GdkRectangle* background_rect,
                                               gint x_offset,
                                               gint y_offset);
static void plank_dock_renderer_draw_item (PlankDockRenderer* self,
                                    cairo_t* cr,
                                    PlankDockItem* item,
                                    PlankDockItemDrawValue* draw_value,
                                    gint64 frame_time);
static void plank_dock_renderer_draw_item_shadow (PlankDockRenderer* self,
                                           cairo_t* cr,
                                           PlankDockItem* item,
                                           PlankDockItemDrawValue* draw_value);
static const gchar* plank_dock_renderer_cairo_surface_type_to_string (cairo_surface_type_t type);
static gboolean ___lambda47_ (Block1Data* _data1_);
static gboolean ____lambda47__gsource_func (gpointer self);
static gdouble plank_dock_renderer_easing_bounce (gdouble t,
                                           gdouble d,
                                           gdouble n);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean __lambda46_ (Block2Data* _data2_,
                      PlankDockElement* i,
                      PlankDockItemDrawValue* val);
static gboolean ___lambda46__gee_forall_map_func (gconstpointer k,
                                           gconstpointer v,
                                           gpointer self);
static inline PlankSurface* plank_dock_renderer_get_item_surface (PlankDockRenderer* self,
                                                    PlankDockItem* item,
                                                    gint icon_size);
static PlankSurface* plank_dock_renderer_draw_item_foreground (gint width,
                                                        gint height,
                                                        PlankSurface* model,
                                                        PlankDockItem* item,
                                                        PlankDockRenderer* self);
static void plank_dock_renderer_draw_indicator_state (PlankDockRenderer* self,
                                               cairo_t* cr,
                                               GdkRectangle* item_rect,
                                               PlankIndicatorState indicator,
                                               PlankItemState item_state);
static PlankSurface* plank_dock_renderer_draw_item_background (gint width,
                                                        gint height,
                                                        PlankSurface* model,
                                                        PlankDockItem* item,
                                                        PlankDockRenderer* self);
static void plank_dock_renderer_get_styled_color (PlankDockRenderer* self,
                                           PlankColor* result);
static gboolean _gdk_point_equal (const GdkPoint * s1,
                           const GdkPoint * s2);
static void plank_dock_renderer_set_local_cursor (PlankDockRenderer* self,
                                           GdkPoint * value);
static gboolean plank_dock_renderer_real_animation_needed (PlankRenderer* base,
                                                    gint64 frame_time);
static inline gboolean plank_dock_renderer_item_animation_needed (PlankDockRenderer* self,
                                                    PlankDockItem* item,
                                                    gint64 render_time);
static GObject * plank_dock_renderer_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void plank_dock_renderer_finalize (GObject * obj);
static GType plank_dock_renderer_get_type_once (void);
static void _vala_plank_dock_renderer_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_plank_dock_renderer_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
plank_dock_renderer_get_instance_private (PlankDockRenderer* self)
{
	return G_STRUCT_MEMBER_P (self, PlankDockRenderer_private_offset);
}

static void
_plank_dock_renderer_prefs_changed_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 124 "DockRenderer.vala"
	plank_dock_renderer_prefs_changed ((PlankDockRenderer*) self, _sender, pspec);
#line 265 "DockRenderer.c"
}

static void
_plank_dock_renderer_theme_changed_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 125 "DockRenderer.vala"
	plank_dock_renderer_theme_changed ((PlankDockRenderer*) self);
#line 275 "DockRenderer.c"
}

static void
_plank_dock_renderer_hidden_changed_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 127 "DockRenderer.vala"
	plank_dock_renderer_hidden_changed ((PlankDockRenderer*) self);
#line 285 "DockRenderer.c"
}

static void
_plank_dock_renderer_hovered_changed_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self)
{
#line 128 "DockRenderer.vala"
	plank_dock_renderer_hovered_changed ((PlankDockRenderer*) self);
#line 295 "DockRenderer.c"
}

static void
_plank_renderer_animated_draw_g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
#line 129 "DockRenderer.vala"
	plank_renderer_animated_draw ((PlankRenderer*) self);
#line 305 "DockRenderer.c"
}

/**
 * Create a new dock renderer for a dock.
 *
 * @param controller the dock controller to manage drawing for
 * @param window the dock window to be animated
 */
PlankDockRenderer*
plank_dock_renderer_construct (GType object_type,
                               PlankDockController* controller,
                               GtkWindow* window)
{
	PlankDockRenderer * self = NULL;
#line 92 "DockRenderer.vala"
	g_return_val_if_fail (controller != NULL, NULL);
#line 92 "DockRenderer.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 94 "DockRenderer.vala"
	self = (PlankDockRenderer*) g_object_new (object_type, "controller", controller, "widget", window, NULL);
#line 92 "DockRenderer.vala"
	return self;
#line 328 "DockRenderer.c"
}

PlankDockRenderer*
plank_dock_renderer_new (PlankDockController* controller,
                         GtkWindow* window)
{
#line 92 "DockRenderer.vala"
	return plank_dock_renderer_construct (PLANK_TYPE_DOCK_RENDERER, controller, window);
#line 337 "DockRenderer.c"
}

/**
 * Initializes the renderer.  Call after the DockWindow is constructed.
 */
void
plank_dock_renderer_initialize (PlankDockRenderer* self)
{
	PlankDockController* _tmp0_;
	PlankDockWindow* _tmp1_;
	PlankDockWindow* _tmp2_;
	PlankDockController* _tmp3_;
	PlankPositionManager* _tmp4_;
	PlankPositionManager* _tmp5_;
	PlankDockTheme* _tmp6_;
	PlankDockController* _tmp7_;
	PlankDockWindow* _tmp8_;
	PlankDockWindow* _tmp9_;
	PlankDockController* _tmp10_;
	PlankHideManager* _tmp11_;
	PlankHideManager* _tmp12_;
	PlankDockController* _tmp13_;
	PlankHideManager* _tmp14_;
	PlankHideManager* _tmp15_;
#line 112 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 112 "DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 112 "DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_window (_tmp0_);
#line 112 "DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 112 "DockRenderer.vala"
	_vala_return_if_fail (_tmp2_ != NULL, "controller.window != null");
#line 115 "DockRenderer.vala"
	_tmp3_ = self->priv->_controller;
#line 115 "DockRenderer.vala"
	_tmp4_ = plank_dock_controller_get_position_manager (_tmp3_);
#line 115 "DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 115 "DockRenderer.vala"
	_tmp6_ = self->priv->_theme;
#line 115 "DockRenderer.vala"
	plank_position_manager_update (_tmp5_, _tmp6_);
#line 117 "DockRenderer.vala"
	_tmp7_ = self->priv->_controller;
#line 117 "DockRenderer.vala"
	_tmp8_ = plank_dock_controller_get_window (_tmp7_);
#line 117 "DockRenderer.vala"
	_tmp9_ = _tmp8_;
#line 117 "DockRenderer.vala"
	g_signal_connect_object ((GObject*) _tmp9_, "notify::HoveredItem", (GCallback) _plank_renderer_animated_draw_g_object_notify, (PlankRenderer*) self, 0);
#line 118 "DockRenderer.vala"
	_tmp10_ = self->priv->_controller;
#line 118 "DockRenderer.vala"
	_tmp11_ = plank_dock_controller_get_hide_manager (_tmp10_);
#line 118 "DockRenderer.vala"
	_tmp12_ = _tmp11_;
#line 118 "DockRenderer.vala"
	g_signal_connect_object ((GObject*) _tmp12_, "notify::Hidden", (GCallback) _plank_dock_renderer_hidden_changed_g_object_notify, self, 0);
#line 119 "DockRenderer.vala"
	_tmp13_ = self->priv->_controller;
#line 119 "DockRenderer.vala"
	_tmp14_ = plank_dock_controller_get_hide_manager (_tmp13_);
#line 119 "DockRenderer.vala"
	_tmp15_ = _tmp14_;
#line 119 "DockRenderer.vala"
	g_signal_connect_object ((GObject*) _tmp15_, "notify::Hovered", (GCallback) _plank_dock_renderer_hovered_changed_g_object_notify, self, 0);
#line 406 "DockRenderer.c"
}

static void
plank_dock_renderer_prefs_changed (PlankDockRenderer* self,
                                   GObject* prefs,
                                   GParamSpec* prop)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 134 "DockRenderer.vala"
	static GQuark _tmp2_label0 = 0;
#line 134 "DockRenderer.vala"
	static GQuark _tmp2_label1 = 0;
#line 134 "DockRenderer.vala"
	static GQuark _tmp2_label2 = 0;
#line 134 "DockRenderer.vala"
	static GQuark _tmp2_label3 = 0;
#line 134 "DockRenderer.vala"
	static GQuark _tmp2_label4 = 0;
#line 134 "DockRenderer.vala"
	static GQuark _tmp2_label5 = 0;
#line 132 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 132 "DockRenderer.vala"
	g_return_if_fail (prefs != NULL);
#line 132 "DockRenderer.vala"
	g_return_if_fail (prop != NULL);
#line 134 "DockRenderer.vala"
	_tmp0_ = prop->name;
#line 134 "DockRenderer.vala"
	_tmp1_ = _tmp0_;
#line 134 "DockRenderer.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 134 "DockRenderer.vala"
	if (((((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("Alignment")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("IconSize"))))) || (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("ItemsAlignment"))))) || (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("Offset"))))) || (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("Position"))))) {
#line 134 "DockRenderer.vala"
		switch (0) {
#line 445 "DockRenderer.c"
			default:
			{
#line 140 "DockRenderer.vala"
				plank_dock_renderer_reset_position_manager (self);
#line 141 "DockRenderer.vala"
				break;
#line 452 "DockRenderer.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("Theme")))) {
#line 134 "DockRenderer.vala"
		switch (0) {
#line 458 "DockRenderer.c"
			default:
			{
#line 143 "DockRenderer.vala"
				plank_dock_renderer_load_theme (self);
#line 144 "DockRenderer.vala"
				break;
#line 465 "DockRenderer.c"
			}
		}
	} else {
#line 134 "DockRenderer.vala"
		switch (0) {
#line 471 "DockRenderer.c"
			default:
			{
#line 147 "DockRenderer.vala"
				break;
#line 476 "DockRenderer.c"
			}
		}
	}
}

static void
plank_dock_renderer_theme_changed (PlankDockRenderer* self)
{
#line 151 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 153 "DockRenderer.vala"
	plank_dock_renderer_reset_position_manager (self);
#line 489 "DockRenderer.c"
}

static gboolean
__lambda45_ (PlankDockRenderer* self)
{
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	PlankDockTheme* _tmp3_;
	gboolean result;
#line 165 "DockRenderer.vala"
	self->priv->reset_position_manager_timer_id = 0U;
#line 167 "DockRenderer.vala"
	plank_dock_renderer_reset_buffers (self);
#line 168 "DockRenderer.vala"
	plank_dock_renderer_reset_item_buffers (self);
#line 169 "DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 169 "DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 169 "DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 169 "DockRenderer.vala"
	_tmp3_ = self->priv->_theme;
#line 169 "DockRenderer.vala"
	plank_position_manager_update (_tmp2_, _tmp3_);
#line 171 "DockRenderer.vala"
	result = FALSE;
#line 171 "DockRenderer.vala"
	return result;
#line 520 "DockRenderer.c"
}

static gboolean
___lambda45__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda45_ ((PlankDockRenderer*) self);
#line 164 "DockRenderer.vala"
	return result;
#line 530 "DockRenderer.c"
}

static void
plank_dock_renderer_reset_position_manager (PlankDockRenderer* self)
{
#line 156 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 161 "DockRenderer.vala"
	if (self->priv->reset_position_manager_timer_id > 0U) {
#line 162 "DockRenderer.vala"
		g_source_remove (self->priv->reset_position_manager_timer_id);
#line 542 "DockRenderer.c"
	}
#line 164 "DockRenderer.vala"
	self->priv->reset_position_manager_timer_id = gdk_threads_add_timeout ((guint) 50, ___lambda45__gsource_func, self);
#line 546 "DockRenderer.c"
}

static void
_plank_dock_renderer_load_theme_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
#line 185 "DockRenderer.vala"
	plank_dock_renderer_load_theme ((PlankDockRenderer*) self);
#line 556 "DockRenderer.c"
}

static void
plank_dock_renderer_load_theme (PlankDockRenderer* self)
{
	gboolean is_reload = FALSE;
	PlankDockTheme* _tmp0_;
	const gchar* name = NULL;
	PlankDockController* _tmp3_;
	PlankDockPreferences* _tmp4_;
	PlankDockPreferences* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp12_;
	PlankDockTheme* _tmp13_;
	PlankDockTheme* _tmp14_;
	PlankDockTheme* _tmp15_;
	PlankDockTheme* _tmp16_;
#line 175 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 177 "DockRenderer.vala"
	_tmp0_ = self->priv->_theme;
#line 177 "DockRenderer.vala"
	is_reload = _tmp0_ != NULL;
#line 179 "DockRenderer.vala"
	if (is_reload) {
#line 584 "DockRenderer.c"
		PlankDockTheme* _tmp1_;
		guint _tmp2_;
#line 180 "DockRenderer.vala"
		_tmp1_ = self->priv->_theme;
#line 180 "DockRenderer.vala"
		g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp2_, NULL, FALSE);
#line 180 "DockRenderer.vala"
		g_signal_handlers_disconnect_matched ((GObject*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _plank_dock_renderer_theme_changed_g_object_notify, self);
#line 593 "DockRenderer.c"
	}
#line 182 "DockRenderer.vala"
	_tmp3_ = self->priv->_controller;
#line 182 "DockRenderer.vala"
	_tmp4_ = plank_dock_controller_get_prefs (_tmp3_);
#line 182 "DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 182 "DockRenderer.vala"
	_tmp6_ = plank_dock_preferences_get_Theme (_tmp5_);
#line 182 "DockRenderer.vala"
	_tmp7_ = _tmp6_;
#line 182 "DockRenderer.vala"
	name = _tmp7_;
#line 183 "DockRenderer.vala"
	_tmp8_ = name;
#line 183 "DockRenderer.vala"
	if (g_strcmp0 (_tmp8_, PLANK_THEME_GTK_THEME_NAME) == 0) {
#line 184 "DockRenderer.vala"
		if (self->priv->gtk_theme_name_changed_handler_id == 0UL) {
#line 613 "DockRenderer.c"
			GtkSettings* _tmp9_;
			gulong _tmp10_;
#line 185 "DockRenderer.vala"
			_tmp9_ = gtk_settings_get_default ();
#line 185 "DockRenderer.vala"
			_tmp10_ = g_signal_connect_object ((GObject*) _tmp9_, "notify::gtk-theme-name", (GCallback) _plank_dock_renderer_load_theme_g_object_notify, self, 0);
#line 185 "DockRenderer.vala"
			self->priv->gtk_theme_name_changed_handler_id = _tmp10_;
#line 622 "DockRenderer.c"
		}
	} else {
#line 186 "DockRenderer.vala"
		if (self->priv->gtk_theme_name_changed_handler_id > 0UL) {
#line 627 "DockRenderer.c"
			GtkSettings* _tmp11_;
#line 187 "DockRenderer.vala"
			_tmp11_ = gtk_settings_get_default ();
#line 187 "DockRenderer.vala"
			g_signal_handler_disconnect (_tmp11_, self->priv->gtk_theme_name_changed_handler_id);
#line 188 "DockRenderer.vala"
			self->priv->gtk_theme_name_changed_handler_id = 0UL;
#line 635 "DockRenderer.c"
		}
	}
#line 191 "DockRenderer.vala"
	_tmp12_ = name;
#line 191 "DockRenderer.vala"
	_tmp13_ = plank_dock_theme_new (_tmp12_);
#line 191 "DockRenderer.vala"
	_tmp14_ = _tmp13_;
#line 191 "DockRenderer.vala"
	plank_dock_renderer_set_theme (self, _tmp14_);
#line 191 "DockRenderer.vala"
	_g_object_unref0 (_tmp14_);
#line 192 "DockRenderer.vala"
	_tmp15_ = self->priv->_theme;
#line 192 "DockRenderer.vala"
	plank_theme_load ((PlankTheme*) _tmp15_, "dock");
#line 193 "DockRenderer.vala"
	_tmp16_ = self->priv->_theme;
#line 193 "DockRenderer.vala"
	g_signal_connect_object ((GObject*) _tmp16_, "notify", (GCallback) _plank_dock_renderer_theme_changed_g_object_notify, self, 0);
#line 195 "DockRenderer.vala"
	if (is_reload) {
#line 196 "DockRenderer.vala"
		plank_dock_renderer_theme_changed (self);
#line 660 "DockRenderer.c"
	}
}

/**
 * Resets all internal buffers and forces a redraw.
 */
void
plank_dock_renderer_reset_buffers (PlankDockRenderer* self)
{
#line 202 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 204 "DockRenderer.vala"
	plank_logger_verbose ("DockRenderer.reset_buffers ()", NULL);
#line 206 "DockRenderer.vala"
	_g_object_unref0 (self->priv->main_buffer);
#line 206 "DockRenderer.vala"
	self->priv->main_buffer = NULL;
#line 207 "DockRenderer.vala"
	_g_object_unref0 (self->priv->fade_buffer);
#line 207 "DockRenderer.vala"
	self->priv->fade_buffer = NULL;
#line 208 "DockRenderer.vala"
	_g_object_unref0 (self->priv->item_buffer);
#line 208 "DockRenderer.vala"
	self->priv->item_buffer = NULL;
#line 209 "DockRenderer.vala"
	_g_object_unref0 (self->priv->shadow_buffer);
#line 209 "DockRenderer.vala"
	self->priv->shadow_buffer = NULL;
#line 211 "DockRenderer.vala"
	_g_object_unref0 (self->priv->background_buffer);
#line 211 "DockRenderer.vala"
	self->priv->background_buffer = NULL;
#line 212 "DockRenderer.vala"
	_g_object_unref0 (self->priv->indicator_buffer);
#line 212 "DockRenderer.vala"
	self->priv->indicator_buffer = NULL;
#line 213 "DockRenderer.vala"
	_g_object_unref0 (self->priv->urgent_indicator_buffer);
#line 213 "DockRenderer.vala"
	self->priv->urgent_indicator_buffer = NULL;
#line 214 "DockRenderer.vala"
	_g_object_unref0 (self->priv->urgent_glow_buffer);
#line 214 "DockRenderer.vala"
	self->priv->urgent_glow_buffer = NULL;
#line 216 "DockRenderer.vala"
	plank_renderer_animated_draw ((PlankRenderer*) self);
#line 708 "DockRenderer.c"
}

/**
 * Resets all internal item buffers and forces a redraw.
 */
static void
plank_dock_renderer_reset_item_buffers (PlankDockRenderer* self)
{
	PlankDockController* _tmp0_;
#line 222 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 224 "DockRenderer.vala"
	plank_logger_verbose ("DockRenderer.reset_item_buffers ()", NULL);
#line 226 "DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 226 "DockRenderer.vala"
	plank_dock_element_reset_buffers ((PlankDockElement*) _tmp0_);
#line 228 "DockRenderer.vala"
	plank_renderer_animated_draw ((PlankRenderer*) self);
#line 728 "DockRenderer.c"
}

/**
 * {@inheritDoc}
 */
static void
plank_dock_renderer_real_initialize_frame (PlankRenderer* base,
                                           gint64 frame_time)
{
	PlankDockRenderer * self;
	PlankDockTheme* _tmp0_;
	GeeArrayList* new_items = NULL;
	PlankDockController* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp7_;
	PlankPositionManager* _tmp8_;
	PlankPositionManager* _tmp9_;
	PlankPositionManager* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	PlankEnvironmentSettings* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	gdouble fade_opacity = 0.0;
	PlankDockTheme* _tmp16_;
	gdouble _tmp17_;
	gdouble _tmp18_;
	GeeArrayList* _tmp50_;
	GeeArrayList* _tmp51_;
	GeeArrayList* _tmp52_;
	GeeArrayList* _tmp78_;
	PlankPositionManager* _tmp79_;
	GeeArrayList* _tmp80_;
	PlankPositionManager* _tmp81_;
	GdkRectangle _tmp82_ = {0};
#line 234 "DockRenderer.vala"
	self = (PlankDockRenderer*) base;
#line 236 "DockRenderer.vala"
	_tmp0_ = self->priv->_theme;
#line 236 "DockRenderer.vala"
	g_return_if_fail (_tmp0_ != NULL);
#line 238 "DockRenderer.vala"
	_tmp1_ = self->priv->_controller;
#line 238 "DockRenderer.vala"
	_tmp2_ = plank_dock_controller_get_VisibleItems (_tmp1_);
#line 238 "DockRenderer.vala"
	_tmp3_ = _tmp2_;
#line 238 "DockRenderer.vala"
	new_items = _tmp3_;
#line 241 "DockRenderer.vala"
	_tmp4_ = new_items;
#line 241 "DockRenderer.vala"
	_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 241 "DockRenderer.vala"
	_tmp6_ = _tmp5_;
#line 241 "DockRenderer.vala"
	if (_tmp6_ <= 0) {
#line 242 "DockRenderer.vala"
		g_critical ("DockRenderer.vala:242: No items available to initialize frame");
#line 243 "DockRenderer.vala"
		return;
#line 795 "DockRenderer.c"
	}
#line 246 "DockRenderer.vala"
	_tmp7_ = self->priv->_controller;
#line 246 "DockRenderer.vala"
	_tmp8_ = plank_dock_controller_get_position_manager (_tmp7_);
#line 246 "DockRenderer.vala"
	_tmp9_ = _tmp8_;
#line 246 "DockRenderer.vala"
	position_manager = _tmp9_;
#line 248 "DockRenderer.vala"
	_tmp10_ = position_manager;
#line 248 "DockRenderer.vala"
	_tmp11_ = plank_position_manager_get_screen_is_composited (_tmp10_);
#line 248 "DockRenderer.vala"
	_tmp12_ = _tmp11_;
#line 248 "DockRenderer.vala"
	self->priv->screen_is_composited = _tmp12_;
#line 249 "DockRenderer.vala"
	_tmp13_ = plank_environment_settings_get_instance ();
#line 249 "DockRenderer.vala"
	_tmp14_ = plank_environment_settings_get_ShowNotifications (_tmp13_);
#line 249 "DockRenderer.vala"
	_tmp15_ = _tmp14_;
#line 249 "DockRenderer.vala"
	self->priv->show_notifications = _tmp15_;
#line 250 "DockRenderer.vala"
	self->priv->dynamic_animation_offset = 0.0;
#line 252 "DockRenderer.vala"
	_tmp16_ = self->priv->_theme;
#line 252 "DockRenderer.vala"
	_tmp17_ = plank_dock_theme_get_FadeOpacity (_tmp16_);
#line 252 "DockRenderer.vala"
	_tmp18_ = _tmp17_;
#line 252 "DockRenderer.vala"
	fade_opacity = _tmp18_;
#line 254 "DockRenderer.vala"
	if (self->priv->screen_is_composited) {
#line 833 "DockRenderer.c"
		gint _tmp19_ = 0;
		gint hide_duration = 0;
		gint64 hide_time = 0LL;
		guint zoom_duration = 0U;
		gint64 zoom_time = 0LL;
		gdouble zoom_progress = 0.0;
		gdouble _tmp48_;
#line 255 "DockRenderer.vala"
		if (fade_opacity == 1.0) {
#line 843 "DockRenderer.c"
			PlankDockTheme* _tmp20_;
			gint _tmp21_;
			gint _tmp22_;
#line 255 "DockRenderer.vala"
			_tmp20_ = self->priv->_theme;
#line 255 "DockRenderer.vala"
			_tmp21_ = plank_dock_theme_get_HideTime (_tmp20_);
#line 255 "DockRenderer.vala"
			_tmp22_ = _tmp21_;
#line 255 "DockRenderer.vala"
			_tmp19_ = _tmp22_;
#line 855 "DockRenderer.c"
		} else {
			PlankDockTheme* _tmp23_;
			gint _tmp24_;
			gint _tmp25_;
#line 255 "DockRenderer.vala"
			_tmp23_ = self->priv->_theme;
#line 255 "DockRenderer.vala"
			_tmp24_ = plank_dock_theme_get_FadeTime (_tmp23_);
#line 255 "DockRenderer.vala"
			_tmp25_ = _tmp24_;
#line 255 "DockRenderer.vala"
			_tmp19_ = _tmp25_;
#line 868 "DockRenderer.c"
		}
#line 255 "DockRenderer.vala"
		hide_duration = _tmp19_ * 1000;
#line 256 "DockRenderer.vala"
		hide_time = MAX (0LL, frame_time - self->priv->last_hide);
#line 257 "DockRenderer.vala"
		if (hide_time < ((gint64) hide_duration)) {
#line 876 "DockRenderer.c"
			PlankDockController* _tmp26_;
			PlankHideManager* _tmp27_;
			PlankHideManager* _tmp28_;
			gboolean _tmp29_;
			gboolean _tmp30_;
#line 258 "DockRenderer.vala"
			_tmp26_ = self->priv->_controller;
#line 258 "DockRenderer.vala"
			_tmp27_ = plank_dock_controller_get_hide_manager (_tmp26_);
#line 258 "DockRenderer.vala"
			_tmp28_ = _tmp27_;
#line 258 "DockRenderer.vala"
			_tmp29_ = plank_hide_manager_get_Hidden (_tmp28_);
#line 258 "DockRenderer.vala"
			_tmp30_ = _tmp29_;
#line 258 "DockRenderer.vala"
			if (_tmp30_) {
#line 259 "DockRenderer.vala"
				plank_dock_renderer_set_hide_progress (self, plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_IN_CUBIC, (gdouble) hide_time, (gdouble) hide_duration));
#line 896 "DockRenderer.c"
			} else {
#line 261 "DockRenderer.vala"
				plank_dock_renderer_set_hide_progress (self, 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_OUT_CUBIC, (gdouble) hide_time, (gdouble) hide_duration));
#line 900 "DockRenderer.c"
			}
		} else {
			gdouble _tmp31_ = 0.0;
			PlankDockController* _tmp32_;
			PlankHideManager* _tmp33_;
			PlankHideManager* _tmp34_;
			gboolean _tmp35_;
			gboolean _tmp36_;
#line 263 "DockRenderer.vala"
			_tmp32_ = self->priv->_controller;
#line 263 "DockRenderer.vala"
			_tmp33_ = plank_dock_controller_get_hide_manager (_tmp32_);
#line 263 "DockRenderer.vala"
			_tmp34_ = _tmp33_;
#line 263 "DockRenderer.vala"
			_tmp35_ = plank_hide_manager_get_Hidden (_tmp34_);
#line 263 "DockRenderer.vala"
			_tmp36_ = _tmp35_;
#line 263 "DockRenderer.vala"
			if (_tmp36_) {
#line 263 "DockRenderer.vala"
				_tmp31_ = 1.0;
#line 923 "DockRenderer.c"
			} else {
#line 263 "DockRenderer.vala"
				_tmp31_ = 0.0;
#line 927 "DockRenderer.c"
			}
#line 263 "DockRenderer.vala"
			plank_dock_renderer_set_hide_progress (self, _tmp31_);
#line 931 "DockRenderer.c"
		}
#line 266 "DockRenderer.vala"
		zoom_duration = PLANK_DOCK_ZOOM_DURATION * 1000;
#line 267 "DockRenderer.vala"
		zoom_time = MAX (0LL, frame_time - self->priv->last_hovered_changed);
#line 269 "DockRenderer.vala"
		if (zoom_time < ((gint64) zoom_duration)) {
#line 939 "DockRenderer.c"
			PlankDockController* _tmp37_;
			PlankHideManager* _tmp38_;
			PlankHideManager* _tmp39_;
			gboolean _tmp40_;
			gboolean _tmp41_;
#line 270 "DockRenderer.vala"
			_tmp37_ = self->priv->_controller;
#line 270 "DockRenderer.vala"
			_tmp38_ = plank_dock_controller_get_hide_manager (_tmp37_);
#line 270 "DockRenderer.vala"
			_tmp39_ = _tmp38_;
#line 270 "DockRenderer.vala"
			_tmp40_ = plank_hide_manager_get_Hovered (_tmp39_);
#line 270 "DockRenderer.vala"
			_tmp41_ = _tmp40_;
#line 270 "DockRenderer.vala"
			if (_tmp41_) {
#line 271 "DockRenderer.vala"
				zoom_progress = plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_OUT_CUBIC, (gdouble) zoom_time, (gdouble) zoom_duration);
#line 959 "DockRenderer.c"
			} else {
#line 273 "DockRenderer.vala"
				zoom_progress = 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_IN_CUBIC, (gdouble) zoom_time, (gdouble) zoom_duration);
#line 963 "DockRenderer.c"
			}
		} else {
			gdouble _tmp42_ = 0.0;
			PlankDockController* _tmp43_;
			PlankHideManager* _tmp44_;
			PlankHideManager* _tmp45_;
			gboolean _tmp46_;
			gboolean _tmp47_;
#line 275 "DockRenderer.vala"
			_tmp43_ = self->priv->_controller;
#line 275 "DockRenderer.vala"
			_tmp44_ = plank_dock_controller_get_hide_manager (_tmp43_);
#line 275 "DockRenderer.vala"
			_tmp45_ = _tmp44_;
#line 275 "DockRenderer.vala"
			_tmp46_ = plank_hide_manager_get_Hovered (_tmp45_);
#line 275 "DockRenderer.vala"
			_tmp47_ = _tmp46_;
#line 275 "DockRenderer.vala"
			if (_tmp47_) {
#line 275 "DockRenderer.vala"
				_tmp42_ = 1.0;
#line 986 "DockRenderer.c"
			} else {
#line 275 "DockRenderer.vala"
				_tmp42_ = 0.0;
#line 990 "DockRenderer.c"
			}
#line 275 "DockRenderer.vala"
			zoom_progress = _tmp42_;
#line 994 "DockRenderer.c"
		}
#line 277 "DockRenderer.vala"
		_tmp48_ = self->priv->_hide_progress;
#line 277 "DockRenderer.vala"
		plank_dock_renderer_set_zoom_in_progress (self, zoom_progress * (1.0 - _tmp48_));
#line 1000 "DockRenderer.c"
	} else {
#line 279 "DockRenderer.vala"
		plank_dock_renderer_set_hide_progress (self, 0.0);
#line 280 "DockRenderer.vala"
		plank_dock_renderer_set_zoom_in_progress (self, 0.0);
#line 1006 "DockRenderer.c"
	}
#line 283 "DockRenderer.vala"
	if (fade_opacity < 1.0) {
#line 1010 "DockRenderer.c"
		gdouble _tmp49_;
#line 284 "DockRenderer.vala"
		_tmp49_ = self->priv->_hide_progress;
#line 284 "DockRenderer.vala"
		plank_dock_renderer_set_opacity (self, 1.0 - ((1.0 - fade_opacity) * _tmp49_));
#line 1016 "DockRenderer.c"
	} else {
#line 286 "DockRenderer.vala"
		plank_dock_renderer_set_opacity (self, 1.0);
#line 1020 "DockRenderer.c"
	}
#line 289 "DockRenderer.vala"
	_tmp50_ = self->priv->current_items;
#line 289 "DockRenderer.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp50_);
#line 290 "DockRenderer.vala"
	_tmp51_ = self->priv->current_items;
#line 290 "DockRenderer.vala"
	_tmp52_ = new_items;
#line 290 "DockRenderer.vala"
	gee_array_list_add_all (_tmp51_, (GeeCollection*) _tmp52_);
#line 292 "DockRenderer.vala"
	if (self->priv->screen_is_composited) {
#line 1034 "DockRenderer.c"
		gint64 add_time = 0LL;
		gint64 remove_time = 0LL;
		gint64 move_time = 0LL;
		gint move_duration = 0;
		PlankDockTheme* _tmp53_;
		gint _tmp54_;
		gint _tmp55_;
		GeeIterator* transient_items_it = NULL;
		GeeHashSet* _tmp56_;
		GeeIterator* _tmp57_;
#line 293 "DockRenderer.vala"
		add_time = 0LL;
#line 294 "DockRenderer.vala"
		remove_time = 0LL;
#line 295 "DockRenderer.vala"
		move_time = 0LL;
#line 296 "DockRenderer.vala"
		_tmp53_ = self->priv->_theme;
#line 296 "DockRenderer.vala"
		_tmp54_ = plank_dock_theme_get_ItemMoveTime (_tmp53_);
#line 296 "DockRenderer.vala"
		_tmp55_ = _tmp54_;
#line 296 "DockRenderer.vala"
		move_duration = _tmp55_ * 1000;
#line 298 "DockRenderer.vala"
		_tmp56_ = self->priv->transient_items;
#line 298 "DockRenderer.vala"
		_tmp57_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp56_);
#line 298 "DockRenderer.vala"
		transient_items_it = _tmp57_;
#line 299 "DockRenderer.vala"
		while (TRUE) {
#line 1067 "DockRenderer.c"
			GeeIterator* _tmp58_;
			PlankDockItem* item = NULL;
			GeeIterator* _tmp59_;
			gpointer _tmp60_;
			PlankDockItem* _tmp61_;
			gint64 _tmp62_;
			gint64 _tmp63_;
			PlankDockItem* _tmp64_;
			gint64 _tmp65_;
			gint64 _tmp66_;
#line 299 "DockRenderer.vala"
			_tmp58_ = transient_items_it;
#line 299 "DockRenderer.vala"
			if (!gee_iterator_next (_tmp58_)) {
#line 299 "DockRenderer.vala"
				break;
#line 1084 "DockRenderer.c"
			}
#line 300 "DockRenderer.vala"
			_tmp59_ = transient_items_it;
#line 300 "DockRenderer.vala"
			_tmp60_ = gee_iterator_get (_tmp59_);
#line 300 "DockRenderer.vala"
			item = (PlankDockItem*) _tmp60_;
#line 301 "DockRenderer.vala"
			_tmp61_ = item;
#line 301 "DockRenderer.vala"
			_tmp62_ = plank_dock_element_get_AddTime ((PlankDockElement*) _tmp61_);
#line 301 "DockRenderer.vala"
			_tmp63_ = _tmp62_;
#line 301 "DockRenderer.vala"
			add_time = _tmp63_;
#line 302 "DockRenderer.vala"
			_tmp64_ = item;
#line 302 "DockRenderer.vala"
			_tmp65_ = plank_dock_element_get_RemoveTime ((PlankDockElement*) _tmp64_);
#line 302 "DockRenderer.vala"
			_tmp66_ = _tmp65_;
#line 302 "DockRenderer.vala"
			remove_time = _tmp66_;
#line 304 "DockRenderer.vala"
			if (add_time > remove_time) {
#line 305 "DockRenderer.vala"
				move_time = frame_time - add_time;
#line 306 "DockRenderer.vala"
				if (move_time < ((gint64) move_duration)) {
#line 1114 "DockRenderer.c"
					GeeArrayList* _tmp67_;
					PlankDockItem* _tmp68_;
#line 307 "DockRenderer.vala"
					_tmp67_ = self->priv->current_items;
#line 307 "DockRenderer.vala"
					_tmp68_ = item;
#line 307 "DockRenderer.vala"
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp67_, _tmp68_)) {
#line 1123 "DockRenderer.c"
						GeeArrayList* _tmp69_;
						PlankDockItem* _tmp70_;
#line 308 "DockRenderer.vala"
						_tmp69_ = self->priv->current_items;
#line 308 "DockRenderer.vala"
						_tmp70_ = item;
#line 308 "DockRenderer.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp69_, _tmp70_);
#line 1132 "DockRenderer.c"
					}
				} else {
					GeeIterator* _tmp71_;
#line 310 "DockRenderer.vala"
					_tmp71_ = transient_items_it;
#line 310 "DockRenderer.vala"
					gee_iterator_remove (_tmp71_);
#line 1140 "DockRenderer.c"
				}
			} else {
#line 312 "DockRenderer.vala"
				if (remove_time > ((gint64) 0)) {
#line 313 "DockRenderer.vala"
					move_time = frame_time - remove_time;
#line 314 "DockRenderer.vala"
					if (move_time < ((gint64) move_duration)) {
#line 1149 "DockRenderer.c"
						GeeArrayList* _tmp72_;
						PlankDockItem* _tmp73_;
#line 315 "DockRenderer.vala"
						_tmp72_ = self->priv->current_items;
#line 315 "DockRenderer.vala"
						_tmp73_ = item;
#line 315 "DockRenderer.vala"
						if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp72_, _tmp73_)) {
#line 1158 "DockRenderer.c"
							GeeArrayList* _tmp74_;
							PlankDockItem* _tmp75_;
#line 316 "DockRenderer.vala"
							_tmp74_ = self->priv->current_items;
#line 316 "DockRenderer.vala"
							_tmp75_ = item;
#line 316 "DockRenderer.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp74_, _tmp75_);
#line 1167 "DockRenderer.c"
						}
					} else {
						GeeIterator* _tmp76_;
#line 318 "DockRenderer.vala"
						_tmp76_ = transient_items_it;
#line 318 "DockRenderer.vala"
						gee_iterator_remove (_tmp76_);
#line 1175 "DockRenderer.c"
					}
				}
			}
#line 299 "DockRenderer.vala"
			_g_object_unref0 (item);
#line 1181 "DockRenderer.c"
		}
#line 292 "DockRenderer.vala"
		_g_object_unref0 (transient_items_it);
#line 1185 "DockRenderer.c"
	} else {
		GeeHashSet* _tmp77_;
#line 323 "DockRenderer.vala"
		_tmp77_ = self->priv->transient_items;
#line 323 "DockRenderer.vala"
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp77_);
#line 1192 "DockRenderer.c"
	}
#line 326 "DockRenderer.vala"
	_tmp78_ = self->priv->current_items;
#line 326 "DockRenderer.vala"
	gee_list_sort ((GeeList*) _tmp78_, (GCompareDataFunc) plank_dock_renderer_compare_dock_item_position, NULL, NULL);
#line 329 "DockRenderer.vala"
	_tmp79_ = position_manager;
#line 329 "DockRenderer.vala"
	_tmp80_ = self->priv->current_items;
#line 329 "DockRenderer.vala"
	plank_position_manager_update_draw_values (_tmp79_, _tmp80_, (PlankDrawValueFunc) plank_dock_renderer_animate_draw_value_for_item, self, (PlankDrawValuesFunc) plank_dock_renderer_post_process_draw_values, self);
#line 333 "DockRenderer.vala"
	_tmp81_ = position_manager;
#line 333 "DockRenderer.vala"
	plank_position_manager_get_background_region (_tmp81_, &_tmp82_);
#line 333 "DockRenderer.vala"
	self->priv->background_rect = _tmp82_;
#line 1210 "DockRenderer.c"
}

/**
 * {@inheritDoc}
 */
static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 339 "DockRenderer.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 339 "DockRenderer.vala"
	return _data1_;
#line 1223 "DockRenderer.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 339 "DockRenderer.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1233 "DockRenderer.c"
		PlankDockRenderer* self;
#line 339 "DockRenderer.vala"
		self = _data1_->self;
#line 339 "DockRenderer.vala"
		_g_object_unref0 (self);
#line 339 "DockRenderer.vala"
		g_slice_free (Block1Data, _data1_);
#line 1241 "DockRenderer.c"
	}
}

static gboolean
___lambda47_ (Block1Data* _data1_)
{
	PlankDockRenderer* self;
	PlankHideManager* hide_manager = NULL;
	PlankDockController* _tmp0_;
	PlankHideManager* _tmp1_;
	PlankHideManager* _tmp2_;
	PlankHideManager* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	PlankHideManager* _tmp6_;
	gboolean result;
#line 483 "DockRenderer.vala"
	self = _data1_->self;
#line 484 "DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 484 "DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_hide_manager (_tmp0_);
#line 484 "DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 484 "DockRenderer.vala"
	hide_manager = _tmp2_;
#line 489 "DockRenderer.vala"
	_tmp3_ = hide_manager;
#line 489 "DockRenderer.vala"
	_tmp4_ = plank_hide_manager_get_Hidden (_tmp3_);
#line 489 "DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 489 "DockRenderer.vala"
	if (_tmp5_) {
#line 490 "DockRenderer.vala"
		result = FALSE;
#line 490 "DockRenderer.vala"
		return result;
#line 1280 "DockRenderer.c"
	}
#line 493 "DockRenderer.vala"
	_tmp6_ = hide_manager;
#line 493 "DockRenderer.vala"
	plank_hide_manager_update_hovered (_tmp6_);
#line 497 "DockRenderer.vala"
	plank_renderer_force_frame_time_update ((PlankRenderer*) self);
#line 498 "DockRenderer.vala"
	self->priv->last_hide = _data1_->frame_time;
#line 500 "DockRenderer.vala"
	plank_dock_renderer_hidden_changed (self);
#line 501 "DockRenderer.vala"
	result = FALSE;
#line 501 "DockRenderer.vala"
	return result;
#line 1296 "DockRenderer.c"
}

static gboolean
____lambda47__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda47_ (self);
#line 483 "DockRenderer.vala"
	return result;
#line 1306 "DockRenderer.c"
}

static void
plank_dock_renderer_real_draw (PlankRenderer* base,
                               cairo_t* cr,
                               gint64 frame_time)
{
	PlankDockRenderer * self;
	Block1Data* _data1_;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	PlankDockController* _tmp3_;
	PlankDockWindow* _tmp4_;
	PlankDockWindow* _tmp5_;
	GdkWindow* _tmp6_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean no_full_draw_needed = FALSE;
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp11_;
	PlankPositionManager* _tmp12_;
	PlankPositionManager* _tmp13_;
	PlankDockItem* dragged_item = NULL;
	PlankDockController* _tmp14_;
	PlankDragManager* _tmp15_;
	PlankDragManager* _tmp16_;
	PlankDockItem* _tmp17_;
	PlankDockItem* _tmp18_;
	GdkRectangle win_rect = {0};
	PlankPositionManager* _tmp19_;
	GdkRectangle _tmp20_ = {0};
	PlankSurface* _tmp21_;
	PlankSurface* _tmp29_;
	PlankSurface* _tmp37_;
	gboolean _tmp45_ = FALSE;
	gboolean _tmp46_ = FALSE;
	gboolean _tmp58_ = FALSE;
	gdouble _tmp59_;
	PlankSurface* _tmp68_;
	PlankSurface* _tmp69_;
	PlankSurface* _tmp70_;
	cairo_t* item_cr = NULL;
	PlankSurface* _tmp71_;
	cairo_t* _tmp72_;
	cairo_t* _tmp73_;
	cairo_t* shadow_cr = NULL;
	PlankSurface* _tmp74_;
	cairo_t* _tmp75_;
	cairo_t* _tmp76_;
	gint x_offset = 0;
	gint y_offset = 0;
	gdouble _tmp77_;
	PlankSurface* _tmp81_;
	cairo_t* main_cr = NULL;
	PlankSurface* _tmp82_;
	cairo_t* _tmp83_;
	cairo_t* _tmp84_;
	cairo_t* _tmp85_;
	cairo_t* _tmp86_;
	GdkRectangle _tmp87_;
	cairo_t* _tmp111_;
	PlankSurface* _tmp112_;
	cairo_surface_t* _tmp113_;
	cairo_surface_t* _tmp114_;
	cairo_t* _tmp115_;
	cairo_t* _tmp116_;
	PlankSurface* _tmp117_;
	cairo_surface_t* _tmp118_;
	cairo_surface_t* _tmp119_;
	cairo_t* _tmp120_;
	gdouble _tmp121_;
	gboolean _tmp139_ = FALSE;
#line 339 "DockRenderer.vala"
	self = (PlankDockRenderer*) base;
#line 339 "DockRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 339 "DockRenderer.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 339 "DockRenderer.vala"
	_data1_->_ref_count_ = 1;
#line 339 "DockRenderer.vala"
	_data1_->self = g_object_ref (self);
#line 339 "DockRenderer.vala"
	_data1_->frame_time = frame_time;
#line 342 "DockRenderer.vala"
	_tmp0_ = self->priv->current_items;
#line 342 "DockRenderer.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 342 "DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 342 "DockRenderer.vala"
	if (_tmp2_ <= 0) {
#line 343 "DockRenderer.vala"
		g_critical ("DockRenderer.vala:343: No items available to draw frame");
#line 344 "DockRenderer.vala"
		block1_data_unref (_data1_);
#line 344 "DockRenderer.vala"
		_data1_ = NULL;
#line 344 "DockRenderer.vala"
		return;
#line 1408 "DockRenderer.c"
	}
#line 347 "DockRenderer.vala"
	_tmp3_ = self->priv->_controller;
#line 347 "DockRenderer.vala"
	_tmp4_ = plank_dock_controller_get_window (_tmp3_);
#line 347 "DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 347 "DockRenderer.vala"
	_tmp6_ = gtk_widget_get_window ((GtkWidget*) _tmp5_);
#line 347 "DockRenderer.vala"
	self->priv->window_scale_factor = gdk_window_get_scale_factor (_tmp6_);
#line 350 "DockRenderer.vala"
	if (!self->priv->is_first_frame) {
#line 1422 "DockRenderer.c"
		gdouble _tmp9_;
#line 350 "DockRenderer.vala"
		_tmp9_ = self->priv->_hide_progress;
#line 350 "DockRenderer.vala"
		_tmp8_ = _tmp9_ == 1.0;
#line 1428 "DockRenderer.c"
	} else {
#line 350 "DockRenderer.vala"
		_tmp8_ = FALSE;
#line 1432 "DockRenderer.c"
	}
#line 350 "DockRenderer.vala"
	if (_tmp8_) {
#line 1436 "DockRenderer.c"
		gdouble _tmp10_;
#line 350 "DockRenderer.vala"
		_tmp10_ = self->priv->_opacity;
#line 350 "DockRenderer.vala"
		_tmp7_ = _tmp10_ == 1.0;
#line 1442 "DockRenderer.c"
	} else {
#line 350 "DockRenderer.vala"
		_tmp7_ = FALSE;
#line 1446 "DockRenderer.c"
	}
#line 350 "DockRenderer.vala"
	no_full_draw_needed = _tmp7_;
#line 352 "DockRenderer.vala"
	_tmp11_ = self->priv->_controller;
#line 352 "DockRenderer.vala"
	_tmp12_ = plank_dock_controller_get_position_manager (_tmp11_);
#line 352 "DockRenderer.vala"
	_tmp13_ = _tmp12_;
#line 352 "DockRenderer.vala"
	position_manager = _tmp13_;
#line 353 "DockRenderer.vala"
	_tmp14_ = self->priv->_controller;
#line 353 "DockRenderer.vala"
	_tmp15_ = plank_dock_controller_get_drag_manager (_tmp14_);
#line 353 "DockRenderer.vala"
	_tmp16_ = _tmp15_;
#line 353 "DockRenderer.vala"
	_tmp17_ = plank_drag_manager_get_DragItem (_tmp16_);
#line 353 "DockRenderer.vala"
	_tmp18_ = _tmp17_;
#line 353 "DockRenderer.vala"
	dragged_item = _tmp18_;
#line 354 "DockRenderer.vala"
	_tmp19_ = position_manager;
#line 354 "DockRenderer.vala"
	plank_position_manager_get_dock_window_region (_tmp19_, &_tmp20_);
#line 354 "DockRenderer.vala"
	win_rect = _tmp20_;
#line 356 "DockRenderer.vala"
	_tmp21_ = self->priv->main_buffer;
#line 356 "DockRenderer.vala"
	if (_tmp21_ == NULL) {
#line 1480 "DockRenderer.c"
		GdkRectangle _tmp22_;
		GdkRectangle _tmp23_;
		cairo_surface_t* _tmp24_;
		PlankSurface* _tmp25_;
		PlankSurface* _tmp26_;
		cairo_surface_t* _tmp27_;
		cairo_surface_t* _tmp28_;
#line 357 "DockRenderer.vala"
		_tmp22_ = win_rect;
#line 357 "DockRenderer.vala"
		_tmp23_ = win_rect;
#line 357 "DockRenderer.vala"
		_tmp24_ = cairo_get_target (cr);
#line 357 "DockRenderer.vala"
		_tmp25_ = plank_surface_new_with_cairo_surface (_tmp22_.width, _tmp23_.height, _tmp24_);
#line 357 "DockRenderer.vala"
		_g_object_unref0 (self->priv->main_buffer);
#line 357 "DockRenderer.vala"
		self->priv->main_buffer = _tmp25_;
#line 358 "DockRenderer.vala"
		_tmp26_ = self->priv->main_buffer;
#line 358 "DockRenderer.vala"
		_tmp27_ = plank_surface_get_Internal (_tmp26_);
#line 358 "DockRenderer.vala"
		_tmp28_ = _tmp27_;
#line 358 "DockRenderer.vala"
		cairo_surface_set_device_scale (_tmp28_, (gdouble) self->priv->window_scale_factor, (gdouble) self->priv->window_scale_factor);
#line 1508 "DockRenderer.c"
	}
#line 361 "DockRenderer.vala"
	_tmp29_ = self->priv->item_buffer;
#line 361 "DockRenderer.vala"
	if (_tmp29_ == NULL) {
#line 1514 "DockRenderer.c"
		GdkRectangle _tmp30_;
		GdkRectangle _tmp31_;
		cairo_surface_t* _tmp32_;
		PlankSurface* _tmp33_;
		PlankSurface* _tmp34_;
		cairo_surface_t* _tmp35_;
		cairo_surface_t* _tmp36_;
#line 362 "DockRenderer.vala"
		_tmp30_ = win_rect;
#line 362 "DockRenderer.vala"
		_tmp31_ = win_rect;
#line 362 "DockRenderer.vala"
		_tmp32_ = cairo_get_target (cr);
#line 362 "DockRenderer.vala"
		_tmp33_ = plank_surface_new_with_cairo_surface (_tmp30_.width, _tmp31_.height, _tmp32_);
#line 362 "DockRenderer.vala"
		_g_object_unref0 (self->priv->item_buffer);
#line 362 "DockRenderer.vala"
		self->priv->item_buffer = _tmp33_;
#line 363 "DockRenderer.vala"
		_tmp34_ = self->priv->item_buffer;
#line 363 "DockRenderer.vala"
		_tmp35_ = plank_surface_get_Internal (_tmp34_);
#line 363 "DockRenderer.vala"
		_tmp36_ = _tmp35_;
#line 363 "DockRenderer.vala"
		cairo_surface_set_device_scale (_tmp36_, (gdouble) self->priv->window_scale_factor, (gdouble) self->priv->window_scale_factor);
#line 1542 "DockRenderer.c"
	}
#line 366 "DockRenderer.vala"
	_tmp37_ = self->priv->shadow_buffer;
#line 366 "DockRenderer.vala"
	if (_tmp37_ == NULL) {
#line 1548 "DockRenderer.c"
		GdkRectangle _tmp38_;
		GdkRectangle _tmp39_;
		cairo_surface_t* _tmp40_;
		PlankSurface* _tmp41_;
		PlankSurface* _tmp42_;
		cairo_surface_t* _tmp43_;
		cairo_surface_t* _tmp44_;
#line 367 "DockRenderer.vala"
		_tmp38_ = win_rect;
#line 367 "DockRenderer.vala"
		_tmp39_ = win_rect;
#line 367 "DockRenderer.vala"
		_tmp40_ = cairo_get_target (cr);
#line 367 "DockRenderer.vala"
		_tmp41_ = plank_surface_new_with_cairo_surface (_tmp38_.width, _tmp39_.height, _tmp40_);
#line 367 "DockRenderer.vala"
		_g_object_unref0 (self->priv->shadow_buffer);
#line 367 "DockRenderer.vala"
		self->priv->shadow_buffer = _tmp41_;
#line 368 "DockRenderer.vala"
		_tmp42_ = self->priv->shadow_buffer;
#line 368 "DockRenderer.vala"
		_tmp43_ = plank_surface_get_Internal (_tmp42_);
#line 368 "DockRenderer.vala"
		_tmp44_ = _tmp43_;
#line 368 "DockRenderer.vala"
		cairo_surface_set_device_scale (_tmp44_, (gdouble) self->priv->window_scale_factor, (gdouble) self->priv->window_scale_factor);
#line 1576 "DockRenderer.c"
	}
#line 374 "DockRenderer.vala"
	if (no_full_draw_needed) {
#line 1580 "DockRenderer.c"
		gdouble _tmp47_;
#line 374 "DockRenderer.vala"
		_tmp47_ = self->priv->_hide_progress;
#line 374 "DockRenderer.vala"
		_tmp46_ = _tmp47_ == 1.0;
#line 1586 "DockRenderer.c"
	} else {
#line 374 "DockRenderer.vala"
		_tmp46_ = FALSE;
#line 1590 "DockRenderer.c"
	}
#line 374 "DockRenderer.vala"
	if (_tmp46_) {
#line 1594 "DockRenderer.c"
		gdouble _tmp48_;
#line 374 "DockRenderer.vala"
		_tmp48_ = self->priv->_opacity;
#line 374 "DockRenderer.vala"
		_tmp45_ = _tmp48_ == 1.0;
#line 1600 "DockRenderer.c"
	} else {
#line 374 "DockRenderer.vala"
		_tmp45_ = FALSE;
#line 1604 "DockRenderer.c"
	}
#line 374 "DockRenderer.vala"
	if (_tmp45_) {
#line 376 "DockRenderer.vala"
		cairo_save (cr);
#line 377 "DockRenderer.vala"
		cairo_set_operator (cr, CAIRO_OPERATOR_CLEAR);
#line 378 "DockRenderer.vala"
		cairo_paint (cr);
#line 379 "DockRenderer.vala"
		cairo_restore (cr);
#line 381 "DockRenderer.vala"
		if (self->priv->show_notifications) {
#line 1618 "DockRenderer.c"
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp49_;
				gint _item_size = 0;
				GeeArrayList* _tmp50_;
				gint _tmp51_;
				gint _tmp52_;
				gint _item_index = 0;
#line 382 "DockRenderer.vala"
				_tmp49_ = self->priv->current_items;
#line 382 "DockRenderer.vala"
				_item_list = _tmp49_;
#line 382 "DockRenderer.vala"
				_tmp50_ = _item_list;
#line 382 "DockRenderer.vala"
				_tmp51_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp50_);
#line 382 "DockRenderer.vala"
				_tmp52_ = _tmp51_;
#line 382 "DockRenderer.vala"
				_item_size = _tmp52_;
#line 382 "DockRenderer.vala"
				_item_index = -1;
#line 382 "DockRenderer.vala"
				while (TRUE) {
#line 1643 "DockRenderer.c"
					gint _tmp53_;
					gint _tmp54_;
					PlankDockItem* item = NULL;
					GeeArrayList* _tmp55_;
					gpointer _tmp56_;
					PlankDockItem* _tmp57_;
#line 382 "DockRenderer.vala"
					_item_index = _item_index + 1;
#line 382 "DockRenderer.vala"
					_tmp53_ = _item_index;
#line 382 "DockRenderer.vala"
					_tmp54_ = _item_size;
#line 382 "DockRenderer.vala"
					if (!(_tmp53_ < _tmp54_)) {
#line 382 "DockRenderer.vala"
						break;
#line 1660 "DockRenderer.c"
					}
#line 382 "DockRenderer.vala"
					_tmp55_ = _item_list;
#line 382 "DockRenderer.vala"
					_tmp56_ = gee_abstract_list_get ((GeeAbstractList*) _tmp55_, _item_index);
#line 382 "DockRenderer.vala"
					item = (PlankDockItem*) _tmp56_;
#line 383 "DockRenderer.vala"
					_tmp57_ = item;
#line 383 "DockRenderer.vala"
					plank_dock_renderer_draw_urgent_glow (self, _tmp57_, cr, _data1_->frame_time);
#line 1672 "DockRenderer.c"
				}
			}
		}
#line 385 "DockRenderer.vala"
		block1_data_unref (_data1_);
#line 385 "DockRenderer.vala"
		_data1_ = NULL;
#line 385 "DockRenderer.vala"
		return;
#line 1682 "DockRenderer.c"
	}
#line 388 "DockRenderer.vala"
	_tmp59_ = self->priv->_opacity;
#line 388 "DockRenderer.vala"
	if (_tmp59_ < 1.0) {
#line 1688 "DockRenderer.c"
		PlankSurface* _tmp60_;
#line 388 "DockRenderer.vala"
		_tmp60_ = self->priv->fade_buffer;
#line 388 "DockRenderer.vala"
		_tmp58_ = _tmp60_ == NULL;
#line 1694 "DockRenderer.c"
	} else {
#line 388 "DockRenderer.vala"
		_tmp58_ = FALSE;
#line 1698 "DockRenderer.c"
	}
#line 388 "DockRenderer.vala"
	if (_tmp58_) {
#line 1702 "DockRenderer.c"
		GdkRectangle _tmp61_;
		GdkRectangle _tmp62_;
		cairo_surface_t* _tmp63_;
		PlankSurface* _tmp64_;
		PlankSurface* _tmp65_;
		cairo_surface_t* _tmp66_;
		cairo_surface_t* _tmp67_;
#line 389 "DockRenderer.vala"
		_tmp61_ = win_rect;
#line 389 "DockRenderer.vala"
		_tmp62_ = win_rect;
#line 389 "DockRenderer.vala"
		_tmp63_ = cairo_get_target (cr);
#line 389 "DockRenderer.vala"
		_tmp64_ = plank_surface_new_with_cairo_surface (_tmp61_.width, _tmp62_.height, _tmp63_);
#line 389 "DockRenderer.vala"
		_g_object_unref0 (self->priv->fade_buffer);
#line 389 "DockRenderer.vala"
		self->priv->fade_buffer = _tmp64_;
#line 390 "DockRenderer.vala"
		_tmp65_ = self->priv->fade_buffer;
#line 390 "DockRenderer.vala"
		_tmp66_ = plank_surface_get_Internal (_tmp65_);
#line 390 "DockRenderer.vala"
		_tmp67_ = _tmp66_;
#line 390 "DockRenderer.vala"
		cairo_surface_set_device_scale (_tmp67_, (gdouble) self->priv->window_scale_factor, (gdouble) self->priv->window_scale_factor);
#line 1730 "DockRenderer.c"
	}
#line 399 "DockRenderer.vala"
	_tmp68_ = self->priv->main_buffer;
#line 399 "DockRenderer.vala"
	plank_surface_clear (_tmp68_);
#line 400 "DockRenderer.vala"
	_tmp69_ = self->priv->item_buffer;
#line 400 "DockRenderer.vala"
	plank_surface_clear (_tmp69_);
#line 401 "DockRenderer.vala"
	_tmp70_ = self->priv->shadow_buffer;
#line 401 "DockRenderer.vala"
	plank_surface_clear (_tmp70_);
#line 402 "DockRenderer.vala"
	_tmp71_ = self->priv->item_buffer;
#line 402 "DockRenderer.vala"
	_tmp72_ = plank_surface_get_Context (_tmp71_);
#line 402 "DockRenderer.vala"
	_tmp73_ = _tmp72_;
#line 402 "DockRenderer.vala"
	item_cr = _tmp73_;
#line 403 "DockRenderer.vala"
	_tmp74_ = self->priv->shadow_buffer;
#line 403 "DockRenderer.vala"
	_tmp75_ = plank_surface_get_Context (_tmp74_);
#line 403 "DockRenderer.vala"
	_tmp76_ = _tmp75_;
#line 403 "DockRenderer.vala"
	shadow_cr = _tmp76_;
#line 406 "DockRenderer.vala"
	x_offset = 0;
#line 406 "DockRenderer.vala"
	y_offset = 0;
#line 407 "DockRenderer.vala"
	_tmp77_ = self->priv->_opacity;
#line 407 "DockRenderer.vala"
	if (_tmp77_ == 1.0) {
#line 1768 "DockRenderer.c"
		PlankPositionManager* _tmp78_;
		gint _tmp79_ = 0;
		gint _tmp80_ = 0;
#line 408 "DockRenderer.vala"
		_tmp78_ = position_manager;
#line 408 "DockRenderer.vala"
		plank_position_manager_get_dock_draw_position (_tmp78_, &_tmp79_, &_tmp80_);
#line 408 "DockRenderer.vala"
		x_offset = _tmp79_;
#line 408 "DockRenderer.vala"
		y_offset = _tmp80_;
#line 1780 "DockRenderer.c"
	}
#line 411 "DockRenderer.vala"
	_tmp81_ = self->priv->main_buffer;
#line 411 "DockRenderer.vala"
	plank_surface_clear (_tmp81_);
#line 412 "DockRenderer.vala"
	_tmp82_ = self->priv->main_buffer;
#line 412 "DockRenderer.vala"
	_tmp83_ = plank_surface_get_Context (_tmp82_);
#line 412 "DockRenderer.vala"
	_tmp84_ = _tmp83_;
#line 412 "DockRenderer.vala"
	main_cr = _tmp84_;
#line 413 "DockRenderer.vala"
	_tmp85_ = main_cr;
#line 413 "DockRenderer.vala"
	cairo_set_operator (_tmp85_, CAIRO_OPERATOR_OVER);
#line 419 "DockRenderer.vala"
	_tmp86_ = main_cr;
#line 419 "DockRenderer.vala"
	_tmp87_ = self->priv->background_rect;
#line 419 "DockRenderer.vala"
	plank_dock_renderer_draw_dock_background (self, _tmp86_, &_tmp87_, x_offset, y_offset);
#line 1804 "DockRenderer.c"
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp88_;
		gint _item_size = 0;
		GeeArrayList* _tmp89_;
		gint _tmp90_;
		gint _tmp91_;
		gint _item_index = 0;
#line 426 "DockRenderer.vala"
		_tmp88_ = self->priv->current_items;
#line 426 "DockRenderer.vala"
		_item_list = _tmp88_;
#line 426 "DockRenderer.vala"
		_tmp89_ = _item_list;
#line 426 "DockRenderer.vala"
		_tmp90_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp89_);
#line 426 "DockRenderer.vala"
		_tmp91_ = _tmp90_;
#line 426 "DockRenderer.vala"
		_item_size = _tmp91_;
#line 426 "DockRenderer.vala"
		_item_index = -1;
#line 426 "DockRenderer.vala"
		while (TRUE) {
#line 1829 "DockRenderer.c"
			gint _tmp92_;
			gint _tmp93_;
			PlankDockItem* item = NULL;
			GeeArrayList* _tmp94_;
			gpointer _tmp95_;
			gboolean _tmp96_ = FALSE;
			PlankDockItem* _tmp97_;
			gboolean _tmp98_;
			gboolean _tmp99_;
#line 426 "DockRenderer.vala"
			_item_index = _item_index + 1;
#line 426 "DockRenderer.vala"
			_tmp92_ = _item_index;
#line 426 "DockRenderer.vala"
			_tmp93_ = _item_size;
#line 426 "DockRenderer.vala"
			if (!(_tmp92_ < _tmp93_)) {
#line 426 "DockRenderer.vala"
				break;
#line 1849 "DockRenderer.c"
			}
#line 426 "DockRenderer.vala"
			_tmp94_ = _item_list;
#line 426 "DockRenderer.vala"
			_tmp95_ = gee_abstract_list_get ((GeeAbstractList*) _tmp94_, _item_index);
#line 426 "DockRenderer.vala"
			item = (PlankDockItem*) _tmp95_;
#line 431 "DockRenderer.vala"
			_tmp97_ = item;
#line 431 "DockRenderer.vala"
			_tmp98_ = plank_dock_element_get_IsVisible ((PlankDockElement*) _tmp97_);
#line 431 "DockRenderer.vala"
			_tmp99_ = _tmp98_;
#line 431 "DockRenderer.vala"
			if (_tmp99_) {
#line 1865 "DockRenderer.c"
				PlankDockItem* _tmp100_;
				PlankDockItem* _tmp101_;
#line 431 "DockRenderer.vala"
				_tmp100_ = dragged_item;
#line 431 "DockRenderer.vala"
				_tmp101_ = item;
#line 431 "DockRenderer.vala"
				_tmp96_ = _tmp100_ != _tmp101_;
#line 1874 "DockRenderer.c"
			} else {
#line 431 "DockRenderer.vala"
				_tmp96_ = FALSE;
#line 1878 "DockRenderer.c"
			}
#line 431 "DockRenderer.vala"
			if (_tmp96_) {
#line 1882 "DockRenderer.c"
				PlankDockItemDrawValue* draw_value = NULL;
				PlankPositionManager* _tmp102_;
				PlankDockItem* _tmp103_;
				PlankDockItemDrawValue* _tmp104_;
				cairo_t* _tmp105_;
				PlankDockItem* _tmp106_;
				PlankDockItemDrawValue* _tmp107_;
				cairo_t* _tmp108_;
				PlankDockItem* _tmp109_;
				PlankDockItemDrawValue* _tmp110_;
#line 432 "DockRenderer.vala"
				_tmp102_ = position_manager;
#line 432 "DockRenderer.vala"
				_tmp103_ = item;
#line 432 "DockRenderer.vala"
				_tmp104_ = plank_position_manager_get_draw_value_for_item (_tmp102_, _tmp103_);
#line 432 "DockRenderer.vala"
				draw_value = _tmp104_;
#line 433 "DockRenderer.vala"
				_tmp105_ = item_cr;
#line 433 "DockRenderer.vala"
				_tmp106_ = item;
#line 433 "DockRenderer.vala"
				_tmp107_ = draw_value;
#line 433 "DockRenderer.vala"
				plank_dock_renderer_draw_item (self, _tmp105_, _tmp106_, _tmp107_, _data1_->frame_time);
#line 434 "DockRenderer.vala"
				_tmp108_ = shadow_cr;
#line 434 "DockRenderer.vala"
				_tmp109_ = item;
#line 434 "DockRenderer.vala"
				_tmp110_ = draw_value;
#line 434 "DockRenderer.vala"
				plank_dock_renderer_draw_item_shadow (self, _tmp108_, _tmp109_, _tmp110_);
#line 431 "DockRenderer.vala"
				_plank_dock_item_draw_value_unref0 (draw_value);
#line 1919 "DockRenderer.c"
			}
		}
	}
#line 443 "DockRenderer.vala"
	_tmp111_ = main_cr;
#line 443 "DockRenderer.vala"
	_tmp112_ = self->priv->shadow_buffer;
#line 443 "DockRenderer.vala"
	_tmp113_ = plank_surface_get_Internal (_tmp112_);
#line 443 "DockRenderer.vala"
	_tmp114_ = _tmp113_;
#line 443 "DockRenderer.vala"
	cairo_set_source_surface (_tmp111_, _tmp114_, (gdouble) x_offset, (gdouble) y_offset);
#line 444 "DockRenderer.vala"
	_tmp115_ = main_cr;
#line 444 "DockRenderer.vala"
	cairo_paint (_tmp115_);
#line 447 "DockRenderer.vala"
	_tmp116_ = main_cr;
#line 447 "DockRenderer.vala"
	_tmp117_ = self->priv->item_buffer;
#line 447 "DockRenderer.vala"
	_tmp118_ = plank_surface_get_Internal (_tmp117_);
#line 447 "DockRenderer.vala"
	_tmp119_ = _tmp118_;
#line 447 "DockRenderer.vala"
	cairo_set_source_surface (_tmp116_, _tmp119_, (gdouble) x_offset, (gdouble) y_offset);
#line 448 "DockRenderer.vala"
	_tmp120_ = main_cr;
#line 448 "DockRenderer.vala"
	cairo_paint (_tmp120_);
#line 451 "DockRenderer.vala"
	cairo_set_operator (cr, CAIRO_OPERATOR_SOURCE);
#line 452 "DockRenderer.vala"
	_tmp121_ = self->priv->_opacity;
#line 452 "DockRenderer.vala"
	if (_tmp121_ < 1.0) {
#line 1957 "DockRenderer.c"
		PlankSurface* _tmp122_;
		cairo_t* fade_cr = NULL;
		PlankSurface* _tmp123_;
		cairo_t* _tmp124_;
		cairo_t* _tmp125_;
		cairo_t* _tmp126_;
		cairo_t* _tmp127_;
		PlankSurface* _tmp128_;
		cairo_surface_t* _tmp129_;
		cairo_surface_t* _tmp130_;
		cairo_t* _tmp131_;
		gdouble _tmp132_;
		PlankSurface* _tmp133_;
		cairo_surface_t* _tmp134_;
		cairo_surface_t* _tmp135_;
#line 453 "DockRenderer.vala"
		_tmp122_ = self->priv->fade_buffer;
#line 453 "DockRenderer.vala"
		plank_surface_clear (_tmp122_);
#line 454 "DockRenderer.vala"
		_tmp123_ = self->priv->fade_buffer;
#line 454 "DockRenderer.vala"
		_tmp124_ = plank_surface_get_Context (_tmp123_);
#line 454 "DockRenderer.vala"
		_tmp125_ = _tmp124_;
#line 454 "DockRenderer.vala"
		fade_cr = _tmp125_;
#line 455 "DockRenderer.vala"
		_tmp126_ = fade_cr;
#line 455 "DockRenderer.vala"
		cairo_set_operator (_tmp126_, CAIRO_OPERATOR_OVER);
#line 456 "DockRenderer.vala"
		_tmp127_ = fade_cr;
#line 456 "DockRenderer.vala"
		_tmp128_ = self->priv->main_buffer;
#line 456 "DockRenderer.vala"
		_tmp129_ = plank_surface_get_Internal (_tmp128_);
#line 456 "DockRenderer.vala"
		_tmp130_ = _tmp129_;
#line 456 "DockRenderer.vala"
		cairo_set_source_surface (_tmp127_, _tmp130_, (gdouble) 0, (gdouble) 0);
#line 457 "DockRenderer.vala"
		_tmp131_ = fade_cr;
#line 457 "DockRenderer.vala"
		_tmp132_ = self->priv->_opacity;
#line 457 "DockRenderer.vala"
		cairo_paint_with_alpha (_tmp131_, _tmp132_);
#line 459 "DockRenderer.vala"
		_tmp133_ = self->priv->fade_buffer;
#line 459 "DockRenderer.vala"
		_tmp134_ = plank_surface_get_Internal (_tmp133_);
#line 459 "DockRenderer.vala"
		_tmp135_ = _tmp134_;
#line 459 "DockRenderer.vala"
		cairo_set_source_surface (cr, _tmp135_, (gdouble) 0, (gdouble) 0);
#line 2013 "DockRenderer.c"
	} else {
		PlankSurface* _tmp136_;
		cairo_surface_t* _tmp137_;
		cairo_surface_t* _tmp138_;
#line 461 "DockRenderer.vala"
		_tmp136_ = self->priv->main_buffer;
#line 461 "DockRenderer.vala"
		_tmp137_ = plank_surface_get_Internal (_tmp136_);
#line 461 "DockRenderer.vala"
		_tmp138_ = _tmp137_;
#line 461 "DockRenderer.vala"
		cairo_set_source_surface (cr, _tmp138_, (gdouble) 0, (gdouble) 0);
#line 2026 "DockRenderer.c"
	}
#line 463 "DockRenderer.vala"
	cairo_paint (cr);
#line 466 "DockRenderer.vala"
	if (self->priv->show_notifications) {
#line 2032 "DockRenderer.c"
		gdouble _tmp140_;
#line 466 "DockRenderer.vala"
		_tmp140_ = self->priv->_hide_progress;
#line 466 "DockRenderer.vala"
		_tmp139_ = _tmp140_ == 1.0;
#line 2038 "DockRenderer.c"
	} else {
#line 466 "DockRenderer.vala"
		_tmp139_ = FALSE;
#line 2042 "DockRenderer.c"
	}
#line 466 "DockRenderer.vala"
	if (_tmp139_) {
#line 2046 "DockRenderer.c"
		{
			GeeArrayList* _item_list = NULL;
			GeeArrayList* _tmp141_;
			gint _item_size = 0;
			GeeArrayList* _tmp142_;
			gint _tmp143_;
			gint _tmp144_;
			gint _item_index = 0;
#line 467 "DockRenderer.vala"
			_tmp141_ = self->priv->current_items;
#line 467 "DockRenderer.vala"
			_item_list = _tmp141_;
#line 467 "DockRenderer.vala"
			_tmp142_ = _item_list;
#line 467 "DockRenderer.vala"
			_tmp143_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp142_);
#line 467 "DockRenderer.vala"
			_tmp144_ = _tmp143_;
#line 467 "DockRenderer.vala"
			_item_size = _tmp144_;
#line 467 "DockRenderer.vala"
			_item_index = -1;
#line 467 "DockRenderer.vala"
			while (TRUE) {
#line 2071 "DockRenderer.c"
				gint _tmp145_;
				gint _tmp146_;
				PlankDockItem* item = NULL;
				GeeArrayList* _tmp147_;
				gpointer _tmp148_;
				PlankDockItem* _tmp149_;
#line 467 "DockRenderer.vala"
				_item_index = _item_index + 1;
#line 467 "DockRenderer.vala"
				_tmp145_ = _item_index;
#line 467 "DockRenderer.vala"
				_tmp146_ = _item_size;
#line 467 "DockRenderer.vala"
				if (!(_tmp145_ < _tmp146_)) {
#line 467 "DockRenderer.vala"
					break;
#line 2088 "DockRenderer.c"
				}
#line 467 "DockRenderer.vala"
				_tmp147_ = _item_list;
#line 467 "DockRenderer.vala"
				_tmp148_ = gee_abstract_list_get ((GeeAbstractList*) _tmp147_, _item_index);
#line 467 "DockRenderer.vala"
				item = (PlankDockItem*) _tmp148_;
#line 468 "DockRenderer.vala"
				_tmp149_ = item;
#line 468 "DockRenderer.vala"
				plank_dock_renderer_draw_urgent_glow (self, _tmp149_, cr, _data1_->frame_time);
#line 2100 "DockRenderer.c"
			}
		}
	}
#line 480 "DockRenderer.vala"
	if (self->priv->is_first_frame) {
#line 2106 "DockRenderer.c"
		cairo_surface_t* _tmp150_;
		const gchar* _tmp151_;
#line 481 "DockRenderer.vala"
		_tmp150_ = cairo_get_target (cr);
#line 481 "DockRenderer.vala"
		_tmp151_ = plank_dock_renderer_cairo_surface_type_to_string (cairo_surface_get_type (_tmp150_));
#line 481 "DockRenderer.vala"
		g_message ("DockRenderer.vala:481: Cairo.SurfaceType: %s", _tmp151_);
#line 483 "DockRenderer.vala"
		gdk_threads_add_idle_full (G_PRIORITY_LOW, ____lambda47__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 504 "DockRenderer.vala"
		self->priv->is_first_frame = FALSE;
#line 2119 "DockRenderer.c"
	}
#line 339 "DockRenderer.vala"
	block1_data_unref (_data1_);
#line 339 "DockRenderer.vala"
	_data1_ = NULL;
#line 2125 "DockRenderer.c"
}

static void
plank_dock_renderer_draw_dock_background (PlankDockRenderer* self,
                                          cairo_t* cr,
                                          GdkRectangle* background_rect,
                                          gint x_offset,
                                          gint y_offset)
{
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GdkRectangle _tmp4_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	PlankSurface* _tmp8_;
	gboolean _tmp25_ = FALSE;
	gdouble _tmp26_;
	PlankSurface* _tmp35_;
	cairo_surface_t* _tmp36_;
	cairo_surface_t* _tmp37_;
	GdkRectangle _tmp38_;
	GdkRectangle _tmp39_;
#line 508 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 508 "DockRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 508 "DockRenderer.vala"
	g_return_if_fail (background_rect != NULL);
#line 510 "DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 510 "DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 510 "DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 510 "DockRenderer.vala"
	position_manager = _tmp2_;
#line 512 "DockRenderer.vala"
	_tmp4_ = *background_rect;
#line 512 "DockRenderer.vala"
	if (_tmp4_.width <= 0) {
#line 512 "DockRenderer.vala"
		_tmp3_ = TRUE;
#line 2171 "DockRenderer.c"
	} else {
		GdkRectangle _tmp5_;
#line 512 "DockRenderer.vala"
		_tmp5_ = *background_rect;
#line 512 "DockRenderer.vala"
		_tmp3_ = _tmp5_.height <= 0;
#line 2178 "DockRenderer.c"
	}
#line 512 "DockRenderer.vala"
	if (_tmp3_) {
#line 513 "DockRenderer.vala"
		_g_object_unref0 (self->priv->background_buffer);
#line 513 "DockRenderer.vala"
		self->priv->background_buffer = NULL;
#line 514 "DockRenderer.vala"
		return;
#line 2188 "DockRenderer.c"
	}
#line 517 "DockRenderer.vala"
	_tmp8_ = self->priv->background_buffer;
#line 517 "DockRenderer.vala"
	if (_tmp8_ == NULL) {
#line 517 "DockRenderer.vala"
		_tmp7_ = TRUE;
#line 2196 "DockRenderer.c"
	} else {
		PlankSurface* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		GdkRectangle _tmp12_;
#line 517 "DockRenderer.vala"
		_tmp9_ = self->priv->background_buffer;
#line 517 "DockRenderer.vala"
		_tmp10_ = plank_surface_get_Width (_tmp9_);
#line 517 "DockRenderer.vala"
		_tmp11_ = _tmp10_;
#line 517 "DockRenderer.vala"
		_tmp12_ = *background_rect;
#line 517 "DockRenderer.vala"
		_tmp7_ = _tmp11_ != _tmp12_.width;
#line 2212 "DockRenderer.c"
	}
#line 517 "DockRenderer.vala"
	if (_tmp7_) {
#line 517 "DockRenderer.vala"
		_tmp6_ = TRUE;
#line 2218 "DockRenderer.c"
	} else {
		PlankSurface* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		GdkRectangle _tmp16_;
#line 518 "DockRenderer.vala"
		_tmp13_ = self->priv->background_buffer;
#line 518 "DockRenderer.vala"
		_tmp14_ = plank_surface_get_Height (_tmp13_);
#line 518 "DockRenderer.vala"
		_tmp15_ = _tmp14_;
#line 518 "DockRenderer.vala"
		_tmp16_ = *background_rect;
#line 518 "DockRenderer.vala"
		_tmp6_ = _tmp15_ != _tmp16_.height;
#line 2234 "DockRenderer.c"
	}
#line 517 "DockRenderer.vala"
	if (_tmp6_) {
#line 2238 "DockRenderer.c"
		PlankDockTheme* _tmp17_;
		GdkRectangle _tmp18_;
		GdkRectangle _tmp19_;
		PlankPositionManager* _tmp20_;
		GtkPositionType _tmp21_;
		GtkPositionType _tmp22_;
		PlankSurface* _tmp23_;
		PlankSurface* _tmp24_;
#line 519 "DockRenderer.vala"
		_tmp17_ = self->priv->_theme;
#line 519 "DockRenderer.vala"
		_tmp18_ = *background_rect;
#line 519 "DockRenderer.vala"
		_tmp19_ = *background_rect;
#line 519 "DockRenderer.vala"
		_tmp20_ = position_manager;
#line 519 "DockRenderer.vala"
		_tmp21_ = plank_position_manager_get_Position (_tmp20_);
#line 519 "DockRenderer.vala"
		_tmp22_ = _tmp21_;
#line 519 "DockRenderer.vala"
		_tmp23_ = self->priv->main_buffer;
#line 519 "DockRenderer.vala"
		_tmp24_ = plank_dock_theme_create_background (_tmp17_, _tmp18_.width, _tmp19_.height, _tmp22_, _tmp23_);
#line 519 "DockRenderer.vala"
		_g_object_unref0 (self->priv->background_buffer);
#line 519 "DockRenderer.vala"
		self->priv->background_buffer = _tmp24_;
#line 2267 "DockRenderer.c"
	}
#line 522 "DockRenderer.vala"
	_tmp26_ = self->priv->_hide_progress;
#line 522 "DockRenderer.vala"
	if (_tmp26_ > 0.0) {
#line 2273 "DockRenderer.c"
		PlankDockTheme* _tmp27_;
		gboolean _tmp28_;
		gboolean _tmp29_;
#line 522 "DockRenderer.vala"
		_tmp27_ = self->priv->_theme;
#line 522 "DockRenderer.vala"
		_tmp28_ = plank_dock_theme_get_CascadeHide (_tmp27_);
#line 522 "DockRenderer.vala"
		_tmp29_ = _tmp28_;
#line 522 "DockRenderer.vala"
		_tmp25_ = _tmp29_;
#line 2285 "DockRenderer.c"
	} else {
#line 522 "DockRenderer.vala"
		_tmp25_ = FALSE;
#line 2289 "DockRenderer.c"
	}
#line 522 "DockRenderer.vala"
	if (_tmp25_) {
#line 2293 "DockRenderer.c"
		gint x = 0;
		gint y = 0;
		PlankPositionManager* _tmp30_;
		gint _tmp31_ = 0;
		gint _tmp32_ = 0;
		gdouble _tmp33_;
		gdouble _tmp34_;
#line 524 "DockRenderer.vala"
		_tmp30_ = position_manager;
#line 524 "DockRenderer.vala"
		plank_position_manager_get_background_padding (_tmp30_, &_tmp31_, &_tmp32_);
#line 524 "DockRenderer.vala"
		x = _tmp31_;
#line 524 "DockRenderer.vala"
		y = _tmp32_;
#line 525 "DockRenderer.vala"
		_tmp33_ = self->priv->_hide_progress;
#line 525 "DockRenderer.vala"
		x_offset = x_offset - ((gint) (x * _tmp33_));
#line 526 "DockRenderer.vala"
		_tmp34_ = self->priv->_hide_progress;
#line 526 "DockRenderer.vala"
		y_offset = y_offset - ((gint) (y * _tmp34_));
#line 2317 "DockRenderer.c"
	}
#line 529 "DockRenderer.vala"
	_tmp35_ = self->priv->background_buffer;
#line 529 "DockRenderer.vala"
	_tmp36_ = plank_surface_get_Internal (_tmp35_);
#line 529 "DockRenderer.vala"
	_tmp37_ = _tmp36_;
#line 529 "DockRenderer.vala"
	_tmp38_ = *background_rect;
#line 529 "DockRenderer.vala"
	_tmp39_ = *background_rect;
#line 529 "DockRenderer.vala"
	cairo_set_source_surface (cr, _tmp37_, (gdouble) (_tmp38_.x + x_offset), (gdouble) (_tmp39_.y + y_offset));
#line 530 "DockRenderer.vala"
	cairo_paint (cr);
#line 2333 "DockRenderer.c"
}

static void
plank_dock_renderer_animate_draw_value_for_item (PlankDockItem* item,
                                                 PlankDockItemDrawValue* draw_value,
                                                 PlankDockRenderer* self)
{
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	PlankDockItem* hovered_item = NULL;
	PlankDockController* _tmp3_;
	PlankDockWindow* _tmp4_;
	PlankDockWindow* _tmp5_;
	PlankDockItem* _tmp6_;
	PlankDockItem* _tmp7_;
	PlankDragManager* drag_manager = NULL;
	PlankDockController* _tmp8_;
	PlankDragManager* _tmp9_;
	PlankDragManager* _tmp10_;
	gint icon_size = 0;
	GtkPositionType position = 0;
	PlankPositionManager* _tmp11_;
	GtkPositionType _tmp12_;
	GtkPositionType _tmp13_;
	gdouble x_offset = 0.0;
	gdouble y_offset = 0.0;
	gint _tmp14_ = 0;
	PlankAnimationType _tmp15_;
	PlankAnimationType _tmp16_;
	gint max_click_time = 0;
	gint64 click_time = 0LL;
	gint64 _tmp23_;
	gint64 _tmp24_;
	gint64 _tmp25_;
	gint64 _tmp26_;
	guint max_scroll_time = 0U;
	gint64 scroll_time = 0LL;
	gint64 _tmp32_;
	gint64 _tmp33_;
	gint64 _tmp34_;
	gint64 _tmp35_;
	guint max_hover_time = 0U;
	gint64 hover_time = 0LL;
	gint64 _tmp38_;
	gint64 _tmp39_;
	gint64 _tmp40_;
	gint64 _tmp41_;
	gboolean _tmp46_ = FALSE;
	PlankDockItem* _tmp47_;
	gboolean _tmp60_ = FALSE;
	gboolean _tmp61_ = FALSE;
	PlankDockContainer* container = NULL;
	PlankDockContainer* _tmp74_;
	PlankDockContainer* _tmp75_;
	gboolean _tmp76_ = FALSE;
	gboolean allow_animation = FALSE;
	gboolean _tmp84_ = FALSE;
	PlankItemState _tmp121_;
	PlankItemState _tmp122_;
	PlankItemState _tmp141_;
	PlankItemState _tmp142_;
#line 534 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 534 "DockRenderer.vala"
	g_return_if_fail (item != NULL);
#line 534 "DockRenderer.vala"
	g_return_if_fail (draw_value != NULL);
#line 536 "DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 536 "DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 536 "DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 536 "DockRenderer.vala"
	position_manager = _tmp2_;
#line 537 "DockRenderer.vala"
	_tmp3_ = self->priv->_controller;
#line 537 "DockRenderer.vala"
	_tmp4_ = plank_dock_controller_get_window (_tmp3_);
#line 537 "DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 537 "DockRenderer.vala"
	_tmp6_ = plank_dock_window_get_HoveredItem (_tmp5_);
#line 537 "DockRenderer.vala"
	_tmp7_ = _tmp6_;
#line 537 "DockRenderer.vala"
	hovered_item = _tmp7_;
#line 538 "DockRenderer.vala"
	_tmp8_ = self->priv->_controller;
#line 538 "DockRenderer.vala"
	_tmp9_ = plank_dock_controller_get_drag_manager (_tmp8_);
#line 538 "DockRenderer.vala"
	_tmp10_ = _tmp9_;
#line 538 "DockRenderer.vala"
	drag_manager = _tmp10_;
#line 540 "DockRenderer.vala"
	icon_size = (gint) draw_value->icon_size;
#line 541 "DockRenderer.vala"
	_tmp11_ = position_manager;
#line 541 "DockRenderer.vala"
	_tmp12_ = plank_position_manager_get_Position (_tmp11_);
#line 541 "DockRenderer.vala"
	_tmp13_ = _tmp12_;
#line 541 "DockRenderer.vala"
	position = _tmp13_;
#line 542 "DockRenderer.vala"
	x_offset = 0.0;
#line 542 "DockRenderer.vala"
	y_offset = 0.0;
#line 545 "DockRenderer.vala"
	_tmp15_ = plank_dock_element_get_ClickedAnimation ((PlankDockElement*) item);
#line 545 "DockRenderer.vala"
	_tmp16_ = _tmp15_;
#line 545 "DockRenderer.vala"
	if (_tmp16_ == PLANK_ANIMATION_TYPE_BOUNCE) {
#line 2451 "DockRenderer.c"
		PlankDockTheme* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
#line 545 "DockRenderer.vala"
		_tmp17_ = self->priv->_theme;
#line 545 "DockRenderer.vala"
		_tmp18_ = plank_dock_theme_get_LaunchBounceTime (_tmp17_);
#line 545 "DockRenderer.vala"
		_tmp19_ = _tmp18_;
#line 545 "DockRenderer.vala"
		_tmp14_ = _tmp19_;
#line 2463 "DockRenderer.c"
	} else {
		PlankDockTheme* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
#line 545 "DockRenderer.vala"
		_tmp20_ = self->priv->_theme;
#line 545 "DockRenderer.vala"
		_tmp21_ = plank_dock_theme_get_ClickTime (_tmp20_);
#line 545 "DockRenderer.vala"
		_tmp22_ = _tmp21_;
#line 545 "DockRenderer.vala"
		_tmp14_ = _tmp22_;
#line 2476 "DockRenderer.c"
	}
#line 545 "DockRenderer.vala"
	max_click_time = _tmp14_;
#line 546 "DockRenderer.vala"
	max_click_time *= 1000;
#line 547 "DockRenderer.vala"
	_tmp23_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 547 "DockRenderer.vala"
	_tmp24_ = _tmp23_;
#line 547 "DockRenderer.vala"
	_tmp25_ = plank_dock_element_get_LastClicked ((PlankDockElement*) item);
#line 547 "DockRenderer.vala"
	_tmp26_ = _tmp25_;
#line 547 "DockRenderer.vala"
	click_time = MAX (0LL, _tmp24_ - _tmp26_);
#line 548 "DockRenderer.vala"
	if (click_time < ((gint64) max_click_time)) {
#line 2494 "DockRenderer.c"
		gdouble click_animation_progress = 0.0;
		PlankAnimationType _tmp27_;
		PlankAnimationType _tmp28_;
#line 549 "DockRenderer.vala"
		click_animation_progress = click_time / ((gdouble) max_click_time);
#line 551 "DockRenderer.vala"
		_tmp27_ = plank_dock_element_get_ClickedAnimation ((PlankDockElement*) item);
#line 551 "DockRenderer.vala"
		_tmp28_ = _tmp27_;
#line 551 "DockRenderer.vala"
		switch (_tmp28_) {
#line 2506 "DockRenderer.c"
			default:
#line 551 "DockRenderer.vala"
			case PLANK_ANIMATION_TYPE_NONE:
#line 2510 "DockRenderer.c"
			{
#line 554 "DockRenderer.vala"
				break;
#line 2514 "DockRenderer.c"
			}
#line 551 "DockRenderer.vala"
			case PLANK_ANIMATION_TYPE_BOUNCE:
#line 2518 "DockRenderer.c"
			{
#line 556 "DockRenderer.vala"
				if (self->priv->screen_is_composited) {
#line 2522 "DockRenderer.c"
					PlankPositionManager* _tmp29_;
					gint _tmp30_;
					gint _tmp31_;
#line 557 "DockRenderer.vala"
					_tmp29_ = position_manager;
#line 557 "DockRenderer.vala"
					_tmp30_ = plank_position_manager_get_LaunchBounceHeight (_tmp29_);
#line 557 "DockRenderer.vala"
					_tmp31_ = _tmp30_;
#line 557 "DockRenderer.vala"
					y_offset += _tmp31_ * plank_dock_renderer_easing_bounce ((gdouble) click_time, (gdouble) max_click_time, (gdouble) 2);
#line 2534 "DockRenderer.c"
				}
#line 558 "DockRenderer.vala"
				break;
#line 2538 "DockRenderer.c"
			}
#line 551 "DockRenderer.vala"
			case PLANK_ANIMATION_TYPE_DARKEN:
#line 2542 "DockRenderer.c"
			{
#line 560 "DockRenderer.vala"
				draw_value->darken = MAX ((gdouble) 0, sin (G_PI * click_animation_progress)) * 0.5;
#line 561 "DockRenderer.vala"
				break;
#line 2548 "DockRenderer.c"
			}
#line 551 "DockRenderer.vala"
			case PLANK_ANIMATION_TYPE_LIGHTEN:
#line 2552 "DockRenderer.c"
			{
#line 563 "DockRenderer.vala"
				draw_value->lighten = MAX ((gdouble) 0, sin (G_PI * click_animation_progress)) * 0.5;
#line 564 "DockRenderer.vala"
				break;
#line 2558 "DockRenderer.c"
			}
		}
	}
#line 569 "DockRenderer.vala"
	max_scroll_time = PLANK_ITEM_SCROLL_DURATION * 1000;
#line 570 "DockRenderer.vala"
	_tmp32_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 570 "DockRenderer.vala"
	_tmp33_ = _tmp32_;
#line 570 "DockRenderer.vala"
	_tmp34_ = plank_dock_element_get_LastScrolled ((PlankDockElement*) item);
#line 570 "DockRenderer.vala"
	_tmp35_ = _tmp34_;
#line 570 "DockRenderer.vala"
	scroll_time = MAX (0LL, _tmp33_ - _tmp35_);
#line 571 "DockRenderer.vala"
	if (scroll_time < ((gint64) max_scroll_time)) {
#line 2576 "DockRenderer.c"
		gdouble scroll_animation_progress = 0.0;
		PlankAnimationType _tmp36_;
		PlankAnimationType _tmp37_;
#line 572 "DockRenderer.vala"
		scroll_animation_progress = scroll_time / ((gdouble) max_scroll_time);
#line 574 "DockRenderer.vala"
		_tmp36_ = plank_dock_element_get_ScrolledAnimation ((PlankDockElement*) item);
#line 574 "DockRenderer.vala"
		_tmp37_ = _tmp36_;
#line 574 "DockRenderer.vala"
		switch (_tmp37_) {
#line 2588 "DockRenderer.c"
			default:
#line 574 "DockRenderer.vala"
			case PLANK_ANIMATION_TYPE_NONE:
#line 2592 "DockRenderer.c"
			{
#line 577 "DockRenderer.vala"
				break;
#line 2596 "DockRenderer.c"
			}
#line 574 "DockRenderer.vala"
			case PLANK_ANIMATION_TYPE_DARKEN:
#line 2600 "DockRenderer.c"
			{
#line 579 "DockRenderer.vala"
				draw_value->darken = MAX ((gdouble) 0, sin (G_PI * scroll_animation_progress)) * 0.5;
#line 580 "DockRenderer.vala"
				break;
#line 2606 "DockRenderer.c"
			}
#line 574 "DockRenderer.vala"
			case PLANK_ANIMATION_TYPE_LIGHTEN:
#line 2610 "DockRenderer.c"
			{
#line 582 "DockRenderer.vala"
				draw_value->lighten = MAX ((gdouble) 0, sin (G_PI * scroll_animation_progress)) * 0.5;
#line 583 "DockRenderer.vala"
				break;
#line 2616 "DockRenderer.c"
			}
		}
	}
#line 588 "DockRenderer.vala"
	max_hover_time = PLANK_ITEM_HOVER_DURATION * 1000;
#line 589 "DockRenderer.vala"
	_tmp38_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 589 "DockRenderer.vala"
	_tmp39_ = _tmp38_;
#line 589 "DockRenderer.vala"
	_tmp40_ = plank_dock_element_get_LastHovered ((PlankDockElement*) item);
#line 589 "DockRenderer.vala"
	_tmp41_ = _tmp40_;
#line 589 "DockRenderer.vala"
	hover_time = MAX (0LL, _tmp39_ - _tmp41_);
#line 590 "DockRenderer.vala"
	if (hover_time < ((gint64) max_hover_time)) {
#line 2634 "DockRenderer.c"
		gdouble hover_animation_progress = 0.0;
		PlankDockItem* _tmp42_;
		PlankAnimationType _tmp43_;
		PlankAnimationType _tmp44_;
#line 591 "DockRenderer.vala"
		hover_animation_progress = 0.0;
#line 592 "DockRenderer.vala"
		_tmp42_ = hovered_item;
#line 592 "DockRenderer.vala"
		if (_tmp42_ == item) {
#line 593 "DockRenderer.vala"
			hover_animation_progress = plank_easing_for_mode (PLANK_ANIMATION_MODE_LINEAR, (gdouble) hover_time, (gdouble) max_hover_time);
#line 2647 "DockRenderer.c"
		} else {
#line 595 "DockRenderer.vala"
			hover_animation_progress = 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_LINEAR, (gdouble) hover_time, (gdouble) max_hover_time);
#line 2651 "DockRenderer.c"
		}
#line 598 "DockRenderer.vala"
		_tmp43_ = plank_dock_element_get_HoveredAnimation ((PlankDockElement*) item);
#line 598 "DockRenderer.vala"
		_tmp44_ = _tmp43_;
#line 598 "DockRenderer.vala"
		switch (_tmp44_) {
#line 2659 "DockRenderer.c"
			default:
#line 598 "DockRenderer.vala"
			case PLANK_ANIMATION_TYPE_NONE:
#line 2663 "DockRenderer.c"
			{
#line 601 "DockRenderer.vala"
				break;
#line 2667 "DockRenderer.c"
			}
#line 598 "DockRenderer.vala"
			case PLANK_ANIMATION_TYPE_LIGHTEN:
#line 2671 "DockRenderer.c"
			{
#line 603 "DockRenderer.vala"
				draw_value->lighten = hover_animation_progress * 0.2;
#line 604 "DockRenderer.vala"
				break;
#line 2677 "DockRenderer.c"
			}
		}
	} else {
		PlankDockItem* _tmp45_;
#line 606 "DockRenderer.vala"
		_tmp45_ = hovered_item;
#line 606 "DockRenderer.vala"
		if (_tmp45_ == item) {
#line 607 "DockRenderer.vala"
			draw_value->lighten = 0.2;
#line 2688 "DockRenderer.c"
		}
	}
#line 610 "DockRenderer.vala"
	_tmp47_ = hovered_item;
#line 610 "DockRenderer.vala"
	if (_tmp47_ == item) {
#line 2695 "DockRenderer.c"
		PlankDockController* _tmp48_;
		PlankDockWindow* _tmp49_;
		PlankDockWindow* _tmp50_;
#line 610 "DockRenderer.vala"
		_tmp48_ = self->priv->_controller;
#line 610 "DockRenderer.vala"
		_tmp49_ = plank_dock_controller_get_window (_tmp48_);
#line 610 "DockRenderer.vala"
		_tmp50_ = _tmp49_;
#line 610 "DockRenderer.vala"
		_tmp46_ = plank_dock_window_menu_is_visible (_tmp50_);
#line 2707 "DockRenderer.c"
	} else {
#line 610 "DockRenderer.vala"
		_tmp46_ = FALSE;
#line 2711 "DockRenderer.c"
	}
#line 610 "DockRenderer.vala"
	if (_tmp46_) {
#line 611 "DockRenderer.vala"
		draw_value->darken = draw_value->darken + 0.4;
#line 2717 "DockRenderer.c"
	} else {
		gboolean _tmp51_ = FALSE;
		gboolean _tmp52_ = FALSE;
		PlankDragManager* _tmp53_;
		gboolean _tmp54_;
		gboolean _tmp55_;
#line 612 "DockRenderer.vala"
		_tmp53_ = drag_manager;
#line 612 "DockRenderer.vala"
		_tmp54_ = plank_drag_manager_get_ExternalDragActive (_tmp53_);
#line 612 "DockRenderer.vala"
		_tmp55_ = _tmp54_;
#line 612 "DockRenderer.vala"
		if (_tmp55_) {
#line 2732 "DockRenderer.c"
			PlankDragManager* _tmp56_;
			gboolean _tmp57_;
			gboolean _tmp58_;
#line 613 "DockRenderer.vala"
			_tmp56_ = drag_manager;
#line 613 "DockRenderer.vala"
			_tmp57_ = plank_drag_manager_get_DragNeedsCheck (_tmp56_);
#line 613 "DockRenderer.vala"
			_tmp58_ = _tmp57_;
#line 613 "DockRenderer.vala"
			_tmp52_ = _tmp58_;
#line 2744 "DockRenderer.c"
		} else {
#line 612 "DockRenderer.vala"
			_tmp52_ = FALSE;
#line 2748 "DockRenderer.c"
		}
#line 612 "DockRenderer.vala"
		if (_tmp52_) {
#line 2752 "DockRenderer.c"
			PlankDragManager* _tmp59_;
#line 614 "DockRenderer.vala"
			_tmp59_ = drag_manager;
#line 614 "DockRenderer.vala"
			_tmp51_ = !plank_drag_manager_drop_is_accepted_by (_tmp59_, item);
#line 2758 "DockRenderer.c"
		} else {
#line 612 "DockRenderer.vala"
			_tmp51_ = FALSE;
#line 2762 "DockRenderer.c"
		}
#line 612 "DockRenderer.vala"
		if (_tmp51_) {
#line 615 "DockRenderer.vala"
			draw_value->darken = draw_value->darken + 0.6;
#line 2768 "DockRenderer.c"
		}
	}
#line 618 "DockRenderer.vala"
	if (self->priv->screen_is_composited) {
#line 618 "DockRenderer.vala"
		_tmp61_ = self->priv->show_notifications;
#line 2775 "DockRenderer.c"
	} else {
#line 618 "DockRenderer.vala"
		_tmp61_ = FALSE;
#line 2779 "DockRenderer.c"
	}
#line 618 "DockRenderer.vala"
	if (_tmp61_) {
#line 2783 "DockRenderer.c"
		PlankItemState _tmp62_;
		PlankItemState _tmp63_;
#line 618 "DockRenderer.vala"
		_tmp62_ = plank_dock_item_get_State (item);
#line 618 "DockRenderer.vala"
		_tmp63_ = _tmp62_;
#line 618 "DockRenderer.vala"
		_tmp60_ = (_tmp63_ & PLANK_ITEM_STATE_URGENT) != 0;
#line 2792 "DockRenderer.c"
	} else {
#line 618 "DockRenderer.vala"
		_tmp60_ = FALSE;
#line 2796 "DockRenderer.c"
	}
#line 618 "DockRenderer.vala"
	if (_tmp60_) {
#line 2800 "DockRenderer.c"
		gint urgent_duration = 0;
		PlankDockTheme* _tmp64_;
		gint _tmp65_;
		gint _tmp66_;
		gint64 urgent_time = 0LL;
		gint64 _tmp67_;
		gint64 _tmp68_;
		gint64 _tmp69_;
		gint64 _tmp70_;
#line 619 "DockRenderer.vala"
		_tmp64_ = self->priv->_theme;
#line 619 "DockRenderer.vala"
		_tmp65_ = plank_dock_theme_get_UrgentBounceTime (_tmp64_);
#line 619 "DockRenderer.vala"
		_tmp66_ = _tmp65_;
#line 619 "DockRenderer.vala"
		urgent_duration = _tmp66_ * 1000;
#line 620 "DockRenderer.vala"
		_tmp67_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 620 "DockRenderer.vala"
		_tmp68_ = _tmp67_;
#line 620 "DockRenderer.vala"
		_tmp69_ = plank_dock_element_get_LastUrgent ((PlankDockElement*) item);
#line 620 "DockRenderer.vala"
		_tmp70_ = _tmp69_;
#line 620 "DockRenderer.vala"
		urgent_time = MAX (0LL, _tmp68_ - _tmp70_);
#line 621 "DockRenderer.vala"
		if (urgent_time < ((gint64) urgent_duration)) {
#line 2830 "DockRenderer.c"
			PlankPositionManager* _tmp71_;
			gint _tmp72_;
			gint _tmp73_;
#line 622 "DockRenderer.vala"
			_tmp71_ = position_manager;
#line 622 "DockRenderer.vala"
			_tmp72_ = plank_position_manager_get_UrgentBounceHeight (_tmp71_);
#line 622 "DockRenderer.vala"
			_tmp73_ = _tmp72_;
#line 622 "DockRenderer.vala"
			y_offset += _tmp73_ * plank_dock_renderer_easing_bounce ((gdouble) urgent_time, (gdouble) urgent_duration, 1.0);
#line 2842 "DockRenderer.c"
		}
	}
#line 626 "DockRenderer.vala"
	_tmp74_ = plank_dock_element_get_Container ((PlankDockElement*) item);
#line 626 "DockRenderer.vala"
	_tmp75_ = _tmp74_;
#line 626 "DockRenderer.vala"
	container = _tmp75_;
#line 627 "DockRenderer.vala"
	if (self->priv->screen_is_composited) {
#line 2853 "DockRenderer.c"
		gboolean _tmp77_ = FALSE;
		PlankDockContainer* _tmp78_;
#line 627 "DockRenderer.vala"
		_tmp78_ = container;
#line 627 "DockRenderer.vala"
		if (_tmp78_ == NULL) {
#line 627 "DockRenderer.vala"
			_tmp77_ = TRUE;
#line 2862 "DockRenderer.c"
		} else {
			PlankDockContainer* _tmp79_;
			gint64 _tmp80_;
			gint64 _tmp81_;
			gint64 _tmp82_;
			gint64 _tmp83_;
#line 627 "DockRenderer.vala"
			_tmp79_ = container;
#line 627 "DockRenderer.vala"
			_tmp80_ = plank_dock_element_get_AddTime ((PlankDockElement*) _tmp79_);
#line 627 "DockRenderer.vala"
			_tmp81_ = _tmp80_;
#line 627 "DockRenderer.vala"
			_tmp82_ = plank_dock_element_get_AddTime ((PlankDockElement*) item);
#line 627 "DockRenderer.vala"
			_tmp83_ = _tmp82_;
#line 627 "DockRenderer.vala"
			_tmp77_ = _tmp81_ < _tmp83_;
#line 2881 "DockRenderer.c"
		}
#line 627 "DockRenderer.vala"
		_tmp76_ = _tmp77_;
#line 2885 "DockRenderer.c"
	} else {
#line 627 "DockRenderer.vala"
		_tmp76_ = FALSE;
#line 2889 "DockRenderer.c"
	}
#line 627 "DockRenderer.vala"
	allow_animation = _tmp76_;
#line 628 "DockRenderer.vala"
	if (allow_animation) {
#line 2895 "DockRenderer.c"
		gint64 _tmp85_;
		gint64 _tmp86_;
		gint64 _tmp87_;
		gint64 _tmp88_;
#line 628 "DockRenderer.vala"
		_tmp85_ = plank_dock_element_get_AddTime ((PlankDockElement*) item);
#line 628 "DockRenderer.vala"
		_tmp86_ = _tmp85_;
#line 628 "DockRenderer.vala"
		_tmp87_ = plank_dock_element_get_RemoveTime ((PlankDockElement*) item);
#line 628 "DockRenderer.vala"
		_tmp88_ = _tmp87_;
#line 628 "DockRenderer.vala"
		_tmp84_ = _tmp86_ > _tmp88_;
#line 2910 "DockRenderer.c"
	} else {
#line 628 "DockRenderer.vala"
		_tmp84_ = FALSE;
#line 2914 "DockRenderer.c"
	}
#line 628 "DockRenderer.vala"
	if (_tmp84_) {
#line 2918 "DockRenderer.c"
		gint move_duration = 0;
		PlankDockTheme* _tmp89_;
		gint _tmp90_;
		gint _tmp91_;
		gint64 move_time = 0LL;
		gint64 _tmp92_;
		gint64 _tmp93_;
		gint64 _tmp94_;
		gint64 _tmp95_;
#line 629 "DockRenderer.vala"
		_tmp89_ = self->priv->_theme;
#line 629 "DockRenderer.vala"
		_tmp90_ = plank_dock_theme_get_ItemMoveTime (_tmp89_);
#line 629 "DockRenderer.vala"
		_tmp91_ = _tmp90_;
#line 629 "DockRenderer.vala"
		move_duration = _tmp91_ * 1000;
#line 630 "DockRenderer.vala"
		_tmp92_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 630 "DockRenderer.vala"
		_tmp93_ = _tmp92_;
#line 630 "DockRenderer.vala"
		_tmp94_ = plank_dock_element_get_AddTime ((PlankDockElement*) item);
#line 630 "DockRenderer.vala"
		_tmp95_ = _tmp94_;
#line 630 "DockRenderer.vala"
		move_time = MAX (0LL, _tmp93_ - _tmp95_);
#line 631 "DockRenderer.vala"
		if (move_time < ((gint64) move_duration)) {
#line 2948 "DockRenderer.c"
			gdouble move_animation_progress = 0.0;
			PlankPositionManager* _tmp96_;
			gint _tmp97_;
			gint _tmp98_;
			PlankPositionManager* _tmp99_;
			gint _tmp100_;
			gint _tmp101_;
#line 632 "DockRenderer.vala"
			move_animation_progress = 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_LINEAR, (gdouble) move_time, (gdouble) move_duration);
#line 633 "DockRenderer.vala"
			draw_value->opacity = plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_IN_EXPO, (gdouble) move_time, (gdouble) move_duration);
#line 634 "DockRenderer.vala"
			_tmp96_ = position_manager;
#line 634 "DockRenderer.vala"
			_tmp97_ = plank_position_manager_get_BottomPadding (_tmp96_);
#line 634 "DockRenderer.vala"
			_tmp98_ = _tmp97_;
#line 634 "DockRenderer.vala"
			y_offset -= move_animation_progress * (icon_size + _tmp98_);
#line 635 "DockRenderer.vala"
			draw_value->show_indicator = FALSE;
#line 638 "DockRenderer.vala"
			move_animation_progress = 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_OUT_QUINT, (gdouble) move_time, (gdouble) move_duration);
#line 639 "DockRenderer.vala"
			_tmp99_ = position_manager;
#line 639 "DockRenderer.vala"
			_tmp100_ = plank_position_manager_get_ItemPadding (_tmp99_);
#line 639 "DockRenderer.vala"
			_tmp101_ = _tmp100_;
#line 639 "DockRenderer.vala"
			self->priv->dynamic_animation_offset = self->priv->dynamic_animation_offset - (move_animation_progress * (icon_size + _tmp101_));
#line 640 "DockRenderer.vala"
			x_offset += self->priv->dynamic_animation_offset;
#line 2982 "DockRenderer.c"
		}
	} else {
		gboolean _tmp102_ = FALSE;
#line 642 "DockRenderer.vala"
		if (allow_animation) {
#line 2988 "DockRenderer.c"
			gint64 _tmp103_;
			gint64 _tmp104_;
#line 642 "DockRenderer.vala"
			_tmp103_ = plank_dock_element_get_RemoveTime ((PlankDockElement*) item);
#line 642 "DockRenderer.vala"
			_tmp104_ = _tmp103_;
#line 642 "DockRenderer.vala"
			_tmp102_ = _tmp104_ > ((gint64) 0);
#line 2997 "DockRenderer.c"
		} else {
#line 642 "DockRenderer.vala"
			_tmp102_ = FALSE;
#line 3001 "DockRenderer.c"
		}
#line 642 "DockRenderer.vala"
		if (_tmp102_) {
#line 3005 "DockRenderer.c"
			gint move_duration = 0;
			PlankDockTheme* _tmp105_;
			gint _tmp106_;
			gint _tmp107_;
			gint64 move_time = 0LL;
			gint64 _tmp108_;
			gint64 _tmp109_;
			gint64 _tmp110_;
			gint64 _tmp111_;
#line 643 "DockRenderer.vala"
			_tmp105_ = self->priv->_theme;
#line 643 "DockRenderer.vala"
			_tmp106_ = plank_dock_theme_get_ItemMoveTime (_tmp105_);
#line 643 "DockRenderer.vala"
			_tmp107_ = _tmp106_;
#line 643 "DockRenderer.vala"
			move_duration = _tmp107_ * 1000;
#line 644 "DockRenderer.vala"
			_tmp108_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 644 "DockRenderer.vala"
			_tmp109_ = _tmp108_;
#line 644 "DockRenderer.vala"
			_tmp110_ = plank_dock_element_get_RemoveTime ((PlankDockElement*) item);
#line 644 "DockRenderer.vala"
			_tmp111_ = _tmp110_;
#line 644 "DockRenderer.vala"
			move_time = MAX (0LL, _tmp109_ - _tmp111_);
#line 645 "DockRenderer.vala"
			if (move_time < ((gint64) move_duration)) {
#line 3035 "DockRenderer.c"
				gdouble move_animation_progress = 0.0;
				PlankPositionManager* _tmp112_;
				gint _tmp113_;
				gint _tmp114_;
				PlankPositionManager* _tmp115_;
				gint _tmp116_;
				gint _tmp117_;
				PlankPositionManager* _tmp118_;
				gint _tmp119_;
				gint _tmp120_;
#line 646 "DockRenderer.vala"
				move_animation_progress = plank_easing_for_mode (PLANK_ANIMATION_MODE_LINEAR, (gdouble) move_time, (gdouble) move_duration);
#line 647 "DockRenderer.vala"
				draw_value->opacity = 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_OUT_EXPO, (gdouble) move_time, (gdouble) move_duration);
#line 648 "DockRenderer.vala"
				_tmp112_ = position_manager;
#line 648 "DockRenderer.vala"
				_tmp113_ = plank_position_manager_get_BottomPadding (_tmp112_);
#line 648 "DockRenderer.vala"
				_tmp114_ = _tmp113_;
#line 648 "DockRenderer.vala"
				y_offset -= move_animation_progress * (icon_size + _tmp114_);
#line 649 "DockRenderer.vala"
				draw_value->show_indicator = FALSE;
#line 652 "DockRenderer.vala"
				move_animation_progress = 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_IN_QUINT, (gdouble) move_time, (gdouble) move_duration);
#line 653 "DockRenderer.vala"
				_tmp115_ = position_manager;
#line 653 "DockRenderer.vala"
				_tmp116_ = plank_position_manager_get_ItemPadding (_tmp115_);
#line 653 "DockRenderer.vala"
				_tmp117_ = _tmp116_;
#line 653 "DockRenderer.vala"
				self->priv->dynamic_animation_offset = self->priv->dynamic_animation_offset + (move_animation_progress * (icon_size + _tmp117_));
#line 654 "DockRenderer.vala"
				_tmp118_ = position_manager;
#line 654 "DockRenderer.vala"
				_tmp119_ = plank_position_manager_get_ItemPadding (_tmp118_);
#line 654 "DockRenderer.vala"
				_tmp120_ = _tmp119_;
#line 654 "DockRenderer.vala"
				x_offset += self->priv->dynamic_animation_offset - (icon_size + _tmp120_);
#line 3078 "DockRenderer.c"
			}
		}
	}
#line 659 "DockRenderer.vala"
	_tmp121_ = plank_dock_item_get_State (item);
#line 659 "DockRenderer.vala"
	_tmp122_ = _tmp121_;
#line 659 "DockRenderer.vala"
	if ((_tmp122_ & PLANK_ITEM_STATE_MOVE) != 0) {
#line 3088 "DockRenderer.c"
		gint move_duration = 0;
		PlankDockTheme* _tmp123_;
		gint _tmp124_;
		gint _tmp125_;
		gint64 move_time = 0LL;
		gint64 _tmp126_;
		gint64 _tmp127_;
		gint64 _tmp128_;
		gint64 _tmp129_;
#line 660 "DockRenderer.vala"
		_tmp123_ = self->priv->_theme;
#line 660 "DockRenderer.vala"
		_tmp124_ = plank_dock_theme_get_ItemMoveTime (_tmp123_);
#line 660 "DockRenderer.vala"
		_tmp125_ = _tmp124_;
#line 660 "DockRenderer.vala"
		move_duration = _tmp125_ * 1000;
#line 661 "DockRenderer.vala"
		_tmp126_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 661 "DockRenderer.vala"
		_tmp127_ = _tmp126_;
#line 661 "DockRenderer.vala"
		_tmp128_ = plank_dock_element_get_LastMove ((PlankDockElement*) item);
#line 661 "DockRenderer.vala"
		_tmp129_ = _tmp128_;
#line 661 "DockRenderer.vala"
		move_time = MAX (0LL, _tmp127_ - _tmp129_);
#line 662 "DockRenderer.vala"
		if (move_time < ((gint64) move_duration)) {
#line 3118 "DockRenderer.c"
			gdouble move_animation_progress = 0.0;
			GeeHashSet* _tmp130_;
			gint _tmp131_;
			gint _tmp132_;
			gdouble change = 0.0;
			PlankPositionManager* _tmp133_;
			gint _tmp134_;
			gint _tmp135_;
			gdouble _tmp136_ = 0.0;
			gint _tmp137_;
			gint _tmp138_;
			gint _tmp139_;
			gint _tmp140_;
#line 663 "DockRenderer.vala"
			move_animation_progress = 0.0;
#line 664 "DockRenderer.vala"
			_tmp130_ = self->priv->transient_items;
#line 664 "DockRenderer.vala"
			_tmp131_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp130_);
#line 664 "DockRenderer.vala"
			_tmp132_ = _tmp131_;
#line 664 "DockRenderer.vala"
			if (_tmp132_ > 0) {
#line 665 "DockRenderer.vala"
				if (self->priv->dynamic_animation_offset > ((gdouble) 0)) {
#line 666 "DockRenderer.vala"
					move_animation_progress = 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_IN_QUINT, (gdouble) move_time, (gdouble) move_duration);
#line 3146 "DockRenderer.c"
				} else {
#line 668 "DockRenderer.vala"
					move_animation_progress = 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_OUT_QUINT, (gdouble) move_time, (gdouble) move_duration);
#line 3150 "DockRenderer.c"
				}
			} else {
#line 670 "DockRenderer.vala"
				move_animation_progress = 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_OUT_CIRC, (gdouble) move_time, (gdouble) move_duration);
#line 3155 "DockRenderer.c"
			}
#line 672 "DockRenderer.vala"
			_tmp133_ = position_manager;
#line 672 "DockRenderer.vala"
			_tmp134_ = plank_position_manager_get_ItemPadding (_tmp133_);
#line 672 "DockRenderer.vala"
			_tmp135_ = _tmp134_;
#line 672 "DockRenderer.vala"
			change = move_animation_progress * (icon_size + _tmp135_);
#line 673 "DockRenderer.vala"
			_tmp137_ = plank_dock_item_get_Position (item);
#line 673 "DockRenderer.vala"
			_tmp138_ = _tmp137_;
#line 673 "DockRenderer.vala"
			_tmp139_ = plank_dock_item_get_LastPosition (item);
#line 673 "DockRenderer.vala"
			_tmp140_ = _tmp139_;
#line 673 "DockRenderer.vala"
			if (_tmp138_ < _tmp140_) {
#line 673 "DockRenderer.vala"
				_tmp136_ = change;
#line 3177 "DockRenderer.c"
			} else {
#line 673 "DockRenderer.vala"
				_tmp136_ = -change;
#line 3181 "DockRenderer.c"
			}
#line 673 "DockRenderer.vala"
			x_offset += _tmp136_;
#line 3185 "DockRenderer.c"
		} else {
#line 675 "DockRenderer.vala"
			plank_dock_item_unset_move_state (item);
#line 3189 "DockRenderer.c"
		}
	}
#line 680 "DockRenderer.vala"
	_tmp141_ = plank_dock_item_get_State (item);
#line 680 "DockRenderer.vala"
	_tmp142_ = _tmp141_;
#line 680 "DockRenderer.vala"
	if ((_tmp142_ & PLANK_ITEM_STATE_INVALID) != 0) {
#line 3198 "DockRenderer.c"
		guint invalid_duration = 0U;
		gint64 invalid_time = 0LL;
		gint64 _tmp143_;
		gint64 _tmp144_;
		gint64 _tmp145_;
		gint64 _tmp146_;
#line 681 "DockRenderer.vala"
		invalid_duration = PLANK_ITEM_INVALID_DURATION * 1000;
#line 682 "DockRenderer.vala"
		_tmp143_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 682 "DockRenderer.vala"
		_tmp144_ = _tmp143_;
#line 682 "DockRenderer.vala"
		_tmp145_ = plank_dock_element_get_LastValid ((PlankDockElement*) item);
#line 682 "DockRenderer.vala"
		_tmp146_ = _tmp145_;
#line 682 "DockRenderer.vala"
		invalid_time = MAX (0LL, _tmp144_ - _tmp146_);
#line 683 "DockRenderer.vala"
		if (invalid_time < ((gint64) invalid_duration)) {
#line 684 "DockRenderer.vala"
			draw_value->opacity = 0.10 + ((0.90 * (cos (((invalid_time / ((gdouble) invalid_duration)) * 4.5) * G_PI) + 1)) / 2);
#line 3221 "DockRenderer.c"
		} else {
#line 686 "DockRenderer.vala"
			draw_value->opacity = 0.10;
#line 3225 "DockRenderer.c"
		}
	}
#line 690 "DockRenderer.vala"
	if (x_offset != 0.0) {
#line 691 "DockRenderer.vala"
		plank_dock_item_draw_value_move_right (draw_value, position, x_offset);
#line 3232 "DockRenderer.c"
	}
#line 693 "DockRenderer.vala"
	if (y_offset != 0.0) {
#line 694 "DockRenderer.vala"
		plank_dock_item_draw_value_move_in (draw_value, position, y_offset);
#line 3238 "DockRenderer.c"
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 698 "DockRenderer.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 698 "DockRenderer.vala"
	return _data2_;
#line 3249 "DockRenderer.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 698 "DockRenderer.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 3259 "DockRenderer.c"
		PlankDockRenderer* self;
#line 698 "DockRenderer.vala"
		self = _data2_->self;
#line 698 "DockRenderer.vala"
		_g_object_unref0 (self);
#line 698 "DockRenderer.vala"
		g_slice_free (Block2Data, _data2_);
#line 3267 "DockRenderer.c"
	}
}

static gboolean
__lambda46_ (Block2Data* _data2_,
             PlankDockElement* i,
             PlankDockItemDrawValue* val)
{
	PlankDockRenderer* self;
	gboolean result;
#line 737 "DockRenderer.vala"
	self = _data2_->self;
#line 737 "DockRenderer.vala"
	g_return_val_if_fail (i != NULL, FALSE);
#line 738 "DockRenderer.vala"
	plank_dock_item_draw_value_move_right (val, _data2_->position, _data2_->x_offset);
#line 739 "DockRenderer.vala"
	result = TRUE;
#line 739 "DockRenderer.vala"
	return result;
#line 3288 "DockRenderer.c"
}

static gboolean
___lambda46__gee_forall_map_func (gconstpointer k,
                                  gconstpointer v,
                                  gpointer self)
{
	gboolean result;
	result = __lambda46_ (self, (PlankDockElement*) k, (PlankDockItemDrawValue*) v);
#line 737 "DockRenderer.vala"
	return result;
#line 3300 "DockRenderer.c"
}

static void
plank_dock_renderer_post_process_draw_values (GeeHashMap* draw_values,
                                              PlankDockRenderer* self)
{
	Block2Data* _data2_;
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	PlankPositionManager* _tmp3_;
	GtkPositionType _tmp4_;
	GtkPositionType _tmp5_;
	PlankPositionManager* _tmp6_;
	GtkAlign _tmp7_;
	GtkAlign _tmp8_;
	GeeMapIterator* _tmp12_;
	GeeMapIterator* _tmp13_;
#line 698 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 698 "DockRenderer.vala"
	g_return_if_fail (draw_values != NULL);
#line 698 "DockRenderer.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 698 "DockRenderer.vala"
	_data2_->_ref_count_ = 1;
#line 698 "DockRenderer.vala"
	_data2_->self = g_object_ref (self);
#line 700 "DockRenderer.vala"
	if (self->priv->dynamic_animation_offset == 0.0) {
#line 701 "DockRenderer.vala"
		block2_data_unref (_data2_);
#line 701 "DockRenderer.vala"
		_data2_ = NULL;
#line 701 "DockRenderer.vala"
		return;
#line 3338 "DockRenderer.c"
	}
#line 703 "DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 703 "DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 703 "DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 703 "DockRenderer.vala"
	position_manager = _tmp2_;
#line 704 "DockRenderer.vala"
	_tmp3_ = position_manager;
#line 704 "DockRenderer.vala"
	_tmp4_ = plank_position_manager_get_Position (_tmp3_);
#line 704 "DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 704 "DockRenderer.vala"
	_data2_->position = _tmp5_;
#line 706 "DockRenderer.vala"
	_data2_->x_offset = 0.0;
#line 708 "DockRenderer.vala"
	_tmp6_ = position_manager;
#line 708 "DockRenderer.vala"
	_tmp7_ = plank_position_manager_get_Alignment (_tmp6_);
#line 708 "DockRenderer.vala"
	_tmp8_ = _tmp7_;
#line 708 "DockRenderer.vala"
	switch (_tmp8_) {
#line 3366 "DockRenderer.c"
		default:
#line 708 "DockRenderer.vala"
		case GTK_ALIGN_CENTER:
#line 3370 "DockRenderer.c"
		{
#line 711 "DockRenderer.vala"
			_data2_->x_offset -= round (self->priv->dynamic_animation_offset / 2.0);
#line 712 "DockRenderer.vala"
			break;
#line 3376 "DockRenderer.c"
		}
#line 708 "DockRenderer.vala"
		case GTK_ALIGN_START:
#line 3380 "DockRenderer.c"
		{
#line 714 "DockRenderer.vala"
			break;
#line 3384 "DockRenderer.c"
		}
#line 708 "DockRenderer.vala"
		case GTK_ALIGN_END:
#line 3388 "DockRenderer.c"
		{
#line 716 "DockRenderer.vala"
			_data2_->x_offset -= round (self->priv->dynamic_animation_offset);
#line 717 "DockRenderer.vala"
			break;
#line 3394 "DockRenderer.c"
		}
#line 708 "DockRenderer.vala"
		case GTK_ALIGN_FILL:
#line 3398 "DockRenderer.c"
		{
			PlankPositionManager* _tmp9_;
			GtkAlign _tmp10_;
			GtkAlign _tmp11_;
#line 719 "DockRenderer.vala"
			_tmp9_ = position_manager;
#line 719 "DockRenderer.vala"
			_tmp10_ = plank_position_manager_get_ItemsAlignment (_tmp9_);
#line 719 "DockRenderer.vala"
			_tmp11_ = _tmp10_;
#line 719 "DockRenderer.vala"
			switch (_tmp11_) {
#line 3411 "DockRenderer.c"
				default:
#line 719 "DockRenderer.vala"
				case GTK_ALIGN_FILL:
#line 719 "DockRenderer.vala"
				case GTK_ALIGN_CENTER:
#line 3417 "DockRenderer.c"
				{
#line 723 "DockRenderer.vala"
					_data2_->x_offset -= round (self->priv->dynamic_animation_offset / 2.0);
#line 724 "DockRenderer.vala"
					break;
#line 3423 "DockRenderer.c"
				}
#line 719 "DockRenderer.vala"
				case GTK_ALIGN_START:
#line 3427 "DockRenderer.c"
				{
#line 726 "DockRenderer.vala"
					break;
#line 3431 "DockRenderer.c"
				}
#line 719 "DockRenderer.vala"
				case GTK_ALIGN_END:
#line 3435 "DockRenderer.c"
				{
#line 728 "DockRenderer.vala"
					_data2_->x_offset -= round (self->priv->dynamic_animation_offset);
#line 729 "DockRenderer.vala"
					break;
#line 3441 "DockRenderer.c"
				}
			}
#line 731 "DockRenderer.vala"
			break;
#line 3446 "DockRenderer.c"
		}
	}
#line 734 "DockRenderer.vala"
	if (_data2_->x_offset == 0.0) {
#line 735 "DockRenderer.vala"
		block2_data_unref (_data2_);
#line 735 "DockRenderer.vala"
		_data2_ = NULL;
#line 735 "DockRenderer.vala"
		return;
#line 3457 "DockRenderer.c"
	}
#line 737 "DockRenderer.vala"
	_tmp12_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) draw_values);
#line 737 "DockRenderer.vala"
	_tmp13_ = _tmp12_;
#line 737 "DockRenderer.vala"
	gee_map_iterator_foreach (_tmp13_, ___lambda46__gee_forall_map_func, _data2_);
#line 737 "DockRenderer.vala"
	_g_object_unref0 (_tmp13_);
#line 698 "DockRenderer.vala"
	block2_data_unref (_data2_);
#line 698 "DockRenderer.vala"
	_data2_ = NULL;
#line 3471 "DockRenderer.c"
}

static inline PlankSurface*
plank_dock_renderer_get_item_surface (PlankDockRenderer* self,
                                      PlankDockItem* item,
                                      gint icon_size)
{
	PlankSurface* private_icon_surface = NULL;
	PlankSurface* _tmp0_;
	PlankSurface* _tmp1_;
	gchar* drawing_status = NULL;
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp2_;
	PlankPositionManager* _tmp3_;
	PlankPositionManager* _tmp4_;
	gint max_icon_size = 0;
	PlankPositionManager* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean _tmp8_ = FALSE;
	PlankSurface* result;
#line 743 "DockRenderer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 743 "DockRenderer.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 745 "DockRenderer.vala"
	_tmp0_ = self->priv->item_buffer;
#line 745 "DockRenderer.vala"
	_tmp1_ = plank_dock_item_get_surface (item, icon_size, icon_size, _tmp0_);
#line 745 "DockRenderer.vala"
	private_icon_surface = _tmp1_;
#line 746 "DockRenderer.vala"
	if (!self->priv->screen_is_composited) {
#line 747 "DockRenderer.vala"
		result = private_icon_surface;
#line 747 "DockRenderer.vala"
		return result;
#line 3509 "DockRenderer.c"
	}
#line 753 "DockRenderer.vala"
	_tmp2_ = self->priv->_controller;
#line 753 "DockRenderer.vala"
	_tmp3_ = plank_dock_controller_get_position_manager (_tmp2_);
#line 753 "DockRenderer.vala"
	_tmp4_ = _tmp3_;
#line 753 "DockRenderer.vala"
	position_manager = _tmp4_;
#line 754 "DockRenderer.vala"
	_tmp5_ = position_manager;
#line 754 "DockRenderer.vala"
	_tmp6_ = plank_position_manager_get_ZoomIconSize (_tmp5_);
#line 754 "DockRenderer.vala"
	_tmp7_ = _tmp6_;
#line 754 "DockRenderer.vala"
	max_icon_size = _tmp7_ * self->priv->window_scale_factor;
#line 755 "DockRenderer.vala"
	if (icon_size < max_icon_size) {
#line 3529 "DockRenderer.c"
		gboolean _tmp9_ = FALSE;
		PlankSurface* _tmp10_;
		gpointer _tmp11_;
		const gchar* _tmp12_;
#line 756 "DockRenderer.vala"
		_tmp10_ = private_icon_surface;
#line 756 "DockRenderer.vala"
		_tmp11_ = g_object_steal_qdata ((GObject*) _tmp10_, plank_quark_surface_stats);
#line 756 "DockRenderer.vala"
		_g_free0 (drawing_status);
#line 756 "DockRenderer.vala"
		drawing_status = (gchar*) _tmp11_;
#line 756 "DockRenderer.vala"
		_tmp12_ = drawing_status;
#line 756 "DockRenderer.vala"
		if (_tmp12_ != NULL) {
#line 3546 "DockRenderer.c"
			const gchar* _tmp13_;
#line 757 "DockRenderer.vala"
			_tmp13_ = drawing_status;
#line 757 "DockRenderer.vala"
			_tmp9_ = g_strcmp0 (_tmp13_, PLANK_SURFACE_STATS_DRAWING_TIME_EXCEEDED) == 0;
#line 3552 "DockRenderer.c"
		} else {
#line 756 "DockRenderer.vala"
			_tmp9_ = FALSE;
#line 3556 "DockRenderer.c"
		}
#line 756 "DockRenderer.vala"
		_tmp8_ = _tmp9_;
#line 3560 "DockRenderer.c"
	} else {
#line 755 "DockRenderer.vala"
		_tmp8_ = FALSE;
#line 3564 "DockRenderer.c"
	}
#line 755 "DockRenderer.vala"
	if (_tmp8_) {
#line 3568 "DockRenderer.c"
		PlankSurface* _tmp14_;
		PlankSurface* _tmp15_;
		PlankSurface* _tmp16_;
#line 758 "DockRenderer.vala"
		_tmp14_ = self->priv->item_buffer;
#line 758 "DockRenderer.vala"
		_tmp15_ = plank_dock_item_get_surface (item, max_icon_size, max_icon_size, _tmp14_);
#line 758 "DockRenderer.vala"
		_tmp16_ = _tmp15_;
#line 758 "DockRenderer.vala"
		_g_object_unref0 (_tmp16_);
#line 3580 "DockRenderer.c"
	}
#line 760 "DockRenderer.vala"
	result = private_icon_surface;
#line 760 "DockRenderer.vala"
	_g_free0 (drawing_status);
#line 760 "DockRenderer.vala"
	return result;
#line 3588 "DockRenderer.c"
}

static void
plank_dock_renderer_draw_item (PlankDockRenderer* self,
                               cairo_t* cr,
                               PlankDockItem* item,
                               PlankDockItemDrawValue* draw_value,
                               gint64 frame_time)
{
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	gint icon_size = 0;
	GtkPositionType position = 0;
	PlankPositionManager* _tmp3_;
	GtkPositionType _tmp4_;
	GtkPositionType _tmp5_;
	PlankSurface* icon_surface = NULL;
	PlankSurface* _tmp6_;
	PlankSurface* _tmp7_;
	PlankSurface* _tmp8_;
	PlankSurface* _tmp9_;
	cairo_t* icon_cr = NULL;
	PlankSurface* _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
	PlankSurface* icon_overlay_surface = NULL;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_;
	gboolean _tmp15_;
	PlankSurface* _tmp20_;
	gint64 active_time = 0LL;
	gint64 _tmp40_;
	gint64 _tmp41_;
	gdouble opacity = 0.0;
	PlankDockTheme* _tmp42_;
	gint _tmp43_;
	gint _tmp44_;
	PlankItemState _tmp45_;
	PlankItemState _tmp46_;
	GdkRectangle draw_region = {0};
	GdkRectangle _tmp53_;
	PlankSurface* _tmp54_;
	cairo_surface_t* _tmp55_;
	cairo_surface_t* _tmp56_;
	GdkRectangle _tmp57_;
	GdkRectangle _tmp58_;
	gboolean _tmp59_ = FALSE;
#line 763 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 763 "DockRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 763 "DockRenderer.vala"
	g_return_if_fail (item != NULL);
#line 763 "DockRenderer.vala"
	g_return_if_fail (draw_value != NULL);
#line 765 "DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 765 "DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 765 "DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 765 "DockRenderer.vala"
	position_manager = _tmp2_;
#line 766 "DockRenderer.vala"
	icon_size = ((gint) draw_value->icon_size) * self->priv->window_scale_factor;
#line 767 "DockRenderer.vala"
	_tmp3_ = position_manager;
#line 767 "DockRenderer.vala"
	_tmp4_ = plank_position_manager_get_Position (_tmp3_);
#line 767 "DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 767 "DockRenderer.vala"
	position = _tmp5_;
#line 773 "DockRenderer.vala"
	_tmp6_ = plank_dock_renderer_get_item_surface (self, item, icon_size);
#line 773 "DockRenderer.vala"
	_tmp7_ = _tmp6_;
#line 773 "DockRenderer.vala"
	_tmp8_ = plank_surface_copy (_tmp7_);
#line 773 "DockRenderer.vala"
	_tmp9_ = _tmp8_;
#line 773 "DockRenderer.vala"
	_g_object_unref0 (_tmp7_);
#line 773 "DockRenderer.vala"
	icon_surface = _tmp9_;
#line 774 "DockRenderer.vala"
	_tmp10_ = icon_surface;
#line 774 "DockRenderer.vala"
	_tmp11_ = plank_surface_get_Context (_tmp10_);
#line 774 "DockRenderer.vala"
	_tmp12_ = _tmp11_;
#line 774 "DockRenderer.vala"
	icon_cr = _tmp12_;
#line 776 "DockRenderer.vala"
	icon_overlay_surface = NULL;
#line 777 "DockRenderer.vala"
	_tmp14_ = plank_dock_item_get_CountVisible (item);
#line 777 "DockRenderer.vala"
	_tmp15_ = _tmp14_;
#line 777 "DockRenderer.vala"
	if (_tmp15_) {
#line 777 "DockRenderer.vala"
		_tmp13_ = TRUE;
#line 3694 "DockRenderer.c"
	} else {
		gboolean _tmp16_;
		gboolean _tmp17_;
#line 777 "DockRenderer.vala"
		_tmp16_ = plank_dock_item_get_ProgressVisible (item);
#line 777 "DockRenderer.vala"
		_tmp17_ = _tmp16_;
#line 777 "DockRenderer.vala"
		_tmp13_ = _tmp17_;
#line 3704 "DockRenderer.c"
	}
#line 777 "DockRenderer.vala"
	if (_tmp13_) {
#line 3708 "DockRenderer.c"
		PlankSurface* _tmp18_;
		PlankSurface* _tmp19_;
#line 778 "DockRenderer.vala"
		_tmp18_ = self->priv->item_buffer;
#line 778 "DockRenderer.vala"
		_tmp19_ = plank_dock_item_get_foreground_surface (item, icon_size, icon_size, _tmp18_, (PlankDrawDataFunc) plank_dock_renderer_draw_item_foreground, self);
#line 778 "DockRenderer.vala"
		_g_object_unref0 (icon_overlay_surface);
#line 778 "DockRenderer.vala"
		icon_overlay_surface = _tmp19_;
#line 3719 "DockRenderer.c"
	}
#line 780 "DockRenderer.vala"
	_tmp20_ = icon_overlay_surface;
#line 780 "DockRenderer.vala"
	if (_tmp20_ != NULL) {
#line 3725 "DockRenderer.c"
		cairo_t* _tmp21_;
		PlankSurface* _tmp22_;
		cairo_surface_t* _tmp23_;
		cairo_surface_t* _tmp24_;
		cairo_t* _tmp25_;
#line 781 "DockRenderer.vala"
		_tmp21_ = icon_cr;
#line 781 "DockRenderer.vala"
		_tmp22_ = icon_overlay_surface;
#line 781 "DockRenderer.vala"
		_tmp23_ = plank_surface_get_Internal (_tmp22_);
#line 781 "DockRenderer.vala"
		_tmp24_ = _tmp23_;
#line 781 "DockRenderer.vala"
		cairo_set_source_surface (_tmp21_, _tmp24_, (gdouble) 0, (gdouble) 0);
#line 782 "DockRenderer.vala"
		_tmp25_ = icon_cr;
#line 782 "DockRenderer.vala"
		cairo_paint (_tmp25_);
#line 3745 "DockRenderer.c"
	}
#line 791 "DockRenderer.vala"
	if (draw_value->lighten > ((gdouble) 0)) {
#line 3749 "DockRenderer.c"
		cairo_t* _tmp26_;
		cairo_t* _tmp27_;
		cairo_t* _tmp28_;
#line 792 "DockRenderer.vala"
		_tmp26_ = icon_cr;
#line 792 "DockRenderer.vala"
		cairo_set_operator (_tmp26_, CAIRO_OPERATOR_ADD);
#line 793 "DockRenderer.vala"
		_tmp27_ = icon_cr;
#line 793 "DockRenderer.vala"
		cairo_paint_with_alpha (_tmp27_, draw_value->lighten);
#line 794 "DockRenderer.vala"
		_tmp28_ = icon_cr;
#line 794 "DockRenderer.vala"
		cairo_set_operator (_tmp28_, CAIRO_OPERATOR_OVER);
#line 3765 "DockRenderer.c"
	}
#line 798 "DockRenderer.vala"
	if (draw_value->darken > ((gdouble) 0)) {
#line 3769 "DockRenderer.c"
		cairo_t* _tmp29_;
		PlankSurface* _tmp30_;
		gint _tmp31_;
		gint _tmp32_;
		PlankSurface* _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
		cairo_t* _tmp36_;
		cairo_t* _tmp37_;
		cairo_t* _tmp38_;
		cairo_t* _tmp39_;
#line 799 "DockRenderer.vala"
		_tmp29_ = icon_cr;
#line 799 "DockRenderer.vala"
		_tmp30_ = icon_surface;
#line 799 "DockRenderer.vala"
		_tmp31_ = plank_surface_get_Width (_tmp30_);
#line 799 "DockRenderer.vala"
		_tmp32_ = _tmp31_;
#line 799 "DockRenderer.vala"
		_tmp33_ = icon_surface;
#line 799 "DockRenderer.vala"
		_tmp34_ = plank_surface_get_Height (_tmp33_);
#line 799 "DockRenderer.vala"
		_tmp35_ = _tmp34_;
#line 799 "DockRenderer.vala"
		cairo_rectangle (_tmp29_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp32_, (gdouble) _tmp35_);
#line 800 "DockRenderer.vala"
		_tmp36_ = icon_cr;
#line 800 "DockRenderer.vala"
		cairo_set_source_rgba (_tmp36_, (gdouble) 0, (gdouble) 0, (gdouble) 0, draw_value->darken);
#line 801 "DockRenderer.vala"
		_tmp37_ = icon_cr;
#line 801 "DockRenderer.vala"
		cairo_set_operator (_tmp37_, CAIRO_OPERATOR_ATOP);
#line 802 "DockRenderer.vala"
		_tmp38_ = icon_cr;
#line 802 "DockRenderer.vala"
		cairo_fill (_tmp38_);
#line 803 "DockRenderer.vala"
		_tmp39_ = icon_cr;
#line 803 "DockRenderer.vala"
		cairo_set_operator (_tmp39_, CAIRO_OPERATOR_OVER);
#line 3813 "DockRenderer.c"
	}
#line 807 "DockRenderer.vala"
	_tmp40_ = plank_dock_element_get_LastActive ((PlankDockElement*) item);
#line 807 "DockRenderer.vala"
	_tmp41_ = _tmp40_;
#line 807 "DockRenderer.vala"
	active_time = MAX (0LL, frame_time - _tmp41_);
#line 808 "DockRenderer.vala"
	_tmp42_ = self->priv->_theme;
#line 808 "DockRenderer.vala"
	_tmp43_ = plank_dock_theme_get_ActiveTime (_tmp42_);
#line 808 "DockRenderer.vala"
	_tmp44_ = _tmp43_;
#line 808 "DockRenderer.vala"
	opacity = MIN ((gdouble) 1, active_time / ((gdouble) (_tmp44_ * 1000)));
#line 809 "DockRenderer.vala"
	_tmp45_ = plank_dock_item_get_State (item);
#line 809 "DockRenderer.vala"
	_tmp46_ = _tmp45_;
#line 809 "DockRenderer.vala"
	if ((_tmp46_ & PLANK_ITEM_STATE_ACTIVE) == 0) {
#line 810 "DockRenderer.vala"
		opacity = 1 - opacity;
#line 3837 "DockRenderer.c"
	}
#line 811 "DockRenderer.vala"
	if (opacity > ((gdouble) 0)) {
#line 3841 "DockRenderer.c"
		PlankDockTheme* _tmp47_;
		PlankSurface* _tmp48_;
		GdkRectangle _tmp49_;
		GdkRectangle _tmp50_;
		PlankColor _tmp51_ = {0};
		PlankColor _tmp52_;
#line 812 "DockRenderer.vala"
		_tmp47_ = self->priv->_theme;
#line 812 "DockRenderer.vala"
		_tmp48_ = self->priv->item_buffer;
#line 812 "DockRenderer.vala"
		_tmp49_ = self->priv->background_rect;
#line 812 "DockRenderer.vala"
		_tmp50_ = draw_value->background_region;
#line 812 "DockRenderer.vala"
		plank_dock_item_get_AverageIconColor (item, &_tmp51_);
#line 812 "DockRenderer.vala"
		_tmp52_ = _tmp51_;
#line 812 "DockRenderer.vala"
		plank_dock_theme_draw_active_glow (_tmp47_, _tmp48_, &_tmp49_, &_tmp50_, &_tmp52_, opacity, position);
#line 3862 "DockRenderer.c"
	}
#line 816 "DockRenderer.vala"
	if (self->priv->window_scale_factor > 1) {
#line 817 "DockRenderer.vala"
		cairo_save (cr);
#line 818 "DockRenderer.vala"
		cairo_scale (cr, 1.0 / self->priv->window_scale_factor, 1.0 / self->priv->window_scale_factor);
#line 3870 "DockRenderer.c"
	}
#line 820 "DockRenderer.vala"
	_tmp53_ = draw_value->draw_region;
#line 820 "DockRenderer.vala"
	draw_region = _tmp53_;
#line 821 "DockRenderer.vala"
	_tmp54_ = icon_surface;
#line 821 "DockRenderer.vala"
	_tmp55_ = plank_surface_get_Internal (_tmp54_);
#line 821 "DockRenderer.vala"
	_tmp56_ = _tmp55_;
#line 821 "DockRenderer.vala"
	_tmp57_ = draw_region;
#line 821 "DockRenderer.vala"
	_tmp58_ = draw_region;
#line 821 "DockRenderer.vala"
	cairo_set_source_surface (cr, _tmp56_, (gdouble) (_tmp57_.x * self->priv->window_scale_factor), (gdouble) (_tmp58_.y * self->priv->window_scale_factor));
#line 822 "DockRenderer.vala"
	if (draw_value->opacity < 1.0) {
#line 823 "DockRenderer.vala"
		cairo_paint_with_alpha (cr, draw_value->opacity);
#line 3892 "DockRenderer.c"
	} else {
#line 825 "DockRenderer.vala"
		cairo_paint (cr);
#line 3896 "DockRenderer.c"
	}
#line 826 "DockRenderer.vala"
	if (self->priv->window_scale_factor > 1) {
#line 827 "DockRenderer.vala"
		cairo_restore (cr);
#line 3902 "DockRenderer.c"
	}
#line 830 "DockRenderer.vala"
	if (draw_value->show_indicator) {
#line 3906 "DockRenderer.c"
		PlankIndicatorState _tmp60_;
		PlankIndicatorState _tmp61_;
#line 830 "DockRenderer.vala"
		_tmp60_ = plank_dock_item_get_Indicator (item);
#line 830 "DockRenderer.vala"
		_tmp61_ = _tmp60_;
#line 830 "DockRenderer.vala"
		_tmp59_ = _tmp61_ != PLANK_INDICATOR_STATE_NONE;
#line 3915 "DockRenderer.c"
	} else {
#line 830 "DockRenderer.vala"
		_tmp59_ = FALSE;
#line 3919 "DockRenderer.c"
	}
#line 830 "DockRenderer.vala"
	if (_tmp59_) {
#line 3923 "DockRenderer.c"
		GdkRectangle _tmp62_;
		PlankIndicatorState _tmp63_;
		PlankIndicatorState _tmp64_;
		PlankItemState _tmp65_;
		PlankItemState _tmp66_;
#line 831 "DockRenderer.vala"
		_tmp62_ = draw_value->hover_region;
#line 831 "DockRenderer.vala"
		_tmp63_ = plank_dock_item_get_Indicator (item);
#line 831 "DockRenderer.vala"
		_tmp64_ = _tmp63_;
#line 831 "DockRenderer.vala"
		_tmp65_ = plank_dock_item_get_State (item);
#line 831 "DockRenderer.vala"
		_tmp66_ = _tmp65_;
#line 831 "DockRenderer.vala"
		plank_dock_renderer_draw_indicator_state (self, cr, &_tmp62_, _tmp64_, _tmp66_);
#line 3941 "DockRenderer.c"
	}
#line 763 "DockRenderer.vala"
	_g_object_unref0 (icon_overlay_surface);
#line 763 "DockRenderer.vala"
	_g_object_unref0 (icon_surface);
#line 3947 "DockRenderer.c"
}

static void
plank_dock_renderer_draw_item_shadow (PlankDockRenderer* self,
                                      cairo_t* cr,
                                      PlankDockItem* item,
                                      PlankDockItemDrawValue* draw_value)
{
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	gint shadow_size = 0;
	PlankPositionManager* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint icon_size = 0;
	PlankSurface* icon_shadow_surface = NULL;
	PlankSurface* _tmp8_;
#line 834 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 834 "DockRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 834 "DockRenderer.vala"
	g_return_if_fail (item != NULL);
#line 834 "DockRenderer.vala"
	g_return_if_fail (draw_value != NULL);
#line 836 "DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 836 "DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 836 "DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 836 "DockRenderer.vala"
	position_manager = _tmp2_;
#line 837 "DockRenderer.vala"
	_tmp3_ = position_manager;
#line 837 "DockRenderer.vala"
	_tmp4_ = plank_position_manager_get_IconShadowSize (_tmp3_);
#line 837 "DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 837 "DockRenderer.vala"
	shadow_size = _tmp5_;
#line 839 "DockRenderer.vala"
	icon_size = ((gint) (draw_value->icon_size + (2 * shadow_size))) * self->priv->window_scale_factor;
#line 842 "DockRenderer.vala"
	icon_shadow_surface = NULL;
#line 843 "DockRenderer.vala"
	if (shadow_size > 0) {
#line 3997 "DockRenderer.c"
		PlankSurface* _tmp6_;
		PlankSurface* _tmp7_;
#line 844 "DockRenderer.vala"
		_tmp6_ = self->priv->item_buffer;
#line 844 "DockRenderer.vala"
		_tmp7_ = plank_dock_item_get_background_surface (item, icon_size, icon_size, _tmp6_, (PlankDrawDataFunc) plank_dock_renderer_draw_item_background, self);
#line 844 "DockRenderer.vala"
		_g_object_unref0 (icon_shadow_surface);
#line 844 "DockRenderer.vala"
		icon_shadow_surface = _tmp7_;
#line 4008 "DockRenderer.c"
	}
#line 846 "DockRenderer.vala"
	_tmp8_ = icon_shadow_surface;
#line 846 "DockRenderer.vala"
	if (_tmp8_ != NULL) {
#line 4014 "DockRenderer.c"
		GdkRectangle draw_region = {0};
		GdkRectangle _tmp9_;
		PlankSurface* _tmp10_;
		cairo_surface_t* _tmp11_;
		cairo_surface_t* _tmp12_;
		GdkRectangle _tmp13_;
		GdkRectangle _tmp14_;
#line 847 "DockRenderer.vala"
		if (self->priv->window_scale_factor > 1) {
#line 848 "DockRenderer.vala"
			cairo_save (cr);
#line 849 "DockRenderer.vala"
			cairo_scale (cr, 1.0 / self->priv->window_scale_factor, 1.0 / self->priv->window_scale_factor);
#line 4028 "DockRenderer.c"
		}
#line 851 "DockRenderer.vala"
		_tmp9_ = draw_value->draw_region;
#line 851 "DockRenderer.vala"
		draw_region = _tmp9_;
#line 852 "DockRenderer.vala"
		cairo_set_operator (cr, CAIRO_OPERATOR_OVER);
#line 853 "DockRenderer.vala"
		_tmp10_ = icon_shadow_surface;
#line 853 "DockRenderer.vala"
		_tmp11_ = plank_surface_get_Internal (_tmp10_);
#line 853 "DockRenderer.vala"
		_tmp12_ = _tmp11_;
#line 853 "DockRenderer.vala"
		_tmp13_ = draw_region;
#line 853 "DockRenderer.vala"
		_tmp14_ = draw_region;
#line 853 "DockRenderer.vala"
		cairo_set_source_surface (cr, _tmp12_, (gdouble) ((_tmp13_.x - shadow_size) * self->priv->window_scale_factor), (gdouble) ((_tmp14_.y - shadow_size) * self->priv->window_scale_factor));
#line 854 "DockRenderer.vala"
		if (draw_value->opacity < 1.0) {
#line 855 "DockRenderer.vala"
			cairo_paint_with_alpha (cr, draw_value->opacity);
#line 4052 "DockRenderer.c"
		} else {
#line 857 "DockRenderer.vala"
			cairo_paint (cr);
#line 4056 "DockRenderer.c"
		}
#line 858 "DockRenderer.vala"
		if (self->priv->window_scale_factor > 1) {
#line 859 "DockRenderer.vala"
			cairo_restore (cr);
#line 4062 "DockRenderer.c"
		}
	}
#line 834 "DockRenderer.vala"
	_g_object_unref0 (icon_shadow_surface);
#line 4067 "DockRenderer.c"
}

static PlankSurface*
plank_dock_renderer_draw_item_foreground (gint width,
                                          gint height,
                                          PlankSurface* model,
                                          PlankDockItem* item,
                                          PlankDockRenderer* self)
{
	PlankSurface* surface = NULL;
	PlankSurface* _tmp0_;
	gint icon_size = 0;
	PlankColor urgent_color = {0};
	PlankDockTheme* _tmp1_;
	PlankColor _tmp2_ = {0};
	PlankColor _tmp3_;
	GdkRGBA _tmp4_ = {0};
	gboolean _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	PlankSurface* result;
#line 864 "DockRenderer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 864 "DockRenderer.vala"
	g_return_val_if_fail (model != NULL, NULL);
#line 864 "DockRenderer.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 866 "DockRenderer.vala"
	plank_logger_verbose ("DockItem.draw_item_overlay (width = %i, height = %i)", width, height, NULL);
#line 867 "DockRenderer.vala"
	_tmp0_ = plank_surface_new_with_surface (width, height, model);
#line 867 "DockRenderer.vala"
	surface = _tmp0_;
#line 869 "DockRenderer.vala"
	icon_size = MIN (width, height);
#line 870 "DockRenderer.vala"
	_tmp1_ = self->priv->_theme;
#line 870 "DockRenderer.vala"
	plank_dock_theme_get_BadgeColor (_tmp1_, &_tmp2_);
#line 870 "DockRenderer.vala"
	_tmp3_ = _tmp2_;
#line 870 "DockRenderer.vala"
	urgent_color = _tmp3_;
#line 871 "DockRenderer.vala"
	_tmp4_.red = 0.0;
#line 871 "DockRenderer.vala"
	_tmp4_.green = 0.0;
#line 871 "DockRenderer.vala"
	_tmp4_.blue = 0.0;
#line 871 "DockRenderer.vala"
	_tmp4_.alpha = 0.0;
#line 871 "DockRenderer.vala"
	if (gdk_rgba_equal (&urgent_color, &_tmp4_)) {
#line 4122 "DockRenderer.c"
		PlankColor _tmp5_ = {0};
		PlankDockTheme* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 872 "DockRenderer.vala"
		plank_dock_renderer_get_styled_color (self, &_tmp5_);
#line 872 "DockRenderer.vala"
		urgent_color = _tmp5_;
#line 873 "DockRenderer.vala"
		_tmp6_ = self->priv->_theme;
#line 873 "DockRenderer.vala"
		_tmp7_ = plank_dock_theme_get_UrgentHueShift (_tmp6_);
#line 873 "DockRenderer.vala"
		_tmp8_ = _tmp7_;
#line 873 "DockRenderer.vala"
		plank_color_add_hue (&urgent_color, (gdouble) _tmp8_);
#line 4139 "DockRenderer.c"
	}
#line 877 "DockRenderer.vala"
	_tmp9_ = plank_dock_item_get_CountVisible (item);
#line 877 "DockRenderer.vala"
	_tmp10_ = _tmp9_;
#line 877 "DockRenderer.vala"
	if (_tmp10_) {
#line 4147 "DockRenderer.c"
		PlankDockTheme* _tmp11_;
		PlankSurface* _tmp12_;
		PlankColor _tmp13_;
		gint64 _tmp14_;
		gint64 _tmp15_;
#line 878 "DockRenderer.vala"
		_tmp11_ = self->priv->_theme;
#line 878 "DockRenderer.vala"
		_tmp12_ = surface;
#line 878 "DockRenderer.vala"
		_tmp13_ = urgent_color;
#line 878 "DockRenderer.vala"
		_tmp14_ = plank_dock_item_get_Count (item);
#line 878 "DockRenderer.vala"
		_tmp15_ = _tmp14_;
#line 878 "DockRenderer.vala"
		plank_dock_theme_draw_item_count (_tmp11_, _tmp12_, icon_size, &_tmp13_, _tmp15_);
#line 4165 "DockRenderer.c"
	}
#line 881 "DockRenderer.vala"
	_tmp16_ = plank_dock_item_get_ProgressVisible (item);
#line 881 "DockRenderer.vala"
	_tmp17_ = _tmp16_;
#line 881 "DockRenderer.vala"
	if (_tmp17_) {
#line 4173 "DockRenderer.c"
		PlankDockTheme* _tmp18_;
		PlankSurface* _tmp19_;
		PlankColor _tmp20_;
		gdouble _tmp21_;
		gdouble _tmp22_;
#line 882 "DockRenderer.vala"
		_tmp18_ = self->priv->_theme;
#line 882 "DockRenderer.vala"
		_tmp19_ = surface;
#line 882 "DockRenderer.vala"
		_tmp20_ = urgent_color;
#line 882 "DockRenderer.vala"
		_tmp21_ = plank_dock_item_get_Progress (item);
#line 882 "DockRenderer.vala"
		_tmp22_ = _tmp21_;
#line 882 "DockRenderer.vala"
		plank_dock_theme_draw_item_progress (_tmp18_, _tmp19_, icon_size, &_tmp20_, _tmp22_);
#line 4191 "DockRenderer.c"
	}
#line 884 "DockRenderer.vala"
	result = surface;
#line 884 "DockRenderer.vala"
	return result;
#line 4197 "DockRenderer.c"
}

static PlankSurface*
plank_dock_renderer_draw_item_background (gint width,
                                          gint height,
                                          PlankSurface* model,
                                          PlankDockItem* item,
                                          PlankDockRenderer* self)
{
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	gint shadow_size = 0;
	PlankPositionManager* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	PlankDockItemDrawValue* draw_value = NULL;
	PlankPositionManager* _tmp6_;
	PlankDockItemDrawValue* _tmp7_;
	gint icon_size = 0;
	PlankDockItemDrawValue* _tmp8_;
	PlankSurface* icon_surface = NULL;
	PlankSurface* _tmp9_;
	PlankSurface* surface = NULL;
	PlankSurface* _tmp10_;
	cairo_t* cr = NULL;
	PlankSurface* _tmp11_;
	cairo_t* _tmp12_;
	cairo_t* _tmp13_;
	PlankSurface* shadow_surface = NULL;
	PlankSurface* _tmp14_;
	PlankSurface* _tmp15_;
	gint xoffset = 0;
	gint yoffset = 0;
	PlankPositionManager* _tmp16_;
	GtkPositionType _tmp17_;
	GtkPositionType _tmp18_;
	cairo_t* _tmp19_;
	PlankSurface* _tmp20_;
	cairo_surface_t* _tmp21_;
	cairo_surface_t* _tmp22_;
	cairo_t* _tmp23_;
	PlankSurface* _tmp24_;
	PlankSurface* result;
#line 888 "DockRenderer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 888 "DockRenderer.vala"
	g_return_val_if_fail (model != NULL, NULL);
#line 888 "DockRenderer.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 890 "DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 890 "DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 890 "DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 890 "DockRenderer.vala"
	position_manager = _tmp2_;
#line 891 "DockRenderer.vala"
	_tmp3_ = position_manager;
#line 891 "DockRenderer.vala"
	_tmp4_ = plank_position_manager_get_IconShadowSize (_tmp3_);
#line 891 "DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 891 "DockRenderer.vala"
	shadow_size = _tmp5_ * self->priv->window_scale_factor;
#line 893 "DockRenderer.vala"
	_tmp6_ = position_manager;
#line 893 "DockRenderer.vala"
	_tmp7_ = plank_position_manager_get_draw_value_for_item (_tmp6_, item);
#line 893 "DockRenderer.vala"
	draw_value = _tmp7_;
#line 894 "DockRenderer.vala"
	_tmp8_ = draw_value;
#line 894 "DockRenderer.vala"
	icon_size = ((gint) _tmp8_->icon_size) * self->priv->window_scale_factor;
#line 895 "DockRenderer.vala"
	_tmp9_ = plank_dock_item_get_surface (item, icon_size, icon_size, model);
#line 895 "DockRenderer.vala"
	icon_surface = _tmp9_;
#line 897 "DockRenderer.vala"
	plank_logger_verbose ("DockItem.draw_icon_with_shadow (width = %i, height = %i, shadow_size =" \
" %i)", width, height, shadow_size, NULL);
#line 898 "DockRenderer.vala"
	_tmp10_ = plank_surface_new_with_surface (width, height, model);
#line 898 "DockRenderer.vala"
	surface = _tmp10_;
#line 899 "DockRenderer.vala"
	_tmp11_ = surface;
#line 899 "DockRenderer.vala"
	_tmp12_ = plank_surface_get_Context (_tmp11_);
#line 899 "DockRenderer.vala"
	_tmp13_ = _tmp12_;
#line 899 "DockRenderer.vala"
	cr = _tmp13_;
#line 900 "DockRenderer.vala"
	_tmp14_ = icon_surface;
#line 900 "DockRenderer.vala"
	_tmp15_ = plank_surface_create_mask (_tmp14_, 0.4, NULL);
#line 900 "DockRenderer.vala"
	shadow_surface = _tmp15_;
#line 902 "DockRenderer.vala"
	xoffset = 0;
#line 902 "DockRenderer.vala"
	yoffset = 0;
#line 903 "DockRenderer.vala"
	_tmp16_ = position_manager;
#line 903 "DockRenderer.vala"
	_tmp17_ = plank_position_manager_get_Position (_tmp16_);
#line 903 "DockRenderer.vala"
	_tmp18_ = _tmp17_;
#line 903 "DockRenderer.vala"
	switch (_tmp18_) {
#line 4311 "DockRenderer.c"
		default:
#line 903 "DockRenderer.vala"
		case GTK_POS_BOTTOM:
#line 4315 "DockRenderer.c"
		{
#line 906 "DockRenderer.vala"
			yoffset = (-shadow_size) / 4;
#line 907 "DockRenderer.vala"
			break;
#line 4321 "DockRenderer.c"
		}
#line 903 "DockRenderer.vala"
		case GTK_POS_TOP:
#line 4325 "DockRenderer.c"
		{
#line 909 "DockRenderer.vala"
			yoffset = shadow_size / 4;
#line 910 "DockRenderer.vala"
			break;
#line 4331 "DockRenderer.c"
		}
#line 903 "DockRenderer.vala"
		case GTK_POS_LEFT:
#line 4335 "DockRenderer.c"
		{
#line 912 "DockRenderer.vala"
			xoffset = shadow_size / 4;
#line 913 "DockRenderer.vala"
			break;
#line 4341 "DockRenderer.c"
		}
#line 903 "DockRenderer.vala"
		case GTK_POS_RIGHT:
#line 4345 "DockRenderer.c"
		{
#line 915 "DockRenderer.vala"
			xoffset = (-shadow_size) / 4;
#line 916 "DockRenderer.vala"
			break;
#line 4351 "DockRenderer.c"
		}
	}
#line 919 "DockRenderer.vala"
	_tmp19_ = cr;
#line 919 "DockRenderer.vala"
	_tmp20_ = shadow_surface;
#line 919 "DockRenderer.vala"
	_tmp21_ = plank_surface_get_Internal (_tmp20_);
#line 919 "DockRenderer.vala"
	_tmp22_ = _tmp21_;
#line 919 "DockRenderer.vala"
	cairo_set_source_surface (_tmp19_, _tmp22_, (gdouble) (shadow_size + xoffset), (gdouble) (shadow_size + yoffset));
#line 920 "DockRenderer.vala"
	_tmp23_ = cr;
#line 920 "DockRenderer.vala"
	cairo_paint_with_alpha (_tmp23_, 0.44);
#line 921 "DockRenderer.vala"
	_tmp24_ = surface;
#line 921 "DockRenderer.vala"
	plank_surface_gaussian_blur (_tmp24_, shadow_size);
#line 923 "DockRenderer.vala"
	result = surface;
#line 923 "DockRenderer.vala"
	_g_object_unref0 (shadow_surface);
#line 923 "DockRenderer.vala"
	_g_object_unref0 (icon_surface);
#line 923 "DockRenderer.vala"
	_plank_dock_item_draw_value_unref0 (draw_value);
#line 923 "DockRenderer.vala"
	return result;
#line 4382 "DockRenderer.c"
}

static void
plank_dock_renderer_draw_indicator_state (PlankDockRenderer* self,
                                          cairo_t* cr,
                                          GdkRectangle* item_rect,
                                          PlankIndicatorState indicator,
                                          PlankItemState item_state)
{
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	PlankSurface* _tmp3_;
	PlankSurface* _tmp12_;
	PlankSurface* _tmp24_ = NULL;
	PlankSurface* indicator_surface = NULL;
	gdouble x = 0.0;
	gdouble y = 0.0;
	PlankPositionManager* _tmp27_;
	GtkPositionType _tmp28_;
	GtkPositionType _tmp29_;
#line 926 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 926 "DockRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 926 "DockRenderer.vala"
	g_return_if_fail (item_rect != NULL);
#line 928 "DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 928 "DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 928 "DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 928 "DockRenderer.vala"
	position_manager = _tmp2_;
#line 930 "DockRenderer.vala"
	_tmp3_ = self->priv->indicator_buffer;
#line 930 "DockRenderer.vala"
	if (_tmp3_ == NULL) {
#line 4423 "DockRenderer.c"
		PlankColor indicator_color = {0};
		PlankColor _tmp4_ = {0};
		PlankDockTheme* _tmp5_;
		PlankPositionManager* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		PlankColor _tmp9_;
		PlankSurface* _tmp10_;
		PlankSurface* _tmp11_;
#line 931 "DockRenderer.vala"
		plank_dock_renderer_get_styled_color (self, &_tmp4_);
#line 931 "DockRenderer.vala"
		indicator_color = _tmp4_;
#line 932 "DockRenderer.vala"
		plank_color_set_min_sat (&indicator_color, 0.4);
#line 933 "DockRenderer.vala"
		_tmp5_ = self->priv->_theme;
#line 933 "DockRenderer.vala"
		_tmp6_ = position_manager;
#line 933 "DockRenderer.vala"
		_tmp7_ = plank_position_manager_get_IndicatorSize (_tmp6_);
#line 933 "DockRenderer.vala"
		_tmp8_ = _tmp7_;
#line 933 "DockRenderer.vala"
		_tmp9_ = indicator_color;
#line 933 "DockRenderer.vala"
		_tmp10_ = self->priv->item_buffer;
#line 933 "DockRenderer.vala"
		_tmp11_ = plank_dock_theme_create_indicator (_tmp5_, _tmp8_, &_tmp9_, _tmp10_);
#line 933 "DockRenderer.vala"
		_g_object_unref0 (self->priv->indicator_buffer);
#line 933 "DockRenderer.vala"
		self->priv->indicator_buffer = _tmp11_;
#line 4457 "DockRenderer.c"
	}
#line 935 "DockRenderer.vala"
	_tmp12_ = self->priv->urgent_indicator_buffer;
#line 935 "DockRenderer.vala"
	if (_tmp12_ == NULL) {
#line 4463 "DockRenderer.c"
		PlankColor urgent_indicator_color = {0};
		PlankColor _tmp13_ = {0};
		PlankDockTheme* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		PlankDockTheme* _tmp17_;
		PlankPositionManager* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		PlankColor _tmp21_;
		PlankSurface* _tmp22_;
		PlankSurface* _tmp23_;
#line 936 "DockRenderer.vala"
		plank_dock_renderer_get_styled_color (self, &_tmp13_);
#line 936 "DockRenderer.vala"
		urgent_indicator_color = _tmp13_;
#line 937 "DockRenderer.vala"
		_tmp14_ = self->priv->_theme;
#line 937 "DockRenderer.vala"
		_tmp15_ = plank_dock_theme_get_UrgentHueShift (_tmp14_);
#line 937 "DockRenderer.vala"
		_tmp16_ = _tmp15_;
#line 937 "DockRenderer.vala"
		plank_color_add_hue (&urgent_indicator_color, (gdouble) _tmp16_);
#line 938 "DockRenderer.vala"
		plank_color_set_sat (&urgent_indicator_color, 1.0);
#line 939 "DockRenderer.vala"
		_tmp17_ = self->priv->_theme;
#line 939 "DockRenderer.vala"
		_tmp18_ = position_manager;
#line 939 "DockRenderer.vala"
		_tmp19_ = plank_position_manager_get_IndicatorSize (_tmp18_);
#line 939 "DockRenderer.vala"
		_tmp20_ = _tmp19_;
#line 939 "DockRenderer.vala"
		_tmp21_ = urgent_indicator_color;
#line 939 "DockRenderer.vala"
		_tmp22_ = self->priv->item_buffer;
#line 939 "DockRenderer.vala"
		_tmp23_ = plank_dock_theme_create_indicator (_tmp17_, _tmp20_, &_tmp21_, _tmp22_);
#line 939 "DockRenderer.vala"
		_g_object_unref0 (self->priv->urgent_indicator_buffer);
#line 939 "DockRenderer.vala"
		self->priv->urgent_indicator_buffer = _tmp23_;
#line 4508 "DockRenderer.c"
	}
#line 942 "DockRenderer.vala"
	if ((item_state & PLANK_ITEM_STATE_URGENT) != 0) {
#line 4512 "DockRenderer.c"
		PlankSurface* _tmp25_;
#line 942 "DockRenderer.vala"
		_tmp25_ = self->priv->urgent_indicator_buffer;
#line 942 "DockRenderer.vala"
		_tmp24_ = _tmp25_;
#line 4518 "DockRenderer.c"
	} else {
		PlankSurface* _tmp26_;
#line 942 "DockRenderer.vala"
		_tmp26_ = self->priv->indicator_buffer;
#line 942 "DockRenderer.vala"
		_tmp24_ = _tmp26_;
#line 4525 "DockRenderer.c"
	}
#line 942 "DockRenderer.vala"
	indicator_surface = _tmp24_;
#line 944 "DockRenderer.vala"
	x = 0.0;
#line 944 "DockRenderer.vala"
	y = 0.0;
#line 945 "DockRenderer.vala"
	_tmp27_ = position_manager;
#line 945 "DockRenderer.vala"
	_tmp28_ = plank_position_manager_get_Position (_tmp27_);
#line 945 "DockRenderer.vala"
	_tmp29_ = _tmp28_;
#line 945 "DockRenderer.vala"
	switch (_tmp29_) {
#line 4541 "DockRenderer.c"
		default:
#line 945 "DockRenderer.vala"
		case GTK_POS_BOTTOM:
#line 4545 "DockRenderer.c"
		{
			GdkRectangle _tmp30_;
			GdkRectangle _tmp31_;
			PlankSurface* _tmp32_;
			gint _tmp33_;
			gint _tmp34_;
			PlankSurface* _tmp35_;
			gint _tmp36_;
			gint _tmp37_;
			PlankSurface* _tmp38_;
			gint _tmp39_;
			gint _tmp40_;
			PlankDockTheme* _tmp41_;
			PlankSurface* _tmp42_;
			gint _tmp43_;
			gint _tmp44_;
#line 948 "DockRenderer.vala"
			_tmp30_ = *item_rect;
#line 948 "DockRenderer.vala"
			_tmp31_ = *item_rect;
#line 948 "DockRenderer.vala"
			_tmp32_ = indicator_surface;
#line 948 "DockRenderer.vala"
			_tmp33_ = plank_surface_get_Width (_tmp32_);
#line 948 "DockRenderer.vala"
			_tmp34_ = _tmp33_;
#line 948 "DockRenderer.vala"
			x = (_tmp30_.x + (_tmp31_.width / 2.0)) - (_tmp34_ / 2.0);
#line 949 "DockRenderer.vala"
			_tmp35_ = self->priv->item_buffer;
#line 949 "DockRenderer.vala"
			_tmp36_ = plank_surface_get_Height (_tmp35_);
#line 949 "DockRenderer.vala"
			_tmp37_ = _tmp36_;
#line 949 "DockRenderer.vala"
			_tmp38_ = indicator_surface;
#line 949 "DockRenderer.vala"
			_tmp39_ = plank_surface_get_Height (_tmp38_);
#line 949 "DockRenderer.vala"
			_tmp40_ = _tmp39_;
#line 949 "DockRenderer.vala"
			_tmp41_ = self->priv->_theme;
#line 949 "DockRenderer.vala"
			_tmp42_ = indicator_surface;
#line 949 "DockRenderer.vala"
			_tmp43_ = plank_surface_get_Height (_tmp42_);
#line 949 "DockRenderer.vala"
			_tmp44_ = _tmp43_;
#line 949 "DockRenderer.vala"
			y = ((_tmp37_ - (_tmp40_ / 2.0)) - (2.0 * plank_theme_get_bottom_offset ((PlankTheme*) _tmp41_))) - (_tmp44_ / 24.0);
#line 950 "DockRenderer.vala"
			break;
#line 4598 "DockRenderer.c"
		}
#line 945 "DockRenderer.vala"
		case GTK_POS_TOP:
#line 4602 "DockRenderer.c"
		{
			GdkRectangle _tmp45_;
			GdkRectangle _tmp46_;
			PlankSurface* _tmp47_;
			gint _tmp48_;
			gint _tmp49_;
			PlankSurface* _tmp50_;
			gint _tmp51_;
			gint _tmp52_;
			PlankDockTheme* _tmp53_;
			PlankSurface* _tmp54_;
			gint _tmp55_;
			gint _tmp56_;
#line 952 "DockRenderer.vala"
			_tmp45_ = *item_rect;
#line 952 "DockRenderer.vala"
			_tmp46_ = *item_rect;
#line 952 "DockRenderer.vala"
			_tmp47_ = indicator_surface;
#line 952 "DockRenderer.vala"
			_tmp48_ = plank_surface_get_Width (_tmp47_);
#line 952 "DockRenderer.vala"
			_tmp49_ = _tmp48_;
#line 952 "DockRenderer.vala"
			x = (_tmp45_.x + (_tmp46_.width / 2.0)) - (_tmp49_ / 2.0);
#line 953 "DockRenderer.vala"
			_tmp50_ = indicator_surface;
#line 953 "DockRenderer.vala"
			_tmp51_ = plank_surface_get_Height (_tmp50_);
#line 953 "DockRenderer.vala"
			_tmp52_ = _tmp51_;
#line 953 "DockRenderer.vala"
			_tmp53_ = self->priv->_theme;
#line 953 "DockRenderer.vala"
			_tmp54_ = indicator_surface;
#line 953 "DockRenderer.vala"
			_tmp55_ = plank_surface_get_Height (_tmp54_);
#line 953 "DockRenderer.vala"
			_tmp56_ = _tmp55_;
#line 953 "DockRenderer.vala"
			y = (((-_tmp52_) / 2.0) + (2.0 * plank_theme_get_bottom_offset ((PlankTheme*) _tmp53_))) + (_tmp56_ / 24.0);
#line 954 "DockRenderer.vala"
			break;
#line 4646 "DockRenderer.c"
		}
#line 945 "DockRenderer.vala"
		case GTK_POS_LEFT:
#line 4650 "DockRenderer.c"
		{
			PlankSurface* _tmp57_;
			gint _tmp58_;
			gint _tmp59_;
			PlankDockTheme* _tmp60_;
			PlankSurface* _tmp61_;
			gint _tmp62_;
			gint _tmp63_;
			GdkRectangle _tmp64_;
			GdkRectangle _tmp65_;
			PlankSurface* _tmp66_;
			gint _tmp67_;
			gint _tmp68_;
#line 956 "DockRenderer.vala"
			_tmp57_ = indicator_surface;
#line 956 "DockRenderer.vala"
			_tmp58_ = plank_surface_get_Width (_tmp57_);
#line 956 "DockRenderer.vala"
			_tmp59_ = _tmp58_;
#line 956 "DockRenderer.vala"
			_tmp60_ = self->priv->_theme;
#line 956 "DockRenderer.vala"
			_tmp61_ = indicator_surface;
#line 956 "DockRenderer.vala"
			_tmp62_ = plank_surface_get_Width (_tmp61_);
#line 956 "DockRenderer.vala"
			_tmp63_ = _tmp62_;
#line 956 "DockRenderer.vala"
			x = (((-_tmp59_) / 2.0) + (2.0 * plank_theme_get_bottom_offset ((PlankTheme*) _tmp60_))) + (_tmp63_ / 24.0);
#line 957 "DockRenderer.vala"
			_tmp64_ = *item_rect;
#line 957 "DockRenderer.vala"
			_tmp65_ = *item_rect;
#line 957 "DockRenderer.vala"
			_tmp66_ = indicator_surface;
#line 957 "DockRenderer.vala"
			_tmp67_ = plank_surface_get_Height (_tmp66_);
#line 957 "DockRenderer.vala"
			_tmp68_ = _tmp67_;
#line 957 "DockRenderer.vala"
			y = (_tmp64_.y + (_tmp65_.height / 2.0)) - (_tmp68_ / 2.0);
#line 958 "DockRenderer.vala"
			break;
#line 4694 "DockRenderer.c"
		}
#line 945 "DockRenderer.vala"
		case GTK_POS_RIGHT:
#line 4698 "DockRenderer.c"
		{
			PlankSurface* _tmp69_;
			gint _tmp70_;
			gint _tmp71_;
			PlankSurface* _tmp72_;
			gint _tmp73_;
			gint _tmp74_;
			PlankDockTheme* _tmp75_;
			PlankSurface* _tmp76_;
			gint _tmp77_;
			gint _tmp78_;
			GdkRectangle _tmp79_;
			GdkRectangle _tmp80_;
			PlankSurface* _tmp81_;
			gint _tmp82_;
			gint _tmp83_;
#line 960 "DockRenderer.vala"
			_tmp69_ = self->priv->item_buffer;
#line 960 "DockRenderer.vala"
			_tmp70_ = plank_surface_get_Width (_tmp69_);
#line 960 "DockRenderer.vala"
			_tmp71_ = _tmp70_;
#line 960 "DockRenderer.vala"
			_tmp72_ = indicator_surface;
#line 960 "DockRenderer.vala"
			_tmp73_ = plank_surface_get_Width (_tmp72_);
#line 960 "DockRenderer.vala"
			_tmp74_ = _tmp73_;
#line 960 "DockRenderer.vala"
			_tmp75_ = self->priv->_theme;
#line 960 "DockRenderer.vala"
			_tmp76_ = indicator_surface;
#line 960 "DockRenderer.vala"
			_tmp77_ = plank_surface_get_Width (_tmp76_);
#line 960 "DockRenderer.vala"
			_tmp78_ = _tmp77_;
#line 960 "DockRenderer.vala"
			x = ((_tmp71_ - (_tmp74_ / 2.0)) - (2.0 * plank_theme_get_bottom_offset ((PlankTheme*) _tmp75_))) - (_tmp78_ / 24.0);
#line 961 "DockRenderer.vala"
			_tmp79_ = *item_rect;
#line 961 "DockRenderer.vala"
			_tmp80_ = *item_rect;
#line 961 "DockRenderer.vala"
			_tmp81_ = indicator_surface;
#line 961 "DockRenderer.vala"
			_tmp82_ = plank_surface_get_Height (_tmp81_);
#line 961 "DockRenderer.vala"
			_tmp83_ = _tmp82_;
#line 961 "DockRenderer.vala"
			y = (_tmp79_.y + (_tmp80_.height / 2.0)) - (_tmp83_ / 2.0);
#line 962 "DockRenderer.vala"
			break;
#line 4751 "DockRenderer.c"
		}
	}
#line 965 "DockRenderer.vala"
	if (indicator == PLANK_INDICATOR_STATE_SINGLE) {
#line 4756 "DockRenderer.c"
		PlankSurface* _tmp84_;
		cairo_surface_t* _tmp85_;
		cairo_surface_t* _tmp86_;
#line 966 "DockRenderer.vala"
		_tmp84_ = indicator_surface;
#line 966 "DockRenderer.vala"
		_tmp85_ = plank_surface_get_Internal (_tmp84_);
#line 966 "DockRenderer.vala"
		_tmp86_ = _tmp85_;
#line 966 "DockRenderer.vala"
		cairo_set_source_surface (cr, _tmp86_, x, y);
#line 967 "DockRenderer.vala"
		cairo_paint (cr);
#line 4770 "DockRenderer.c"
	} else {
		gdouble x_offset = 0.0;
		gdouble y_offset = 0.0;
		PlankPositionManager* _tmp87_;
		PlankSurface* _tmp94_;
		cairo_surface_t* _tmp95_;
		cairo_surface_t* _tmp96_;
		PlankSurface* _tmp97_;
		cairo_surface_t* _tmp98_;
		cairo_surface_t* _tmp99_;
#line 969 "DockRenderer.vala"
		x_offset = 0.0;
#line 969 "DockRenderer.vala"
		y_offset = 0.0;
#line 970 "DockRenderer.vala"
		_tmp87_ = position_manager;
#line 970 "DockRenderer.vala"
		if (plank_position_manager_is_horizontal_dock (_tmp87_)) {
#line 4789 "DockRenderer.c"
			PlankPositionManager* _tmp88_;
			gint _tmp89_;
			gint _tmp90_;
#line 971 "DockRenderer.vala"
			_tmp88_ = position_manager;
#line 971 "DockRenderer.vala"
			_tmp89_ = plank_position_manager_get_IconSize (_tmp88_);
#line 971 "DockRenderer.vala"
			_tmp90_ = _tmp89_;
#line 971 "DockRenderer.vala"
			x_offset = _tmp90_ / 16.0;
#line 4801 "DockRenderer.c"
		} else {
			PlankPositionManager* _tmp91_;
			gint _tmp92_;
			gint _tmp93_;
#line 973 "DockRenderer.vala"
			_tmp91_ = position_manager;
#line 973 "DockRenderer.vala"
			_tmp92_ = plank_position_manager_get_IconSize (_tmp91_);
#line 973 "DockRenderer.vala"
			_tmp93_ = _tmp92_;
#line 973 "DockRenderer.vala"
			y_offset = _tmp93_ / 16.0;
#line 4814 "DockRenderer.c"
		}
#line 975 "DockRenderer.vala"
		_tmp94_ = indicator_surface;
#line 975 "DockRenderer.vala"
		_tmp95_ = plank_surface_get_Internal (_tmp94_);
#line 975 "DockRenderer.vala"
		_tmp96_ = _tmp95_;
#line 975 "DockRenderer.vala"
		cairo_set_source_surface (cr, _tmp96_, x - x_offset, y - y_offset);
#line 976 "DockRenderer.vala"
		cairo_paint (cr);
#line 977 "DockRenderer.vala"
		_tmp97_ = indicator_surface;
#line 977 "DockRenderer.vala"
		_tmp98_ = plank_surface_get_Internal (_tmp97_);
#line 977 "DockRenderer.vala"
		_tmp99_ = _tmp98_;
#line 977 "DockRenderer.vala"
		cairo_set_source_surface (cr, _tmp99_, x + x_offset, y + y_offset);
#line 978 "DockRenderer.vala"
		cairo_paint (cr);
#line 4836 "DockRenderer.c"
	}
}

static void
plank_dock_renderer_draw_urgent_glow (PlankDockRenderer* self,
                                      PlankDockItem* item,
                                      cairo_t* cr,
                                      gint64 frame_time)
{
	PlankItemState _tmp0_;
	PlankItemState _tmp1_;
	gint64 diff = 0LL;
	gint64 _tmp2_;
	gint64 _tmp3_;
	PlankDockTheme* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp7_;
	PlankPositionManager* _tmp8_;
	PlankPositionManager* _tmp9_;
	gint x_offset = 0;
	gint y_offset = 0;
	PlankSurface* _tmp10_;
	PlankPositionManager* _tmp22_;
	gint _tmp23_ = 0;
	gint _tmp24_ = 0;
	PlankSurface* _tmp25_;
	cairo_surface_t* _tmp26_;
	cairo_surface_t* _tmp27_;
	gdouble opacity = 0.0;
	PlankDockTheme* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
#line 982 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 982 "DockRenderer.vala"
	g_return_if_fail (item != NULL);
#line 982 "DockRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 984 "DockRenderer.vala"
	_tmp0_ = plank_dock_item_get_State (item);
#line 984 "DockRenderer.vala"
	_tmp1_ = _tmp0_;
#line 984 "DockRenderer.vala"
	if ((_tmp1_ & PLANK_ITEM_STATE_URGENT) == 0) {
#line 985 "DockRenderer.vala"
		return;
#line 4885 "DockRenderer.c"
	}
#line 987 "DockRenderer.vala"
	_tmp2_ = plank_dock_element_get_LastUrgent ((PlankDockElement*) item);
#line 987 "DockRenderer.vala"
	_tmp3_ = _tmp2_;
#line 987 "DockRenderer.vala"
	diff = MAX (0LL, frame_time - _tmp3_);
#line 988 "DockRenderer.vala"
	_tmp4_ = self->priv->_theme;
#line 988 "DockRenderer.vala"
	_tmp5_ = plank_dock_theme_get_GlowTime (_tmp4_);
#line 988 "DockRenderer.vala"
	_tmp6_ = _tmp5_;
#line 988 "DockRenderer.vala"
	if (diff >= ((gint64) (_tmp6_ * 1000))) {
#line 989 "DockRenderer.vala"
		return;
#line 4903 "DockRenderer.c"
	}
#line 991 "DockRenderer.vala"
	_tmp7_ = self->priv->_controller;
#line 991 "DockRenderer.vala"
	_tmp8_ = plank_dock_controller_get_position_manager (_tmp7_);
#line 991 "DockRenderer.vala"
	_tmp9_ = _tmp8_;
#line 991 "DockRenderer.vala"
	position_manager = _tmp9_;
#line 992 "DockRenderer.vala"
	x_offset = 0;
#line 992 "DockRenderer.vala"
	y_offset = 0;
#line 994 "DockRenderer.vala"
	_tmp10_ = self->priv->urgent_glow_buffer;
#line 994 "DockRenderer.vala"
	if (_tmp10_ == NULL) {
#line 4921 "DockRenderer.c"
		PlankColor urgent_color = {0};
		PlankColor _tmp11_ = {0};
		PlankDockTheme* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		PlankDockTheme* _tmp15_;
		PlankPositionManager* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		PlankColor _tmp19_;
		PlankSurface* _tmp20_;
		PlankSurface* _tmp21_;
#line 995 "DockRenderer.vala"
		plank_dock_renderer_get_styled_color (self, &_tmp11_);
#line 995 "DockRenderer.vala"
		urgent_color = _tmp11_;
#line 996 "DockRenderer.vala"
		_tmp12_ = self->priv->_theme;
#line 996 "DockRenderer.vala"
		_tmp13_ = plank_dock_theme_get_UrgentHueShift (_tmp12_);
#line 996 "DockRenderer.vala"
		_tmp14_ = _tmp13_;
#line 996 "DockRenderer.vala"
		plank_color_add_hue (&urgent_color, (gdouble) _tmp14_);
#line 997 "DockRenderer.vala"
		plank_color_set_sat (&urgent_color, 1.0);
#line 998 "DockRenderer.vala"
		_tmp15_ = self->priv->_theme;
#line 998 "DockRenderer.vala"
		_tmp16_ = position_manager;
#line 998 "DockRenderer.vala"
		_tmp17_ = plank_position_manager_get_GlowSize (_tmp16_);
#line 998 "DockRenderer.vala"
		_tmp18_ = _tmp17_;
#line 998 "DockRenderer.vala"
		_tmp19_ = urgent_color;
#line 998 "DockRenderer.vala"
		_tmp20_ = self->priv->main_buffer;
#line 998 "DockRenderer.vala"
		_tmp21_ = plank_dock_theme_create_urgent_glow (_tmp15_, _tmp18_, &_tmp19_, _tmp20_);
#line 998 "DockRenderer.vala"
		_g_object_unref0 (self->priv->urgent_glow_buffer);
#line 998 "DockRenderer.vala"
		self->priv->urgent_glow_buffer = _tmp21_;
#line 4966 "DockRenderer.c"
	}
#line 1001 "DockRenderer.vala"
	_tmp22_ = position_manager;
#line 1001 "DockRenderer.vala"
	plank_position_manager_get_urgent_glow_position (_tmp22_, item, &_tmp23_, &_tmp24_);
#line 1001 "DockRenderer.vala"
	x_offset = _tmp23_;
#line 1001 "DockRenderer.vala"
	y_offset = _tmp24_;
#line 1003 "DockRenderer.vala"
	_tmp25_ = self->priv->urgent_glow_buffer;
#line 1003 "DockRenderer.vala"
	_tmp26_ = plank_surface_get_Internal (_tmp25_);
#line 1003 "DockRenderer.vala"
	_tmp27_ = _tmp26_;
#line 1003 "DockRenderer.vala"
	cairo_set_source_surface (cr, _tmp27_, (gdouble) x_offset, (gdouble) y_offset);
#line 1004 "DockRenderer.vala"
	_tmp28_ = self->priv->_theme;
#line 1004 "DockRenderer.vala"
	_tmp29_ = plank_dock_theme_get_GlowPulseTime (_tmp28_);
#line 1004 "DockRenderer.vala"
	_tmp30_ = _tmp29_;
#line 1004 "DockRenderer.vala"
	opacity = 0.2 + ((0.75 * (sin (((diff / ((gdouble) (_tmp30_ * 1000))) * 2) * G_PI) + 1)) / 2);
#line 1005 "DockRenderer.vala"
	cairo_paint_with_alpha (cr, opacity);
#line 4994 "DockRenderer.c"
}

static void
plank_dock_renderer_get_styled_color (PlankDockRenderer* self,
                                      PlankColor* result)
{
	GtkStyleContext* context = NULL;
	PlankDockTheme* _tmp0_;
	GtkStyleContext* _tmp1_;
	PlankColor color = {0};
	GdkRGBA _tmp2_ = {0};
#line 1008 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 1010 "DockRenderer.vala"
	_tmp0_ = self->priv->_theme;
#line 1010 "DockRenderer.vala"
	_tmp1_ = plank_theme_get_style_context ((PlankTheme*) _tmp0_);
#line 1010 "DockRenderer.vala"
	context = _tmp1_;
#line 1011 "DockRenderer.vala"
	gtk_style_context_get_background_color (context, gtk_style_context_get_state (context), &_tmp2_);
#line 1011 "DockRenderer.vala"
	color = (PlankColor) _tmp2_;
#line 1012 "DockRenderer.vala"
	plank_color_set_min_val (&color, 90 / ((gdouble) G_MAXUINT16));
#line 1013 "DockRenderer.vala"
	*result = color;
#line 1013 "DockRenderer.vala"
	return;
#line 5024 "DockRenderer.c"
}

static void
plank_dock_renderer_hidden_changed (PlankDockRenderer* self)
{
	gint64 now = 0LL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gint64 diff = 0LL;
	gint _tmp2_ = 0;
	PlankDockTheme* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gint time = 0;
	PlankDockController* _tmp18_;
	PlankDockWindow* _tmp19_;
	PlankDockWindow* _tmp20_;
#line 1016 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 1018 "DockRenderer.vala"
	plank_renderer_force_frame_time_update ((PlankRenderer*) self);
#line 1019 "DockRenderer.vala"
	_tmp0_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 1019 "DockRenderer.vala"
	_tmp1_ = _tmp0_;
#line 1019 "DockRenderer.vala"
	now = _tmp1_;
#line 1020 "DockRenderer.vala"
	diff = now - self->priv->last_hide;
#line 1021 "DockRenderer.vala"
	_tmp3_ = self->priv->_theme;
#line 1021 "DockRenderer.vala"
	_tmp4_ = plank_dock_theme_get_FadeOpacity (_tmp3_);
#line 1021 "DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 1021 "DockRenderer.vala"
	if (_tmp5_ == 1.0) {
#line 5062 "DockRenderer.c"
		PlankDockTheme* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 1021 "DockRenderer.vala"
		_tmp6_ = self->priv->_theme;
#line 1021 "DockRenderer.vala"
		_tmp7_ = plank_dock_theme_get_HideTime (_tmp6_);
#line 1021 "DockRenderer.vala"
		_tmp8_ = _tmp7_;
#line 1021 "DockRenderer.vala"
		_tmp2_ = _tmp8_;
#line 5074 "DockRenderer.c"
	} else {
		PlankDockTheme* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
#line 1021 "DockRenderer.vala"
		_tmp9_ = self->priv->_theme;
#line 1021 "DockRenderer.vala"
		_tmp10_ = plank_dock_theme_get_FadeTime (_tmp9_);
#line 1021 "DockRenderer.vala"
		_tmp11_ = _tmp10_;
#line 1021 "DockRenderer.vala"
		_tmp2_ = _tmp11_;
#line 5087 "DockRenderer.c"
	}
#line 1021 "DockRenderer.vala"
	time = _tmp2_ * 1000;
#line 1023 "DockRenderer.vala"
	if (diff < ((gint64) time)) {
#line 1024 "DockRenderer.vala"
		self->priv->last_hide = now + (diff - time);
#line 5095 "DockRenderer.c"
	} else {
#line 1026 "DockRenderer.vala"
		self->priv->last_hide = now;
#line 5099 "DockRenderer.c"
	}
#line 1028 "DockRenderer.vala"
	if (!self->priv->screen_is_composited) {
#line 5103 "DockRenderer.c"
		PlankDockController* _tmp12_;
		PlankPositionManager* _tmp13_;
		PlankPositionManager* _tmp14_;
		PlankDockController* _tmp15_;
		PlankDockWindow* _tmp16_;
		PlankDockWindow* _tmp17_;
#line 1029 "DockRenderer.vala"
		_tmp12_ = self->priv->_controller;
#line 1029 "DockRenderer.vala"
		_tmp13_ = plank_dock_controller_get_position_manager (_tmp12_);
#line 1029 "DockRenderer.vala"
		_tmp14_ = _tmp13_;
#line 1029 "DockRenderer.vala"
		plank_position_manager_update_dock_position (_tmp14_);
#line 1030 "DockRenderer.vala"
		_tmp15_ = self->priv->_controller;
#line 1030 "DockRenderer.vala"
		_tmp16_ = plank_dock_controller_get_window (_tmp15_);
#line 1030 "DockRenderer.vala"
		_tmp17_ = _tmp16_;
#line 1030 "DockRenderer.vala"
		plank_dock_window_update_size_and_position (_tmp17_);
#line 1031 "DockRenderer.vala"
		return;
#line 5128 "DockRenderer.c"
	}
#line 1034 "DockRenderer.vala"
	_tmp18_ = self->priv->_controller;
#line 1034 "DockRenderer.vala"
	_tmp19_ = plank_dock_controller_get_window (_tmp18_);
#line 1034 "DockRenderer.vala"
	_tmp20_ = _tmp19_;
#line 1034 "DockRenderer.vala"
	plank_dock_window_update_icon_regions (_tmp20_);
#line 1036 "DockRenderer.vala"
	plank_renderer_animated_draw ((PlankRenderer*) self);
#line 5140 "DockRenderer.c"
}

static void
plank_dock_renderer_hovered_changed (PlankDockRenderer* self)
{
	gint64 now = 0LL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gint64 diff = 0LL;
	guint time = 0U;
#line 1039 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 1041 "DockRenderer.vala"
	plank_renderer_force_frame_time_update ((PlankRenderer*) self);
#line 1042 "DockRenderer.vala"
	_tmp0_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 1042 "DockRenderer.vala"
	_tmp1_ = _tmp0_;
#line 1042 "DockRenderer.vala"
	now = _tmp1_;
#line 1043 "DockRenderer.vala"
	diff = now - self->priv->last_hovered_changed;
#line 1044 "DockRenderer.vala"
	time = PLANK_DOCK_ZOOM_DURATION * 1000;
#line 1046 "DockRenderer.vala"
	if (diff < ((gint64) time)) {
#line 1047 "DockRenderer.vala"
		self->priv->last_hovered_changed = now + (diff - time);
#line 5169 "DockRenderer.c"
	} else {
#line 1049 "DockRenderer.vala"
		self->priv->last_hovered_changed = now;
#line 5173 "DockRenderer.c"
	}
#line 1051 "DockRenderer.vala"
	plank_renderer_animated_draw ((PlankRenderer*) self);
#line 5177 "DockRenderer.c"
}

static gboolean
_gdk_point_equal (const GdkPoint * s1,
                  const GdkPoint * s2)
{
#line 1057 "DockRenderer.vala"
	if (s1 == s2) {
#line 1057 "DockRenderer.vala"
		return TRUE;
#line 5188 "DockRenderer.c"
	}
#line 1057 "DockRenderer.vala"
	if (s1 == NULL) {
#line 1057 "DockRenderer.vala"
		return FALSE;
#line 5194 "DockRenderer.c"
	}
#line 1057 "DockRenderer.vala"
	if (s2 == NULL) {
#line 1057 "DockRenderer.vala"
		return FALSE;
#line 5200 "DockRenderer.c"
	}
#line 1057 "DockRenderer.vala"
	if (s1->x != s2->x) {
#line 1057 "DockRenderer.vala"
		return FALSE;
#line 5206 "DockRenderer.c"
	}
#line 1057 "DockRenderer.vala"
	if (s1->y != s2->y) {
#line 1057 "DockRenderer.vala"
		return FALSE;
#line 5212 "DockRenderer.c"
	}
#line 1057 "DockRenderer.vala"
	return TRUE;
#line 5216 "DockRenderer.c"
}

void
plank_dock_renderer_update_local_cursor (PlankDockRenderer* self,
                                         gint x,
                                         gint y)
{
	GdkPoint new_cursor = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_;
	GdkPoint _tmp2_;
	GdkPoint _tmp3_;
#line 1054 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 1056 "DockRenderer.vala"
	_tmp0_.x = x;
#line 1056 "DockRenderer.vala"
	_tmp0_.y = y;
#line 1056 "DockRenderer.vala"
	new_cursor = _tmp0_;
#line 1057 "DockRenderer.vala"
	_tmp1_ = self->priv->_local_cursor;
#line 1057 "DockRenderer.vala"
	_tmp2_ = new_cursor;
#line 1057 "DockRenderer.vala"
	if (_gdk_point_equal (&_tmp1_, &_tmp2_) == TRUE) {
#line 1058 "DockRenderer.vala"
		return;
#line 5245 "DockRenderer.c"
	}
#line 1060 "DockRenderer.vala"
	_tmp3_ = new_cursor;
#line 1060 "DockRenderer.vala"
	plank_dock_renderer_set_local_cursor (self, &_tmp3_);
#line 1062 "DockRenderer.vala"
	if (self->priv->screen_is_composited) {
#line 1063 "DockRenderer.vala"
		self->priv->zoom_changed = TRUE;
#line 1064 "DockRenderer.vala"
		plank_renderer_animated_draw ((PlankRenderer*) self);
#line 5257 "DockRenderer.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 1074 "DockRenderer.vala"
	return self ? g_object_ref (self) : NULL;
#line 5266 "DockRenderer.c"
}

void
plank_dock_renderer_animate_items (PlankDockRenderer* self,
                                   GeeList* elements)
{
	GeeHashSet* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
#line 1068 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 1068 "DockRenderer.vala"
	g_return_if_fail (elements != NULL);
#line 1070 "DockRenderer.vala"
	if (!self->priv->screen_is_composited) {
#line 1071 "DockRenderer.vala"
		return;
#line 5284 "DockRenderer.c"
	}
	{
		GeeList* _element_list = NULL;
		gint _element_size = 0;
		GeeList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _element_index = 0;
#line 1073 "DockRenderer.vala"
		_element_list = elements;
#line 1073 "DockRenderer.vala"
		_tmp0_ = _element_list;
#line 1073 "DockRenderer.vala"
		_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 1073 "DockRenderer.vala"
		_tmp2_ = _tmp1_;
#line 1073 "DockRenderer.vala"
		_element_size = _tmp2_;
#line 1073 "DockRenderer.vala"
		_element_index = -1;
#line 1073 "DockRenderer.vala"
		while (TRUE) {
#line 5307 "DockRenderer.c"
			gint _tmp3_;
			gint _tmp4_;
			PlankDockElement* element = NULL;
			GeeList* _tmp5_;
			gpointer _tmp6_;
			PlankDockItem* item = NULL;
			PlankDockElement* _tmp7_;
			PlankDockItem* _tmp8_;
			PlankDockItem* _tmp9_;
#line 1073 "DockRenderer.vala"
			_element_index = _element_index + 1;
#line 1073 "DockRenderer.vala"
			_tmp3_ = _element_index;
#line 1073 "DockRenderer.vala"
			_tmp4_ = _element_size;
#line 1073 "DockRenderer.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 1073 "DockRenderer.vala"
				break;
#line 5327 "DockRenderer.c"
			}
#line 1073 "DockRenderer.vala"
			_tmp5_ = _element_list;
#line 1073 "DockRenderer.vala"
			_tmp6_ = gee_list_get (_tmp5_, _element_index);
#line 1073 "DockRenderer.vala"
			element = (PlankDockElement*) _tmp6_;
#line 1074 "DockRenderer.vala"
			_tmp7_ = element;
#line 1074 "DockRenderer.vala"
			_tmp8_ = _g_object_ref0 (PLANK_IS_DOCK_ITEM (_tmp7_) ? ((PlankDockItem*) _tmp7_) : NULL);
#line 1074 "DockRenderer.vala"
			item = _tmp8_;
#line 1075 "DockRenderer.vala"
			_tmp9_ = item;
#line 1075 "DockRenderer.vala"
			if (_tmp9_ != NULL) {
#line 5345 "DockRenderer.c"
				GeeHashSet* _tmp10_;
				PlankDockItem* _tmp11_;
#line 1076 "DockRenderer.vala"
				_tmp10_ = self->priv->transient_items;
#line 1076 "DockRenderer.vala"
				_tmp11_ = item;
#line 1076 "DockRenderer.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 5354 "DockRenderer.c"
			}
#line 1073 "DockRenderer.vala"
			_g_object_unref0 (item);
#line 1073 "DockRenderer.vala"
			_g_object_unref0 (element);
#line 5360 "DockRenderer.c"
		}
	}
#line 1079 "DockRenderer.vala"
	_tmp12_ = self->priv->transient_items;
#line 1079 "DockRenderer.vala"
	_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 1079 "DockRenderer.vala"
	_tmp14_ = _tmp13_;
#line 1079 "DockRenderer.vala"
	if (_tmp14_ > 0) {
#line 1080 "DockRenderer.vala"
		plank_renderer_animated_draw ((PlankRenderer*) self);
#line 5373 "DockRenderer.c"
	}
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_dock_renderer_real_animation_needed (PlankRenderer* base,
                                           gint64 frame_time)
{
	PlankDockRenderer * self;
	PlankDockTheme* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	GeeHashSet* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gboolean result;
#line 1086 "DockRenderer.vala"
	self = (PlankDockRenderer*) base;
#line 1088 "DockRenderer.vala"
	if (self->priv->zoom_changed) {
#line 1090 "DockRenderer.vala"
		self->priv->zoom_changed = FALSE;
#line 1091 "DockRenderer.vala"
		result = TRUE;
#line 1091 "DockRenderer.vala"
		return result;
#line 5402 "DockRenderer.c"
	}
#line 1094 "DockRenderer.vala"
	if ((frame_time - self->priv->last_hovered_changed) <= ((gint64) (PLANK_DOCK_ZOOM_DURATION * 1000))) {
#line 1095 "DockRenderer.vala"
		result = TRUE;
#line 1095 "DockRenderer.vala"
		return result;
#line 5410 "DockRenderer.c"
	}
#line 1097 "DockRenderer.vala"
	_tmp0_ = self->priv->_theme;
#line 1097 "DockRenderer.vala"
	_tmp1_ = plank_dock_theme_get_FadeOpacity (_tmp0_);
#line 1097 "DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 1097 "DockRenderer.vala"
	if (_tmp2_ == 1.0) {
#line 5420 "DockRenderer.c"
		PlankDockTheme* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 1098 "DockRenderer.vala"
		_tmp3_ = self->priv->_theme;
#line 1098 "DockRenderer.vala"
		_tmp4_ = plank_dock_theme_get_HideTime (_tmp3_);
#line 1098 "DockRenderer.vala"
		_tmp5_ = _tmp4_;
#line 1098 "DockRenderer.vala"
		if ((frame_time - self->priv->last_hide) <= ((gint64) (_tmp5_ * 1000))) {
#line 1099 "DockRenderer.vala"
			result = TRUE;
#line 1099 "DockRenderer.vala"
			return result;
#line 5436 "DockRenderer.c"
		}
	} else {
		PlankDockTheme* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 1101 "DockRenderer.vala"
		_tmp6_ = self->priv->_theme;
#line 1101 "DockRenderer.vala"
		_tmp7_ = plank_dock_theme_get_FadeTime (_tmp6_);
#line 1101 "DockRenderer.vala"
		_tmp8_ = _tmp7_;
#line 1101 "DockRenderer.vala"
		if ((frame_time - self->priv->last_hide) <= ((gint64) (_tmp8_ * 1000))) {
#line 1102 "DockRenderer.vala"
			result = TRUE;
#line 1102 "DockRenderer.vala"
			return result;
#line 5454 "DockRenderer.c"
		}
	}
#line 1105 "DockRenderer.vala"
	_tmp9_ = self->priv->transient_items;
#line 1105 "DockRenderer.vala"
	_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
#line 1105 "DockRenderer.vala"
	_tmp11_ = _tmp10_;
#line 1105 "DockRenderer.vala"
	if (_tmp11_ > 0) {
#line 1106 "DockRenderer.vala"
		result = TRUE;
#line 1106 "DockRenderer.vala"
		return result;
#line 5469 "DockRenderer.c"
	}
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp12_;
		gint _item_size = 0;
		GeeArrayList* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _item_index = 0;
#line 1108 "DockRenderer.vala"
		_tmp12_ = self->priv->current_items;
#line 1108 "DockRenderer.vala"
		_item_list = _tmp12_;
#line 1108 "DockRenderer.vala"
		_tmp13_ = _item_list;
#line 1108 "DockRenderer.vala"
		_tmp14_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp13_);
#line 1108 "DockRenderer.vala"
		_tmp15_ = _tmp14_;
#line 1108 "DockRenderer.vala"
		_item_size = _tmp15_;
#line 1108 "DockRenderer.vala"
		_item_index = -1;
#line 1108 "DockRenderer.vala"
		while (TRUE) {
#line 5495 "DockRenderer.c"
			gint _tmp16_;
			gint _tmp17_;
			PlankDockItem* item = NULL;
			GeeArrayList* _tmp18_;
			gpointer _tmp19_;
			PlankDockItem* _tmp20_;
			PlankDockItem* _tmp21_;
#line 1108 "DockRenderer.vala"
			_item_index = _item_index + 1;
#line 1108 "DockRenderer.vala"
			_tmp16_ = _item_index;
#line 1108 "DockRenderer.vala"
			_tmp17_ = _item_size;
#line 1108 "DockRenderer.vala"
			if (!(_tmp16_ < _tmp17_)) {
#line 1108 "DockRenderer.vala"
				break;
#line 5513 "DockRenderer.c"
			}
#line 1108 "DockRenderer.vala"
			_tmp18_ = _item_list;
#line 1108 "DockRenderer.vala"
			_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, _item_index);
#line 1108 "DockRenderer.vala"
			_tmp20_ = _g_object_ref0 ((PlankDockItem*) _tmp19_);
#line 1108 "DockRenderer.vala"
			item = _tmp20_;
#line 1109 "DockRenderer.vala"
			_tmp21_ = item;
#line 1109 "DockRenderer.vala"
			if (plank_dock_renderer_item_animation_needed (self, _tmp21_, frame_time)) {
#line 1110 "DockRenderer.vala"
				result = TRUE;
#line 1110 "DockRenderer.vala"
				_g_object_unref0 (item);
#line 1110 "DockRenderer.vala"
				return result;
#line 5533 "DockRenderer.c"
			}
#line 1108 "DockRenderer.vala"
			_g_object_unref0 (item);
#line 5537 "DockRenderer.c"
		}
	}
#line 1112 "DockRenderer.vala"
	result = FALSE;
#line 1112 "DockRenderer.vala"
	return result;
#line 5544 "DockRenderer.c"
}

static inline gboolean
plank_dock_renderer_item_animation_needed (PlankDockRenderer* self,
                                           PlankDockItem* item,
                                           gint64 render_time)
{
	gboolean _tmp0_ = FALSE;
	PlankAnimationType _tmp1_;
	PlankAnimationType _tmp2_;
	gboolean _tmp14_ = FALSE;
	PlankAnimationType _tmp15_;
	PlankAnimationType _tmp16_;
	gboolean _tmp19_ = FALSE;
	PlankAnimationType _tmp20_;
	PlankAnimationType _tmp21_;
	gint64 _tmp24_;
	gint64 _tmp25_;
	PlankDockTheme* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gboolean _tmp29_ = FALSE;
	gint64 _tmp40_;
	gint64 _tmp41_;
	PlankDockTheme* _tmp42_;
	gint _tmp43_;
	gint _tmp44_;
	gint64 _tmp45_;
	gint64 _tmp46_;
	PlankDockTheme* _tmp47_;
	gint _tmp48_;
	gint _tmp49_;
	gint64 _tmp50_;
	gint64 _tmp51_;
	PlankDockTheme* _tmp52_;
	gint _tmp53_;
	gint _tmp54_;
	gint64 _tmp55_;
	gint64 _tmp56_;
	gboolean result;
#line 1115 "DockRenderer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1115 "DockRenderer.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1117 "DockRenderer.vala"
	_tmp1_ = plank_dock_element_get_ClickedAnimation ((PlankDockElement*) item);
#line 1117 "DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 1117 "DockRenderer.vala"
	if (_tmp2_ != PLANK_ANIMATION_TYPE_NONE) {
#line 5595 "DockRenderer.c"
		gint _tmp3_ = 0;
		PlankAnimationType _tmp4_;
		PlankAnimationType _tmp5_;
		gint64 _tmp12_;
		gint64 _tmp13_;
#line 1118 "DockRenderer.vala"
		_tmp4_ = plank_dock_element_get_ClickedAnimation ((PlankDockElement*) item);
#line 1118 "DockRenderer.vala"
		_tmp5_ = _tmp4_;
#line 1118 "DockRenderer.vala"
		if (_tmp5_ == PLANK_ANIMATION_TYPE_BOUNCE) {
#line 5607 "DockRenderer.c"
			PlankDockTheme* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
#line 1118 "DockRenderer.vala"
			_tmp6_ = self->priv->_theme;
#line 1118 "DockRenderer.vala"
			_tmp7_ = plank_dock_theme_get_LaunchBounceTime (_tmp6_);
#line 1118 "DockRenderer.vala"
			_tmp8_ = _tmp7_;
#line 1118 "DockRenderer.vala"
			_tmp3_ = _tmp8_;
#line 5619 "DockRenderer.c"
		} else {
			PlankDockTheme* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
#line 1118 "DockRenderer.vala"
			_tmp9_ = self->priv->_theme;
#line 1118 "DockRenderer.vala"
			_tmp10_ = plank_dock_theme_get_ClickTime (_tmp9_);
#line 1118 "DockRenderer.vala"
			_tmp11_ = _tmp10_;
#line 1118 "DockRenderer.vala"
			_tmp3_ = _tmp11_;
#line 5632 "DockRenderer.c"
		}
#line 1118 "DockRenderer.vala"
		_tmp12_ = plank_dock_element_get_LastClicked ((PlankDockElement*) item);
#line 1118 "DockRenderer.vala"
		_tmp13_ = _tmp12_;
#line 1118 "DockRenderer.vala"
		_tmp0_ = (render_time - _tmp13_) <= ((gint64) (_tmp3_ * 1000));
#line 5640 "DockRenderer.c"
	} else {
#line 1117 "DockRenderer.vala"
		_tmp0_ = FALSE;
#line 5644 "DockRenderer.c"
	}
#line 1117 "DockRenderer.vala"
	if (_tmp0_) {
#line 1119 "DockRenderer.vala"
		result = TRUE;
#line 1119 "DockRenderer.vala"
		return result;
#line 5652 "DockRenderer.c"
	}
#line 1120 "DockRenderer.vala"
	_tmp15_ = plank_dock_element_get_HoveredAnimation ((PlankDockElement*) item);
#line 1120 "DockRenderer.vala"
	_tmp16_ = _tmp15_;
#line 1120 "DockRenderer.vala"
	if (_tmp16_ != PLANK_ANIMATION_TYPE_NONE) {
#line 5660 "DockRenderer.c"
		gint64 _tmp17_;
		gint64 _tmp18_;
#line 1121 "DockRenderer.vala"
		_tmp17_ = plank_dock_element_get_LastHovered ((PlankDockElement*) item);
#line 1121 "DockRenderer.vala"
		_tmp18_ = _tmp17_;
#line 1121 "DockRenderer.vala"
		_tmp14_ = (render_time - _tmp18_) <= ((gint64) (PLANK_ITEM_HOVER_DURATION * 1000));
#line 5669 "DockRenderer.c"
	} else {
#line 1120 "DockRenderer.vala"
		_tmp14_ = FALSE;
#line 5673 "DockRenderer.c"
	}
#line 1120 "DockRenderer.vala"
	if (_tmp14_) {
#line 1122 "DockRenderer.vala"
		result = TRUE;
#line 1122 "DockRenderer.vala"
		return result;
#line 5681 "DockRenderer.c"
	}
#line 1123 "DockRenderer.vala"
	_tmp20_ = plank_dock_element_get_ScrolledAnimation ((PlankDockElement*) item);
#line 1123 "DockRenderer.vala"
	_tmp21_ = _tmp20_;
#line 1123 "DockRenderer.vala"
	if (_tmp21_ != PLANK_ANIMATION_TYPE_NONE) {
#line 5689 "DockRenderer.c"
		gint64 _tmp22_;
		gint64 _tmp23_;
#line 1124 "DockRenderer.vala"
		_tmp22_ = plank_dock_element_get_LastScrolled ((PlankDockElement*) item);
#line 1124 "DockRenderer.vala"
		_tmp23_ = _tmp22_;
#line 1124 "DockRenderer.vala"
		_tmp19_ = (render_time - _tmp23_) <= ((gint64) (PLANK_ITEM_SCROLL_DURATION * 1000));
#line 5698 "DockRenderer.c"
	} else {
#line 1123 "DockRenderer.vala"
		_tmp19_ = FALSE;
#line 5702 "DockRenderer.c"
	}
#line 1123 "DockRenderer.vala"
	if (_tmp19_) {
#line 1125 "DockRenderer.vala"
		result = TRUE;
#line 1125 "DockRenderer.vala"
		return result;
#line 5710 "DockRenderer.c"
	}
#line 1126 "DockRenderer.vala"
	_tmp24_ = plank_dock_element_get_LastActive ((PlankDockElement*) item);
#line 1126 "DockRenderer.vala"
	_tmp25_ = _tmp24_;
#line 1126 "DockRenderer.vala"
	_tmp26_ = self->priv->_theme;
#line 1126 "DockRenderer.vala"
	_tmp27_ = plank_dock_theme_get_ActiveTime (_tmp26_);
#line 1126 "DockRenderer.vala"
	_tmp28_ = _tmp27_;
#line 1126 "DockRenderer.vala"
	if ((render_time - _tmp25_) <= ((gint64) (_tmp28_ * 1000))) {
#line 1127 "DockRenderer.vala"
		result = TRUE;
#line 1127 "DockRenderer.vala"
		return result;
#line 5728 "DockRenderer.c"
	}
#line 1128 "DockRenderer.vala"
	if (self->priv->show_notifications) {
#line 5732 "DockRenderer.c"
		gint _tmp30_ = 0;
		gdouble _tmp31_;
		gint64 _tmp38_;
		gint64 _tmp39_;
#line 1129 "DockRenderer.vala"
		_tmp31_ = self->priv->_hide_progress;
#line 1129 "DockRenderer.vala"
		if (_tmp31_ == 1.0) {
#line 5741 "DockRenderer.c"
			PlankDockTheme* _tmp32_;
			gint _tmp33_;
			gint _tmp34_;
#line 1129 "DockRenderer.vala"
			_tmp32_ = self->priv->_theme;
#line 1129 "DockRenderer.vala"
			_tmp33_ = plank_dock_theme_get_GlowTime (_tmp32_);
#line 1129 "DockRenderer.vala"
			_tmp34_ = _tmp33_;
#line 1129 "DockRenderer.vala"
			_tmp30_ = _tmp34_;
#line 5753 "DockRenderer.c"
		} else {
			PlankDockTheme* _tmp35_;
			gint _tmp36_;
			gint _tmp37_;
#line 1129 "DockRenderer.vala"
			_tmp35_ = self->priv->_theme;
#line 1129 "DockRenderer.vala"
			_tmp36_ = plank_dock_theme_get_UrgentBounceTime (_tmp35_);
#line 1129 "DockRenderer.vala"
			_tmp37_ = _tmp36_;
#line 1129 "DockRenderer.vala"
			_tmp30_ = _tmp37_;
#line 5766 "DockRenderer.c"
		}
#line 1129 "DockRenderer.vala"
		_tmp38_ = plank_dock_element_get_LastUrgent ((PlankDockElement*) item);
#line 1129 "DockRenderer.vala"
		_tmp39_ = _tmp38_;
#line 1129 "DockRenderer.vala"
		_tmp29_ = (render_time - _tmp39_) <= ((gint64) (_tmp30_ * 1000));
#line 5774 "DockRenderer.c"
	} else {
#line 1128 "DockRenderer.vala"
		_tmp29_ = FALSE;
#line 5778 "DockRenderer.c"
	}
#line 1128 "DockRenderer.vala"
	if (_tmp29_) {
#line 1130 "DockRenderer.vala"
		result = TRUE;
#line 1130 "DockRenderer.vala"
		return result;
#line 5786 "DockRenderer.c"
	}
#line 1131 "DockRenderer.vala"
	_tmp40_ = plank_dock_element_get_LastMove ((PlankDockElement*) item);
#line 1131 "DockRenderer.vala"
	_tmp41_ = _tmp40_;
#line 1131 "DockRenderer.vala"
	_tmp42_ = self->priv->_theme;
#line 1131 "DockRenderer.vala"
	_tmp43_ = plank_dock_theme_get_ItemMoveTime (_tmp42_);
#line 1131 "DockRenderer.vala"
	_tmp44_ = _tmp43_;
#line 1131 "DockRenderer.vala"
	if ((render_time - _tmp41_) <= ((gint64) (_tmp44_ * 1000))) {
#line 1132 "DockRenderer.vala"
		result = TRUE;
#line 1132 "DockRenderer.vala"
		return result;
#line 5804 "DockRenderer.c"
	}
#line 1133 "DockRenderer.vala"
	_tmp45_ = plank_dock_element_get_AddTime ((PlankDockElement*) item);
#line 1133 "DockRenderer.vala"
	_tmp46_ = _tmp45_;
#line 1133 "DockRenderer.vala"
	_tmp47_ = self->priv->_theme;
#line 1133 "DockRenderer.vala"
	_tmp48_ = plank_dock_theme_get_ItemMoveTime (_tmp47_);
#line 1133 "DockRenderer.vala"
	_tmp49_ = _tmp48_;
#line 1133 "DockRenderer.vala"
	if ((render_time - _tmp46_) <= ((gint64) (_tmp49_ * 1000))) {
#line 1134 "DockRenderer.vala"
		result = TRUE;
#line 1134 "DockRenderer.vala"
		return result;
#line 5822 "DockRenderer.c"
	}
#line 1135 "DockRenderer.vala"
	_tmp50_ = plank_dock_element_get_RemoveTime ((PlankDockElement*) item);
#line 1135 "DockRenderer.vala"
	_tmp51_ = _tmp50_;
#line 1135 "DockRenderer.vala"
	_tmp52_ = self->priv->_theme;
#line 1135 "DockRenderer.vala"
	_tmp53_ = plank_dock_theme_get_ItemMoveTime (_tmp52_);
#line 1135 "DockRenderer.vala"
	_tmp54_ = _tmp53_;
#line 1135 "DockRenderer.vala"
	if ((render_time - _tmp51_) <= ((gint64) (_tmp54_ * 1000))) {
#line 1136 "DockRenderer.vala"
		result = TRUE;
#line 1136 "DockRenderer.vala"
		return result;
#line 5840 "DockRenderer.c"
	}
#line 1137 "DockRenderer.vala"
	_tmp55_ = plank_dock_element_get_LastValid ((PlankDockElement*) item);
#line 1137 "DockRenderer.vala"
	_tmp56_ = _tmp55_;
#line 1137 "DockRenderer.vala"
	if ((render_time - _tmp56_) <= ((gint64) (PLANK_ITEM_INVALID_DURATION * 1000))) {
#line 1138 "DockRenderer.vala"
		result = TRUE;
#line 1138 "DockRenderer.vala"
		return result;
#line 5852 "DockRenderer.c"
	}
#line 1140 "DockRenderer.vala"
	result = FALSE;
#line 1140 "DockRenderer.vala"
	return result;
#line 5858 "DockRenderer.c"
}

static gint
plank_dock_renderer_compare_dock_item_position (PlankDockItem* i1,
                                                PlankDockItem* i2)
{
	gint p_i1 = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint p_i2 = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint64 _tmp4_;
	gint64 _tmp5_;
	gint64 _tmp6_;
	gint64 _tmp7_;
	gint result;
#line 1143 "DockRenderer.vala"
	g_return_val_if_fail (i1 != NULL, 0);
#line 1143 "DockRenderer.vala"
	g_return_val_if_fail (i2 != NULL, 0);
#line 1145 "DockRenderer.vala"
	_tmp0_ = plank_dock_item_get_Position (i1);
#line 1145 "DockRenderer.vala"
	_tmp1_ = _tmp0_;
#line 1145 "DockRenderer.vala"
	p_i1 = _tmp1_;
#line 1146 "DockRenderer.vala"
	_tmp2_ = plank_dock_item_get_Position (i2);
#line 1146 "DockRenderer.vala"
	_tmp3_ = _tmp2_;
#line 1146 "DockRenderer.vala"
	p_i2 = _tmp3_;
#line 1148 "DockRenderer.vala"
	if (p_i1 > p_i2) {
#line 1149 "DockRenderer.vala"
		result = 1;
#line 1149 "DockRenderer.vala"
		return result;
#line 5898 "DockRenderer.c"
	}
#line 1151 "DockRenderer.vala"
	if (p_i1 < p_i2) {
#line 1152 "DockRenderer.vala"
		result = -1;
#line 1152 "DockRenderer.vala"
		return result;
#line 5906 "DockRenderer.c"
	}
#line 1154 "DockRenderer.vala"
	_tmp4_ = plank_dock_element_get_RemoveTime ((PlankDockElement*) i1);
#line 1154 "DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 1154 "DockRenderer.vala"
	_tmp6_ = plank_dock_element_get_RemoveTime ((PlankDockElement*) i2);
#line 1154 "DockRenderer.vala"
	_tmp7_ = _tmp6_;
#line 1154 "DockRenderer.vala"
	if (_tmp5_ > _tmp7_) {
#line 1155 "DockRenderer.vala"
		result = -1;
#line 1155 "DockRenderer.vala"
		return result;
#line 5922 "DockRenderer.c"
	}
#line 1157 "DockRenderer.vala"
	result = 1;
#line 1157 "DockRenderer.vala"
	return result;
#line 5928 "DockRenderer.c"
}

static gdouble
plank_dock_renderer_easing_bounce (gdouble t,
                                   gdouble d,
                                   gdouble n)
{
	gdouble p = 0.0;
	gdouble result;
#line 1160 "DockRenderer.vala"
	_vala_return_val_if_fail (((t >= 0.0) && (d > 0.0)) && (n >= 1.0), "t >= 0.0 && d > 0.0 && n >= 1.0", 0.0);
#line 1160 "DockRenderer.vala"
	_vala_return_val_if_fail (t <= d, "t <= d", 0.0);
#line 1164 "DockRenderer.vala"
	p = t / d;
#line 1165 "DockRenderer.vala"
	result = fabs (sin ((n * G_PI) * p) * MIN (1.0, ((1.0 - p) * (2.0 * n)) / ((2.0 * n) - 1.0)));
#line 1165 "DockRenderer.vala"
	return result;
#line 5948 "DockRenderer.c"
}

static const gchar*
plank_dock_renderer_cairo_surface_type_to_string (cairo_surface_type_t type)
{
	const gchar* _result_ = NULL;
	const gchar* _tmp0_;
	const gchar* result;
#line 1172 "DockRenderer.vala"
	switch (type) {
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_IMAGE:
#line 5961 "DockRenderer.c"
		{
#line 1173 "DockRenderer.vala"
			_result_ = "IMAGE";
#line 1173 "DockRenderer.vala"
			break;
#line 5967 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_PDF:
#line 5971 "DockRenderer.c"
		{
#line 1174 "DockRenderer.vala"
			_result_ = "PDF";
#line 1174 "DockRenderer.vala"
			break;
#line 5977 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_PS:
#line 5981 "DockRenderer.c"
		{
#line 1175 "DockRenderer.vala"
			_result_ = "PS";
#line 1175 "DockRenderer.vala"
			break;
#line 5987 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_XLIB:
#line 5991 "DockRenderer.c"
		{
#line 1176 "DockRenderer.vala"
			_result_ = "XLIB";
#line 1176 "DockRenderer.vala"
			break;
#line 5997 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_XCB:
#line 6001 "DockRenderer.c"
		{
#line 1177 "DockRenderer.vala"
			_result_ = "XCB";
#line 1177 "DockRenderer.vala"
			break;
#line 6007 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_GLITZ:
#line 6011 "DockRenderer.c"
		{
#line 1178 "DockRenderer.vala"
			_result_ = "GLITZ";
#line 1178 "DockRenderer.vala"
			break;
#line 6017 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_QUARTZ:
#line 6021 "DockRenderer.c"
		{
#line 1179 "DockRenderer.vala"
			_result_ = "QUARTZ";
#line 1179 "DockRenderer.vala"
			break;
#line 6027 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_WIN32:
#line 6031 "DockRenderer.c"
		{
#line 1180 "DockRenderer.vala"
			_result_ = "WIN32";
#line 1180 "DockRenderer.vala"
			break;
#line 6037 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_BEOS:
#line 6041 "DockRenderer.c"
		{
#line 1181 "DockRenderer.vala"
			_result_ = "BEOS";
#line 1181 "DockRenderer.vala"
			break;
#line 6047 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_DIRECTFB:
#line 6051 "DockRenderer.c"
		{
#line 1182 "DockRenderer.vala"
			_result_ = "DIRECTFB";
#line 1182 "DockRenderer.vala"
			break;
#line 6057 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_SVG:
#line 6061 "DockRenderer.c"
		{
#line 1183 "DockRenderer.vala"
			_result_ = "SVG";
#line 1183 "DockRenderer.vala"
			break;
#line 6067 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_OS2:
#line 6071 "DockRenderer.c"
		{
#line 1184 "DockRenderer.vala"
			_result_ = "OS2";
#line 1184 "DockRenderer.vala"
			break;
#line 6077 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_WIN32_PRINTING:
#line 6081 "DockRenderer.c"
		{
#line 1185 "DockRenderer.vala"
			_result_ = "WIN32_PRINTING";
#line 1185 "DockRenderer.vala"
			break;
#line 6087 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_QUARTZ_IMAGE:
#line 6091 "DockRenderer.c"
		{
#line 1186 "DockRenderer.vala"
			_result_ = "QUARTZ_IMAGE";
#line 1186 "DockRenderer.vala"
			break;
#line 6097 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_SCRIPT:
#line 6101 "DockRenderer.c"
		{
#line 1187 "DockRenderer.vala"
			_result_ = "SCRIPT";
#line 1187 "DockRenderer.vala"
			break;
#line 6107 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_QT:
#line 6111 "DockRenderer.c"
		{
#line 1188 "DockRenderer.vala"
			_result_ = "QT";
#line 1188 "DockRenderer.vala"
			break;
#line 6117 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_RECORDING:
#line 6121 "DockRenderer.c"
		{
#line 1189 "DockRenderer.vala"
			_result_ = "RECORDING";
#line 1189 "DockRenderer.vala"
			break;
#line 6127 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_VG:
#line 6131 "DockRenderer.c"
		{
#line 1190 "DockRenderer.vala"
			_result_ = "VG";
#line 1190 "DockRenderer.vala"
			break;
#line 6137 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_GL:
#line 6141 "DockRenderer.c"
		{
#line 1191 "DockRenderer.vala"
			_result_ = "GL";
#line 1191 "DockRenderer.vala"
			break;
#line 6147 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_DRM:
#line 6151 "DockRenderer.c"
		{
#line 1192 "DockRenderer.vala"
			_result_ = "DRM";
#line 1192 "DockRenderer.vala"
			break;
#line 6157 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_TEE:
#line 6161 "DockRenderer.c"
		{
#line 1193 "DockRenderer.vala"
			_result_ = "TEE";
#line 1193 "DockRenderer.vala"
			break;
#line 6167 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_XML:
#line 6171 "DockRenderer.c"
		{
#line 1194 "DockRenderer.vala"
			_result_ = "XML";
#line 1194 "DockRenderer.vala"
			break;
#line 6177 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_SKIA:
#line 6181 "DockRenderer.c"
		{
#line 1195 "DockRenderer.vala"
			_result_ = "SKIA";
#line 1195 "DockRenderer.vala"
			break;
#line 6187 "DockRenderer.c"
		}
#line 1172 "DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_SUBSURFACE:
#line 6191 "DockRenderer.c"
		{
#line 1196 "DockRenderer.vala"
			_result_ = "SUBSURFACE";
#line 1196 "DockRenderer.vala"
			break;
#line 6197 "DockRenderer.c"
		}
		default:
		{
#line 1199 "DockRenderer.vala"
			_result_ = "???";
#line 1199 "DockRenderer.vala"
			break;
#line 6205 "DockRenderer.c"
		}
	}
#line 1202 "DockRenderer.vala"
	_tmp0_ = _result_;
#line 1202 "DockRenderer.vala"
	result = _tmp0_;
#line 1202 "DockRenderer.vala"
	return result;
#line 6214 "DockRenderer.c"
}

static PlankDockController*
plank_dock_renderer_get_controller (PlankDockRenderer* self)
{
	PlankDockController* result;
	PlankDockController* _tmp0_;
#line 27 "DockRenderer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 27 "DockRenderer.vala"
	result = _tmp0_;
#line 27 "DockRenderer.vala"
	return result;
#line 6230 "DockRenderer.c"
}

static void
plank_dock_renderer_set_controller (PlankDockRenderer* self,
                                    PlankDockController* value)
{
	PlankDockController* old_value;
#line 27 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 27 "DockRenderer.vala"
	old_value = plank_dock_renderer_get_controller (self);
#line 27 "DockRenderer.vala"
	if (old_value != value) {
#line 6244 "DockRenderer.c"
		PlankDockController* _tmp0_;
#line 27 "DockRenderer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 27 "DockRenderer.vala"
		_g_object_unref0 (self->priv->_controller);
#line 27 "DockRenderer.vala"
		self->priv->_controller = _tmp0_;
#line 27 "DockRenderer.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_renderer_properties[PLANK_DOCK_RENDERER_CONTROLLER_PROPERTY]);
#line 6254 "DockRenderer.c"
	}
}

PlankDockTheme*
plank_dock_renderer_get_theme (PlankDockRenderer* self)
{
	PlankDockTheme* result;
	PlankDockTheme* _tmp0_;
#line 29 "DockRenderer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "DockRenderer.vala"
	_tmp0_ = self->priv->_theme;
#line 29 "DockRenderer.vala"
	result = _tmp0_;
#line 29 "DockRenderer.vala"
	return result;
#line 6271 "DockRenderer.c"
}

static void
plank_dock_renderer_set_theme (PlankDockRenderer* self,
                               PlankDockTheme* value)
{
	PlankDockTheme* old_value;
#line 29 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 29 "DockRenderer.vala"
	old_value = plank_dock_renderer_get_theme (self);
#line 29 "DockRenderer.vala"
	if (old_value != value) {
#line 6285 "DockRenderer.c"
		PlankDockTheme* _tmp0_;
#line 29 "DockRenderer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 29 "DockRenderer.vala"
		_g_object_unref0 (self->priv->_theme);
#line 29 "DockRenderer.vala"
		self->priv->_theme = _tmp0_;
#line 29 "DockRenderer.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_renderer_properties[PLANK_DOCK_RENDERER_THEME_PROPERTY]);
#line 6295 "DockRenderer.c"
	}
}

gdouble
plank_dock_renderer_get_hide_progress (PlankDockRenderer* self)
{
	gdouble result;
#line 35 "DockRenderer.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 35 "DockRenderer.vala"
	result = self->priv->_hide_progress;
#line 35 "DockRenderer.vala"
	return result;
#line 6309 "DockRenderer.c"
}

static void
plank_dock_renderer_set_hide_progress (PlankDockRenderer* self,
                                       gdouble value)
{
#line 35 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 35 "DockRenderer.vala"
	self->priv->_hide_progress = value;
#line 6320 "DockRenderer.c"
}

static gdouble
plank_dock_renderer_get_opacity (PlankDockRenderer* self)
{
	gdouble result;
#line 41 "DockRenderer.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 41 "DockRenderer.vala"
	result = self->priv->_opacity;
#line 41 "DockRenderer.vala"
	return result;
#line 6333 "DockRenderer.c"
}

static void
plank_dock_renderer_set_opacity (PlankDockRenderer* self,
                                 gdouble value)
{
#line 41 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 41 "DockRenderer.vala"
	self->priv->_opacity = value;
#line 6344 "DockRenderer.c"
}

gdouble
plank_dock_renderer_get_zoom_in_progress (PlankDockRenderer* self)
{
	gdouble result;
#line 47 "DockRenderer.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 47 "DockRenderer.vala"
	result = self->priv->_zoom_in_progress;
#line 47 "DockRenderer.vala"
	return result;
#line 6357 "DockRenderer.c"
}

static void
plank_dock_renderer_set_zoom_in_progress (PlankDockRenderer* self,
                                          gdouble value)
{
#line 47 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 47 "DockRenderer.vala"
	self->priv->_zoom_in_progress = value;
#line 6368 "DockRenderer.c"
}

void
plank_dock_renderer_get_local_cursor (PlankDockRenderer* self,
                                      GdkPoint * result)
{
	GdkPoint _tmp0_;
#line 53 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 53 "DockRenderer.vala"
	_tmp0_ = self->priv->_local_cursor;
#line 53 "DockRenderer.vala"
	*result = _tmp0_;
#line 53 "DockRenderer.vala"
	return;
#line 6384 "DockRenderer.c"
}

static void
plank_dock_renderer_set_local_cursor (PlankDockRenderer* self,
                                      GdkPoint * value)
{
	GdkPoint _tmp0_;
#line 53 "DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 53 "DockRenderer.vala"
	_tmp0_ = *value;
#line 53 "DockRenderer.vala"
	self->priv->_local_cursor = _tmp0_;
#line 6398 "DockRenderer.c"
}

static GObject *
plank_dock_renderer_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankDockRenderer * self;
	GeeHashSet* _tmp0_;
	GeeArrayList* _tmp1_;
	PlankDockController* _tmp2_;
	PlankDockPreferences* _tmp3_;
	PlankDockPreferences* _tmp4_;
#line 97 "DockRenderer.vala"
	parent_class = G_OBJECT_CLASS (plank_dock_renderer_parent_class);
#line 97 "DockRenderer.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 97 "DockRenderer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DOCK_RENDERER, PlankDockRenderer);
#line 99 "DockRenderer.vala"
	_tmp0_ = gee_hash_set_new (PLANK_TYPE_DOCK_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 99 "DockRenderer.vala"
	_g_object_unref0 (self->priv->transient_items);
#line 99 "DockRenderer.vala"
	self->priv->transient_items = _tmp0_;
#line 100 "DockRenderer.vala"
	_tmp1_ = gee_array_list_new (PLANK_TYPE_DOCK_ITEM, NULL, NULL, NULL, NULL, NULL);
#line 100 "DockRenderer.vala"
	_g_object_unref0 (self->priv->current_items);
#line 100 "DockRenderer.vala"
	self->priv->current_items = _tmp1_;
#line 104 "DockRenderer.vala"
	_tmp2_ = self->priv->_controller;
#line 104 "DockRenderer.vala"
	_tmp3_ = plank_dock_controller_get_prefs (_tmp2_);
#line 104 "DockRenderer.vala"
	_tmp4_ = _tmp3_;
#line 104 "DockRenderer.vala"
	g_signal_connect_object ((GObject*) _tmp4_, "notify", (GCallback) _plank_dock_renderer_prefs_changed_g_object_notify, self, 0);
#line 106 "DockRenderer.vala"
	plank_dock_renderer_load_theme (self);
#line 97 "DockRenderer.vala"
	return obj;
#line 6444 "DockRenderer.c"
}

static void
plank_dock_renderer_class_init (PlankDockRendererClass * klass,
                                gpointer klass_data)
{
#line 25 "DockRenderer.vala"
	plank_dock_renderer_parent_class = g_type_class_peek_parent (klass);
#line 25 "DockRenderer.vala"
	g_type_class_adjust_private_offset (klass, &PlankDockRenderer_private_offset);
#line 25 "DockRenderer.vala"
	((PlankRendererClass *) klass)->initialize_frame = (void (*) (PlankRenderer*, gint64)) plank_dock_renderer_real_initialize_frame;
#line 25 "DockRenderer.vala"
	((PlankRendererClass *) klass)->draw = (void (*) (PlankRenderer*, cairo_t*, gint64)) plank_dock_renderer_real_draw;
#line 25 "DockRenderer.vala"
	((PlankRendererClass *) klass)->animation_needed = (gboolean (*) (PlankRenderer*, gint64)) plank_dock_renderer_real_animation_needed;
#line 25 "DockRenderer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_dock_renderer_get_property;
#line 25 "DockRenderer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_dock_renderer_set_property;
#line 25 "DockRenderer.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_dock_renderer_constructor;
#line 25 "DockRenderer.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_dock_renderer_finalize;
#line 25 "DockRenderer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_RENDERER_CONTROLLER_PROPERTY, plank_dock_renderer_properties[PLANK_DOCK_RENDERER_CONTROLLER_PROPERTY] = g_param_spec_object ("controller", "controller", "controller", PLANK_TYPE_DOCK_CONTROLLER, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 25 "DockRenderer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_RENDERER_THEME_PROPERTY, plank_dock_renderer_properties[PLANK_DOCK_RENDERER_THEME_PROPERTY] = g_param_spec_object ("theme", "theme", "theme", PLANK_TYPE_DOCK_THEME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6473 "DockRenderer.c"
	/**
	 * The current progress [0.0..1.0] of the hide-animation of the dock.
	 */
#line 25 "DockRenderer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_RENDERER_HIDE_PROGRESS_PROPERTY, plank_dock_renderer_properties[PLANK_DOCK_RENDERER_HIDE_PROGRESS_PROPERTY] = g_param_spec_double ("hide-progress", "hide-progress", "hide-progress", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 6479 "DockRenderer.c"
	/**
	 * The current progress [0.0..1.0] of the zoom-in-animation of the dock.
	 */
#line 25 "DockRenderer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_RENDERER_ZOOM_IN_PROGRESS_PROPERTY, plank_dock_renderer_properties[PLANK_DOCK_RENDERER_ZOOM_IN_PROGRESS_PROPERTY] = g_param_spec_double ("zoom-in-progress", "zoom-in-progress", "zoom-in-progress", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 6485 "DockRenderer.c"
}

static void
plank_dock_renderer_instance_init (PlankDockRenderer * self,
                                   gpointer klass)
{
#line 25 "DockRenderer.vala"
	self->priv = plank_dock_renderer_get_instance_private (self);
#line 55 "DockRenderer.vala"
	self->priv->main_buffer = NULL;
#line 56 "DockRenderer.vala"
	self->priv->fade_buffer = NULL;
#line 57 "DockRenderer.vala"
	self->priv->item_buffer = NULL;
#line 58 "DockRenderer.vala"
	self->priv->shadow_buffer = NULL;
#line 60 "DockRenderer.vala"
	self->priv->background_buffer = NULL;
#line 62 "DockRenderer.vala"
	self->priv->indicator_buffer = NULL;
#line 63 "DockRenderer.vala"
	self->priv->urgent_indicator_buffer = NULL;
#line 64 "DockRenderer.vala"
	self->priv->urgent_glow_buffer = NULL;
#line 66 "DockRenderer.vala"
	self->priv->last_hide = 0LL;
#line 67 "DockRenderer.vala"
	self->priv->last_hovered_changed = 0LL;
#line 69 "DockRenderer.vala"
	self->priv->screen_is_composited = FALSE;
#line 70 "DockRenderer.vala"
	self->priv->show_notifications = TRUE;
#line 71 "DockRenderer.vala"
	self->priv->reset_position_manager_timer_id = 0U;
#line 72 "DockRenderer.vala"
	self->priv->window_scale_factor = 1;
#line 73 "DockRenderer.vala"
	self->priv->is_first_frame = TRUE;
#line 74 "DockRenderer.vala"
	self->priv->zoom_changed = FALSE;
#line 76 "DockRenderer.vala"
	self->priv->gtk_theme_name_changed_handler_id = 0UL;
#line 78 "DockRenderer.vala"
	self->priv->dynamic_animation_offset = 0.0;
#line 6530 "DockRenderer.c"
}

static void
plank_dock_renderer_finalize (GObject * obj)
{
	PlankDockRenderer * self;
	PlankDockController* _tmp0_;
	PlankDockPreferences* _tmp1_;
	PlankDockPreferences* _tmp2_;
	guint _tmp3_;
	PlankDockTheme* _tmp4_;
	guint _tmp5_;
	PlankDockController* _tmp6_;
	PlankHideManager* _tmp7_;
	PlankHideManager* _tmp8_;
	guint _tmp9_;
	GQuark _tmp10_;
	PlankDockController* _tmp11_;
	PlankHideManager* _tmp12_;
	PlankHideManager* _tmp13_;
	guint _tmp14_;
	GQuark _tmp15_;
	PlankDockController* _tmp16_;
	PlankDockWindow* _tmp17_;
	PlankDockWindow* _tmp18_;
	guint _tmp19_;
	GQuark _tmp20_;
#line 25 "DockRenderer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DOCK_RENDERER, PlankDockRenderer);
#line 124 "DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 124 "DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_prefs (_tmp0_);
#line 124 "DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 124 "DockRenderer.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp3_, NULL, FALSE);
#line 124 "DockRenderer.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _plank_dock_renderer_prefs_changed_g_object_notify, self);
#line 125 "DockRenderer.vala"
	_tmp4_ = self->priv->_theme;
#line 125 "DockRenderer.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp5_, NULL, FALSE);
#line 125 "DockRenderer.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _plank_dock_renderer_theme_changed_g_object_notify, self);
#line 127 "DockRenderer.vala"
	_tmp6_ = self->priv->_controller;
#line 127 "DockRenderer.vala"
	_tmp7_ = plank_dock_controller_get_hide_manager (_tmp6_);
#line 127 "DockRenderer.vala"
	_tmp8_ = _tmp7_;
#line 127 "DockRenderer.vala"
	g_signal_parse_name ("notify::Hidden", G_TYPE_OBJECT, &_tmp9_, &_tmp10_, TRUE);
#line 127 "DockRenderer.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, _tmp10_, NULL, (GCallback) _plank_dock_renderer_hidden_changed_g_object_notify, self);
#line 128 "DockRenderer.vala"
	_tmp11_ = self->priv->_controller;
#line 128 "DockRenderer.vala"
	_tmp12_ = plank_dock_controller_get_hide_manager (_tmp11_);
#line 128 "DockRenderer.vala"
	_tmp13_ = _tmp12_;
#line 128 "DockRenderer.vala"
	g_signal_parse_name ("notify::Hovered", G_TYPE_OBJECT, &_tmp14_, &_tmp15_, TRUE);
#line 128 "DockRenderer.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp13_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp14_, _tmp15_, NULL, (GCallback) _plank_dock_renderer_hovered_changed_g_object_notify, self);
#line 129 "DockRenderer.vala"
	_tmp16_ = self->priv->_controller;
#line 129 "DockRenderer.vala"
	_tmp17_ = plank_dock_controller_get_window (_tmp16_);
#line 129 "DockRenderer.vala"
	_tmp18_ = _tmp17_;
#line 129 "DockRenderer.vala"
	g_signal_parse_name ("notify::HoveredItem", G_TYPE_OBJECT, &_tmp19_, &_tmp20_, TRUE);
#line 129 "DockRenderer.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp18_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp19_, _tmp20_, NULL, (GCallback) _plank_renderer_animated_draw_g_object_notify, (PlankRenderer*) self);
#line 27 "DockRenderer.vala"
	_g_object_unref0 (self->priv->_controller);
#line 29 "DockRenderer.vala"
	_g_object_unref0 (self->priv->_theme);
#line 55 "DockRenderer.vala"
	_g_object_unref0 (self->priv->main_buffer);
#line 56 "DockRenderer.vala"
	_g_object_unref0 (self->priv->fade_buffer);
#line 57 "DockRenderer.vala"
	_g_object_unref0 (self->priv->item_buffer);
#line 58 "DockRenderer.vala"
	_g_object_unref0 (self->priv->shadow_buffer);
#line 60 "DockRenderer.vala"
	_g_object_unref0 (self->priv->background_buffer);
#line 62 "DockRenderer.vala"
	_g_object_unref0 (self->priv->indicator_buffer);
#line 63 "DockRenderer.vala"
	_g_object_unref0 (self->priv->urgent_indicator_buffer);
#line 64 "DockRenderer.vala"
	_g_object_unref0 (self->priv->urgent_glow_buffer);
#line 80 "DockRenderer.vala"
	_g_object_unref0 (self->priv->current_items);
#line 81 "DockRenderer.vala"
	_g_object_unref0 (self->priv->transient_items);
#line 25 "DockRenderer.vala"
	G_OBJECT_CLASS (plank_dock_renderer_parent_class)->finalize (obj);
#line 6632 "DockRenderer.c"
}

/**
 * Handles all of the drawing for a dock.
 */
static GType
plank_dock_renderer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankDockRendererClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_dock_renderer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDockRenderer), 0, (GInstanceInitFunc) plank_dock_renderer_instance_init, NULL };
	GType plank_dock_renderer_type_id;
	plank_dock_renderer_type_id = g_type_register_static (PLANK_TYPE_RENDERER, "PlankDockRenderer", &g_define_type_info, 0);
	PlankDockRenderer_private_offset = g_type_add_instance_private (plank_dock_renderer_type_id, sizeof (PlankDockRendererPrivate));
	return plank_dock_renderer_type_id;
}

GType
plank_dock_renderer_get_type (void)
{
	static volatile gsize plank_dock_renderer_type_id__once = 0;
	if (g_once_init_enter (&plank_dock_renderer_type_id__once)) {
		GType plank_dock_renderer_type_id;
		plank_dock_renderer_type_id = plank_dock_renderer_get_type_once ();
		g_once_init_leave (&plank_dock_renderer_type_id__once, plank_dock_renderer_type_id);
	}
	return plank_dock_renderer_type_id__once;
}

static void
_vala_plank_dock_renderer_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	PlankDockRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DOCK_RENDERER, PlankDockRenderer);
#line 25 "DockRenderer.vala"
	switch (property_id) {
#line 25 "DockRenderer.vala"
		case PLANK_DOCK_RENDERER_CONTROLLER_PROPERTY:
#line 25 "DockRenderer.vala"
		g_value_set_object (value, plank_dock_renderer_get_controller (self));
#line 25 "DockRenderer.vala"
		break;
#line 25 "DockRenderer.vala"
		case PLANK_DOCK_RENDERER_THEME_PROPERTY:
#line 25 "DockRenderer.vala"
		g_value_set_object (value, plank_dock_renderer_get_theme (self));
#line 25 "DockRenderer.vala"
		break;
#line 25 "DockRenderer.vala"
		case PLANK_DOCK_RENDERER_HIDE_PROGRESS_PROPERTY:
#line 25 "DockRenderer.vala"
		g_value_set_double (value, plank_dock_renderer_get_hide_progress (self));
#line 25 "DockRenderer.vala"
		break;
#line 25 "DockRenderer.vala"
		case PLANK_DOCK_RENDERER_ZOOM_IN_PROGRESS_PROPERTY:
#line 25 "DockRenderer.vala"
		g_value_set_double (value, plank_dock_renderer_get_zoom_in_progress (self));
#line 25 "DockRenderer.vala"
		break;
#line 6694 "DockRenderer.c"
		default:
#line 25 "DockRenderer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "DockRenderer.vala"
		break;
#line 6700 "DockRenderer.c"
	}
}

static void
_vala_plank_dock_renderer_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	PlankDockRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DOCK_RENDERER, PlankDockRenderer);
#line 25 "DockRenderer.vala"
	switch (property_id) {
#line 25 "DockRenderer.vala"
		case PLANK_DOCK_RENDERER_CONTROLLER_PROPERTY:
#line 25 "DockRenderer.vala"
		plank_dock_renderer_set_controller (self, g_value_get_object (value));
#line 25 "DockRenderer.vala"
		break;
#line 25 "DockRenderer.vala"
		case PLANK_DOCK_RENDERER_THEME_PROPERTY:
#line 25 "DockRenderer.vala"
		plank_dock_renderer_set_theme (self, g_value_get_object (value));
#line 25 "DockRenderer.vala"
		break;
#line 25 "DockRenderer.vala"
		case PLANK_DOCK_RENDERER_HIDE_PROGRESS_PROPERTY:
#line 25 "DockRenderer.vala"
		plank_dock_renderer_set_hide_progress (self, g_value_get_double (value));
#line 25 "DockRenderer.vala"
		break;
#line 25 "DockRenderer.vala"
		case PLANK_DOCK_RENDERER_ZOOM_IN_PROGRESS_PROPERTY:
#line 25 "DockRenderer.vala"
		plank_dock_renderer_set_zoom_in_progress (self, g_value_get_double (value));
#line 25 "DockRenderer.vala"
		break;
#line 6738 "DockRenderer.c"
		default:
#line 25 "DockRenderer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "DockRenderer.vala"
		break;
#line 6744 "DockRenderer.c"
	}
}

