/* PositionManager.c generated by valac 0.56.18, the Vala compiler
 * generated from PositionManager.vala, do not modify */

/**/
/*  Copyright (C) 2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <glib.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <cairo-gobject.h>
#include "plank-internal.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PLANK_POSITION_MANAGER_0_PROPERTY,
	PLANK_POSITION_MANAGER_CONTROLLER_PROPERTY,
	PLANK_POSITION_MANAGER_SCREEN_IS_COMPOSITED_PROPERTY,
	PLANK_POSITION_MANAGER_LINE_WIDTH_PROPERTY,
	PLANK_POSITION_MANAGER_ICON_SIZE_PROPERTY,
	PLANK_POSITION_MANAGER_ZOOM_ICON_SIZE_PROPERTY,
	PLANK_POSITION_MANAGER_POSITION_PROPERTY,
	PLANK_POSITION_MANAGER_ALIGNMENT_PROPERTY,
	PLANK_POSITION_MANAGER_ITEMS_ALIGNMENT_PROPERTY,
	PLANK_POSITION_MANAGER_OFFSET_PROPERTY,
	PLANK_POSITION_MANAGER_INDICATOR_SIZE_PROPERTY,
	PLANK_POSITION_MANAGER_ICON_SHADOW_SIZE_PROPERTY,
	PLANK_POSITION_MANAGER_GLOW_SIZE_PROPERTY,
	PLANK_POSITION_MANAGER_HORIZ_PADDING_PROPERTY,
	PLANK_POSITION_MANAGER_TOP_PADDING_PROPERTY,
	PLANK_POSITION_MANAGER_BOTTOM_PADDING_PROPERTY,
	PLANK_POSITION_MANAGER_ITEM_PADDING_PROPERTY,
	PLANK_POSITION_MANAGER_URGENT_BOUNCE_HEIGHT_PROPERTY,
	PLANK_POSITION_MANAGER_LAUNCH_BOUNCE_HEIGHT_PROPERTY,
	PLANK_POSITION_MANAGER_MAX_ITEM_COUNT_PROPERTY,
	PLANK_POSITION_MANAGER_NUM_PROPERTIES
};
static GParamSpec* plank_position_manager_properties[PLANK_POSITION_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _plank_dock_item_draw_value_unref0(var) ((var == NULL) ? NULL : (var = (plank_dock_item_draw_value_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PlankPositionManagerPrivate {
	PlankDockController* _controller;
	gboolean _screen_is_composited;
	GdkRectangle static_dock_region;
	GeeHashMap* draw_values;
	GdkRectangle monitor_geo;
	gint window_scale_factor;
	gint _LineWidth;
	gint _IconSize;
	gint _ZoomIconSize;
	GtkPositionType _Position;
	GtkAlign _Alignment;
	GtkAlign _ItemsAlignment;
	gint _Offset;
	gint _IndicatorSize;
	gint _IconShadowSize;
	gint _GlowSize;
	gint _HorizPadding;
	gint _TopPadding;
	gint _BottomPadding;
	gint _ItemPadding;
	gint _UrgentBounceHeight;
	gint _LaunchBounceHeight;
	gint items_width;
	gint items_offset;
	gint top_offset;
	gint bottom_offset;
	gint extra_hide_offset;
	gint win_x;
	gint win_y;
	gint VisibleDockHeight;
	gint DockHeight;
	gint DockBackgroundHeight;
	gint VisibleDockWidth;
	gint DockWidth;
	gint DockBackgroundWidth;
	gdouble ZoomPercent;
	GdkRectangle background_rect;
	gint _MaxItemCount;
	gint _MaxIconSize;
};

static gint PlankPositionManager_private_offset;
static gpointer plank_position_manager_parent_class = NULL;

static PlankDockController* plank_position_manager_get_controller (PlankPositionManager* self);
static void plank_position_manager_screen_changed (PlankPositionManager* self,
                                            GdkScreen* screen);
static void _plank_position_manager_screen_changed_gdk_screen_monitors_changed (GdkScreen* _sender,
                                                                         gpointer self);
static void _plank_position_manager_screen_changed_gdk_screen_size_changed (GdkScreen* _sender,
                                                                     gpointer self);
static void plank_position_manager_screen_composited_changed (PlankPositionManager* self,
                                                       GdkScreen* screen);
static void _plank_position_manager_screen_composited_changed_gdk_screen_composited_changed (GdkScreen* _sender,
                                                                                      gpointer self);
static void plank_position_manager_prefs_changed (PlankPositionManager* self,
                                           GObject* prefs,
                                           GParamSpec* prop);
static void _plank_position_manager_prefs_changed_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static gint plank_position_manager_find_monitor_number (GdkScreen* screen,
                                                 const gchar* plug_name);
static void plank_position_manager_set_screen_is_composited (PlankPositionManager* self,
                                                      gboolean value);
static void plank_position_manager_prefs_monitor_changed (PlankPositionManager* self);
static void plank_position_manager_prefs_zoom_changed (PlankPositionManager* self);
static void plank_position_manager_update_dimensions (PlankPositionManager* self);
static void plank_position_manager_update_caches (PlankPositionManager* self,
                                           PlankDockTheme* theme);
static void plank_position_manager_update_max_icon_size (PlankPositionManager* self,
                                                  PlankDockTheme* theme);
static void plank_position_manager_set_Position (PlankPositionManager* self,
                                          GtkPositionType value);
static void plank_position_manager_set_Alignment (PlankPositionManager* self,
                                           GtkAlign value);
static void plank_position_manager_set_ItemsAlignment (PlankPositionManager* self,
                                                GtkAlign value);
static void plank_position_manager_set_Offset (PlankPositionManager* self,
                                        gint value);
static gint plank_position_manager_get_MaxIconSize (PlankPositionManager* self);
static void plank_position_manager_set_IconSize (PlankPositionManager* self,
                                          gint value);
static void plank_position_manager_set_ZoomIconSize (PlankPositionManager* self,
                                              gint value);
static void plank_position_manager_set_IconShadowSize (PlankPositionManager* self,
                                                gint value);
static void plank_position_manager_set_IndicatorSize (PlankPositionManager* self,
                                               gint value);
static void plank_position_manager_set_GlowSize (PlankPositionManager* self,
                                          gint value);
static void plank_position_manager_set_HorizPadding (PlankPositionManager* self,
                                              gint value);
static void plank_position_manager_set_TopPadding (PlankPositionManager* self,
                                            gint value);
static void plank_position_manager_set_BottomPadding (PlankPositionManager* self,
                                               gint value);
static void plank_position_manager_set_ItemPadding (PlankPositionManager* self,
                                             gint value);
static void plank_position_manager_set_UrgentBounceHeight (PlankPositionManager* self,
                                                    gint value);
static void plank_position_manager_set_LaunchBounceHeight (PlankPositionManager* self,
                                                    gint value);
static void plank_position_manager_set_LineWidth (PlankPositionManager* self,
                                           gint value);
static void plank_position_manager_set_MaxIconSize (PlankPositionManager* self,
                                             gint value);
static void plank_position_manager_set_MaxItemCount (PlankPositionManager* self,
                                              gint value);
static void plank_position_manager_update_background_region (PlankPositionManager* self,
                                                      PlankDockItemDrawValue* val_first,
                                                      PlankDockItemDrawValue* val_last);
static gboolean __lambda29_ (PlankPositionManager* self,
                      PlankDockElement* i,
                      PlankDockItemDrawValue* val);
static void plank_position_manager_get_item_draw_region (PlankPositionManager* self,
                                                  PlankDockItemDrawValue* val,
                                                  GdkRectangle* result);
static void plank_position_manager_get_item_hover_region (PlankPositionManager* self,
                                                   PlankDockItemDrawValue* val,
                                                   GdkRectangle* result);
static void plank_position_manager_get_item_background_region (PlankPositionManager* self,
                                                        PlankDockItemDrawValue* val,
                                                        GdkRectangle* result);
static gboolean ___lambda29__gee_forall_map_func (gconstpointer k,
                                           gconstpointer v,
                                           gpointer self);
static GObject * plank_position_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void plank_position_manager_finalize (GObject * obj);
static GType plank_position_manager_get_type_once (void);
static void _vala_plank_position_manager_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_plank_position_manager_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
plank_position_manager_get_instance_private (PlankPositionManager* self)
{
	return G_STRUCT_MEMBER_P (self, PlankPositionManager_private_offset);
}

static void
_plank_position_manager_screen_changed_gdk_screen_monitors_changed (GdkScreen* _sender,
                                                                    gpointer self)
{
#line 77 "PositionManager.vala"
	plank_position_manager_screen_changed ((PlankPositionManager*) self, _sender);
#line 232 "PositionManager.c"
}

static void
_plank_position_manager_screen_changed_gdk_screen_size_changed (GdkScreen* _sender,
                                                                gpointer self)
{
#line 78 "PositionManager.vala"
	plank_position_manager_screen_changed ((PlankPositionManager*) self, _sender);
#line 241 "PositionManager.c"
}

static void
_plank_position_manager_screen_composited_changed_gdk_screen_composited_changed (GdkScreen* _sender,
                                                                                 gpointer self)
{
#line 79 "PositionManager.vala"
	plank_position_manager_screen_composited_changed ((PlankPositionManager*) self, _sender);
#line 250 "PositionManager.c"
}

static void
_plank_position_manager_prefs_changed_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
#line 80 "PositionManager.vala"
	plank_position_manager_prefs_changed ((PlankPositionManager*) self, _sender, pspec);
#line 260 "PositionManager.c"
}

/**
 * Creates a new position manager.
 *
 * @param controller the dock controller to manage positions for
 */
PlankPositionManager*
plank_position_manager_construct (GType object_type,
                                  PlankDockController* controller)
{
	PlankPositionManager * self = NULL;
#line 43 "PositionManager.vala"
	g_return_val_if_fail (controller != NULL, NULL);
#line 45 "PositionManager.vala"
	self = (PlankPositionManager*) g_object_new (object_type, "controller", controller, NULL);
#line 43 "PositionManager.vala"
	return self;
#line 279 "PositionManager.c"
}

PlankPositionManager*
plank_position_manager_new (PlankDockController* controller)
{
#line 43 "PositionManager.vala"
	return plank_position_manager_construct (PLANK_TYPE_POSITION_MANAGER, controller);
#line 287 "PositionManager.c"
}

/**
 * Initializes the position manager.
 */
void
plank_position_manager_initialize (PlankPositionManager* self)
{
	PlankDockController* _tmp0_;
	PlankDockWindow* _tmp1_;
	PlankDockWindow* _tmp2_;
	GdkScreen* screen = NULL;
	PlankDockController* _tmp3_;
	PlankDockWindow* _tmp4_;
	PlankDockWindow* _tmp5_;
	GdkScreen* _tmp6_;
	PlankDockController* _tmp7_;
	PlankDockPreferences* _tmp8_;
	PlankDockPreferences* _tmp9_;
	PlankDockController* _tmp10_;
	PlankDockPreferences* _tmp11_;
	PlankDockPreferences* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	GdkRectangle _tmp15_ = {0};
#line 57 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 57 "PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 57 "PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_window (_tmp0_);
#line 57 "PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 57 "PositionManager.vala"
	_vala_return_if_fail (_tmp2_ != NULL, "controller.window != null");
#line 60 "PositionManager.vala"
	_tmp3_ = self->priv->_controller;
#line 60 "PositionManager.vala"
	_tmp4_ = plank_dock_controller_get_window (_tmp3_);
#line 60 "PositionManager.vala"
	_tmp5_ = _tmp4_;
#line 60 "PositionManager.vala"
	_tmp6_ = gtk_window_get_screen ((GtkWindow*) _tmp5_);
#line 60 "PositionManager.vala"
	screen = _tmp6_;
#line 62 "PositionManager.vala"
	_tmp7_ = self->priv->_controller;
#line 62 "PositionManager.vala"
	_tmp8_ = plank_dock_controller_get_prefs (_tmp7_);
#line 62 "PositionManager.vala"
	_tmp9_ = _tmp8_;
#line 62 "PositionManager.vala"
	g_signal_connect_object ((GObject*) _tmp9_, "notify", (GCallback) _plank_position_manager_prefs_changed_g_object_notify, self, 0);
#line 63 "PositionManager.vala"
	g_signal_connect_object (screen, "monitors-changed", (GCallback) _plank_position_manager_screen_changed_gdk_screen_monitors_changed, self, 0);
#line 64 "PositionManager.vala"
	g_signal_connect_object (screen, "size-changed", (GCallback) _plank_position_manager_screen_changed_gdk_screen_size_changed, self, 0);
#line 65 "PositionManager.vala"
	g_signal_connect_object (screen, "composited-changed", (GCallback) _plank_position_manager_screen_composited_changed_gdk_screen_composited_changed, self, 0);
#line 68 "PositionManager.vala"
	_tmp10_ = self->priv->_controller;
#line 68 "PositionManager.vala"
	_tmp11_ = plank_dock_controller_get_prefs (_tmp10_);
#line 68 "PositionManager.vala"
	_tmp12_ = _tmp11_;
#line 68 "PositionManager.vala"
	_tmp13_ = plank_dock_preferences_get_Monitor (_tmp12_);
#line 68 "PositionManager.vala"
	_tmp14_ = _tmp13_;
#line 68 "PositionManager.vala"
	gdk_screen_get_monitor_geometry (screen, plank_position_manager_find_monitor_number (screen, _tmp14_), &_tmp15_);
#line 68 "PositionManager.vala"
	self->priv->monitor_geo = _tmp15_;
#line 70 "PositionManager.vala"
	plank_position_manager_set_screen_is_composited (self, gdk_screen_is_composited (screen));
#line 363 "PositionManager.c"
}

static void
plank_position_manager_prefs_changed (PlankPositionManager* self,
                                      GObject* prefs,
                                      GParamSpec* prop)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 87 "PositionManager.vala"
	static GQuark _tmp2_label0 = 0;
#line 87 "PositionManager.vala"
	static GQuark _tmp2_label1 = 0;
#line 87 "PositionManager.vala"
	static GQuark _tmp2_label2 = 0;
#line 85 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 85 "PositionManager.vala"
	g_return_if_fail (prefs != NULL);
#line 85 "PositionManager.vala"
	g_return_if_fail (prop != NULL);
#line 87 "PositionManager.vala"
	_tmp0_ = prop->name;
#line 87 "PositionManager.vala"
	_tmp1_ = _tmp0_;
#line 87 "PositionManager.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 87 "PositionManager.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("Monitor")))) {
#line 87 "PositionManager.vala"
		switch (0) {
#line 396 "PositionManager.c"
			default:
			{
#line 89 "PositionManager.vala"
				plank_position_manager_prefs_monitor_changed (self);
#line 90 "PositionManager.vala"
				break;
#line 403 "PositionManager.c"
			}
		}
	} else if ((_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("ZoomPercent")))) || (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("ZoomEnabled"))))) {
#line 87 "PositionManager.vala"
		switch (0) {
#line 409 "PositionManager.c"
			default:
			{
#line 93 "PositionManager.vala"
				plank_position_manager_prefs_zoom_changed (self);
#line 94 "PositionManager.vala"
				break;
#line 416 "PositionManager.c"
			}
		}
	} else {
#line 87 "PositionManager.vala"
		switch (0) {
#line 422 "PositionManager.c"
			default:
			{
#line 97 "PositionManager.vala"
				break;
#line 427 "PositionManager.c"
			}
		}
	}
}

gchar**
plank_position_manager_get_monitor_plug_names (GdkScreen* screen,
                                               gint* result_length1)
{
	gint n_monitors = 0;
	gchar** _result_ = NULL;
	gchar** _tmp0_;
	gint _result__length1;
	gint __result__size_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar** result;
#line 101 "PositionManager.vala"
	g_return_val_if_fail (screen != NULL, NULL);
#line 103 "PositionManager.vala"
	n_monitors = gdk_screen_get_n_monitors (screen);
#line 104 "PositionManager.vala"
	_tmp0_ = g_new0 (gchar*, n_monitors + 1);
#line 104 "PositionManager.vala"
	_result_ = _tmp0_;
#line 104 "PositionManager.vala"
	_result__length1 = n_monitors;
#line 104 "PositionManager.vala"
	__result__size_ = _result__length1;
#line 457 "PositionManager.c"
	{
		gint i = 0;
#line 106 "PositionManager.vala"
		i = 0;
#line 462 "PositionManager.c"
		{
			gboolean _tmp1_ = FALSE;
#line 106 "PositionManager.vala"
			_tmp1_ = TRUE;
#line 106 "PositionManager.vala"
			while (TRUE) {
#line 469 "PositionManager.c"
				gchar* _tmp3_ = NULL;
				gchar* _tmp4_;
				gchar** _tmp6_;
				gint _tmp6__length1;
				gchar* _tmp7_;
#line 106 "PositionManager.vala"
				if (!_tmp1_) {
#line 477 "PositionManager.c"
					gint _tmp2_;
#line 106 "PositionManager.vala"
					_tmp2_ = i;
#line 106 "PositionManager.vala"
					i = _tmp2_ + 1;
#line 483 "PositionManager.c"
				}
#line 106 "PositionManager.vala"
				_tmp1_ = FALSE;
#line 106 "PositionManager.vala"
				if (!(i < n_monitors)) {
#line 106 "PositionManager.vala"
					break;
#line 491 "PositionManager.c"
				}
#line 107 "PositionManager.vala"
				_tmp4_ = gdk_screen_get_monitor_plug_name (screen, i);
#line 107 "PositionManager.vala"
				_tmp3_ = _tmp4_;
#line 107 "PositionManager.vala"
				if (_tmp3_ == NULL) {
#line 499 "PositionManager.c"
					gchar* _tmp5_;
#line 107 "PositionManager.vala"
					_tmp5_ = g_strdup_printf ("PLUG_MONITOR_%i", i);
#line 107 "PositionManager.vala"
					_g_free0 (_tmp3_);
#line 107 "PositionManager.vala"
					_tmp3_ = _tmp5_;
#line 507 "PositionManager.c"
				}
#line 107 "PositionManager.vala"
				_tmp6_ = _result_;
#line 107 "PositionManager.vala"
				_tmp6__length1 = _result__length1;
#line 107 "PositionManager.vala"
				_tmp7_ = _tmp3_;
#line 107 "PositionManager.vala"
				_tmp3_ = NULL;
#line 107 "PositionManager.vala"
				_g_free0 (_tmp6_[i]);
#line 107 "PositionManager.vala"
				_tmp6_[i] = _tmp7_;
#line 106 "PositionManager.vala"
				_g_free0 (_tmp3_);
#line 523 "PositionManager.c"
			}
		}
	}
#line 109 "PositionManager.vala"
	_tmp8_ = _result_;
#line 109 "PositionManager.vala"
	_tmp8__length1 = _result__length1;
#line 109 "PositionManager.vala"
	if (result_length1) {
#line 109 "PositionManager.vala"
		*result_length1 = _tmp8__length1;
#line 535 "PositionManager.c"
	}
#line 109 "PositionManager.vala"
	result = _tmp8_;
#line 109 "PositionManager.vala"
	return result;
#line 541 "PositionManager.c"
}

static gint
plank_position_manager_find_monitor_number (GdkScreen* screen,
                                            const gchar* plug_name)
{
	gint n_monitors = 0;
	gint result;
#line 112 "PositionManager.vala"
	g_return_val_if_fail (screen != NULL, 0);
#line 112 "PositionManager.vala"
	g_return_val_if_fail (plug_name != NULL, 0);
#line 114 "PositionManager.vala"
	if (g_strcmp0 (plug_name, "") == 0) {
#line 115 "PositionManager.vala"
		result = gdk_screen_get_primary_monitor (screen);
#line 115 "PositionManager.vala"
		return result;
#line 560 "PositionManager.c"
	}
#line 117 "PositionManager.vala"
	n_monitors = gdk_screen_get_n_monitors (screen);
#line 564 "PositionManager.c"
	{
		gint i = 0;
#line 119 "PositionManager.vala"
		i = 0;
#line 569 "PositionManager.c"
		{
			gboolean _tmp0_ = FALSE;
#line 119 "PositionManager.vala"
			_tmp0_ = TRUE;
#line 119 "PositionManager.vala"
			while (TRUE) {
#line 576 "PositionManager.c"
				gchar* _tmp2_ = NULL;
				gchar* _tmp3_;
				gchar* name = NULL;
				gchar* _tmp5_;
				const gchar* _tmp6_;
#line 119 "PositionManager.vala"
				if (!_tmp0_) {
#line 584 "PositionManager.c"
					gint _tmp1_;
#line 119 "PositionManager.vala"
					_tmp1_ = i;
#line 119 "PositionManager.vala"
					i = _tmp1_ + 1;
#line 590 "PositionManager.c"
				}
#line 119 "PositionManager.vala"
				_tmp0_ = FALSE;
#line 119 "PositionManager.vala"
				if (!(i < n_monitors)) {
#line 119 "PositionManager.vala"
					break;
#line 598 "PositionManager.c"
				}
#line 120 "PositionManager.vala"
				_tmp3_ = gdk_screen_get_monitor_plug_name (screen, i);
#line 120 "PositionManager.vala"
				_tmp2_ = _tmp3_;
#line 120 "PositionManager.vala"
				if (_tmp2_ == NULL) {
#line 606 "PositionManager.c"
					gchar* _tmp4_;
#line 120 "PositionManager.vala"
					_tmp4_ = g_strdup_printf ("PLUG_MONITOR_%i", i);
#line 120 "PositionManager.vala"
					_g_free0 (_tmp2_);
#line 120 "PositionManager.vala"
					_tmp2_ = _tmp4_;
#line 614 "PositionManager.c"
				}
#line 120 "PositionManager.vala"
				_tmp5_ = _tmp2_;
#line 120 "PositionManager.vala"
				_tmp2_ = NULL;
#line 120 "PositionManager.vala"
				name = _tmp5_;
#line 121 "PositionManager.vala"
				_tmp6_ = name;
#line 121 "PositionManager.vala"
				if (g_strcmp0 (plug_name, _tmp6_) == 0) {
#line 122 "PositionManager.vala"
					result = i;
#line 122 "PositionManager.vala"
					_g_free0 (name);
#line 122 "PositionManager.vala"
					_g_free0 (_tmp2_);
#line 122 "PositionManager.vala"
					return result;
#line 634 "PositionManager.c"
				}
#line 119 "PositionManager.vala"
				_g_free0 (name);
#line 119 "PositionManager.vala"
				_g_free0 (_tmp2_);
#line 640 "PositionManager.c"
			}
		}
	}
#line 125 "PositionManager.vala"
	result = gdk_screen_get_primary_monitor (screen);
#line 125 "PositionManager.vala"
	return result;
#line 648 "PositionManager.c"
}

static void
plank_position_manager_prefs_monitor_changed (PlankPositionManager* self)
{
	PlankDockController* _tmp0_;
	PlankDockWindow* _tmp1_;
	PlankDockWindow* _tmp2_;
	GdkScreen* _tmp3_;
#line 128 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 130 "PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 130 "PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_window (_tmp0_);
#line 130 "PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 130 "PositionManager.vala"
	_tmp3_ = gtk_window_get_screen ((GtkWindow*) _tmp2_);
#line 130 "PositionManager.vala"
	plank_position_manager_screen_changed (self, _tmp3_);
#line 670 "PositionManager.c"
}

static void
plank_position_manager_screen_changed (PlankPositionManager* self,
                                       GdkScreen* screen)
{
	GdkRectangle old_monitor_geo = {0};
	GdkRectangle _tmp0_;
	PlankDockController* _tmp1_;
	PlankDockPreferences* _tmp2_;
	PlankDockPreferences* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GdkRectangle _tmp6_ = {0};
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	GdkRectangle _tmp10_;
	GdkRectangle _tmp11_;
	GdkRectangle _tmp18_;
	GdkRectangle _tmp19_;
	GdkRectangle _tmp20_;
	GdkRectangle _tmp21_;
#line 133 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 133 "PositionManager.vala"
	g_return_if_fail (screen != NULL);
#line 135 "PositionManager.vala"
	_tmp0_ = self->priv->monitor_geo;
#line 135 "PositionManager.vala"
	old_monitor_geo = _tmp0_;
#line 137 "PositionManager.vala"
	_tmp1_ = self->priv->_controller;
#line 137 "PositionManager.vala"
	_tmp2_ = plank_dock_controller_get_prefs (_tmp1_);
#line 137 "PositionManager.vala"
	_tmp3_ = _tmp2_;
#line 137 "PositionManager.vala"
	_tmp4_ = plank_dock_preferences_get_Monitor (_tmp3_);
#line 137 "PositionManager.vala"
	_tmp5_ = _tmp4_;
#line 137 "PositionManager.vala"
	gdk_screen_get_monitor_geometry (screen, plank_position_manager_find_monitor_number (screen, _tmp5_), &_tmp6_);
#line 137 "PositionManager.vala"
	self->priv->monitor_geo = _tmp6_;
#line 140 "PositionManager.vala"
	_tmp10_ = old_monitor_geo;
#line 140 "PositionManager.vala"
	_tmp11_ = self->priv->monitor_geo;
#line 140 "PositionManager.vala"
	if (_tmp10_.x == _tmp11_.x) {
#line 722 "PositionManager.c"
		GdkRectangle _tmp12_;
		GdkRectangle _tmp13_;
#line 141 "PositionManager.vala"
		_tmp12_ = old_monitor_geo;
#line 141 "PositionManager.vala"
		_tmp13_ = self->priv->monitor_geo;
#line 141 "PositionManager.vala"
		_tmp9_ = _tmp12_.y == _tmp13_.y;
#line 731 "PositionManager.c"
	} else {
#line 140 "PositionManager.vala"
		_tmp9_ = FALSE;
#line 735 "PositionManager.c"
	}
#line 140 "PositionManager.vala"
	if (_tmp9_) {
#line 739 "PositionManager.c"
		GdkRectangle _tmp14_;
		GdkRectangle _tmp15_;
#line 142 "PositionManager.vala"
		_tmp14_ = old_monitor_geo;
#line 142 "PositionManager.vala"
		_tmp15_ = self->priv->monitor_geo;
#line 142 "PositionManager.vala"
		_tmp8_ = _tmp14_.width == _tmp15_.width;
#line 748 "PositionManager.c"
	} else {
#line 140 "PositionManager.vala"
		_tmp8_ = FALSE;
#line 752 "PositionManager.c"
	}
#line 140 "PositionManager.vala"
	if (_tmp8_) {
#line 756 "PositionManager.c"
		GdkRectangle _tmp16_;
		GdkRectangle _tmp17_;
#line 143 "PositionManager.vala"
		_tmp16_ = old_monitor_geo;
#line 143 "PositionManager.vala"
		_tmp17_ = self->priv->monitor_geo;
#line 143 "PositionManager.vala"
		_tmp7_ = _tmp16_.height == _tmp17_.height;
#line 765 "PositionManager.c"
	} else {
#line 140 "PositionManager.vala"
		_tmp7_ = FALSE;
#line 769 "PositionManager.c"
	}
#line 140 "PositionManager.vala"
	if (_tmp7_) {
#line 144 "PositionManager.vala"
		return;
#line 775 "PositionManager.c"
	}
#line 146 "PositionManager.vala"
	_tmp18_ = self->priv->monitor_geo;
#line 146 "PositionManager.vala"
	_tmp19_ = self->priv->monitor_geo;
#line 146 "PositionManager.vala"
	_tmp20_ = self->priv->monitor_geo;
#line 146 "PositionManager.vala"
	_tmp21_ = self->priv->monitor_geo;
#line 146 "PositionManager.vala"
	plank_logger_verbose ("PositionManager.monitor_geo_changed (%i,%i-%ix%i)", _tmp18_.x, _tmp19_.y, _tmp20_.width, _tmp21_.height, NULL);
#line 149 "PositionManager.vala"
	g_object_freeze_notify ((GObject*) self);
#line 151 "PositionManager.vala"
	plank_position_manager_update_dimensions (self);
#line 152 "PositionManager.vala"
	plank_position_manager_update_regions (self);
#line 154 "PositionManager.vala"
	g_object_thaw_notify ((GObject*) self);
#line 795 "PositionManager.c"
}

static void
plank_position_manager_screen_composited_changed (PlankPositionManager* self,
                                                  GdkScreen* screen)
{
	PlankDockController* _tmp0_;
	PlankDockRenderer* _tmp1_;
	PlankDockRenderer* _tmp2_;
	PlankDockTheme* _tmp3_;
	PlankDockTheme* _tmp4_;
#line 157 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 157 "PositionManager.vala"
	g_return_if_fail (screen != NULL);
#line 159 "PositionManager.vala"
	g_object_freeze_notify ((GObject*) self);
#line 161 "PositionManager.vala"
	plank_position_manager_set_screen_is_composited (self, gdk_screen_is_composited (screen));
#line 163 "PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 163 "PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_renderer (_tmp0_);
#line 163 "PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 163 "PositionManager.vala"
	_tmp3_ = plank_dock_renderer_get_theme (_tmp2_);
#line 163 "PositionManager.vala"
	_tmp4_ = _tmp3_;
#line 163 "PositionManager.vala"
	plank_position_manager_update (self, _tmp4_);
#line 165 "PositionManager.vala"
	g_object_thaw_notify ((GObject*) self);
#line 829 "PositionManager.c"
}

/**
 * Updates all internal caches.
 *
 * @param theme the current dock theme
 */
void
plank_position_manager_update (PlankPositionManager* self,
                               PlankDockTheme* theme)
{
	PlankDockController* _tmp0_;
	PlankDockWindow* _tmp1_;
	PlankDockWindow* _tmp2_;
	GdkScreen* _tmp3_;
#line 306 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 306 "PositionManager.vala"
	g_return_if_fail (theme != NULL);
#line 308 "PositionManager.vala"
	plank_logger_verbose ("PositionManager.update ()", NULL);
#line 310 "PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 310 "PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_window (_tmp0_);
#line 310 "PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 310 "PositionManager.vala"
	_tmp3_ = gtk_window_get_screen ((GtkWindow*) _tmp2_);
#line 310 "PositionManager.vala"
	plank_position_manager_set_screen_is_composited (self, gdk_screen_is_composited (_tmp3_));
#line 312 "PositionManager.vala"
	g_object_freeze_notify ((GObject*) self);
#line 314 "PositionManager.vala"
	plank_position_manager_update_caches (self, theme);
#line 315 "PositionManager.vala"
	plank_position_manager_update_max_icon_size (self, theme);
#line 316 "PositionManager.vala"
	plank_position_manager_update_dimensions (self);
#line 317 "PositionManager.vala"
	plank_position_manager_update_regions (self);
#line 319 "PositionManager.vala"
	g_object_thaw_notify ((GObject*) self);
#line 873 "PositionManager.c"
}

static void
plank_position_manager_update_caches (PlankPositionManager* self,
                                      PlankDockTheme* theme)
{
	PlankDockPreferences* prefs = NULL;
	PlankDockController* _tmp0_;
	PlankDockPreferences* _tmp1_;
	PlankDockPreferences* _tmp2_;
	PlankDockPreferences* _tmp3_;
	GtkPositionType _tmp4_;
	GtkPositionType _tmp5_;
	PlankDockPreferences* _tmp6_;
	GtkAlign _tmp7_;
	GtkAlign _tmp8_;
	PlankDockPreferences* _tmp9_;
	GtkAlign _tmp10_;
	GtkAlign _tmp11_;
	PlankDockPreferences* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp21_;
	PlankDockPreferences* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	gdouble _tmp25_ = 0.0;
	gboolean _tmp26_;
	gint _tmp30_ = 0;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_;
	gdouble scaled_icon_size = 0.0;
	gint _tmp38_;
	gdouble _tmp39_;
	gdouble _tmp40_;
	gdouble _tmp41_;
	gdouble _tmp42_;
	gint _tmp43_;
	gint _tmp44_;
	gdouble _tmp45_;
	gdouble _tmp46_;
	gdouble _tmp47_;
	gdouble _tmp48_;
	gdouble _tmp49_;
	gdouble _tmp50_;
	gdouble _tmp51_;
	gdouble _tmp52_;
	gdouble _tmp53_;
	gdouble _tmp54_;
	gint _tmp55_;
	gdouble _tmp56_;
	gdouble _tmp57_;
	gint _tmp58_;
	gint _tmp59_;
	gint _tmp60_;
	gboolean _tmp61_;
	gint _tmp64_ = 0;
	gint _tmp65_;
	gint _tmp67_;
	gint _tmp68_;
	gint _tmp69_;
#line 322 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 322 "PositionManager.vala"
	g_return_if_fail (theme != NULL);
#line 324 "PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 324 "PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_prefs (_tmp0_);
#line 324 "PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 324 "PositionManager.vala"
	prefs = _tmp2_;
#line 326 "PositionManager.vala"
	_tmp3_ = prefs;
#line 326 "PositionManager.vala"
	_tmp4_ = plank_dock_preferences_get_Position (_tmp3_);
#line 326 "PositionManager.vala"
	_tmp5_ = _tmp4_;
#line 326 "PositionManager.vala"
	plank_position_manager_set_Position (self, _tmp5_);
#line 327 "PositionManager.vala"
	_tmp6_ = prefs;
#line 327 "PositionManager.vala"
	_tmp7_ = plank_dock_preferences_get_Alignment (_tmp6_);
#line 327 "PositionManager.vala"
	_tmp8_ = _tmp7_;
#line 327 "PositionManager.vala"
	plank_position_manager_set_Alignment (self, _tmp8_);
#line 328 "PositionManager.vala"
	_tmp9_ = prefs;
#line 328 "PositionManager.vala"
	_tmp10_ = plank_dock_preferences_get_ItemsAlignment (_tmp9_);
#line 328 "PositionManager.vala"
	_tmp11_ = _tmp10_;
#line 328 "PositionManager.vala"
	plank_position_manager_set_ItemsAlignment (self, _tmp11_);
#line 329 "PositionManager.vala"
	_tmp12_ = prefs;
#line 329 "PositionManager.vala"
	_tmp13_ = plank_dock_preferences_get_Offset (_tmp12_);
#line 329 "PositionManager.vala"
	_tmp14_ = _tmp13_;
#line 329 "PositionManager.vala"
	plank_position_manager_set_Offset (self, _tmp14_);
#line 332 "PositionManager.vala"
	if (gtk_widget_get_default_direction () == GTK_TEXT_DIR_RTL) {
#line 333 "PositionManager.vala"
		if (plank_position_manager_is_horizontal_dock (self)) {
#line 983 "PositionManager.c"
			GtkAlign _tmp15_;
			GtkAlign _tmp17_;
			gint _tmp19_;
#line 334 "PositionManager.vala"
			_tmp15_ = self->priv->_Alignment;
#line 334 "PositionManager.vala"
			if (_tmp15_ == GTK_ALIGN_START) {
#line 335 "PositionManager.vala"
				plank_position_manager_set_Alignment (self, GTK_ALIGN_END);
#line 993 "PositionManager.c"
			} else {
				GtkAlign _tmp16_;
#line 336 "PositionManager.vala"
				_tmp16_ = self->priv->_Alignment;
#line 336 "PositionManager.vala"
				if (_tmp16_ == GTK_ALIGN_END) {
#line 337 "PositionManager.vala"
					plank_position_manager_set_Alignment (self, GTK_ALIGN_START);
#line 1002 "PositionManager.c"
				}
			}
#line 339 "PositionManager.vala"
			_tmp17_ = self->priv->_ItemsAlignment;
#line 339 "PositionManager.vala"
			if (_tmp17_ == GTK_ALIGN_START) {
#line 340 "PositionManager.vala"
				plank_position_manager_set_ItemsAlignment (self, GTK_ALIGN_END);
#line 1011 "PositionManager.c"
			} else {
				GtkAlign _tmp18_;
#line 341 "PositionManager.vala"
				_tmp18_ = self->priv->_ItemsAlignment;
#line 341 "PositionManager.vala"
				if (_tmp18_ == GTK_ALIGN_END) {
#line 342 "PositionManager.vala"
					plank_position_manager_set_ItemsAlignment (self, GTK_ALIGN_START);
#line 1020 "PositionManager.c"
				}
			}
#line 344 "PositionManager.vala"
			_tmp19_ = self->priv->_Offset;
#line 344 "PositionManager.vala"
			plank_position_manager_set_Offset (self, -_tmp19_);
#line 1027 "PositionManager.c"
		} else {
			GtkPositionType _tmp20_;
#line 346 "PositionManager.vala"
			_tmp20_ = self->priv->_Position;
#line 346 "PositionManager.vala"
			if (_tmp20_ == GTK_POS_RIGHT) {
#line 347 "PositionManager.vala"
				plank_position_manager_set_Position (self, GTK_POS_LEFT);
#line 1036 "PositionManager.c"
			} else {
#line 349 "PositionManager.vala"
				plank_position_manager_set_Position (self, GTK_POS_RIGHT);
#line 1040 "PositionManager.c"
			}
		}
	}
#line 353 "PositionManager.vala"
	_tmp21_ = self->priv->_MaxIconSize;
#line 353 "PositionManager.vala"
	_tmp22_ = prefs;
#line 353 "PositionManager.vala"
	_tmp23_ = plank_dock_preferences_get_IconSize (_tmp22_);
#line 353 "PositionManager.vala"
	_tmp24_ = _tmp23_;
#line 353 "PositionManager.vala"
	plank_position_manager_set_IconSize (self, MIN (_tmp21_, _tmp24_));
#line 354 "PositionManager.vala"
	_tmp26_ = self->priv->_screen_is_composited;
#line 354 "PositionManager.vala"
	if (_tmp26_) {
#line 1058 "PositionManager.c"
		PlankDockPreferences* _tmp27_;
		guint _tmp28_;
		guint _tmp29_;
#line 354 "PositionManager.vala"
		_tmp27_ = prefs;
#line 354 "PositionManager.vala"
		_tmp28_ = plank_dock_preferences_get_ZoomPercent (_tmp27_);
#line 354 "PositionManager.vala"
		_tmp29_ = _tmp28_;
#line 354 "PositionManager.vala"
		_tmp25_ = _tmp29_ / 100.0;
#line 1070 "PositionManager.c"
	} else {
#line 354 "PositionManager.vala"
		_tmp25_ = 1.0;
#line 1074 "PositionManager.c"
	}
#line 354 "PositionManager.vala"
	self->priv->ZoomPercent = _tmp25_;
#line 355 "PositionManager.vala"
	_tmp32_ = self->priv->_screen_is_composited;
#line 355 "PositionManager.vala"
	if (_tmp32_) {
#line 1082 "PositionManager.c"
		PlankDockPreferences* _tmp33_;
		gboolean _tmp34_;
		gboolean _tmp35_;
#line 355 "PositionManager.vala"
		_tmp33_ = prefs;
#line 355 "PositionManager.vala"
		_tmp34_ = plank_dock_preferences_get_ZoomEnabled (_tmp33_);
#line 355 "PositionManager.vala"
		_tmp35_ = _tmp34_;
#line 355 "PositionManager.vala"
		_tmp31_ = _tmp35_;
#line 1094 "PositionManager.c"
	} else {
#line 355 "PositionManager.vala"
		_tmp31_ = FALSE;
#line 1098 "PositionManager.c"
	}
#line 355 "PositionManager.vala"
	if (_tmp31_) {
#line 1102 "PositionManager.c"
		gint _tmp36_;
#line 355 "PositionManager.vala"
		_tmp36_ = self->priv->_IconSize;
#line 355 "PositionManager.vala"
		_tmp30_ = (gint) round (_tmp36_ * self->priv->ZoomPercent);
#line 1108 "PositionManager.c"
	} else {
		gint _tmp37_;
#line 355 "PositionManager.vala"
		_tmp37_ = self->priv->_IconSize;
#line 355 "PositionManager.vala"
		_tmp30_ = _tmp37_;
#line 1115 "PositionManager.c"
	}
#line 355 "PositionManager.vala"
	plank_position_manager_set_ZoomIconSize (self, _tmp30_);
#line 357 "PositionManager.vala"
	_tmp38_ = self->priv->_IconSize;
#line 357 "PositionManager.vala"
	scaled_icon_size = _tmp38_ / 10.0;
#line 359 "PositionManager.vala"
	_tmp39_ = plank_dock_theme_get_IconShadowSize (theme);
#line 359 "PositionManager.vala"
	_tmp40_ = _tmp39_;
#line 359 "PositionManager.vala"
	plank_position_manager_set_IconShadowSize (self, (gint) ceil (_tmp40_ * scaled_icon_size));
#line 360 "PositionManager.vala"
	_tmp41_ = plank_dock_theme_get_IndicatorSize (theme);
#line 360 "PositionManager.vala"
	_tmp42_ = _tmp41_;
#line 360 "PositionManager.vala"
	plank_position_manager_set_IndicatorSize (self, (gint) (_tmp42_ * scaled_icon_size));
#line 361 "PositionManager.vala"
	_tmp43_ = plank_dock_theme_get_GlowSize (theme);
#line 361 "PositionManager.vala"
	_tmp44_ = _tmp43_;
#line 361 "PositionManager.vala"
	plank_position_manager_set_GlowSize (self, (gint) (_tmp44_ * scaled_icon_size));
#line 362 "PositionManager.vala"
	_tmp45_ = plank_dock_theme_get_HorizPadding (theme);
#line 362 "PositionManager.vala"
	_tmp46_ = _tmp45_;
#line 362 "PositionManager.vala"
	plank_position_manager_set_HorizPadding (self, (gint) (_tmp46_ * scaled_icon_size));
#line 363 "PositionManager.vala"
	_tmp47_ = plank_dock_theme_get_TopPadding (theme);
#line 363 "PositionManager.vala"
	_tmp48_ = _tmp47_;
#line 363 "PositionManager.vala"
	plank_position_manager_set_TopPadding (self, (gint) (_tmp48_ * scaled_icon_size));
#line 364 "PositionManager.vala"
	_tmp49_ = plank_dock_theme_get_BottomPadding (theme);
#line 364 "PositionManager.vala"
	_tmp50_ = _tmp49_;
#line 364 "PositionManager.vala"
	plank_position_manager_set_BottomPadding (self, (gint) (_tmp50_ * scaled_icon_size));
#line 365 "PositionManager.vala"
	_tmp51_ = plank_dock_theme_get_ItemPadding (theme);
#line 365 "PositionManager.vala"
	_tmp52_ = _tmp51_;
#line 365 "PositionManager.vala"
	plank_position_manager_set_ItemPadding (self, (gint) (_tmp52_ * scaled_icon_size));
#line 366 "PositionManager.vala"
	_tmp53_ = plank_dock_theme_get_UrgentBounceHeight (theme);
#line 366 "PositionManager.vala"
	_tmp54_ = _tmp53_;
#line 366 "PositionManager.vala"
	_tmp55_ = self->priv->_IconSize;
#line 366 "PositionManager.vala"
	plank_position_manager_set_UrgentBounceHeight (self, (gint) (_tmp54_ * _tmp55_));
#line 367 "PositionManager.vala"
	_tmp56_ = plank_dock_theme_get_LaunchBounceHeight (theme);
#line 367 "PositionManager.vala"
	_tmp57_ = _tmp56_;
#line 367 "PositionManager.vala"
	_tmp58_ = self->priv->_IconSize;
#line 367 "PositionManager.vala"
	plank_position_manager_set_LaunchBounceHeight (self, (gint) (_tmp57_ * _tmp58_));
#line 368 "PositionManager.vala"
	_tmp59_ = plank_theme_get_LineWidth ((PlankTheme*) theme);
#line 368 "PositionManager.vala"
	_tmp60_ = _tmp59_;
#line 368 "PositionManager.vala"
	plank_position_manager_set_LineWidth (self, _tmp60_);
#line 370 "PositionManager.vala"
	_tmp61_ = self->priv->_screen_is_composited;
#line 370 "PositionManager.vala"
	if (!_tmp61_) {
#line 1191 "PositionManager.c"
		gint _tmp62_;
		gint _tmp63_;
#line 371 "PositionManager.vala"
		_tmp62_ = self->priv->_HorizPadding;
#line 371 "PositionManager.vala"
		if (_tmp62_ < 0) {
#line 372 "PositionManager.vala"
			plank_position_manager_set_HorizPadding (self, (gint) scaled_icon_size);
#line 1200 "PositionManager.c"
		}
#line 373 "PositionManager.vala"
		_tmp63_ = self->priv->_TopPadding;
#line 373 "PositionManager.vala"
		if (_tmp63_ < 0) {
#line 374 "PositionManager.vala"
			plank_position_manager_set_TopPadding (self, (gint) scaled_icon_size);
#line 1208 "PositionManager.c"
		}
	}
#line 377 "PositionManager.vala"
	_tmp65_ = self->priv->_HorizPadding;
#line 377 "PositionManager.vala"
	if (_tmp65_ > 0) {
#line 1215 "PositionManager.c"
		gint _tmp66_;
#line 377 "PositionManager.vala"
		_tmp66_ = self->priv->_HorizPadding;
#line 377 "PositionManager.vala"
		_tmp64_ = _tmp66_;
#line 1221 "PositionManager.c"
	} else {
#line 377 "PositionManager.vala"
		_tmp64_ = 0;
#line 1225 "PositionManager.c"
	}
#line 377 "PositionManager.vala"
	_tmp67_ = self->priv->_LineWidth;
#line 377 "PositionManager.vala"
	self->priv->items_offset = (gint) ((2 * _tmp67_) + _tmp64_);
#line 379 "PositionManager.vala"
	_tmp68_ = self->priv->_TopPadding;
#line 379 "PositionManager.vala"
	self->priv->top_offset = plank_theme_get_top_offset ((PlankTheme*) theme) + _tmp68_;
#line 380 "PositionManager.vala"
	_tmp69_ = self->priv->_BottomPadding;
#line 380 "PositionManager.vala"
	self->priv->bottom_offset = plank_theme_get_bottom_offset ((PlankTheme*) theme) + _tmp69_;
#line 382 "PositionManager.vala"
	if (self->priv->top_offset < 0) {
#line 1241 "PositionManager.c"
		gint _tmp70_;
#line 383 "PositionManager.vala"
		_tmp70_ = self->priv->_IconShadowSize;
#line 383 "PositionManager.vala"
		self->priv->extra_hide_offset = _tmp70_;
#line 1247 "PositionManager.c"
	} else {
		gint _tmp71_;
#line 384 "PositionManager.vala"
		_tmp71_ = self->priv->_IconShadowSize;
#line 384 "PositionManager.vala"
		if (self->priv->top_offset < _tmp71_) {
#line 1254 "PositionManager.c"
			gint _tmp72_;
#line 385 "PositionManager.vala"
			_tmp72_ = self->priv->_IconShadowSize;
#line 385 "PositionManager.vala"
			self->priv->extra_hide_offset = _tmp72_ - self->priv->top_offset;
#line 1260 "PositionManager.c"
		} else {
#line 387 "PositionManager.vala"
			self->priv->extra_hide_offset = 0;
#line 1264 "PositionManager.c"
		}
	}
}

static void
plank_position_manager_prefs_zoom_changed (PlankPositionManager* self)
{
	PlankDockPreferences* prefs = NULL;
	PlankDockController* _tmp0_;
	PlankDockPreferences* _tmp1_;
	PlankDockPreferences* _tmp2_;
	gdouble _tmp3_ = 0.0;
	gboolean _tmp4_;
	gint _tmp8_ = 0;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_;
#line 390 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 392 "PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 392 "PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_prefs (_tmp0_);
#line 392 "PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 392 "PositionManager.vala"
	prefs = _tmp2_;
#line 394 "PositionManager.vala"
	_tmp4_ = self->priv->_screen_is_composited;
#line 394 "PositionManager.vala"
	if (_tmp4_) {
#line 1295 "PositionManager.c"
		PlankDockPreferences* _tmp5_;
		guint _tmp6_;
		guint _tmp7_;
#line 394 "PositionManager.vala"
		_tmp5_ = prefs;
#line 394 "PositionManager.vala"
		_tmp6_ = plank_dock_preferences_get_ZoomPercent (_tmp5_);
#line 394 "PositionManager.vala"
		_tmp7_ = _tmp6_;
#line 394 "PositionManager.vala"
		_tmp3_ = _tmp7_ / 100.0;
#line 1307 "PositionManager.c"
	} else {
#line 394 "PositionManager.vala"
		_tmp3_ = 1.0;
#line 1311 "PositionManager.c"
	}
#line 394 "PositionManager.vala"
	self->priv->ZoomPercent = _tmp3_;
#line 395 "PositionManager.vala"
	_tmp10_ = self->priv->_screen_is_composited;
#line 395 "PositionManager.vala"
	if (_tmp10_) {
#line 1319 "PositionManager.c"
		PlankDockPreferences* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
#line 395 "PositionManager.vala"
		_tmp11_ = prefs;
#line 395 "PositionManager.vala"
		_tmp12_ = plank_dock_preferences_get_ZoomEnabled (_tmp11_);
#line 395 "PositionManager.vala"
		_tmp13_ = _tmp12_;
#line 395 "PositionManager.vala"
		_tmp9_ = _tmp13_;
#line 1331 "PositionManager.c"
	} else {
#line 395 "PositionManager.vala"
		_tmp9_ = FALSE;
#line 1335 "PositionManager.c"
	}
#line 395 "PositionManager.vala"
	if (_tmp9_) {
#line 1339 "PositionManager.c"
		gint _tmp14_;
#line 395 "PositionManager.vala"
		_tmp14_ = self->priv->_IconSize;
#line 395 "PositionManager.vala"
		_tmp8_ = (gint) round (_tmp14_ * self->priv->ZoomPercent);
#line 1345 "PositionManager.c"
	} else {
		gint _tmp15_;
#line 395 "PositionManager.vala"
		_tmp15_ = self->priv->_IconSize;
#line 395 "PositionManager.vala"
		_tmp8_ = _tmp15_;
#line 1352 "PositionManager.c"
	}
#line 395 "PositionManager.vala"
	plank_position_manager_set_ZoomIconSize (self, _tmp8_);
#line 1356 "PositionManager.c"
}

/**
 * Find an appropriate MaxIconSize
 */
static void
plank_position_manager_update_max_icon_size (PlankPositionManager* self,
                                             PlankDockTheme* theme)
{
	PlankDockPreferences* prefs = NULL;
	PlankDockController* _tmp0_;
	PlankDockPreferences* _tmp1_;
	PlankDockPreferences* _tmp2_;
	gint item_count = 0;
	PlankDockController* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint width = 0;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_ = 0;
	gint max_width = 0;
	gint step_size = 0;
	gboolean _tmp15_ = FALSE;
#line 401 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 401 "PositionManager.vala"
	g_return_if_fail (theme != NULL);
#line 403 "PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 403 "PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_prefs (_tmp0_);
#line 403 "PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 403 "PositionManager.vala"
	prefs = _tmp2_;
#line 406 "PositionManager.vala"
	_tmp3_ = self->priv->_controller;
#line 406 "PositionManager.vala"
	_tmp4_ = plank_dock_controller_get_VisibleItems (_tmp3_);
#line 406 "PositionManager.vala"
	_tmp5_ = _tmp4_;
#line 406 "PositionManager.vala"
	_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 406 "PositionManager.vala"
	_tmp7_ = _tmp6_;
#line 406 "PositionManager.vala"
	item_count = _tmp7_;
#line 407 "PositionManager.vala"
	_tmp8_ = self->priv->_ItemPadding;
#line 407 "PositionManager.vala"
	_tmp9_ = self->priv->_IconSize;
#line 407 "PositionManager.vala"
	_tmp10_ = self->priv->_HorizPadding;
#line 407 "PositionManager.vala"
	_tmp11_ = self->priv->_LineWidth;
#line 407 "PositionManager.vala"
	width = ((item_count * (_tmp8_ + _tmp9_)) + (2 * _tmp10_)) + (4 * _tmp11_);
#line 408 "PositionManager.vala"
	if (plank_position_manager_is_horizontal_dock (self)) {
#line 1421 "PositionManager.c"
		GdkRectangle _tmp13_;
#line 408 "PositionManager.vala"
		_tmp13_ = self->priv->monitor_geo;
#line 408 "PositionManager.vala"
		_tmp12_ = _tmp13_.width;
#line 1427 "PositionManager.c"
	} else {
		GdkRectangle _tmp14_;
#line 408 "PositionManager.vala"
		_tmp14_ = self->priv->monitor_geo;
#line 408 "PositionManager.vala"
		_tmp12_ = _tmp14_.height;
#line 1434 "PositionManager.c"
	}
#line 408 "PositionManager.vala"
	max_width = _tmp12_;
#line 409 "PositionManager.vala"
	step_size = MAX (1, (gint) (fabs ((gdouble) (width - max_width)) / item_count));
#line 411 "PositionManager.vala"
	if (width > max_width) {
#line 1442 "PositionManager.c"
		gint _tmp16_;
#line 411 "PositionManager.vala"
		_tmp16_ = self->priv->_MaxIconSize;
#line 411 "PositionManager.vala"
		_tmp15_ = _tmp16_ > PLANK_DOCK_PREFERENCES_MIN_ICON_SIZE;
#line 1448 "PositionManager.c"
	} else {
#line 411 "PositionManager.vala"
		_tmp15_ = FALSE;
#line 1452 "PositionManager.c"
	}
#line 411 "PositionManager.vala"
	if (_tmp15_) {
#line 1456 "PositionManager.c"
		gint _tmp17_;
#line 412 "PositionManager.vala"
		_tmp17_ = self->priv->_MaxIconSize;
#line 412 "PositionManager.vala"
		plank_position_manager_set_MaxIconSize (self, _tmp17_ - step_size);
#line 1462 "PositionManager.c"
	} else {
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
#line 413 "PositionManager.vala"
		if (width < max_width) {
#line 1468 "PositionManager.c"
			gint _tmp20_;
			PlankDockPreferences* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
#line 413 "PositionManager.vala"
			_tmp20_ = self->priv->_MaxIconSize;
#line 413 "PositionManager.vala"
			_tmp21_ = prefs;
#line 413 "PositionManager.vala"
			_tmp22_ = plank_dock_preferences_get_IconSize (_tmp21_);
#line 413 "PositionManager.vala"
			_tmp23_ = _tmp22_;
#line 413 "PositionManager.vala"
			_tmp19_ = _tmp20_ < _tmp23_;
#line 1483 "PositionManager.c"
		} else {
#line 413 "PositionManager.vala"
			_tmp19_ = FALSE;
#line 1487 "PositionManager.c"
		}
#line 413 "PositionManager.vala"
		if (_tmp19_) {
#line 413 "PositionManager.vala"
			_tmp18_ = step_size > 1;
#line 1493 "PositionManager.c"
		} else {
#line 413 "PositionManager.vala"
			_tmp18_ = FALSE;
#line 1497 "PositionManager.c"
		}
#line 413 "PositionManager.vala"
		if (_tmp18_) {
#line 1501 "PositionManager.c"
			gint _tmp24_;
#line 414 "PositionManager.vala"
			_tmp24_ = self->priv->_MaxIconSize;
#line 414 "PositionManager.vala"
			plank_position_manager_set_MaxIconSize (self, _tmp24_ + step_size);
#line 1507 "PositionManager.c"
		} else {
			gint _tmp25_;
			gint _tmp26_;
#line 417 "PositionManager.vala"
			_tmp25_ = self->priv->_MaxIconSize;
#line 417 "PositionManager.vala"
			plank_position_manager_set_MaxIconSize (self, MAX (PLANK_DOCK_PREFERENCES_MIN_ICON_SIZE, MIN (PLANK_DOCK_PREFERENCES_MAX_ICON_SIZE, ((gint) (_tmp25_ / 2.0)) * 2)));
#line 419 "PositionManager.vala"
			_tmp26_ = self->priv->_MaxIconSize;
#line 419 "PositionManager.vala"
			plank_logger_verbose ("PositionManager.MaxIconSize = %i", _tmp26_, NULL);
#line 420 "PositionManager.vala"
			plank_position_manager_update_caches (self, theme);
#line 421 "PositionManager.vala"
			return;
#line 1523 "PositionManager.c"
		}
	}
#line 424 "PositionManager.vala"
	plank_position_manager_update_caches (self, theme);
#line 425 "PositionManager.vala"
	plank_position_manager_update_max_icon_size (self, theme);
#line 1530 "PositionManager.c"
}

static void
plank_position_manager_update_dimensions (PlankPositionManager* self)
{
	gint height = 0;
	gint _tmp0_;
	gint background_height = 0;
	gint _tmp1_ = 0;
	gboolean _tmp2_;
	gint dock_height = 0;
	gint width = 0;
	GtkAlign _tmp4_;
	gint background_width = 0;
	gint _tmp16_;
#line 428 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 430 "PositionManager.vala"
	plank_logger_verbose ("PositionManager.update_dimensions ()", NULL);
#line 433 "PositionManager.vala"
	_tmp0_ = self->priv->_IconSize;
#line 433 "PositionManager.vala"
	height = (_tmp0_ + self->priv->top_offset) + self->priv->bottom_offset;
#line 436 "PositionManager.vala"
	background_height = MAX (0, height);
#line 438 "PositionManager.vala"
	if (self->priv->top_offset < 0) {
#line 439 "PositionManager.vala"
		height -= self->priv->top_offset;
#line 1560 "PositionManager.c"
	}
#line 442 "PositionManager.vala"
	_tmp2_ = self->priv->_screen_is_composited;
#line 442 "PositionManager.vala"
	if (_tmp2_) {
#line 1566 "PositionManager.c"
		gint _tmp3_;
#line 442 "PositionManager.vala"
		_tmp3_ = self->priv->_UrgentBounceHeight;
#line 442 "PositionManager.vala"
		_tmp1_ = _tmp3_;
#line 1572 "PositionManager.c"
	} else {
#line 442 "PositionManager.vala"
		_tmp1_ = 0;
#line 1576 "PositionManager.c"
	}
#line 442 "PositionManager.vala"
	dock_height = height + _tmp1_;
#line 444 "PositionManager.vala"
	width = 0;
#line 445 "PositionManager.vala"
	_tmp4_ = self->priv->_Alignment;
#line 445 "PositionManager.vala"
	switch (_tmp4_) {
#line 1586 "PositionManager.c"
		default:
#line 445 "PositionManager.vala"
		case GTK_ALIGN_START:
#line 445 "PositionManager.vala"
		case GTK_ALIGN_END:
#line 445 "PositionManager.vala"
		case GTK_ALIGN_CENTER:
#line 1594 "PositionManager.c"
		{
			PlankDockController* _tmp5_;
			GeeArrayList* _tmp6_;
			GeeArrayList* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
#line 450 "PositionManager.vala"
			_tmp5_ = self->priv->_controller;
#line 450 "PositionManager.vala"
			_tmp6_ = plank_dock_controller_get_VisibleItems (_tmp5_);
#line 450 "PositionManager.vala"
			_tmp7_ = _tmp6_;
#line 450 "PositionManager.vala"
			_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 450 "PositionManager.vala"
			_tmp9_ = _tmp8_;
#line 450 "PositionManager.vala"
			_tmp10_ = self->priv->_ItemPadding;
#line 450 "PositionManager.vala"
			_tmp11_ = self->priv->_IconSize;
#line 450 "PositionManager.vala"
			_tmp12_ = self->priv->_HorizPadding;
#line 450 "PositionManager.vala"
			_tmp13_ = self->priv->_LineWidth;
#line 450 "PositionManager.vala"
			width = ((_tmp9_ * (_tmp10_ + _tmp11_)) + (2 * _tmp12_)) + (4 * _tmp13_);
#line 451 "PositionManager.vala"
			break;
#line 1627 "PositionManager.c"
		}
#line 445 "PositionManager.vala"
		case GTK_ALIGN_FILL:
#line 1631 "PositionManager.c"
		{
#line 453 "PositionManager.vala"
			if (plank_position_manager_is_horizontal_dock (self)) {
#line 1635 "PositionManager.c"
				GdkRectangle _tmp14_;
#line 454 "PositionManager.vala"
				_tmp14_ = self->priv->monitor_geo;
#line 454 "PositionManager.vala"
				width = _tmp14_.width;
#line 1641 "PositionManager.c"
			} else {
				GdkRectangle _tmp15_;
#line 456 "PositionManager.vala"
				_tmp15_ = self->priv->monitor_geo;
#line 456 "PositionManager.vala"
				width = _tmp15_.height;
#line 1648 "PositionManager.c"
			}
#line 457 "PositionManager.vala"
			break;
#line 1652 "PositionManager.c"
		}
	}
#line 461 "PositionManager.vala"
	background_width = MAX (0, width);
#line 464 "PositionManager.vala"
	_tmp16_ = self->priv->_HorizPadding;
#line 464 "PositionManager.vala"
	if (_tmp16_ < 0) {
#line 1661 "PositionManager.c"
		gint _tmp17_;
#line 465 "PositionManager.vala"
		_tmp17_ = self->priv->_HorizPadding;
#line 465 "PositionManager.vala"
		width -= 2 * _tmp17_;
#line 1667 "PositionManager.c"
	}
#line 467 "PositionManager.vala"
	if (plank_position_manager_is_horizontal_dock (self)) {
#line 1671 "PositionManager.c"
		GdkRectangle _tmp18_;
		gint _tmp19_ = 0;
		gboolean _tmp20_;
		GdkRectangle _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
#line 468 "PositionManager.vala"
		_tmp18_ = self->priv->monitor_geo;
#line 468 "PositionManager.vala"
		width = MIN (_tmp18_.width, width);
#line 469 "PositionManager.vala"
		self->priv->VisibleDockHeight = height;
#line 470 "PositionManager.vala"
		self->priv->VisibleDockWidth = width;
#line 471 "PositionManager.vala"
		self->priv->DockHeight = dock_height;
#line 472 "PositionManager.vala"
		_tmp20_ = self->priv->_screen_is_composited;
#line 472 "PositionManager.vala"
		if (_tmp20_) {
#line 1694 "PositionManager.c"
			GdkRectangle _tmp21_;
#line 472 "PositionManager.vala"
			_tmp21_ = self->priv->monitor_geo;
#line 472 "PositionManager.vala"
			_tmp19_ = _tmp21_.width;
#line 1700 "PositionManager.c"
		} else {
#line 472 "PositionManager.vala"
			_tmp19_ = width;
#line 1704 "PositionManager.c"
		}
#line 472 "PositionManager.vala"
		self->priv->DockWidth = _tmp19_;
#line 473 "PositionManager.vala"
		self->priv->DockBackgroundHeight = background_height;
#line 474 "PositionManager.vala"
		self->priv->DockBackgroundWidth = background_width;
#line 475 "PositionManager.vala"
		_tmp22_ = self->priv->monitor_geo;
#line 475 "PositionManager.vala"
		_tmp23_ = self->priv->_HorizPadding;
#line 475 "PositionManager.vala"
		_tmp24_ = self->priv->_LineWidth;
#line 475 "PositionManager.vala"
		_tmp25_ = self->priv->_ItemPadding;
#line 475 "PositionManager.vala"
		_tmp26_ = self->priv->_IconSize;
#line 475 "PositionManager.vala"
		plank_position_manager_set_MaxItemCount (self, (gint) floor (((gdouble) ((_tmp22_.width - (2 * _tmp23_)) + (4 * _tmp24_))) / (_tmp25_ + _tmp26_)));
#line 1724 "PositionManager.c"
	} else {
		GdkRectangle _tmp27_;
		gint _tmp28_ = 0;
		gboolean _tmp29_;
		GdkRectangle _tmp31_;
		gint _tmp32_;
		gint _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
#line 477 "PositionManager.vala"
		_tmp27_ = self->priv->monitor_geo;
#line 477 "PositionManager.vala"
		width = MIN (_tmp27_.height, width);
#line 478 "PositionManager.vala"
		self->priv->VisibleDockHeight = width;
#line 479 "PositionManager.vala"
		self->priv->VisibleDockWidth = height;
#line 480 "PositionManager.vala"
		_tmp29_ = self->priv->_screen_is_composited;
#line 480 "PositionManager.vala"
		if (_tmp29_) {
#line 1746 "PositionManager.c"
			GdkRectangle _tmp30_;
#line 480 "PositionManager.vala"
			_tmp30_ = self->priv->monitor_geo;
#line 480 "PositionManager.vala"
			_tmp28_ = _tmp30_.height;
#line 1752 "PositionManager.c"
		} else {
#line 480 "PositionManager.vala"
			_tmp28_ = width;
#line 1756 "PositionManager.c"
		}
#line 480 "PositionManager.vala"
		self->priv->DockHeight = _tmp28_;
#line 481 "PositionManager.vala"
		self->priv->DockWidth = dock_height;
#line 482 "PositionManager.vala"
		self->priv->DockBackgroundHeight = background_width;
#line 483 "PositionManager.vala"
		self->priv->DockBackgroundWidth = background_height;
#line 484 "PositionManager.vala"
		_tmp31_ = self->priv->monitor_geo;
#line 484 "PositionManager.vala"
		_tmp32_ = self->priv->_HorizPadding;
#line 484 "PositionManager.vala"
		_tmp33_ = self->priv->_LineWidth;
#line 484 "PositionManager.vala"
		_tmp34_ = self->priv->_ItemPadding;
#line 484 "PositionManager.vala"
		_tmp35_ = self->priv->_IconSize;
#line 484 "PositionManager.vala"
		plank_position_manager_set_MaxItemCount (self, (gint) floor (((gdouble) ((_tmp31_.height - (2 * _tmp32_)) + (4 * _tmp33_))) / (_tmp34_ + _tmp35_)));
#line 1778 "PositionManager.c"
	}
}

/**
 * Return whether or not a dock is a horizontal dock.
 *
 * @return true if the dock's position indicates it is horizontal
 */
gboolean
plank_position_manager_is_horizontal_dock (PlankPositionManager* self)
{
	gboolean _tmp0_ = FALSE;
	GtkPositionType _tmp1_;
	gboolean result;
#line 493 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 495 "PositionManager.vala"
	_tmp1_ = self->priv->_Position;
#line 495 "PositionManager.vala"
	if (_tmp1_ == GTK_POS_TOP) {
#line 495 "PositionManager.vala"
		_tmp0_ = TRUE;
#line 1801 "PositionManager.c"
	} else {
		GtkPositionType _tmp2_;
#line 495 "PositionManager.vala"
		_tmp2_ = self->priv->_Position;
#line 495 "PositionManager.vala"
		_tmp0_ = _tmp2_ == GTK_POS_BOTTOM;
#line 1808 "PositionManager.c"
	}
#line 495 "PositionManager.vala"
	result = _tmp0_;
#line 495 "PositionManager.vala"
	return result;
#line 1814 "PositionManager.c"
}

/**
 * Returns the cursor region for the dock.
 * This is the region that the cursor can interact with the dock.
 *
 * @return the cursor region for the dock
 */
void
plank_position_manager_get_cursor_region (PlankPositionManager* self,
                                          GdkRectangle* result)
{
	GdkRectangle cursor_region = {0};
	GdkRectangle _tmp0_;
	gdouble progress = 0.0;
	PlankDockController* _tmp1_;
	PlankDockRenderer* _tmp2_;
	PlankDockRenderer* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	PlankDockController* _tmp6_;
	PlankDockWindow* _tmp7_;
	PlankDockWindow* _tmp8_;
	GdkWindow* _tmp9_;
	PlankDockController* _tmp10_;
	PlankDockPreferences* _tmp11_;
	PlankDockPreferences* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	GtkPositionType _tmp25_;
#line 504 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 506 "PositionManager.vala"
	_tmp0_ = self->priv->static_dock_region;
#line 506 "PositionManager.vala"
	cursor_region = _tmp0_;
#line 507 "PositionManager.vala"
	_tmp1_ = self->priv->_controller;
#line 507 "PositionManager.vala"
	_tmp2_ = plank_dock_controller_get_renderer (_tmp1_);
#line 507 "PositionManager.vala"
	_tmp3_ = _tmp2_;
#line 507 "PositionManager.vala"
	_tmp4_ = plank_dock_renderer_get_hide_progress (_tmp3_);
#line 507 "PositionManager.vala"
	_tmp5_ = _tmp4_;
#line 507 "PositionManager.vala"
	progress = 1.0 - _tmp5_;
#line 508 "PositionManager.vala"
	_tmp6_ = self->priv->_controller;
#line 508 "PositionManager.vala"
	_tmp7_ = plank_dock_controller_get_window (_tmp6_);
#line 508 "PositionManager.vala"
	_tmp8_ = _tmp7_;
#line 508 "PositionManager.vala"
	_tmp9_ = gtk_widget_get_window ((GtkWidget*) _tmp8_);
#line 508 "PositionManager.vala"
	self->priv->window_scale_factor = gdk_window_get_scale_factor (_tmp9_);
#line 511 "PositionManager.vala"
	_tmp10_ = self->priv->_controller;
#line 511 "PositionManager.vala"
	_tmp11_ = plank_dock_controller_get_prefs (_tmp10_);
#line 511 "PositionManager.vala"
	_tmp12_ = _tmp11_;
#line 511 "PositionManager.vala"
	_tmp13_ = plank_dock_preferences_get_ZoomEnabled (_tmp12_);
#line 511 "PositionManager.vala"
	_tmp14_ = _tmp13_;
#line 511 "PositionManager.vala"
	if (_tmp14_) {
#line 1885 "PositionManager.c"
		PlankDockItem* hovered_item = NULL;
		PlankDockController* _tmp15_;
		PlankDockWindow* _tmp16_;
		PlankDockWindow* _tmp17_;
		PlankDockItem* _tmp18_;
		PlankDockItem* _tmp19_;
		PlankDockItem* _tmp20_;
#line 512 "PositionManager.vala"
		_tmp15_ = self->priv->_controller;
#line 512 "PositionManager.vala"
		_tmp16_ = plank_dock_controller_get_window (_tmp15_);
#line 512 "PositionManager.vala"
		_tmp17_ = _tmp16_;
#line 512 "PositionManager.vala"
		_tmp18_ = plank_dock_window_get_HoveredItem (_tmp17_);
#line 512 "PositionManager.vala"
		_tmp19_ = _tmp18_;
#line 512 "PositionManager.vala"
		hovered_item = _tmp19_;
#line 513 "PositionManager.vala"
		_tmp20_ = hovered_item;
#line 513 "PositionManager.vala"
		if (_tmp20_ != NULL) {
#line 1909 "PositionManager.c"
			GdkRectangle hover_region = {0};
			PlankDockItem* _tmp21_;
			GdkRectangle _tmp22_ = {0};
			GdkRectangle _tmp23_;
			GdkRectangle _tmp24_ = {0};
#line 514 "PositionManager.vala"
			_tmp21_ = hovered_item;
#line 514 "PositionManager.vala"
			plank_position_manager_get_hover_region_for_element (self, (PlankDockElement*) _tmp21_, &_tmp22_);
#line 514 "PositionManager.vala"
			hover_region = _tmp22_;
#line 515 "PositionManager.vala"
			_tmp23_ = hover_region;
#line 515 "PositionManager.vala"
			gdk_rectangle_union (&cursor_region, &_tmp23_, &_tmp24_);
#line 515 "PositionManager.vala"
			cursor_region = _tmp24_;
#line 1927 "PositionManager.c"
		}
	}
#line 519 "PositionManager.vala"
	_tmp25_ = self->priv->_Position;
#line 519 "PositionManager.vala"
	switch (_tmp25_) {
#line 1934 "PositionManager.c"
		default:
#line 519 "PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 1938 "PositionManager.c"
		{
			GdkRectangle _tmp26_;
			GdkRectangle _tmp27_;
#line 522 "PositionManager.vala"
			_tmp26_ = cursor_region;
#line 522 "PositionManager.vala"
			cursor_region.height = MAX (1 * self->priv->window_scale_factor, (gint) (progress * _tmp26_.height));
#line 523 "PositionManager.vala"
			_tmp27_ = cursor_region;
#line 523 "PositionManager.vala"
			cursor_region.y = (self->priv->DockHeight - _tmp27_.height) + (self->priv->window_scale_factor - 1);
#line 524 "PositionManager.vala"
			break;
#line 1952 "PositionManager.c"
		}
#line 519 "PositionManager.vala"
		case GTK_POS_TOP:
#line 1956 "PositionManager.c"
		{
			GdkRectangle _tmp28_;
#line 526 "PositionManager.vala"
			_tmp28_ = cursor_region;
#line 526 "PositionManager.vala"
			cursor_region.height = MAX (1 * self->priv->window_scale_factor, (gint) (progress * _tmp28_.height));
#line 527 "PositionManager.vala"
			cursor_region.y = 0;
#line 528 "PositionManager.vala"
			break;
#line 1967 "PositionManager.c"
		}
#line 519 "PositionManager.vala"
		case GTK_POS_LEFT:
#line 1971 "PositionManager.c"
		{
			GdkRectangle _tmp29_;
#line 530 "PositionManager.vala"
			_tmp29_ = cursor_region;
#line 530 "PositionManager.vala"
			cursor_region.width = MAX (1 * self->priv->window_scale_factor, (gint) (progress * _tmp29_.width));
#line 531 "PositionManager.vala"
			cursor_region.x = 0;
#line 532 "PositionManager.vala"
			break;
#line 1982 "PositionManager.c"
		}
#line 519 "PositionManager.vala"
		case GTK_POS_RIGHT:
#line 1986 "PositionManager.c"
		{
			GdkRectangle _tmp30_;
			GdkRectangle _tmp31_;
#line 534 "PositionManager.vala"
			_tmp30_ = cursor_region;
#line 534 "PositionManager.vala"
			cursor_region.width = MAX (1 * self->priv->window_scale_factor, (gint) (progress * _tmp30_.width));
#line 535 "PositionManager.vala"
			_tmp31_ = cursor_region;
#line 535 "PositionManager.vala"
			cursor_region.x = (self->priv->DockWidth - _tmp31_.width) + (self->priv->window_scale_factor - 1);
#line 536 "PositionManager.vala"
			break;
#line 2000 "PositionManager.c"
		}
	}
#line 539 "PositionManager.vala"
	*result = cursor_region;
#line 539 "PositionManager.vala"
	return;
#line 2007 "PositionManager.c"
}

/**
 * Returns the static dock region for the dock.
 * This is the region that the dock occupies when not hidden.
 *
 * @return the static dock region for the dock
 */
void
plank_position_manager_get_static_dock_region (PlankPositionManager* self,
                                               GdkRectangle* result)
{
	GdkRectangle dock_region = {0};
	GdkRectangle _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
#line 548 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 550 "PositionManager.vala"
	_tmp0_ = self->priv->static_dock_region;
#line 550 "PositionManager.vala"
	dock_region = _tmp0_;
#line 551 "PositionManager.vala"
	dock_region.x = dock_region.x + self->priv->win_x;
#line 552 "PositionManager.vala"
	dock_region.y = dock_region.y + self->priv->win_y;
#line 555 "PositionManager.vala"
	_tmp2_ = self->priv->_screen_is_composited;
#line 555 "PositionManager.vala"
	if (!_tmp2_) {
#line 2038 "PositionManager.c"
		PlankDockController* _tmp3_;
		PlankHideManager* _tmp4_;
		PlankHideManager* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 555 "PositionManager.vala"
		_tmp3_ = self->priv->_controller;
#line 555 "PositionManager.vala"
		_tmp4_ = plank_dock_controller_get_hide_manager (_tmp3_);
#line 555 "PositionManager.vala"
		_tmp5_ = _tmp4_;
#line 555 "PositionManager.vala"
		_tmp6_ = plank_hide_manager_get_Hidden (_tmp5_);
#line 555 "PositionManager.vala"
		_tmp7_ = _tmp6_;
#line 555 "PositionManager.vala"
		_tmp1_ = _tmp7_;
#line 2056 "PositionManager.c"
	} else {
#line 555 "PositionManager.vala"
		_tmp1_ = FALSE;
#line 2060 "PositionManager.c"
	}
#line 555 "PositionManager.vala"
	if (_tmp1_) {
#line 2064 "PositionManager.c"
		GtkPositionType _tmp8_;
#line 556 "PositionManager.vala"
		_tmp8_ = self->priv->_Position;
#line 556 "PositionManager.vala"
		switch (_tmp8_) {
#line 2070 "PositionManager.c"
			default:
#line 556 "PositionManager.vala"
			case GTK_POS_BOTTOM:
#line 2074 "PositionManager.c"
			{
#line 559 "PositionManager.vala"
				dock_region.y = dock_region.y - (self->priv->DockHeight - 1);
#line 560 "PositionManager.vala"
				break;
#line 2080 "PositionManager.c"
			}
#line 556 "PositionManager.vala"
			case GTK_POS_TOP:
#line 2084 "PositionManager.c"
			{
#line 562 "PositionManager.vala"
				dock_region.y = dock_region.y + (self->priv->DockHeight - 1);
#line 563 "PositionManager.vala"
				break;
#line 2090 "PositionManager.c"
			}
#line 556 "PositionManager.vala"
			case GTK_POS_LEFT:
#line 2094 "PositionManager.c"
			{
#line 565 "PositionManager.vala"
				dock_region.x = dock_region.x + (self->priv->DockWidth - 1);
#line 566 "PositionManager.vala"
				break;
#line 2100 "PositionManager.c"
			}
#line 556 "PositionManager.vala"
			case GTK_POS_RIGHT:
#line 2104 "PositionManager.c"
			{
#line 568 "PositionManager.vala"
				dock_region.x = dock_region.x - (self->priv->DockWidth - 1);
#line 569 "PositionManager.vala"
				break;
#line 2110 "PositionManager.c"
			}
		}
	}
#line 573 "PositionManager.vala"
	*result = dock_region;
#line 573 "PositionManager.vala"
	return;
#line 2118 "PositionManager.c"
}

/**
 * Call when any cached region needs updating.
 */
void
plank_position_manager_update_regions (PlankPositionManager* self)
{
	GdkRectangle old_region = {0};
	GdkRectangle _tmp0_;
	PlankDockController* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint xoffset = 0;
	GdkRectangle _tmp8_;
	gint yoffset = 0;
	GdkRectangle _tmp9_;
	gboolean _tmp10_;
	GtkPositionType _tmp21_;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_;
#line 579 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 581 "PositionManager.vala"
	plank_logger_verbose ("PositionManager.update_regions ()", NULL);
#line 583 "PositionManager.vala"
	_tmp0_ = self->priv->static_dock_region;
#line 583 "PositionManager.vala"
	old_region = _tmp0_;
#line 586 "PositionManager.vala"
	_tmp1_ = self->priv->_controller;
#line 586 "PositionManager.vala"
	_tmp2_ = plank_dock_controller_get_VisibleItems (_tmp1_);
#line 586 "PositionManager.vala"
	_tmp3_ = _tmp2_;
#line 586 "PositionManager.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 586 "PositionManager.vala"
	_tmp5_ = _tmp4_;
#line 586 "PositionManager.vala"
	_tmp6_ = self->priv->_ItemPadding;
#line 586 "PositionManager.vala"
	_tmp7_ = self->priv->_IconSize;
#line 586 "PositionManager.vala"
	self->priv->items_width = _tmp5_ * (_tmp6_ + _tmp7_);
#line 588 "PositionManager.vala"
	self->priv->static_dock_region.width = self->priv->VisibleDockWidth;
#line 589 "PositionManager.vala"
	self->priv->static_dock_region.height = self->priv->VisibleDockHeight;
#line 591 "PositionManager.vala"
	_tmp8_ = self->priv->static_dock_region;
#line 591 "PositionManager.vala"
	xoffset = (self->priv->DockWidth - _tmp8_.width) / 2;
#line 592 "PositionManager.vala"
	_tmp9_ = self->priv->static_dock_region;
#line 592 "PositionManager.vala"
	yoffset = (self->priv->DockHeight - _tmp9_.height) / 2;
#line 594 "PositionManager.vala"
	_tmp10_ = self->priv->_screen_is_composited;
#line 594 "PositionManager.vala"
	if (_tmp10_) {
#line 2187 "PositionManager.c"
		gint offset = 0;
		gint _tmp11_;
		GtkAlign _tmp12_;
#line 595 "PositionManager.vala"
		_tmp11_ = self->priv->_Offset;
#line 595 "PositionManager.vala"
		offset = _tmp11_;
#line 596 "PositionManager.vala"
		xoffset = (gint) ((1 + (offset / 100.0)) * xoffset);
#line 597 "PositionManager.vala"
		yoffset = (gint) ((1 + (offset / 100.0)) * yoffset);
#line 599 "PositionManager.vala"
		_tmp12_ = self->priv->_Alignment;
#line 599 "PositionManager.vala"
		switch (_tmp12_) {
#line 2203 "PositionManager.c"
			default:
#line 599 "PositionManager.vala"
			case GTK_ALIGN_CENTER:
#line 599 "PositionManager.vala"
			case GTK_ALIGN_FILL:
#line 2209 "PositionManager.c"
			{
#line 603 "PositionManager.vala"
				break;
#line 2213 "PositionManager.c"
			}
#line 599 "PositionManager.vala"
			case GTK_ALIGN_START:
#line 2217 "PositionManager.c"
			{
#line 605 "PositionManager.vala"
				if (plank_position_manager_is_horizontal_dock (self)) {
#line 2221 "PositionManager.c"
					GdkRectangle _tmp13_;
					GdkRectangle _tmp14_;
#line 606 "PositionManager.vala"
					xoffset = 0;
#line 607 "PositionManager.vala"
					_tmp13_ = self->priv->monitor_geo;
#line 607 "PositionManager.vala"
					_tmp14_ = self->priv->static_dock_region;
#line 607 "PositionManager.vala"
					yoffset = _tmp13_.height - _tmp14_.height;
#line 2232 "PositionManager.c"
				} else {
					GdkRectangle _tmp15_;
					GdkRectangle _tmp16_;
#line 609 "PositionManager.vala"
					_tmp15_ = self->priv->monitor_geo;
#line 609 "PositionManager.vala"
					_tmp16_ = self->priv->static_dock_region;
#line 609 "PositionManager.vala"
					xoffset = _tmp15_.width - _tmp16_.width;
#line 610 "PositionManager.vala"
					yoffset = 0;
#line 2244 "PositionManager.c"
				}
#line 612 "PositionManager.vala"
				break;
#line 2248 "PositionManager.c"
			}
#line 599 "PositionManager.vala"
			case GTK_ALIGN_END:
#line 2252 "PositionManager.c"
			{
#line 614 "PositionManager.vala"
				if (plank_position_manager_is_horizontal_dock (self)) {
#line 2256 "PositionManager.c"
					GdkRectangle _tmp17_;
					GdkRectangle _tmp18_;
#line 615 "PositionManager.vala"
					_tmp17_ = self->priv->monitor_geo;
#line 615 "PositionManager.vala"
					_tmp18_ = self->priv->static_dock_region;
#line 615 "PositionManager.vala"
					xoffset = _tmp17_.width - _tmp18_.width;
#line 616 "PositionManager.vala"
					yoffset = 0;
#line 2267 "PositionManager.c"
				} else {
					GdkRectangle _tmp19_;
					GdkRectangle _tmp20_;
#line 618 "PositionManager.vala"
					xoffset = 0;
#line 619 "PositionManager.vala"
					_tmp19_ = self->priv->monitor_geo;
#line 619 "PositionManager.vala"
					_tmp20_ = self->priv->static_dock_region;
#line 619 "PositionManager.vala"
					yoffset = _tmp19_.height - _tmp20_.height;
#line 2279 "PositionManager.c"
				}
#line 621 "PositionManager.vala"
				break;
#line 2283 "PositionManager.c"
			}
		}
	}
#line 625 "PositionManager.vala"
	_tmp21_ = self->priv->_Position;
#line 625 "PositionManager.vala"
	switch (_tmp21_) {
#line 2291 "PositionManager.c"
		default:
#line 625 "PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 2295 "PositionManager.c"
		{
			GdkRectangle _tmp22_;
#line 628 "PositionManager.vala"
			self->priv->static_dock_region.x = xoffset;
#line 629 "PositionManager.vala"
			_tmp22_ = self->priv->static_dock_region;
#line 629 "PositionManager.vala"
			self->priv->static_dock_region.y = self->priv->DockHeight - _tmp22_.height;
#line 630 "PositionManager.vala"
			break;
#line 2306 "PositionManager.c"
		}
#line 625 "PositionManager.vala"
		case GTK_POS_TOP:
#line 2310 "PositionManager.c"
		{
#line 632 "PositionManager.vala"
			self->priv->static_dock_region.x = xoffset;
#line 633 "PositionManager.vala"
			self->priv->static_dock_region.y = 0;
#line 634 "PositionManager.vala"
			break;
#line 2318 "PositionManager.c"
		}
#line 625 "PositionManager.vala"
		case GTK_POS_LEFT:
#line 2322 "PositionManager.c"
		{
#line 636 "PositionManager.vala"
			self->priv->static_dock_region.y = yoffset;
#line 637 "PositionManager.vala"
			self->priv->static_dock_region.x = 0;
#line 638 "PositionManager.vala"
			break;
#line 2330 "PositionManager.c"
		}
#line 625 "PositionManager.vala"
		case GTK_POS_RIGHT:
#line 2334 "PositionManager.c"
		{
			GdkRectangle _tmp23_;
#line 640 "PositionManager.vala"
			self->priv->static_dock_region.y = yoffset;
#line 641 "PositionManager.vala"
			_tmp23_ = self->priv->static_dock_region;
#line 641 "PositionManager.vala"
			self->priv->static_dock_region.x = self->priv->DockWidth - _tmp23_.width;
#line 642 "PositionManager.vala"
			break;
#line 2345 "PositionManager.c"
		}
	}
#line 645 "PositionManager.vala"
	plank_position_manager_update_dock_position (self);
#line 647 "PositionManager.vala"
	_tmp28_ = self->priv->_screen_is_composited;
#line 647 "PositionManager.vala"
	if (!_tmp28_) {
#line 647 "PositionManager.vala"
		_tmp27_ = TRUE;
#line 2356 "PositionManager.c"
	} else {
		GdkRectangle _tmp29_;
		GdkRectangle _tmp30_;
#line 648 "PositionManager.vala"
		_tmp29_ = old_region;
#line 648 "PositionManager.vala"
		_tmp30_ = self->priv->static_dock_region;
#line 648 "PositionManager.vala"
		_tmp27_ = _tmp29_.x != _tmp30_.x;
#line 2366 "PositionManager.c"
	}
#line 647 "PositionManager.vala"
	if (_tmp27_) {
#line 647 "PositionManager.vala"
		_tmp26_ = TRUE;
#line 2372 "PositionManager.c"
	} else {
		GdkRectangle _tmp31_;
		GdkRectangle _tmp32_;
#line 649 "PositionManager.vala"
		_tmp31_ = old_region;
#line 649 "PositionManager.vala"
		_tmp32_ = self->priv->static_dock_region;
#line 649 "PositionManager.vala"
		_tmp26_ = _tmp31_.y != _tmp32_.y;
#line 2382 "PositionManager.c"
	}
#line 647 "PositionManager.vala"
	if (_tmp26_) {
#line 647 "PositionManager.vala"
		_tmp25_ = TRUE;
#line 2388 "PositionManager.c"
	} else {
		GdkRectangle _tmp33_;
		GdkRectangle _tmp34_;
#line 650 "PositionManager.vala"
		_tmp33_ = old_region;
#line 650 "PositionManager.vala"
		_tmp34_ = self->priv->static_dock_region;
#line 650 "PositionManager.vala"
		_tmp25_ = _tmp33_.width != _tmp34_.width;
#line 2398 "PositionManager.c"
	}
#line 647 "PositionManager.vala"
	if (_tmp25_) {
#line 647 "PositionManager.vala"
		_tmp24_ = TRUE;
#line 2404 "PositionManager.c"
	} else {
		GdkRectangle _tmp35_;
		GdkRectangle _tmp36_;
#line 651 "PositionManager.vala"
		_tmp35_ = old_region;
#line 651 "PositionManager.vala"
		_tmp36_ = self->priv->static_dock_region;
#line 651 "PositionManager.vala"
		_tmp24_ = _tmp35_.height != _tmp36_.height;
#line 2414 "PositionManager.c"
	}
#line 647 "PositionManager.vala"
	if (_tmp24_) {
#line 2418 "PositionManager.c"
		PlankDockController* _tmp37_;
		PlankDockWindow* _tmp38_;
		PlankDockWindow* _tmp39_;
		PlankDockController* _tmp40_;
		PlankHideManager* _tmp41_;
		PlankHideManager* _tmp42_;
		gboolean _tmp43_;
#line 652 "PositionManager.vala"
		_tmp37_ = self->priv->_controller;
#line 652 "PositionManager.vala"
		_tmp38_ = plank_dock_controller_get_window (_tmp37_);
#line 652 "PositionManager.vala"
		_tmp39_ = _tmp38_;
#line 652 "PositionManager.vala"
		plank_dock_window_update_size_and_position (_tmp39_);
#line 654 "PositionManager.vala"
		_tmp40_ = self->priv->_controller;
#line 654 "PositionManager.vala"
		_tmp41_ = plank_dock_controller_get_hide_manager (_tmp40_);
#line 654 "PositionManager.vala"
		_tmp42_ = _tmp41_;
#line 654 "PositionManager.vala"
		plank_hide_manager_update_barrier (_tmp42_);
#line 659 "PositionManager.vala"
		_tmp43_ = self->priv->_screen_is_composited;
#line 659 "PositionManager.vala"
		if (_tmp43_) {
#line 2446 "PositionManager.c"
			PlankDockController* _tmp44_;
			PlankDockRenderer* _tmp45_;
			PlankDockRenderer* _tmp46_;
#line 660 "PositionManager.vala"
			_tmp44_ = self->priv->_controller;
#line 660 "PositionManager.vala"
			_tmp45_ = plank_dock_controller_get_renderer (_tmp44_);
#line 660 "PositionManager.vala"
			_tmp46_ = _tmp45_;
#line 660 "PositionManager.vala"
			plank_renderer_animated_draw ((PlankRenderer*) _tmp46_);
#line 2458 "PositionManager.c"
		}
	} else {
		PlankDockController* _tmp47_;
		PlankDockRenderer* _tmp48_;
		PlankDockRenderer* _tmp49_;
#line 662 "PositionManager.vala"
		_tmp47_ = self->priv->_controller;
#line 662 "PositionManager.vala"
		_tmp48_ = plank_dock_controller_get_renderer (_tmp47_);
#line 662 "PositionManager.vala"
		_tmp49_ = _tmp48_;
#line 662 "PositionManager.vala"
		plank_renderer_animated_draw ((PlankRenderer*) _tmp49_);
#line 2472 "PositionManager.c"
	}
}

/**
 * The draw-value for a dock item.
 *
 * @param item the dock item to find the drawvalue for
 * @return the region for the dock item
 */
PlankDockItemDrawValue*
plank_position_manager_get_draw_value_for_item (PlankPositionManager* self,
                                                PlankDockItem* item)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	PlankDockItemDrawValue* draw_value = NULL;
	GeeHashMap* _tmp6_;
	gpointer _tmp7_;
	PlankDockItemDrawValue* _tmp8_;
	PlankDockItemDrawValue* result;
#line 672 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 672 "PositionManager.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 674 "PositionManager.vala"
	_tmp0_ = self->priv->draw_values;
#line 674 "PositionManager.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 674 "PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 674 "PositionManager.vala"
	if (_tmp2_ == 0) {
#line 2506 "PositionManager.c"
		PlankDockController* _tmp3_;
		GeeArrayList* _tmp4_;
		GeeArrayList* _tmp5_;
#line 675 "PositionManager.vala"
		g_debug ("PositionManager.vala:675: Without draw_values there is trouble ahead");
#line 676 "PositionManager.vala"
		_tmp3_ = self->priv->_controller;
#line 676 "PositionManager.vala"
		_tmp4_ = plank_dock_controller_get_VisibleItems (_tmp3_);
#line 676 "PositionManager.vala"
		_tmp5_ = _tmp4_;
#line 676 "PositionManager.vala"
		plank_position_manager_update_draw_values (self, _tmp5_, NULL, NULL, NULL, NULL);
#line 2520 "PositionManager.c"
	}
#line 679 "PositionManager.vala"
	_tmp6_ = self->priv->draw_values;
#line 679 "PositionManager.vala"
	_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, (PlankDockElement*) item);
#line 679 "PositionManager.vala"
	draw_value = (PlankDockItemDrawValue*) _tmp7_;
#line 680 "PositionManager.vala"
	_tmp8_ = draw_value;
#line 680 "PositionManager.vala"
	if (_tmp8_ == NULL) {
#line 2532 "PositionManager.c"
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		PlankDockItemDrawValue* _tmp11_;
#line 681 "PositionManager.vala"
		_tmp9_ = plank_dock_element_get_Text ((PlankDockElement*) item);
#line 681 "PositionManager.vala"
		_tmp10_ = _tmp9_;
#line 681 "PositionManager.vala"
		g_warning ("PositionManager.vala:681: Without a draw_value there is trouble ahead " \
"for '%s'", _tmp10_);
#line 682 "PositionManager.vala"
		_tmp11_ = plank_dock_item_draw_value_new ();
#line 682 "PositionManager.vala"
		_plank_dock_item_draw_value_unref0 (draw_value);
#line 682 "PositionManager.vala"
		draw_value = _tmp11_;
#line 2548 "PositionManager.c"
	}
#line 685 "PositionManager.vala"
	result = draw_value;
#line 685 "PositionManager.vala"
	return result;
#line 2554 "PositionManager.c"
}

/**
 * Update and recalculated all internal draw-values using the given methodes for custom manipulations.
 *
 * @param items the ordered list of all current item which are suppose to be shown on the dock
 * @param func a function which adjusts the draw-value per item
 * @param post_func a function which post-processes all draw-values
 */
static gboolean
__lambda29_ (PlankPositionManager* self,
             PlankDockElement* i,
             PlankDockItemDrawValue* val)
{
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _tmp1_ = {0};
	GdkRectangle _tmp2_ = {0};
	gboolean result;
#line 893 "PositionManager.vala"
	g_return_val_if_fail (i != NULL, FALSE);
#line 893 "PositionManager.vala"
	g_return_val_if_fail (val != NULL, FALSE);
#line 894 "PositionManager.vala"
	plank_position_manager_get_item_draw_region (self, val, &_tmp0_);
#line 894 "PositionManager.vala"
	val->draw_region = _tmp0_;
#line 895 "PositionManager.vala"
	plank_position_manager_get_item_hover_region (self, val, &_tmp1_);
#line 895 "PositionManager.vala"
	val->hover_region = _tmp1_;
#line 896 "PositionManager.vala"
	plank_position_manager_get_item_background_region (self, val, &_tmp2_);
#line 896 "PositionManager.vala"
	val->background_region = _tmp2_;
#line 897 "PositionManager.vala"
	result = TRUE;
#line 897 "PositionManager.vala"
	return result;
#line 2593 "PositionManager.c"
}

static gboolean
___lambda29__gee_forall_map_func (gconstpointer k,
                                  gconstpointer v,
                                  gpointer self)
{
	gboolean result;
	result = __lambda29_ ((PlankPositionManager*) self, (PlankDockElement*) k, (PlankDockItemDrawValue*) v);
#line 893 "PositionManager.vala"
	return result;
#line 2605 "PositionManager.c"
}

void
plank_position_manager_update_draw_values (PlankPositionManager* self,
                                           GeeArrayList* items,
                                           PlankDrawValueFunc func,
                                           gpointer func_target,
                                           PlankDrawValuesFunc post_func,
                                           gpointer post_func_target)
{
	PlankDockPreferences* prefs = NULL;
	PlankDockController* _tmp0_;
	PlankDockPreferences* _tmp1_;
	PlankDockPreferences* _tmp2_;
	PlankDockRenderer* renderer = NULL;
	PlankDockController* _tmp3_;
	PlankDockRenderer* _tmp4_;
	PlankDockRenderer* _tmp5_;
	GeeHashMap* _tmp6_;
	gint width = 0;
	gint height = 0;
	gint icon_size = 0;
	gint _tmp7_;
	GdkPoint cursor = {0};
	PlankDockRenderer* _tmp8_;
	GdkPoint _tmp9_ = {0};
	GdkPoint _tmp10_;
	GtkPositionType _tmp11_;
	gdouble _tmp16_ = 0.0;
	gdouble center_y = 0.0;
	gdouble center_x = 0.0;
	gint _tmp19_;
	GtkAlign _tmp20_;
	PlankPointD center = {0};
	PlankPointD _tmp32_ = {0};
	gboolean _tmp33_ = FALSE;
	PlankDockController* _tmp34_;
	PlankDragManager* _tmp35_;
	PlankDragManager* _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp38_;
	gboolean expand_for_drop = FALSE;
	gboolean zoom_enabled = FALSE;
	PlankDockPreferences* _tmp42_;
	gboolean _tmp43_;
	gboolean _tmp44_;
	gdouble _tmp45_ = 0.0;
	gboolean _tmp46_ = FALSE;
	gdouble zoom_in_progress = 0.0;
	gdouble _tmp50_ = 0.0;
	gdouble zoom_in_percent = 0.0;
	gdouble zoom_icon_size = 0.0;
	gint _tmp51_;
	GeeHashMap* _tmp110_;
	gpointer _tmp111_;
	gpointer _tmp112_;
	PlankDockItemDrawValue* _tmp113_;
	GeeHashMap* _tmp114_;
	gpointer _tmp115_;
	gpointer _tmp116_;
	PlankDockItemDrawValue* _tmp117_;
	GeeHashMap* _tmp118_;
	GeeMapIterator* _tmp119_;
	GeeMapIterator* _tmp120_;
#line 695 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 695 "PositionManager.vala"
	g_return_if_fail (items != NULL);
#line 698 "PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 698 "PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_prefs (_tmp0_);
#line 698 "PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 698 "PositionManager.vala"
	prefs = _tmp2_;
#line 699 "PositionManager.vala"
	_tmp3_ = self->priv->_controller;
#line 699 "PositionManager.vala"
	_tmp4_ = plank_dock_controller_get_renderer (_tmp3_);
#line 699 "PositionManager.vala"
	_tmp5_ = _tmp4_;
#line 699 "PositionManager.vala"
	renderer = _tmp5_;
#line 701 "PositionManager.vala"
	_tmp6_ = self->priv->draw_values;
#line 701 "PositionManager.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp6_);
#line 706 "PositionManager.vala"
	width = self->priv->DockWidth;
#line 707 "PositionManager.vala"
	height = self->priv->DockHeight;
#line 708 "PositionManager.vala"
	_tmp7_ = self->priv->_IconSize;
#line 708 "PositionManager.vala"
	icon_size = _tmp7_;
#line 710 "PositionManager.vala"
	_tmp8_ = renderer;
#line 710 "PositionManager.vala"
	plank_dock_renderer_get_local_cursor (_tmp8_, &_tmp9_);
#line 710 "PositionManager.vala"
	_tmp10_ = _tmp9_;
#line 710 "PositionManager.vala"
	cursor = _tmp10_;
#line 713 "PositionManager.vala"
	_tmp11_ = self->priv->_Position;
#line 713 "PositionManager.vala"
	switch (_tmp11_) {
#line 713 "PositionManager.vala"
		case GTK_POS_RIGHT:
#line 2716 "PositionManager.c"
		{
			GdkPoint _tmp12_;
#line 715 "PositionManager.vala"
			_tmp12_ = cursor;
#line 715 "PositionManager.vala"
			cursor.x = width - _tmp12_.x;
#line 716 "PositionManager.vala"
			break;
#line 2725 "PositionManager.c"
		}
#line 713 "PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 2729 "PositionManager.c"
		{
			GdkPoint _tmp13_;
#line 718 "PositionManager.vala"
			_tmp13_ = cursor;
#line 718 "PositionManager.vala"
			cursor.y = height - _tmp13_.y;
#line 719 "PositionManager.vala"
			break;
#line 2738 "PositionManager.c"
		}
		default:
		{
#line 721 "PositionManager.vala"
			break;
#line 2744 "PositionManager.c"
		}
	}
#line 725 "PositionManager.vala"
	if (!plank_position_manager_is_horizontal_dock (self)) {
#line 2749 "PositionManager.c"
		gint tmp = 0;
		GdkPoint _tmp14_;
		GdkPoint _tmp15_;
#line 726 "PositionManager.vala"
		_tmp14_ = cursor;
#line 726 "PositionManager.vala"
		tmp = _tmp14_.y;
#line 727 "PositionManager.vala"
		_tmp15_ = cursor;
#line 727 "PositionManager.vala"
		cursor.y = _tmp15_.x;
#line 728 "PositionManager.vala"
		cursor.x = tmp;
#line 730 "PositionManager.vala"
		tmp = width;
#line 731 "PositionManager.vala"
		width = height;
#line 732 "PositionManager.vala"
		height = tmp;
#line 2769 "PositionManager.c"
	}
#line 737 "PositionManager.vala"
	if (plank_position_manager_is_horizontal_dock (self)) {
#line 2773 "PositionManager.c"
		GdkRectangle _tmp17_;
#line 737 "PositionManager.vala"
		_tmp17_ = self->priv->static_dock_region;
#line 737 "PositionManager.vala"
		_tmp16_ = _tmp17_.height / 2.0;
#line 2779 "PositionManager.c"
	} else {
		GdkRectangle _tmp18_;
#line 737 "PositionManager.vala"
		_tmp18_ = self->priv->static_dock_region;
#line 737 "PositionManager.vala"
		_tmp16_ = _tmp18_.width / 2.0;
#line 2786 "PositionManager.c"
	}
#line 737 "PositionManager.vala"
	center_y = _tmp16_;
#line 739 "PositionManager.vala"
	_tmp19_ = self->priv->_ItemPadding;
#line 739 "PositionManager.vala"
	center_x = ((icon_size + _tmp19_) / 2.0) + self->priv->items_offset;
#line 740 "PositionManager.vala"
	_tmp20_ = self->priv->_Alignment;
#line 740 "PositionManager.vala"
	if (_tmp20_ == GTK_ALIGN_FILL) {
#line 2798 "PositionManager.c"
		GtkAlign _tmp21_;
#line 741 "PositionManager.vala"
		_tmp21_ = self->priv->_ItemsAlignment;
#line 741 "PositionManager.vala"
		switch (_tmp21_) {
#line 2804 "PositionManager.c"
			default:
#line 741 "PositionManager.vala"
			case GTK_ALIGN_FILL:
#line 741 "PositionManager.vala"
			case GTK_ALIGN_CENTER:
#line 2810 "PositionManager.c"
			{
#line 745 "PositionManager.vala"
				if (plank_position_manager_is_horizontal_dock (self)) {
#line 2814 "PositionManager.c"
					GdkRectangle _tmp22_;
					GdkRectangle _tmp23_;
#line 746 "PositionManager.vala"
					_tmp22_ = self->priv->static_dock_region;
#line 746 "PositionManager.vala"
					_tmp23_ = self->priv->static_dock_region;
#line 746 "PositionManager.vala"
					center_x += (gdouble) (_tmp22_.x + (((_tmp23_.width - (2 * self->priv->items_offset)) - self->priv->items_width) / 2));
#line 2823 "PositionManager.c"
				} else {
					GdkRectangle _tmp24_;
					GdkRectangle _tmp25_;
#line 748 "PositionManager.vala"
					_tmp24_ = self->priv->static_dock_region;
#line 748 "PositionManager.vala"
					_tmp25_ = self->priv->static_dock_region;
#line 748 "PositionManager.vala"
					center_x += (gdouble) (_tmp24_.y + (((_tmp25_.height - (2 * self->priv->items_offset)) - self->priv->items_width) / 2));
#line 2833 "PositionManager.c"
				}
#line 749 "PositionManager.vala"
				break;
#line 2837 "PositionManager.c"
			}
#line 741 "PositionManager.vala"
			case GTK_ALIGN_START:
#line 2841 "PositionManager.c"
			{
#line 751 "PositionManager.vala"
				break;
#line 2845 "PositionManager.c"
			}
#line 741 "PositionManager.vala"
			case GTK_ALIGN_END:
#line 2849 "PositionManager.c"
			{
#line 753 "PositionManager.vala"
				if (plank_position_manager_is_horizontal_dock (self)) {
#line 2853 "PositionManager.c"
					GdkRectangle _tmp26_;
					GdkRectangle _tmp27_;
#line 754 "PositionManager.vala"
					_tmp26_ = self->priv->static_dock_region;
#line 754 "PositionManager.vala"
					_tmp27_ = self->priv->static_dock_region;
#line 754 "PositionManager.vala"
					center_x += (gdouble) (_tmp26_.x + ((_tmp27_.width - (2 * self->priv->items_offset)) - self->priv->items_width));
#line 2862 "PositionManager.c"
				} else {
					GdkRectangle _tmp28_;
					GdkRectangle _tmp29_;
#line 756 "PositionManager.vala"
					_tmp28_ = self->priv->static_dock_region;
#line 756 "PositionManager.vala"
					_tmp29_ = self->priv->static_dock_region;
#line 756 "PositionManager.vala"
					center_x += (gdouble) (_tmp28_.y + ((_tmp29_.height - (2 * self->priv->items_offset)) - self->priv->items_width));
#line 2872 "PositionManager.c"
				}
#line 757 "PositionManager.vala"
				break;
#line 2876 "PositionManager.c"
			}
		}
	} else {
#line 760 "PositionManager.vala"
		if (plank_position_manager_is_horizontal_dock (self)) {
#line 2882 "PositionManager.c"
			GdkRectangle _tmp30_;
#line 761 "PositionManager.vala"
			_tmp30_ = self->priv->static_dock_region;
#line 761 "PositionManager.vala"
			center_x += (gdouble) _tmp30_.x;
#line 2888 "PositionManager.c"
		} else {
			GdkRectangle _tmp31_;
#line 763 "PositionManager.vala"
			_tmp31_ = self->priv->static_dock_region;
#line 763 "PositionManager.vala"
			center_x += (gdouble) _tmp31_.y;
#line 2895 "PositionManager.c"
		}
	}
#line 766 "PositionManager.vala"
	_tmp32_.x = floor (center_x);
#line 766 "PositionManager.vala"
	_tmp32_.y = floor (center_y);
#line 766 "PositionManager.vala"
	center = _tmp32_;
#line 773 "PositionManager.vala"
	_tmp34_ = self->priv->_controller;
#line 773 "PositionManager.vala"
	_tmp35_ = plank_dock_controller_get_drag_manager (_tmp34_);
#line 773 "PositionManager.vala"
	_tmp36_ = _tmp35_;
#line 773 "PositionManager.vala"
	_tmp37_ = plank_drag_manager_get_ExternalDragActive (_tmp36_);
#line 773 "PositionManager.vala"
	_tmp38_ = _tmp37_;
#line 773 "PositionManager.vala"
	if (_tmp38_) {
#line 2916 "PositionManager.c"
		PlankDockPreferences* _tmp39_;
		gboolean _tmp40_;
		gboolean _tmp41_;
#line 773 "PositionManager.vala"
		_tmp39_ = prefs;
#line 773 "PositionManager.vala"
		_tmp40_ = plank_dock_preferences_get_LockItems (_tmp39_);
#line 773 "PositionManager.vala"
		_tmp41_ = _tmp40_;
#line 773 "PositionManager.vala"
		_tmp33_ = !_tmp41_;
#line 2928 "PositionManager.c"
	} else {
#line 773 "PositionManager.vala"
		_tmp33_ = FALSE;
#line 2932 "PositionManager.c"
	}
#line 773 "PositionManager.vala"
	expand_for_drop = _tmp33_;
#line 774 "PositionManager.vala"
	_tmp42_ = prefs;
#line 774 "PositionManager.vala"
	_tmp43_ = plank_dock_preferences_get_ZoomEnabled (_tmp42_);
#line 774 "PositionManager.vala"
	_tmp44_ = _tmp43_;
#line 774 "PositionManager.vala"
	zoom_enabled = _tmp44_;
#line 775 "PositionManager.vala"
	if (zoom_enabled) {
#line 775 "PositionManager.vala"
		_tmp46_ = TRUE;
#line 2948 "PositionManager.c"
	} else {
#line 775 "PositionManager.vala"
		_tmp46_ = expand_for_drop;
#line 2952 "PositionManager.c"
	}
#line 775 "PositionManager.vala"
	if (_tmp46_) {
#line 2956 "PositionManager.c"
		PlankDockRenderer* _tmp47_;
		gdouble _tmp48_;
		gdouble _tmp49_;
#line 775 "PositionManager.vala"
		_tmp47_ = renderer;
#line 775 "PositionManager.vala"
		_tmp48_ = plank_dock_renderer_get_zoom_in_progress (_tmp47_);
#line 775 "PositionManager.vala"
		_tmp49_ = _tmp48_;
#line 775 "PositionManager.vala"
		_tmp45_ = _tmp49_;
#line 2968 "PositionManager.c"
	} else {
#line 775 "PositionManager.vala"
		_tmp45_ = 0.0;
#line 2972 "PositionManager.c"
	}
#line 775 "PositionManager.vala"
	zoom_in_progress = _tmp45_;
#line 776 "PositionManager.vala"
	if (zoom_enabled) {
#line 776 "PositionManager.vala"
		_tmp50_ = 1.0 + ((self->priv->ZoomPercent - 1.0) * zoom_in_progress);
#line 2980 "PositionManager.c"
	} else {
#line 776 "PositionManager.vala"
		_tmp50_ = 1.0;
#line 2984 "PositionManager.c"
	}
#line 776 "PositionManager.vala"
	zoom_in_percent = _tmp50_;
#line 777 "PositionManager.vala"
	_tmp51_ = self->priv->_ZoomIconSize;
#line 777 "PositionManager.vala"
	zoom_icon_size = (gdouble) _tmp51_;
#line 2992 "PositionManager.c"
	{
		GeeArrayList* _item_list = NULL;
		gint _item_size = 0;
		GeeArrayList* _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
		gint _item_index = 0;
#line 779 "PositionManager.vala"
		_item_list = items;
#line 779 "PositionManager.vala"
		_tmp52_ = _item_list;
#line 779 "PositionManager.vala"
		_tmp53_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp52_);
#line 779 "PositionManager.vala"
		_tmp54_ = _tmp53_;
#line 779 "PositionManager.vala"
		_item_size = _tmp54_;
#line 779 "PositionManager.vala"
		_item_index = -1;
#line 779 "PositionManager.vala"
		while (TRUE) {
#line 3014 "PositionManager.c"
			gint _tmp55_;
			gint _tmp56_;
			PlankDockItem* item = NULL;
			GeeArrayList* _tmp57_;
			gpointer _tmp58_;
			PlankDockItemDrawValue* val = NULL;
			PlankDockItemDrawValue* _tmp59_;
			PlankDockItemDrawValue* _tmp60_;
			PlankDockItemDrawValue* _tmp61_;
			PlankDockItemDrawValue* _tmp62_;
			PlankDockItemDrawValue* _tmp63_;
			PlankDockItemDrawValue* _tmp64_;
			PlankDockItemDrawValue* _tmp65_;
			PlankPointD _tmp66_;
			gdouble cursor_position = 0.0;
			GdkPoint _tmp67_;
			gdouble center_position = 0.0;
			PlankPointD _tmp68_;
			gdouble offset = 0.0;
			gdouble offset_percent = 0.0;
			gdouble zoom = 0.0;
			gdouble zoomed_center_height = 0.0;
			PlankDockItemDrawValue* _tmp69_;
			PlankPointD _tmp70_ = {0};
			PlankDockItemDrawValue* _tmp71_;
			PlankDockItemDrawValue* _tmp72_;
			GtkPositionType _tmp85_;
			PlankDockItemDrawValue* _tmp98_;
			GtkPositionType _tmp99_;
			GeeHashMap* _tmp102_;
			PlankDockItem* _tmp103_;
			PlankDockItemDrawValue* _tmp104_;
			PlankDockItem* _tmp105_;
			gint64 _tmp106_;
			gint64 _tmp107_;
#line 779 "PositionManager.vala"
			_item_index = _item_index + 1;
#line 779 "PositionManager.vala"
			_tmp55_ = _item_index;
#line 779 "PositionManager.vala"
			_tmp56_ = _item_size;
#line 779 "PositionManager.vala"
			if (!(_tmp55_ < _tmp56_)) {
#line 779 "PositionManager.vala"
				break;
#line 3060 "PositionManager.c"
			}
#line 779 "PositionManager.vala"
			_tmp57_ = _item_list;
#line 779 "PositionManager.vala"
			_tmp58_ = gee_abstract_list_get ((GeeAbstractList*) _tmp57_, _item_index);
#line 779 "PositionManager.vala"
			item = (PlankDockItem*) _tmp58_;
#line 780 "PositionManager.vala"
			_tmp59_ = plank_dock_item_draw_value_new ();
#line 780 "PositionManager.vala"
			val = _tmp59_;
#line 781 "PositionManager.vala"
			_tmp60_ = val;
#line 781 "PositionManager.vala"
			_tmp60_->opacity = 1.0;
#line 782 "PositionManager.vala"
			_tmp61_ = val;
#line 782 "PositionManager.vala"
			_tmp61_->darken = 0.0;
#line 783 "PositionManager.vala"
			_tmp62_ = val;
#line 783 "PositionManager.vala"
			_tmp62_->lighten = 0.0;
#line 784 "PositionManager.vala"
			_tmp63_ = val;
#line 784 "PositionManager.vala"
			_tmp63_->show_indicator = TRUE;
#line 785 "PositionManager.vala"
			_tmp64_ = val;
#line 785 "PositionManager.vala"
			_tmp64_->zoom = 1.0;
#line 787 "PositionManager.vala"
			_tmp65_ = val;
#line 787 "PositionManager.vala"
			_tmp66_ = center;
#line 787 "PositionManager.vala"
			_tmp65_->static_center = _tmp66_;
#line 790 "PositionManager.vala"
			_tmp67_ = cursor;
#line 790 "PositionManager.vala"
			cursor_position = (gdouble) _tmp67_.x;
#line 791 "PositionManager.vala"
			_tmp68_ = center;
#line 791 "PositionManager.vala"
			center_position = _tmp68_.x;
#line 794 "PositionManager.vala"
			offset = MIN (fabs (cursor_position - center_position), zoom_icon_size);
#line 797 "PositionManager.vala"
			if (expand_for_drop) {
#line 799 "PositionManager.vala"
				offset += (offset * zoom_icon_size) / icon_size;
#line 800 "PositionManager.vala"
				offset_percent = MIN (1.0, offset / (2.0 * zoom_icon_size));
#line 3114 "PositionManager.c"
			} else {
#line 802 "PositionManager.vala"
				offset_percent = offset / zoom_icon_size;
#line 3118 "PositionManager.c"
			}
#line 805 "PositionManager.vala"
			if (offset_percent > 0.99) {
#line 806 "PositionManager.vala"
				offset_percent = 1.0;
#line 3124 "PositionManager.c"
			}
#line 818 "PositionManager.vala"
			if (expand_for_drop) {
#line 819 "PositionManager.vala"
				offset *= zoom_in_progress / 2.0;
#line 3130 "PositionManager.c"
			} else {
#line 821 "PositionManager.vala"
				offset *= zoom_in_percent - 1.0;
#line 3134 "PositionManager.c"
			}
#line 822 "PositionManager.vala"
			offset *= 1.0 - (offset_percent / 3.0);
#line 824 "PositionManager.vala"
			if (cursor_position > center_position) {
#line 825 "PositionManager.vala"
				center_position -= offset;
#line 3142 "PositionManager.c"
			} else {
#line 827 "PositionManager.vala"
				center_position += offset;
#line 3146 "PositionManager.c"
			}
#line 834 "PositionManager.vala"
			zoom = 1.0 - pow (offset_percent, (gdouble) 2);
#line 837 "PositionManager.vala"
			zoom = 1.0 + (zoom * (zoom_in_percent - 1.0));
#line 839 "PositionManager.vala"
			zoomed_center_height = (icon_size * zoom) / 2.0;
#line 841 "PositionManager.vala"
			if (zoom == 1.0) {
#line 842 "PositionManager.vala"
				center_position = round (center_position);
#line 3158 "PositionManager.c"
			}
#line 844 "PositionManager.vala"
			_tmp69_ = val;
#line 844 "PositionManager.vala"
			_tmp70_.x = center_position;
#line 844 "PositionManager.vala"
			_tmp70_.y = zoomed_center_height;
#line 844 "PositionManager.vala"
			_tmp69_->center = _tmp70_;
#line 845 "PositionManager.vala"
			_tmp71_ = val;
#line 845 "PositionManager.vala"
			_tmp71_->zoom = zoom;
#line 846 "PositionManager.vala"
			_tmp72_ = val;
#line 846 "PositionManager.vala"
			_tmp72_->icon_size = round (zoom * icon_size);
#line 849 "PositionManager.vala"
			if (!plank_position_manager_is_horizontal_dock (self)) {
#line 3178 "PositionManager.c"
				gdouble tmp = 0.0;
				PlankDockItemDrawValue* _tmp73_;
				PlankPointD _tmp74_;
				PlankDockItemDrawValue* _tmp75_;
				PlankDockItemDrawValue* _tmp76_;
				PlankPointD _tmp77_;
				PlankDockItemDrawValue* _tmp78_;
				PlankDockItemDrawValue* _tmp79_;
				PlankPointD _tmp80_;
				PlankDockItemDrawValue* _tmp81_;
				PlankDockItemDrawValue* _tmp82_;
				PlankPointD _tmp83_;
				PlankDockItemDrawValue* _tmp84_;
#line 850 "PositionManager.vala"
				_tmp73_ = val;
#line 850 "PositionManager.vala"
				_tmp74_ = _tmp73_->center;
#line 850 "PositionManager.vala"
				tmp = _tmp74_.y;
#line 851 "PositionManager.vala"
				_tmp75_ = val;
#line 851 "PositionManager.vala"
				_tmp76_ = val;
#line 851 "PositionManager.vala"
				_tmp77_ = _tmp76_->center;
#line 851 "PositionManager.vala"
				_tmp75_->center.y = _tmp77_.x;
#line 852 "PositionManager.vala"
				_tmp78_ = val;
#line 852 "PositionManager.vala"
				_tmp78_->center.x = tmp;
#line 854 "PositionManager.vala"
				_tmp79_ = val;
#line 854 "PositionManager.vala"
				_tmp80_ = _tmp79_->static_center;
#line 854 "PositionManager.vala"
				tmp = _tmp80_.y;
#line 855 "PositionManager.vala"
				_tmp81_ = val;
#line 855 "PositionManager.vala"
				_tmp82_ = val;
#line 855 "PositionManager.vala"
				_tmp83_ = _tmp82_->static_center;
#line 855 "PositionManager.vala"
				_tmp81_->static_center.y = _tmp83_.x;
#line 856 "PositionManager.vala"
				_tmp84_ = val;
#line 856 "PositionManager.vala"
				_tmp84_->static_center.x = tmp;
#line 3228 "PositionManager.c"
			}
#line 859 "PositionManager.vala"
			_tmp85_ = self->priv->_Position;
#line 859 "PositionManager.vala"
			switch (_tmp85_) {
#line 859 "PositionManager.vala"
				case GTK_POS_RIGHT:
#line 3236 "PositionManager.c"
				{
					PlankDockItemDrawValue* _tmp86_;
					PlankDockItemDrawValue* _tmp87_;
					PlankPointD _tmp88_;
					PlankDockItemDrawValue* _tmp89_;
					PlankDockItemDrawValue* _tmp90_;
					PlankPointD _tmp91_;
#line 861 "PositionManager.vala"
					_tmp86_ = val;
#line 861 "PositionManager.vala"
					_tmp87_ = val;
#line 861 "PositionManager.vala"
					_tmp88_ = _tmp87_->center;
#line 861 "PositionManager.vala"
					_tmp86_->center.x = height - _tmp88_.x;
#line 862 "PositionManager.vala"
					_tmp89_ = val;
#line 862 "PositionManager.vala"
					_tmp90_ = val;
#line 862 "PositionManager.vala"
					_tmp91_ = _tmp90_->static_center;
#line 862 "PositionManager.vala"
					_tmp89_->static_center.x = height - _tmp91_.x;
#line 863 "PositionManager.vala"
					break;
#line 3262 "PositionManager.c"
				}
#line 859 "PositionManager.vala"
				case GTK_POS_BOTTOM:
#line 3266 "PositionManager.c"
				{
					PlankDockItemDrawValue* _tmp92_;
					PlankDockItemDrawValue* _tmp93_;
					PlankPointD _tmp94_;
					PlankDockItemDrawValue* _tmp95_;
					PlankDockItemDrawValue* _tmp96_;
					PlankPointD _tmp97_;
#line 865 "PositionManager.vala"
					_tmp92_ = val;
#line 865 "PositionManager.vala"
					_tmp93_ = val;
#line 865 "PositionManager.vala"
					_tmp94_ = _tmp93_->center;
#line 865 "PositionManager.vala"
					_tmp92_->center.y = height - _tmp94_.y;
#line 866 "PositionManager.vala"
					_tmp95_ = val;
#line 866 "PositionManager.vala"
					_tmp96_ = val;
#line 866 "PositionManager.vala"
					_tmp97_ = _tmp96_->static_center;
#line 866 "PositionManager.vala"
					_tmp95_->static_center.y = height - _tmp97_.y;
#line 867 "PositionManager.vala"
					break;
#line 3292 "PositionManager.c"
				}
				default:
				{
#line 869 "PositionManager.vala"
					break;
#line 3298 "PositionManager.c"
				}
			}
#line 873 "PositionManager.vala"
			_tmp98_ = val;
#line 873 "PositionManager.vala"
			_tmp99_ = self->priv->_Position;
#line 873 "PositionManager.vala"
			plank_dock_item_draw_value_move_in (_tmp98_, _tmp99_, (gdouble) self->priv->bottom_offset);
#line 876 "PositionManager.vala"
			if (func != NULL) {
#line 3309 "PositionManager.c"
				PlankDockItem* _tmp100_;
				PlankDockItemDrawValue* _tmp101_;
#line 877 "PositionManager.vala"
				_tmp100_ = item;
#line 877 "PositionManager.vala"
				_tmp101_ = val;
#line 877 "PositionManager.vala"
				func (_tmp100_, _tmp101_, func_target);
#line 3318 "PositionManager.c"
			}
#line 879 "PositionManager.vala"
			_tmp102_ = self->priv->draw_values;
#line 879 "PositionManager.vala"
			_tmp103_ = item;
#line 879 "PositionManager.vala"
			_tmp104_ = val;
#line 879 "PositionManager.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp102_, (PlankDockElement*) _tmp103_, _tmp104_);
#line 883 "PositionManager.vala"
			_tmp105_ = item;
#line 883 "PositionManager.vala"
			_tmp106_ = plank_dock_element_get_RemoveTime ((PlankDockElement*) _tmp105_);
#line 883 "PositionManager.vala"
			_tmp107_ = _tmp106_;
#line 883 "PositionManager.vala"
			if (_tmp107_ == ((gint64) 0)) {
#line 3336 "PositionManager.c"
				gint _tmp108_;
#line 884 "PositionManager.vala"
				_tmp108_ = self->priv->_ItemPadding;
#line 884 "PositionManager.vala"
				center.x = center.x + (icon_size + _tmp108_);
#line 3342 "PositionManager.c"
			}
#line 779 "PositionManager.vala"
			_plank_dock_item_draw_value_unref0 (val);
#line 3346 "PositionManager.c"
		}
	}
#line 887 "PositionManager.vala"
	if (post_func != NULL) {
#line 3351 "PositionManager.c"
		GeeHashMap* _tmp109_;
#line 888 "PositionManager.vala"
		_tmp109_ = self->priv->draw_values;
#line 888 "PositionManager.vala"
		post_func (_tmp109_, post_func_target);
#line 3357 "PositionManager.c"
	}
#line 890 "PositionManager.vala"
	_tmp110_ = self->priv->draw_values;
#line 890 "PositionManager.vala"
	_tmp111_ = gee_list_first ((GeeList*) items);
#line 890 "PositionManager.vala"
	_tmp112_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp110_, (PlankDockElement*) ((PlankDockItem*) _tmp111_));
#line 890 "PositionManager.vala"
	_tmp113_ = (PlankDockItemDrawValue*) _tmp112_;
#line 890 "PositionManager.vala"
	_tmp114_ = self->priv->draw_values;
#line 890 "PositionManager.vala"
	_tmp115_ = gee_list_last ((GeeList*) items);
#line 890 "PositionManager.vala"
	_tmp116_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp114_, (PlankDockElement*) ((PlankDockItem*) _tmp115_));
#line 890 "PositionManager.vala"
	_tmp117_ = (PlankDockItemDrawValue*) _tmp116_;
#line 890 "PositionManager.vala"
	plank_position_manager_update_background_region (self, _tmp113_, _tmp117_);
#line 890 "PositionManager.vala"
	_plank_dock_item_draw_value_unref0 (_tmp117_);
#line 890 "PositionManager.vala"
	_plank_dock_item_draw_value_unref0 (_tmp113_);
#line 893 "PositionManager.vala"
	_tmp118_ = self->priv->draw_values;
#line 893 "PositionManager.vala"
	_tmp119_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _tmp118_);
#line 893 "PositionManager.vala"
	_tmp120_ = _tmp119_;
#line 893 "PositionManager.vala"
	gee_map_iterator_foreach (_tmp120_, ___lambda29__gee_forall_map_func, self);
#line 893 "PositionManager.vala"
	_g_object_unref0 (_tmp120_);
#line 3391 "PositionManager.c"
}

/**
 * The region for drawing a dock item.
 *
 * @param val the item's DockItemDrawValue
 * @return the region for the dock item
 */
static void
plank_position_manager_get_item_draw_region (PlankPositionManager* self,
                                             PlankDockItemDrawValue* val,
                                             GdkRectangle* result)
{
	gdouble width = 0.0;
	gdouble height = 0.0;
	PlankPointD _tmp0_;
	PlankPointD _tmp1_;
	GdkRectangle _tmp2_ = {0};
#line 906 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 906 "PositionManager.vala"
	g_return_if_fail (val != NULL);
#line 908 "PositionManager.vala"
	width = val->icon_size;
#line 908 "PositionManager.vala"
	height = val->icon_size;
#line 910 "PositionManager.vala"
	_tmp0_ = val->center;
#line 910 "PositionManager.vala"
	_tmp1_ = val->center;
#line 910 "PositionManager.vala"
	_tmp2_.x = (gint) round (_tmp0_.x - (width / 2.0));
#line 910 "PositionManager.vala"
	_tmp2_.y = (gint) round (_tmp1_.y - (height / 2.0));
#line 910 "PositionManager.vala"
	_tmp2_.width = (gint) width;
#line 910 "PositionManager.vala"
	_tmp2_.height = (gint) height;
#line 910 "PositionManager.vala"
	*result = _tmp2_;
#line 910 "PositionManager.vala"
	return;
#line 3434 "PositionManager.c"
}

/**
 * The intersecting region of a dock item's hover region and the background.
 *
 * @param val the item's DockItemDrawValue
 * @return the region for the dock item
 */
static void
plank_position_manager_get_item_background_region (PlankPositionManager* self,
                                                   PlankDockItemDrawValue* val,
                                                   GdkRectangle* result)
{
	GdkRectangle rect = {0};
	GdkRectangle hover_region = {0};
	GdkRectangle _tmp0_;
	GtkPositionType _tmp1_;
	GdkRectangle _tmp16_;
	GdkRectangle _tmp17_ = {0};
	gboolean _tmp18_;
#line 922 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 922 "PositionManager.vala"
	g_return_if_fail (val != NULL);
#line 925 "PositionManager.vala"
	_tmp0_ = val->hover_region;
#line 925 "PositionManager.vala"
	hover_region = _tmp0_;
#line 928 "PositionManager.vala"
	_tmp1_ = self->priv->_Position;
#line 928 "PositionManager.vala"
	switch (_tmp1_) {
#line 3467 "PositionManager.c"
		default:
#line 928 "PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 3471 "PositionManager.c"
		{
			GdkRectangle _tmp2_;
			GdkRectangle _tmp3_;
			GdkRectangle _tmp4_;
#line 931 "PositionManager.vala"
			_tmp2_ = self->priv->background_rect;
#line 931 "PositionManager.vala"
			_tmp3_ = self->priv->background_rect;
#line 931 "PositionManager.vala"
			_tmp4_ = hover_region;
#line 931 "PositionManager.vala"
			hover_region.height = abs ((_tmp2_.y + _tmp3_.height) - _tmp4_.y);
#line 932 "PositionManager.vala"
			break;
#line 3486 "PositionManager.c"
		}
#line 928 "PositionManager.vala"
		case GTK_POS_TOP:
#line 3490 "PositionManager.c"
		{
			GdkRectangle _tmp5_;
			GdkRectangle _tmp6_;
			GdkRectangle _tmp7_;
			GdkRectangle _tmp8_;
#line 934 "PositionManager.vala"
			_tmp5_ = self->priv->background_rect;
#line 934 "PositionManager.vala"
			hover_region.y = _tmp5_.y;
#line 935 "PositionManager.vala"
			_tmp6_ = hover_region;
#line 935 "PositionManager.vala"
			_tmp7_ = self->priv->background_rect;
#line 935 "PositionManager.vala"
			_tmp8_ = self->priv->background_rect;
#line 935 "PositionManager.vala"
			hover_region.height = abs ((_tmp6_.y - _tmp7_.y) + _tmp8_.height);
#line 936 "PositionManager.vala"
			break;
#line 3510 "PositionManager.c"
		}
#line 928 "PositionManager.vala"
		case GTK_POS_LEFT:
#line 3514 "PositionManager.c"
		{
			GdkRectangle _tmp9_;
			GdkRectangle _tmp10_;
			GdkRectangle _tmp11_;
			GdkRectangle _tmp12_;
#line 938 "PositionManager.vala"
			_tmp9_ = self->priv->background_rect;
#line 938 "PositionManager.vala"
			hover_region.x = _tmp9_.x;
#line 939 "PositionManager.vala"
			_tmp10_ = hover_region;
#line 939 "PositionManager.vala"
			_tmp11_ = self->priv->background_rect;
#line 939 "PositionManager.vala"
			_tmp12_ = self->priv->background_rect;
#line 939 "PositionManager.vala"
			hover_region.width = abs ((_tmp10_.x - _tmp11_.x) + _tmp12_.width);
#line 940 "PositionManager.vala"
			break;
#line 3534 "PositionManager.c"
		}
#line 928 "PositionManager.vala"
		case GTK_POS_RIGHT:
#line 3538 "PositionManager.c"
		{
			GdkRectangle _tmp13_;
			GdkRectangle _tmp14_;
			GdkRectangle _tmp15_;
#line 942 "PositionManager.vala"
			_tmp13_ = self->priv->background_rect;
#line 942 "PositionManager.vala"
			_tmp14_ = self->priv->background_rect;
#line 942 "PositionManager.vala"
			_tmp15_ = hover_region;
#line 942 "PositionManager.vala"
			hover_region.width = abs ((_tmp13_.x + _tmp14_.width) - _tmp15_.x);
#line 943 "PositionManager.vala"
			break;
#line 3553 "PositionManager.c"
		}
	}
#line 946 "PositionManager.vala"
	_tmp16_ = self->priv->background_rect;
#line 946 "PositionManager.vala"
	_tmp18_ = gdk_rectangle_intersect (&hover_region, &_tmp16_, &_tmp17_);
#line 946 "PositionManager.vala"
	rect = _tmp17_;
#line 946 "PositionManager.vala"
	if (!_tmp18_) {
#line 3564 "PositionManager.c"
		GdkRectangle _tmp19_ = {0};
#line 947 "PositionManager.vala"
		*result = _tmp19_;
#line 947 "PositionManager.vala"
		return;
#line 3570 "PositionManager.c"
	}
#line 949 "PositionManager.vala"
	*result = rect;
#line 949 "PositionManager.vala"
	return;
#line 3576 "PositionManager.c"
}

/**
 * The cursor region for interacting with a dock element.
 *
 * @param val the item's DockItemDrawValue
 * @return the region for the dock item
 */
static void
plank_position_manager_get_item_hover_region (PlankPositionManager* self,
                                              PlankDockItemDrawValue* val,
                                              GdkRectangle* result)
{
	GdkRectangle rect = {0};
	gint item_padding = 0;
	gint _tmp0_;
	gint _tmp1_ = 0;
	gint top_padding = 0;
	gint bottom_padding = 0;
	gdouble width = 0.0;
	gdouble height = 0.0;
	GtkPositionType _tmp2_;
	PlankPointD _tmp3_;
	PlankPointD _tmp4_;
	GdkRectangle _tmp5_ = {0};
	GtkPositionType _tmp6_;
	GdkRectangle background_region = {0};
	GdkRectangle _tmp7_ = {0};
	GdkRectangle _tmp8_ = {0};
	gboolean _tmp9_;
#line 958 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 958 "PositionManager.vala"
	g_return_if_fail (val != NULL);
#line 962 "PositionManager.vala"
	_tmp0_ = self->priv->_ItemPadding;
#line 962 "PositionManager.vala"
	item_padding = _tmp0_;
#line 963 "PositionManager.vala"
	if (self->priv->top_offset < 0) {
#line 963 "PositionManager.vala"
		_tmp1_ = 0;
#line 3619 "PositionManager.c"
	} else {
#line 963 "PositionManager.vala"
		_tmp1_ = self->priv->top_offset;
#line 3623 "PositionManager.c"
	}
#line 963 "PositionManager.vala"
	top_padding = _tmp1_;
#line 964 "PositionManager.vala"
	bottom_padding = self->priv->bottom_offset;
#line 965 "PositionManager.vala"
	width = val->icon_size;
#line 965 "PositionManager.vala"
	height = val->icon_size;
#line 968 "PositionManager.vala"
	_tmp2_ = self->priv->_Position;
#line 968 "PositionManager.vala"
	switch (_tmp2_) {
#line 3637 "PositionManager.c"
		default:
#line 968 "PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 3641 "PositionManager.c"
		{
#line 971 "PositionManager.vala"
			width += (gdouble) item_padding;
#line 972 "PositionManager.vala"
			break;
#line 3647 "PositionManager.c"
		}
#line 968 "PositionManager.vala"
		case GTK_POS_TOP:
#line 3651 "PositionManager.c"
		{
#line 974 "PositionManager.vala"
			width += (gdouble) item_padding;
#line 975 "PositionManager.vala"
			break;
#line 3657 "PositionManager.c"
		}
#line 968 "PositionManager.vala"
		case GTK_POS_LEFT:
#line 3661 "PositionManager.c"
		{
#line 977 "PositionManager.vala"
			height += (gdouble) item_padding;
#line 978 "PositionManager.vala"
			break;
#line 3667 "PositionManager.c"
		}
#line 968 "PositionManager.vala"
		case GTK_POS_RIGHT:
#line 3671 "PositionManager.c"
		{
#line 980 "PositionManager.vala"
			height += (gdouble) item_padding;
#line 981 "PositionManager.vala"
			break;
#line 3677 "PositionManager.c"
		}
	}
#line 984 "PositionManager.vala"
	_tmp3_ = val->center;
#line 984 "PositionManager.vala"
	_tmp4_ = val->center;
#line 984 "PositionManager.vala"
	_tmp5_.x = (gint) round (_tmp3_.x - (width / 2.0));
#line 984 "PositionManager.vala"
	_tmp5_.y = (gint) round (_tmp4_.y - (height / 2.0));
#line 984 "PositionManager.vala"
	_tmp5_.width = (gint) width;
#line 984 "PositionManager.vala"
	_tmp5_.height = (gint) height;
#line 984 "PositionManager.vala"
	rect = _tmp5_;
#line 990 "PositionManager.vala"
	_tmp6_ = self->priv->_Position;
#line 990 "PositionManager.vala"
	switch (_tmp6_) {
#line 3698 "PositionManager.c"
		default:
#line 990 "PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 3702 "PositionManager.c"
		{
#line 993 "PositionManager.vala"
			rect.y = rect.y - top_padding;
#line 994 "PositionManager.vala"
			rect.height = rect.height + (bottom_padding + top_padding);
#line 995 "PositionManager.vala"
			break;
#line 3710 "PositionManager.c"
		}
#line 990 "PositionManager.vala"
		case GTK_POS_TOP:
#line 3714 "PositionManager.c"
		{
#line 997 "PositionManager.vala"
			rect.y = rect.y - bottom_padding;
#line 998 "PositionManager.vala"
			rect.height = rect.height + (bottom_padding + top_padding);
#line 999 "PositionManager.vala"
			break;
#line 3722 "PositionManager.c"
		}
#line 990 "PositionManager.vala"
		case GTK_POS_LEFT:
#line 3726 "PositionManager.c"
		{
#line 1001 "PositionManager.vala"
			rect.x = rect.x - bottom_padding;
#line 1002 "PositionManager.vala"
			rect.width = rect.width + (bottom_padding + top_padding);
#line 1003 "PositionManager.vala"
			break;
#line 3734 "PositionManager.c"
		}
#line 990 "PositionManager.vala"
		case GTK_POS_RIGHT:
#line 3738 "PositionManager.c"
		{
#line 1005 "PositionManager.vala"
			rect.x = rect.x - top_padding;
#line 1006 "PositionManager.vala"
			rect.width = rect.width + (bottom_padding + top_padding);
#line 1007 "PositionManager.vala"
			break;
#line 3746 "PositionManager.c"
		}
	}
#line 1012 "PositionManager.vala"
	plank_position_manager_get_background_region (self, &_tmp7_);
#line 1012 "PositionManager.vala"
	_tmp9_ = gdk_rectangle_intersect (&rect, &_tmp7_, &_tmp8_);
#line 1012 "PositionManager.vala"
	background_region = _tmp8_;
#line 1012 "PositionManager.vala"
	if (_tmp9_) {
#line 3757 "PositionManager.c"
		GdkRectangle _tmp10_ = {0};
		GdkRectangle _tmp11_ = {0};
#line 1013 "PositionManager.vala"
		plank_position_manager_get_item_draw_region (self, val, &_tmp10_);
#line 1013 "PositionManager.vala"
		gdk_rectangle_union (&background_region, &_tmp10_, &_tmp11_);
#line 1013 "PositionManager.vala"
		rect = _tmp11_;
#line 3766 "PositionManager.c"
	}
#line 1015 "PositionManager.vala"
	*result = rect;
#line 1015 "PositionManager.vala"
	return;
#line 3772 "PositionManager.c"
}

/**
 * The cursor region for interacting with a dock element.
 *
 * @param element the dock element to find a region for
 * @return the region for the dock item
 */
void
plank_position_manager_get_hover_region_for_element (PlankPositionManager* self,
                                                     PlankDockElement* element,
                                                     GdkRectangle* result)
{
	PlankDockItem* item = NULL;
	PlankDockItem* _tmp0_;
	PlankDockContainer* container = NULL;
	PlankDockContainer* _tmp6_;
	GeeArrayList* items = NULL;
	PlankDockContainer* _tmp8_;
	GeeArrayList* _tmp9_;
	GeeArrayList* _tmp10_;
	GeeArrayList* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	GdkRectangle first_rect = {0};
	GeeArrayList* _tmp15_;
	gpointer _tmp16_;
	PlankDockElement* _tmp17_;
	GdkRectangle _tmp18_ = {0};
	GdkRectangle _tmp19_;
	GeeArrayList* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	GdkRectangle last_rect = {0};
	GeeArrayList* _tmp23_;
	gpointer _tmp24_;
	PlankDockElement* _tmp25_;
	GdkRectangle _tmp26_ = {0};
	GdkRectangle _tmp27_;
	GdkRectangle _result_ = {0};
	GdkRectangle _tmp28_;
	GdkRectangle _tmp29_ = {0};
#line 1024 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1024 "PositionManager.vala"
	g_return_if_fail (element != NULL);
#line 1026 "PositionManager.vala"
	item = PLANK_IS_DOCK_ITEM (element) ? ((PlankDockItem*) element) : NULL;
#line 1027 "PositionManager.vala"
	_tmp0_ = item;
#line 1027 "PositionManager.vala"
	if (_tmp0_ != NULL) {
#line 3825 "PositionManager.c"
		PlankDockItem* _tmp1_;
		PlankDockItemDrawValue* _tmp2_;
		PlankDockItemDrawValue* _tmp3_;
		GdkRectangle _tmp4_;
		GdkRectangle _tmp5_;
#line 1028 "PositionManager.vala"
		_tmp1_ = item;
#line 1028 "PositionManager.vala"
		_tmp2_ = plank_position_manager_get_draw_value_for_item (self, _tmp1_);
#line 1028 "PositionManager.vala"
		_tmp3_ = _tmp2_;
#line 1028 "PositionManager.vala"
		_tmp4_ = _tmp3_->hover_region;
#line 1028 "PositionManager.vala"
		_tmp5_ = _tmp4_;
#line 1028 "PositionManager.vala"
		_plank_dock_item_draw_value_unref0 (_tmp3_);
#line 1028 "PositionManager.vala"
		*result = _tmp5_;
#line 1028 "PositionManager.vala"
		return;
#line 3847 "PositionManager.c"
	}
#line 1030 "PositionManager.vala"
	container = PLANK_IS_DOCK_CONTAINER (element) ? ((PlankDockContainer*) element) : NULL;
#line 1031 "PositionManager.vala"
	_tmp6_ = container;
#line 1031 "PositionManager.vala"
	if (_tmp6_ == NULL) {
#line 3855 "PositionManager.c"
		GdkRectangle _tmp7_ = {0};
#line 1032 "PositionManager.vala"
		*result = _tmp7_;
#line 1032 "PositionManager.vala"
		return;
#line 3861 "PositionManager.c"
	}
#line 1034 "PositionManager.vala"
	_tmp8_ = container;
#line 1034 "PositionManager.vala"
	_tmp9_ = plank_dock_container_get_VisibleElements (_tmp8_);
#line 1034 "PositionManager.vala"
	_tmp10_ = _tmp9_;
#line 1034 "PositionManager.vala"
	items = _tmp10_;
#line 1036 "PositionManager.vala"
	_tmp11_ = items;
#line 1036 "PositionManager.vala"
	_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 1036 "PositionManager.vala"
	_tmp13_ = _tmp12_;
#line 1036 "PositionManager.vala"
	if (_tmp13_ == 0) {
#line 3879 "PositionManager.c"
		GdkRectangle _tmp14_ = {0};
#line 1037 "PositionManager.vala"
		*result = _tmp14_;
#line 1037 "PositionManager.vala"
		return;
#line 3885 "PositionManager.c"
	}
#line 1039 "PositionManager.vala"
	_tmp15_ = items;
#line 1039 "PositionManager.vala"
	_tmp16_ = gee_list_first ((GeeList*) _tmp15_);
#line 1039 "PositionManager.vala"
	_tmp17_ = (PlankDockElement*) _tmp16_;
#line 1039 "PositionManager.vala"
	plank_position_manager_get_hover_region_for_element (self, _tmp17_, &_tmp18_);
#line 1039 "PositionManager.vala"
	_tmp19_ = _tmp18_;
#line 1039 "PositionManager.vala"
	_g_object_unref0 (_tmp17_);
#line 1039 "PositionManager.vala"
	first_rect = _tmp19_;
#line 1040 "PositionManager.vala"
	_tmp20_ = items;
#line 1040 "PositionManager.vala"
	_tmp21_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp20_);
#line 1040 "PositionManager.vala"
	_tmp22_ = _tmp21_;
#line 1040 "PositionManager.vala"
	if (_tmp22_ == 1) {
#line 1041 "PositionManager.vala"
		*result = first_rect;
#line 1041 "PositionManager.vala"
		return;
#line 3913 "PositionManager.c"
	}
#line 1043 "PositionManager.vala"
	_tmp23_ = items;
#line 1043 "PositionManager.vala"
	_tmp24_ = gee_list_last ((GeeList*) _tmp23_);
#line 1043 "PositionManager.vala"
	_tmp25_ = (PlankDockElement*) _tmp24_;
#line 1043 "PositionManager.vala"
	plank_position_manager_get_hover_region_for_element (self, _tmp25_, &_tmp26_);
#line 1043 "PositionManager.vala"
	_tmp27_ = _tmp26_;
#line 1043 "PositionManager.vala"
	_g_object_unref0 (_tmp25_);
#line 1043 "PositionManager.vala"
	last_rect = _tmp27_;
#line 1046 "PositionManager.vala"
	_tmp28_ = last_rect;
#line 1046 "PositionManager.vala"
	gdk_rectangle_union (&first_rect, &_tmp28_, &_tmp29_);
#line 1046 "PositionManager.vala"
	_result_ = _tmp29_;
#line 1047 "PositionManager.vala"
	*result = _result_;
#line 1047 "PositionManager.vala"
	return;
#line 3939 "PositionManager.c"
}

/**
 * Get the item which is the nearest at the given coordinates. If a container is given
 * the result will be restricted to its children.
 *
 * @param x the x position
 * @param y the y position
 * @param container a container or NULL 
 */
PlankDockItem*
plank_position_manager_get_nearest_item_at (PlankPositionManager* self,
                                            gint x,
                                            gint y,
                                            PlankDockContainer* container)
{
	PlankDockItem* _result_ = NULL;
	gdouble square_distance = 0.0;
	GeeMapIterator* draw_values_it = NULL;
	GeeHashMap* _tmp0_;
	GeeMapIterator* _tmp1_;
	PlankDockItem* _tmp21_;
	PlankDockItem* result;
#line 1058 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1060 "PositionManager.vala"
	_result_ = NULL;
#line 1061 "PositionManager.vala"
	square_distance = DBL_MAX;
#line 1063 "PositionManager.vala"
	_tmp0_ = self->priv->draw_values;
#line 1063 "PositionManager.vala"
	_tmp1_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _tmp0_);
#line 1063 "PositionManager.vala"
	draw_values_it = _tmp1_;
#line 1064 "PositionManager.vala"
	while (TRUE) {
#line 3977 "PositionManager.c"
		GeeMapIterator* _tmp2_;
		PlankDockItemDrawValue* val = NULL;
		GeeMapIterator* _tmp3_;
		gpointer _tmp4_;
		PlankPointD center = {0};
		PlankDockItemDrawValue* _tmp5_;
		PlankPointD _tmp6_;
		gdouble new_square_distance = 0.0;
		PlankPointD _tmp7_;
		PlankPointD _tmp8_;
		PlankPointD _tmp9_;
		PlankPointD _tmp10_;
#line 1064 "PositionManager.vala"
		_tmp2_ = draw_values_it;
#line 1064 "PositionManager.vala"
		if (!gee_map_iterator_next (_tmp2_)) {
#line 1064 "PositionManager.vala"
			break;
#line 3996 "PositionManager.c"
		}
#line 1065 "PositionManager.vala"
		_tmp3_ = draw_values_it;
#line 1065 "PositionManager.vala"
		_tmp4_ = gee_map_iterator_get_value (_tmp3_);
#line 1065 "PositionManager.vala"
		val = (PlankDockItemDrawValue*) _tmp4_;
#line 1066 "PositionManager.vala"
		_tmp5_ = val;
#line 1066 "PositionManager.vala"
		_tmp6_ = _tmp5_->static_center;
#line 1066 "PositionManager.vala"
		center = _tmp6_;
#line 1067 "PositionManager.vala"
		_tmp7_ = center;
#line 1067 "PositionManager.vala"
		_tmp8_ = center;
#line 1067 "PositionManager.vala"
		_tmp9_ = center;
#line 1067 "PositionManager.vala"
		_tmp10_ = center;
#line 1067 "PositionManager.vala"
		new_square_distance = ((x - _tmp7_.x) * (x - _tmp8_.x)) + ((y - _tmp9_.y) * (y - _tmp10_.y));
#line 1068 "PositionManager.vala"
		if (square_distance > new_square_distance) {
#line 4022 "PositionManager.c"
			PlankDockItem* item = NULL;
			GeeMapIterator* _tmp11_;
			gpointer _tmp12_;
			PlankDockElement* _tmp13_;
			PlankDockItem* _tmp14_;
			PlankDockItem* _tmp15_;
			gboolean _tmp16_ = FALSE;
#line 1069 "PositionManager.vala"
			_tmp11_ = draw_values_it;
#line 1069 "PositionManager.vala"
			_tmp12_ = gee_map_iterator_get_key (_tmp11_);
#line 1069 "PositionManager.vala"
			_tmp13_ = (PlankDockElement*) _tmp12_;
#line 1069 "PositionManager.vala"
			_tmp14_ = PLANK_IS_DOCK_ITEM (_tmp13_) ? ((PlankDockItem*) _tmp13_) : NULL;
#line 1069 "PositionManager.vala"
			if (_tmp14_ == NULL) {
#line 1069 "PositionManager.vala"
				_g_object_unref0 (_tmp13_);
#line 4042 "PositionManager.c"
			}
#line 1069 "PositionManager.vala"
			item = _tmp14_;
#line 1070 "PositionManager.vala"
			_tmp15_ = item;
#line 1070 "PositionManager.vala"
			if (_tmp15_ == NULL) {
#line 1071 "PositionManager.vala"
				_g_object_unref0 (item);
#line 1071 "PositionManager.vala"
				_plank_dock_item_draw_value_unref0 (val);
#line 1071 "PositionManager.vala"
				continue;
#line 4056 "PositionManager.c"
			}
#line 1072 "PositionManager.vala"
			if (container == NULL) {
#line 1072 "PositionManager.vala"
				_tmp16_ = TRUE;
#line 4062 "PositionManager.c"
			} else {
				PlankDockItem* _tmp17_;
				PlankDockContainer* _tmp18_;
				PlankDockContainer* _tmp19_;
#line 1072 "PositionManager.vala"
				_tmp17_ = item;
#line 1072 "PositionManager.vala"
				_tmp18_ = plank_dock_element_get_Container ((PlankDockElement*) _tmp17_);
#line 1072 "PositionManager.vala"
				_tmp19_ = _tmp18_;
#line 1072 "PositionManager.vala"
				_tmp16_ = _tmp19_ == container;
#line 4075 "PositionManager.c"
			}
#line 1072 "PositionManager.vala"
			if (_tmp16_) {
#line 4079 "PositionManager.c"
				PlankDockItem* _tmp20_;
#line 1073 "PositionManager.vala"
				square_distance = new_square_distance;
#line 1074 "PositionManager.vala"
				_tmp20_ = item;
#line 1074 "PositionManager.vala"
				_result_ = _tmp20_;
#line 4087 "PositionManager.c"
			}
#line 1068 "PositionManager.vala"
			_g_object_unref0 (item);
#line 4091 "PositionManager.c"
		}
#line 1064 "PositionManager.vala"
		_plank_dock_item_draw_value_unref0 (val);
#line 4095 "PositionManager.c"
	}
#line 1079 "PositionManager.vala"
	_tmp21_ = _result_;
#line 1079 "PositionManager.vala"
	result = _tmp21_;
#line 1079 "PositionManager.vala"
	_g_object_unref0 (draw_values_it);
#line 1079 "PositionManager.vala"
	return result;
#line 4105 "PositionManager.c"
}

/**
 * Get the item which is the appropriate target for a drag'n'drop action.
 * The returned item may not hovered and is meant to be used as target
 * for e.g. DockContainer.add/move_to functions.
 * If a container is given the result will be restricted to its children.
 *
 * @param container a container or NULL 
 */
PlankDockItem*
plank_position_manager_get_current_target_item (PlankPositionManager* self,
                                                PlankDockContainer* container)
{
	PlankDockRenderer* renderer = NULL;
	PlankDockController* _tmp0_;
	PlankDockRenderer* _tmp1_;
	PlankDockRenderer* _tmp2_;
	GdkPoint cursor = {0};
	GdkPoint _tmp3_ = {0};
	GdkPoint _tmp4_;
	gint offset = 0;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GdkPoint _tmp9_;
	GdkPoint _tmp10_;
	PlankDockItem* _tmp11_;
	PlankDockItem* result;
#line 1090 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1092 "PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 1092 "PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_renderer (_tmp0_);
#line 1092 "PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 1092 "PositionManager.vala"
	renderer = _tmp2_;
#line 1093 "PositionManager.vala"
	plank_dock_renderer_get_local_cursor (renderer, &_tmp3_);
#line 1093 "PositionManager.vala"
	_tmp4_ = _tmp3_;
#line 1093 "PositionManager.vala"
	cursor = _tmp4_;
#line 1094 "PositionManager.vala"
	_tmp5_ = plank_dock_renderer_get_zoom_in_progress (renderer);
#line 1094 "PositionManager.vala"
	_tmp6_ = _tmp5_;
#line 1094 "PositionManager.vala"
	_tmp7_ = self->priv->_ZoomIconSize;
#line 1094 "PositionManager.vala"
	_tmp8_ = self->priv->_ItemPadding;
#line 1094 "PositionManager.vala"
	offset = (gint) (((_tmp6_ * _tmp7_) + _tmp8_) / 2.0);
#line 1096 "PositionManager.vala"
	_tmp9_ = cursor;
#line 1096 "PositionManager.vala"
	_tmp10_ = cursor;
#line 1096 "PositionManager.vala"
	_tmp11_ = plank_position_manager_get_nearest_item_at (self, _tmp9_.x + offset, _tmp10_.y + offset, container);
#line 1096 "PositionManager.vala"
	result = _tmp11_;
#line 1096 "PositionManager.vala"
	return result;
#line 4172 "PositionManager.c"
}

/**
 * Get's the x and y position to display a menu for a dock item.
 *
 * @param hovered the item that is hovered
 * @param requisition the menu's requisition
 * @param x the resulting x position
 * @param y the resulting y position
 */
void
plank_position_manager_get_menu_position (PlankPositionManager* self,
                                          PlankDockItem* hovered,
                                          GtkRequisition* requisition,
                                          gint* x,
                                          gint* y)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	GdkRectangle rect = {0};
	GdkRectangle _tmp0_ = {0};
	gint offset = 0;
	GtkPositionType _tmp1_;
#line 1107 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1107 "PositionManager.vala"
	g_return_if_fail (hovered != NULL);
#line 1107 "PositionManager.vala"
	g_return_if_fail (requisition != NULL);
#line 1109 "PositionManager.vala"
	plank_position_manager_get_hover_region_for_element (self, (PlankDockElement*) hovered, &_tmp0_);
#line 1109 "PositionManager.vala"
	rect = _tmp0_;
#line 1111 "PositionManager.vala"
	offset = 10;
#line 1112 "PositionManager.vala"
	_tmp1_ = self->priv->_Position;
#line 1112 "PositionManager.vala"
	switch (_tmp1_) {
#line 4212 "PositionManager.c"
		default:
#line 1112 "PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 4216 "PositionManager.c"
		{
			GdkRectangle _tmp2_;
			GdkRectangle _tmp3_;
			GtkRequisition _tmp4_;
			GdkRectangle _tmp5_;
			GtkRequisition _tmp6_;
#line 1115 "PositionManager.vala"
			_tmp2_ = rect;
#line 1115 "PositionManager.vala"
			_tmp3_ = rect;
#line 1115 "PositionManager.vala"
			_tmp4_ = *requisition;
#line 1115 "PositionManager.vala"
			_vala_x = (self->priv->win_x + _tmp2_.x) + ((_tmp3_.width - _tmp4_.width) / 2);
#line 1116 "PositionManager.vala"
			_tmp5_ = rect;
#line 1116 "PositionManager.vala"
			_tmp6_ = *requisition;
#line 1116 "PositionManager.vala"
			_vala_y = ((self->priv->win_y + _tmp5_.y) - _tmp6_.height) - offset;
#line 1117 "PositionManager.vala"
			break;
#line 4239 "PositionManager.c"
		}
#line 1112 "PositionManager.vala"
		case GTK_POS_TOP:
#line 4243 "PositionManager.c"
		{
			GdkRectangle _tmp7_;
			GdkRectangle _tmp8_;
			GtkRequisition _tmp9_;
			GdkRectangle _tmp10_;
#line 1119 "PositionManager.vala"
			_tmp7_ = rect;
#line 1119 "PositionManager.vala"
			_tmp8_ = rect;
#line 1119 "PositionManager.vala"
			_tmp9_ = *requisition;
#line 1119 "PositionManager.vala"
			_vala_x = (self->priv->win_x + _tmp7_.x) + ((_tmp8_.width - _tmp9_.width) / 2);
#line 1120 "PositionManager.vala"
			_tmp10_ = rect;
#line 1120 "PositionManager.vala"
			_vala_y = (self->priv->win_y + _tmp10_.height) + offset;
#line 1121 "PositionManager.vala"
			break;
#line 4263 "PositionManager.c"
		}
#line 1112 "PositionManager.vala"
		case GTK_POS_LEFT:
#line 4267 "PositionManager.c"
		{
			GdkRectangle _tmp11_;
			GdkRectangle _tmp12_;
			GtkRequisition _tmp13_;
			GdkRectangle _tmp14_;
			GdkRectangle _tmp15_;
#line 1123 "PositionManager.vala"
			_tmp11_ = rect;
#line 1123 "PositionManager.vala"
			_tmp12_ = rect;
#line 1123 "PositionManager.vala"
			_tmp13_ = *requisition;
#line 1123 "PositionManager.vala"
			_vala_y = (self->priv->win_y + _tmp11_.y) + ((_tmp12_.height - _tmp13_.height) / 2);
#line 1124 "PositionManager.vala"
			_tmp14_ = rect;
#line 1124 "PositionManager.vala"
			_tmp15_ = rect;
#line 1124 "PositionManager.vala"
			_vala_x = ((self->priv->win_x + _tmp14_.x) + _tmp15_.width) + offset;
#line 1125 "PositionManager.vala"
			break;
#line 4290 "PositionManager.c"
		}
#line 1112 "PositionManager.vala"
		case GTK_POS_RIGHT:
#line 4294 "PositionManager.c"
		{
			GdkRectangle _tmp16_;
			GdkRectangle _tmp17_;
			GtkRequisition _tmp18_;
			GdkRectangle _tmp19_;
			GtkRequisition _tmp20_;
#line 1127 "PositionManager.vala"
			_tmp16_ = rect;
#line 1127 "PositionManager.vala"
			_tmp17_ = rect;
#line 1127 "PositionManager.vala"
			_tmp18_ = *requisition;
#line 1127 "PositionManager.vala"
			_vala_y = (self->priv->win_y + _tmp16_.y) + ((_tmp17_.height - _tmp18_.height) / 2);
#line 1128 "PositionManager.vala"
			_tmp19_ = rect;
#line 1128 "PositionManager.vala"
			_tmp20_ = *requisition;
#line 1128 "PositionManager.vala"
			_vala_x = ((self->priv->win_x + _tmp19_.x) - _tmp20_.width) - offset;
#line 1129 "PositionManager.vala"
			break;
#line 4317 "PositionManager.c"
		}
	}
#line 1107 "PositionManager.vala"
	if (x) {
#line 1107 "PositionManager.vala"
		*x = _vala_x;
#line 4324 "PositionManager.c"
	}
#line 1107 "PositionManager.vala"
	if (y) {
#line 1107 "PositionManager.vala"
		*y = _vala_y;
#line 4330 "PositionManager.c"
	}
}

/**
 * Get's the x and y position to display a hover window for a dock item.
 *
 * @param hovered the item that is hovered
 * @param x the resulting x position
 * @param y the resulting y position
 */
void
plank_position_manager_get_hover_position (PlankPositionManager* self,
                                           PlankDockItem* hovered,
                                           gint* x,
                                           gint* y)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	PlankPointD center = {0};
	PlankDockItemDrawValue* _tmp0_;
	PlankDockItemDrawValue* _tmp1_;
	PlankPointD _tmp2_;
	PlankPointD _tmp3_;
	gdouble offset = 0.0;
	gint _tmp4_;
	gint _tmp5_;
	GtkPositionType _tmp6_;
#line 1140 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1140 "PositionManager.vala"
	g_return_if_fail (hovered != NULL);
#line 1142 "PositionManager.vala"
	_tmp0_ = plank_position_manager_get_draw_value_for_item (self, hovered);
#line 1142 "PositionManager.vala"
	_tmp1_ = _tmp0_;
#line 1142 "PositionManager.vala"
	_tmp2_ = _tmp1_->static_center;
#line 1142 "PositionManager.vala"
	_tmp3_ = _tmp2_;
#line 1142 "PositionManager.vala"
	_plank_dock_item_draw_value_unref0 (_tmp1_);
#line 1142 "PositionManager.vala"
	center = _tmp3_;
#line 1143 "PositionManager.vala"
	_tmp4_ = self->priv->_ZoomIconSize;
#line 1143 "PositionManager.vala"
	_tmp5_ = self->priv->_IconSize;
#line 1143 "PositionManager.vala"
	offset = _tmp4_ - (_tmp5_ / 2.0);
#line 1145 "PositionManager.vala"
	_tmp6_ = self->priv->_Position;
#line 1145 "PositionManager.vala"
	switch (_tmp6_) {
#line 4384 "PositionManager.c"
		default:
#line 1145 "PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 4388 "PositionManager.c"
		{
			PlankPointD _tmp7_;
			PlankPointD _tmp8_;
#line 1148 "PositionManager.vala"
			_tmp7_ = center;
#line 1148 "PositionManager.vala"
			_vala_x = (gint) round (_tmp7_.x + self->priv->win_x);
#line 1149 "PositionManager.vala"
			_tmp8_ = center;
#line 1149 "PositionManager.vala"
			_vala_y = (gint) round ((_tmp8_.y + self->priv->win_y) - offset);
#line 1150 "PositionManager.vala"
			break;
#line 4402 "PositionManager.c"
		}
#line 1145 "PositionManager.vala"
		case GTK_POS_TOP:
#line 4406 "PositionManager.c"
		{
			PlankPointD _tmp9_;
			PlankPointD _tmp10_;
#line 1152 "PositionManager.vala"
			_tmp9_ = center;
#line 1152 "PositionManager.vala"
			_vala_x = (gint) round (_tmp9_.x + self->priv->win_x);
#line 1153 "PositionManager.vala"
			_tmp10_ = center;
#line 1153 "PositionManager.vala"
			_vala_y = (gint) round ((_tmp10_.y + self->priv->win_y) + offset);
#line 1154 "PositionManager.vala"
			break;
#line 4420 "PositionManager.c"
		}
#line 1145 "PositionManager.vala"
		case GTK_POS_LEFT:
#line 4424 "PositionManager.c"
		{
			PlankPointD _tmp11_;
			PlankPointD _tmp12_;
#line 1156 "PositionManager.vala"
			_tmp11_ = center;
#line 1156 "PositionManager.vala"
			_vala_x = (gint) round ((_tmp11_.x + self->priv->win_x) + offset);
#line 1157 "PositionManager.vala"
			_tmp12_ = center;
#line 1157 "PositionManager.vala"
			_vala_y = (gint) round (_tmp12_.y + self->priv->win_y);
#line 1158 "PositionManager.vala"
			break;
#line 4438 "PositionManager.c"
		}
#line 1145 "PositionManager.vala"
		case GTK_POS_RIGHT:
#line 4442 "PositionManager.c"
		{
			PlankPointD _tmp13_;
			PlankPointD _tmp14_;
#line 1160 "PositionManager.vala"
			_tmp13_ = center;
#line 1160 "PositionManager.vala"
			_vala_x = (gint) round ((_tmp13_.x + self->priv->win_x) - offset);
#line 1161 "PositionManager.vala"
			_tmp14_ = center;
#line 1161 "PositionManager.vala"
			_vala_y = (gint) round (_tmp14_.y + self->priv->win_y);
#line 1162 "PositionManager.vala"
			break;
#line 4456 "PositionManager.c"
		}
	}
#line 1140 "PositionManager.vala"
	if (x) {
#line 1140 "PositionManager.vala"
		*x = _vala_x;
#line 4463 "PositionManager.c"
	}
#line 1140 "PositionManager.vala"
	if (y) {
#line 1140 "PositionManager.vala"
		*y = _vala_y;
#line 4469 "PositionManager.c"
	}
}

/**
 * Get's the x and y position to display a hover window for the given coordinates.
 *
 * @param x the resulting x position
 * @param y the resulting y position
 */
void
plank_position_manager_get_hover_position_at (PlankPositionManager* self,
                                              gint* x,
                                              gint* y)
{
	PlankPointD center = {0};
	PlankDockController* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gpointer _tmp3_;
	PlankDockItemDrawValue* _tmp4_;
	PlankDockItemDrawValue* _tmp5_;
	PlankPointD _tmp6_;
	PlankPointD _tmp7_;
	gdouble offset = 0.0;
	gint _tmp8_;
	gint _tmp9_;
	GtkPositionType _tmp10_;
#line 1172 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1175 "PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 1175 "PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_VisibleItems (_tmp0_);
#line 1175 "PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 1175 "PositionManager.vala"
	_tmp3_ = gee_list_first ((GeeList*) _tmp2_);
#line 1175 "PositionManager.vala"
	_tmp4_ = plank_position_manager_get_draw_value_for_item (self, (PlankDockItem*) _tmp3_);
#line 1175 "PositionManager.vala"
	_tmp5_ = _tmp4_;
#line 1175 "PositionManager.vala"
	_tmp6_ = _tmp5_->static_center;
#line 1175 "PositionManager.vala"
	_tmp7_ = _tmp6_;
#line 1175 "PositionManager.vala"
	_plank_dock_item_draw_value_unref0 (_tmp5_);
#line 1175 "PositionManager.vala"
	center = _tmp7_;
#line 1176 "PositionManager.vala"
	_tmp8_ = self->priv->_ZoomIconSize;
#line 1176 "PositionManager.vala"
	_tmp9_ = self->priv->_IconSize;
#line 1176 "PositionManager.vala"
	offset = _tmp8_ - (_tmp9_ / 2.0);
#line 1178 "PositionManager.vala"
	_tmp10_ = self->priv->_Position;
#line 1178 "PositionManager.vala"
	switch (_tmp10_) {
#line 4529 "PositionManager.c"
		default:
#line 1178 "PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 4533 "PositionManager.c"
		{
			PlankPointD _tmp11_;
#line 1181 "PositionManager.vala"
			_tmp11_ = center;
#line 1181 "PositionManager.vala"
			*y = (gint) round ((_tmp11_.y + self->priv->win_y) - offset);
#line 1182 "PositionManager.vala"
			break;
#line 4542 "PositionManager.c"
		}
#line 1178 "PositionManager.vala"
		case GTK_POS_TOP:
#line 4546 "PositionManager.c"
		{
			PlankPointD _tmp12_;
#line 1184 "PositionManager.vala"
			_tmp12_ = center;
#line 1184 "PositionManager.vala"
			*y = (gint) round ((_tmp12_.y + self->priv->win_y) + offset);
#line 1185 "PositionManager.vala"
			break;
#line 4555 "PositionManager.c"
		}
#line 1178 "PositionManager.vala"
		case GTK_POS_LEFT:
#line 4559 "PositionManager.c"
		{
			PlankPointD _tmp13_;
#line 1187 "PositionManager.vala"
			_tmp13_ = center;
#line 1187 "PositionManager.vala"
			*x = (gint) round ((_tmp13_.x + self->priv->win_x) + offset);
#line 1188 "PositionManager.vala"
			break;
#line 4568 "PositionManager.c"
		}
#line 1178 "PositionManager.vala"
		case GTK_POS_RIGHT:
#line 4572 "PositionManager.c"
		{
			PlankPointD _tmp14_;
#line 1190 "PositionManager.vala"
			_tmp14_ = center;
#line 1190 "PositionManager.vala"
			*x = (gint) round ((_tmp14_.x + self->priv->win_x) - offset);
#line 1191 "PositionManager.vala"
			break;
#line 4581 "PositionManager.c"
		}
	}
}

/**
 * Get's the x and y position to display the urgent-glow for a dock item.
 *
 * @param item the item to show urgent-glow for
 * @param x the resulting x position
 * @param y the resulting y position
 */
void
plank_position_manager_get_urgent_glow_position (PlankPositionManager* self,
                                                 PlankDockItem* item,
                                                 gint* x,
                                                 gint* y)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	GdkRectangle rect = {0};
	GdkRectangle _tmp0_ = {0};
	gint glow_size = 0;
	gint _tmp1_;
	GtkPositionType _tmp2_;
#line 1202 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1202 "PositionManager.vala"
	g_return_if_fail (item != NULL);
#line 1204 "PositionManager.vala"
	plank_position_manager_get_hover_region_for_element (self, (PlankDockElement*) item, &_tmp0_);
#line 1204 "PositionManager.vala"
	rect = _tmp0_;
#line 1205 "PositionManager.vala"
	_tmp1_ = self->priv->_GlowSize;
#line 1205 "PositionManager.vala"
	glow_size = _tmp1_;
#line 1207 "PositionManager.vala"
	_tmp2_ = self->priv->_Position;
#line 1207 "PositionManager.vala"
	switch (_tmp2_) {
#line 4622 "PositionManager.c"
		default:
#line 1207 "PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 4626 "PositionManager.c"
		{
			GdkRectangle _tmp3_;
			GdkRectangle _tmp4_;
#line 1210 "PositionManager.vala"
			_tmp3_ = rect;
#line 1210 "PositionManager.vala"
			_tmp4_ = rect;
#line 1210 "PositionManager.vala"
			_vala_x = _tmp3_.x + ((_tmp4_.width - glow_size) / 2);
#line 1211 "PositionManager.vala"
			_vala_y = self->priv->DockHeight - (glow_size / 2);
#line 1212 "PositionManager.vala"
			break;
#line 4640 "PositionManager.c"
		}
#line 1207 "PositionManager.vala"
		case GTK_POS_TOP:
#line 4644 "PositionManager.c"
		{
			GdkRectangle _tmp5_;
			GdkRectangle _tmp6_;
#line 1214 "PositionManager.vala"
			_tmp5_ = rect;
#line 1214 "PositionManager.vala"
			_tmp6_ = rect;
#line 1214 "PositionManager.vala"
			_vala_x = _tmp5_.x + ((_tmp6_.width - glow_size) / 2);
#line 1215 "PositionManager.vala"
			_vala_y = (-glow_size) / 2;
#line 1216 "PositionManager.vala"
			break;
#line 4658 "PositionManager.c"
		}
#line 1207 "PositionManager.vala"
		case GTK_POS_LEFT:
#line 4662 "PositionManager.c"
		{
			GdkRectangle _tmp7_;
			GdkRectangle _tmp8_;
#line 1218 "PositionManager.vala"
			_tmp7_ = rect;
#line 1218 "PositionManager.vala"
			_tmp8_ = rect;
#line 1218 "PositionManager.vala"
			_vala_y = _tmp7_.y + ((_tmp8_.height - glow_size) / 2);
#line 1219 "PositionManager.vala"
			_vala_x = (-glow_size) / 2;
#line 1220 "PositionManager.vala"
			break;
#line 4676 "PositionManager.c"
		}
#line 1207 "PositionManager.vala"
		case GTK_POS_RIGHT:
#line 4680 "PositionManager.c"
		{
			GdkRectangle _tmp9_;
			GdkRectangle _tmp10_;
#line 1222 "PositionManager.vala"
			_tmp9_ = rect;
#line 1222 "PositionManager.vala"
			_tmp10_ = rect;
#line 1222 "PositionManager.vala"
			_vala_y = _tmp9_.y + ((_tmp10_.height - glow_size) / 2);
#line 1223 "PositionManager.vala"
			_vala_x = self->priv->DockWidth - (glow_size / 2);
#line 1224 "PositionManager.vala"
			break;
#line 4694 "PositionManager.c"
		}
	}
#line 1202 "PositionManager.vala"
	if (x) {
#line 1202 "PositionManager.vala"
		*x = _vala_x;
#line 4701 "PositionManager.c"
	}
#line 1202 "PositionManager.vala"
	if (y) {
#line 1202 "PositionManager.vala"
		*y = _vala_y;
#line 4707 "PositionManager.c"
	}
}

/**
 * Caches the x and y position of the dock window.
 */
void
plank_position_manager_update_dock_position (PlankPositionManager* self)
{
	gint xoffset = 0;
	gint yoffset = 0;
	gboolean _tmp0_;
	GtkPositionType _tmp13_;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_;
#line 1231 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1233 "PositionManager.vala"
	xoffset = 0;
#line 1234 "PositionManager.vala"
	yoffset = 0;
#line 1236 "PositionManager.vala"
	_tmp0_ = self->priv->_screen_is_composited;
#line 1236 "PositionManager.vala"
	if (!_tmp0_) {
#line 4733 "PositionManager.c"
		gint offset = 0;
		gint _tmp1_;
		GdkRectangle _tmp2_;
		GdkRectangle _tmp3_;
		GtkAlign _tmp4_;
#line 1237 "PositionManager.vala"
		_tmp1_ = self->priv->_Offset;
#line 1237 "PositionManager.vala"
		offset = _tmp1_;
#line 1238 "PositionManager.vala"
		_tmp2_ = self->priv->monitor_geo;
#line 1238 "PositionManager.vala"
		xoffset = (gint) (((1 + (offset / 100.0)) * (_tmp2_.width - self->priv->DockWidth)) / 2);
#line 1239 "PositionManager.vala"
		_tmp3_ = self->priv->monitor_geo;
#line 1239 "PositionManager.vala"
		yoffset = (gint) (((1 + (offset / 100.0)) * (_tmp3_.height - self->priv->DockHeight)) / 2);
#line 1241 "PositionManager.vala"
		_tmp4_ = self->priv->_Alignment;
#line 1241 "PositionManager.vala"
		switch (_tmp4_) {
#line 4755 "PositionManager.c"
			default:
#line 1241 "PositionManager.vala"
			case GTK_ALIGN_CENTER:
#line 1241 "PositionManager.vala"
			case GTK_ALIGN_FILL:
#line 4761 "PositionManager.c"
			{
#line 1245 "PositionManager.vala"
				break;
#line 4765 "PositionManager.c"
			}
#line 1241 "PositionManager.vala"
			case GTK_ALIGN_START:
#line 4769 "PositionManager.c"
			{
#line 1247 "PositionManager.vala"
				if (plank_position_manager_is_horizontal_dock (self)) {
#line 4773 "PositionManager.c"
					GdkRectangle _tmp5_;
					GdkRectangle _tmp6_;
#line 1248 "PositionManager.vala"
					xoffset = 0;
#line 1249 "PositionManager.vala"
					_tmp5_ = self->priv->monitor_geo;
#line 1249 "PositionManager.vala"
					_tmp6_ = self->priv->static_dock_region;
#line 1249 "PositionManager.vala"
					yoffset = _tmp5_.height - _tmp6_.height;
#line 4784 "PositionManager.c"
				} else {
					GdkRectangle _tmp7_;
					GdkRectangle _tmp8_;
#line 1251 "PositionManager.vala"
					_tmp7_ = self->priv->monitor_geo;
#line 1251 "PositionManager.vala"
					_tmp8_ = self->priv->static_dock_region;
#line 1251 "PositionManager.vala"
					xoffset = _tmp7_.width - _tmp8_.width;
#line 1252 "PositionManager.vala"
					yoffset = 0;
#line 4796 "PositionManager.c"
				}
#line 1254 "PositionManager.vala"
				break;
#line 4800 "PositionManager.c"
			}
#line 1241 "PositionManager.vala"
			case GTK_ALIGN_END:
#line 4804 "PositionManager.c"
			{
#line 1256 "PositionManager.vala"
				if (plank_position_manager_is_horizontal_dock (self)) {
#line 4808 "PositionManager.c"
					GdkRectangle _tmp9_;
					GdkRectangle _tmp10_;
#line 1257 "PositionManager.vala"
					_tmp9_ = self->priv->monitor_geo;
#line 1257 "PositionManager.vala"
					_tmp10_ = self->priv->static_dock_region;
#line 1257 "PositionManager.vala"
					xoffset = _tmp9_.width - _tmp10_.width;
#line 1258 "PositionManager.vala"
					yoffset = 0;
#line 4819 "PositionManager.c"
				} else {
					GdkRectangle _tmp11_;
					GdkRectangle _tmp12_;
#line 1260 "PositionManager.vala"
					xoffset = 0;
#line 1261 "PositionManager.vala"
					_tmp11_ = self->priv->monitor_geo;
#line 1261 "PositionManager.vala"
					_tmp12_ = self->priv->static_dock_region;
#line 1261 "PositionManager.vala"
					yoffset = _tmp11_.height - _tmp12_.height;
#line 4831 "PositionManager.c"
				}
#line 1263 "PositionManager.vala"
				break;
#line 4835 "PositionManager.c"
			}
		}
	}
#line 1267 "PositionManager.vala"
	_tmp13_ = self->priv->_Position;
#line 1267 "PositionManager.vala"
	switch (_tmp13_) {
#line 4843 "PositionManager.c"
		default:
#line 1267 "PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 4847 "PositionManager.c"
		{
			GdkRectangle _tmp14_;
			GdkRectangle _tmp15_;
			GdkRectangle _tmp16_;
#line 1270 "PositionManager.vala"
			_tmp14_ = self->priv->monitor_geo;
#line 1270 "PositionManager.vala"
			self->priv->win_x = _tmp14_.x + xoffset;
#line 1271 "PositionManager.vala"
			_tmp15_ = self->priv->monitor_geo;
#line 1271 "PositionManager.vala"
			_tmp16_ = self->priv->monitor_geo;
#line 1271 "PositionManager.vala"
			self->priv->win_y = (_tmp15_.y + _tmp16_.height) - self->priv->DockHeight;
#line 1272 "PositionManager.vala"
			break;
#line 4864 "PositionManager.c"
		}
#line 1267 "PositionManager.vala"
		case GTK_POS_TOP:
#line 4868 "PositionManager.c"
		{
			GdkRectangle _tmp17_;
			GdkRectangle _tmp18_;
#line 1274 "PositionManager.vala"
			_tmp17_ = self->priv->monitor_geo;
#line 1274 "PositionManager.vala"
			self->priv->win_x = _tmp17_.x + xoffset;
#line 1275 "PositionManager.vala"
			_tmp18_ = self->priv->monitor_geo;
#line 1275 "PositionManager.vala"
			self->priv->win_y = _tmp18_.y;
#line 1276 "PositionManager.vala"
			break;
#line 4882 "PositionManager.c"
		}
#line 1267 "PositionManager.vala"
		case GTK_POS_LEFT:
#line 4886 "PositionManager.c"
		{
			GdkRectangle _tmp19_;
			GdkRectangle _tmp20_;
#line 1278 "PositionManager.vala"
			_tmp19_ = self->priv->monitor_geo;
#line 1278 "PositionManager.vala"
			self->priv->win_y = _tmp19_.y + yoffset;
#line 1279 "PositionManager.vala"
			_tmp20_ = self->priv->monitor_geo;
#line 1279 "PositionManager.vala"
			self->priv->win_x = _tmp20_.x;
#line 1280 "PositionManager.vala"
			break;
#line 4900 "PositionManager.c"
		}
#line 1267 "PositionManager.vala"
		case GTK_POS_RIGHT:
#line 4904 "PositionManager.c"
		{
			GdkRectangle _tmp21_;
			GdkRectangle _tmp22_;
			GdkRectangle _tmp23_;
#line 1282 "PositionManager.vala"
			_tmp21_ = self->priv->monitor_geo;
#line 1282 "PositionManager.vala"
			self->priv->win_y = _tmp21_.y + yoffset;
#line 1283 "PositionManager.vala"
			_tmp22_ = self->priv->monitor_geo;
#line 1283 "PositionManager.vala"
			_tmp23_ = self->priv->monitor_geo;
#line 1283 "PositionManager.vala"
			self->priv->win_x = (_tmp22_.x + _tmp23_.width) - self->priv->DockWidth;
#line 1284 "PositionManager.vala"
			break;
#line 4921 "PositionManager.c"
		}
	}
#line 1288 "PositionManager.vala"
	_tmp25_ = self->priv->_screen_is_composited;
#line 1288 "PositionManager.vala"
	if (!_tmp25_) {
#line 4928 "PositionManager.c"
		PlankDockController* _tmp26_;
		PlankHideManager* _tmp27_;
		PlankHideManager* _tmp28_;
		gboolean _tmp29_;
		gboolean _tmp30_;
#line 1288 "PositionManager.vala"
		_tmp26_ = self->priv->_controller;
#line 1288 "PositionManager.vala"
		_tmp27_ = plank_dock_controller_get_hide_manager (_tmp26_);
#line 1288 "PositionManager.vala"
		_tmp28_ = _tmp27_;
#line 1288 "PositionManager.vala"
		_tmp29_ = plank_hide_manager_get_Hidden (_tmp28_);
#line 1288 "PositionManager.vala"
		_tmp30_ = _tmp29_;
#line 1288 "PositionManager.vala"
		_tmp24_ = _tmp30_;
#line 4946 "PositionManager.c"
	} else {
#line 1288 "PositionManager.vala"
		_tmp24_ = FALSE;
#line 4950 "PositionManager.c"
	}
#line 1288 "PositionManager.vala"
	if (_tmp24_) {
#line 4954 "PositionManager.c"
		GtkPositionType _tmp31_;
#line 1289 "PositionManager.vala"
		_tmp31_ = self->priv->_Position;
#line 1289 "PositionManager.vala"
		switch (_tmp31_) {
#line 4960 "PositionManager.c"
			default:
#line 1289 "PositionManager.vala"
			case GTK_POS_BOTTOM:
#line 4964 "PositionManager.c"
			{
#line 1292 "PositionManager.vala"
				self->priv->win_y = self->priv->win_y + (self->priv->DockHeight - 1);
#line 1293 "PositionManager.vala"
				break;
#line 4970 "PositionManager.c"
			}
#line 1289 "PositionManager.vala"
			case GTK_POS_TOP:
#line 4974 "PositionManager.c"
			{
#line 1295 "PositionManager.vala"
				self->priv->win_y = self->priv->win_y - (self->priv->DockHeight - 1);
#line 1296 "PositionManager.vala"
				break;
#line 4980 "PositionManager.c"
			}
#line 1289 "PositionManager.vala"
			case GTK_POS_LEFT:
#line 4984 "PositionManager.c"
			{
#line 1298 "PositionManager.vala"
				self->priv->win_x = self->priv->win_x - (self->priv->DockWidth - 1);
#line 1299 "PositionManager.vala"
				break;
#line 4990 "PositionManager.c"
			}
#line 1289 "PositionManager.vala"
			case GTK_POS_RIGHT:
#line 4994 "PositionManager.c"
			{
#line 1301 "PositionManager.vala"
				self->priv->win_x = self->priv->win_x + (self->priv->DockWidth - 1);
#line 1302 "PositionManager.vala"
				break;
#line 5000 "PositionManager.c"
			}
		}
	}
}

/**
 * Get's the x and y position to display the main dock buffer.
 *
 * @param x the resulting x position
 * @param y the resulting y position
 */
void
plank_position_manager_get_dock_draw_position (PlankPositionManager* self,
                                               gint* x,
                                               gint* y)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	gboolean _tmp0_;
	gdouble progress = 0.0;
	PlankDockController* _tmp1_;
	PlankDockRenderer* _tmp2_;
	PlankDockRenderer* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	GtkPositionType _tmp6_;
#line 1313 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1315 "PositionManager.vala"
	_tmp0_ = self->priv->_screen_is_composited;
#line 1315 "PositionManager.vala"
	if (!_tmp0_) {
#line 1316 "PositionManager.vala"
		_vala_x = 0;
#line 1317 "PositionManager.vala"
		_vala_y = 0;
#line 1318 "PositionManager.vala"
		if (x) {
#line 1318 "PositionManager.vala"
			*x = _vala_x;
#line 5041 "PositionManager.c"
		}
#line 1318 "PositionManager.vala"
		if (y) {
#line 1318 "PositionManager.vala"
			*y = _vala_y;
#line 5047 "PositionManager.c"
		}
#line 1318 "PositionManager.vala"
		return;
#line 5051 "PositionManager.c"
	}
#line 1321 "PositionManager.vala"
	_tmp1_ = self->priv->_controller;
#line 1321 "PositionManager.vala"
	_tmp2_ = plank_dock_controller_get_renderer (_tmp1_);
#line 1321 "PositionManager.vala"
	_tmp3_ = _tmp2_;
#line 1321 "PositionManager.vala"
	_tmp4_ = plank_dock_renderer_get_hide_progress (_tmp3_);
#line 1321 "PositionManager.vala"
	_tmp5_ = _tmp4_;
#line 1321 "PositionManager.vala"
	progress = _tmp5_;
#line 1323 "PositionManager.vala"
	_tmp6_ = self->priv->_Position;
#line 1323 "PositionManager.vala"
	switch (_tmp6_) {
#line 5069 "PositionManager.c"
		default:
#line 1323 "PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 5073 "PositionManager.c"
		{
#line 1326 "PositionManager.vala"
			_vala_x = 0;
#line 1327 "PositionManager.vala"
			_vala_y = (gint) ((self->priv->VisibleDockHeight + self->priv->extra_hide_offset) * progress);
#line 1328 "PositionManager.vala"
			break;
#line 5081 "PositionManager.c"
		}
#line 1323 "PositionManager.vala"
		case GTK_POS_TOP:
#line 5085 "PositionManager.c"
		{
#line 1330 "PositionManager.vala"
			_vala_x = 0;
#line 1331 "PositionManager.vala"
			_vala_y = (gint) ((-(self->priv->VisibleDockHeight + self->priv->extra_hide_offset)) * progress);
#line 1332 "PositionManager.vala"
			break;
#line 5093 "PositionManager.c"
		}
#line 1323 "PositionManager.vala"
		case GTK_POS_LEFT:
#line 5097 "PositionManager.c"
		{
#line 1334 "PositionManager.vala"
			_vala_x = (gint) ((-(self->priv->VisibleDockWidth + self->priv->extra_hide_offset)) * progress);
#line 1335 "PositionManager.vala"
			_vala_y = 0;
#line 1336 "PositionManager.vala"
			break;
#line 5105 "PositionManager.c"
		}
#line 1323 "PositionManager.vala"
		case GTK_POS_RIGHT:
#line 5109 "PositionManager.c"
		{
#line 1338 "PositionManager.vala"
			_vala_x = (gint) ((self->priv->VisibleDockWidth + self->priv->extra_hide_offset) * progress);
#line 1339 "PositionManager.vala"
			_vala_y = 0;
#line 1340 "PositionManager.vala"
			break;
#line 5117 "PositionManager.c"
		}
	}
#line 1313 "PositionManager.vala"
	if (x) {
#line 1313 "PositionManager.vala"
		*x = _vala_x;
#line 5124 "PositionManager.c"
	}
#line 1313 "PositionManager.vala"
	if (y) {
#line 1313 "PositionManager.vala"
		*y = _vala_y;
#line 5130 "PositionManager.c"
	}
}

/**
 * Get's the region to display the dock window at.
 *
 * @return the region for the dock window
 */
void
plank_position_manager_get_dock_window_region (PlankPositionManager* self,
                                               GdkRectangle* result)
{
	GdkRectangle _tmp0_ = {0};
#line 1349 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1351 "PositionManager.vala"
	_tmp0_.x = self->priv->win_x;
#line 1351 "PositionManager.vala"
	_tmp0_.y = self->priv->win_y;
#line 1351 "PositionManager.vala"
	_tmp0_.width = self->priv->DockWidth;
#line 1351 "PositionManager.vala"
	_tmp0_.height = self->priv->DockHeight;
#line 1351 "PositionManager.vala"
	*result = _tmp0_;
#line 1351 "PositionManager.vala"
	return;
#line 5158 "PositionManager.c"
}

/**
 * Get's the padding between background and icons of the dock.
 *
 * @param x the horizontal padding
 * @param y the vertical padding
 */
void
plank_position_manager_get_background_padding (PlankPositionManager* self,
                                               gint* x,
                                               gint* y)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	GtkPositionType _tmp0_;
#line 1360 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1362 "PositionManager.vala"
	_tmp0_ = self->priv->_Position;
#line 1362 "PositionManager.vala"
	switch (_tmp0_) {
#line 5181 "PositionManager.c"
		default:
#line 1362 "PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 5185 "PositionManager.c"
		{
#line 1365 "PositionManager.vala"
			_vala_x = 0;
#line 1366 "PositionManager.vala"
			_vala_y = (self->priv->VisibleDockHeight - self->priv->DockBackgroundHeight) + self->priv->extra_hide_offset;
#line 1367 "PositionManager.vala"
			break;
#line 5193 "PositionManager.c"
		}
#line 1362 "PositionManager.vala"
		case GTK_POS_TOP:
#line 5197 "PositionManager.c"
		{
#line 1369 "PositionManager.vala"
			_vala_x = 0;
#line 1370 "PositionManager.vala"
			_vala_y = -((self->priv->VisibleDockHeight - self->priv->DockBackgroundHeight) + self->priv->extra_hide_offset);
#line 1371 "PositionManager.vala"
			break;
#line 5205 "PositionManager.c"
		}
#line 1362 "PositionManager.vala"
		case GTK_POS_LEFT:
#line 5209 "PositionManager.c"
		{
#line 1373 "PositionManager.vala"
			_vala_x = -((self->priv->VisibleDockWidth - self->priv->DockBackgroundWidth) + self->priv->extra_hide_offset);
#line 1374 "PositionManager.vala"
			_vala_y = 0;
#line 1375 "PositionManager.vala"
			break;
#line 5217 "PositionManager.c"
		}
#line 1362 "PositionManager.vala"
		case GTK_POS_RIGHT:
#line 5221 "PositionManager.c"
		{
#line 1377 "PositionManager.vala"
			_vala_x = (self->priv->VisibleDockWidth - self->priv->DockBackgroundWidth) + self->priv->extra_hide_offset;
#line 1378 "PositionManager.vala"
			_vala_y = 0;
#line 1379 "PositionManager.vala"
			break;
#line 5229 "PositionManager.c"
		}
	}
#line 1360 "PositionManager.vala"
	if (x) {
#line 1360 "PositionManager.vala"
		*x = _vala_x;
#line 5236 "PositionManager.c"
	}
#line 1360 "PositionManager.vala"
	if (y) {
#line 1360 "PositionManager.vala"
		*y = _vala_y;
#line 5242 "PositionManager.c"
	}
}

/**
 * Get's the region for background of the dock.
 *
 * @return the region for the dock background
 */
void
plank_position_manager_get_background_region (PlankPositionManager* self,
                                              GdkRectangle* result)
{
	GdkRectangle _tmp0_;
#line 1388 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1390 "PositionManager.vala"
	_tmp0_ = self->priv->background_rect;
#line 1390 "PositionManager.vala"
	*result = _tmp0_;
#line 1390 "PositionManager.vala"
	return;
#line 5264 "PositionManager.c"
}

static void
plank_position_manager_update_background_region (PlankPositionManager* self,
                                                 PlankDockItemDrawValue* val_first,
                                                 PlankDockItemDrawValue* val_last)
{
	gint x = 0;
	gint y = 0;
	gint width = 0;
	gint height = 0;
	gboolean _tmp0_;
	GtkAlign _tmp3_;
	PlankPointD center_first = {0};
	PlankPointD _tmp6_;
	PlankPointD center_last = {0};
	PlankPointD _tmp7_;
	gint padding = 0;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gdouble padding_first = 0.0;
	gdouble padding_last = 0.0;
	GtkPositionType _tmp11_;
	GdkRectangle _tmp24_ = {0};
#line 1393 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1393 "PositionManager.vala"
	g_return_if_fail (val_first != NULL);
#line 1393 "PositionManager.vala"
	g_return_if_fail (val_last != NULL);
#line 1395 "PositionManager.vala"
	x = 0;
#line 1395 "PositionManager.vala"
	y = 0;
#line 1395 "PositionManager.vala"
	width = 0;
#line 1395 "PositionManager.vala"
	height = 0;
#line 1397 "PositionManager.vala"
	_tmp0_ = self->priv->_screen_is_composited;
#line 1397 "PositionManager.vala"
	if (_tmp0_) {
#line 5308 "PositionManager.c"
		GdkRectangle _tmp1_;
		GdkRectangle _tmp2_;
#line 1398 "PositionManager.vala"
		_tmp1_ = self->priv->static_dock_region;
#line 1398 "PositionManager.vala"
		x = _tmp1_.x;
#line 1399 "PositionManager.vala"
		_tmp2_ = self->priv->static_dock_region;
#line 1399 "PositionManager.vala"
		y = _tmp2_.y;
#line 1400 "PositionManager.vala"
		width = self->priv->VisibleDockWidth;
#line 1401 "PositionManager.vala"
		height = self->priv->VisibleDockHeight;
#line 5323 "PositionManager.c"
	} else {
#line 1403 "PositionManager.vala"
		width = self->priv->DockWidth;
#line 1404 "PositionManager.vala"
		height = self->priv->DockHeight;
#line 5329 "PositionManager.c"
	}
#line 1407 "PositionManager.vala"
	_tmp3_ = self->priv->_Alignment;
#line 1407 "PositionManager.vala"
	if (_tmp3_ == GTK_ALIGN_FILL) {
#line 5335 "PositionManager.c"
		GtkPositionType _tmp4_;
		GdkRectangle _tmp5_ = {0};
#line 1408 "PositionManager.vala"
		_tmp4_ = self->priv->_Position;
#line 1408 "PositionManager.vala"
		switch (_tmp4_) {
#line 5342 "PositionManager.c"
			default:
#line 1408 "PositionManager.vala"
			case GTK_POS_BOTTOM:
#line 5346 "PositionManager.c"
			{
#line 1411 "PositionManager.vala"
				x += (width - self->priv->DockBackgroundWidth) / 2;
#line 1412 "PositionManager.vala"
				y += height - self->priv->DockBackgroundHeight;
#line 1413 "PositionManager.vala"
				break;
#line 5354 "PositionManager.c"
			}
#line 1408 "PositionManager.vala"
			case GTK_POS_TOP:
#line 5358 "PositionManager.c"
			{
#line 1415 "PositionManager.vala"
				x += (width - self->priv->DockBackgroundWidth) / 2;
#line 1416 "PositionManager.vala"
				y = 0;
#line 1417 "PositionManager.vala"
				break;
#line 5366 "PositionManager.c"
			}
#line 1408 "PositionManager.vala"
			case GTK_POS_LEFT:
#line 5370 "PositionManager.c"
			{
#line 1419 "PositionManager.vala"
				x = 0;
#line 1420 "PositionManager.vala"
				y += (height - self->priv->DockBackgroundHeight) / 2;
#line 1421 "PositionManager.vala"
				break;
#line 5378 "PositionManager.c"
			}
#line 1408 "PositionManager.vala"
			case GTK_POS_RIGHT:
#line 5382 "PositionManager.c"
			{
#line 1423 "PositionManager.vala"
				x += width - self->priv->DockBackgroundWidth;
#line 1424 "PositionManager.vala"
				y += (height - self->priv->DockBackgroundHeight) / 2;
#line 1425 "PositionManager.vala"
				break;
#line 5390 "PositionManager.c"
			}
		}
#line 1428 "PositionManager.vala"
		_tmp5_.x = x;
#line 1428 "PositionManager.vala"
		_tmp5_.y = y;
#line 1428 "PositionManager.vala"
		_tmp5_.width = self->priv->DockBackgroundWidth;
#line 1428 "PositionManager.vala"
		_tmp5_.height = self->priv->DockBackgroundHeight;
#line 1428 "PositionManager.vala"
		self->priv->background_rect = _tmp5_;
#line 1429 "PositionManager.vala"
		return;
#line 5405 "PositionManager.c"
	}
#line 1432 "PositionManager.vala"
	_tmp6_ = val_first->center;
#line 1432 "PositionManager.vala"
	center_first = _tmp6_;
#line 1433 "PositionManager.vala"
	_tmp7_ = val_last->center;
#line 1433 "PositionManager.vala"
	center_last = _tmp7_;
#line 1434 "PositionManager.vala"
	_tmp8_ = self->priv->_ItemPadding;
#line 1434 "PositionManager.vala"
	_tmp9_ = self->priv->_HorizPadding;
#line 1434 "PositionManager.vala"
	_tmp10_ = self->priv->_LineWidth;
#line 1434 "PositionManager.vala"
	padding = (_tmp8_ + (2 * _tmp9_)) + (4 * _tmp10_);
#line 1435 "PositionManager.vala"
	padding_first = (val_first->icon_size + padding) / 2.0;
#line 1436 "PositionManager.vala"
	padding_last = (val_last->icon_size + padding) / 2.0;
#line 1438 "PositionManager.vala"
	_tmp11_ = self->priv->_Position;
#line 1438 "PositionManager.vala"
	switch (_tmp11_) {
#line 5431 "PositionManager.c"
		default:
#line 1438 "PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 5435 "PositionManager.c"
		{
			PlankPointD _tmp12_;
			PlankPointD _tmp13_;
			PlankPointD _tmp14_;
#line 1441 "PositionManager.vala"
			_tmp12_ = center_first;
#line 1441 "PositionManager.vala"
			x = (gint) round (_tmp12_.x - padding_first);
#line 1442 "PositionManager.vala"
			y += height - self->priv->DockBackgroundHeight;
#line 1443 "PositionManager.vala"
			_tmp13_ = center_last;
#line 1443 "PositionManager.vala"
			_tmp14_ = center_first;
#line 1443 "PositionManager.vala"
			width = (gint) round (((_tmp13_.x - _tmp14_.x) + padding_first) + padding_last);
#line 1444 "PositionManager.vala"
			height = self->priv->DockBackgroundHeight;
#line 1445 "PositionManager.vala"
			break;
#line 5456 "PositionManager.c"
		}
#line 1438 "PositionManager.vala"
		case GTK_POS_TOP:
#line 5460 "PositionManager.c"
		{
			PlankPointD _tmp15_;
			PlankPointD _tmp16_;
			PlankPointD _tmp17_;
#line 1447 "PositionManager.vala"
			_tmp15_ = center_first;
#line 1447 "PositionManager.vala"
			x = (gint) round (_tmp15_.x - padding_first);
#line 1448 "PositionManager.vala"
			y = 0;
#line 1449 "PositionManager.vala"
			_tmp16_ = center_last;
#line 1449 "PositionManager.vala"
			_tmp17_ = center_first;
#line 1449 "PositionManager.vala"
			width = (gint) round (((_tmp16_.x - _tmp17_.x) + padding_first) + padding_last);
#line 1450 "PositionManager.vala"
			height = self->priv->DockBackgroundHeight;
#line 1451 "PositionManager.vala"
			break;
#line 5481 "PositionManager.c"
		}
#line 1438 "PositionManager.vala"
		case GTK_POS_LEFT:
#line 5485 "PositionManager.c"
		{
			PlankPointD _tmp18_;
			PlankPointD _tmp19_;
			PlankPointD _tmp20_;
#line 1453 "PositionManager.vala"
			x = 0;
#line 1454 "PositionManager.vala"
			_tmp18_ = center_first;
#line 1454 "PositionManager.vala"
			y = (gint) round (_tmp18_.y - padding_first);
#line 1455 "PositionManager.vala"
			width = self->priv->DockBackgroundWidth;
#line 1456 "PositionManager.vala"
			_tmp19_ = center_last;
#line 1456 "PositionManager.vala"
			_tmp20_ = center_first;
#line 1456 "PositionManager.vala"
			height = (gint) round (((_tmp19_.y - _tmp20_.y) + padding_first) + padding_last);
#line 1457 "PositionManager.vala"
			break;
#line 5506 "PositionManager.c"
		}
#line 1438 "PositionManager.vala"
		case GTK_POS_RIGHT:
#line 5510 "PositionManager.c"
		{
			PlankPointD _tmp21_;
			PlankPointD _tmp22_;
			PlankPointD _tmp23_;
#line 1459 "PositionManager.vala"
			x += width - self->priv->DockBackgroundWidth;
#line 1460 "PositionManager.vala"
			_tmp21_ = center_first;
#line 1460 "PositionManager.vala"
			y = (gint) round (_tmp21_.y - padding_first);
#line 1461 "PositionManager.vala"
			width = self->priv->DockBackgroundWidth;
#line 1462 "PositionManager.vala"
			_tmp22_ = center_last;
#line 1462 "PositionManager.vala"
			_tmp23_ = center_first;
#line 1462 "PositionManager.vala"
			height = (gint) round (((_tmp22_.y - _tmp23_.y) + padding_first) + padding_last);
#line 1463 "PositionManager.vala"
			break;
#line 5531 "PositionManager.c"
		}
	}
#line 1466 "PositionManager.vala"
	_tmp24_.x = x;
#line 1466 "PositionManager.vala"
	_tmp24_.y = y;
#line 1466 "PositionManager.vala"
	_tmp24_.width = width;
#line 1466 "PositionManager.vala"
	_tmp24_.height = height;
#line 1466 "PositionManager.vala"
	self->priv->background_rect = _tmp24_;
#line 5544 "PositionManager.c"
}

/**
 * Get the item's icon geometry for the dock.
 *
 * @param item an application-dockitem of the dock
 * @param for_hidden whether the geometry should apply for a hidden dock
 * @return icon geometry for the given application-dockitem
 */
void
plank_position_manager_get_icon_geometry (PlankPositionManager* self,
                                          PlankApplicationDockItem* item,
                                          gboolean for_hidden,
                                          GdkRectangle* result)
{
	GdkRectangle region = {0};
	GdkRectangle _tmp0_ = {0};
	gint x = 0;
	gint y = 0;
	GtkPositionType _tmp1_;
	GdkRectangle _tmp10_ = {0};
#line 1476 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1476 "PositionManager.vala"
	g_return_if_fail (item != NULL);
#line 1478 "PositionManager.vala"
	plank_position_manager_get_hover_region_for_element (self, (PlankDockElement*) item, &_tmp0_);
#line 1478 "PositionManager.vala"
	region = _tmp0_;
#line 1480 "PositionManager.vala"
	if (!for_hidden) {
#line 1481 "PositionManager.vala"
		region.x = region.x + self->priv->win_x;
#line 1482 "PositionManager.vala"
		region.y = region.y + self->priv->win_y;
#line 1484 "PositionManager.vala"
		*result = region;
#line 1484 "PositionManager.vala"
		return;
#line 5584 "PositionManager.c"
	}
#line 1487 "PositionManager.vala"
	x = self->priv->win_x;
#line 1487 "PositionManager.vala"
	y = self->priv->win_y;
#line 1489 "PositionManager.vala"
	_tmp1_ = self->priv->_Position;
#line 1489 "PositionManager.vala"
	switch (_tmp1_) {
#line 5594 "PositionManager.c"
		default:
#line 1489 "PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 5598 "PositionManager.c"
		{
			GdkRectangle _tmp2_;
			GdkRectangle _tmp3_;
#line 1492 "PositionManager.vala"
			_tmp2_ = region;
#line 1492 "PositionManager.vala"
			_tmp3_ = region;
#line 1492 "PositionManager.vala"
			x += _tmp2_.x + (_tmp3_.width / 2);
#line 1493 "PositionManager.vala"
			y += self->priv->DockHeight;
#line 1494 "PositionManager.vala"
			break;
#line 5612 "PositionManager.c"
		}
#line 1489 "PositionManager.vala"
		case GTK_POS_TOP:
#line 5616 "PositionManager.c"
		{
			GdkRectangle _tmp4_;
			GdkRectangle _tmp5_;
#line 1496 "PositionManager.vala"
			_tmp4_ = region;
#line 1496 "PositionManager.vala"
			_tmp5_ = region;
#line 1496 "PositionManager.vala"
			x += _tmp4_.x + (_tmp5_.width / 2);
#line 1497 "PositionManager.vala"
			y += 0;
#line 1498 "PositionManager.vala"
			break;
#line 5630 "PositionManager.c"
		}
#line 1489 "PositionManager.vala"
		case GTK_POS_LEFT:
#line 5634 "PositionManager.c"
		{
			GdkRectangle _tmp6_;
			GdkRectangle _tmp7_;
#line 1500 "PositionManager.vala"
			x += 0;
#line 1501 "PositionManager.vala"
			_tmp6_ = region;
#line 1501 "PositionManager.vala"
			_tmp7_ = region;
#line 1501 "PositionManager.vala"
			y += _tmp6_.y + (_tmp7_.height / 2);
#line 1502 "PositionManager.vala"
			break;
#line 5648 "PositionManager.c"
		}
#line 1489 "PositionManager.vala"
		case GTK_POS_RIGHT:
#line 5652 "PositionManager.c"
		{
			GdkRectangle _tmp8_;
			GdkRectangle _tmp9_;
#line 1504 "PositionManager.vala"
			x += self->priv->DockWidth;
#line 1505 "PositionManager.vala"
			_tmp8_ = region;
#line 1505 "PositionManager.vala"
			_tmp9_ = region;
#line 1505 "PositionManager.vala"
			y += _tmp8_.y + (_tmp9_.height / 2);
#line 1506 "PositionManager.vala"
			break;
#line 5666 "PositionManager.c"
		}
	}
#line 1509 "PositionManager.vala"
	_tmp10_.x = x;
#line 1509 "PositionManager.vala"
	_tmp10_.y = y;
#line 1509 "PositionManager.vala"
	_tmp10_.width = 0;
#line 1509 "PositionManager.vala"
	_tmp10_.height = 0;
#line 1509 "PositionManager.vala"
	*result = _tmp10_;
#line 1509 "PositionManager.vala"
	return;
#line 5681 "PositionManager.c"
}

/**
 * Computes the struts for the dock.
 *
 * @param struts the array to contain the struts
 */
void
plank_position_manager_get_struts (PlankPositionManager* self,
                                   gulong** struts,
                                   gint* struts_length1)
{
	PlankDockController* _tmp0_;
	PlankDockWindow* _tmp1_;
	PlankDockWindow* _tmp2_;
	GdkWindow* _tmp3_;
	GtkPositionType _tmp4_;
#line 1517 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1519 "PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 1519 "PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_window (_tmp0_);
#line 1519 "PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 1519 "PositionManager.vala"
	_tmp3_ = gtk_widget_get_window ((GtkWidget*) _tmp2_);
#line 1519 "PositionManager.vala"
	self->priv->window_scale_factor = gdk_window_get_scale_factor (_tmp3_);
#line 1520 "PositionManager.vala"
	_tmp4_ = self->priv->_Position;
#line 1520 "PositionManager.vala"
	switch (_tmp4_) {
#line 5715 "PositionManager.c"
		default:
#line 1520 "PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 5719 "PositionManager.c"
		{
			PlankDockController* _tmp5_;
			PlankDockWindow* _tmp6_;
			PlankDockWindow* _tmp7_;
			GdkScreen* _tmp8_;
			GdkRectangle _tmp9_;
			GdkRectangle _tmp10_;
			GdkRectangle _tmp11_;
			GdkRectangle _tmp12_;
			GdkRectangle _tmp13_;
#line 1523 "PositionManager.vala"
			_tmp5_ = self->priv->_controller;
#line 1523 "PositionManager.vala"
			_tmp6_ = plank_dock_controller_get_window (_tmp5_);
#line 1523 "PositionManager.vala"
			_tmp7_ = _tmp6_;
#line 1523 "PositionManager.vala"
			_tmp8_ = gtk_window_get_screen ((GtkWindow*) _tmp7_);
#line 1523 "PositionManager.vala"
			_tmp9_ = self->priv->monitor_geo;
#line 1523 "PositionManager.vala"
			_tmp10_ = self->priv->monitor_geo;
#line 1523 "PositionManager.vala"
			(*struts)[PLANK_STRUTS_BOTTOM] = (gulong) ((((self->priv->VisibleDockHeight + gdk_screen_get_height (_tmp8_)) - _tmp9_.y) - _tmp10_.height) * self->priv->window_scale_factor);
#line 1524 "PositionManager.vala"
			_tmp11_ = self->priv->monitor_geo;
#line 1524 "PositionManager.vala"
			(*struts)[PLANK_STRUTS_BOTTOM_START] = (gulong) (_tmp11_.x * self->priv->window_scale_factor);
#line 1525 "PositionManager.vala"
			_tmp12_ = self->priv->monitor_geo;
#line 1525 "PositionManager.vala"
			_tmp13_ = self->priv->monitor_geo;
#line 1525 "PositionManager.vala"
			(*struts)[PLANK_STRUTS_BOTTOM_END] = (gulong) (((_tmp12_.x + _tmp13_.width) * self->priv->window_scale_factor) - 1);
#line 1526 "PositionManager.vala"
			break;
#line 5756 "PositionManager.c"
		}
#line 1520 "PositionManager.vala"
		case GTK_POS_TOP:
#line 5760 "PositionManager.c"
		{
			GdkRectangle _tmp14_;
			GdkRectangle _tmp15_;
			GdkRectangle _tmp16_;
			GdkRectangle _tmp17_;
#line 1528 "PositionManager.vala"
			_tmp14_ = self->priv->monitor_geo;
#line 1528 "PositionManager.vala"
			(*struts)[PLANK_STRUTS_TOP] = (gulong) ((_tmp14_.y + self->priv->VisibleDockHeight) * self->priv->window_scale_factor);
#line 1529 "PositionManager.vala"
			_tmp15_ = self->priv->monitor_geo;
#line 1529 "PositionManager.vala"
			(*struts)[PLANK_STRUTS_TOP_START] = (gulong) (_tmp15_.x * self->priv->window_scale_factor);
#line 1530 "PositionManager.vala"
			_tmp16_ = self->priv->monitor_geo;
#line 1530 "PositionManager.vala"
			_tmp17_ = self->priv->monitor_geo;
#line 1530 "PositionManager.vala"
			(*struts)[PLANK_STRUTS_TOP_END] = (gulong) (((_tmp16_.x + _tmp17_.width) * self->priv->window_scale_factor) - 1);
#line 1531 "PositionManager.vala"
			break;
#line 5782 "PositionManager.c"
		}
#line 1520 "PositionManager.vala"
		case GTK_POS_LEFT:
#line 5786 "PositionManager.c"
		{
			GdkRectangle _tmp18_;
			GdkRectangle _tmp19_;
			GdkRectangle _tmp20_;
			GdkRectangle _tmp21_;
#line 1533 "PositionManager.vala"
			_tmp18_ = self->priv->monitor_geo;
#line 1533 "PositionManager.vala"
			(*struts)[PLANK_STRUTS_LEFT] = (gulong) ((_tmp18_.x + self->priv->VisibleDockWidth) * self->priv->window_scale_factor);
#line 1534 "PositionManager.vala"
			_tmp19_ = self->priv->monitor_geo;
#line 1534 "PositionManager.vala"
			(*struts)[PLANK_STRUTS_LEFT_START] = (gulong) (_tmp19_.y * self->priv->window_scale_factor);
#line 1535 "PositionManager.vala"
			_tmp20_ = self->priv->monitor_geo;
#line 1535 "PositionManager.vala"
			_tmp21_ = self->priv->monitor_geo;
#line 1535 "PositionManager.vala"
			(*struts)[PLANK_STRUTS_LEFT_END] = (gulong) (((_tmp20_.y + _tmp21_.height) * self->priv->window_scale_factor) - 1);
#line 1536 "PositionManager.vala"
			break;
#line 5808 "PositionManager.c"
		}
#line 1520 "PositionManager.vala"
		case GTK_POS_RIGHT:
#line 5812 "PositionManager.c"
		{
			PlankDockController* _tmp22_;
			PlankDockWindow* _tmp23_;
			PlankDockWindow* _tmp24_;
			GdkScreen* _tmp25_;
			GdkRectangle _tmp26_;
			GdkRectangle _tmp27_;
			GdkRectangle _tmp28_;
			GdkRectangle _tmp29_;
			GdkRectangle _tmp30_;
#line 1538 "PositionManager.vala"
			_tmp22_ = self->priv->_controller;
#line 1538 "PositionManager.vala"
			_tmp23_ = plank_dock_controller_get_window (_tmp22_);
#line 1538 "PositionManager.vala"
			_tmp24_ = _tmp23_;
#line 1538 "PositionManager.vala"
			_tmp25_ = gtk_window_get_screen ((GtkWindow*) _tmp24_);
#line 1538 "PositionManager.vala"
			_tmp26_ = self->priv->monitor_geo;
#line 1538 "PositionManager.vala"
			_tmp27_ = self->priv->monitor_geo;
#line 1538 "PositionManager.vala"
			(*struts)[PLANK_STRUTS_RIGHT] = (gulong) ((((self->priv->VisibleDockWidth + gdk_screen_get_width (_tmp25_)) - _tmp26_.x) - _tmp27_.width) * self->priv->window_scale_factor);
#line 1539 "PositionManager.vala"
			_tmp28_ = self->priv->monitor_geo;
#line 1539 "PositionManager.vala"
			(*struts)[PLANK_STRUTS_RIGHT_START] = (gulong) (_tmp28_.y * self->priv->window_scale_factor);
#line 1540 "PositionManager.vala"
			_tmp29_ = self->priv->monitor_geo;
#line 1540 "PositionManager.vala"
			_tmp30_ = self->priv->monitor_geo;
#line 1540 "PositionManager.vala"
			(*struts)[PLANK_STRUTS_RIGHT_END] = (gulong) (((_tmp29_.y + _tmp30_.height) * self->priv->window_scale_factor) - 1);
#line 1541 "PositionManager.vala"
			break;
#line 5849 "PositionManager.c"
		}
	}
}

void
plank_position_manager_get_barrier (PlankPositionManager* self,
                                    GdkRectangle* result)
{
	GdkRectangle barrier = {0};
	GdkRectangle _tmp0_ = {0};
	GtkPositionType _tmp1_;
	gboolean _tmp16_ = FALSE;
	GdkRectangle _tmp17_;
#line 1546 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1548 "PositionManager.vala"
	barrier = _tmp0_;
#line 1550 "PositionManager.vala"
	_tmp1_ = self->priv->_Position;
#line 1550 "PositionManager.vala"
	switch (_tmp1_) {
#line 5871 "PositionManager.c"
		default:
#line 1550 "PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 5875 "PositionManager.c"
		{
			GdkRectangle _tmp2_;
			GdkRectangle _tmp3_;
			GdkRectangle _tmp4_;
			GdkRectangle _tmp5_;
#line 1553 "PositionManager.vala"
			_tmp2_ = self->priv->monitor_geo;
#line 1553 "PositionManager.vala"
			_tmp3_ = self->priv->monitor_geo;
#line 1553 "PositionManager.vala"
			barrier.x = _tmp2_.x + ((_tmp3_.width - self->priv->VisibleDockWidth) / 2);
#line 1554 "PositionManager.vala"
			_tmp4_ = self->priv->monitor_geo;
#line 1554 "PositionManager.vala"
			_tmp5_ = self->priv->monitor_geo;
#line 1554 "PositionManager.vala"
			barrier.y = _tmp4_.y + _tmp5_.height;
#line 1555 "PositionManager.vala"
			barrier.width = self->priv->VisibleDockWidth;
#line 1556 "PositionManager.vala"
			barrier.height = 0;
#line 1557 "PositionManager.vala"
			break;
#line 5899 "PositionManager.c"
		}
#line 1550 "PositionManager.vala"
		case GTK_POS_TOP:
#line 5903 "PositionManager.c"
		{
			GdkRectangle _tmp6_;
			GdkRectangle _tmp7_;
			GdkRectangle _tmp8_;
#line 1559 "PositionManager.vala"
			_tmp6_ = self->priv->monitor_geo;
#line 1559 "PositionManager.vala"
			_tmp7_ = self->priv->monitor_geo;
#line 1559 "PositionManager.vala"
			barrier.x = _tmp6_.x + ((_tmp7_.width - self->priv->VisibleDockWidth) / 2);
#line 1560 "PositionManager.vala"
			_tmp8_ = self->priv->monitor_geo;
#line 1560 "PositionManager.vala"
			barrier.y = _tmp8_.y;
#line 1561 "PositionManager.vala"
			barrier.width = self->priv->VisibleDockWidth;
#line 1562 "PositionManager.vala"
			barrier.height = 0;
#line 1563 "PositionManager.vala"
			break;
#line 5924 "PositionManager.c"
		}
#line 1550 "PositionManager.vala"
		case GTK_POS_LEFT:
#line 5928 "PositionManager.c"
		{
			GdkRectangle _tmp9_;
			GdkRectangle _tmp10_;
			GdkRectangle _tmp11_;
#line 1565 "PositionManager.vala"
			_tmp9_ = self->priv->monitor_geo;
#line 1565 "PositionManager.vala"
			barrier.x = _tmp9_.x;
#line 1566 "PositionManager.vala"
			_tmp10_ = self->priv->monitor_geo;
#line 1566 "PositionManager.vala"
			_tmp11_ = self->priv->monitor_geo;
#line 1566 "PositionManager.vala"
			barrier.y = _tmp10_.y + ((_tmp11_.height - self->priv->VisibleDockHeight) / 2);
#line 1567 "PositionManager.vala"
			barrier.width = 0;
#line 1568 "PositionManager.vala"
			barrier.height = self->priv->VisibleDockHeight;
#line 1569 "PositionManager.vala"
			break;
#line 5949 "PositionManager.c"
		}
#line 1550 "PositionManager.vala"
		case GTK_POS_RIGHT:
#line 5953 "PositionManager.c"
		{
			GdkRectangle _tmp12_;
			GdkRectangle _tmp13_;
			GdkRectangle _tmp14_;
			GdkRectangle _tmp15_;
#line 1571 "PositionManager.vala"
			_tmp12_ = self->priv->monitor_geo;
#line 1571 "PositionManager.vala"
			_tmp13_ = self->priv->monitor_geo;
#line 1571 "PositionManager.vala"
			barrier.x = _tmp12_.x + _tmp13_.width;
#line 1572 "PositionManager.vala"
			_tmp14_ = self->priv->monitor_geo;
#line 1572 "PositionManager.vala"
			_tmp15_ = self->priv->monitor_geo;
#line 1572 "PositionManager.vala"
			barrier.y = _tmp14_.y + ((_tmp15_.height - self->priv->VisibleDockHeight) / 2);
#line 1573 "PositionManager.vala"
			barrier.width = 0;
#line 1574 "PositionManager.vala"
			barrier.height = self->priv->VisibleDockHeight;
#line 1575 "PositionManager.vala"
			break;
#line 5977 "PositionManager.c"
		}
	}
#line 1578 "PositionManager.vala"
	_tmp17_ = barrier;
#line 1578 "PositionManager.vala"
	if (_tmp17_.width > 0) {
#line 1578 "PositionManager.vala"
		_tmp16_ = TRUE;
#line 5986 "PositionManager.c"
	} else {
		GdkRectangle _tmp18_;
#line 1578 "PositionManager.vala"
		_tmp18_ = barrier;
#line 1578 "PositionManager.vala"
		_tmp16_ = _tmp18_.height > 0;
#line 5993 "PositionManager.c"
	}
#line 1578 "PositionManager.vala"
	g_warn_if_fail (_tmp16_);
#line 1580 "PositionManager.vala"
	*result = barrier;
#line 1580 "PositionManager.vala"
	return;
#line 6001 "PositionManager.c"
}

static PlankDockController*
plank_position_manager_get_controller (PlankPositionManager* self)
{
	PlankDockController* result;
	PlankDockController* _tmp0_;
#line 27 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 27 "PositionManager.vala"
	result = _tmp0_;
#line 27 "PositionManager.vala"
	return result;
#line 6017 "PositionManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 27 "PositionManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 6025 "PositionManager.c"
}

static void
plank_position_manager_set_controller (PlankPositionManager* self,
                                       PlankDockController* value)
{
	PlankDockController* old_value;
#line 27 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 27 "PositionManager.vala"
	old_value = plank_position_manager_get_controller (self);
#line 27 "PositionManager.vala"
	if (old_value != value) {
#line 6039 "PositionManager.c"
		PlankDockController* _tmp0_;
#line 27 "PositionManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 27 "PositionManager.vala"
		_g_object_unref0 (self->priv->_controller);
#line 27 "PositionManager.vala"
		self->priv->_controller = _tmp0_;
#line 27 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_CONTROLLER_PROPERTY]);
#line 6049 "PositionManager.c"
	}
}

gboolean
plank_position_manager_get_screen_is_composited (PlankPositionManager* self)
{
	gboolean result;
#line 29 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 29 "PositionManager.vala"
	result = self->priv->_screen_is_composited;
#line 29 "PositionManager.vala"
	return result;
#line 6063 "PositionManager.c"
}

static void
plank_position_manager_set_screen_is_composited (PlankPositionManager* self,
                                                 gboolean value)
{
	gboolean old_value;
#line 29 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "PositionManager.vala"
	old_value = plank_position_manager_get_screen_is_composited (self);
#line 29 "PositionManager.vala"
	if (old_value != value) {
#line 29 "PositionManager.vala"
		self->priv->_screen_is_composited = value;
#line 29 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_SCREEN_IS_COMPOSITED_PROPERTY]);
#line 6081 "PositionManager.c"
	}
}

gint
plank_position_manager_get_LineWidth (PlankPositionManager* self)
{
	gint result;
#line 175 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 175 "PositionManager.vala"
	result = self->priv->_LineWidth;
#line 175 "PositionManager.vala"
	return result;
#line 6095 "PositionManager.c"
}

static void
plank_position_manager_set_LineWidth (PlankPositionManager* self,
                                      gint value)
{
	gint old_value;
#line 175 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 175 "PositionManager.vala"
	old_value = plank_position_manager_get_LineWidth (self);
#line 175 "PositionManager.vala"
	if (old_value != value) {
#line 175 "PositionManager.vala"
		self->priv->_LineWidth = value;
#line 175 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_LINE_WIDTH_PROPERTY]);
#line 6113 "PositionManager.c"
	}
}

gint
plank_position_manager_get_IconSize (PlankPositionManager* self)
{
	gint result;
#line 180 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 180 "PositionManager.vala"
	result = self->priv->_IconSize;
#line 180 "PositionManager.vala"
	return result;
#line 6127 "PositionManager.c"
}

static void
plank_position_manager_set_IconSize (PlankPositionManager* self,
                                     gint value)
{
	gint old_value;
#line 180 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 180 "PositionManager.vala"
	old_value = plank_position_manager_get_IconSize (self);
#line 180 "PositionManager.vala"
	if (old_value != value) {
#line 180 "PositionManager.vala"
		self->priv->_IconSize = value;
#line 180 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_ICON_SIZE_PROPERTY]);
#line 6145 "PositionManager.c"
	}
}

gint
plank_position_manager_get_ZoomIconSize (PlankPositionManager* self)
{
	gint result;
#line 185 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 185 "PositionManager.vala"
	result = self->priv->_ZoomIconSize;
#line 185 "PositionManager.vala"
	return result;
#line 6159 "PositionManager.c"
}

static void
plank_position_manager_set_ZoomIconSize (PlankPositionManager* self,
                                         gint value)
{
	gint old_value;
#line 185 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 185 "PositionManager.vala"
	old_value = plank_position_manager_get_ZoomIconSize (self);
#line 185 "PositionManager.vala"
	if (old_value != value) {
#line 185 "PositionManager.vala"
		self->priv->_ZoomIconSize = value;
#line 185 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_ZOOM_ICON_SIZE_PROPERTY]);
#line 6177 "PositionManager.c"
	}
}

GtkPositionType
plank_position_manager_get_Position (PlankPositionManager* self)
{
	GtkPositionType result;
#line 190 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 190 "PositionManager.vala"
	result = self->priv->_Position;
#line 190 "PositionManager.vala"
	return result;
#line 6191 "PositionManager.c"
}

static void
plank_position_manager_set_Position (PlankPositionManager* self,
                                     GtkPositionType value)
{
	GtkPositionType old_value;
#line 190 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 190 "PositionManager.vala"
	old_value = plank_position_manager_get_Position (self);
#line 190 "PositionManager.vala"
	if (old_value != value) {
#line 190 "PositionManager.vala"
		self->priv->_Position = value;
#line 190 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_POSITION_PROPERTY]);
#line 6209 "PositionManager.c"
	}
}

GtkAlign
plank_position_manager_get_Alignment (PlankPositionManager* self)
{
	GtkAlign result;
#line 195 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 195 "PositionManager.vala"
	result = self->priv->_Alignment;
#line 195 "PositionManager.vala"
	return result;
#line 6223 "PositionManager.c"
}

static void
plank_position_manager_set_Alignment (PlankPositionManager* self,
                                      GtkAlign value)
{
	GtkAlign old_value;
#line 195 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 195 "PositionManager.vala"
	old_value = plank_position_manager_get_Alignment (self);
#line 195 "PositionManager.vala"
	if (old_value != value) {
#line 195 "PositionManager.vala"
		self->priv->_Alignment = value;
#line 195 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_ALIGNMENT_PROPERTY]);
#line 6241 "PositionManager.c"
	}
}

GtkAlign
plank_position_manager_get_ItemsAlignment (PlankPositionManager* self)
{
	GtkAlign result;
#line 200 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 200 "PositionManager.vala"
	result = self->priv->_ItemsAlignment;
#line 200 "PositionManager.vala"
	return result;
#line 6255 "PositionManager.c"
}

static void
plank_position_manager_set_ItemsAlignment (PlankPositionManager* self,
                                           GtkAlign value)
{
	GtkAlign old_value;
#line 200 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 200 "PositionManager.vala"
	old_value = plank_position_manager_get_ItemsAlignment (self);
#line 200 "PositionManager.vala"
	if (old_value != value) {
#line 200 "PositionManager.vala"
		self->priv->_ItemsAlignment = value;
#line 200 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_ITEMS_ALIGNMENT_PROPERTY]);
#line 6273 "PositionManager.c"
	}
}

gint
plank_position_manager_get_Offset (PlankPositionManager* self)
{
	gint result;
#line 205 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 205 "PositionManager.vala"
	result = self->priv->_Offset;
#line 205 "PositionManager.vala"
	return result;
#line 6287 "PositionManager.c"
}

static void
plank_position_manager_set_Offset (PlankPositionManager* self,
                                   gint value)
{
	gint old_value;
#line 205 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 205 "PositionManager.vala"
	old_value = plank_position_manager_get_Offset (self);
#line 205 "PositionManager.vala"
	if (old_value != value) {
#line 205 "PositionManager.vala"
		self->priv->_Offset = value;
#line 205 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_OFFSET_PROPERTY]);
#line 6305 "PositionManager.c"
	}
}

gint
plank_position_manager_get_IndicatorSize (PlankPositionManager* self)
{
	gint result;
#line 210 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 210 "PositionManager.vala"
	result = self->priv->_IndicatorSize;
#line 210 "PositionManager.vala"
	return result;
#line 6319 "PositionManager.c"
}

static void
plank_position_manager_set_IndicatorSize (PlankPositionManager* self,
                                          gint value)
{
	gint old_value;
#line 210 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 210 "PositionManager.vala"
	old_value = plank_position_manager_get_IndicatorSize (self);
#line 210 "PositionManager.vala"
	if (old_value != value) {
#line 210 "PositionManager.vala"
		self->priv->_IndicatorSize = value;
#line 210 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_INDICATOR_SIZE_PROPERTY]);
#line 6337 "PositionManager.c"
	}
}

gint
plank_position_manager_get_IconShadowSize (PlankPositionManager* self)
{
	gint result;
#line 214 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 214 "PositionManager.vala"
	result = self->priv->_IconShadowSize;
#line 214 "PositionManager.vala"
	return result;
#line 6351 "PositionManager.c"
}

static void
plank_position_manager_set_IconShadowSize (PlankPositionManager* self,
                                           gint value)
{
	gint old_value;
#line 214 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 214 "PositionManager.vala"
	old_value = plank_position_manager_get_IconShadowSize (self);
#line 214 "PositionManager.vala"
	if (old_value != value) {
#line 214 "PositionManager.vala"
		self->priv->_IconShadowSize = value;
#line 214 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_ICON_SHADOW_SIZE_PROPERTY]);
#line 6369 "PositionManager.c"
	}
}

gint
plank_position_manager_get_GlowSize (PlankPositionManager* self)
{
	gint result;
#line 218 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 218 "PositionManager.vala"
	result = self->priv->_GlowSize;
#line 218 "PositionManager.vala"
	return result;
#line 6383 "PositionManager.c"
}

static void
plank_position_manager_set_GlowSize (PlankPositionManager* self,
                                     gint value)
{
	gint old_value;
#line 218 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 218 "PositionManager.vala"
	old_value = plank_position_manager_get_GlowSize (self);
#line 218 "PositionManager.vala"
	if (old_value != value) {
#line 218 "PositionManager.vala"
		self->priv->_GlowSize = value;
#line 218 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_GLOW_SIZE_PROPERTY]);
#line 6401 "PositionManager.c"
	}
}

gint
plank_position_manager_get_HorizPadding (PlankPositionManager* self)
{
	gint result;
#line 222 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 222 "PositionManager.vala"
	result = self->priv->_HorizPadding;
#line 222 "PositionManager.vala"
	return result;
#line 6415 "PositionManager.c"
}

static void
plank_position_manager_set_HorizPadding (PlankPositionManager* self,
                                         gint value)
{
	gint old_value;
#line 222 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 222 "PositionManager.vala"
	old_value = plank_position_manager_get_HorizPadding (self);
#line 222 "PositionManager.vala"
	if (old_value != value) {
#line 222 "PositionManager.vala"
		self->priv->_HorizPadding = value;
#line 222 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_HORIZ_PADDING_PROPERTY]);
#line 6433 "PositionManager.c"
	}
}

gint
plank_position_manager_get_TopPadding (PlankPositionManager* self)
{
	gint result;
#line 226 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 226 "PositionManager.vala"
	result = self->priv->_TopPadding;
#line 226 "PositionManager.vala"
	return result;
#line 6447 "PositionManager.c"
}

static void
plank_position_manager_set_TopPadding (PlankPositionManager* self,
                                       gint value)
{
	gint old_value;
#line 226 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 226 "PositionManager.vala"
	old_value = plank_position_manager_get_TopPadding (self);
#line 226 "PositionManager.vala"
	if (old_value != value) {
#line 226 "PositionManager.vala"
		self->priv->_TopPadding = value;
#line 226 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_TOP_PADDING_PROPERTY]);
#line 6465 "PositionManager.c"
	}
}

gint
plank_position_manager_get_BottomPadding (PlankPositionManager* self)
{
	gint result;
#line 230 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 230 "PositionManager.vala"
	result = self->priv->_BottomPadding;
#line 230 "PositionManager.vala"
	return result;
#line 6479 "PositionManager.c"
}

static void
plank_position_manager_set_BottomPadding (PlankPositionManager* self,
                                          gint value)
{
	gint old_value;
#line 230 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 230 "PositionManager.vala"
	old_value = plank_position_manager_get_BottomPadding (self);
#line 230 "PositionManager.vala"
	if (old_value != value) {
#line 230 "PositionManager.vala"
		self->priv->_BottomPadding = value;
#line 230 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_BOTTOM_PADDING_PROPERTY]);
#line 6497 "PositionManager.c"
	}
}

gint
plank_position_manager_get_ItemPadding (PlankPositionManager* self)
{
	gint result;
#line 234 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 234 "PositionManager.vala"
	result = self->priv->_ItemPadding;
#line 234 "PositionManager.vala"
	return result;
#line 6511 "PositionManager.c"
}

static void
plank_position_manager_set_ItemPadding (PlankPositionManager* self,
                                        gint value)
{
	gint old_value;
#line 234 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 234 "PositionManager.vala"
	old_value = plank_position_manager_get_ItemPadding (self);
#line 234 "PositionManager.vala"
	if (old_value != value) {
#line 234 "PositionManager.vala"
		self->priv->_ItemPadding = value;
#line 234 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_ITEM_PADDING_PROPERTY]);
#line 6529 "PositionManager.c"
	}
}

gint
plank_position_manager_get_UrgentBounceHeight (PlankPositionManager* self)
{
	gint result;
#line 238 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 238 "PositionManager.vala"
	result = self->priv->_UrgentBounceHeight;
#line 238 "PositionManager.vala"
	return result;
#line 6543 "PositionManager.c"
}

static void
plank_position_manager_set_UrgentBounceHeight (PlankPositionManager* self,
                                               gint value)
{
	gint old_value;
#line 238 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 238 "PositionManager.vala"
	old_value = plank_position_manager_get_UrgentBounceHeight (self);
#line 238 "PositionManager.vala"
	if (old_value != value) {
#line 238 "PositionManager.vala"
		self->priv->_UrgentBounceHeight = value;
#line 238 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_URGENT_BOUNCE_HEIGHT_PROPERTY]);
#line 6561 "PositionManager.c"
	}
}

gint
plank_position_manager_get_LaunchBounceHeight (PlankPositionManager* self)
{
	gint result;
#line 242 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 242 "PositionManager.vala"
	result = self->priv->_LaunchBounceHeight;
#line 242 "PositionManager.vala"
	return result;
#line 6575 "PositionManager.c"
}

static void
plank_position_manager_set_LaunchBounceHeight (PlankPositionManager* self,
                                               gint value)
{
	gint old_value;
#line 242 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 242 "PositionManager.vala"
	old_value = plank_position_manager_get_LaunchBounceHeight (self);
#line 242 "PositionManager.vala"
	if (old_value != value) {
#line 242 "PositionManager.vala"
		self->priv->_LaunchBounceHeight = value;
#line 242 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_LAUNCH_BOUNCE_HEIGHT_PROPERTY]);
#line 6593 "PositionManager.c"
	}
}

gint
plank_position_manager_get_MaxItemCount (PlankPositionManager* self)
{
	gint result;
#line 293 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 293 "PositionManager.vala"
	result = self->priv->_MaxItemCount;
#line 293 "PositionManager.vala"
	return result;
#line 6607 "PositionManager.c"
}

static void
plank_position_manager_set_MaxItemCount (PlankPositionManager* self,
                                         gint value)
{
	gint old_value;
#line 293 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 293 "PositionManager.vala"
	old_value = plank_position_manager_get_MaxItemCount (self);
#line 293 "PositionManager.vala"
	if (old_value != value) {
#line 293 "PositionManager.vala"
		self->priv->_MaxItemCount = value;
#line 293 "PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_MAX_ITEM_COUNT_PROPERTY]);
#line 6625 "PositionManager.c"
	}
}

static gint
plank_position_manager_get_MaxIconSize (PlankPositionManager* self)
{
	gint result;
#line 299 "PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 299 "PositionManager.vala"
	result = self->priv->_MaxIconSize;
#line 299 "PositionManager.vala"
	return result;
#line 6639 "PositionManager.c"
}

static void
plank_position_manager_set_MaxIconSize (PlankPositionManager* self,
                                        gint value)
{
#line 299 "PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 299 "PositionManager.vala"
	self->priv->_MaxIconSize = value;
#line 6650 "PositionManager.c"
}

static GObject *
plank_position_manager_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankPositionManager * self;
	GdkRectangle _tmp0_ = {0};
	GeeHashMap* _tmp1_;
#line 48 "PositionManager.vala"
	parent_class = G_OBJECT_CLASS (plank_position_manager_parent_class);
#line 48 "PositionManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 48 "PositionManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_POSITION_MANAGER, PlankPositionManager);
#line 50 "PositionManager.vala"
	self->priv->static_dock_region = _tmp0_;
#line 51 "PositionManager.vala"
	_tmp1_ = gee_hash_map_new (PLANK_TYPE_DOCK_ELEMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, PLANK_TYPE_DOCK_ITEM_DRAW_VALUE, (GBoxedCopyFunc) plank_dock_item_draw_value_ref, (GDestroyNotify) plank_dock_item_draw_value_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 51 "PositionManager.vala"
	_g_object_unref0 (self->priv->draw_values);
#line 51 "PositionManager.vala"
	self->priv->draw_values = _tmp1_;
#line 48 "PositionManager.vala"
	return obj;
#line 6679 "PositionManager.c"
}

static void
plank_position_manager_class_init (PlankPositionManagerClass * klass,
                                   gpointer klass_data)
{
#line 25 "PositionManager.vala"
	plank_position_manager_parent_class = g_type_class_peek_parent (klass);
#line 25 "PositionManager.vala"
	g_type_class_adjust_private_offset (klass, &PlankPositionManager_private_offset);
#line 25 "PositionManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_position_manager_get_property;
#line 25 "PositionManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_position_manager_set_property;
#line 25 "PositionManager.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_position_manager_constructor;
#line 25 "PositionManager.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_position_manager_finalize;
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_CONTROLLER_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_CONTROLLER_PROPERTY] = g_param_spec_object ("controller", "controller", "controller", PLANK_TYPE_DOCK_CONTROLLER, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_SCREEN_IS_COMPOSITED_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_SCREEN_IS_COMPOSITED_PROPERTY] = g_param_spec_boolean ("screen-is-composited", "screen-is-composited", "screen-is-composited", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6702 "PositionManager.c"
	/**
	 * Theme-based line-width.
	 */
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_LINE_WIDTH_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_LINE_WIDTH_PROPERTY] = g_param_spec_int ("LineWidth", "LineWidth", "LineWidth", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6708 "PositionManager.c"
	/**
	 * Cached current icon size for the dock.
	 */
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_ICON_SIZE_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_ICON_SIZE_PROPERTY] = g_param_spec_int ("IconSize", "IconSize", "IconSize", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6714 "PositionManager.c"
	/**
	 * Cached current icon size for the dock.
	 */
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_ZOOM_ICON_SIZE_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_ZOOM_ICON_SIZE_PROPERTY] = g_param_spec_int ("ZoomIconSize", "ZoomIconSize", "ZoomIconSize", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6720 "PositionManager.c"
	/**
	 * Cached position of the dock.
	 */
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_POSITION_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_POSITION_PROPERTY] = g_param_spec_enum ("Position", "Position", "Position", gtk_position_type_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6726 "PositionManager.c"
	/**
	 * Cached alignment of the dock.
	 */
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_ALIGNMENT_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_ALIGNMENT_PROPERTY] = g_param_spec_enum ("Alignment", "Alignment", "Alignment", gtk_align_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6732 "PositionManager.c"
	/**
	 * Cached alignment of the items.
	 */
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_ITEMS_ALIGNMENT_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_ITEMS_ALIGNMENT_PROPERTY] = g_param_spec_enum ("ItemsAlignment", "ItemsAlignment", "ItemsAlignment", gtk_align_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6738 "PositionManager.c"
	/**
	 * Cached offset of the dock.
	 */
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_OFFSET_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_OFFSET_PROPERTY] = g_param_spec_int ("Offset", "Offset", "Offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6744 "PositionManager.c"
	/**
	 * Theme-based indicator size, scaled by icon size.
	 */
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_INDICATOR_SIZE_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_INDICATOR_SIZE_PROPERTY] = g_param_spec_int ("IndicatorSize", "IndicatorSize", "IndicatorSize", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6750 "PositionManager.c"
	/**
	 * Theme-based icon-shadow size, scaled by icon size.
	 */
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_ICON_SHADOW_SIZE_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_ICON_SHADOW_SIZE_PROPERTY] = g_param_spec_int ("IconShadowSize", "IconShadowSize", "IconShadowSize", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6756 "PositionManager.c"
	/**
	 * Theme-based urgent glow size, scaled by icon size.
	 */
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_GLOW_SIZE_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_GLOW_SIZE_PROPERTY] = g_param_spec_int ("GlowSize", "GlowSize", "GlowSize", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6762 "PositionManager.c"
	/**
	 * Theme-based horizontal padding, scaled by icon size.
	 */
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_HORIZ_PADDING_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_HORIZ_PADDING_PROPERTY] = g_param_spec_int ("HorizPadding", "HorizPadding", "HorizPadding", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6768 "PositionManager.c"
	/**
	 * Theme-based top padding, scaled by icon size.
	 */
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_TOP_PADDING_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_TOP_PADDING_PROPERTY] = g_param_spec_int ("TopPadding", "TopPadding", "TopPadding", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6774 "PositionManager.c"
	/**
	 * Theme-based bottom padding, scaled by icon size.
	 */
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_BOTTOM_PADDING_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_BOTTOM_PADDING_PROPERTY] = g_param_spec_int ("BottomPadding", "BottomPadding", "BottomPadding", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6780 "PositionManager.c"
	/**
	 * Theme-based item padding, scaled by icon size.
	 */
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_ITEM_PADDING_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_ITEM_PADDING_PROPERTY] = g_param_spec_int ("ItemPadding", "ItemPadding", "ItemPadding", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6786 "PositionManager.c"
	/**
	 * Theme-based urgent-bounce height, scaled by icon size.
	 */
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_URGENT_BOUNCE_HEIGHT_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_URGENT_BOUNCE_HEIGHT_PROPERTY] = g_param_spec_int ("UrgentBounceHeight", "UrgentBounceHeight", "UrgentBounceHeight", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6792 "PositionManager.c"
	/**
	 * Theme-based launch-bounce height, scaled by icon size.
	 */
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_LAUNCH_BOUNCE_HEIGHT_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_LAUNCH_BOUNCE_HEIGHT_PROPERTY] = g_param_spec_int ("LaunchBounceHeight", "LaunchBounceHeight", "LaunchBounceHeight", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6798 "PositionManager.c"
	/**
	 * The maximum item count which fit the dock in its maximum
	 * size with the current theme and icon-size.
	 */
#line 25 "PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_MAX_ITEM_COUNT_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_MAX_ITEM_COUNT_PROPERTY] = g_param_spec_int ("MaxItemCount", "MaxItemCount", "MaxItemCount", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6805 "PositionManager.c"
}

static void
plank_position_manager_instance_init (PlankPositionManager * self,
                                      gpointer klass)
{
#line 25 "PositionManager.vala"
	self->priv = plank_position_manager_get_instance_private (self);
#line 36 "PositionManager.vala"
	self->priv->window_scale_factor = 1;
#line 299 "PositionManager.vala"
	self->priv->_MaxIconSize = PLANK_DOCK_PREFERENCES_MAX_ICON_SIZE;
#line 6818 "PositionManager.c"
}

static void
plank_position_manager_finalize (GObject * obj)
{
	PlankPositionManager * self;
	GdkScreen* screen = NULL;
	PlankDockController* _tmp0_;
	PlankDockWindow* _tmp1_;
	PlankDockWindow* _tmp2_;
	GdkScreen* _tmp3_;
	GdkScreen* _tmp4_;
	guint _tmp5_;
	GdkScreen* _tmp6_;
	guint _tmp7_;
	GdkScreen* _tmp8_;
	guint _tmp9_;
	PlankDockController* _tmp10_;
	PlankDockPreferences* _tmp11_;
	PlankDockPreferences* _tmp12_;
	guint _tmp13_;
	GeeHashMap* _tmp14_;
#line 25 "PositionManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_POSITION_MANAGER, PlankPositionManager);
#line 75 "PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 75 "PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_window (_tmp0_);
#line 75 "PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 75 "PositionManager.vala"
	_tmp3_ = gtk_window_get_screen ((GtkWindow*) _tmp2_);
#line 75 "PositionManager.vala"
	screen = _tmp3_;
#line 77 "PositionManager.vala"
	_tmp4_ = screen;
#line 77 "PositionManager.vala"
	g_signal_parse_name ("monitors-changed", gdk_screen_get_type (), &_tmp5_, NULL, FALSE);
#line 77 "PositionManager.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _plank_position_manager_screen_changed_gdk_screen_monitors_changed, self);
#line 78 "PositionManager.vala"
	_tmp6_ = screen;
#line 78 "PositionManager.vala"
	g_signal_parse_name ("size-changed", gdk_screen_get_type (), &_tmp7_, NULL, FALSE);
#line 78 "PositionManager.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _plank_position_manager_screen_changed_gdk_screen_size_changed, self);
#line 79 "PositionManager.vala"
	_tmp8_ = screen;
#line 79 "PositionManager.vala"
	g_signal_parse_name ("composited-changed", gdk_screen_get_type (), &_tmp9_, NULL, FALSE);
#line 79 "PositionManager.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _plank_position_manager_screen_composited_changed_gdk_screen_composited_changed, self);
#line 80 "PositionManager.vala"
	_tmp10_ = self->priv->_controller;
#line 80 "PositionManager.vala"
	_tmp11_ = plank_dock_controller_get_prefs (_tmp10_);
#line 80 "PositionManager.vala"
	_tmp12_ = _tmp11_;
#line 80 "PositionManager.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp13_, NULL, FALSE);
#line 80 "PositionManager.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _plank_position_manager_prefs_changed_g_object_notify, self);
#line 82 "PositionManager.vala"
	_tmp14_ = self->priv->draw_values;
#line 82 "PositionManager.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp14_);
#line 27 "PositionManager.vala"
	_g_object_unref0 (self->priv->_controller);
#line 32 "PositionManager.vala"
	_g_object_unref0 (self->priv->draw_values);
#line 25 "PositionManager.vala"
	G_OBJECT_CLASS (plank_position_manager_parent_class)->finalize (obj);
#line 6891 "PositionManager.c"
}

/**
 * Handles computing any size/position information for the dock.
 */
static GType
plank_position_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankPositionManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_position_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankPositionManager), 0, (GInstanceInitFunc) plank_position_manager_instance_init, NULL };
	GType plank_position_manager_type_id;
	plank_position_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankPositionManager", &g_define_type_info, 0);
	PlankPositionManager_private_offset = g_type_add_instance_private (plank_position_manager_type_id, sizeof (PlankPositionManagerPrivate));
	return plank_position_manager_type_id;
}

GType
plank_position_manager_get_type (void)
{
	static volatile gsize plank_position_manager_type_id__once = 0;
	if (g_once_init_enter (&plank_position_manager_type_id__once)) {
		GType plank_position_manager_type_id;
		plank_position_manager_type_id = plank_position_manager_get_type_once ();
		g_once_init_leave (&plank_position_manager_type_id__once, plank_position_manager_type_id);
	}
	return plank_position_manager_type_id__once;
}

static void
_vala_plank_position_manager_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	PlankPositionManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_POSITION_MANAGER, PlankPositionManager);
#line 25 "PositionManager.vala"
	switch (property_id) {
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_CONTROLLER_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_object (value, plank_position_manager_get_controller (self));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_SCREEN_IS_COMPOSITED_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_boolean (value, plank_position_manager_get_screen_is_composited (self));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_LINE_WIDTH_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_LineWidth (self));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_ICON_SIZE_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_IconSize (self));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_ZOOM_ICON_SIZE_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_ZoomIconSize (self));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_POSITION_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_enum (value, plank_position_manager_get_Position (self));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_ALIGNMENT_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_enum (value, plank_position_manager_get_Alignment (self));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_ITEMS_ALIGNMENT_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_enum (value, plank_position_manager_get_ItemsAlignment (self));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_OFFSET_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_Offset (self));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_INDICATOR_SIZE_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_IndicatorSize (self));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_ICON_SHADOW_SIZE_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_IconShadowSize (self));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_GLOW_SIZE_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_GlowSize (self));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_HORIZ_PADDING_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_HorizPadding (self));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_TOP_PADDING_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_TopPadding (self));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_BOTTOM_PADDING_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_BottomPadding (self));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_ITEM_PADDING_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_ItemPadding (self));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_URGENT_BOUNCE_HEIGHT_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_UrgentBounceHeight (self));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_LAUNCH_BOUNCE_HEIGHT_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_LaunchBounceHeight (self));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_MAX_ITEM_COUNT_PROPERTY:
#line 25 "PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_MaxItemCount (self));
#line 25 "PositionManager.vala"
		break;
#line 7043 "PositionManager.c"
		default:
#line 25 "PositionManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "PositionManager.vala"
		break;
#line 7049 "PositionManager.c"
	}
}

static void
_vala_plank_position_manager_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	PlankPositionManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_POSITION_MANAGER, PlankPositionManager);
#line 25 "PositionManager.vala"
	switch (property_id) {
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_CONTROLLER_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_controller (self, g_value_get_object (value));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_SCREEN_IS_COMPOSITED_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_screen_is_composited (self, g_value_get_boolean (value));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_LINE_WIDTH_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_LineWidth (self, g_value_get_int (value));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_ICON_SIZE_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_IconSize (self, g_value_get_int (value));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_ZOOM_ICON_SIZE_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_ZoomIconSize (self, g_value_get_int (value));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_POSITION_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_Position (self, g_value_get_enum (value));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_ALIGNMENT_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_Alignment (self, g_value_get_enum (value));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_ITEMS_ALIGNMENT_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_ItemsAlignment (self, g_value_get_enum (value));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_OFFSET_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_Offset (self, g_value_get_int (value));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_INDICATOR_SIZE_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_IndicatorSize (self, g_value_get_int (value));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_ICON_SHADOW_SIZE_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_IconShadowSize (self, g_value_get_int (value));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_GLOW_SIZE_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_GlowSize (self, g_value_get_int (value));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_HORIZ_PADDING_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_HorizPadding (self, g_value_get_int (value));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_TOP_PADDING_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_TopPadding (self, g_value_get_int (value));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_BOTTOM_PADDING_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_BottomPadding (self, g_value_get_int (value));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_ITEM_PADDING_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_ItemPadding (self, g_value_get_int (value));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_URGENT_BOUNCE_HEIGHT_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_UrgentBounceHeight (self, g_value_get_int (value));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_LAUNCH_BOUNCE_HEIGHT_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_LaunchBounceHeight (self, g_value_get_int (value));
#line 25 "PositionManager.vala"
		break;
#line 25 "PositionManager.vala"
		case PLANK_POSITION_MANAGER_MAX_ITEM_COUNT_PROPERTY:
#line 25 "PositionManager.vala"
		plank_position_manager_set_MaxItemCount (self, g_value_get_int (value));
#line 25 "PositionManager.vala"
		break;
#line 7177 "PositionManager.c"
		default:
#line 25 "PositionManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "PositionManager.vala"
		break;
#line 7183 "PositionManager.c"
	}
}

